
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
if(AjxPackage.define("Assistant")){
if(AjxPackage.define("zimbraMail.share.view.dialog.ZmAssistantDialog")){
ZmAssistantDialog=function(){
var t=new DwtDialog_ButtonDescriptor(ZmAssistantDialog.HELP_BUTTON,ZmMsg.help,DwtDialog.ALIGN_LEFT);
var e=new DwtDialog_ButtonDescriptor(ZmAssistantDialog.EXTRA_BUTTON,ZmMsg.moreDetails,DwtDialog.ALIGN_LEFT);
DwtDialog.call(this,{
parent:appCtxt.getShell(),className:"ZmAssistantDialog",title:ZmMsg.zimbraAssistant,extraButtons:[t,e]}
);
this.setContent(this._contentHtml());
this._initContent();
this.setButtonListener(DwtDialog.OK_BUTTON,new AjxListener(this,this._okButtonListener));
this.setButtonListener(ZmAssistantDialog.EXTRA_BUTTON,new AjxListener(this,this._extraButtonListener));
this.setButtonListener(ZmAssistantDialog.HELP_BUTTON,new AjxListener(this,this._helpButtonListener));
this._parseInterval=75;
this._parseTimedAction=new AjxTimedAction(this,this._parseAction);
this._parseActionId=-1;
ZmAssistantDialog.initializeAssistants()
};
ZmAssistantDialog.prototype=new DwtDialog;
ZmAssistantDialog.prototype.constructor=ZmAssistantDialog;
ZmAssistantDialog.initializeAssistants=function(){
if(!ZmAssistantDialog._handlerInit){
ZmAssistant.register(new ZmVersionAssistant());
ZmAssistant.register(new ZmDebugAssistant());
for(var i=0;
i<ZmApp.APPS.length;
i++){
var app=ZmApp.APPS[i];
var setting=ZmApp.SETTING[app];
if(!setting||appCtxt.get(setting)){
var assistants=ZmApp.ASSISTANTS[app];
if(assistants){
for(var asstName in assistants){
var pkg=assistants[asstName];
AjxDispatcher.require(pkg);
var asst=eval(asstName);
ZmAssistant.register(new asst())
}}}}}};
ZmAssistantDialog.HELP_BUTTON=++DwtDialog.LAST_BUTTON;
ZmAssistantDialog.EXTRA_BUTTON=++DwtDialog.LAST_BUTTON;
ZmAssistantDialog._handlerInit=false;
ZmAssistantDialog.prototype.popup=function(){
this._commandEl.value="";
var e=ZmAssistant.getHandlerCommands().join(", ");
this._availableCommands=ZmMsg.ASST_availableCommands+" "+e;
this._setDefault();
this._setHelpButton(null,true,true);
DwtDialog.prototype.popup.call(this);
this._commandEl.focus()
};
ZmAssistantDialog.prototype._contentHtml=function(){
var e=new AjxBuffer();
this._contentId=Dwt.getNextId();
this._commandId=Dwt.getNextId();
this._commandTitleId=Dwt.getNextId();
e.append("<table cellspacing=3 border=0 width=400>");
e.append("<tr><td colspan=3>",ZmMsg.enterCommand,"&nbsp;<span class='ZmAsstField' id='",this._commandTitleId,"'></span></td></tr>");
e.append("<tr><td colspan=3><div>");
e.append("<textarea rows=",AjxEnv.isIE?"3":"2"," style='width:100%' id='",this._commandId,"'>");
e.append("</textarea>");
e.append("</div></td></tr>");
e.append("<tr><td colspan=3><div class=horizSep></div></td></tr>");
e.append("<tr><td colspan=3><div id='",this._contentId,"'></div></td></tr>");
e.append("</table>");
return e.toString()
};
ZmAssistantDialog.prototype.setAssistantContent=function(t){
var e=document.getElementById(this._contentId);
e.innerHTML=t
};
ZmAssistantDialog.prototype.getAssistantDiv=function(e){
return document.getElementById(this._contentId)
};
ZmAssistantDialog.prototype._initContent=function(){
this._commandEl=document.getElementById(this._commandId);
Dwt.associateElementWithObject(this._commandEl,this);
this._commandEl.onkeyup=ZmAssistantDialog._keyUpHdlr
};
ZmAssistantDialog._keyUpHdlr=function(t){
var e=DwtShell.keyEvent;
e.setFromDhtmlEvent(t,true);
var a=e.dwtObj;
a._commandUpdated()
};
ZmAssistantDialog.prototype._commandUpdated=function(){
if(this._parseActionId!=-1){
AjxTimedAction.cancelAction(this._parseActionId)
}
this._parseActionId=AjxTimedAction.scheduleAction(this._parseTimedAction,this._parseInterval)
};
ZmAssistantDialog.__RE_parseActionLeadingWord=new RegExp(["^((?:\\.|",ZmAssistant.NONSPACE,")+)",ZmAssistant.SPACES].join(""));
ZmAssistantDialog.prototype._parseAction=function(){
var o=null;
var a=ZmAssistant.trimLeading(this._commandEl.value);
var n=a.match(ZmAssistantDialog.__RE_parseActionLeadingWord);
if(n){
var r=a.substring(n[0].length);
var e=n[1];
var t=ZmAssistant.matchWord(e);
switch(t.length){
case 0:this._availableCommands=ZmMsg.ASST_availableCommands+" "+ZmMsg.ASST_no_match;
break;
case 1:o=ZmAssistant.getHandler(t[0]);
break;
default:this._availableCommands=ZmMsg.ASST_availableCommands+" "+t.join(", ");
break
}
if(o&&e==a&&this._assistant!=o){
this._commandEl.value=o.getCommand()+" ";
var s=this._commandEl.value.length;
Dwt.setSelectionRange(this._commandEl,s,s)
}}else{
this._availableCommands=ZmMsg.ASST_availableCommands+" "+ZmAssistant.getHandlerCommands().join(", ")
}
if(this._assistant!=o){
if(this._assistant!=null){
this._assistant.finish(this)
}
this._assistant=o;
if(this._assistant){
this._setHelpButton(null,true,true);
this._setExtraButton(ZmMsg.moreDetails,false,false,true,null);
this._assistant.initialize(this);
var h=this._assistant.getTitle();
if(h){
this._setCommandTitle(h)
}
var i=this._assistant.getHelp();
this._setHelpButton(null,i!=null,true)
}}
if(this._assistant){
this._assistant.handle(this,null,r)
}else{
this._setDefault()
}};
ZmAssistantDialog.prototype._setDefault=function(){
this.setAssistantContent(this._availableCommands);
this._setOkButton(AjxMsg.ok,false,false,true,null);
this._setHelpButton(null,true,true);
this._setExtraButton(ZmMsg.moreDetails,false,false,true,null);
this._setCommandTitle("")
};
ZmAssistantDialog.prototype._setCommandTitle=function(a,t){
var e=document.getElementById(this._commandTitleId);
if(e){
e.innerHTML=t?a:AjxStringUtil.htmlEncode(a)
}};
ZmAssistantDialog.prototype._setOkButton=function(i,a,e){
var t=this.getButton(DwtDialog.OK_BUTTON);
if(i){
t.setText(i)
}
t.setEnabled(e);
t.setVisible(a)
};
ZmAssistantDialog.prototype._setExtraButton=function(i,a,e){
var t=this.getButton(ZmAssistantDialog.EXTRA_BUTTON);
if(i){
t.setText(i)
}
t.setEnabled(e);
t.setVisible(a)
};
ZmAssistantDialog.prototype._setHelpButton=function(i,a,t){
var e=this.getButton(ZmAssistantDialog.HELP_BUTTON);
if(i){
e.setText(i)
}
e.setEnabled(t);
e.setVisible(a)
};
ZmAssistantDialog.prototype.popdown=function(){
DwtDialog.prototype.popdown.call(this);
if(this._assistant!=null){
this._assistant.finish(this)
}
this._assistant=null
};
ZmAssistantDialog.prototype._okButtonListener=function(e){
if(this._assistant&&!this._assistant.okHandler(this)){
return
}
this.popdown()
};
ZmAssistantDialog.prototype._extraButtonListener=function(e){
if(this._assistant&&!this._assistant.extraButtonHandler(this)){
return
}
this.popdown()
};
ZmAssistantDialog.prototype._helpButtonListener=function(s){
if(this._assistant){
var t=this._assistant.getHelp();
if(t!=null){
this.messageDialog(t,DwtMessageDialog.INFO_STYLE)
}}else{
var o=new AjxBuffer();
o.append(ZmMsg.ASST_HELP);
o.append("<table cellspacing=1 cellpadding=2 border=0>");
var e=ZmAssistant.getHandlerCommands();
for(var a=0;
a<e.length;
a++){
var n=ZmAssistant.getHandler(e[a]);
o.append("<tr><td><b>",AjxStringUtil.htmlEncode(n.getCommand()),"</b></td><td>&nbsp;</td><td>",AjxStringUtil.htmlEncode(n.getCommandSummary()),"</td></tr>")
}
o.append("</table>");
this.messageDialog(o.toString(),DwtMessageDialog.INFO_STYLE)
}};
ZmAssistantDialog.prototype._handleResponseOkButtonListener=function(){
this.popdown()
};
ZmAssistantDialog.prototype.messageDialog=function(a,t){
var e=appCtxt.getMsgDialog();
e.reset();
e.setMessage(a,t);
e.popup()
}
}
if(AjxPackage.define("zimbraMail.share.view.assistant.ZmCallAssistant")){
ZmCallAssistant=function(){
ZmAssistant.call(this,ZmMsg.call,ZmMsg.ASST_CMD_CALL)
};
ZmCallAssistant.prototype=new ZmAssistant();
ZmCallAssistant.prototype.constructor=ZmCallAssistant;
ZmCallAssistant.prototype.okHandler=function(e){
return true
};
ZmCallAssistant.prototype.handle=function(t,a,e){
t._setOkButton(AjxMsg.ok,true,true)
};
ZmCallAssistant.prototype.initialize=function(t){
var e=new AjxBuffer();
e.append("<div>HelloWorld</div>");
t.setAssistantContent(e.toString())
};
ZmCallAssistant.prototype.finish=function(e){}
}
if(AjxPackage.define("zimbraMail.share.view.assistant.ZmVersionAssistant")){
ZmVersionAssistant=function(){
ZmAssistant.call(this,"Client Version Information",".version")
};
ZmVersionAssistant.prototype=new ZmAssistant();
ZmVersionAssistant.prototype.constructor=ZmVersionAssistant;
ZmVersionAssistant.prototype.handle=function(t,a,e){
t._setOkButton(AjxMsg.ok,true,true);
this._setField("Version",appCtxt.get(ZmSetting.CLIENT_VERSION),false,true);
this._setField("Release",appCtxt.get(ZmSetting.CLIENT_RELEASE),false,true);
this._setField("Build Date",appCtxt.get(ZmSetting.CLIENT_DATETIME),false,true)
}
}
if(AjxPackage.define("zimbraMail.share.view.assistant.ZmDebugAssistant")){
ZmDebugAssistant=function(){
ZmAssistant.call(this,"Debugging Info",".debug");
this._dbg=window.DBG
};
ZmDebugAssistant.prototype=new ZmAssistant();
ZmDebugAssistant.prototype.constructor=ZmDebugAssistant;
ZmDebugAssistant.prototype.okHandler=function(){
if(this._newLevel>=0){
this._dbg.setDebugLevel(this._newLevel)
}
return true
};
ZmDebugAssistant.__RE_handleNumber=new RegExp(["^",ZmAssistant.SPACES,"([0123])",ZmAssistant.SPACES,"$"].join(""));
ZmDebugAssistant.prototype.handle=function(a,i,t){
var e=t.match(ZmDebugAssistant.__RE_handleNumber);
this._newLevel=e?parseInt(e[1]):-1;
var o=this._newLevel>=0;
a._setOkButton(AjxMsg.ok,true,o);
this._setField("Current Level",this._dbg.getDebugLevel()+"",false,true);
this._setField("New Level",!o?"(0 = none, 1 = minimal, 2 = moderate, 3 = anything goes)":this._newLevel+"",!o,true)
}
}};
