
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
if(AjxPackage.define("Browse")){
if(AjxPackage.define("zimbraMail.share.model.ZmAttachmentTypeList")){
ZmAttachmentTypeList=function(){
ZmModel.call(this,ZmEvent.S_ATT)
};
ZmAttachmentTypeList.prototype=new ZmModel;
ZmAttachmentTypeList.prototype.constructor=ZmAttachmentTypeList;
ZmAttachmentTypeList.prototype.toString=function(){
return"ZmAttachmentTypeList"
};
ZmAttachmentTypeList.prototype.getAttachments=function(){
return this._attachments
};
ZmAttachmentTypeList.compareEntry=function(t,e){
if(t.desc.toLowerCase()<e.desc.toLowerCase()){
return -1
}
if(t.desc.toLowerCase()>e.desc.toLowerCase()){
return 1
}else{
return 0
}};
ZmAttachmentTypeList.prototype.load=function(a){
this._attachments=new Array();
var e=AjxSoapDoc.create("BrowseRequest","urn:zimbraMail");
e.getMethod().setAttribute("browseBy","attachments");
var t=new AjxCallback(this,this._handleResponseLoad,a);
appCtxt.getAppController().sendRequest({
soapDoc:e,asyncMode:true,callback:t}
)
};
ZmAttachmentTypeList.prototype._handleResponseLoad=function(n,e){
var t=e.getResponse().BrowseResponse.bd;
if(t){
for(var a=0;
a<t.length;
a++){
var o=t[a]._content;
if(!ZmMimeTable.isIgnored(o)&&(o.indexOf("/")!=-1||o=="image")){
this._attachments.push(ZmMimeTable.getInfo(o,true))
}}
this._attachments.sort(ZmAttachmentTypeList.compareEntry)
}
if(n){
n.run(e)
}}
}
if(AjxPackage.define("zimbraMail.share.model.ZmDomain")){
ZmDomain=function(e,t,a){
ZmModel.call(this);
this.name=e.toLowerCase();
this.parent=t;
this._parseHeaderFlags(a);
this._subdomains={}
};
ZmDomain.prototype=new ZmModel;
ZmDomain.prototype.constructor=ZmDomain;
ZmDomain.sortCompare=function(o,e){
var t=ZmOrganizer.checkSortArgs(o,e);
if(t!=null){
return t
}
if(o.name<e.name){
return -1
}
if(o.name>e.name){
return 1
}
return 0
};
ZmDomain.prototype.toString=function(){
return"ZmDomain"
};
ZmDomain.prototype.getSubDomain=function(e){
return this._subdomains[e]
};
ZmDomain.prototype.getSubDomains=function(){
return this._subdomains
};
ZmDomain.prototype.getSortedSubDomains=function(){
if(this._sorted){
return this._sorted
}
this._sorted=[];
for(var e in this._subdomains){
this._sorted.push(this._subdomains[e])
}
this._sorted.sort(ZmDomain.sortCompare);
return this._sorted
};
ZmDomain.prototype.addSubDomain=function(e,a){
e=e.toLowerCase();
var t=this._subdomains[e];
if(t){
return t
}
t=new ZmDomain(e,this,a);
this._subdomains[e]=t;
if(this._sorted){
delete this._sorted
}
return t
};
ZmDomain.prototype._parseHeaderFlags=function(e){
this.hasFrom=(e.indexOf("f")!=-1);
this.hasTo=(e.indexOf("t")!=-1);
this.hasCc=(e.indexOf("c")!=-1)
}
}
if(AjxPackage.define("zimbraMail.share.model.ZmDomainTree")){
ZmDomainTree=function(){
ZmModel.call(this)
};
ZmDomainTree.prototype=new ZmModel;
ZmDomainTree.prototype.constructor=ZmDomainTree;
ZmDomainTree._searchResults={};
ZmDomainTree.prototype.toString=function(){
return"ZmDomainTree"
};
ZmDomainTree.prototype.getRootDomain=function(){
return this._rootDomain
};
ZmDomainTree.prototype.load=function(o){
this._rootDomain=new ZmDomain(".",null,"");
var a={
BrowseRequest:{
_jsns:"urn:zimbraMail"}};
var e=a.BrowseRequest;
e.browseBy="domains";
var t=new AjxCallback(this,this._handleResponseLoad,o);
appCtxt.getAppController().sendRequest({
jsonObj:a,asyncMode:true,callback:t}
)
};
ZmDomainTree.prototype._handleResponseLoad=function(o,t){
var e=t.getResponse().BrowseResponse.bd;
if(e){
for(var a=0;
a<e.length;
a++){
this._rootDomain.addSubDomain(e[a]._content,e[a].h)
}}
if(o){
o.run(t)
}};
ZmDomainTree.search=function(a,e,s){
if(ZmDomainTree._searchResults[a]){
s.run(ZmDomainTree._searchResults[a]);
return
}
var n={
BrowseRequest:{
_jsns:"urn:zimbraMail"}};
var t=n.BrowseRequest;
t.browseBy="domains";
if(a&&(/[a-z]/i.test(a))){
if(/\.\w{2,3}$/.test(a)){
t.regex=[".*",AjxStringUtil.regExEscape(a),"$"].join("")
}else{
t.regex=["^",a,".*"].join("")
}}
if(e){
t.maxToReturn=e
}
var o=new AjxCallback(null,ZmDomainTree._handleResponseSearch,[a,s]);
appCtxt.getAppController().sendRequest({
jsonObj:n,asyncMode:true,callback:o}
)
};
ZmDomainTree._handleResponseSearch=function(s,r,t){
var e=t.getResponse().BrowseResponse.bd;
var n=[];
if(e){
for(var a=0;
a<e.length;
a++){
var o=e[a];
n[a]=new ZmDomain(o._content,null,o.h)
}}
n.sort(ZmDomain.sortCompare);
ZmDomainTree._searchResults[s]=n;
r.run(n)
};
ZmDomainTree.reset=function(){
for(var e in ZmDomainTree._searchResults){
ZmDomainTree._searchResults[e]=null
}
ZmDomainTree._searchResults={}
}
}
if(AjxPackage.define("zimbraMail.share.view.ZmBrowseToolBar")){
ZmBrowseToolBar=function(a,o){
ZmToolBar.call(this,{
parent:a,className:"ZmBrowseToolBar"}
);
for(var t=0;
t<o.length;
t++){
var s=o[t];
var e=this.createButton(s,{
image:ZmPicker.IMAGE[s],text:ZmMsg[ZmPicker.MSG_KEY[s]],tooltip:ZmMsg[ZmPicker.TT_MSG_KEY[s]]}
);
e.setData(ZmPicker.KEY_ID,s);
e.setData(ZmPicker.KEY_CTOR,ZmPicker.CTOR[s])
}
this.addSeparator();
var s=ZmPicker.RESET;
var e=this.createButton(s,{
image:ZmPicker.IMAGE[s],text:ZmMsg[ZmPicker.MSG_KEY[s]],tooltip:ZmMsg[ZmPicker.TT_MSG_KEY[s]]}
);
e.setData(ZmPicker.KEY_ID,s);
this.addFiller();
var s=ZmPicker.CLOSE;
var n=ZmMsg[ZmPicker.MSG_KEY[s]];
var e=this.createButton(s,{
image:ZmPicker.IMAGE[s],text:n,tooltip:ZmMsg[ZmPicker.TT_MSG_KEY[s]]}
);
e.setData(ZmPicker.KEY_ID,s)
};
ZmBrowseToolBar.prototype=new ZmToolBar;
ZmBrowseToolBar.prototype.constructor=ZmBrowseToolBar;
ZmBrowseToolBar.prototype.toString=function(){
return"ZmBrowseToolBar"
}
}
if(AjxPackage.define("zimbraMail.share.view.ZmBrowseView")){
ZmBrowseView=function(e,t){
DwtComposite.call(this,{
parent:e,className:"ZmBrowseView",posStyle:DwtControl.ABSOLUTE_STYLE}
);
this.setScrollStyle(DwtControl.SCROLL);
this.addControlListener(new AjxListener(this,this._controlListener));
this._pickers=new AjxVector()
};
ZmBrowseView.prototype=new DwtComposite;
ZmBrowseView.prototype.constructor=ZmBrowseView;
ZmBrowseView.prototype.toString=function(){
return"ZmBrowseView"
};
ZmBrowseView.prototype.getToolBar=function(){
return this._toolbar
};
ZmBrowseView.prototype.addPicker=function(e,t){
this._pickers.add(e);
this.layout()
};
ZmBrowseView.prototype.getPickers=function(){
return this._pickers
};
ZmBrowseView.prototype.removePicker=function(e){
var t=this._pickers;
if(t.size()==0){
return
}
if(t.remove(e)){
e.dispose();
this.layout()
}};
ZmBrowseView.prototype.removeAllPickers=function(){
var t=this._pickers;
while(t.size()>0){
var e=t.getLast();
e.dispose();
t.removeLast()
}};
ZmBrowseView.prototype.layout=function(){
if(!this.getVisible()){
return
}
var n=this._pickers;
var a,e;
var o=n.size();
for(a=0;
a<o;
a++){
e=(a==0)?0:n.get(a-1).getXW();
var t=n.get(a);
t.setBounds(e,0,Dwt.DEFAULT,this.getH())
}
return this
};
ZmBrowseView.prototype._controlListener=function(e){
this.layout()
}
}
if(AjxPackage.define("zimbraMail.share.view.picker.ZmPicker")){
ZmPicker=function(e,t){
if(arguments.length==0){
return
}
DwtComposite.call(this,{
parent:e,className:"ZmPicker",posStyle:DwtControl.ABSOLUTE_STYLE}
);
this._header=new DwtToolBar({
parent:this}
);
this._label=new DwtLabel(this._header,DwtLabel.IMAGE_LEFT|DwtLabel.ALIGN_LEFT,"ZmPickerLabel");
this._header.addFiller();
this._close=new DwtButton({
parent:this._header,style:DwtLabel.IMAGE_LEFT,className:"DwtToolbarButton"}
);
this._close.setImage("Close");
this._close.setToolTipContent(ZmMsg.close);
this._picker=new DwtComposite(this,"ZmPickerOverview");
this._picker.setSize(Dwt.DEFAULT,e.getH()-this._header.getH());
this._picker.setScrollStyle(Dwt.SCROLL);
this._pickerEvent=new ZmEvent(ZmEvent.S_PICKER);
this._pickerEvent.set(ZmEvent.E_MODIFY,this);
this.id=t;
this.setTitle(ZmMsg[ZmPicker.T_MSG_KEY[t]]);
this.setImage(ZmPicker.IMAGE[t]);
this._setupPicker(this._picker)
};
ZmPicker.prototype=new DwtComposite;
ZmPicker.prototype.constructor=ZmPicker;
var i=1;
ZmPicker.ATTACHMENT=i++;
ZmPicker.BASIC=i++;
ZmPicker.CUSTOM=i++;
ZmPicker.DATE=i++;
ZmPicker.DOMAIN=i++;
ZmPicker.FLAG=i++;
ZmPicker.FOLDER=i++;
ZmPicker.ZIMLET=i++;
ZmPicker.SEARCH=i++;
ZmPicker.SIZE=i++;
ZmPicker.TAG=i++;
ZmPicker.TIME=i++;
ZmPicker.RESET=i++;
ZmPicker.CLOSE=i++;
ZmPicker.NEXT_ID=i;
ZmPicker.DEFAULT_PICKERS=[ZmPicker.ATTACHMENT,ZmPicker.BASIC,ZmPicker.DATE,ZmPicker.DOMAIN,ZmPicker.FOLDER];
ZmPicker.MSG_KEY={};
ZmPicker.MSG_KEY[ZmPicker.ATTACHMENT]="attachment";
ZmPicker.MSG_KEY[ZmPicker.BASIC]="basic";
ZmPicker.MSG_KEY[ZmPicker.CUSTOM]="custom";
ZmPicker.MSG_KEY[ZmPicker.DATE]="date";
ZmPicker.MSG_KEY[ZmPicker.DOMAIN]="domain";
ZmPicker.MSG_KEY[ZmPicker.FLAG]="status";
ZmPicker.MSG_KEY[ZmPicker.FOLDER]="folder";
ZmPicker.MSG_KEY[ZmPicker.ZIMLET]="zimlets";
ZmPicker.MSG_KEY[ZmPicker.SEARCH]="savedSearch";
ZmPicker.MSG_KEY[ZmPicker.SIZE]="size";
ZmPicker.MSG_KEY[ZmPicker.TAG]="tag";
ZmPicker.MSG_KEY[ZmPicker.TIME]="time";
ZmPicker.MSG_KEY[ZmPicker.RESET]="removeAll";
ZmPicker.MSG_KEY[ZmPicker.CLOSE]="close";
ZmPicker.IMAGE={};
ZmPicker.IMAGE[ZmPicker.ATTACHMENT]="Attachment";
ZmPicker.IMAGE[ZmPicker.BASIC]="Message";
ZmPicker.IMAGE[ZmPicker.CUSTOM]="Search";
ZmPicker.IMAGE[ZmPicker.DATE]="Date";
ZmPicker.IMAGE[ZmPicker.DOMAIN]="Domain";
ZmPicker.IMAGE[ZmPicker.FLAG]="FlagRed";
ZmPicker.IMAGE[ZmPicker.FOLDER]="Folder";
ZmPicker.IMAGE[ZmPicker.ZIMLET]="Zimlet";
ZmPicker.IMAGE[ZmPicker.SEARCH]="SearchFolder";
ZmPicker.IMAGE[ZmPicker.SIZE]="Folder";
ZmPicker.IMAGE[ZmPicker.TAG]="Tag";
ZmPicker.IMAGE[ZmPicker.TIME]="Time";
ZmPicker.IMAGE[ZmPicker.CLOSE]="Close";
ZmPicker.TT_MSG_KEY={};
ZmPicker.TT_MSG_KEY[ZmPicker.ATTACHMENT]="searchByAttachment";
ZmPicker.TT_MSG_KEY[ZmPicker.BASIC]="searchByBasic";
ZmPicker.TT_MSG_KEY[ZmPicker.CUSTOM]="searchByCustom";
ZmPicker.TT_MSG_KEY[ZmPicker.DATE]="searchByDate";
ZmPicker.TT_MSG_KEY[ZmPicker.DOMAIN]="searchByDomain";
ZmPicker.TT_MSG_KEY[ZmPicker.FLAG]="searchByFlag";
ZmPicker.TT_MSG_KEY[ZmPicker.FOLDER]="searchByFolder";
ZmPicker.TT_MSG_KEY[ZmPicker.ZIMLET]="searchByZimlet";
ZmPicker.TT_MSG_KEY[ZmPicker.SEARCH]="searchBySavedSearch";
ZmPicker.TT_MSG_KEY[ZmPicker.SIZE]="searchBySize";
ZmPicker.TT_MSG_KEY[ZmPicker.TAG]="searchByTag";
ZmPicker.TT_MSG_KEY[ZmPicker.TIME]="searchByTime";
ZmPicker.TT_MSG_KEY[ZmPicker.RESET]="clearAdvSearch";
ZmPicker.TT_MSG_KEY[ZmPicker.CLOSE]="closeSearchBuilder";
ZmPicker.T_MSG_KEY={};
ZmPicker.T_MSG_KEY[ZmPicker.ATTACHMENT]="attachments";
ZmPicker.T_MSG_KEY[ZmPicker.BASIC]="basicSearch";
ZmPicker.T_MSG_KEY[ZmPicker.CUSTOM]="custom";
ZmPicker.T_MSG_KEY[ZmPicker.DATE]="date";
ZmPicker.T_MSG_KEY[ZmPicker.DOMAIN]="domains";
ZmPicker.T_MSG_KEY[ZmPicker.FLAG]="status";
ZmPicker.T_MSG_KEY[ZmPicker.FOLDER]="folders";
ZmPicker.T_MSG_KEY[ZmPicker.ZIMLET]="zimlets";
ZmPicker.T_MSG_KEY[ZmPicker.SEARCH]="savedSearches";
ZmPicker.T_MSG_KEY[ZmPicker.SIZE]="size";
ZmPicker.T_MSG_KEY[ZmPicker.TAG]="tags";
ZmPicker.T_MSG_KEY[ZmPicker.TIME]="time";
ZmPicker.LIMIT={};
ZmPicker.LIMIT[ZmPicker.ATTACHMENT]=1;
ZmPicker.LIMIT[ZmPicker.BASIC]=-1;
ZmPicker.LIMIT[ZmPicker.CUSTOM]=1;
ZmPicker.LIMIT[ZmPicker.DATE]=2;
ZmPicker.LIMIT[ZmPicker.DOMAIN]=2;
ZmPicker.LIMIT[ZmPicker.FLAG]=4;
ZmPicker.LIMIT[ZmPicker.FOLDER]=1;
ZmPicker.LIMIT[ZmPicker.ZIMLET]=-1;
ZmPicker.LIMIT[ZmPicker.SEARCH]=-1;
ZmPicker.LIMIT[ZmPicker.SIZE]=2;
ZmPicker.LIMIT[ZmPicker.TAG]=-1;
ZmPicker.LIMIT[ZmPicker.TIME]=1;
ZmPicker.MULTI_JOIN={};
for(var i=1;
i<=ZmPicker.CLOSE;
i++){
ZmPicker.MULTI_JOIN[i]=" "
}
ZmPicker.MULTI_JOIN[ZmPicker.BASIC]=" OR ";
ZmPicker.MULTI_JOIN[ZmPicker.FLAG]=" OR ";
ZmPicker.CTOR=new Object();
ZmPicker.DEFAULT_PICKER=ZmPicker.BASIC;
ZmPicker.KEY_ID="_id_";
ZmPicker.KEY_CTOR="_ctor_";
ZmPicker.KEY_PICKER="_picker_";
ZmPicker_Descriptor=function(n,t,o,e,a){
this.id=n;
this.label=t||ZmMsg[ZmPicker.MSG_KEY[n]];
this.image=o||ZmPicker.IMAGE[n];
this.toolTip=e||ZmMsg[ZmPicker.TT_MSG_KEY[n]]||this.label;
this.ctor=a
};
ZmPicker.prototype.toString=function(){
return"ZmPicker"
};
ZmPicker.prototype._setupPicker=function(){};
ZmPicker.prototype._updateQuery=function(){};
ZmPicker.prototype._treeListener=function(){};
ZmPicker.prototype.setTitle=function(e){
this._label.setText(e)
};
ZmPicker.prototype.setImage=function(e){
this._label.setImage(e)
};
ZmPicker.prototype.getCloseButton=function(){
return this._close
};
ZmPicker.prototype.setEnabled=function(e){
DwtControl.prototype.setEnabled.call(this,e);
this._label.setEnabled(e);
if(this._picker.setEnabled){
this._picker.setEnabled(e)
}};
ZmPicker.prototype.addPickerListener=function(e){
this.addListener(ZmEvent.L_PICKER,e)
};
ZmPicker.prototype.removePickerListener=function(e){
this.removeListener(ZmEvent.L_PICKER,e)
};
ZmPicker.prototype.execute=function(){
if(this.isListenerRegistered(ZmEvent.L_PICKER)){
this._pickerEvent.set(ZmEvent.E_LOAD,this);
this.notifyListeners(ZmEvent.L_PICKER,this._pickerEvent)
}};
ZmPicker.prototype.setQuery=function(e){
this._query=e;
if(this.isListenerRegistered(ZmEvent.L_PICKER)){
this._pickerEvent.set(ZmEvent.E_MODIFY,this);
this.notifyListeners(ZmEvent.L_PICKER,this._pickerEvent)
}};
ZmPicker.prototype.dispose=function(){
DwtComposite.prototype.dispose.call(this);
if(this._treeView){
var e=appCtxt.getOverviewController();
this._overview.clear()
}};
ZmPicker.prototype._setOverview=function(r,o,a){
var s={
overviewId:r,parent:o,headerClass:"DwtTreeItem",treeStyle:DwtTree.CHECKEDITEM_STYLE,isCheckedByDefault:false,treeIds:a,account:appCtxt.getActiveAccount()};
var n=this._overview=appCtxt.getOverviewController().createOverview(s);
n.set(a);
this._treeView={};
for(var t=0;
t<a.length;
t++){
var e=this._treeView[a[t]]=n.getTreeView(a[t]);
e.addSelectionListener(new AjxListener(this,this._treeListener))
}
if(a.length==1){
this._hideRoot(a[0])
}};
ZmPicker.prototype._hideRoot=function(a){
var t=this._treeView[a].getTreeItemById(ZmOrganizer.ID_ROOT);
if(!t){
var e=ZmOrganizer.getSystemId(ZmOrganizer.ID_ROOT);
t=this._treeView[a].getTreeItemById(e)
}
t.showCheckBox(false);
t.setExpanded(true);
t.setVisible(false,true)
}
}
if(AjxPackage.define("zimbraMail.share.view.picker.ZmAttachmentPicker")){
ZmAttachmentPicker=function(e){
ZmPicker.call(this,e,ZmPicker.ATTACHMENT);
this._checkedItems={}
};
ZmAttachmentPicker.prototype=new ZmPicker;
ZmAttachmentPicker.prototype.constructor=ZmAttachmentPicker;
ZmPicker.CTOR[ZmPicker.ATTACHMENT]=ZmAttachmentPicker;
ZmAttachmentPicker.NONE=1;
ZmAttachmentPicker.ANY=2;
ZmAttachmentPicker.SPEC=3;
ZmAttachmentPicker.FILE=4;
ZmAttachmentPicker.RADIO_BUTTONS=[ZmAttachmentPicker.NONE,ZmAttachmentPicker.ANY,ZmAttachmentPicker.SPEC,ZmAttachmentPicker.FILE];
ZmAttachmentPicker.MSG_KEY=new Object();
ZmAttachmentPicker.MSG_KEY[ZmAttachmentPicker.NONE]="noAtt";
ZmAttachmentPicker.MSG_KEY[ZmAttachmentPicker.ANY]="anyAtt";
ZmAttachmentPicker.MSG_KEY[ZmAttachmentPicker.SPEC]="specAtt";
ZmAttachmentPicker.MSG_KEY[ZmAttachmentPicker.FILE]="specFile";
ZmAttachmentPicker.RADIO_CHECKED=ZmAttachmentPicker.SPEC;
ZmAttachmentPicker.ATT_KEY="_att_";
ZmAttachmentPicker.prototype.toString=function(){
return"ZmAttachmentPicker"
};
ZmAttachmentPicker.prototype._newType=function(e,n){
var o=new DwtTreeItem({
parent:e,text:n[0].desc,imageInfo:n[0].image}
);
o.setChecked(false,true);
o.setData(ZmAttachmentPicker.ATT_KEY,n[0].desc);
var a=[];
for(var t=0;
t<n.length;
t++){
a.push(n[t].type)
}
o.setToolTipContent(a.join("<br />"));
return o
};
ZmAttachmentPicker.prototype._newRadio=function(e){
var a=new Array(5);
var n=ZmMsg[ZmAttachmentPicker.MSG_KEY[e]];
var o=(e==ZmAttachmentPicker.RADIO_CHECKED)?"checked":"";
var s=this._radioId[e];
var t=0;
a[t++]="<tr valign='middle'><td align='left'>";
a[t++]="<input type='radio' name='r'";
a[t++]=o;
a[t++]=" id='";
a[t++]=s;
a[t++]="'></td><td align='left'>";
a[t++]=n;
a[t++]="</td></tr>";
return a.join("")
};
ZmAttachmentPicker.prototype._setupRadio=function(e){
var a=this._radioId[e];
var t=this._radio[e]=document.getElementById(a);
Dwt.setHandler(t,DwtEvent.ONCLICK,ZmAttachmentPicker._radioChange);
t._picker=this;
t._radioId=e
};
ZmAttachmentPicker.prototype._setupPicker=function(h){
var r=new DwtComposite(h);
this._radio={};
this._radioId={};
for(var t=0;
t<ZmAttachmentPicker.RADIO_BUTTONS.length;
t++){
this._radioId[ZmAttachmentPicker.RADIO_BUTTONS[t]]=Dwt.getNextId()
}
var n=Dwt.getNextId();
var a=Dwt.getNextId();
var s=Dwt.getNextId();
var o=new Array(10);
var l=0;
o[l++]="<table cellpadding='2' cellspacing='0' border='0'>";
for(var t=0;
t<ZmAttachmentPicker.RADIO_BUTTONS.length;
t++){
o[l++]=this._newRadio(ZmAttachmentPicker.RADIO_BUTTONS[t])
}
o[l++]="</table>";
o[l++]="<div style='display:none; padding: 0 5' id='";
o[l++]=a;
o[l++]="'><hr /><table border=0><tr><td width=1%>";
o[l++]=ZmMsg.filename;
o[l++]="</td><td>";
o[l++]="<input type='text' autocomplete='off' nowrap style='width:90%' id='";
o[l++]=s;
o[l++]="'>";
o[l++]="</td></tr></table></div>";
o[l++]="<div id='";
o[l++]=n;
o[l++]="'><hr /></div>";
r.getHtmlElement().innerHTML=o.join("");
for(var t=0;
t<ZmAttachmentPicker.RADIO_BUTTONS.length;
t++){
this._setupRadio(ZmAttachmentPicker.RADIO_BUTTONS[t])
}
this._fileNameDiv=document.getElementById(a);
this._fileNameInput=document.getElementById(s);
Dwt.setHandler(this._fileNameInput,DwtEvent.ONKEYUP,ZmAttachmentPicker._onChange);
Dwt.associateElementWithObject(this._fileNameInput,this);
this._tree=new DwtTree({
parent:r,style:DwtTree.CHECKEDITEM_STYLE}
);
this._tree.addSelectionListener(new AjxListener(this,this._treeListener));
var e=new ZmAttachmentTypeList();
var c=new AjxCallback(this,this._handleResponseSetupPicker,[e,this._tree,n]);
e.load(c)
};
ZmAttachmentPicker.prototype._handleResponseSetupPicker=function(a,t,s){
var e=a.getAttachments();
this._attsByDesc={};
var n=[];
var r;
for(var o=0;
o<e.length;
o++){
var h=e[o].desc;
if(h!=r){
this._attsByDesc[h]=[];
n.push(h)
}
this._attsByDesc[h].push(e[o]);
r=h
}
for(var o=0;
o<n.length;
o++){
this._newType(t,this._attsByDesc[n[o]])
}
this._treeDiv=document.getElementById(s);
this._treeDiv.appendChild(t.getHtmlElement());
Dwt.setVisible(this._treeDiv,ZmAttachmentPicker.RADIO_CHECKED==ZmAttachmentPicker.RADIO_CHECKED);
this._updateQuery()
};
ZmAttachmentPicker.prototype._updateQuery=function(){
if(this._radio[ZmAttachmentPicker.ANY].checked){
this.setQuery("attachment:any")
}else{
if(this._radio[ZmAttachmentPicker.NONE].checked){
this.setQuery("attachment:none")
}else{
if(this._radio[ZmAttachmentPicker.FILE].checked){
if(this._fileNameInput.value.trim()==""){
this.setQuery("");
return
}
var o="filename:("+this._fileNameInput.value+")";
this.setQuery(o);
return
}else{
var t=[];
for(var n in this._checkedItems){
var s=this._attsByDesc[n];
for(var e=0;
e<s.length;
e++){
t.push('"'+s[e].type+'"')
}}
if(t.length){
var a=t.join(" OR ");
if(t.length>1){
a="("+a+")"
}
this.setQuery("attachment:"+a)
}else{
this.setQuery("")
}}}}
this.execute()
};
ZmAttachmentPicker.prototype._treeListener=function(a){
if(a.detail==DwtTree.ITEM_CHECKED){
var e=a.item;
var t=e.getChecked();
if(t){
this._checkedItems[e.getData(ZmAttachmentPicker.ATT_KEY)]=true
}else{
delete this._checkedItems[e.getData(ZmAttachmentPicker.ATT_KEY)]
}
this._updateQuery()
}};
ZmAttachmentPicker._radioChange=function(o){
var a=DwtUiEvent.getTarget(o);
var t=a._picker;
Dwt.setVisible(t._treeDiv,(a._radioId==ZmAttachmentPicker.SPEC));
var e=a._radioId==ZmAttachmentPicker.FILE?Dwt.DISPLAY_BLOCK:Dwt.DISPLAY_NONE;
Dwt.setDisplay(t._fileNameDiv,e);
if(a._radioId==ZmAttachmentPicker.FILE){
t._fileNameInput.focus();
return
}
t._updateQuery()
};
ZmAttachmentPicker._onChange=function(o){
var a=DwtUiEvent.getTarget(o);
var t=Dwt.getObjectFromElement(a);
var e=DwtKeyEvent.getCharCode(o);
if(e==13||e==3||e==9){
t.execute();
return false
}else{
t._updateQuery();
return true
}}
}
if(AjxPackage.define("zimbraMail.share.view.picker.ZmBasicPicker")){
ZmBasicPicker=function(t){
ZmPicker.call(this,t,ZmPicker.BASIC);
var e=appCtxt.getSettings();
var a=new AjxListener(this,this._settingChangeListener);
e.getSetting(ZmSetting.SEARCH_INCLUDES_SPAM).addChangeListener(a);
e.getSetting(ZmSetting.SEARCH_INCLUDES_TRASH).addChangeListener(a)
};
ZmBasicPicker.prototype=new ZmPicker;
ZmBasicPicker.prototype.constructor=ZmBasicPicker;
ZmPicker.CTOR[ZmPicker.BASIC]=ZmBasicPicker;
ZmBasicPicker.prototype.toString=function(){
return"ZmBasicPicker"
};
ZmBasicPicker.prototype._makeRow=function(o,n){
var a=17;
var t=[];
var e=0;
t[e++]="<tr valign='middle'>";
t[e++]="<td align='right' nowrap>";
t[e++]=AjxMessageFormat.format(ZmMsg.makeLabel,o);
t[e++]="</td>";
t[e++]="<td align='left' nowrap><input type='text' autocomplete='off' nowrap size='";
t[e++]=a;
t[e++]="' id='";
t[e++]=n;
t[e++]="'/></td>";
t[e++]="</tr>";
return t.join("")
};
ZmBasicPicker.prototype._setupPicker=function(d){
var h=new DwtComposite(d);
var n=Dwt.getNextId();
var a=Dwt.getNextId();
var o=Dwt.getNextId();
var e=Dwt.getNextId();
var l=Dwt.getNextId();
var t,c;
var r=[];
var s=0;
r[s++]="<table cellpadding='5' cellspacing='0' border='0' width='100%'>";
r[s++]=this._makeRow(ZmMsg.from,n);
r[s++]=this._makeRow(ZmMsg.toCc,a);
r[s++]=this._makeRow(ZmMsg.subject,o);
r[s++]=this._makeRow(ZmMsg.content,e);
r[s++]="</table>";
r[s++]="<div style='overflow:hidden; padding-left: 20px;'>";
if(appCtxt.get(ZmSetting.SPAM_ENABLED)){
t=Dwt.getNextId();
c=appCtxt.get(ZmSetting.SEARCH_INCLUDES_SPAM)?" checked":"";
r[s++]="<span><input type='checkbox'";
r[s++]=c;
r[s++]=" id='";
r[s++]=t;
r[s++]="' /></span>";
r[s++]="<span>";
r[s++]=ZmMsg.includeJunk;
r[s++]="</span>";
r[s++]="<br>"
}
c=appCtxt.get(ZmSetting.SEARCH_INCLUDES_TRASH)?" checked":"";
r[s++]="<span><input type='checkbox'";
r[s++]=c;
r[s++]=" id='";
r[s++]=l;
r[s++]="' /></span>";
r[s++]="<span>";
r[s++]=ZmMsg.includeTrash;
r[s++]="</span>";
r[s++]="</div>";
h.getHtmlElement().innerHTML=r.join("");
this._from=this._setupField(n);
this._to=this._setupField(a);
this._subject=this._setupField(o);
this._content=this._setupField(e);
if(appCtxt.get(ZmSetting.SPAM_ENABLED)){
this._inSpam=this._setupCheckbox(t)
}
this._inTrash=this._setupCheckbox(l)
};
ZmBasicPicker.prototype.setFrom=function(e){
this._from.value=e;
this._updateQuery()
};
ZmBasicPicker.prototype.setTo=function(e){
this._to.value=e;
this._updateQuery()
};
ZmBasicPicker.prototype.setSubject=function(e){
this._subject.value=e;
this._updateQuery()
};
ZmBasicPicker.prototype.setContent=function(e){
this._content.value=e;
this._updateQuery()
};
ZmBasicPicker.prototype._setupField=function(t){
var e=document.getElementById(t);
Dwt.setHandler(e,DwtEvent.ONKEYUP,ZmBasicPicker._onChange);
Dwt.associateElementWithObject(e,this);
return e
};
ZmBasicPicker.prototype._setupCheckbox=function(t){
var e=document.getElementById(t);
Dwt.setHandler(e,DwtEvent.ONCLICK,ZmBasicPicker._onChange);
Dwt.associateElementWithObject(e,this);
return e
};
ZmBasicPicker._onChange=function(o){
var a=DwtUiEvent.getTarget(o);
var t=Dwt.getObjectFromElement(a);
var e=DwtKeyEvent.getCharCode(o);
if(e==13||e==3||e==9){
t.execute();
return false
}else{
t._updateQuery();
return true
}};
ZmBasicPicker.prototype._updateQuery=function(){
var l=[];
var c=AjxStringUtil.trim(this._from.value,true);
if(c.length){
l.push("from:("+c+")")
}
var d=AjxStringUtil.trim(this._to.value,true);
if(d.length){
l.push("(to:("+d+") OR cc:("+d+"))")
}
var h=AjxStringUtil.trim(this._subject.value,true);
if(h.length){
l.push("subject:("+h+")")
}
var n=AjxStringUtil.trim(this._content.value,true);
if(n.length){
l.push("content:("+n+")")
}
var s=[];
var u=appCtxt.get(ZmSetting.SEARCH_INCLUDES_SPAM);
var m=appCtxt.get(ZmSetting.SEARCH_INCLUDES_TRASH);
var o=(this._inSpam&&this._inSpam.checked);
var a=(this._inTrash&&this._inTrash.checked);
if((!u&&o)&&(!m&&a)){
s.push("is:anywhere")
}else{
if(!u&&o){
s.push("is:anywhere not in:trash")
}else{
if(m&&!a){
s.push("not in:trash")
}}
if(!m&&a){
s.push("is:anywhere not in:junk")
}else{
if(u&&!o){
s.push("not in:junk")
}}}
var t=s.length?s.join(" "):null;
var e=(l.length&&((this._cbQuery||t)&&(this._cbQuery!=t)));
var r=l.concat(s);
this.setQuery(r.length?r.join(" "):"");
if(e){
this.execute()
}
this._cbQuery=t
};
ZmBasicPicker.prototype._settingChangeListener=function(t){
if(t.type!=ZmEvent.S_SETTING){
return
}
var e=t.source;
if(e.id==ZmSetting.SEARCH_INCLUDES_SPAM){
this._inSpam.checked=appCtxt.get(ZmSetting.SEARCH_INCLUDES_SPAM);
this._updateQuery()
}else{
if(e.id==ZmSetting.SEARCH_INCLUDES_TRASH){
this._inTrash.checked=appCtxt.get(ZmSetting.SEARCH_INCLUDES_TRASH);
this._updateQuery()
}}}
}
if(AjxPackage.define("zimbraMail.share.view.picker.ZmCustomPicker")){
ZmCustomPicker=function(e){
ZmPicker.call(this,e);
this.setTitle(ZmMsg.search);
this.setImage("Search")
};
ZmCustomPicker.prototype=new ZmPicker;
ZmCustomPicker.prototype.constructor=ZmCustomPicker;
ZmPicker.CTOR[ZmPicker.CUSTOM]=ZmCustomPicker;
ZmCustomPicker.prototype.toString=function(){
return"ZmCustomPicker"
};
ZmCustomPicker.prototype._setupPicker=function(s){
var t=new DwtComposite(s);
var n=24;
var e=Dwt.getNextId();
var o=new Array(20);
var a=0;
o[a++]="<p>"+ZmMsg.addSearch+"</p>";
o[a++]="<center><table cellpadding='2' cellspacing='0' border='0'>";
o[a++]="<tr valign='middle'>";
o[a++]="<td align='right' nowrap>"+ZmMsg.searchLabel+"</td>";
o[a++]="<td align='left' nowrap><input type='text' autocomplete='off' nowrap size='"+n+"' id='"+e+"'/></td>";
o[a++]="</tr>";
o[a++]="</table></center>";
t.getHtmlElement().innerHTML=o.join("");
var r=this._field=document.getElementById(e);
Dwt.setHandler(r,DwtEvent.ONCHANGE,ZmCustomPicker._onChange);
r._picker=this
};
ZmCustomPicker._onChange=function(o){
var a=DwtUiEvent.getTarget(o);
var t=a._picker;
var e=DwtKeyEvent.getCharCode(o);
if(e==13||e==3){
t.execute();
return false
}else{
t._updateQuery();
return true
}};
ZmCustomPicker.prototype._updateQuery=function(){
var e=this._field.value;
if(e){
this.setQuery("("+this._field.value+")")
}else{
this.setQuery("")
}}
}
if(AjxPackage.define("zimbraMail.share.view.picker.ZmDatePicker")){
ZmDatePicker=function(e){
ZmPicker.call(this,e,ZmPicker.DATE)
};
ZmDatePicker.prototype=new ZmPicker;
ZmDatePicker.prototype.constructor=ZmDatePicker;
ZmPicker.CTOR[ZmPicker.DATE]=ZmDatePicker;
ZmDatePicker.SELECT_OPTIONS=[{
label:ZmMsg.isAfter,value:"after",selected:false}
,{
label:ZmMsg.isBefore,value:"before",selected:true}
,{
label:ZmMsg.isOn,value:"date",selected:false}
];
ZmDatePicker.prototype.toString=function(){
return"ZmDatePicker"
};
ZmDatePicker.prototype._setupPicker=function(h){
var r=new DwtComposite(h);
var a=Dwt.getNextId();
var l=Dwt.getNextId();
var s=new Array(11);
var o=0;
s[o++]="<table cellpadding=3 cellspacing=0 border=0 style='width:100%;'>";
s[o++]="<tr align='center' valign='middle'><td align='right' nowrap>";
s[o++]=ZmMsg.dateLabel;
s[o++]="</td><td align='left' id='";
s[o++]=a;
s[o++]="'></td></tr>";
s[o++]="<tr valign='left'>";
s[o++]="<td nowrap align='center' colspan='2' id='";
s[o++]=l;
s[o++]="'></td></tr></table>";
r.getHtmlElement().innerHTML=s.join("");
this._select=new DwtSelect({
parent:this}
);
this._select.addChangeListener(new AjxListener(this,this._dateChangeListener));
for(var o=0;
o<ZmDatePicker.SELECT_OPTIONS.length;
o++){
var n=ZmDatePicker.SELECT_OPTIONS[o];
this._select.addOption(n.label,n.selected,n.value)
}
this._select.reparentHtmlElement(a);
var t=appCtxt.get(ZmSetting.CAL_FIRST_DAY_OF_WEEK)||0;
var e=this._cal=new DwtCalendar({
parent:r,firstDayOfWeek:t}
);
e.setDate(new Date());
e.addSelectionListener(new AjxListener(this,this._calSelectionListener));
e.reparentHtmlElement(l);
this._updateQuery()
};
ZmDatePicker.prototype.secondDate=function(){
this._select.setSelected(0);
var e=new Date(this._cal.getDate().getTime());
AjxDateUtil.roll(e,AjxDateUtil.MONTH,-3);
this._cal.setDate(e);
this._updateQuery()
};
ZmDatePicker.prototype._updateQuery=function(){
var o=this._cal.getDate();
if(o){
var a;
if(appCtxt.getAppController().getAppViewMgr().getCurrentViewId()==ZmId.VIEW_CAL&&this._select.getValue()=="date"){
a=[this._select.getValue(),":",o.getTime()].join("")
}else{
var t=AjxDateFormat.getDateInstance(AjxDateFormat.SEARCH);
var e=t.format(o);
a=[this._select.getValue(),':"',e,'"'].join("")
}
this.setQuery(a)
}else{
this.setQuery("")
}
this.execute()
};
ZmDatePicker.prototype._calSelectionListener=function(e){
this._updateQuery()
};
ZmDatePicker.prototype._dateChangeListener=function(e){
this._updateQuery()
}
}
if(AjxPackage.define("zimbraMail.share.view.picker.ZmDomainPicker")){
ZmDomainPicker=function(e){
ZmPicker.call(this,e,ZmPicker.DOMAIN);
this._checkedItems={};
ZmDomainPicker._instance=this;
this._searchAction=new AjxTimedAction(null,this._search);
this._searchActionId=-1
};
ZmDomainPicker.prototype=new ZmPicker;
ZmDomainPicker.prototype.constructor=ZmDomainPicker;
ZmPicker.CTOR[ZmPicker.DOMAIN]=ZmDomainPicker;
ZmDomainPicker.LIMIT=20;
ZmDomainPicker._onClick=function(a){
var t=DwtUiEvent.getTarget(a);
var e=ZmDomainPicker._instance;
if(t.checked){
e._checkedItems[t.value]=1
}else{
delete e._checkedItems[t.value]
}
e._updateQuery()
};
ZmDomainPicker._onChange=function(a){
var t=DwtUiEvent.getTarget(a);
var e=ZmDomainPicker._instance;
e._updateDomains();
e._updateQuery()
};
ZmDomainPicker._onKeyUp=function(t){
var e=ZmDomainPicker._instance;
if(e._searchActionId!=-1){
AjxTimedAction.cancelAction(e._searchActionId);
e._searchActionId=-1
}
e._searchAction.obj=e;
e._searchAction.args=[e._textField.value];
e._searchActionId=AjxTimedAction.scheduleAction(e._searchAction,300)
};
ZmDomainPicker.prototype.toString=function(){
return"ZmDomainPicker"
};
ZmDomainPicker.prototype._domainHtml=function(n,o,e){
var t=this._divIds[n]=Dwt.getNextId();
var a=this._inputIds[n]=Dwt.getNextId();
o[e++]="<div id='";
o[e++]=t;
o[e++]="'><table cellpadding='0' cellspacing='0' border='0'><tr valign='middle'>";
o[e++]="<td align='left'><input type='checkbox' id='";
o[e++]=a;
o[e++]="'></input></td><td align='left' nowrap>";
o[e++]=n;
o[e++]="</td></tr></table></div>";
return e
};
ZmDomainPicker.prototype._setupPicker=function(l){
this._elements={};
this._divIds={};
this._inputIds={};
var n=new DwtComposite(l);
var t=Dwt.getNextId();
var e=Dwt.getNextId();
var o=Dwt.getNextId();
var c=Dwt.getNextId();
var u=15;
var a=[];
var h=0;
a[h++]="<table cellpadding='3' cellspacing='0' border='0' style='width:100%;'>";
a[h++]="<tr>";
a[h++]="<td align='right' nowrap>";
a[h++]=AjxMessageFormat.format(ZmMsg.makeLabel,ZmMsg.search);
a[h++]="</td>";
a[h++]="<td align='left' nowrap><input type='text' autocomplete='off' nowrap size='";
a[h++]=u;
a[h++]="' id='";
a[h++]=o;
a[h++]="'/></td>";
a[h++]="</tr>";
a[h++]="<tr align='center' valign='middle'>";
a[h++]="<td align='left'><input type='checkbox' checked id='"+t+"'/> "+ZmMsg.from+"</td>";
a[h++]="<td align='left'><input type='checkbox' id='"+e+"'/> "+ZmMsg.toCc+"</td>";
a[h++]="</tr>";
a[h++]="<tr>";
a[h++]="<td nowrap align='left' colspan='2'><hr /></td>";
a[h++]="</tr></table>";
a[h++]="<div id='";
a[h++]=c;
a[h++]="'></div>";
this._picker.getHtmlElement().innerHTML=a.join("");
var r=this._from=document.getElementById(t);
Dwt.setHandler(r,DwtEvent.ONCHANGE,ZmDomainPicker._onChange);
var s=this._to=document.getElementById(e);
Dwt.setHandler(s,DwtEvent.ONCHANGE,ZmDomainPicker._onChange);
var d=this._textField=document.getElementById(o);
Dwt.setHandler(d,DwtEvent.ONKEYUP,ZmDomainPicker._onKeyUp);
this._domainsDiv=document.getElementById(c);
this._search()
};
ZmDomainPicker.prototype._search=function(e){
respCallback=new AjxCallback(this,this._handleResponseSearch);
ZmDomainTree.search(e,ZmDomainPicker.LIMIT,respCallback)
};
ZmDomainPicker.prototype._handleResponseSearch=function(e){
ZmDomainPicker.domains=e;
this._showDomains(e)
};
ZmDomainPicker.prototype._showDomains=function(t){
var o=[];
var e=0;
for(var a in t){
e=this._domainHtml(t[a].name,o,e)
}
this._domainsDiv.innerHTML=o.join("");
for(var a in t){
var n=t[a];
var s=document.getElementById(this._inputIds[n.name]);
Dwt.setHandler(s,DwtEvent.ONCLICK,ZmDomainPicker._onClick);
s.value=n.name;
s._div=document.getElementById(this._divIds[n.name]);
this._elements[n.name]=s
}
this._updateDomains()
};
ZmDomainPicker.prototype._updateDomains=function(e){
var e=ZmDomainPicker.domains;
for(var a in e){
var n=e[a];
var o=this._elements[n.name];
var t=(this._from.checked&&n.hasFrom)||(this._to.checked&&(n.hasTo||n.hasCc));
if(Dwt.getVisible(o._div)!=t){
Dwt.setVisible(o._div,t)
}
o.checked=false
}
this._checkedItems={}
};
ZmDomainPicker.prototype._updateQuery=function(){
var c=new Array(10);
var s=new Array(10);
var r=0;
var n=0;
var t=[];
if(this._from.checked){
t.push("from")
}
if(this._to.checked){
t.push("to","cc")
}
var e=t.length;
if(e==0){
this.setQuery("");
this.execute();
return
}
c[r++]="(";
for(var a in this._checkedItems){
if(n++>0){
c[r++]=" OR "
}
c[r++]="@"+a
}
if(n>0){
c[r++]=")";
var l=c.join("");
r=0;
if(e>1){
s[r++]="("
}
for(var o in t){
if(o>0){
s[r++]=" OR "
}
s[r++]=t[o];
s[r++]=":";
s[r++]=l
}
if(e>1){
s[r++]=")"
}
this.setQuery(s.join(""))
}else{
this.setQuery("")
}
this.execute()
}
}
if(AjxPackage.define("zimbraMail.share.view.picker.ZmFlagPicker")){
ZmFlagPicker=function(e){
ZmPicker.call(this,e,ZmPicker.FLAG)
};
ZmFlagPicker.prototype=new ZmPicker;
ZmFlagPicker.prototype.constructor=ZmFlagPicker;
ZmPicker.CTOR[ZmPicker.FLAG]=ZmFlagPicker;
ZmFlagPicker.prototype.toString=function(){
return"ZmFlagPicker"
};
ZmFlagPicker.prototype._setupPicker=function(t){
var e=this._tree=new DwtTree({
parent:t,style:DwtTree.CHECKEDITEM_STYLE,isCheckedByDefault:false}
);
e.addSelectionListener(new AjxListener(this,ZmFlagPicker.prototype._treeListener));
var a=this._flagged=new DwtTreeItem({
parent:e,text:ZmMsg.flagged,imageInfo:"FlagRed"}
);
a=this._unflagged=new DwtTreeItem({
parent:e,text:ZmMsg.unflagged,imageInfo:"FlagDis"}
);
e.addSeparator();
a=this._read=new DwtTreeItem({
parent:e,text:ZmMsg.read,imageInfo:"ReadMessage"}
);
a=this._unread=new DwtTreeItem({
parent:e,text:ZmMsg.unread,imageInfo:"UnreadMessage"}
);
e.addSeparator();
a=this._replied=new DwtTreeItem({
parent:e,text:ZmMsg.replied,imageInfo:"Reply"}
);
a=this._forwarded=new DwtTreeItem({
parent:e,text:ZmMsg.forwarded,imageInfo:"Forward"}
)
};
ZmFlagPicker.prototype._updateQuery=function(){
var e=[];
if(this._flagged.getChecked()){
e.push("is:flagged")
}else{
if(this._unflagged.getChecked()){
e.push("is:unflagged")
}}
if(this._read.getChecked()){
e.push("is:read")
}else{
if(this._unread.getChecked()){
e.push("is:unread")
}}
if(this._replied.getChecked()){
e.push("is:replied")
}
if(this._forwarded.getChecked()){
e.push("is:forwarded")
}
this.setQuery(e.length?(e.join(" ")):"");
this.execute()
};
ZmFlagPicker.prototype._treeListener=function(a){
if(a.detail==DwtTree.ITEM_CHECKED){
var e=a.item;
var t=e.getChecked();
if(e==this._flagged&&t&&this._unflagged.getChecked()){
this._unflagged.setChecked(false)
}else{
if(e==this._unflagged&&t&&this._flagged.getChecked()){
this._flagged.setChecked(false)
}else{
if(e==this._read&&t&&this._unread.getChecked()){
this._unread.setChecked(false)
}else{
if(e==this._unread&&t&&this._read.getChecked()){
this._read.setChecked(false)
}}}}
this._updateQuery()
}}
}
if(AjxPackage.define("zimbraMail.share.view.picker.ZmFolderPicker")){
ZmFolderPicker=function(e){
ZmPicker.call(this,e,ZmPicker.FOLDER);
this._checkedItems=new AjxVector()
};
ZmFolderPicker._OVERVIEW_ID="ZmFolderPicker";
ZmFolderPicker.prototype=new ZmPicker;
ZmFolderPicker.prototype.constructor=ZmFolderPicker;
ZmPicker.CTOR[ZmPicker.FOLDER]=ZmFolderPicker;
ZmFolderPicker.prototype.toString=function(){
return"ZmFolderPicker"
};
ZmFolderPicker.prototype._setupPicker=function(e){
var t=ZmFolderPicker._OVERVIEW_ID+"_"+Dwt.getNextId();
this._setOverview(t,e,[ZmOrganizer.FOLDER]);
this._twiddle()
};
ZmFolderPicker.prototype._updateQuery=function(){
var o=[];
var t=this._checkedItems.size();
for(var a=0;
a<t;
a++){
var n=this._checkedItems.get(a);
o.push(n.createQuery(true))
}
var s="";
if(o.length){
var e=o.join(" OR ");
if(o.length>1){
e="("+e+")"
}
s+="in:"+e
}
this.setQuery(s);
this.execute()
};
ZmFolderPicker.prototype._treeListener=function(o){
if(o.detail==DwtTree.ITEM_CHECKED){
var e=o.item;
var a=e.getChecked();
var t=e.getData(Dwt.KEY_OBJECT);
if(e.getChecked()){
this._checkedItems.add(t)
}else{
this._checkedItems.remove(t)
}
this._updateQuery()
}};
ZmFolderPicker.prototype._twiddle=function(){
for(var a in this._treeView){
var t=this._treeView[a];
for(var n in t._treeItemHash){
var o=t._treeItemHash[n];
var e=o.getData(Dwt.KEY_OBJECT);
if(e.type==ZmOrganizer.SEARCH){
o.setVisible(false)
}}}}
}
if(AjxPackage.define("zimbraMail.share.view.picker.ZmZimletPicker")){
ZmZimletPicker=function(e){
ZmPicker.call(this,e,ZmPicker.ZIMLET)
};
ZmZimletPicker.prototype=new ZmPicker();
ZmZimletPicker.prototype.constructor=ZmZimletPicker;
ZmPicker.CTOR[ZmPicker.ZIMLET]=ZmZimletPicker;
ZmZimletPicker.prototype.toString=function(){
return"ZmZimletPicker"
};
ZmZimletPicker.prototype._addZimlet=function(t,n,e,o){
var a=this._zimlets[o]=new DwtTreeItem({
parent:t}
);
a.setText(n);
a.setImage(e)
};
ZmZimletPicker.prototype._setupPicker=function(a){
this._zimlets={};
var t=appCtxt.getZimletMgr().getIndexedZimlets();
if(t.length){
var e=this._tree=new DwtTree({
parent:a,style:DwtTree.CHECKEDITEM_STYLE}
);
e.addSelectionListener(new AjxListener(this,ZmZimletPicker.prototype._treeListener));
for(var o=0;
o<t.length;
o+=1){
this._addZimlet(e,t[o].description,t[o].icon,t[o].keyword)
}}};
ZmZimletPicker.prototype._updateQuery=function(){
var e=new Array();
for(var t in this._zimlets){
if(this._zimlets[t].getChecked()){
e.push(t)
}}
if(e.length){
var a=e.join(" OR ");
if(e.length>1){
a="("+a+")"
}
this.setQuery("has:"+a)
}else{
this.setQuery("")
}
this.execute()
};
ZmZimletPicker.prototype._treeListener=function(e){
if(e.detail==DwtTree.ITEM_CHECKED){
this._updateQuery()
}}
}
if(AjxPackage.define("zimbraMail.share.view.picker.ZmSavedSearchPicker")){
ZmSavedSearchPicker=function(e){
ZmPicker.call(this,e,ZmPicker.SEARCH);
this._checkedItems=new AjxVector()
};
ZmSavedSearchPicker._OVERVIEW_ID="ZmSavedSearchPicker";
ZmSavedSearchPicker.prototype=new ZmPicker;
ZmSavedSearchPicker.prototype.constructor=ZmSavedSearchPicker;
ZmPicker.CTOR[ZmPicker.SEARCH]=ZmSavedSearchPicker;
ZmSavedSearchPicker.prototype.toString=function(){
return"ZmSavedSearchPicker"
};
ZmSavedSearchPicker.prototype._setupPicker=function(e){
var t=ZmSavedSearchPicker._OVERVIEW_ID+"_"+Dwt.getNextId();
this._setOverview(t,e,[ZmOrganizer.FOLDER,ZmOrganizer.SEARCH]);
this._twiddle()
};
ZmSavedSearchPicker.prototype._updateQuery=function(){
var n=[];
var t=this._checkedItems.size();
for(var o=0;
o<t;
o++){
var a=this._checkedItems.get(o);
n.push("("+a.query+")")
}
var s="";
if(n.length){
if(s.length){
s+=" OR "
}
var e=n.join(" OR ");
if(n.length>1){
e="("+e+")"
}
s+=e
}
if(t==1){
this._searchId=this._checkedItems.get(0).searchId
}
this.setQuery(s);
this.execute()
};
ZmSavedSearchPicker.prototype._treeListener=function(o){
if(o.detail==DwtTree.ITEM_CHECKED){
var t=o.item;
var a=t.getChecked();
var e=t.getData(Dwt.KEY_OBJECT).search;
if(t.getChecked()){
this._checkedItems.add(e)
}else{
this._checkedItems.remove(e)
}
this._updateQuery()
}};
ZmSavedSearchPicker.prototype._twiddle=function(){
for(var o in this._treeView){
var t=this._treeView[o];
var a=t.getHeaderItem();
if(a){
a.setExpanded(true,true);
a.setVisible(false,true)
}
for(var s in t._treeItemHash){
var n=t._treeItemHash[s];
var e=n.getData(Dwt.KEY_OBJECT);
if(e.type==ZmOrganizer.FOLDER&&e.nId!=ZmOrganizer.ID_ROOT){
if(e.hasSearch()){
if(n._checkBoxCell){
Dwt.setVisible(n._checkBoxCell,false)
}}else{
n.setVisible(false)
}}}}}
}
if(AjxPackage.define("zimbraMail.share.view.picker.ZmSizePicker")){
ZmSizePicker=function(e){
ZmPicker.call(this,e,ZmPicker.SIZE)
};
ZmSizePicker.prototype=new ZmPicker;
ZmSizePicker.prototype.constructor=ZmSizePicker;
ZmPicker.CTOR[ZmPicker.SIZE]=ZmSizePicker;
ZmSizePicker.OP_SELECT_OPTIONS=[{
label:ZmMsg.larger,value:"larger",selected:true}
,{
label:ZmMsg.smaller,value:"smaller",selected:false}
];
ZmSizePicker.UNIT_SELECT_OPTIONS=[{
label:ZmMsg.bytes,value:"b",selected:false}
,{
label:ZmMsg.kilobytes,value:"kb",selected:true}
,{
label:ZmMsg.megabytes,value:"mb",selected:false}
];
ZmSizePicker.prototype.toString=function(){
return"ZmSizePicker"
};
ZmSizePicker.prototype._setupPicker=function(l){
var n=new DwtComposite(l);
var h=Dwt.getNextId();
var c=Dwt.getNextId();
var s=Dwt.getNextId();
var o=new Array(21);
var t=0;
o[t++]="<center><table cellpadding=5 cellspacing=0 border=0>";
o[t++]="<tr valign='middle'><td align='right' nowrap>";
o[t++]=ZmMsg.sizeLabel;
o[t++]="</td><td align='left' nowrap colspan=1 id='";
o[t++]=h;
o[t++]="'></td></tr>";
o[t++]="<tr valign='middle'><td align='right' nowrap>";
o[t++]=ZmMsg.valueLabel;
o[t++]="</td>";
o[t++]="<td align='left' nowrap><div id='";
o[t++]=s;
o[t++]="'></td></tr>";
o[t++]="<tr valign='middle'><td align='right' nowrap>";
o[t++]=ZmMsg.unitsLabel;
o[t++]="</td><td align='left' nowrap id='";
o[t++]=c;
o[t++]="'></td></tr>";
o[t++]="</table></center>";
n.getHtmlElement().innerHTML=o.join("");
var e=new AjxListener(this,this._selectChangeListener);
this._op=new DwtSelect({
parent:this}
);
this._op.addChangeListener(e);
for(var t=0;
t<ZmSizePicker.OP_SELECT_OPTIONS.length;
t++){
var a=ZmSizePicker.OP_SELECT_OPTIONS[t];
this._op.addOption(a.label,a.selected,a.value)
}
this._op.reparentHtmlElement(h);
this._units=new DwtSelect({
parent:this}
);
this._units.addChangeListener(e);
for(var t=0;
t<ZmSizePicker.UNIT_SELECT_OPTIONS.length;
t++){
var a=ZmSizePicker.UNIT_SELECT_OPTIONS[t];
this._units.addOption(a.label,a.selected,a.value)
}
this._units.reparentHtmlElement(c);
var r={
parent:this,size:16,type:DwtInputField.INTEGER,validator:ZmSizePicker._validateSize,validationStyle:DwtInputField.CONTINUAL_VALIDATION};
this._size=new DwtInputField(r);
this._size.setValidNumberRange(0,null);
this._size.addListener(DwtEvent.ONKEYUP,new AjxListener(this,this._onKeyUp));
this._size.replaceElement(s);
document.getElementById(s)
};
ZmSizePicker.prototype._updateQuery=function(){
var e=this._size.isValid();
if(e){
this.setQuery(this._op.getValue()+":"+e+this._units.getValue())
}else{
this.setQuery("")
}};
ZmSizePicker.prototype._selectChangeListener=function(e){
this._updateQuery();
this.execute()
};
ZmSizePicker.prototype._onKeyUp=function(t){
var e=DwtKeyEvent.getCharCode(t);
if(e==13||e==3){
this.execute()
}else{
this._updateQuery()
}};
ZmSizePicker._validateSize=function(e){
if(e&&!e.match(/^[1-9][0-9]*$/)){
throw ZmMsg.errorInvalidSize
}
return e
}
}
if(AjxPackage.define("zimbraMail.share.view.picker.ZmTagPicker")){
ZmTagPicker=function(e){
ZmPicker.call(this,e,ZmPicker.TAG);
this._checkedItems={}
};
ZmTagPicker._OVERVIEW_ID="ZmTagPicker";
ZmTagPicker.prototype=new ZmPicker;
ZmTagPicker.prototype.constructor=ZmTagPicker;
ZmPicker.CTOR[ZmPicker.TAG]=ZmTagPicker;
ZmTagPicker.prototype.toString=function(){
return"ZmTagPicker"
};
ZmTagPicker.prototype._setupPicker=function(e){
var t=ZmTagPicker._OVERVIEW_ID+"_"+Dwt.getNextId();
this._setOverview(t,e,[ZmOrganizer.TAG])
};
ZmTagPicker.prototype._updateQuery=function(){
var a=[];
for(var o in this._checkedItems){
var e=this._checkedItems[o];
a.push('"'+e.name+'"')
}
var t=a.length;
if(t){
var n=a.join(" OR ");
if(t>1){
n="("+n+")"
}
this.setQuery("tag:"+n)
}else{
this.setQuery("")
}
this.execute()
};
ZmTagPicker.prototype._treeListener=function(n){
if(n.detail==DwtTree.ITEM_CHECKED){
var a=n.item;
var o=a.getChecked();
var t=a.getData(Dwt.KEY_ID);
var e=a.getData(Dwt.KEY_OBJECT);
if(a.getChecked()){
this._checkedItems[t]=e
}else{
delete this._checkedItems[t]
}
this._updateQuery()
}}
}
if(AjxPackage.define("zimbraMail.share.view.picker.ZmTimePicker")){
ZmTimePicker=function(e){
ZmPicker.call(this,e,ZmPicker.TIME);
this._checkedItems=new Object()
};
ZmPicker.CTOR[ZmPicker.TIME]=ZmTimePicker;
ZmTimePicker._onClick=function(a){
var t=DwtUiEvent.getTarget(a);
var e=t._picker;
if(t.checked){
e._checkedItems[t._query]=true
}else{
delete e._checkedItems[t._query]
}
e._updateQuery()
};
ZmTimePicker.prototype=new ZmPicker;
ZmTimePicker.prototype.constructor=ZmTimePicker;
ZmTimePicker.prototype.toString=function(){
return"ZmTimePicker"
};
ZmTimePicker.prototype._makeRow=function(r,n,o,s){
var a=20;
var t=new Array(10);
var e=0;
t[e++]="<tr valign='middle'>";
t[e++]="<td align='left' nowrap><input id='"+n+"' type='checkbox' value='"+r+"'></input></td>";
t[e++]="<td align='left' nowrap>"+r+"</td>";
t[e++]="<td align='left' nowrap><input id='"+s+"' type='checkbox'></input></td>";
t[e++]="<td align='left' nowrap>"+o+"</td>";
t[e++]="</tr>";
return t.join("")
};
ZmTimePicker.prototype._setupPicker=function(m){
var l=new DwtComposite(m);
var r=Dwt.getNextId();
var u=Dwt.getNextId();
var c=Dwt.getNextId();
var e=Dwt.getNextId();
var t=Dwt.getNextId();
var h=Dwt.getNextId();
var f=Dwt.getNextId();
var o=Dwt.getNextId();
var a=Dwt.getNextId();
var d=Dwt.getNextId();
var s=new Array(10);
var n=0;
s[n++]="<table cellpadding='2' cellspacing='0' border='0'>";
s[n++]=this._makeRow(ZmMsg.P_TIME_LAST_HOUR,r,ZmMsg.P_TIME_LAST_4_HOURS,u);
s[n++]=this._makeRow(ZmMsg.P_TIME_TODAY,c,ZmMsg.P_TIME_YESTERDAY,e);
s[n++]=this._makeRow(ZmMsg.P_TIME_THIS_WEEK,t,ZmMsg.P_TIME_LAST_WEEK,h);
s[n++]=this._makeRow(ZmMsg.P_TIME_THIS_MONTH,f,ZmMsg.P_TIME_LAST_MONTH,o);
s[n++]=this._makeRow(ZmMsg.P_TIME_THIS_YEAR,a,ZmMsg.P_TIME_LAST_YEAR,d);
s[n++]="</table>";
l.getHtmlElement().innerHTML=s.join("");
this._installOnClick(r,"date:>-60mi");
this._installOnClick(u,"date:>-240mi");
this._installOnClick(c,"date:-0day");
this._installOnClick(e,"date:yesterday");
this._installOnClick(t,"date:-0week");
this._installOnClick(h,"date:-1week");
this._installOnClick(f,"date:-0month");
this._installOnClick(o,"date:-1month");
this._installOnClick(a,"date:-0year");
this._installOnClick(d,"date:-1year")
};
ZmTimePicker.prototype._installOnClick=function(a,t){
var e=document.getElementById(a);
Dwt.setHandler(e,DwtEvent.ONCLICK,ZmTimePicker._onClick);
e._query=t;
e._picker=this
};
ZmTimePicker.prototype._updateQuery=function(){
var t=new Array();
for(var e in this._checkedItems){
t.push(e)
}
var a="";
if(t.length>1){
a+="("
}
a+=t.join(" OR ");
if(t.length>1){
a+=")"
}
this.setQuery(a);
this.execute()
}
}
if(AjxPackage.define("zimbraMail.share.controller.ZmBrowseController")){
ZmBrowseController=function(a){
ZmController.call(this,null);
var n=this._allPickers=this._getPickers();
this._browseView=new ZmBrowseView(this._shell,n);
this._toolbar=new ZmBrowseToolBar(this._shell,n);
this._browseView._toolbar=this._toolbar;
var t=new AjxListener(this,this._addPickerListener);
for(var e=0;
e<n.length;
e++){
var s=n[e];
this._toolbar.addSelectionListener(s,t)
}
this._toolbar.addSelectionListener(ZmPicker.RESET,new AjxListener(this,this._resetListener));
this._toolbar.addSelectionListener(ZmPicker.CLOSE,new AjxListener(this,this._closeListener));
this._resetPickers();
this._browseViewVisible=false;
var o={};
o[ZmAppViewMgr.C_SEARCH_BUILDER_TOOLBAR]=this._toolbar;
o[ZmAppViewMgr.C_SEARCH_BUILDER]=this._browseView;
appCtxt.getAppViewMgr().addComponents(o,true);
this._searchBuilderOpened=false
};
ZmBrowseController.prototype=new ZmController;
ZmBrowseController.prototype.constructor=ZmBrowseController;
ZmBrowseController.prototype.toString=function(){
return"ZmBrowseController"
};
ZmBrowseController.prototype._getPickers=function(){
var t=ZmPicker.DEFAULT_PICKERS;
if(appCtxt.get(ZmSetting.SAVED_SEARCHES_ENABLED)){
t.push(ZmPicker.SEARCH)
}
t.push(ZmPicker.SIZE);
if(appCtxt.zimletsPresent()){
var e=appCtxt.getZimletMgr().getIndexedZimlets();
if(e.length){
t.push(ZmPicker.ZIMLET)
}}
t.push(ZmPicker.FLAG);
if(appCtxt.get(ZmSetting.TAGGING_ENABLED)){
t.push(ZmPicker.TAG)
}
t.push(ZmPicker.TIME);
return t
};
ZmBrowseController.prototype.getBrowseView=function(){
return(appCtxt.get(ZmSetting.BROWSE_ENABLED))?this._browseView:null
};
ZmBrowseController.prototype.getBrowseViewVisible=function(){
return this._browseViewVisible
};
ZmBrowseController.prototype.setBrowseViewVisible=function(n){
if(this._browseViewVisible==n){
return
}
var a,t;
if(AjxEnv.isGeckoBased&&skin.getTopAdContainer()){
a=skin._getEl("skin_table_outer");
t=a.offsetHeight
}
appCtxt.getAppViewMgr().showSearchBuilder(n);
if(AjxEnv.isGeckoBased&&skin.getTopAdContainer()){
a.style.height=t+"px";
setTimeout(function(){
a.style.height="100%"
}
,10)
}
if(n&&!this._searchBuilderOpened){
appCtxt.getAppViewMgr().showSearchBuilder(!n);
appCtxt.getAppViewMgr().showSearchBuilder(n);
this._searchBuilderOpened=true
}
var o=appCtxt.getSearchController();
this._browseViewVisible=n;
if(n){
if(this._browseView.getPickers().size()==0){
this.addPicker(ZmPicker.DEFAULT_PICKER)
}
if(this._query){
o.setSearchField(this._query)
}}
var e=o.getSearchToolbar().getButton(ZmSearchToolBar.BROWSE_BUTTON);
e.setToolTipContent(n?ZmMsg.closeSearchBuilder:ZmMsg.openSearchBuilder);
e.setSelected(n)
};
ZmBrowseController.prototype._updateQuery=function(c){
var h={};
var d=0;
for(var t in this._pickers){
var m=this._pickers[t].getArray();
for(var r=0;
r<m.length;
r++){
var o=m[r]._query;
if(o&&o.length){
if(!h[t]){
h[t]=[];
d++
}
h[t].push(o)
}}}
var s=[];
for(var t in h){
var m=h[t];
if(m&&m.length){
if(m.length>1){
var e=[];
var n=ZmPicker.MULTI_JOIN[t];
var l=(n!=" ");
for(var r=0;
r<m.length;
r++){
e.push((l&&m.length>1)?"("+m[r]+")":m[r])
}
var u=e.join(n);
if(l&&d>1){
u="("+u+")"
}
s.push(u)
}else{
s.push(m[0])
}}}
if(appCtxt.get(ZmSetting.SAVED_SEARCHES_ENABLED)){
var m=this._pickers[ZmPicker.SEARCH].getArray();
this._searchId=null;
if(m&&(m.length==1)&&(s.length==1)){
this._searchId=m[0]._searchId
}}
var f=s.join(" ");
if(f!=this._query){
this._query=f;
if(c){
appCtxt.getSearchController().search({
query:this._query,searchId:this._searchId}
)
}else{
appCtxt.getSearchController().setSearchField(this._query)
}}};
ZmBrowseController.prototype._executeQuery=function(){
appCtxt.getSearchController().search({
query:this._query,searchId:this._searchId}
)
};
ZmBrowseController.prototype._resetListener=function(e){
this.removeAllPickers()
};
ZmBrowseController.prototype._closeListener=function(e){
this.setBrowseViewVisible(false)
};
ZmBrowseController.prototype.removeAllPickers=function(e){
this._browseView.removeAllPickers();
this._clearQuery();
this._resetPickers()
};
ZmBrowseController.prototype.addPicker=function(o){
if(ZmPicker.LIMIT[o]!=-1&&this._pickers[o].size()>=ZmPicker.LIMIT[o]){
return
}
var a=ZmPicker.CTOR[o];
var t=new a(this._browseView);
this._browseView.addPicker(t,o);
this._pickers[o].add(t);
this._numPickers++;
if(o==ZmPicker.DATE&&this._pickers[o].size()==ZmPicker.LIMIT[o]){
t.secondDate()
}
var e=t.getCloseButton();
e.setData(ZmPicker.KEY_ID,o);
e.setData(ZmPicker.KEY_PICKER,t);
e.addSelectionListener(new AjxListener(this,this._pickerCloseListener));
t.addPickerListener(new AjxListener(this,this._pickerListener));
this._updateQuery(true);
if(ZmPicker.LIMIT[o]!=-1&&this._pickers[o].size()==ZmPicker.LIMIT[o]){
this._toolbar.enable(o,false)
}
return t
};
ZmBrowseController.prototype._addPickerListener=function(e){
var t=e.item.getData(ZmPicker.KEY_ID);
this.addPicker(t)
};
ZmBrowseController.prototype._pickerCloseListener=function(a){
var e=a.item;
var t=e.getData(ZmPicker.KEY_PICKER);
this._browseView.removePicker(t);
var o=e.getData(ZmPicker.KEY_ID);
this._pickers[o].remove(t);
this._numPickers--;
if(this._numPickers==0){
this._clearQuery()
}else{
this._updateQuery(true)
}
if(ZmPicker.LIMIT[o]!=-1&&this._pickers[o].size()<ZmPicker.LIMIT[o]){
this._toolbar.enable(o,true)
}};
ZmBrowseController.prototype._clearQuery=function(){
this._query="";
appCtxt.getSearchController().setSearchField("")
};
ZmBrowseController.prototype._pickerListener=function(e){
if(e.type!=ZmEvent.S_PICKER){
return
}
if(e.event==ZmEvent.E_MODIFY){
this._updateQuery(false)
}else{
if(e.event==ZmEvent.E_LOAD){
this._executeQuery()
}}};
ZmBrowseController.prototype._resetPickers=function(){
this._pickers={};
for(var e=0;
e<this._allPickers.length;
e++){
var t=this._allPickers[e];
this._pickers[t]=new AjxVector();
this._toolbar.enable(t,true)
}
this._numPickers=0
}
}};
