
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
if(AjxPackage.define("Mixed")){
if(AjxPackage.define("zimbraMail.mixed.view.ZmMixedView")){
ZmMixedView=function(e){
e.headerList=this._getHeaderList(parent);
e.view=ZmId.VIEW_MIXED;
e.type=ZmItem.MIXED;
ZmListView.call(this,e);
this._mixedController=e.controller
};
ZmMixedView.prototype=new ZmListView;
ZmMixedView.prototype.constructor=ZmMixedView;
ZmMixedView.COLWIDTH_ICON=19;
ZmMixedView.COLWIDTH_FROM=ZmMsg.COLUMN_WIDTH_FROM_CLV;
ZmMixedView.COLWIDTH_DATE=ZmMsg.COLUMN_WIDTH_DATE;
ZmMixedView.LV_CLASS={};
ZmMixedView.LV_CLASS[ZmItem.CONTACT]="ZmContactSimpleView";
ZmMixedView.LV_CLASS[ZmItem.GROUP]="ZmContactSimpleView";
ZmMixedView.LV_CLASS[ZmItem.CONV]="ZmConvListView";
ZmMixedView.LV_CLASS[ZmItem.MSG]="ZmMailMsgListView";
ZmMixedView.LV_CLASS[ZmItem.APPT]="ZmApptListView";
ZmMixedView.LV_CLASS[ZmItem.TASK]="ZmTaskListView";
ZmMixedView.LV_CLASS[ZmItem.PAGE]="ZmFileListView";
ZmMixedView.LV_CLASS[ZmItem.BRIEFCASE_ITEM]="ZmDetailListView";
ZmMixedView.LV_FUNCS=["_addParams","_getDiv","_getDivClass","_getTable","_getRow","_getRowClass","_getRowId","_getCell","_getCellId","_getCellClass","_getCellAttrText","_getCellContents","_getFieldId","_getDisplayName"];
ZmMixedView.LV_ADDED_FUNCS={};
ZmMixedView.LV_ADDED_FUNCS[ZmItem.CONV]=["_getFragmentSpan","_getFragmentHtml","_getStyleViaZimlet","_getParticipantHtml","_fitParticipants","_isOutboundFolder"];
ZmMixedView.LV_ADDED_FUNCS[ZmItem.MSG]=["_getFragmentSpan","_getFragmentHtml","_getStyleViaZimlet","_isOutboundFolder"];
ZmMixedView.LV_FUNCS_TT={};
ZmMixedView.LV_FUNCS_TT[ZmItem.CONV]=["_getParticipantToolTip","_handleResponseGetContact"];
ZmMixedView.LV_FUNCS_TT[ZmItem.MSG]=["_getParticipantToolTip","_handleResponseGetContact"];
ZmMixedView.LV_SAVE={};
ZmMixedView.prototype.toString=function(){
return"ZmMixedView"
};
ZmMixedView.prototype.set=function(s,t){
ZmListView.prototype.set.call(this,s,t);
var e=s.getArray();
var n={};
for(var a=0;
a<e.length;
a++){
var s=e[a].list;
if(s){
n[s.type]=s
}}
for(var o in n){
n[o].addChangeListener(this._listChangeListener)
}};
ZmMixedView.prototype._getHeaderList=function(t){
var e=[];
if(appCtxt.get(ZmSetting.SHOW_SELECTION_CHECKBOX)){
e.push(new DwtListHeaderItem({
field:ZmItem.F_SELECTION,icon:"CheckboxUnchecked",width:ZmMixedView.COLWIDTH_ICON}
))
}
if(appCtxt.get(ZmSetting.TAGGING_ENABLED)){
e.push(new DwtListHeaderItem({
field:ZmItem.F_TAG,icon:"Tag",width:ZmMixedView.COLWIDTH_ICON}
))
}
e.push(new DwtListHeaderItem({
field:ZmItem.F_TYPE,icon:"Globe",width:ZmMixedView.COLWIDTH_ICON}
));
e.push(new DwtListHeaderItem({
field:ZmItem.F_FROM,text:ZmMsg.from,width:ZmMixedView.COLWIDTH_FROM,resizeable:true}
));
e.push(new DwtListHeaderItem({
field:ZmItem.F_ATTACHMENT,icon:"Attachment",width:ZmMixedView.COLWIDTH_ICON}
));
e.push(new DwtListHeaderItem({
field:ZmItem.F_SUBJECT,text:ZmMsg.subject,resizeable:true}
));
e.push(new DwtListHeaderItem({
field:ZmItem.F_DATE,text:ZmMsg.date,width:ZmMixedView.COLWIDTH_DATE}
));
return e
};
ZmMixedView.prototype._createItemHtml=function(a,i){
i=i||{};
i.isMixedView=true;
if(a.type==ZmItem.APPT){
appCtxt.cacheSet(a.id,a)
}
AjxDispatcher.require(ZmMixedController.PKGS[a.type]);
var t=window[ZmMixedView.LV_CLASS[a.type]];
var e=ZmMixedView.LV_FUNCS.concat(ZmMixedView.LV_ADDED_FUNCS[a.type]);
this._emulateListView(t,e);
var o=t.prototype._createItemHtml.call(this,a,i);
this._restoreListView(e);
return o
};
ZmMixedView.prototype._emulateListView=function(t,e){
if(!(e&&e.length)){
return
}
for(var a=0;
a<e.length;
a++){
var o=e[a];
ZmMixedView.LV_SAVE[o]=ZmMixedView.prototype[o];
ZmMixedView.prototype[o]=t.prototype[o]
}};
ZmMixedView.prototype._restoreListView=function(e){
if(!(e&&e.length)){
return
}
for(var t=0;
t<e.length;
t++){
var a=e[t];
ZmMixedView.prototype[a]=ZmMixedView.LV_SAVE[a]
}};
ZmMixedView.prototype._getHeaderToolTip=function(t,e){
return(t==ZmItem.F_TYPE)?ZmMsg.itemType:ZmListView.prototype._getHeaderToolTip.apply(this,arguments)
};
ZmMixedView.prototype._getToolTip=function(n){
var i,o=n.field,a=n.item;
if(o==ZmItem.F_TYPE){
i=ZmMsg[ZmItem.MSG_KEY[a.type]]
}else{
var t=window[ZmMixedView.LV_CLASS[a.type]];
var e=ZmMixedView.LV_FUNCS_TT[a.type];
this._emulateListView(t,e);
this._controller=this._mixedController._getListController(a.type);
i=t.prototype._getToolTip.apply(this,arguments);
this._controller=this._mixedController;
this._restoreListView(e)
}
return i
};
ZmMixedView.prototype._changeListener=function(a){
if(appCtxt.getAppViewMgr().getCurrentViewId()!=this.view){
return
}
if(a.event==ZmEvent.E_DELETE||a.event==ZmEvent.E_MOVE){
var e=a.getDetail("items");
for(var t=0;
t<e.length;
t++){
this._controller.getList().remove(e[t])
}}
ZmListView.prototype._changeListener.call(this,a)
};
ZmMixedView.prototype._getFieldId=function(t,a){
var e=window[ZmMixedView.LV_CLASS[t.type]];
return e.prototype._getFieldId.apply(this,arguments)
}
}
if(AjxPackage.define("zimbraMail.mixed.controller.ZmMixedController")){
ZmMixedController=function(e,t){
ZmListController.call(this,e,t);
this._dragSrc=new DwtDragSource(Dwt.DND_DROP_MOVE);
this._dragSrc.addDragListener(new AjxListener(this,this._dragListener));
this._listController={}
};
ZmMixedController.prototype=new ZmListController;
ZmMixedController.prototype.constructor=ZmMixedController;
ZmMixedController.prototype.toString=function(){
return"ZmMixedController"
};
ZmMixedController.PKGS={};
ZmMixedController.PKGS[ZmItem.CONTACT]=["ContactsCore","Contacts"];
ZmMixedController.PKGS[ZmItem.GROUP]=["ContactsCore","Contacts"];
ZmMixedController.PKGS[ZmItem.CONV]=["MailCore","Mail"];
ZmMixedController.PKGS[ZmItem.MSG]=["MailCore","Mail"];
ZmMixedController.PKGS[ZmItem.APPT]=["CalendarCore","Calendar"];
ZmMixedController.PKGS[ZmItem.TASK]=["TasksCore","Tasks"];
ZmMixedController.PKGS[ZmItem.PAGE]=["NotebookCore","Notebook"];
ZmMixedController.PKGS[ZmItem.DOCUMENT]=["NotebookCore","Notebook"];
ZmMixedController.PKGS[ZmItem.BRIEFCASE_ITEM]=["BriefcaseCore","Briefcase"];
ZmMixedController.LIST_CTLR={};
ZmMixedController.LIST_CTLR[ZmItem.MSG]="ZmTradController";
ZmMixedController.LIST_CTLR[ZmItem.CONV]="ZmConvListController";
ZmMixedController.LIST_CTLR[ZmItem.CONTACT]="ZmContactListController";
ZmMixedController.LIST_CTLR[ZmItem.GROUP]="ZmContactListController";
ZmMixedController.LIST_CTLR[ZmItem.APPT]="ZmCalViewController";
ZmMixedController.LIST_CTLR[ZmItem.TASK]="ZmTaskListController";
ZmMixedController.LIST_CTLR[ZmItem.PAGE]="ZmNotebookFileController";
ZmMixedController.LIST_CTLR[ZmItem.DOCUMENT]="ZmNotebookFileController";
ZmMixedController.LIST_CTLR[ZmItem.BRIEFCASE_ITEM]="ZmBriefcaseController";
ZmMixedController.APP={};
ZmMixedController.APP[ZmItem.MSG]=ZmApp.MAIL;
ZmMixedController.APP[ZmItem.CONV]=ZmApp.MAIL;
ZmMixedController.APP[ZmItem.CONTACT]=ZmApp.CONTACTS;
ZmMixedController.APP[ZmItem.GROUP]=ZmApp.CONTACTS;
ZmMixedController.APP[ZmItem.APPT]=ZmApp.CALENDAR;
ZmMixedController.APP[ZmItem.TASK]=ZmApp.TASKS;
ZmMixedController.APP[ZmItem.PAGE]=ZmApp.NOTEBOOK;
ZmMixedController.APP[ZmItem.DOCUMENT]=ZmApp.NOTEBOOK;
ZmMixedController.APP[ZmItem.BRIEFCASE_ITEM]=ZmApp.BRIEFCASE;
ZmMixedController.prototype.show=function(e){
ZmListController.prototype.show.call(this,e);
this._setup(this._currentView);
this._list=e.getResults(ZmItem.MIXED);
var i=this._listView[this._currentView];
if(this._activeSearch){
if(this._list){
this._list.setHasMore(this._activeSearch.getAttribute("more"))
}
if(i){
i.offset=parseInt(this._activeSearch.getAttribute("offset"))
}}
var a={};
a[ZmAppViewMgr.C_TOOLBAR_TOP]=this._toolbar[this._currentView];
a[ZmAppViewMgr.C_APP_CONTENT]=i;
this._setView({
view:this._currentView,elements:a,isAppView:true}
);
this._resetNavToolBarButtons(this._currentView);
var t=i.getList();
if(t&&t.size()>0){
i.setSelection(t.get(0))
}};
ZmMixedController.prototype.getKeyMapName=function(){
return"ZmMixedController"
};
ZmMixedController.prototype.handleKeyAction=function(t){
switch(t){
case ZmKeyMap.DEL:this._deleteListener();
break;
case ZmKeyMap.MOVE:this._moveListener();
break;
case ZmKeyMap.PRINT:if(appCtxt.get(ZmSetting.PRINT_ENABLED)){
this._printListener()
}
break;
case ZmKeyMap.TAG:var e=this.getSelection();
if(e&&e.length&&(appCtxt.getTagTree().size()>0)){
var a=appCtxt.getPickTagDialog();
ZmController.showDialog(a,new AjxCallback(this,this._tagSelectionCallback,[e,a]))
}
break;
case ZmKeyMap.UNTAG:if(appCtxt.get(ZmSetting.TAGGING_ENABLED)){
this._callControllerFunction("_doRemoveAllTags")
}
break;
default:return ZmController.prototype.handleKeyAction.call(this,t)
}
return true
};
ZmMixedController.prototype._initializeToolBar=function(t){
if(this._toolbar[t]){
return
}
ZmListController.prototype._initializeToolBar.call(this,t);
this._toolbar[t].addFiller();
var e=new ZmNavToolBar({
parent:this._toolbar[t],context:t}
);
this._setNavToolBar(e,t);
this._setNewButtonProps(t,ZmMsg.compose,"NewMessage","NewMessageDis",ZmOperation.NEW_MESSAGE)
};
ZmMixedController.prototype._getToolBarOps=function(){
var e=this._standardToolBarOps();
e.push(ZmOperation.SEP,ZmOperation.TAG_MENU);
return e
};
ZmMixedController.prototype._getActionMenuOps=function(){
return this._standardActionMenuOps()
};
ZmMixedController.prototype._getViewType=function(){
return ZmId.VIEW_MIXED
};
ZmMixedController.prototype._createNewView=function(t){
var e=new ZmMixedView({
parent:this._container,posStyle:DwtControl.ABSOLUTE_STYLE,controller:this,dropTgt:this._dropTgt}
);
e.setDragSource(this._dragSrc);
return e
};
ZmMixedController.prototype._getTagMenuMsg=function(e){
return(e==1)?ZmMsg.tagItem:ZmMsg.tagItems
};
ZmMixedController.prototype._getMoveDialogTitle=function(e){
return(e==1)?ZmMsg.moveItem:ZmMsg.moveItems
};
ZmMixedController.prototype._setViewContents=function(e){
this._listView[e].set(this._list)
};
ZmMixedController.prototype._getListController=function(t){
if(!this._listController[t]){
AjxDispatcher.require(ZmMixedController.PKGS[t]);
var a=window[ZmMixedController.LIST_CTLR[t]];
var e=this._listController[t]=new a(appCtxt.getShell(),appCtxt.getApp(ZmMixedController.APP[t]));
this._emulateListController(e,t)
}
return this._listController[t]
};
ZmMixedController.prototype._emulateListController=function(e,t){
if(t==ZmItem.CONV||t==ZmItem.MSG){
e.isReadingPaneOn=function(){
return false
};
e._doublePaneView=e._createDoublePaneView();
e._mailListView=e._doublePaneView._mailListView=this._listView[this._currentView]
}else{
if(t==ZmItem.APPT){
e._viewMgr=new ZmCalViewMgr(e._container,e,e._dropTgt);
e._viewMgr._currentViewName=ZmId.VIEW_CAL_LIST;
e._viewMgr._views[ZmId.VIEW_CAL_LIST]=this._listView[this._currentView]
}}
e._list=this._list;
e._currentView=this._currentView;
e._listView={};
e._listView[this._currentView]=this._listView[this._currentView];
e._toolbar={};
e._toolbar[this._currentView]=this._toolbar[this._currentView];
e._actionMenu=this.getActionMenu()
};
ZmMixedController.prototype._listSelectionListener=function(t){
if(t.detail==DwtListView.ITEM_DBL_CLICKED){
var e=this._getListController(t.item.type);
e._listSelectionListener(t)
}else{
ZmListController.prototype._listSelectionListener.call(this,t);
this._resetOperations(this._toolbar[this._currentView])
}};
ZmMixedController.prototype._listActionListener=function(t){
var e=this._getListController(t.item.type);
e._listActionListener(t);
this._resetOperations(this._actionMenu)
};
ZmMixedController.prototype._resetOperations=function(t){
var e=this._divvyItems();
t.enable(ZmOperation.PRINT,!e[ZmItem.BRIEFCASE_ITEM])
};
ZmMixedController.prototype._divvyItems=function(){
var t={};
var e=this._listView[this._currentView].getSelection();
for(var a=0,n=e.length;
a<n;
a++){
var o=e[a];
if(!t[o.type]){
t[o.type]=[]
}
t[o.type].push(o)
}
return t
};
ZmMixedController.prototype._deleteListener=function(e){
this._callControllerFunction("_deleteListener",[e])
};
ZmMixedController.prototype._moveListener=function(e){
this._callControllerFunction("_moveListener",[e])
};
ZmMixedController.prototype._tagListener=function(e){
this._callControllerFunction("_tagListener",[e])
};
ZmMixedController.prototype._printListener=function(e){
this._callControllerFunction("_printListener",[e])
};
ZmMixedController.prototype._callControllerFunction=function(s,i){
i=i||[];
var t=this._divvyItems();
for(var o in t){
var e=this._getListController(o);
if(e&&e[s]){
var a=t[o];
a[0]._mixedType=o;
var n=i.concat([a]);
e[s].apply(e,n)
}}}
}};
