
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
if(AjxPackage.define("Notebook")){
if(AjxPackage.define("ajax.dwt.events.DwtIdleTimer")){
DwtIdleTimer=function(t,e){
DwtIdleTimer._initEvents();
this.timeout=t;
this.handler=e;
this.idle=false;
this._onIdle=AjxCallback.simpleClosure(this.setIdle,this);
this._startTimer();
DwtIdleTimer.getHandlers().add(this)
};
DwtIdleTimer.idleHandlers=0;
DwtIdleTimer.prototype.toString=function(){
return"DwtIdleTimer"
};
DwtIdleTimer.prototype.kill=function(){
this._stopTimer();
this.idle=false;
DwtIdleTimer.getHandlers().remove(this)
};
DwtIdleTimer.prototype.resurrect=function(e){
this.idle=false;
DwtIdleTimer.getHandlers().add(this,null,true);
if(e!=null){
this.timeout=e
}
this._startTimer()
};
DwtIdleTimer.prototype.setIdle=function(){
if(!this.idle){
DwtIdleTimer.idleHandlers++;
this.idle=true;
this.handler.run(true)
}};
DwtIdleTimer.prototype.resume=function(){
if(this.idle){
this.idle=false;
this.handler.run(false);
DwtIdleTimer.idleHandlers--
}};
DwtIdleTimer.prototype._startTimer=function(){
this._stopTimer();
this._timer=setTimeout(this._onIdle,this.timeout)
};
DwtIdleTimer.prototype._stopTimer=function(){
if(this._timer){
clearTimeout(this._timer);
this._timer=null
}};
DwtIdleTimer._initEvents=function(){
if(!DwtIdleTimer._initialized){
if(!AjxEnv.isIE){
window.addEventListener("keydown",DwtIdleTimer.resetIdle,true);
window.addEventListener("mousemove",DwtIdleTimer.resetIdle,true);
window.addEventListener("mousedown",DwtIdleTimer.resetIdle,true);
window.addEventListener("focus",DwtIdleTimer.resetIdle,true)
}else{
document.body.attachEvent("onkeydown",DwtIdleTimer.resetIdle);
document.body.attachEvent("onkeyup",DwtIdleTimer.resetIdle);
document.body.attachEvent("onmousedown",DwtIdleTimer.resetIdle);
document.body.attachEvent("onmousemove",DwtIdleTimer.resetIdle);
document.body.attachEvent("onmouseover",DwtIdleTimer.resetIdle);
document.body.attachEvent("onmouseout",DwtIdleTimer.resetIdle);
window.attachEvent("onfocus",DwtIdleTimer.resetIdle)
}
DwtIdleTimer._initialized=true
}};
DwtIdleTimer.getHandlers=function(){
var e=DwtIdleTimer.HANDLERS;
if(!e){
e=DwtIdleTimer.HANDLERS=new AjxVector()
}
return e
};
DwtIdleTimer.resetIdle=function(){
var e=DwtIdleTimer.getHandlers();
e.foreach("_startTimer");
if(DwtIdleTimer.idleHandlers>0){
e.foreach("resume")
}}
}
if(AjxPackage.define("zimbraMail.notebook.view.conv.ZmWikiConverter")){
ZmWikiConverter=function(e,t){
if(arguments.length==0){
return
}
this._toHtmlRules=e;
this._toWikiRules=t
};
ZmWikiConverter.prototype.toHtml=function(t){
ZmWikiConverter._converter=this;
var e=[];
t=ZmWikiConverter._saveComments(t,e);
t=ZmWikiConverter.convert(t,this._toHtmlRules);
return ZmWikiConverter._restoreComments(t,e)
};
ZmWikiConverter.prototype.toWiki=function(t){
ZmWikiConverter._converter=this;
var e=[];
t=ZmWikiConverter._saveComments(t,e);
t=ZmWikiConverter.convert(t,this._toWikiRules);
return ZmWikiConverter._restoreComments(t,e)
};
ZmWikiConverter.convert=function(t,o){
ZmWikiConverter._data=[];
for(var e in o){
var a=o[e];
t=t.replace(a.input,a.output||"")
}
return t
};
ZmWikiConverter.store=function(e){
ZmWikiConverter._data.push(e);
return"{{"+ZmWikiConverter._data.length+"}}"
};
ZmWikiConverter.restore=function(e){
return ZmWikiConverter._data[e-1]
};
ZmWikiConverter._saveComments=function(t,e){
return t.replace(/<!--(.|\n)+?-->/g,function(a){
e.push(a);
return"<ZmWikiConverter-COMMENT"+(e.length-1)+">"
}
)
};
ZmWikiConverter._restoreComments=function(t,e){
return t.replace(/<ZmWikiConverter-COMMENT([0-9]+)>/g,function(a,i){
return e[i]
}
)
};
MediaWikiConverter=function(){
ZmWikiConverter.call(this,MediaWikiConverter.toHtml.rules,MediaWikiConverter.toWiki.rules)
};
MediaWikiConverter.prototype=new ZmWikiConverter;
MediaWikiConverter.prototype.constructor=MediaWikiConverter;
MediaWikiConverter.toHtml={};
MediaWikiConverter.toHtml._LIST={
open:{
item:{
"*":"<li>","#":"<li>",";":"<dt>",":":"<dd>"}
,list:{
"*":"<ul>","#":"<ol>",";":"<dl>",":":"<dl>"}}
,close:{
item:{
"*":"</li>","#":"</li>",";":"</dt>",":":"</dd>"}
,list:{
"*":"</ul>","#":"</ol>",";":"</dl>",":":"</dl>"}}};
MediaWikiConverter.toHtml._header=function(e,a,t){
return["<h",a.length,">",t,"</h",a.length,">\n"].join("")
};
MediaWikiConverter.toHtml._list=function(e,a,t){
return["{{",a,"}",t,"{",a,"}}\n"].join("")
};
MediaWikiConverter.toHtml._listTransition=function(r,d,h){
var n=0;
var t=d.length<h.length?d.length:h.length;
while(n<t){
var e=h.charAt(n);
var o=d.charAt(n);
e=e==";"?":":e;
o=o==";"?":":o;
if(e!=o){
break
}
n++
}
var c=[];
for(var s=d.length-1;
s>=n;
s--){
var l=d.charAt(s);
c.push(MediaWikiConverter.toHtml._LIST.close.item[l]);
c.push(MediaWikiConverter.toHtml._LIST.close.list[l])
}
for(var s=n;
s<h.length;
s++){
var l=h.charAt(s);
c.push(MediaWikiConverter.toHtml._LIST.open.list[l]);
c.push(MediaWikiConverter.toHtml._LIST.open.item[l])
}
if(d.length==h.length){
var l=d.charAt(d.length-1);
c.push(MediaWikiConverter.toHtml._LIST.close.item[l])
}
var l=d.charAt(h.length-1);
c.push(MediaWikiConverter.toHtml._LIST.open.item[l]);
return c.join("")
};
MediaWikiConverter.toHtml._listBoundary=function(o,t,r,h){
var e=["\n"];
for(var n=0;
n<t.length;
n++){
var s=t.charAt(n);
e.push(MediaWikiConverter.toHtml._LIST.open.list[s]);
e.push(MediaWikiConverter.toHtml._LIST.open.item[s])
}
e.push(r);
for(var n=h.length-1;
n>=0;
n--){
var s=h.charAt(n);
e.push(MediaWikiConverter.toHtml._LIST.close.item[s]);
e.push(MediaWikiConverter.toHtml._LIST.close.list[s])
}
return e.join("")
};
MediaWikiConverter.toHtml._paragraph=function(e,t){
return[e.substr(t.length-2),"<p>"].join("")
};
MediaWikiConverter.toHtml.rules=[{
input:new RegExp("\\r?\\n","g"),output:"\n"}
,{
input:new RegExp("\\\\(\\{)","g"),output:function(t,e){
return ZmWikiConverter.store(e)
}}
,{
input:new RegExp("\\{\\{","g"),output:function(e){
return ZmWikiConverter.store(e)
}}
,{
input:new RegExp("<pre>.*?<\\/pre>","ig"),output:function(e){
return ZmWikiConverter.store(e)
}}
,{
input:new RegExp("&[^;]+?;","g"),output:function(e){
return ZmWikiConverter.store(e)
}}
,{
input:new RegExp("&","g"),output:"&amp;"}
,{
input:new RegExp("<\\s","g"),output:function(e){
return ZmWikiConverter.store(e)
}}
,{
input:new RegExp("'''''(.+?)'''''","g"),output:"<strong><em>$1</em></strong>"}
,{
input:new RegExp("'''(.+?)'''","g"),output:"<strong>$1</strong>"}
,{
input:new RegExp("''(.+?)''","g"),output:"<em>$1</em>"}
,{
input:new RegExp("\\[\\[.+?\\]\\]","g"),output:function(e){
ZmWikiConverter.store(e)
}}
,{
input:new RegExp("\\[([^\\s]+)\\s+([^\\]]+)\\]","g"),output:"<a href='$1' target='_new'>$2</a>"}
,{
input:new RegExp("\\[([^\\]]+)\\]","g"),output:"<a href='$1' target='_new'>$1</a>"}
,{
input:new RegExp("(?:^|\\n)(={1,4})(.*?)={1,4}","g"),output:MediaWikiConverter.toHtml._header}
,{
input:new RegExp("(?:^|\\n)-{4}(?=\\n|$)","g"),output:"\n<hr>\n"}
,{
input:new RegExp("(?:^|\\n)([*#;:]*)(;[^:]*?)(:.*?)(?:\\n|$)","g"),output:"$1$2$1$3\n"}
,{
input:new RegExp("(?:^|\\n)([*#;:]+)(.*?)(?=\\n|$)","g"),output:MediaWikiConverter.toHtml._list}
,{
input:new RegExp("\\{([*#;:]+)\\}\\}\\n\\{\\{([*#;:]+)\\}","g"),output:MediaWikiConverter.toHtml._listTransition}
,{
input:new RegExp("\\{\\{([*#;:]+)\\}(.*?)\\{([*#;:]+)\\}\\}","g"),output:MediaWikiConverter.toHtml._listBoundary}
,{
input:new RegExp("(?:^|\\n)\\{\\|(.*?)(?=\\n|$)","g"),output:"<table $1>\n"}
,{
input:new RegExp("(?:^|\\n)\\|\\}(?=\\n|$)","g"),output:"</table>\n"}
,{
input:new RegExp("(?:^|\\n)\\|-(.*?)(?=\\n|$)","g"),output:"<tr $1>\n"}
,{
input:new RegExp("(?:^|\\n)\\!([^\\|]+?)\\|(.*?)(?=\\n|$)","g"),output:"<th $1>$2\n"}
,{
input:new RegExp("(?:^|\\n)\\!(.*?)(?=\\n|$)","g"),output:"<th>$1\n"}
,{
input:new RegExp("(?:^|\\n)\\|([^\\|]+?)\\|(.*?)(?=\\n|$)","g"),output:"<td $1>$2\n"}
,{
input:new RegExp("(?:^|\\n)\\|(.*?)(?=\\n|$)","g"),output:"<td>$1\n"}
,{
input:new RegExp("(\\n{2,})","g"),output:MediaWikiConverter.toHtml._paragraph}
,{
input:new RegExp("\\{\\{(\\d+)\\}\\}","g"),output:function(t,e){
return ZmWikiConverter.restore(e)
}}
,{
input:new RegExp("^\\n+|(?:<p.*?>)*\\n+$|<p.*?>*$","i"),output:""}
];
MediaWikiConverter.toWiki={};
MediaWikiConverter.toWiki._header=function(a,o,t,i){
var e="====".substring(0,o);
return["\n",e,i,e,"\n"].join("")
};
MediaWikiConverter.toWiki._listClear=function(e){
MediaWikiConverter.toWiki._listLevel="";
return e
};
MediaWikiConverter.toWiki._list=function(e,a){
if(e.charAt(1)=="/"){
var t=MediaWikiConverter.toWiki._listLevel;
MediaWikiConverter.toWiki._listLevel=t.substring(0,t.length-1);
return e
}
MediaWikiConverter.toWiki._listLevel+=a;
return[e.substring(0,e.length-1)," level=",MediaWikiConverter.toWiki._listLevel,">"].join("")
};
MediaWikiConverter.toWiki._listItem=function(e,a,t){
a=a.replace(/u/g,"*").replace(/o/g,"#").replace(/d/g,";");
return["\n",a," ",t.replace(/[\s\n]+/g," ").replace(/\n+$/,"")].join("")
};
MediaWikiConverter.toWiki.rules=[{
input:new RegExp("^","g"),output:MediaWikiConverter.toWiki._listClear}
,{
input:new RegExp("(?:<em>|<i>)(.*?)(?:<\\/em>|<\\/i>)","ig"),output:"''$1''"}
,{
input:new RegExp("(?:<strong>|<b>)(.*?)(?:<\\/strong>|<\\/b>)","ig"),output:"'''$1'''"}
,{
input:new RegExp("<h(\\d)(.*?)>(.*?)<\\/h\\d\\s*>","ig"),output:MediaWikiConverter.toWiki._header}
,{
input:new RegExp("<hr(?:\\s+.*)?>","ig"),output:"\n----\n"}
,{
input:new RegExp("<(?:\\/)?([uod])l(?:\\s+.*?)?>","ig"),output:MediaWikiConverter.toWiki._list}
,{
input:new RegExp("<.*? level=([uod]+)>[\\s\\n]*<li>(.*?)(?!<\\/.+?>)","ig"),output:MediaWikiConverter.toWiki._listItem}
,{
input:new RegExp("<\\/[uod]l\\s*>|<\\/li>","ig"),output:""}
,{
input:new RegExp("<p(\\s+.*)?>","ig"),output:"\n\n"}
,{
input:new RegExp("\\n{3,}","g"),output:"\n\n"}
,{
input:new RegExp("^\\n+|\\n+$"),output:""}
];
TWikiConverter=function(){
ZmWikiConverter.call(this,TWikiConverter.toHtml.rules,TWikiConverter.toWiki.rules);
this._webMap={};
this._varMap={
TOC:"<wiklet class='TOC'/>"}
};
TWikiConverter.prototype=new ZmWikiConverter;
TWikiConverter.prototype.constructor=TWikiConverter;
TWikiConverter.DEFAULT_NOTEBOOK="Notebook";
TWikiConverter.COLORS={
YELLOW:{
fg:"yellow"}
,ORANGE:{
fg:"#ff6600"}
,RED:{
fg:"red"}
,PINK:{
fg:"magenta"}
,PURPLE:{
fg:"purple"}
,TEAL:{
fg:"teal"}
,NAVY:{
fg:"navy"}
,BLUE:{
fg:"blue"}
,AQUA:{
fg:"aqua"}
,LIME:{
fg:"lime"}
,GREEN:{
fg:"green"}
,OLIVE:{
fg:"olive"}
,MAROON:{
fg:"maroon"}
,BROWN:{
fg:"#996633"}
,BLACK:{
fg:"black"}
,GRAY:{
fg:"gray"}
,SILVER:{
fg:"silver"}
,WHITE:{
fg:"white",bg:"gray"}};
TWikiConverter.prototype._baseNotebook=TWikiConverter.DEFAULT_NOTEBOOK;
TWikiConverter.prototype._webMap;
TWikiConverter.prototype._varMap;
TWikiConverter.prototype.setBaseNotebook=function(e){
this._baseNotebook=e
};
TWikiConverter.prototype.putWebMapping=function(e,t){
this._webMap[e]=t
};
TWikiConverter.prototype.putVariable=function(t,e){
this._varMap[t]=e
};
TWikiConverter.toHtml={};
TWikiConverter.toHtml._verbatim=function(e,t){
var a=["<pre><nowiklet>",t,"</nowiklet></pre>"].join("");
return ZmWikiConverter.store(a)
};
TWikiConverter.toHtml._list=function(e,s,a,n){
var o=s.match(/\t/)?s.length*3:s.length;
if((o%3)!=0){
return e
}
a=a.match(/\*/)?a:"#";
for(var t=Math.floor(o/3)-1;
t>0;
t--){
a+=a.substr(0,1)
}
return MediaWikiConverter.toHtml._list(e,a,n)
};
TWikiConverter.toHtml._color=function(a,t,i){
var e=TWikiConverter.COLORS[t];
return["<span style='","color:",e.fg,";",(e.bg?"background-color:"+e.bg+";":""),"'>",i,"</span>"].join("")
};
TWikiConverter.toHtml._tableRow=function(o,s){
var t=[];
t.push("<tr>");
var i=new RegExp("\\|([^\\|]+?)(\\|{1,})","g");
var e;
while(e=i.exec(s)){
var h=new RegExp("^\\s*<b>(.*?)<\\/b>\\s*$","g");
var r=e[1].match(h);
t.push(r?"<th":"<td");
if(e[1].match(new RegExp("^\\S+"))){
t.push(" align=left")
}else{
if(e[1].match(new RegExp("\\S+$"))){
t.push(" align=right")
}else{
t.push(" align=center")
}}
if(e[2].length>1){
t.push(" colspan=",e[2].length)
}
t.push(">");
t.push((r?r[1]:e[1])||"&nbsp;");
t.push(r?"</th>":"</td>");
i.lastIndex--
}
t.push("</tr>\n");
return t.join("")
};
TWikiConverter.toHtml._attachStart=function(e){
return["<h3>Attachments Imported from TWiki</h3>\n","<table class='Attachment' border='1' cellspacing='1' cellpadding='3'>\n","<tr>","<th>Attachment</th>","<th>Size</th>","<th>Date</th>","<th>Who</th>","<th>Comment</th>","</tr>\n",e].join("")
};
TWikiConverter.toHtml._attachEnd=function(e){
return[e,"</table>"].join("\n")
};
TWikiConverter.toHtml._attachSizeFormatter=new AjxMessageFormat("{0,number,#.0} K");
TWikiConverter.toHtml._attachDateFormatter=new AjxDateFormat("d MMM yyyy - kk:mm");
TWikiConverter.toHtml._attachDateBaseTime=new Date(25200885).getTime();
TWikiConverter.toHtml._metaData=function(o,e,r){
if(e=="META:FILEATTACHMENT"){
var i=TWikiConverter._objectify(r);
var l=Number(i.size)/1024;
var t=new Date(TWikiConverter.toHtml._attachDateBaseTime+Number(i.date)*1000);
var s=TWikiConverter.toHtml._attachSizeFormatter;
var a=TWikiConverter.toHtml._attachDateFormatter;
return["<tr>","<td>[[",i.name,"]]</td>","<td><nobr>",s.format(l),"</nobr></td>","<td><nobr>",a.format(t),"</nobr></td>","<td>",i.user,"</td>","<td>",i.comment,"</td>","</tr>"].join("")
}
var n=new RegExp("^META:(TOPICINFO|TOPICMOVED|TOPICPARENT)");
if(e.match(n)){
var h=["<!--",o.replace(new RegExp("^\\n"),""),"-->"].join("");
return ZmWikiConverter.store(h)
}
return ZmWikiConverter.store(o)
};
TWikiConverter.toHtml._wikiVar=function(t,e){
var i=ZmWikiConverter._converter;
var a=i._varMap[e];
if(a){
if(typeof a=="function"){
return a(e)
}
return a
}
return t
};
TWikiConverter.toHtml._wikiWordBracket=function(t,e,a){
return TWikiConverter.toHtml._wikiWord(t,e,a,true)
};
TWikiConverter.toHtml._wikiWordNoBracket=function(t,e,a){
return TWikiConverter.toHtml._wikiWord(t,e,a,false)
};
TWikiConverter.toHtml._wikiWord=function(n,i,s,e){
var r=ZmWikiConverter._converter;
var o=r._varMap["wiki.user"];
o=o?"//"+o:"";
base=r._baseNotebook||TWikiConverter.DEFAULT_NOTEBOOK;
i=r._webMap[i]||i;
var t=[];
if(!e){
t.push("[[")
}
t.push(o,"/",base,"/",i,"/",s);
if(!e){
t.push("|",i,".",s,"]]")
}
return ZmWikiConverter.store(t.join(""))
};
TWikiConverter._objectify=function(o){
var a={};
var i=new RegExp('([a-z]+)="([^"]*)"',"g");
var e;
while(e=i.exec(o)){
var t=e[1];
var n=e[2];
a[t]=n
}
return a
};
TWikiConverter.toHtml.rules=[{
input:new RegExp("\\r?\\n","g"),output:"\n"}
,{
input:new RegExp("\\\\(\\{)","g"),output:function(t,e){
return ZmWikiConverter.store(e)
}}
,{
input:new RegExp("\\{\\{","g"),output:function(e){
return ZmWikiConverter.store(e)
}}
,{
input:new RegExp("(?:^|\\n)(%META:FILEATTACHMENT.*?%)"),output:TWikiConverter.toHtml._attachStart}
,{
input:new RegExp("(?:^|\\n)(%META:FILEATTACHMENT.*?%).*?$"),output:TWikiConverter.toHtml._attachEnd}
,{
input:new RegExp("(?:^|\\n)%(.*?)(?:\\{(.*?)\\})?%(?=\\n|$)","g"),output:TWikiConverter.toHtml._metaData}
,{
input:new RegExp("<verbatim>((?:.|\\n)*?)<\\/verbatim>","g"),output:TWikiConverter.toHtml._verbatim}
,{
input:new RegExp("<noautolink>(.*?)<\\/noautolink>","g"),output:"<nolink>$1</nolink>"}
,{
input:new RegExp("%([A-Z]+?)%","g"),output:TWikiConverter.toHtml._wikiVar}
,{
input:new RegExp("(?=\\[\\[)([A-Z]+[a-z]+(?:[A-Z]+[A-Za-z0-9]*)?)\\.([A-Z]+[a-z]+[A-Z]+[A-Za-z0-9]*)\\b","g"),output:TWikiConverter.toHtml._wikiWordBracket}
,{
input:new RegExp("\\b([A-Z]+[a-z]+(?:[A-Z]+[A-Za-z0-9]*)?)\\.([A-Z]+[a-z]+[A-Z]+[A-Za-z0-9]*)\\b","g"),output:TWikiConverter.toHtml._wikiWordNoBracket}
,{
input:new RegExp("\\[\\[%ATTACHURL%\\/","g"),output:"[["}
,{
input:new RegExp("\\[\\[(.*?)\\]\\[(.*?)\\]\\]","g"),output:"[[$1|$2]]"}
,{
input:new RegExp("&([a-z]+|#\\d+|#x[\\da-f]+);","ig"),output:function(e){
return ZmWikiConverter.store(e)
}}
,{
input:new RegExp("&","g"),output:"&amp;"}
,{
input:new RegExp("<\\s","g"),output:function(e){
return ZmWikiConverter.store(e)
}}
,{
input:new RegExp("!(\\[\\[.*?\\]\\])","g"),output:"<nolink>$1</nolink>"}
,{
input:new RegExp("!([A-Z]+[a-z]+[A-Z]+[a-zA-Z0-9]*)","g"),output:"<nolink>$1</nolink>"}
,{
input:new RegExp("(?:^|\\n)([ ]{3,}|\\t{1,})([*]|[\\dAaIi]\\.) (.*?)(?=\\n|$)","g"),output:TWikiConverter.toHtml._list}
,{
input:new RegExp("\\{([*#;:]+)\\}\\}\\n\\{\\{([*#;:]+)\\}","g"),output:MediaWikiConverter.toHtml._listTransition}
,{
input:new RegExp("\\{\\{([*#;:]+)\\}(.*?)\\{([*#;:]+)\\}\\}","g"),output:MediaWikiConverter.toHtml._listBoundary}
,{
input:new RegExp("\\b\\*([^*\n]+?)\\*\\b","g"),output:"<b>$1</b>"}
,{
input:new RegExp("\\b__([^_\n]+?)__\\b","g"),output:"<b><i>$1</i></b>"}
,{
input:new RegExp("\\b_([^_\n]+?[^\\s])_\\b","g"),output:"<i>$1</i>"}
,{
input:new RegExp("%(YELLOW|ORANGE|RED|PINK|PURPLE|TEAL|NAVY|BLUE|AQUA|LIME|GREEN|OLIVE|MAROON|BROWN|BLACK|GRAY|SILVER|WHITE)%(.*?)%ENDCOLOR%","g"),output:TWikiConverter.toHtml._color}
,{
input:new RegExp("<[\\/]?[a-zA-Z][a-zA-Z0-9]*.*?>","g"),output:function(e){
return ZmWikiConverter.store(e)
}}
,{
input:new RegExp("\\b==(.+?)==\\b","g"),output:"<b><tt>$1</tt></b>"}
,{
input:new RegExp("\\b=(.+?)=\\b","g"),output:"<tt>$1</tt>"}
,{
input:new RegExp("(?:^|\\n)---(\\+{1,6})(.*?)(?=\\n|$)","g"),output:MediaWikiConverter.toHtml._header}
,{
input:new RegExp("(?:^|\\n)-{3,}(?=\\n|$)","g"),output:"<hr>\n"}
,{
input:new RegExp("(?:^|\\n)((?:\\|.*?\\|(?:\\n|$)){1,})","g"),output:"<table border=1>\n$1</table>\n"}
,{
input:new RegExp("(?!\\n)(\\|.*?\\|)\\n","g"),output:TWikiConverter.toHtml._tableRow}
,{
input:new RegExp("\\{\\{(\\d+)\\}\\}","g"),output:function(t,e){
return ZmWikiConverter.restore(e)
}}
,{
input:new RegExp("\\n{2,}","g"),output:"\n<p>\n"}
,{
input:new RegExp("^\\s+|\\s+$"),output:""}
];
TWikiConverter.toWiki={};
TWikiConverter.toWiki.rules=[{
input:new RegExp("^"),output:"HTML to TWiki NOT IMPLEMENTED!\n\n"}
]
}
if(AjxPackage.define("zimbraMail.notebook.view.ZmNotebookPageView")){
ZmNotebookPageView=function(a,t,e){
if(arguments.length==0){
return
}
DwtComposite.call(this,{
parent:a,className:"ZmNotebookPageView",posStyle:DwtControl.ABSOLUTE_STYLE}
);
this._controller=t;
this._USE_IFRAME=true;
this._iframeLoader="ZmNotebookPageView._iframeOnLoad";
this._hiddenIframeLoader="ZmNotebookPageView._iframeOnLoad1";
this._createHtml();
this._setMouseEventHdlrs();
this._setAllowSelection();
this.setDropTarget(e)
};
ZmNotebookPageView.prototype=new DwtComposite;
ZmNotebookPageView.prototype.constructor=ZmNotebookPageView;
ZmNotebookPageView.prototype.toString=function(){
return"ZmNotebookPageView"
};
ZmNotebookPageView.prototype._controller;
ZmNotebookPageView.prototype.getController=function(){
return this._controller
};
ZmNotebookPageView.prototype.set=function(o){
if(this._USE_IFRAME){
var i=this._controller._toolbar[this._controller._currentView];
i.enable([ZmOperation.REFRESH,ZmOperation.EDIT,ZmOperation.TAG_MENU,ZmOperation.DELETE,ZmOperation.PRINT,ZmOperation.SEND_PAGE,ZmOperation.DETACH],false);
var e=appCtxt.getApp(ZmApp.NOTEBOOK).getNotebookCache();
if(o!=null){
var t=o.getRestUrl();
var n=e.parseURL(t);
this._orginalRestAuthority=n.protocol+"://"+n.authority;
this.loadURL(t)
}}else{
var a=this.getHtmlElement();
if(!o){
a.innerHTML="";
return
}
a.innerHTML=ZmNotebookPageView._generateContent(o);
ZmNotebookPageView._fixLinks(a);
ZmNotebookPageView._findObjects(this._getObjectMgr(),a)
}};
ZmNotebookPageView.prototype.getTitle=function(){
var t=this.getVisiblePage();
if(!t){
return ZmMsg.zimbraTitle
}
var e=t.getFolderId();
var a=appCtxt.getById(e);
var i=(a?a.getName():"");
return[ZmMsg.zimbraTitle,i].join(": ")
};
ZmNotebookPageView.prototype.getContent=function(){
return this.getHtmlElement().innerHTML
};
ZmNotebookPageView.prototype.getSelection=function(){
return[this._controller.getPage()]
};
ZmNotebookPageView.prototype.getVisiblePage=function(){
return this._controller.getPage()
};
ZmNotebookPageView.prototype.addSelectionListener=function(e){};
ZmNotebookPageView.prototype.addActionListener=function(e){};
ZmNotebookPageView.prototype.handleActionPopdown=function(e){};
ZmNotebookPageView.prototype.setBounds=function(t,i,a,e){
DwtComposite.prototype.setBounds.call(this,t,i,a,e);
if(this._USE_IFRAME){
this._iframe.width=a;
this._iframe.height=e
}};
ZmNotebookPageView._fixLinks=function(a){
var e=a.getElementsByTagName("A");
for(var t=0;
t<e.length;
t++){
var o=e[t];
if(!o.href){
continue
}
if(!o.target){
o.target="_new"
}}};
ZmNotebookPageView._generateContent=function(n){
if(!n){
return""
}
var t=appCtxt.getApp(ZmApp.NOTEBOOK).getNotebookCache();
var e=t.getPageByName(n.folderId,ZmNotebook.PAGE_CHROME,true);
var a=e.getContent();
var o=a;
if(n.name!=ZmNotebook.PAGE_CHROME){
var i=n.getContent();
o=a.replace(ZmWiklet.RE_CONTENT,i)
}
return ZmWikletProcessor.process(n,o)
};
ZmNotebookPageView._findObjects=function(a,t){
a.reset();
var e=[];
var i="nolink";
a.processHtmlNode(t,true,e,i)
};
ZmNotebookPageView.prototype._createHtml=function(){
var e=this.getHtmlElement();
Dwt.setScrollStyle(e,Dwt.SCROLL);
if(!AjxEnv.isSafari){
var i={
parent:this,className:"ZmNotebookIframe",hidden:false,html:"<body></body>",posStyle:DwtControl.STATIC_STYLE,useKbMgmt:true,onload:this._iframeLoader+"(this)"};
this._diframe=new DwtIframe(i);
this._iframe=this._diframe.getIframe();
var a={
parent:this,hidden:true,html:"<body></body>",onload:this._hiddenIframeLoader+"(this)"};
this._diframe1=new DwtIframe(a);
this._diframe1.setVisible(false);
this._iframe1=this._diframe1.getIframe()
}else{
var o=this._htmlElId+"_iframe";
var t=this._htmlElId+"_iframe_hidden";
e.innerHTML=["<iframe id='",o,"' frameborder='0' ","onload='",this._iframeLoader,"(this)'>","</iframe>","<iframe id='",t,"' name='",t,"' frameborder='0' style='position: absolute; top: 0; left: 0; visibility: hidden'","onload='",this._hiddenIframeLoader,"(this)'>","</iframe>"].join("");
this._iframe=document.getElementById(o);
this._iframe1=document.getElementById(t)
}
Dwt.associateElementWithObject(this._iframe,this);
Dwt.associateElementWithObject(this._iframe1,this);
window["wikiFrame_"+this._htmlElId]=this._iframe
};
ZmNotebookPageView.prototype._getObjectMgr=function(){
if(!this._objectMgr){
this._objectMgr=new ZmObjectManager(this)
}
return this._objectMgr
};
ZmNotebookPageView._iframeOnLoad=function(o){
var e=Dwt.getObjectFromElement(o);
if(!e){
return
}
try{
e.mutateLinks(o.contentWindow.document);
var t=o.contentWindow.location.href;
var s=o.contentWindow.location.pathname;
if(e.currentPath){
s=e.currentPath;
e.currentPath=null;
e.fetchInfo(s)
}else{
if(s!=window.parent.location.pathname&&s!=""){
e.fetchInfo(s)
}}
e.addIconStyles(o.contentWindow.document)
}
catch(i){}
e.currentSrc=null;
e.currentPath=null;
var n=o.contentWindow.document;
var a=n.body;
if(a){
ZmNotebookPageView._findObjects(e._getObjectMgr(),a)
}
return
};
ZmNotebookPageView.prototype.processPageInfo=function(iSrc,t){
if(t==null){
return
}
var cache=appCtxt.getApp(ZmApp.NOTEBOOK).getNotebookCache();
try{
var data=eval("["+t+"]");
if(data!=null){
var response=data[0];
var items=cache._processResponse(response);
var isPage=true;
if(items&&items.length>1){
isPage=false
}else{
if(items&&items.length==1){
if(unescape(items[0].getRestUrl())!=unescape(iSrc)){
isPage=false
}}}
if(items&&(items.length>0)){
if(!isPage){
var iPage=cache.getPageByName(items[0].folderId,"_Index");
this._controller.setPage(iPage)
}else{
this._controller.setPage(items[0])
}
if(!this._controller.historyLoading){
this._controller.updateHistory()
}else{
this._controller.historyLoading=null
}
this.addColumn(this._iframe.contentWindow.document)
}}}
catch(ex){}};
ZmNotebookPageView.prototype.enableToolbar=function(e){
var t=this._controller._toolbar[view._controller._currentView];
t.enable([ZmOperation.REFRESH,ZmOperation.EDIT,ZmOperation.TAG_MENU,ZmOperation.DELETE,ZmOperation.PRINT,ZmOperation.SEND_PAGE,ZmOperation.DETACH],e)
};
ZmNotebookPageView.prototype.mutateLinks=function(r){
try{
var l=r.getElementsByTagName("a");
var t=this._iframe1.contentWindow;
var h=t.location.protocol+"//"+t.location.host;
if(l){
for(var a=0;
a<l.length;
a++){
var s=l[a];
if(this._orginalRestAuthority){
var o=null;
var e=AjxStringUtil.fixCrossDomainReference(s.href,this._orginalRestAuthority);
if(e!=s.href){
s.href=e
}}
this.mutateLink(s,r,h)
}}}
catch(n){}};
ZmNotebookPageView.prototype.mutateLink=function(s,r,h){
var l=s.href;
var n="_new";
if(l.match(/^https?:\/\//)){
var a=this.fixLinkProtocol(l,h);
if(a!=l){
s.href=a;
l=a
}
if(l.indexOf(h)>=0){
n=this._iframe1.id;
if(l==(window.location.href+"#")){
s.href="javascript:;"
}
if(l.match(/\.txt$/i)||l.match(/\.html?$/i)||l.match(/\.jpg$/i)||l.match(/\.png$/i)){
n="_new"
}}else{
n="_new"
}
if(s.href!="javascript:;"){
var t=AjxStringUtil.parseURL(s.href);
if(t.authority==window.location.host){
var e=s.href;
var o=e.split("#");
var i=o[0]+(e.indexOf("?")<0?"?":"&")+("disp=i")+(o[1]?"#"+o[1]:"");
s.href=i
}}}else{
n=this._iframe1.id
}
s.target=n;
s.innerHTML=decodeURI(s.innerHTML)
};
ZmNotebookPageView.prototype.fetchPageInfo=function(n){
try{
var t=n.indexOf("/home/");
var e=n.substring(t);
var o=e+"?fmt=json";
var i=AjxRpc.invoke("",o,{}
,null,true);
if(i!=null){
if(i.success){
this.processPageInfo(n,i.text)
}}}
catch(a){}};
ZmNotebookPageView.prototype.addIconStyles=function(a){
var e=a.getElementsByTagName("head");
if(!e){
return
}
var t=a.createElement("link");
t.rel="stylesheet";
t.type="text/css";
t.href=appContextPath+"/css/images.css";
e[0].appendChild(t)
};
ZmNotebookPageView.prototype.addColumn=function(r){
var l=null;
var t=r.getElementsByTagName("table");
if(!t){
return
}
for(var o=0;
o<t.length;
o++){
if(t[o].className=="zmwiki-tocListTable"){
l=t[o]
}}
if(!l){
return
}
var a=this._controller._object;
var e=appCtxt.getById(a.folderId);
var n=false;
var h=ZmOrganizer.getSystemId(ZmOrganizer.ID_ROOT);
while(e&&e.parent&&(e.parent.id!=h)&&!e.isReadOnly()){
e=e.parent
}
if(e&&e.isReadOnly()){
n=true
}
var s=l.tBodies[0];
for(var o=0;
o<s.rows.length;
o++){
var c=s.rows[o];
this.addActionLinks(c,r,n)
}};
ZmNotebookPageView.prototype.addActionLinks=function(d,r,o){
if(d.className=="zmwiki-headerUnderLine"){
var i=d.insertCell(2);
i.className="zmwiki-header";
i.innerHTML=ZmMsg.actions;
return
}
for(var a=0;
a<d.cells.length;
a++){
var l=d.cells[a];
if(l.className=="zmwiki-pageLink"){
var c=l.firstChild;
var s=c.innerHTML;
if(c.firstChild&&c.firstChild.innerHTML){
c=c.firstChild;
s=c.innerHTML
}
var e=(d.cells[a-1].firstChild.className=="ImgPage")?true:false;
var i=d.insertCell(a+1);
if(e&&!o){
var t=this.createEditLink(r,s);
var h=this.createDeleteLink(r,s);
var n=this.createHistoryLink(r,s);
i.appendChild(t);
i.appendChild(r.createTextNode(" "));
i.appendChild(h);
i.appendChild(r.createTextNode(" "));
i.appendChild(n)
}else{
i.innerHTML=" - "
}
break
}}};
ZmNotebookPageView.prototype.createEditLink=function(a,t){
var e=a.createElement("a");
e.innerHTML=ZmMsg.edit;
e.href="javascript:window.parent.Dwt.getObjectFromElement(window.parent.wikiFrame_"+this._htmlElId+').editPage("'+t+'");';
e.className="zmwiki-author";
return e
};
ZmNotebookPageView.prototype.createDeleteLink=function(t,e){
var a=t.createElement("a");
a.innerHTML=ZmMsg.del;
a.href="javascript:window.parent.Dwt.getObjectFromElement(window.parent.wikiFrame_"+this._htmlElId+').deletePage("'+e+'");';
a.className="zmwiki-author";
return a
};
ZmNotebookPageView.prototype.createHistoryLink=function(t,e){
var a=t.createElement("a");
a.innerHTML=ZmMsg.historyLabel;
a.href="javascript:window.parent.Dwt.getObjectFromElement(window.parent.wikiFrame_"+this._htmlElId+').showHistory("'+e+'");';
a.className="zmwiki-author";
return a
};
ZmNotebookPageView.prototype.editPage=function(e){
e=AjxStringUtil.htmlDecode(e);
var a=this._controller;
var o=a._object;
var i=appCtxt.getApp(ZmApp.NOTEBOOK).getNotebookCache();
var n=i.getPageByName(o.folderId,e);
if(!n){
return
}
var t=a._app.getPageEditController();
t.show(n)
};
ZmNotebookPageView.prototype.deletePage=function(e){
e=AjxStringUtil.htmlDecode(e);
var t=this._controller;
var i=t._object;
var a=appCtxt.getApp(ZmApp.NOTEBOOK).getNotebookCache();
var o=a.getPageByName(i.folderId,e);
if(!o){
return
}
var n=new AjxListener(this,this.onDelete);
t._doDelete(o,n)
};
ZmNotebookPageView.prototype.showHistory=function(e){
e=AjxStringUtil.htmlDecode(e);
var t=this._controller;
var i=t._object;
var a=appCtxt.getApp(ZmApp.NOTEBOOK).getNotebookCache();
var o=a.getPageByName(i.folderId,e);
if(!o){
return
}
var n=t._app.getPageVersionController();
n.loadVersion(o)
};
ZmNotebookPageView.prototype.onDelete=function(){
var e=this._controller;
var t=e._object;
this.refresh(t.getRestUrl())
};
ZmNotebookPageView._iframeOnLoad1=function(n){
var l=Dwt.getObjectFromElement(n);
if(!l){
return
}
var h=n.contentWindow.location.href;
try{
var u=n.contentWindow.document;
var d=u.title;
l._fixBaseReference(u);
var e=false;
var s=false;
if(d.match(/- Error report$/i)||d.match(/^Error 404/i)||d.match(/^Error 403/i)){
var i=u.body.firstChild;
var m=i.tagName.toLowerCase();
if((m=="h1")&&(i.innerHTML=="HTTP Status 404 - no such item")){
e=true
}else{
if((m=="h2")&&(i.innerHTML=="HTTP ERROR: 404")){
e=true
}else{
if(m=="h2"&&i.innerHTML=="HTTP ERROR: 403"){
s=true
}}}}
if(e){
l.createNewPage(n.contentWindow.location.pathname);
l._currentURL=h
}else{
if(s){
var a=["<b>",ZmMsg.errorPermission,"</b>","<br>",ZmMsg.errorPermissionMsg].join("");
var o=appCtxt.getMsgDialog();
o.reset();
o.setMessage(a,DwtMessageDialog.INFO_STYLE);
o.popup()
}else{
l.currentSrc=h;
l.currentPath=n.contentWindow.location.pathname;
var t=l._iframe.contentWindow.document;
if(!l._replaceHTML||AjxEnv.isIE||AjxEnv.isSafari){
t.open();
t.write(u.documentElement.innerHTML);
t.close();
l._replaceHTML=true
}else{
l.copyIframeContents(t,u)
}
l._currentURL=h
}}
if(l._diframe){
l._diframe._resetEventHandlers()
}}
catch(r){
var c=l._controller._toolbar[l._controller._currentView];
c.enable([ZmOperation.REFRESH,ZmOperation.EDIT,ZmOperation.TAG_MENU,ZmOperation.DELETE,ZmOperation.PRINT,ZmOperation.SEND_PAGE,ZmOperation.DETACH],false)
}};
ZmNotebookPageView.prototype.createNewPage=function(o){
var t=o.replace(/^.*\//,"");
t=unescape(t);
var i=this._controller.getPage();
if(i.folderId){
var a=new ZmPage();
a.name=t;
a.folderId=i.folderId;
var e=AjxDispatcher.run("GetPageEditController");
e.show(a)
}};
ZmNotebookPageView.prototype.fixLinkProtocol=function(e,i){
var t=e;
var a=i;
if(i.match(/^http:\/\//)){
a=i.replace(/^http:\/\//,"https://")
}else{
if(i.match(/^https:\/\//)){
a=i.replace(/^https:\/\//,"http://")
}}
if(e.indexOf(a)>=0){
t=e.replace(a,i)
}
return t
};
ZmNotebookPageView.prototype.loadURL=function(o){
var t=window.location.protocol+"//"+window.location.host;
var i=this.fixLinkProtocol(o,t);
i=AjxStringUtil.fixCrossDomainReference(i);
if(appCtxt.get(ZmSetting.LOCALE_NAME)){
var e=appCtxt.get(ZmSetting.LOCALE_NAME);
var a=e.indexOf("_");
var n,s;
if(a==-1){
n=e;
s=null
}else{
n=e.substr(0,a);
s=e.substr(a+1)
}
i+=(i.match(/\?/)?"&":"?")+"language="+n;
i+=(s?(i.match(/\?/)?"&":"?")+"country="+s:"")
}
i=i+(i.indexOf("?")?"&":"?")+"t="+(new Date()).getTime();
this._iframe1.src=i
};
ZmNotebookPageView.prototype.fetchInfo=function(n){
if(!n||n=="blank"){
return
}
n=decodeURIComponent(n);
if(n.charAt(0)=="/"){
n=n.substring(1)
}
var i=null;
var t=null;
var o=n.split("/");
if(o.length>=3&&o[0]=="home"){
i=o[1];
var e=o.length;
var s=o.splice(2,e-2);
t=s.join("/")
}else{
if(o.length>=4&&o[0]=="service"&&o[1]=="home"){
i=o[2];
var e=o.length;
var s=o.splice(3,e-3);
t=s.join("/")
}}
if(t&&i){
var a=appCtxt.getApp(ZmApp.NOTEBOOK).getNotebookCache();
var r=new AjxCallback(this,this.handleItemResponse);
a.getItemInfo({
path:t,accountName:i,callback:r}
)
}};
ZmNotebookPageView.prototype.refresh=function(e){
this._controller.historyLoading=true;
if(e){
var t=this._iframe1.src;
t=t?t.replace(/\/$/,""):"";
if(AjxEnv.isIE&&(e==t)){
this._iframe1.contentWindow.location.reload();
return
}
this.loadURL(e)
}else{
if(this._iframe1.contentWindow.location.href){
this._iframe1.contentWindow.location.reload()
}}};
ZmNotebookPageView.prototype.handleItemResponse=function(h){
if(!h){
return
}
var e=appCtxt.getApp(ZmApp.NOTEBOOK).getNotebookCache();
var s=e.getPage(h);
this._controller.setPage(s);
if(!this._controller.historyLoading){
this._controller.updateHistory()
}else{
this._controller.historyLoading=null
}
var t=appCtxt.getOverviewController();
var i=t.getTreeController(ZmOrganizer.NOTEBOOK);
var r=appCtxt.getApp(ZmApp.NOTEBOOK);
var o=i.getTreeView(r.getOverviewId());
if(o){
var a=this._controller._object.getFolderId();
var n=true;
o.setSelected(a,n)
}
this.addColumn(this._iframe.contentWindow.document)
};
ZmNotebookPageView.prototype.copyIframeContents=function(r,s){
var i=r.getElementsByTagName("head")?r.getElementsByTagName("head")[0]:null;
var a=r.getElementsByTagName("body")?r.getElementsByTagName("body")[0]:null;
var t=s.getElementsByTagName("head")?s.getElementsByTagName("head")[0]:null;
var e=s.getElementsByTagName("body")?s.getElementsByTagName("body")[0]:null;
if(i){
if(a){
a.innerHTML=""
}
var n=i.firstChild;
while(n){
var o=n.nextSibling;
n.parentNode.removeChild(n);
n=o
}
i.innerHTML=t.innerHTML
}
if(a){
var n=a.firstChild;
while(n){
var o=n.nextSibling;
n.parentNode.removeChild(n);
n=o
}
a.innerHTML=e.innerHTML
}
ZmNotebookPageView._iframeOnLoad(this._iframe)
};
ZmNotebookPageView.prototype.isHistoryLoading=function(){
return(this._controller.historyLoading==true)
};
ZmNotebookPageView.prototype._fixBaseReference=function(a){
var e=a.getElementsByTagName("base");
if(e&&e.length>0){
var t=e[0]?e[0].href:null;
t=t?AjxStringUtil.fixCrossDomainReference(t):null;
if(t){
e[0].href=t
}}}
}
if(AjxPackage.define("zimbraMail.notebook.view.ZmPageVersionView")){
ZmPageVersionView=function(a,t,e){
ZmNotebookPageView.call(this,a,t,e)
};
ZmPageVersionView.prototype=new ZmNotebookPageView;
ZmPageVersionView.prototype.constructor=ZmPageVersionView;
ZmPageVersionView.prototype.toString=function(){
return"ZmPageVersionView"
};
ZmPageVersionView.prototype.set=function(a){
this._page=a;
if(a!=null){
var t=a.getRestUrl()+"?view=history";
var e=appCtxt.getApp(ZmApp.NOTEBOOK).getNotebookCache();
var i=e.parseURL(t);
this._orginalRestAuthority=i.protocol+"://"+i.authority;
this.loadURL(t)
}};
ZmPageVersionView.prototype._createHtml=function(){
this._iframeLoader="ZmPageVersionView._iframeOnLoad";
this._hiddenIframeLoader="ZmPageVersionView._iframeOnLoad1";
ZmNotebookPageView.prototype._createHtml.call(this)
};
ZmPageVersionView._iframeOnLoad=function(e){
ZmNotebookPageView._iframeOnLoad(e)
};
ZmPageVersionView._iframeOnLoad1=function(e){
ZmNotebookPageView._iframeOnLoad1(e)
};
ZmPageVersionView.prototype.handleItemResponse=function(n){
if(!n){
return
}
ZmNotebookPageView.prototype.handleItemResponse.call(this,n);
var a=this._iframe1.contentWindow.location.search;
if(!a){
return
}
var o=false;
var i=/[&|\?]ver=(\d+)/.exec(a);
if(i){
var e=(i&&i.length>1)?parseInt(i[1]):1;
var t=appCtxt.getApp(ZmApp.NOTEBOOK).getNotebookCache();
var s=t.getPage(n);
s.version=e;
this._controller.setPage(s);
o=true
}
this._controller.enableRevertButton(o)
};
ZmPageVersionView.prototype.addActionLinks=function(e,t){
return
}
}
if(AjxPackage.define("zimbraMail.notebook.view.ZmNotebookFileView")){
ZmNotebookFileView=function(t,e){
ZmListView.call(this,{
parent:t,controller:e}
);
this._controller=e
};
ZmNotebookFileView.prototype=new ZmListView;
ZmNotebookFileView.prototype.constructor=ZmNotebookFileView;
ZmNotebookFileView.prototype.toString=function(){
return"ZmNotebookFileView"
};
ZmNotebookFileView.prototype._controller;
ZmNotebookFileView.prototype._fileListView;
ZmNotebookFileView.prototype.handleActionPopdown=function(e){}
}
if(AjxPackage.define("zimbraMail.notebook.view.ZmPageEditView")){
ZmPageEditView=function(t,e){
DwtComposite.call(this,{
parent:t,className:"ZmPageEditView",posStyle:DwtControl.ABSOLUTE_STYLE}
);
this._controller=e;
this._createHtml();
this._page=null;
this._contentHasBeenSet=false;
this._originalContent=null
};
ZmPageEditView.prototype=new DwtComposite;
ZmPageEditView.prototype.constructor=ZmPageEditView;
ZmPageEditView.prototype.toString=function(){
return"ZmPageEditView"
};
ZmPageEditView.DIALOG_X=50;
ZmPageEditView.DIALOG_Y=100;
ZmPageEditView.prototype._controller;
ZmPageEditView.prototype._locationEl;
ZmPageEditView.prototype._pageNameInput;
ZmPageEditView.prototype._pageEditor;
ZmPageEditView.prototype._page;
ZmPageEditView.prototype._isNewPage;
ZmPageEditView.prototype._renameWarningId;
ZmPageEditView.prototype.getController=function(){
return this._controller
};
ZmPageEditView.prototype.clearContents=function(){
this._pageNameInput.setValue("");
this.setContent("")
};
ZmPageEditView.prototype.set=function(e){
this.clearContents();
this._showPageLoading(true);
var t=new AjxCallback(this,this._setResponse,[e]);
e.getContent(t)
};
ZmPageEditView.prototype._setResponse=function(a){
this._pageEditor.setFooterInfo(a);
var e=a.name||"";
this._pageNameInput.setValue(e);
this._isNewPage=(a.version==0);
var t=a.getContent()||"<br>";
this.setContent(t);
this._page=a;
this._showRenameWarning(false);
this.focus()
};
ZmPageEditView.prototype._onEditorContentInitialized=function(){
this._contentHasBeenSet=true;
this._originalContent=this.getContent()
};
ZmPageEditView.prototype.pageSaved=function(e){
this._originalContent=e;
this._isNewPage=false;
this._updateRenameWarning()
};
ZmPageEditView.prototype.getTitle=function(){
var e=this.getPageName();
if(!e||(e.length==0)){
e=ZmMsg.newPage
}
return[ZmMsg.zimbraTitle,e].join(": ")
};
ZmPageEditView.prototype.getPageName=function(){
return this._pageNameInput.getValue()
};
ZmPageEditView.prototype.setFormat=function(e){
this._pageEditor.setFormat(e)
};
ZmPageEditView.prototype.getFormat=function(){
return this._pageEditor.getFormat()
};
ZmPageEditView.prototype.setContent=function(e){
this._pageEditor.setContent(e)
};
ZmPageEditView.prototype.getContent=function(){
return this._pageEditor.getContent()
};
ZmPageEditView.prototype.getPageEditor=function(){
return this._pageEditor
};
ZmPageEditView.prototype.getSelection=function(){
return this._controller.getPage()
};
ZmPageEditView.prototype.addSelectionListener=function(e){};
ZmPageEditView.prototype.addActionListener=function(e){};
ZmPageEditView.prototype.setBounds=function(t,o,i,e){
DwtComposite.prototype.setBounds.call(this,t,o,i,e);
var a=Dwt.getSize(this._inputEl);
this._pageEditor.setSize(i,e-a.y-23)
};
ZmPageEditView.prototype.focus=function(){
var t=this._pageNameInput.getValue();
var e=t==""?this._pageNameInput:this._pageEditor;
e.focus()
};
ZmPageEditView.prototype.isDirty=function(){
if(this._page){
var e=this.getPageName();
var t=this.getContent();
if((this._page.name||"")!=e){
return true
}
if(this._contentHasBeenSet&&(this._originalContent!=t)){
return true
}}
return false
};
ZmPageEditView.prototype._createHtml=function(){
this._renameWarningId=Dwt.getNextId();
this._pageNameInput=new DwtInputField({
parent:this}
);
this._pageNameInput.setRequired(true);
this._pageNameInput.setValidatorFunction(null,ZmPageEditView._validatePageName);
var e=this._pageNameInput.getInputElement();
e.size=50;
Dwt.setHandler(e,DwtEvent.ONCHANGE,ZmPageEditView._onNameChange);
Dwt.setHandler(e,DwtEvent.ONKEYPRESS,ZmPageEditView._onNameChange);
this._pageEditor=new ZmPageEditor(this,null,null,DwtHtmlEditor.HTML,this._controller);
this._pageEditor.isHtmlEditingSupported=new Function("return true");
var n=this._pageEditor.getHtmlElement();
n.style.width="100%";
n.style.height="100%";
this._inputEl=document.createElement("TABLE");
var r=this._inputEl;
r.cellSpacing=0;
r.cellPadding=3;
r.width="100%";
var h=r.insertRow(-1);
var a=h.insertCell(-1);
a.width="1%";
a.style.whiteSpace="nowrap";
a.className="Label";
a.innerHTML=ZmMsg.pageLabel;
var i=h.insertCell(-1);
i.width="1%";
i.appendChild(this._pageNameInput.getHtmlElement());
var t=h.insertCell(-1);
var s=document.createElement("DIV");
t.appendChild(s);
s.id=this._renameWarningId;
Dwt.setVisible(s,false);
s.className="RenameWarning";
s.innerHTML="<table><tr><td>"+AjxImg.getImageHtml("Warning")+"</td><td>"+ZmMsg.wikiChangeNameWarning+"</td></tr></table>";
var o=this.getHtmlElement();
o.appendChild(r);
o.appendChild(n)
};
ZmPageEditView._validatePageName=function(e){
if(e!==""){
this.setValue(unescape(e),true)
}
if(e==""){
throw AjxMsg.valueIsRequired
}else{
if(!ZmOrganizer.VALID_NAME_RE.test(e)){
throw AjxMessageFormat.format(ZmMsg.errorInvalidName,AjxStringUtil.htmlEncode(e))
}}};
ZmPageEditView._onNameChange=function(e){
var a=DwtControl.getTargetControl(e);
while(a){
if(a instanceof ZmPageEditView){
var t=new AjxTimedAction(a,a._updateRenameWarning);
AjxTimedAction.scheduleAction(t,0);
break
}
a=a.parent
}};
ZmPageEditView.prototype._updateRenameWarning=function(t){
if(!this._isNewPage){
var a=this.getPageName();
var e=this._page.name;
this._showRenameWarning(a!=e)
}};
ZmPageEditView.prototype._showRenameWarning=function(e){
var t=document.getElementById(this._renameWarningId);
if(t){
t.innerHTML="<table><tr><td>"+AjxImg.getImageHtml("Warning")+"</td><td>"+ZmMsg.wikiChangeNameWarning+"</td></tr></table>"
}
Dwt.setVisible(t,e)
};
ZmPageEditView.prototype._showPageLoading=function(e){
var t=document.getElementById(this._renameWarningId);
if(t){
t.innerHTML="<table><tr><td>"+AjxImg.getImageHtml("Information")+"</td><td>"+ZmMsg.loading+"</td></tr></table>"
}
Dwt.setVisible(t,e)
};
ZmPageEditView.prototype._getDialogXY=function(){
var e=Dwt.toWindow(this.getHtmlElement(),0,0);
return new DwtPoint(e.x+ZmPageEditView.DIALOG_X,e.y+ZmPageEditView.DIALOG_Y)
};
ZmPageEditor=function(a,t,i,o,e){
if(arguments.length==0){
return
}
ZmHtmlEditor.call(this,a,t,i,o,true);
this._controller=e
};
ZmPageEditor.prototype=new ZmHtmlEditor;
ZmPageEditor.prototype.constructor=ZmPageEditor;
ZmPageEditor.prototype.toString=function(){
return"ZmPageEditor"
};
ZmPageEditor.KEY_FORMAT="format";
ZmPageEditor.HTML_SOURCE="htmlsrc";
ZmPageEditor.MEDIA_WIKI="mediawiki";
ZmPageEditor.RICH_TEXT="richtext";
ZmPageEditor.TWIKI="twiki";
ZmPageEditor.DEFAULT=ZmPageEditor.RICH_TEXT;
ZmPageEditor._MODES={};
ZmPageEditor._MODES[ZmPageEditor.HTML_SOURCE]=DwtHtmlEditor.TEXT;
ZmPageEditor._MODES[ZmPageEditor.MEDIA_WIKI]=DwtHtmlEditor.TEXT;
ZmPageEditor._MODES[ZmPageEditor.RICH_TEXT]=DwtHtmlEditor.HTML;
ZmPageEditor._MODES[ZmPageEditor.TWIKI]=DwtHtmlEditor.TEXT;
ZmPageEditor._CONVERTERS={};
ZmPageEditor._CONVERTERS[ZmPageEditor.MEDIA_WIKI]=new MediaWikiConverter();
ZmPageEditor._CONVERTERS[ZmPageEditor.TWIKI]=new TWikiConverter();
ZmPageEditor.prototype._format=ZmPageEditor.DEFAULT;
ZmPageEditor.prototype.setFormat=function(e){
this._format=e;
this.setMode(ZmPageEditor._MODES[e])
};
ZmPageEditor.prototype.getFormat=function(){
return this._format
};
ZmPageEditor.prototype.setMode=function(e){
if(e!=this._mode){
ZmHtmlEditor.prototype.setMode.call(this,e);
this.setSize(this._oldW,this._oldH)
}};
ZmPageEditor.prototype.setSize=function(e,t){
this._oldW=e;
this._oldH=t;
ZmHtmlEditor.prototype.setSize.apply(this,arguments)
};
ZmPageEditor.prototype.setContent=function(a){
var t=ZmPageEditor._CONVERTERS[this._format];
if(t){
a=t.toWiki(a)
}
ZmHtmlEditor.prototype.setContent.call(this,a);
if(this._mode==DwtHtmlEditor.HTML){
var e=this._getIframeDoc();
this._deserializeWiklets(e);
this._patchLinks(e)
}};
ZmPageEditor.prototype.getContent=function(e){
if(this._mode==DwtHtmlEditor.HTML){
this._serializeWiklets()
}
var a=ZmHtmlEditor.prototype.getContent.call(this,e);
var t=ZmPageEditor._CONVERTERS[this._format];
if(t){
a=t.toHtml(a)
}
return a
};
ZmPageEditor.prototype._patchLinks=function(a){
var e=a.getElementsByTagName("A");
for(var t=0;
t<e.length;
t++){
var o=e[t];
if(!o.href){
continue
}
Dwt.associateElementWithObject(o,this);
if(AjxEnv.isIE){
Dwt.setHandler(o,DwtEvent.ONCLICK,ZmPageEditor._handleLinkClick)
}else{
o.addEventListener("click",ZmPageEditor._handleLinkClick,true)
}}};
ZmPageEditor.prototype._serializeWiklets=function(){
var t=this._getIframeDoc().getElementsByTagName("BUTTON");
for(var s=t.length-1;
s>=0;
s--){
var o=t[s];
var e=o.getAttribute("wikname");
var c=ZmWiklet.getWikletByName(e);
var a=document.createElement("WIKLET");
a.setAttribute("class",e);
var d=o.attributes;
for(var n=0;
n<d.length;
n++){
var h=d[n];
var l=h.nodeName;
if(!l.match(/^wikparam_/)){
continue
}
var r=h.nodeValue.replace(/"/g,"");
if(r==""){
continue
}
a.setAttribute(l.substr(9),r)
}
var u=document.createTextNode(e);
a.appendChild(u);
o.parentNode.replaceChild(a,o)
}};
ZmPageEditor.prototype._deserializeWiklets=function(a){
var e=a.getElementsByTagName("WIKLET");
for(var s=e.length-1;
s>=0;
s--){
var t=e[s];
var d=ZmWiklet.getWikletByName(t.className);
if(!d){
continue
}
var u=[];
var o={};
for(var n=t.attributes.length-1;
n>=0;
n--){
var l=t.attributes[n];
var c=l.nodeName;
var h=l.nodeValue;
u.push(c,'="',h.replace(/"/g,"&quot;"),'" ');
o[c]=h
}
var r=this._createWikletButton(d,u,o);
t.parentNode.replaceChild(r,t)
}};
ZmPageEditor.prototype._createWikletButton=function(o,a,i){
var t=document.createElement("BUTTON");
t.setAttribute("wikname",o.name);
t.innerHTML=o.label||o.name;
if(o.paramdefs){
t.title=ZmMsg.wikletConfigureParams;
if(i){
for(var e in i){
t.setAttribute("wikparam_"+e,i[e]||"")
}}else{
for(var e in o.paramdefs){
t.setAttribute("wikparam_"+e,o.paramdefs[e].value||"")
}}}else{
t.title=ZmMsg.wikletConfigureNone
}
t.onclick=ZmPageEditor._wikletButtonHandler;
return t
};
ZmPageEditor.prototype._embedHtmlContent=function(e){
return e
};
ZmPageEditor.prototype._createToolbars=function(){
var i={
parent:this,className:"ZToolbar",posStyle:DwtControl.RELATIVE_STYLE,cellSpacing:2};
if(!this._toolbar1){
var e=this._toolbar1=new DwtToolBar(i);
e.setVisible(this._mode==DwtHtmlEditor.HTML);
this._createToolBar1(e);
this._toolbars.push(e)
}
if(!this._toolbar2){
var e=this._toolbar2=new DwtToolBar(i);
e.setVisible(this._mode==DwtHtmlEditor.HTML);
var a={
parent:e,style:DwtButton.TOGGLE_STYLE};
var t=new AjxListener(this,this._fontStyleListener);
b=this._strikeThruButton=new DwtToolBarButton(a);
b.setImage("StrikeThru");
b.setToolTipContent(ZmMsg.strikeThruText);
b.setData(ZmHtmlEditor._VALUE,DwtHtmlEditor.STRIKETHRU_STYLE);
b.addSelectionListener(t);
b=this._superscriptButton=new DwtToolBarButton(a);
b.setImage("SuperScript");
b.setToolTipContent(ZmMsg.superscript);
b.setData(ZmHtmlEditor._VALUE,DwtHtmlEditor.SUPERSCRIPT_STYLE);
b.addSelectionListener(t);
b=this._subscriptButton=new DwtToolBarButton(a);
b.setImage("Subscript");
b.setToolTipContent(ZmMsg.subscript);
b.setData(ZmHtmlEditor._VALUE,DwtHtmlEditor.SUBSCRIPT_STYLE);
b.addSelectionListener(t);
new DwtControl({
parent:e,className:"vertSep"}
);
this._createToolBar2(e);
this._toolbars.push(e)
}};
ZmPageEditor.prototype._createToolBar2=function(t){
ZmHtmlEditor.prototype._createToolBar2.call(this,t);
var a={
parent:this._toolbar2};
var e=new DwtToolBarButton(a);
e.setImage("ImageDoc");
e.setToolTipContent(ZmMsg.insertImage);
e.addSelectionListener(new AjxListener(this,this._insertImagesListener));
e=new DwtToolBarButton(a);
e.setImage("Attachment");
e.setToolTipContent(ZmMsg.insertAttachment);
e.addSelectionListener(new AjxListener(this,this._insertAttachmentsListener));
e=new DwtToolBarButton(a);
e.setImage("FindReplace");
e.setToolTipContent(ZmMsg.findNReplaceTitle);
e.addSelectionListener(new AjxListener(this,this._findReplaceListener));
e=new DwtToolBarButton(a);
e.setImage("CamelCase");
e.setToolTipContent(ZmMsg.convertCamelCase);
e.addSelectionListener(new AjxListener(this,this._convertCamelCaseListener))
};
ZmPageEditor.prototype.insertLinks=function(n){
if(!(n instanceof Array)){
n=[n]
}
if(!n.length){
return
}
var a=null;
for(var t=0;
t<n.length;
t++){
if(t>0){
var r=this._getIframeDoc().createTextNode(" ");
a.parentNode.insertBefore(r,a.nextSibling);
a=r
}
var o=this._getIframeDoc().createElement("A");
var s=this._controller.getPage();
var h=appCtxt.getById(s.folderId);
var e=[h.getRestUrl(),"/",AjxStringUtil.urlComponentEncode(n[t])].join("");
o.href=e;
o.innerHTML=decodeURI(n[t]);
this._insertLink(o,a,true);
a=o
}};
ZmPageEditor.prototype._insertImages=function(a){
for(var t=0;
t<a.length;
t++){
var o=this._controller.getPage();
var n=appCtxt.getById(o.folderId);
var e=[n.getRestUrl(),"/",AjxStringUtil.urlComponentEncode(a[t])].join("");
this.insertImage(e)
}};
ZmPageEditor.prototype._insertImagesListener=function(e){
this._insertObjectsListener(e,this._insertImages,ZmMsg.insertImage)
};
ZmPageEditor.prototype._insertAttachmentsListener=function(e){
this._insertObjectsListener(e,this.insertLinks,ZmMsg.insertAttachment)
};
ZmPageEditor.prototype._insertObjectsListener=function(t,e,a){
if(!this._insertObjectsCallback){
this._insertObjectsCallback=new AjxCallback(this,this._insertObjects)
}
this._insertObjectsCallback.args=[e];
this.__popupUploadDialog(this._insertObjectsCallback)
};
ZmPageEditor.prototype.__popupUploadDialog=function(o,i){
var t=this._controller.getPage();
var a=appCtxt.getById(t.folderId);
var e=appCtxt.getUploadDialog();
e.addPopdownListener(new AjxListener(this,this.focus));
e.popup(a,o,i)
};
ZmPageEditor.prototype._insertObjects=function(a,t,e){
a.call(this,e)
};
ZmPageEditor.prototype._fontStyleListener=function(e){
ZmHtmlEditor.prototype._fontStyleListener.call(this,e);
if(e.item==this._superscriptButton&&this._subscriptButton.isToggled()){
this.setFont(null,DwtHtmlEditor.SUBSCRIPT_STYLE)
}else{
if(e.item==this._subscriptButton&&this._superscriptButton.isToggled()){
this.setFont(null,DwtHtmlEditor.SUPERSCRIPT_STYLE)
}}};
ZmPageEditor.prototype._insertLinkListener=function(a){
var o=this._getSelectedText();
var i=null;
var e=null;
var t=this._getParentElement();
if(t&&/^a$/i.test(t.tagName)){
i=t;
e=t.href;
o=t.innerHTML
}
this._popupLinkPropsDialog(i,e,o)
};
ZmPageEditor.prototype._insertLink=function(t,i,e){
if(typeof t=="string"){
if(i){
var a=this._getIframeDoc();
var o=a.createTextNode(t);
i.parentNode.replaceChild(o,i)
}else{
this.insertText(t)
}}else{
Dwt.setHandler(t,DwtEvent.ONCLICK,ZmPageEditor._handleLinkClick);
Dwt.associateElementWithObject(t,this);
if(i){
if(e){
i.parentNode.insertBefore(t,i.nextSibling)
}else{
i.parentNode.replaceChild(t,i)
}}else{
this._insertNodeAtSelection(t)
}}};
ZmPageEditor._handleLinkClick=function(a){
a=DwtUiEvent.getEvent(a,this);
var o=DwtUiEvent.getTarget(a);
var i=o;
if(i.nodeName!="A"){
while(i.nodeName!="A"){
i=i.parentNode;
if(i.nodeName=="A"){
break
}}}
var t=Dwt.getObjectFromElement(i);
var e=i.href;
var n=o.innerHTML;
t._popupLinkPropsDialog(o,e,n);
DwtUiEvent.setDhtmlBehaviour(a,true,false);
return false
};
ZmPageEditor.prototype._popupLinkPropsDialog=function(i,t,o){
var e={
target:i,url:t,text:o,document:this._getIframeDoc()};
if(!this._insertLinkCallback){
this._insertLinkCallback=new AjxCallback(this,this._insertLink)
}
var a=appCtxt.getLinkPropsDialog();
a.addPopdownListener(new AjxListener(this,this.focus));
a.popup(e,this._insertLinkCallback)
};
ZmPageEditor.prototype._wikiToolBarListener=function(a){
var e=a.item.getData("wiklet");
var i=ZmWiklet.getWikletByName(e);
var t=this._createWikletButton(i);
this.focus();
this._insertNodeAtSelection(t);
ZmPageEditor._wikletPressButton(t)
};
ZmPageEditor._wikletButtonHandler=function(t){
var e=DwtUiEvent.getTarget(t);
ZmPageEditor._wikletPressButton(e)
};
ZmPageEditor._wikletPressButton=function(o){
var e=o.getAttribute("wikname");
var c=ZmWiklet.getWikletByName(e);
if(!c){
return
}
var a=[];
for(var i in c.paramdefs){
var s=o.attributes[i];
var l=AjxUtil.createProxy(c.paramdefs[i]);
l.value=s?s.nodeValue:(l.value||"");
a.push(l)
}
if(a.length==0){
return
}
var n=DwtShell.getShell(window);
var h=new ZmDialog({
parent:n,title:ZmMsg.wikletParams}
);
var d=new DwtPropertyEditor(h);
d.initProperties(a);
h.setView(d);
var r=[h,d,o,a];
var t=new AjxListener(null,ZmPageEditor._wikletParamListener,r);
h.setButtonListener(DwtDialog.OK_BUTTON,t);
h.popup();
return false
};
ZmPageEditor._wikletParamListener=function(o,s,a,r){
var n=s.getProperties();
for(var i in n){
var t=i;
var e=n[i];
if(e===""){
a.removeAttribute("wikparam_"+t)
}else{
a.setAttribute("wikparam_"+t,e)
}}
o.popdown()
};
ZmPageEditor.prototype._onContentInitialized=function(){
ZmHtmlEditor.prototype._onContentInitialized.call(this);
this.parent._onEditorContentInitialized();
this._resetFormatControls();
var e=new AjxTimedAction(this,this.focus);
AjxTimedAction.scheduleAction(e,DwtHtmlEditor._INITDELAY+5)
};
ZmPageEditor.prototype._findReplaceListener=function(){
this.focus();
var e=this._getSelection();
this.range_findnreplace=this._createRange(e);
this._popupReplaceDialog()
};
ZmPageEditor.prototype._popupReplaceDialog=function(i,t,o){
var e={
document:this._getIframeDoc(),editor:this};
var a=appCtxt.getReplaceDialog();
a.popup(e)
};
ZmPageEditor.prototype._initialize=function(){
ZmHtmlEditor.prototype._initialize.call(this);
this.addFooter()
};
ZmPageEditor.prototype.addFooter=function(){
var o=this.getHtmlElement();
var s=this._footerEl=document.createElement("div");
var a=Dwt.getNextId();
var t=Dwt.getNextId();
var i=Dwt.getNextId();
var e=Dwt.getNextId();
var n=['<table cellpadding="0" cellspacing="0" class="ZmHtmlEditorFooter">',"<tr>","<td>",ZmMsg.locationLabel,' <span id="',a,'"></span></td>',"<td>",ZmMsg.versionLabel,' <span id="',t,'"></span></td>',"<td>",ZmMsg.authorLabel,' <span id="',i,'"></span></td>',"<td>",ZmMsg.modifiedOnLabel,' <span id="',e,'"></span></td>',"</tr>","</table>"];
s.innerHTML=n.join("");
o.appendChild(s);
this._locationEl=document.getElementById(a);
this._versionEl=document.getElementById(t);
this._authorEl=document.getElementById(i);
this._modifiedEl=document.getElementById(e)
};
ZmPageEditor.prototype.setFooterInfo=function(n){
var o;
var e=ZmOrganizer.getSystemId(ZmOrganizer.ID_ROOT);
if(n.folderId==e){
o=appCtxt.getById(n.folderId).name
}else{
var r="&nbsp;&raquo;&nbsp;";
var i=[];
var t=n.folderId;
while((t!=null)&&(t!=e)){
var s=appCtxt.getById(t);
if(!(s instanceof ZmNotebook)){
break
}
i.unshift(s.name);
if(!s.parent){
break
}
t=s.parent.id;
if(t!=e){
i.unshift(r)
}}
o=i.join("")
}
this._locationEl.innerHTML=o;
this._versionEl.innerHTML=(n.version?n.version:"");
this._authorEl.innerHTML=(n.creator?n.creator:"");
this._modifiedEl.innerHTML=(n.createDate?ZmWiklet._formatDate({
type:"shortdateandtime"}
,n.createDate):"")
};
ZmPageEditor.prototype._initTextMode=function(t){
var e=this.getHtmlElement();
this._textAreaId="textarea_"+Dwt.getNextId();
var a=document.createElement("textarea");
a.className="DwtHtmlEditorTextArea";
a.id=this._textAreaId;
if(this._footerEl){
this._footerEl.parentNode.insertBefore(a,this._footerEl)
}else{
e.appendChild(a)
}
if(!t){
a.value=this._pendingContent;
this._pendingContent=null
}
return a
};
ZmPageEditor.prototype._handleEditorEvent=function(a){
var o=ZmHtmlEditor.prototype._handleEditorEvent.call(this,a);
if(DwtKeyEvent.isKeyPressEvent(a)){
var e=this._keyEvent;
e.setFromDhtmlEvent(a);
if(e.ctrlKey){
var t=String.fromCharCode(e.charCode).toLowerCase();
var i=null;
switch(t){
case"s":this._controller._doSave(false);
e._stopPropagation=true;
e._returnValue=false;
e.setToDhtmlEvent(a);
o=false;
break
}}}
return o
};
ZmPageEditor.WIKIWORD_RE=/[A-Z]+[a-z]+[A-Z]+[a-zA-Z0-9]*/;
ZmPageEditor.LITERAL_RE=/[^\]\|]+?/;
ZmPageEditor.WIKI_LINK_RE=/(^\[\[|\]\]$)/;
ZmPageEditor.TWIKI_KEYWORD_RE=new RegExp("\\b("+ZmPageEditor.WIKIWORD_RE.source+")\\b|(?:\\[\\[("+ZmPageEditor.LITERAL_RE.source+")\\](?:\\[("+ZmPageEditor.LITERAL_RE.source+")\\])?\\])","g");
ZmPageEditor.prototype._convertCamelCaseListener=function(){
var e=this._warningDlg=appCtxt.getYesNoMsgDialog();
e.reset();
e.setMessage(ZmMsg.convertCamelCaseMsg,DwtMessageDialog.WARNING_STYLE);
e.registerCallback(DwtDialog.YES_BUTTON,this._camelcaseYesCallback,this);
e.popup()
};
ZmPageEditor.prototype._camelcaseYesCallback=function(){
this._warningDlg.popdown();
var e=this._getIframeDoc();
if(e&&e.body){
this._convertCamelCaseToLink(e.body)
}};
ZmPageEditor.prototype._convertCamelCaseToLink=function(a){
if(!a){
return
}
var c=a.ownerDocument;
var s,r,t;
switch(a.nodeType){
case 1:var e=a.firstChild;
while(e){
e=this._convertCamelCaseToLink(e)
}
return a.nextSibling;
case 3:case 4:var l=a.data;
var o;
var h=false;
ZmPageEditor.TWIKI_KEYWORD_RE.lastIndex=0;
while(o=ZmPageEditor.TWIKI_KEYWORD_RE.exec(l)){
var d=o[0];
if(d&&!d.match(ZmPageEditor.WIKI_LINK_RE)){
l=this._replaceCamelCaseWord(l,d,ZmPageEditor.TWIKI_KEYWORD_RE.lastIndex);
h=true
}}
if(h){
var n=a.nextSibling;
this._replaceTextNode(a,c.createTextNode(l));
return n
}}
return a.nextSibling
};
ZmPageEditor.prototype._replaceCamelCaseWord=function(i,t,o){
var e=i.substring(0,o-t.length);
var a=i.substring(o-t.length);
if(e!=null&&a!=null){
i=e+a.replace(t,"[["+t+"]]")
}
return i
};
ZmPageEditor.prototype._replaceTextNode=function(a,t){
var o=a.ownerDocument;
var i=a.nextSibling;
var e=a.parentNode;
e.removeChild(a);
if(i){
e.insertBefore(t,i)
}else{
e.appendChild(t)
}}
}
if(AjxPackage.define("zimbraMail.notebook.view.ZmFileListView")){
ZmFileListView=function(s){
var t=s.headerList=this._getHeaderList(parent);
s.view=ZmId.VIEW_NOTEBOOK_FILE;
s.type=ZmItem.PAGE;
ZmListView.call(this,s);
this._colHeaderActionMenu=new ZmPopupMenu(this);
var n=new AjxListener(this,this._colHeaderActionListener);
for(var a=0;
a<t.length;
a++){
var o=t[a];
if(o._width){
var e=this._colHeaderActionMenu.createMenuItem(o._id,{
text:o._name,style:DwtMenuItem.CHECK_STYLE}
);
e.setData(ZmFileListView.KEY_ID,o._id);
e.setChecked(true,true);
this._colHeaderActionMenu.addSelectionListener(o._id,n)
}}};
ZmFileListView.prototype=new ZmListView;
ZmFileListView.prototype.constructor=ZmFileListView;
ZmFileListView.prototype.toString=function(){
return"ZmFileListView"
};
ZmFileListView.KEY_ID="_keyId";
ZmFileListView.COLWIDTH_ICON=20;
ZmFileListView.COLWIDTH_TYPE=ZmMsg.COLUMN_WIDTH_TYPE_DLV;
ZmFileListView.COLWIDTH_SIZE=ZmMsg.COLUMN_WIDTH_SIZE_DLV;
ZmFileListView.COLWIDTH_DATE=ZmMsg.COLUMN_WIDTH_DATE_DLV;
ZmFileListView.COLWIDTH_OWNER=ZmMsg.COLUMN_WIDTH_OWNER_DLV;
ZmFileListView.COLWIDTH_FOLDER=ZmMsg.COLUMN_WIDTH_FOLDER_FLV;
ZmFileListView.prototype._getHeaderList=function(e){
var t=[];
if(appCtxt.get(ZmSetting.TAGGING_ENABLED)){
t.push(new DwtListHeaderItem({
field:ZmItem.F_TAG,icon:"Tag",width:ZmFileListView.COLWIDTH_ICON,name:ZmMsg.tag}
))
}
t.push(new DwtListHeaderItem({
field:ZmItem.F_TYPE,icon:"Globe",width:ZmFileListView.COLWIDTH_ICON}
),new DwtListHeaderItem({
field:ZmItem.F_SUBJECT,text:ZmMsg._name,resizeable:true}
),new DwtListHeaderItem({
field:ZmItem.F_FILE_TYPE,text:ZmMsg.type,width:ZmFileListView.COLWIDTH_TYPE}
),new DwtListHeaderItem({
field:ZmItem.F_SIZE,text:ZmMsg.size,width:ZmFileListView.COLWIDTH_SIZE}
),new DwtListHeaderItem({
field:ZmItem.F_DATE,text:ZmMsg.date,width:ZmFileListView.COLWIDTH_DATE}
),new DwtListHeaderItem({
field:ZmItem.F_FROM,text:ZmMsg.owner,width:ZmFileListView.COLWIDTH_OWNER}
),new DwtListHeaderItem({
field:ZmItem.F_FOLDER,text:ZmMsg.folder,width:ZmFileListView.COLWIDTH_FOLDER}
));
return t
};
ZmFileListView.prototype._getCellContents=function(u,c,f,l,i,t){
if(l==ZmItem.F_SUBJECT){
u[c++]="<div id='"+this._getFieldId(f,ZmItem.F_SUBJECT)+"'>"+AjxStringUtil.htmlEncode(f.name)+"</div>"
}else{
if(l==ZmItem.F_SIZE){
u[c++]=AjxUtil.formatSize(f.size)
}else{
if(l==ZmItem.F_FILE_TYPE){
var s=(f instanceof ZmPage)?ZmMsg.page:null;
if(!s){
var r=f.ct?ZmMimeTable.getInfo(f.ct):null;
s=r?r.desc:"&nbsp;"
}
u[c++]=s
}else{
if(l==ZmItem.F_TYPE){
var h=(f instanceof ZmPage)?"Page":null;
if(!h){
var d=f.contentType;
var r=d?ZmMimeTable.getInfo(d):null;
h=r?r.image:"UnknownDoc"
}
u[c++]="<div class='Img"+h+"'></div>"
}else{
if(l==ZmItem.F_FROM){
var e=f.creator&&f.creator.split("@");
var o=e&&e[0];
var m=appCtxt.get(ZmSetting.USERNAME);
if(m){
var a=m.split("@");
if(e&&(e[1]!=a[1])){
o=e.join("@")
}}
u[c++]="<span style='white-space: nowrap'>";
u[c++]=o;
u[c++]="</span>"
}else{
if(l==ZmItem.F_FOLDER){
var n=appCtxt.getById(f.folderId);
u[c++]=n?n.getPath():f.folderId
}else{
if(l==ZmItem.F_DATE){
f=AjxUtil.createProxy(f);
f.date=f.modifyDate
}
c=ZmListView.prototype._getCellContents.apply(this,arguments)
}}}}}}
return c
};
ZmFileListView.prototype._colHeaderActionListener=function(e){};
ZmFileListView.__typify=function(a,t){
for(var e=0;
e<a.length;
e++){
a[e]._type=t
}};
ZmFileListView.prototype._changeListener=function(o){
var a=o.item||o.getDetail("items");
var e=(a instanceof Array)?a:[a];
for(var t in e){
this._handleChangeItem(o,e[t])
}};
ZmFileListView.prototype._handleChangeItem=function(n,o){
if(n.handled||!this._handleEventType[o.type]&&(this.type!=ZmItem.MIXED)){
return
}
if(n.event==ZmEvent.E_TAGS||n.event==ZmEvent.E_REMOVE_ALL){
this._setImage(o,ZmItem.F_TAG,o.getTagImageInfo())
}
if(n.event==ZmEvent.E_FLAGS){
var a=n.getDetail("flags");
for(var i=0;
i<a.length;
i++){
var t=a[i];
var e=o[ZmItem.FLAG_PROP[t]];
if(t==ZmItem.FLAG_FLAGGED){
this._setImage(o,ZmItem.F_FLAG,e?"FlagRed":null)
}else{
if(t==ZmItem.FLAG_ATTACH){
this._setImage(o,ZmItem.F_ATTACHMENT,e?"Attachment":null)
}}}}
if(n.event==ZmEvent.E_DELETE||n.event==ZmEvent.E_MOVE){
this.removeItem(o,true);
this._controller._app._checkReplenishListView=this;
this._controller._resetToolbarOperations()
}};
ZmFileListView.prototype._getToolTip=function(e){
if(!e.item){
return
}
return this._controller.getItemTooltip(e.item,this)
}
}
if(AjxPackage.define("zimbraMail.notebook.view.wiklet.ZmWiklet")){
ZmWiklet=function(){};
ZmWiklet.RE_WIKLET=new RegExp("<wiklet(?:\\s((?:.|\\n)*?))(?:\\/>|>((?:.|\\n)*?)<\\/wiklet(?:\\s[^>]*)?>)","ig");
ZmWiklet.RE_NOWIKLET=new RegExp("<nowiklet>((?:.|\n)*?)<\\/nowiklet>","ig");
ZmWiklet.RE_CONTENT=new RegExp("<wiklet\\s[^>]*?class\\s*=\\s*['\"]?CONTENT['\"](?:.|\\n)*?(?:/>|(?:.|\\n)*?</wiklet(?:\\s[^>]*)?>)","ig");
ZmWiklet._wiklets={};
ZmWiklet.prototype.name;
ZmWiklet.prototype.tooltip;
ZmWiklet.prototype.params;
ZmWiklet.register=function(t){
for(var e=0;
e<arguments.length;
e++){
ZmWiklet._wiklets[arguments[e].name.toUpperCase()]=arguments[e]
}};
ZmWiklet.unregister=function(e){
delete ZmWiklet._wiklets[e.toUpperCase()]
};
ZmWiklet.getWiklets=function(){
return ZmWiklet._wiklets
};
ZmWiklet.getWikletByName=function(e){
return ZmWiklet._wiklets[e.toUpperCase()]
};
ZmWiklet._formatUser=function(e,t){
return e
};
ZmWiklet._dateFormatters={};
ZmWiklet._formatDate=function(n,i){
if(!i){
return""
}
var r=n.type||"shortdateandtime";
if(r=="pattern"){
var s=n.pattern||"";
if(!ZmWiklet._dateFormatters[s]){
ZmWiklet._dateFormatters[s]=new AjxDateFormat(s)
}
return ZmWiklet._dateFormatters[s].format(i)
}
var h;
var o;
if((o=r.match(/^(short|medium|long|full)(date|time)(?:and(date|time))?$/i))){
var a=ZmWiklet._formatDateFuncs[o[3]?o[2]+o[3]:o[2]];
var t=ZmWiklet._formatDateLengths[o[1]];
var e=ZmWiklet._formatDateLengths[o[1]];
h=a(t,e)
}else{
h=AjxDateFormat.getDateInstance(AjxDateFormat.LONG)
}
return h.format(i)
};
ZmWiklet._formatDateFuncs={
date:AjxDateFormat.getDateInstance,time:AjxDateFormat.getTimeInstance,datetime:AjxDateFormat.getDateTimeInstance};
ZmWiklet._formatDateLengths={
medium:AjxDateFormat.MEDIUM,full:AjxDateFormat.FULL};
ZmWiklet._formatDateLengths["short"]=AjxDateFormat.SHORT;
ZmWiklet._formatDateLengths["long"]=AjxDateFormat.LONG;
ZmWiklet.__parseValueAsParams=function(i){
var n={};
var a=/([a-z]+)\s*=\s*(?:'(.*?)'|"(.*?)"|(\S+))/g;
var e;
while(e=a.exec(i)){
var t=e[1].toLowerCase();
var o=e[2]||e[3]||e[4]|"";
n[t]=o
}
return n
};
ZmWiklet.__object2Array=function(n,t){
var e=[];
for(var i in n){
var s=n[i];
if(!t.test(s.name)){
continue
}
e.push(s)
}
return e
};
ZmWiklet.__byItemName=function(t,e){
var i=t.name.toLowerCase();
var o=e.name.toLowerCase();
if(i<o){
return -1
}
if(i>o){
return 1
}
return 0
};
ZmWiklet.register({
name:"URL",label:ZmMsg.wikletUrl,tooltip:ZmMsg.wikletUrlTT,func:function(a,n,s,i){
var o=i.getItem();
var t=a==ZmNotebook.PAGE_INDEX?ZmMsg.wikiToc:o.name;
var e;
var a;
if(o instanceof ZmPage){
e=o.folderId;
a=o.name
}else{
e=o.id;
a=ZmNotebook.PAGE_INDEX
}
return["[[:",e,"/",a,"|",t,"]]"].join("")
}}
,{
name:"NAME",label:ZmMsg.wikletName,tooltip:ZmMsg.wikletNameTT,func:function(e,a,i,t){
var e=t.getItem().name;
return e==ZmNotebook.PAGE_INDEX?ZmMsg.wikiToc:e
}}
,{
name:"ID",label:ZmMsg.wikletId,tooltip:ZmMsg.wikletIdTT,func:function(t,o,n,a){
var i=a.getItem();
var e=a.getCache();
if(i instanceof ZmPage){
return[":",i.folderId,"/",i.name].join("")
}else{
return[":",i.id,"/",ZmNotebook.PAGE_INDEX].join("")
}}}
,{
name:"ICON",label:ZmMsg.wikletIcon,tooltip:ZmMsg.wikletIconTT,func:function(t,n,s,i){
var a="Page";
var o=i.getItem();
if(o instanceof ZmNotebook){
var e=ZmOrganizer.getSystemId(ZmOrganizer.ID_ROOT);
a=(o.parent.id==e)?"Notebook":"Section"
}
return["<div class='Img",a," _pageIcon'></div>"].join("")
}}
,{
name:"TAGS",label:ZmMsg.wikletTags,tooltip:ZmMsg.wikletTagsTT,func:function(e,l,n,t){
var c=t.getItem();
if(!c.tags||c.tags.length==0){
return
}
var h=[];
h.push("<table border=0><tr>");
for(var s=0;
s<c.tags.length;
s++){
var d=t.getTagById(c.tags[s]);
var o=d?d.color:ZmOrganizer.DEFAULT_COLOR[ZmOrganizer.TAG];
var r=ZmTag.getIcon(o);
h.push("<td><div class='Img",r,"'></div></td>");
h.push("<td style='white-space:nowrap'>",d.name,"</td>")
}
h.push("</tr></table");
return h.join("")
}}
,{
name:"COLOR",label:ZmMsg.wikletColor,tooltip:ZmMsg.wikletColorTT,func:function(t,o,n,a){
var i=a.getItem();
if(i.folderId){
i=a.getNotebookById(i.folderId)
}
var e=i.color||0;
return ZmCalendarTreeController.COLOR_CLASSNAMES[e]
}}
,{
name:"FRAGMENT",label:ZmMsg.wikletFragment,tooltip:ZmMsg.wikletFragmentTT,func:function(t,h,o,a){
var l=a.getItem();
var e=a.getItemCount();
for(var n=e-2;
n>=0;
n--){
var r=a.getItemAt(n);
if(r!=l){
break
}
if(r.folderId==l.folderId&&r.name==l.name){
return ZmMsg.wikiFragmentRecursion
}}
a.pushItem(l);
var s=l.fragment||"";
return["<nolink>",s,"</nolink>"].join("")
}}
,{
name:"MSG",label:ZmMsg.wikletMsg,tooltip:ZmMsg.wikletMsgTT,paramdefs:{
value:{
name:"value",label:ZmMsg.key,type:"string",value:"messageKey"}}
,func:function(e,i,o,a){
var t=o.key;
return t&&ZmMsg[t]?ZmMsg[t]:t
}}
,{
name:"INCLUDE",label:ZmMsg.wikletInclude,tooltip:ZmMsg.wikletIncludeTT,paramdefs:{
page:{
name:"page",label:ZmMsg.page,type:"string",value:"PageName"}
,inherit:{
name:"inherit",label:ZmMsg.wikletIncludeInherit,type:"boolean",value:false}}
,func:function(t,h,o,a){
var e=a.getItemCount();
for(var s=e-1;
s>=0;
s--){
var c=a.getItemAt(s);
if(c.name==o.page){
var l=new AjxMessageFormat(ZmMsg.wikiIncludeRecursion);
return l.format(o.page)
}}
var c=a.getItem();
var n=(o.inherit&&o.inherit.toLowerCase()=="true");
if(c.folderId){
var r=a.getPageByName(c.folderId,o.page,n);
if(r){
a.pushItem(r);
if(t=="INLINE"){
a.pushItem(c)
}
return r.getContent()
}}
var l=new AjxMessageFormat(ZmMsg.wikiIncludeMissing);
return l.format(o.page)
}}
,{
name:"INLINE",label:ZmMsg.wikletInline,tooltip:ZmMsg.wikletInlineTT,paramdefs:{
page:{
name:"page",label:ZmMsg.page,type:"string",value:"PageName"}
,inherit:{
name:"inherit",label:ZmMsg.wikletIncludeInherit,type:"boolean",value:false}}
,func:function(t,i,o,a){
var e=ZmWiklet.getWikletByName("INCLUDE");
return e.func(t,i,o,a)
}}
,{
name:"CREATOR",label:ZmMsg.wikletCreator,tooltip:ZmMsg.wikletCreatorTT,func:function(e,i,o,t){
var a=t.getItem();
return ZmWiklet._formatUser(a.creator,o.link)
}}
,{
name:"MODIFIER",label:ZmMsg.wikletModifier,tooltip:ZmMsg.wikletModifierTT,func:function(t,o,n,a){
var i=a.getItem();
var e=i.modifier||i.creator;
return ZmWiklet._formatUser(e,n.link)
}}
,{
name:"CREATEDATE",label:ZmMsg.wikletCreateDate,tooltip:ZmMsg.wikletCreateDateTT,paramdefs:{
type:{
name:"type",label:ZmMsg.type,type:"enum",item:[{
label:ZmMsg.wikletDateShort,value:"shortdate"}
,{
label:ZmMsg.wikletDateLong,value:"longdate"}
,{
label:ZmMsg.wikletTimeShort,value:"shorttime"}
,{
label:ZmMsg.wikletTimeLong,value:"longtime"}
,{
label:ZmMsg.wikletDateTimeShort,value:"shortdateandtime"}
,{
label:ZmMsg.wikletDateTimeLong,value:"longdateandtime"}
,{
label:ZmMsg.pattern,value:"pattern"}
]}
,pattern:{
name:"pattern",label:ZmMsg.pattern,type:"string"}}
,func:function(e,i,o,t){
var a=t.getItem();
return ZmWiklet._formatDate(o,a.createDate)
}}
,{
name:"MODIFYDATE",label:ZmMsg.wikletModifyDate,tooltip:ZmMsg.wikletModifyDateTT,paramdefs:{
type:{
name:"type",label:ZmMsg.type,type:"enum",item:[{
label:ZmMsg.wikletDateShort,value:"shortdate"}
,{
label:ZmMsg.wikletDateLong,value:"longdate"}
,{
label:ZmMsg.wikletTimeShort,value:"shorttime"}
,{
label:ZmMsg.wikletTimeLong,value:"longtime"}
,{
label:ZmMsg.wikletDateTimeShort,value:"shortdateandtime"}
,{
label:ZmMsg.wikletDateTimeLong,value:"longdateandtime"}
,{
label:ZmMsg.pattern,value:"pattern"}
]}
,pattern:{
name:"pattern",label:ZmMsg.pattern,type:"string"}}
,func:function(e,i,o,t){
var a=t.getItem();
return ZmWiklet._formatDate(o,a.modifyDate||a.createDate)
}}
,{
name:"VERSION",label:ZmMsg.wikletVersion,tooltip:ZmMsg.wikletVersionTT,func:function(e,a,i,t){
return String(t.getItem().version)
}}
,{
name:"TOC",label:ZmMsg.wikletToc,tooltip:ZmMsg.wikletTocTT,paramdefs:{
type:{
name:"type",label:ZmMsg.type,type:"enum",item:[{
label:ZmMsg.pages,value:"pages"}
,{
label:ZmMsg.sections,value:"sections"}
,{
label:ZmMsg.all,value:"all"}
]}
,pattern:{
name:"pattern",label:ZmMsg.pattern,type:"string",value:""}
,sort:{
name:"sort",label:ZmMsg.sortOrder,type:"enum",item:[{
label:ZmMsg.ascending,value:"ascending"}
,{
label:ZmMsg.descending,value:"descending"}
]}
,format:{
name:"format",label:ZmMsg.format,type:"enum",item:[{
label:ZmMsg.simple,value:"simple"}
,{
label:ZmMsg.list,value:"list"}
,{
label:ZmMsg.template,value:"template"}
]}
,bodytemplate:{
name:"bodytemplate",label:ZmMsg.bodyTemplate,type:"string"}
,itemtemplate:{
name:"itemtemplate",label:ZmMsg.itemTemplate,type:"string"}}
,func:function(j,u,w,a){
var y=a.getItem();
var t=y instanceof ZmPage?y.folderId:y.id;
var n=/^[^_]/;
var d={
pages:n,sections:n,files:n};
var h={
pages:a.getPages,sections:a.getSections,files:a.getFiles};
var l=[];
for(var j in d){
if(w.type&&w.type!="all"&&w.type!=j){
continue
}
if(w[j]){
var q=w[j];
q=q.replace(/([\[\(\{\+\.])/g,"\\$1");
q=q.replace(/\?/g,".");
q=q.replace(/\*/g,".*");
d[j]=new RegExp("^"+q+"$","i")
}
var s=h[j];
var x=s.call(a,t);
var r=ZmWiklet.__object2Array(x,d[j]);
l=l.concat(r)
}
l.sort(ZmWiklet.__byItemName);
if(w.sort=="descending"){
l.reverse()
}
var m=[];
if(l.length==0){
m.push("<wiklet class='MSG' value='wikiPagesNotFound' />")
}else{
switch(w.format||"list"){
case"list":m.push("<ul class='zmwiki-tocList'>");
for(var p=0;
p<l.length;
p++){
var y=l[p];
m.push("<li class='zmwiki-pageLink'>","[[",y.name,"]]","</li>")
}
m.push("</ul>");
break;
case"template":var t=a.getItem().folderId;
var k=a.getPageByName(t,(w.itemTemplate||ZmNotebook.PAGE_TOC_ITEM_TEMPLATE),true);
var v=k.getContent();
for(var p=0;
p<l.length;
p++){
var o=a.getItemCount();
try{
a.pushItem(l[p]);
m.push(ZmWikletProcessor._process(v))
}
catch(g){}
a.setItemCount(o)
}
var f=a.getPageByName(t,(w.bodyTemplate||ZmNotebook.PAGE_TOC_BODY_TEMPLATE),true);
var c=f.getContent();
m=[c.replace(ZmWiklet.RE_CONTENT,m.join(""))];
break;
case"simple":default:m.push("<span class='zmwiki-tocSimple'>");
for(var p=0;
p<l.length;
p++){
var y=l[p];
m.push("<span class='zmwiki-pageLink'>","[[",l.name,"]]","</span>")
}
m.push("</span>");
break
}}
return m.join("")
}}
,{
name:"PATH",label:ZmMsg.wikletPath,tooltip:ZmMsg.wikletPathTT,paramdefs:{
format:{
name:"format",label:ZmMsg.format,type:"enum",item:[{
label:ZmMsg.simple,value:"simple"}
,{
label:ZmMsg.template,value:"template"}
]}
,bodytemplate:{
name:"bodytemplate",label:ZmMsg.bodyTemplate,type:"string"}
,itemtemplate:{
name:"itemtemplate",label:ZmMsg.itemTemplate,type:"string"}
,separator:{
name:"separator",label:ZmMsg.separator,type:"string"}
,links:{
name:"links",label:ZmMsg.wikletPathMakeLinks,type:"boolean",value:"true"}}
,func:function(q,d,w,a){
var y=a.getItem();
var r=a.getNotebookById(y.folderId||(y.parent&&y.parent.id));
var c=[];
var v=ZmOrganizer.getSystemId(ZmOrganizer.ID_ROOT);
while(r.id!=v){
c.unshift(r);
r=a.getNotebookById(r.parent.id)
}
var o=w.links==null||w.link=="true";
var u=[];
switch(w.format||"simple"){
case"template":var t=y.folderId;
var n=w.separator||"<td class='zmwiki-path_separator'>&nbsp;&raquo;&nbsp;</td>";
var x=a.getPageByName(t,(w.itemTemplate||ZmNotebook.PATH_ITEM_TEMPLATE),true);
var k=x.getContent();
for(var f=0;
f<c.length;
f++){
if(f>0){
u.push(n)
}
var s=a.getItemCount();
try{
a.pushItem(c[f]);
u.push(ZmWikletProcessor._process(k))
}
catch(g){}
a.setItemCount(s)
}
var m=a.getPageByName(t,(w.bodyTemplate||ZmNotebook.PATH_BODY_TEMPLATE),true);
var l=m.getContent();
u=[l.replace(ZmWiklet.RE_CONTENT,u.join(""))];
break;
case"simple":default:var n=w.separator||" &raquo; ";
u.push("<span class='zmwiki-pathSimple'>");
for(var f=0;
f<c.length;
f++){
if(f>0){
u.push(n)
}
var p=c[f];
var h=p.name;
u.push("<span class='zmwiki-pageLink'>",(o?"[[":""),h,(o?"]]":""),"</span>")
}
u.push("</span>");
break
}
return u.join("")
}}
,{
name:"CONTENT",label:null,tooltip:null,func:function(e,a,i,t){
return"((CONTENT))"
}}
)
}
if(AjxPackage.define("zimbraMail.notebook.view.wiklet.ZmWikletContext")){
ZmWikletContext=function(e){
this._notebookCache=e;
this._items=[]
};
ZmWikletContext.prototype._notebookCache;
ZmWikletContext.prototype._processor;
ZmWikletContext.prototype._items;
ZmWikletContext.prototype.pushItem=function(e){
this._items.push(e);
return this._items.length
};
ZmWikletContext.prototype.getItem=function(){
var e=this._items.length;
return e?this._items[e-1]:null
};
ZmWikletContext.prototype.getItemAt=function(e){
return this._items[e]
};
ZmWikletContext.prototype.getItemCount=function(){
return this._items.length
};
ZmWikletContext.prototype.setItemCount=function(e){
this._items.length=e
};
ZmWikletContext.prototype.getPages=function(e){
return this._notebookCache.getPagesInFolder(e)
};
ZmWikletContext.prototype.getPageByName=function(a,e,t){
return this._notebookCache.getPageByName(a,e,t)
};
ZmWikletContext.prototype.getNotebookById=function(e){
return appCtxt.getById(e)
};
ZmWikletContext.prototype.getSections=function(t){
var e=this.getNotebookById(t);
return e?e.children.getArray():[]
};
ZmWikletContext.prototype.getFiles=function(e){
return[]
};
ZmWikletContext.prototype.getCache=function(){
return this._notebookCache
};
ZmWikletContext.prototype.getTagById=function(e){
return appCtxt.getById(e)
};
ZmWikletContext.prototype.process=function(e){
return ZmWikletProcessor._process(e)
}
}
if(AjxPackage.define("zimbraMail.notebook.view.wiklet.ZmWikletProcessor")){
ZmWikletProcessor=function(){};
ZmWikletProcessor._context;
ZmWikletProcessor._data;
ZmWikletProcessor.process=function(i,a){
var e=appCtxt.getApp(ZmApp.NOTEBOOK);
var t=e.getNotebookCache();
ZmWikletProcessor._context=new ZmWikletContext(t);
ZmWikletProcessor._context.pushItem(i);
ZmWikletProcessor._data=[];
return ZmWikletProcessor._process(a)
};
ZmWikletProcessor._process=function(e){
if(!e){
return""
}
e=e.replace(/(\{\{)/g,ZmWikletProcessor._store);
e=e.replace(/<nowiklet>([.\n]*?)<\/nowiklet>/g,ZmWikletProcessor._store);
e=e.replace(ZmWiklet.RE_WIKLET,ZmWikletProcessor._wiklet);
e=e.replace(/\{\{(\d+)}}/g,ZmWikletProcessor._restore);
return e
};
ZmWikletProcessor._store=function(e,t){
ZmWikletProcessor._data.push(t);
return"{{"+ZmWikletProcessor._data.length+"}}"
};
ZmWikletProcessor._wiklet=function(n,l){
var r=n;
var o=ZmWikletProcessor.__parseValueAsParams(l);
var t=o["class"].toUpperCase();
var h=ZmWiklet.getWikletByName(t);
if(h){
var a=ZmWikletProcessor._context;
var i=a.getItemCount();
try{
r=h.func(t,l,o,a);
r=ZmWikletProcessor._process(r)
}
catch(s){}
a.setItemCount(i)
}
return r
};
ZmWikletProcessor._restore=function(e,t){
return ZmWikletProcessor._data[Number(t)-1]
};
ZmWikletProcessor.__parseValueAsParams=function(i){
var n={};
var a=/([a-z]+)\s*=\s*(?:'(.*?)'|"(.*?)"|(\S+))/ig;
var e;
while(e=a.exec(i)){
var t=e[1].toLowerCase();
var o=e[2]||e[3]||e[4]|"";
n[t]=o
}
return n
}
}
if(AjxPackage.define("zimbraMail.notebook.view.ZmNewNotebookDialog")){
ZmNewNotebookDialog=function(a,t){
var i=ZmMsg.createNewNotebook;
var e=ZmOrganizer.NOTEBOOK;
ZmNewOrganizerDialog.call(this,a,t,i,e)
};
ZmNewNotebookDialog.prototype=new ZmNewOrganizerDialog;
ZmNewNotebookDialog.prototype.constructor=ZmNewNotebookDialog;
ZmNewNotebookDialog.prototype.toString=function(){
return"ZmNewNotebookDialog"
};
ZmNewNotebookDialog.prototype._createRemoteContentHtml=function(t,e){
return e
}
}
if(AjxPackage.define("zimbraMail.notebook.view.ZmImportDialog")){
ZmImportDialog=function(e,t){
t=t||"ZmImportDialog";
var a=ZmMsg.importDocs;
DwtDialog.call(this,{
parent:e,className:t,title:a}
);
this.setButtonListener(DwtDialog.OK_BUTTON,new AjxListener(this,this._upload));
this._createUploadHtml()
};
ZmImportDialog.prototype=new DwtDialog;
ZmImportDialog.prototype.constructor=ZmImportDialog;
ZmImportDialog.ACTION_KEEP_MINE="mine";
ZmImportDialog.ACTION_KEEP_THEIRS="theirs";
ZmImportDialog.ACTION_ASK="ask";
ZmImportDialog.UPLOAD_FIELD_NAME="uploadFile";
ZmImportDialog.prototype._formId;
ZmImportDialog.prototype._tableId;
ZmImportDialog.prototype._selector;
ZmImportDialog.prototype._uploadFolder;
ZmImportDialog.prototype._uploadCallback;
ZmImportDialog.prototype.popup=function(t,n,o,i){
this._uploadFolder=t;
this._uploadCallback=n;
this.setTitle(o||ZmMsg.importDocs);
var e=document.getElementById(this._tableId);
var a=e.rows;
while(a.length){
e.deleteRow(a.length-1)
}
this._addFileInputRow();
this.setButtonEnabled(DwtDialog.OK_BUTTON,true);
this.setButtonEnabled(DwtDialog.CANCEL_BUTTON,true);
DwtDialog.prototype.popup.call(this,i)
};
ZmImportDialog.prototype.popdown=function(){
ZmDialog.prototype.popdown.call(this)
};
ZmImportDialog.CONVERTABLE=/\.(doc|xls|pdf|txt|html)/i;
ZmImportDialog.prototype._upload=function(){
var a=document.getElementById(this._formId);
var t=[];
var e=a.elements;
for(var r=0;
r<e.length;
r++){
var h=a.elements[r];
if(h.name!=ZmImportDialog.UPLOAD_FIELD_NAME){
continue
}
if(!h.value){
continue
}
var n={
fullname:h.value,name:h.value.replace(/^.*[\\\/:]/,"")};
if(!n.fullname.match(ZmImportDialog.CONVERTABLE)){
var o=ZmMsg.formatNotSupported;
var s=appCtxt.getMsgDialog();
s.reset();
s.setMessage(o,DwtMessageDialog.INFO_STYLE);
s.popup();
return
}
t.push(n)
}
if(t.length==0){
return
}
this.setButtonEnabled(DwtDialog.OK_BUTTON,false);
this.setButtonEnabled(DwtDialog.CANCEL_BUTTON,false);
var u=new AjxCallback(this,this._uploadSaveDocs,[t]);
var d=document.getElementById(this._formId);
var l=appCtxt.getUploadManager();
window._uploadManager=l;
try{
l.execute(u,d)
}
catch(c){
if(c.msg){
this._popupErrorDialog(c.msg)
}else{
this._popupErrorDialog(ZmMsg.unknownError)
}}};
ZmImportDialog.prototype._popupErrorDialog=function(t){
this.setButtonEnabled(DwtDialog.OK_BUTTON,true);
this.setButtonEnabled(DwtDialog.CANCEL_BUTTON,true);
var e=appCtxt.getMsgDialog();
e.setMessage(t,DwtMessageDialog.CRITICAL_STYLE,this._title);
e.popup()
};
ZmImportDialog.prototype._uploadSaveDocs=function(o,e,n){
if(e!=AjxPost.SC_OK){
var a=AjxMessageFormat.format(ZmMsg.uploadError,e);
this._popupErrorDialog(a)
}else{
n=n.split(",");
for(var t=0;
t<o.length;
t++){
o[t].guid=n[t]
}
this._uploadSaveDocs2(o,e,n)
}};
ZmImportDialog.prototype._uploadSaveDocs2=function(e,n,r){
var c=AjxSoapDoc.create("BatchRequest","urn:zimbra",null);
c.setMethodAttribute("onerror","continue");
for(var s=0;
s<e.length;
s++){
var a=e[s];
if(a.done){
continue
}
var l=c.set("SaveDocumentRequest",null,null,"urn:zimbraMail");
l.setAttribute("requestId",s);
var t=c.set("doc",null,l);
if(a.id){
t.setAttribute("id",a.id);
t.setAttribute("ver",a.version)
}else{
t.setAttribute("l",this._uploadFolder.id)
}
var m=c.set("upload",null,t);
m.setAttribute("id",a.guid)
}
var h=[e,n,r];
var u=new AjxCallback(this,this._uploadSaveDocsResponse,h);
var o={
soapDoc:c,asyncMode:true,callback:u,errorCallback:null};
var d=appCtxt.getAppController();
d.sendRequest(o)
};
ZmImportDialog.prototype._uploadSaveDocsResponse=function(o,m,d,t){
var h=t&&t._data&&t._data.BatchResponse;
if(h&&h.SaveDocumentResponse){
for(var w=0;
w<h.SaveDocumentResponse.length;
w++){
var e=h.SaveDocumentResponse[w];
o[e.requestId].done=true;
o[e.requestId].rest=e.doc[0].rest;
o[e.requestId].id=e.doc[0].id
}}
var r=[];
if(h&&h.Fault){
var s=[];
for(var w=0;
w<h.Fault.length;
w++){
var n=h.Fault[w];
var g=n.Detail.Error;
var a=g.Code;
var c=g.a;
if(a==ZmCsfeException.MAIL_ALREADY_EXISTS||a==ZmCsfeException.MODIFY_CONFLICT){
var k=o[n.requestId];
for(var l in c){
var u=c[l];
switch(u.n){
case"id":k.id=u._content;
break;
case"ver":k.version=u._content;
break;
case"rest":k.rest=u._content;
break
}}
r.push(k)
}else{
s[n.requestId]=n
}}}
this.popdown();
var y=r.length;
var f=this._selector.getValue();
if(y>0&&f==ZmImportDialog.ACTION_ASK){
var v=appCtxt.getUploadConflictDialog();
if(!this._conflictCallback){
this._conflictCallback=new AjxCallback(this,this._uploadSaveDocs2)
}
this._conflictCallback.args=[o,m,d];
v.popup(this._uploadFolder,r,this._conflictCallback)
}else{
if(y>0&&f==ZmImportDialog.ACTION_KEEP_MINE){
this._uploadSaveDocs2(o,m,d)
}else{
this._importAsHtml(o)
}}};
ZmImportDialog.prototype._importAsHtml=function(a){
var c=[];
for(var h=0;
h<a.length;
h++){
c.push(a[h].rest)
}
var r=c[0];
if(r){
var e=appCtxt.getApp(ZmApp.NOTEBOOK).getNotebookCache();
var o=e.parseURL(r);
r=o.path;
var d=r.indexOf("/home/");
var u=r.substring(d);
var l=u+"?view=html";
var t=AjxRpc.invoke("",l,{}
,null,true);
if(this._uploadCallback){
this._uploadCallback.run(this._uploadFolder,c,t,a)
}}else{
var n=ZmMsg.importFailed+": "+ZmMsg.unableToImportFile;
var s=appCtxt.getMsgDialog();
s.reset();
s.setMessage(n,DwtMessageDialog.INFO_STYLE);
s.popup()
}};
ZmImportDialog.prototype._addFileInputRow=function(){
var s=Dwt.getNextId();
var a=s+"_input";
var t=s+"_remove";
var i=s+"_add";
var o=document.getElementById(this._tableId);
var n=o.insertRow(-1);
var e=n.insertCell(-1);
e.innerHTML=["<input id='",a,"' type='file' name='",ZmImportDialog.UPLOAD_FIELD_NAME,"' size=30>"].join("");
var e=n.insertCell(-1);
e.innerHTML="&nbsp;"
};
ZmImportDialog._removeHandler=function(i){
var a=DwtUiEvent.getTarget(i||window.event);
var e=a.parentNode;
var n=e.parentNode;
if(n.prevSibling==null&&n.nextSibling==null){
var o=DwtControl.findControl(a);
var t=Dwt.getObjectFromElement(o);
t._addFileInputRow()
}
n.parentNode.removeChild(n)
};
ZmImportDialog._addHandler=function(a){
var t=DwtUiEvent.getTarget(a||window.event);
var i=DwtControl.findControl(t);
var e=Dwt.getObjectFromElement(i);
e._addFileInputRow()
};
ZmImportDialog.prototype._createUploadHtml=function(){
this._formId=Dwt.getNextId();
this._tableId=Dwt.getNextId();
this._selector=new DwtSelect({
parent:this}
);
this._selector.addOption(ZmMsg.uploadActionKeepMine,false,ZmImportDialog.ACTION_KEEP_MINE);
this._selector.addOption(ZmMsg.uploadActionKeepTheirs,false,ZmImportDialog.ACTION_KEEP_THEIRS);
this._selector.addOption(ZmMsg.uploadActionAsk,true,ZmImportDialog.ACTION_ASK);
var a=document.createElement("DIV");
a.style.marginBottom="0.5em";
a.innerHTML=ZmMsg.importChoose+" (.doc, .xls, .pdf, .txt and .html)";
var t=document.createElement("DIV");
t.style.marginLeft="1em";
t.style.marginBottom="0.5em";
var n=appCtxt.get(ZmSetting.CSFE_UPLOAD_URI);
t.innerHTML=["<form id='",this._formId,"' method='POST' action='",n,"' enctype='multipart/form-data'>","<table id='",this._tableId,"' cellspacing=4 cellpadding=0 border=0>","</table>","</form>"].join("");
var o=document.createElement("TABLE");
o.border=0;
o.cellPadding=0;
o.cellSpacing=4;
var s=o.insertRow(-1);
var e=s.insertCell(-1);
e.innerHTML=ZmMsg.uploadAction;
var e=s.insertCell(-1);
e.appendChild(this._selector.getHtmlElement());
var i=this._getContentDiv();
i.appendChild(a);
i.appendChild(t);
i.appendChild(o)
}
}
if(AjxPackage.define("zimbraMail.notebook.view.ZmUploadConflictDialog")){
ZmUploadConflictDialog=function(t,a){
a=a||"ZmUploadConflictDialog";
var i=ZmMsg.uploadConflict;
var e=[DwtDialog.OK_BUTTON,DwtDialog.CANCEL_BUTTON];
DwtDialog.call(this,{
parent:t,className:a,title:i,standardButtons:e}
);
this.setButtonListener(DwtDialog.OK_BUTTON,new AjxListener(this,this._resolve));
this._mineId=this._htmlElId+"_mine";
this._theirsId=this._htmlElId+"_theirs";
this._viewId=this._htmlElId+"_view";
this._createUploadHtml()
};
ZmUploadConflictDialog.prototype=new DwtDialog;
ZmUploadConflictDialog.prototype.constructor=ZmUploadConflictDialog;
ZmUploadConflictDialog.prototype.toString=function(){
return"ZmUploadConflictDialog"
};
ZmUploadConflictDialog._MINE="mine";
ZmUploadConflictDialog._THEIRS="theirs";
ZmUploadConflictDialog.prototype._mineId;
ZmUploadConflictDialog.prototype._theirsId;
ZmUploadConflictDialog.prototype._viewId;
ZmUploadConflictDialog.prototype._table;
ZmUploadConflictDialog.prototype._conflicts;
ZmUploadConflictDialog.prototype._conflictCallback;
ZmUploadConflictDialog.prototype.popup=function(o,e,r,s){
this._uploadFolder=o;
this._conflicts=e;
this._conflictCallback=r;
var a=this._table;
for(var t=a.rows.length-1;
t>0;
t--){
a.deleteRow(t)
}
for(var t=0;
t<e.length;
t++){
var n=e[t];
this.__addFileRow(a,n)
}
DwtDialog.prototype.popup.call(this,s)
};
ZmUploadConflictDialog.prototype.popdown=function(){
DwtDialog.prototype.popdown.call(this);
this._conflictCallback=null
};
ZmUploadConflictDialog.prototype._resolve=function(){
var e=this._conflicts;
var t=this._conflictCallback;
this.popdown();
if(t){
t.run(e)
}};
ZmUploadConflictDialog.prototype._selectAll=function(o){
var a=this.getHtmlElement();
var n=a.getElementsByTagName("INPUT");
for(var t=0;
t<n.length;
t++){
var e=n[t];
if(e.type!="radio"){
continue
}
e.checked=e.value==o;
ZmUploadConflictDialog.__setFileDone(e)
}};
ZmUploadConflictDialog._handleMine=function(t){
var a=DwtUiEvent.getTarget(t);
var e=Dwt.getObjectFromElement(a);
e._selectAll(ZmUploadConflictDialog._MINE)
};
ZmUploadConflictDialog._handleTheirs=function(t){
var a=DwtUiEvent.getTarget(t);
var e=Dwt.getObjectFromElement(a);
e._selectAll(ZmUploadConflictDialog._THEIRS)
};
ZmUploadConflictDialog._handleRadio=function(e){
var t=DwtUiEvent.getTarget(e);
ZmUploadConflictDialog.__setFileDone(t)
};
ZmUploadConflictDialog.__setFileDone=function(e){
var t=Dwt.getObjectFromElement(e);
t.done=e.value==ZmUploadConflictDialog._THEIRS
};
ZmUploadConflictDialog._handleViewTheirs=function(e){
var n=DwtUiEvent.getTarget(e);
var i=Dwt.getObjectFromElement(n);
var s=i.dialog;
var a=i.file;
var r=[s._uploadFolder.restUrl||s._uploadFolder.getRestUrl(),"/",AjxStringUtil.urlComponentEncode(a.name)].join("");
var t="_new";
var h=["width=",(window.outerWidth||640),",","height=",(window.outerHeight||480),",","location,menubar,","resizable,scrollbars,status,toolbar"].join("");
var o=open(r,t,h)
};
ZmUploadConflictDialog._handleLinkOver=function(e){
this.style.cursor="pointer"
};
ZmUploadConflictDialog._handleLinkOut=function(e){
this.style.cursor="default"
};
ZmUploadConflictDialog.prototype._createUploadHtml=function(){
var r=document.createElement("DIV");
r.innerHTML=ZmMsg.uploadConflictDesc;
r.style.marginBottom="0.5em";
var i=this._table=document.createElement("TABLE");
i.border=0;
i.cellPadding=0;
i.cellSpacing=3;
var n=i.insertRow(-1);
var e=n.insertCell(-1);
var s=this._mineId;
var o=ZmMsg._new;
var a=ZmUploadConflictDialog._handleMine;
e.appendChild(this.__createLink(s,o,a));
var e=n.insertCell(-1);
var s=this._theirsId;
var o=ZmMsg.old;
var a=ZmUploadConflictDialog._handleTheirs;
e.appendChild(this.__createLink(s,o,a));
var t=this._getContentDiv();
t.appendChild(r);
t.appendChild(i)
};
ZmUploadConflictDialog.prototype.__addFileRow=function(s,t){
var r=ZmUploadConflictDialog._handleRadio;
var h=s.insertRow(-1);
var o=h.insertCell(-1);
var i=ZmUploadConflictDialog._MINE;
o.appendChild(this.__createRadio(t.name,i,true,r,t));
var o=h.insertCell(-1);
var i=ZmUploadConflictDialog._THEIRS;
o.appendChild(this.__createRadio(t.name,i,false,r,t));
var o=h.insertCell(-1);
o.style.paddingLeft="1em";
o.innerHTML=AjxStringUtil.htmlEncode(t.name);
var o=h.insertCell(-1);
o.style.paddingLeft="2em";
var e=this._viewId+(s.rows.length-1);
var n=ZmMsg.viewOld;
var r=ZmUploadConflictDialog._handleViewTheirs;
var a={
dialog:this,file:t};
o.appendChild(this.__createLink(e,n,r,a))
};
ZmUploadConflictDialog.prototype.__createRadio=function(a,h,r,s,t){
var e;
if(AjxEnv.isIE){
var n=[];
var o=0;
n[o++]="<INPUT type=radio name='";
n[o++]=a;
n[o++]="'";
if(r){
n[o++]=" checked"
}
n[o++]=">";
e=document.createElement(n.join(""))
}else{
e=document.createElement("INPUT");
e.type="radio";
e.checked=r;
e.name=a
}
e.value=h;
if(s){
Dwt.setHandler(e,DwtEvent.ONCLICK,s);
Dwt.associateElementWithObject(e,t||this)
}
return e
};
ZmUploadConflictDialog.prototype.__createLink=function(o,i,a,e){
var t=document.createElement("SPAN");
t.id=o;
t.style.color="blue";
t.style.textDecoration="underline";
t.innerHTML=i;
Dwt.setHandler(t,DwtEvent.ONMOUSEOVER,ZmUploadConflictDialog._handleLinkOver);
Dwt.setHandler(t,DwtEvent.ONMOUSEOUT,ZmUploadConflictDialog._handleLinkOut);
Dwt.setHandler(t,DwtEvent.ONCLICK,a);
Dwt.associateElementWithObject(t,e||this);
return t
}
}
if(AjxPackage.define("zimbraMail.notebook.view.ZmPageConflictDialog")){
ZmPageConflictDialog=function(e,t){
t=t||"ZmPageConflictDialog";
var a=ZmMsg.saveConflict;
DwtDialog.call(this,{
parent:e,className:t,title:a,standardButtons:[DwtDialog.CANCEL_BUTTON]}
);
this._createContentHtml()
};
ZmPageConflictDialog.prototype=new DwtDialog;
ZmPageConflictDialog.prototype.constructor=ZmPageConflictDialog;
ZmPageConflictDialog.prototype.toString=function(){
return"ZmPageConflictDialog"
};
ZmPageConflictDialog.KEEP_MINE="mine";
ZmPageConflictDialog.KEEP_THEIRS="theirs";
ZmPageConflictDialog.prototype._conflict;
ZmPageConflictDialog.prototype._conflictCallback;
ZmPageConflictDialog.prototype._viewTheirsCallback;
ZmPageConflictDialog.prototype._keepMineCallback;
ZmPageConflictDialog.prototype._keepTheirsCallback;
ZmPageConflictDialog.prototype.popup=function(e,a,t){
this._conflict=e;
this._conflictCallback=a;
if(!this._formatter){
this._formatter=new AjxMessageFormat(ZmMsg.saveConflictDesc)
}
this._messageDiv.innerHTML=this._formatter.format(e.page.name);
DwtDialog.prototype.popup.call(this,t)
};
ZmPageConflictDialog.prototype.popdown=function(){
ZmDialog.prototype.popdown.call(this);
this._conflict=null;
this._conflictCallback=null
};
ZmPageConflictDialog.prototype._viewTheirsListener=function(a){
var o=this._conflict.page.getRestUrl();
var e="_new";
var t=["width=",(window.outerWidth||640),",","height=",(window.outerHeight||480),",","location,menubar,","resizable,scrollbars,status,toolbar"].join("");
var i=open(o,e,t)
};
ZmPageConflictDialog.prototype._keepMineListener=function(e){
var t=this._conflict;
var a=this._conflictCallback;
this.popdown();
if(a){
a.run(ZmPageConflictDialog.KEEP_MINE,t)
}};
ZmPageConflictDialog.prototype._keepTheirsListener=function(e){
var t=this._conflict;
var a=this._conflictCallback;
this.popdown();
if(a){
a.run(ZmPageConflictDialog.KEEP_THEIRS,t)
}};
ZmPageConflictDialog.prototype._createContentHtml=function(){
var t=new DwtButton({
parent:this}
);
var r=new DwtButton({
parent:this}
);
var n=new DwtButton({
parent:this}
);
t.setText(ZmMsg.saveConflictViewTheirs);
r.setText(ZmMsg.saveConflictKeepMine);
n.setText(ZmMsg.saveConflictKeepTheirs);
t.addSelectionListener(new AjxListener(this,this._viewTheirsListener));
r.addSelectionListener(new AjxListener(this,this._keepMineListener));
n.addSelectionListener(new AjxListener(this,this._keepTheirsListener));
var i=this._messageDiv=document.createElement("DIV");
i.style.marginBottom=".5em";
var o=document.createElement("TABLE");
o.border=0;
o.cellPadding=4;
o.cellSpacing=0;
var s=o.insertRow(-1);
var e=s.insertCell(-1);
e.appendChild(t.getHtmlElement());
var e=s.insertCell(-1);
e.innerHTML=ZmMsg.saveConflictViewTheirsDesc;
var s=o.insertRow(-1);
var e=s.insertCell(-1);
e.appendChild(r.getHtmlElement());
var e=s.insertCell(-1);
e.innerHTML=ZmMsg.saveConflictKeepMineDesc;
var s=o.insertRow(-1);
var e=s.insertCell(-1);
e.appendChild(n.getHtmlElement());
var e=s.insertCell(-1);
e.innerHTML=ZmMsg.saveConflictKeepTheirsDesc;
var a=this._getContentDiv();
a.appendChild(i);
a.appendChild(o)
}
}
if(AjxPackage.define("zimbraMail.notebook.view.ZmNotebookObjectHandler")){
ZmNotebookObjectHandler=function(){
ZmObjectHandler.call(this,ZmNotebookObjectHandler.TYPE)
};
ZmNotebookObjectHandler.prototype=new ZmObjectHandler;
ZmNotebookObjectHandler.prototype.constructor=ZmNotebookObjectHandler;
ZmNotebookObjectHandler.TYPE="notebook";
ZmNotebookObjectHandler.WIKIWORD_RE=/[A-Z]+[a-z]+[A-Z]+[a-zA-Z0-9]*/;
ZmNotebookObjectHandler.LITERAL_RE=/[^\]\|]+?/;
ZmNotebookObjectHandler.TWIKI_KEYWORD_RE=new RegExp("\\b("+ZmNotebookObjectHandler.WIKIWORD_RE.source+")\\b|(?:\\[\\[("+ZmNotebookObjectHandler.LITERAL_RE.source+")\\](?:\\[("+ZmNotebookObjectHandler.LITERAL_RE.source+")\\])?\\])","g");
ZmNotebookObjectHandler.MEDIAWIKI_KEYWORD_RE=new RegExp("\\b("+ZmNotebookObjectHandler.WIKIWORD_RE.source+")\\b|(?:\\[\\[("+ZmNotebookObjectHandler.LITERAL_RE.source+")(?:\\|([^\\]]*?))?\\]\\])","g");
ZmNotebookObjectHandler.WIKIPATH_RE=/^(?:\/\/([^\/]+))?(.*\/([^\/]+)?|.*)/;
ZmNotebookObjectHandler.URL_RE=/^((telnet:|mailto:|callto:)|((https?|ftp|gopher|news|file):\/\/))[^\s\r\n]*?$/gi;
ZmNotebookObjectHandler.prototype.match=function(e,i){
var t=this.matchTWiki(e,i);
var a=this.matchMediaWiki(e,i);
if(t&&a){
return t.index<=a.index?t:a
}
return t||a
};
ZmNotebookObjectHandler.prototype.matchTWiki=function(t,o){
ZmNotebookObjectHandler.TWIKI_KEYWORD_RE.lastIndex=o;
var e=ZmNotebookObjectHandler.TWIKI_KEYWORD_RE.exec(t);
if(e){
var a=e[2]||e[1];
var i=e[3]||e[2]||e[1];
e.matchLength=e[0].length;
e[0]=i;
e.context={
keyword:a,label:i}
}
return e
};
ZmNotebookObjectHandler.prototype.matchMediaWiki=function(t,s){
ZmNotebookObjectHandler.MEDIAWIKI_KEYWORD_RE.lastIndex=s;
var e=ZmNotebookObjectHandler.MEDIAWIKI_KEYWORD_RE.exec(t);
if(e){
var a=e[2]||e[1];
var o=e[2]||e[1];
e.matchLength=e[0].length;
if(e[3]!==undefined){
if(e[3]!=""){
o=e[3]
}else{
var n;
for(n=e.index+e.matchLength;
n<t.length;
n++){
if(t.charAt(n).match(/\s/)){
break
}}
o=e[2]+t.substring(e.index+e.matchLength,n);
e.matchLength=n-e.index
}}
e[0]=o;
e.context={
keyword:a,label:o}
}
return e
};
ZmNotebookObjectHandler.prototype.selected=function(s,t,o,e){
if(ZmNotebookObjectHandler.URL_RE.test(e.keyword)){
ZmNotebookObjectHandler.__openWindow(e.keyword);
return
}
var i=this._getItem(e);
if(!i){
if(!this._formatter){
this._formatter=new AjxMessageFormat(ZmMsg.pageNotFound)
}
var n=appCtxt.getAppController();
var a=this._formatter.format(e.keyword);
n.popupErrorDialog(a,null,null,true);
return
}
this._selectedHandleResponse(i)
};
ZmNotebookObjectHandler.prototype._selectedHandleResponse=function(a){
if(a instanceof ZmDocument){
var i=a.getRestUrl();
ZmNotebookObjectHandler.__openWindow(i);
return
}
var e=!a||(a.version==0&&a.name!=ZmNotebook.PAGE_INDEX);
var t=e?AjxDispatcher.run("GetPageEditController"):AjxDispatcher.run("GetNotebookController");
t.show(a)
};
ZmNotebookObjectHandler.__openWindow=function(i){
var e="_new";
var t=["width=",(window.outerWidth||640),",","height=",(window.outerHeight||480),",","location,menubar,","resizable,scrollbars,status,toolbar"].join("");
var a=open(i,e,t)
};
ZmNotebookObjectHandler.prototype.getToolTipText=function(t,o){
var n=this._getItem(o);
var s=!n&&ZmNotebookObjectHandler.URL_RE.test(o.keyword);
var i=null;
if(s){
i="ImgHtmlDoc"
}else{
if(n instanceof ZmDocument){
i="ImgGenericDoc"
}else{
if(n){
i=n.name==ZmNotebook.PAGE_INDEX?"ImgSection":"ImgPage"
}}}
var a=["<table border=0 cellpadding=0 cellspacing=0>","<tr><td>","<div style='border-bottom:solid black 1px;margin-bottom:0.25em'>","<table width=100% border=0 cellpadding=0 cellspacing=0>","<tr valign=top>","<td><b>",t,"</b></td>","<td align=right style='padding-left:0.5em'><div class='",i,"'></div></td>","</tr>","</table>","</div>","</td></tr>","<tr><td>"];
if(n&&n.fragment){
var e=AjxStringUtil.htmlEncode(n.fragment);
a.push(e,"<br>&nbsp;")
}
a.push("<table border=0 cellpadding=0 cellspacing=0>");
if(s){
this._appendPropertyToTooltip(a,o.keyword,ZmMsg.urlLabel)
}else{
if(n){
this._appendPropertyToTooltip(a,n.creator,ZmMsg.userLabel);
this._appendPropertyToTooltip(a,n.getRestUrl(),ZmMsg.urlLabel)
}
this._appendPropertyToTooltip(a,n?n.getPath():o.keyword,ZmMsg.pathLabel)
}
a.push("</table></td></tr></table>");
return a.join("")
};
ZmNotebookObjectHandler.prototype.getActionMenu=function(e){
return null
};
ZmNotebookObjectHandler.prototype._getItem=function(i){
var t=AjxDispatcher.run("GetNotebookCache");
var d=null;
try{
var u=i.keyword;
if(u!=i.label){
if(u.indexOf(":")==0){
var n=u.indexOf("/",1);
var o=u.substring(1,n);
var l=u.substring(n+1);
return t.getItemByName(o,l)
}}
if(!d){
d=t.getItemByLink(u)
}
if(!d&&!u.match(/^\/\//)){
var a=AjxDispatcher.run("GetNotebookController");
var r=a.getPage();
var c=ZmOrganizer.getSystemId(ZmOrganizer.ID_ROOT);
var o=u.match(/^\//)?c:(r&&r.folderId)||ZmNotebookItem.DEFAULT_FOLDER;
var s=this._getNotebook(o,u);
if(s){
d=new ZmPage();
d.name=u.replace(/^.*\//,"");
d.folderId=s.id
}}}
catch(h){}
return d
};
ZmNotebookObjectHandler.prototype._getNotebook=function(t,s){
var e=appCtxt.getById(t);
if(s.match("/")){
var n=s.replace(/^\//,"").replace(/\/[^\/]*$/,"").split("/");
for(var o=0;
o<n.length;
o++){
var a=n[o];
var r=e.getChild(a);
if(r==null){
e=null;
break
}
e=r
}}
return e
};
ZmNotebookObjectHandler.prototype._appendPropertyToTooltip=function(t,a,e){
if(a){
t.push("<tr valign=top>","<td align=right style='padding-right:5px'>","<b>",e,"</b>","</td>","<td>",a,"</td>","</tr>")
}};
ZmNotebookObjectHandler.prototype._getHtmlContent=function(i,e,t,a){
i[e++]=AjxStringUtil.htmlEncode(t);
return e
}
}
if(AjxPackage.define("zimbraMail.notebook.controller.ZmNotebookController")){
ZmNotebookController=function(e,t){
if(arguments.length==0){
return
}
ZmListController.call(this,e,t);
this._listeners[ZmOperation.REFRESH]=new AjxListener(this,this._refreshListener);
this._listeners[ZmOperation.EDIT]=new AjxListener(this,this._editListener);
this._listeners[ZmOperation.SEND_PAGE]=new AjxListener(this,this._sendPageListener);
this._listeners[ZmOperation.DETACH]=new AjxListener(this,this._detachListener);
this._listeners[ZmOperation.IMPORT_FILE]=new AjxListener(this,this._importListener);
this._listeners[ZmOperation.BROWSE_FOLDER]=new AjxListener(this,this._browseFolderListener)
};
ZmNotebookController.prototype=new ZmListController;
ZmNotebookController.prototype.constructor=ZmNotebookController;
ZmNotebookController.prototype.toString=function(){
return"ZmNotebookController"
};
ZmNotebookController._VIEWS={};
ZmNotebookController._VIEWS[ZmId.VIEW_NOTEBOOK_PAGE]=ZmNotebookPageView;
ZmNotebookController.prototype.show=function(e){
throw"TODO: show method not implemented"
};
ZmNotebookController.prototype.switchView=function(e,a){
var i=a||e!=this._currentView;
if(i){
this._currentView=e;
this._setup(e)
}
this._resetOperations(this._toolbar[e],1);
if(i){
var t={};
t[ZmAppViewMgr.C_TOOLBAR_TOP]=this._toolbar[this._currentView];
t[ZmAppViewMgr.C_APP_CONTENT]=this._listView[this._currentView];
this._setView({
view:e,elements:t,isAppView:!(this._fromSearch&&(e==ZmId.VIEW_NOTEBOOK_PAGE))}
)
}
Dwt.setTitle(this.getCurrentView().getTitle())
};
ZmNotebookController.prototype._standardActionMenuOps=function(){
return[ZmOperation.TAG_MENU,ZmOperation.DELETE,ZmOperation.PRINT]
};
ZmNotebookController.prototype._getToolBarOps=function(){
var e=this._getBasicToolBarOps();
e.push(ZmOperation.SEP);
e=e.concat(this._getItemToolBarOps());
e.push(ZmOperation.SEP,ZmOperation.TAG_MENU,ZmOperation.SEP,ZmOperation.FILLER);
e=e.concat(this._getNaviToolBarOps());
return e
};
ZmNotebookController.prototype._getBasicToolBarOps=function(){
var e=[ZmOperation.NEW_MENU];
e.push(ZmOperation.REFRESH,ZmOperation.EDIT);
e.push(ZmOperation.BROWSE_FOLDER);
return e
};
ZmNotebookController.prototype._getItemToolBarOps=function(){
return[ZmOperation.DELETE,ZmOperation.PRINT]
};
ZmNotebookController.prototype._getNaviToolBarOps=function(){
return[ZmOperation.SEND_PAGE,ZmOperation.SEP,ZmOperation.DETACH]
};
ZmNotebookController.prototype._initializeToolBar=function(t){
ZmListController.prototype._initializeToolBar.call(this,t);
this._setNewButtonProps(t,ZmMsg.createNewPage,"NewPage","NewPageDis",ZmOperation.NEW_PAGE);
var i=this._toolbar[this._currentView];
var a=i.getButton(ZmOperation.DELETE);
if(a){
a.setToolTipContent(ZmMsg.deletePermanentTooltip)
}
var e=i.getButton(ZmOperation.PRINT);
if(e){
e.setToolTipContent(ZmMsg.printDocument)
}};
ZmNotebookController.prototype._resetOperations=function(o,t){
if(!o){
return
}
ZmListController.prototype._resetOperations.call(this,o,t);
o.enable([ZmOperation.REFRESH,ZmOperation.PRINT,ZmOperation.DETACH],true);
o.enable(ZmOperation.SEND_PAGE,appCtxt.getActiveAccount().isZimbraAccount);
o.enable(ZmOperation.EDIT,(this._object&&!this._object.isReadOnly()));
if(appCtxt.get(ZmSetting.VIEW_ATTACHMENT_AS_HTML)){
var i=(this._object&&this._object.isIndex()&&!this._object.isFolderReadOnly());
o.enable(ZmOperation.IMPORT_FILE,i)
}
var a=(this._object&&!this._object.isIndex()&&this.isDeletable());
o.enable(ZmOperation.DELETE,a);
var e=(this._object&&!this._object.isShared()&&!this._object.isIndex());
o.enable([ZmOperation.TAG_MENU],e)
};
ZmNotebookController.prototype.isDeletable=function(){
var r=this._object;
if(!r){
return false
}
var h=r&&!r.isReadOnly();
if(!r.isIndex()){
return h
}
var t=r.id;
var l=ZmOrganizer.getSystemId(ZmOrganizer.ID_ROOT);
var s=appCtxt.getById(t);
var e=ZmOrganizer.getSystemId(ZmOrganizer.ID_NOTEBOOK);
var o=(s.id==l);
var a=(s.id==e);
var n=(!o&&s.parent.id==l);
var i=s.link;
var c=i||s.isRemote();
return(!a&&(!c||(i&&n)||ZmNotebookTreeController.__isAllowed(s.parent,ZmShare.PERM_DELETE)))
};
ZmNotebookController.prototype._getTagMenuMsg=function(){
return ZmMsg.tagPage
};
ZmNotebookController.prototype._doDelete=function(n,t){
if(!n){
n=this._listView[this._currentView].getSelection()
}
var o=n instanceof Array?n[0]:n;
if(o&&(o instanceof ZmPage)&&o.isIndex()){
var e=appCtxt.getOverviewController();
var a=e.getTreeController(ZmOrganizer.NOTEBOOK);
var s=appCtxt.getById(o.id);
if(s){
var r=new AjxCallback(a,a._deleteListener2,[s]);
var l=AjxMessageFormat.format(ZmMsg.confirmDeleteNotebook,AjxStringUtil.htmlEncode(s.name));
var i=appCtxt.getConfirmationDialog();
i.popup(l,r);
return
}}
var i=appCtxt.getConfirmationDialog();
var l=n instanceof Array&&n.length>1?ZmMsg.confirmDeleteItemList:null;
if(!l){
this._confirmDeleteFormatter=!(this._folderId==String(ZmOrganizer.ID_TRASH))?new AjxMessageFormat(ZmMsg.confirmDeleteItem):new AjxMessageFormat(ZmMsg.confirmPermanentDeleteItem);
var h=n instanceof Array?n[0]:n;
l=this._confirmDeleteFormatter.format(AjxStringUtil.htmlEncode(h.name))
}
var r=new AjxCallback(this,this._doDelete2,[n,t]);
i.popup(l,r)
};
ZmNotebookController.prototype._doDelete2=function(o,t){
var e=ZmNotebookController.__itemize(o);
if(!e){
return
}
var n=AjxSoapDoc.create("ItemActionRequest","urn:zimbraMail");
var s=n.set("action");
s.setAttribute("id",e);
s.setAttribute("op","delete");
var r=this._currentView==ZmId.VIEW_NOTEBOOK_PAGE?this._listeners[ZmOperation.PAGE_BACK]:null;
if(t){
r=t
}
var i={
soapDoc:n,asyncMode:true,callback:r,errorCallback:null,noBusyOverlay:false};
var h=appCtxt.getAppController();
var a=h.sendRequest(i);
return a
};
ZmNotebookController.prototype._getViewType=function(){
return this._currentView
};
ZmNotebookController.prototype._defaultView=function(){
return ZmId.VIEW_NOTEBOOK_PAGE
};
ZmNotebookController.prototype._createNewView=function(t){
if(!this._listView[t]){
var e=ZmNotebookController._VIEWS[t];
this._listView[t]=new e(this._container,this,this._dropTgt)
}
return this._listView[t]
};
ZmNotebookController.prototype._setViewContents=function(a){
this._listView[a].set(this._object);
if(this._object){
var e=appCtxt.getOverviewController();
var n=e.getTreeController(ZmOrganizer.NOTEBOOK);
var i=n.getTreeView(this._app.getOverviewId());
if(i){
var t=this._object.getFolderId();
var o=true;
i.setSelected(t,o)
}}};
ZmNotebookController.prototype._refreshListener=function(t){
var i=this._history[this._place];
if(i){
if(this._place==0){
this._showIndex(i.folderId)
}else{
var e=this._app.getNotebookCache();
var a=e.getPageByName(i.folderId,i.name);
a.load();
a.folderId=i.folderId;
this._listView[this._currentView].set(a)
}}};
ZmNotebookController.prototype._editListener=function(t){
var e=this._app.getPageEditController();
var a=this._listView[this._currentView].getVisiblePage();
e.show(a)
};
ZmNotebookController.prototype._importListener=function(a){
var e=this._object?this._object.getFolderId():ZmNotebookItem.DEFAULT_FOLDER;
var i=appCtxt.getById(e);
var o=new AjxCallback(this,this._importCallback);
var t=appCtxt.getImportDialog();
t.popup(i,o)
};
ZmNotebookController.prototype._importCallback=function(s,o,h,e){
var n=new ZmPage();
n.folderId=s?s.id:ZmNotebookItem.DEFAULT_FOLDER;
n.name=this._app.generateUniqueName(n.folderId);
if(h.success){
this.setImportedPageContent(n,h);
var i=new AjxCallback(this,this._saveResponseHandler,[n,e]);
var r=new AjxCallback(this,this._saveErrorResponseHandler,[n,e]);
this._importInProgress=true;
n.save(i,r)
}else{
var t=ZmMsg.importFailed+": "+ZmMsg.unableToGetPage;
var a=appCtxt.getMsgDialog();
a.reset();
a.setMessage(t,DwtMessageDialog.INFO_STYLE);
a.popup()
}};
ZmNotebookController.prototype.setImportedPageContent=function(a,e){
var t=e.text;
t=t.replace(/.*<body>/,"");
t=t.replace(/<\/body>.*/,"");
a.setContent(t)
};
ZmNotebookController.prototype._saveResponseHandler=function(o,a,t){
var e=t._data&&t._data.SaveWikiResponse;
if(e){
var i=e.w[0];
if(!o.id){
o.set(i)
}else{
o.version=i.ver
}
this.gotoPage(o)
}
this._importInProgress=false;
this.deleteImportedDocs(a)
};
ZmNotebookController.prototype.deleteImportedDocs=function(e){
this._doDelete2(e,new AjxCallback(this,this.deleteImportCallback))
};
ZmNotebookController.prototype.deleteImportCallback=function(){};
ZmNotebookController.prototype._saveErrorResponseHandler=function(i,a,t){
var o=ZmMsg.importFailed+": "+ZmMsg.unableToSavePage;
var e=appCtxt.getMsgDialog();
e.reset();
e.setMessage(o,DwtMessageDialog.INFO_STYLE);
e.popup();
this._importInProgress=false;
this.deleteImportedDocs(a)
};
ZmNotebookController.prototype._sendPageListener=function(f){
var r=this._listView[this._currentView];
var c=r.getSelection();
c=c instanceof Array?c:[c];
var h=[];
var y=[];
var n=this._app._inNewWindow(f);
var d="<wiklet class='NAME'/>";
var s,u;
var w=false;
for(var p=0;
p<c.length;
p++){
var v=c[p];
var a=v.getRestUrl();
if(v.remoteFolderId){
var l=this._app.getNotebookCache();
var k=l.getItemInfo({
id:v.remoteFolderId,ignoreCaching:true}
);
if(k){
a=k.getRestUrl()
}}
if(appCtxt.isOffline){
var e=appCtxt.get(ZmSetting.OFFLINE_REMOTE_SERVER_URI);
a=e+a.substring((a.indexOf("/",7)))
}
y.push(a);
h.push(ZmWikletProcessor.process(v,d));
if(w){
continue
}
s=appCtxt.getById(v.folderId);
u=s&&s.shares;
if(u){
for(var m=0;
m<u.length;
m++){
w=w||u[m].grantee.type==ZmShare.TYPE_PUBLIC
}}}
if(!u||!w){
var t=[h,y,n];
var o=new AjxCallback(this,this._sendPageListener2,t);
var g=appCtxt.getConfirmationDialog();
g.popup(ZmMsg.errorPermissionRequired,o)
}else{
this._sendPageListener2(h,y)
}};
ZmNotebookController.prototype._sendPageListener2=function(s,n,a){
var o=ZmOperation.NEW_MESSAGE;
var r=new ZmMailMsg();
var t=null;
var i=new AjxListFormat().format(s);
var e=n.join("\n");
AjxDispatcher.run("Compose",{
action:o,inNewWindow:a,msg:r,toOverride:t,subjOverride:i,extraBodyText:e}
)
};
ZmNotebookController.prototype._detachListener=function(t){
var h=this._listView[this._currentView];
var s=h.getSelection();
s=s instanceof Array?s:[s];
for(var o=0;
o<s.length;
o++){
var c=s[o];
var r=c.getRestUrl();
var e=this._app.getNotebookCache();
r=e.fixCrossDomainReference(r);
var a="_new";
var l=["width=",(window.outerWidth||640),",","height=",(window.outerHeight||480),",","location,menubar,","resizable,scrollbars,status,toolbar"].join("");
var n=open(r,a,l)
}};
ZmNotebookController.prototype._browseFolderListener=function(){
var e=this._object?this._object.getFolderId():ZmNotebookItem.DEFAULT_FOLDER;
var t=appCtxt.getById(e);
appCtxt.getSearchController().search({
query:t.createQuery(),types:[ZmItem.PAGE,ZmItem.DOCUMENT]}
)
};
ZmNotebookController.prototype._getDefaultFocusItem=function(){
return this._toolbar[this._currentView]
};
ZmNotebookController.prototype.gotoPage=function(e){};
ZmNotebookController.prototype.getItemTooltip=function(i,e){
var t=this._getDateInLocaleFormat(i.modifyDate);
var o=[{
name:ZmMsg.briefcasePropName,value:i.name}
,{
name:ZmMsg.briefcasePropSize,value:AjxUtil.formatSize(i.size)}
,{
name:ZmMsg.briefcasePropModified,value:(i.modifyDate?t+"":"")}
];
var a={
fileProperties:o,tagTooltip:e._getTagToolTip(i)};
return AjxTemplate.expand("briefcase.Briefcase#Tooltip",a)
};
ZmNotebookController.prototype._getDateInLocaleFormat=function(e){
var t=AjxDateFormat.getDateTimeInstance(AjxDateFormat.FULL,AjxDateFormat.MEDIUM);
return t.format(e)
};
ZmNotebookController.__itemize=function(o){
if(o instanceof Array){
var a=[];
for(var t=0;
t<o.length;
t++){
var e=o[t];
if(e.id){
a.push(e.id)
}}
return a.join()
}
return o.id
}
}
if(AjxPackage.define("zimbraMail.notebook.controller.ZmNotebookPageController")){
ZmNotebookPageController=function(e,t){
if(arguments.length==0){
return
}
ZmNotebookController.call(this,e,t);
this._history=[];
this._listeners[ZmOperation.CLOSE]=new AjxListener(this,this._closeListener)
};
ZmNotebookPageController.prototype=new ZmNotebookController;
ZmNotebookPageController.prototype.constructor=ZmNotebookPageController;
ZmNotebookPageController.prototype.toString=function(){
return"ZmNotebookPageController"
};
ZmNotebookPageController.prototype._place=-1;
ZmNotebookPageController.prototype.getKeyMapName=function(){
return"ZmNotebookPageController"
};
ZmNotebookPageController.prototype.handleKeyAction=function(e){
switch(e){
case ZmKeyMap.EDIT:if(this._object&&!this._object.isReadOnly()){
this._editListener()
}
break;
case ZmKeyMap.DEL:if(this._object&&!this._object.isReadOnly()){
return ZmListController.prototype.handleKeyAction.call(this,e)
}
break;
case ZmKeyMap.REFRESH:this._refreshListener();
break;
default:return ZmListController.prototype.handleKeyAction.call(this,e);
break
}
return true
};
ZmNotebookPageController.prototype.mapSupported=function(e){
return(e=="editor")
};
ZmNotebookPageController.prototype.gotoPage=function(a){
var e=this._app.getNotebookCache();
var t=null;
if(a.name=="_Index"){
t={
id:a.folderId}
}else{
if(a.pageId){
t={
folderId:a.folderId,id:a.pageId}
}else{
if(a.name){
t={
folderId:a.folderId,name:a.name}
}}}
this._object=e.getItemInfo(t);
this._setViewContents(this._currentView);
this._resetOperations(this._toolbar[this._currentView])
};
ZmNotebookPageController.prototype.setPage=function(t){
var e=this._app.getNotebookCache();
this._object=t;
this._resetOperations(this._toolbar[this._currentView])
};
ZmNotebookPageController.prototype.getPage=function(){
return this._object
};
ZmNotebookPageController.prototype.showLink=function(a){
var t=this._app.getNotebookCache();
try{
var i=t.getPageByLink(a);
if(i){
this.show(i)
}}
catch(o){
if(!this._formatter){
this._formatter=new AjxMessageFormat(ZmMsg.pageNotFound)
}
this.popupErrorDialog(this._formatter.format(a),null,null,true)
}};
ZmNotebookPageController.prototype.show=function(s,n,r){
if(!(s instanceof ZmPage)){
this._showIndex(s||ZmNotebookItem.DEFAULT_FOLDER,n,r);
return
}
this._fromSearch=r;
var o=this._object;
var a=s;
this._object=a;
var e=this._currentView;
if(!e){
e=this._defaultView();
n=true
}
this.switchView(e,n);
if(o&&o.name==a.name&&o.folderId==a.folderId){
return
}
if(!this._currentView._USE_IFRAME){
this._folderId=null;
if(this._object){
this._folderId=this._object.folderId;
for(var t=this._place+1;
t<this._history.length;
t++){
this._history[t]=null
}}
this._list=new ZmList(ZmItem.PAGE);
if(this._object){
this._list.add(this._object)
}}
this._setViewContents(this._currentView)
};
ZmNotebookPageController.prototype._getNaviToolBarOps=function(){
var e=ZmNotebookController.prototype._getNaviToolBarOps.call(this);
e=e.concat(ZmOperation.CLOSE);
return e
};
ZmNotebookPageController.prototype._initializeToolBar=function(e){
ZmNotebookController.prototype._initializeToolBar.call(this,e);
var a=this._toolbar[this._currentView];
var t=a.getButton(ZmOperation.CLOSE);
t.setVisible(this._fromSearch)
};
ZmNotebookPageController.prototype._resetOperations=function(a,e){
if(!a){
return
}
ZmNotebookController.prototype._resetOperations.call(this,a,e);
var t=a.getButton(ZmOperation.CLOSE);
if(t){
t.setVisible(this._fromSearch)
}};
ZmNotebookPageController.prototype._dropListener=function(t){
if(t.action==DwtDropEvent.DRAG_ENTER){
if(this._object&&(this._object.isShared()||this._object.isIndex())){
t.doIt=false
}else{
t.doIt=this._dropTgt.isValidTarget(t.srcData)
}}else{
if(t.action==DwtDropEvent.DRAG_DROP){
var e=t.srcData;
this._doTag([this._object],e,true)
}}};
ZmNotebookPageController.prototype._showIndex=function(e,i,n){
var t=this._app.getNotebookCache();
var o={
id:e};
var a=t.getItemInfo(o);
if(a){
this.show(a,i,n)
}};
ZmNotebookPageController.__setButtonToolTip=function(t,o,e){
var i=o?o.name:e;
if(i==ZmNotebook.PAGE_INDEX){
var a=appCtxt.getById(o.folderId);
if(a){
i=a.getName()
}else{}}
t.setToolTipContent(i)
};
ZmNotebookPageController.prototype.updateHistory=function(){
this._folderId=null;
if(this._object){
this._folderId=this._object.folderId;
for(var e=this._place+1;
e<this._history.length;
e++){
this._history[e]=null
}
this._history.length=++this._place;
var t={
folderId:this._object.folderId,name:this._object.name,pageId:this._object.id};
this._history[this._place]=t
}
this._list=new ZmList(ZmItem.PAGE);
if(this._object){
this._list.add(this._object)
}};
ZmNotebookPageController.prototype.refreshCurrentPage=function(){
if(this._object&&this._listView[ZmId.VIEW_NOTEBOOK_PAGE]){
this._listView[ZmId.VIEW_NOTEBOOK_PAGE].refresh(this._object.getRestUrl())
}};
ZmNotebookPageController.prototype.isIframeEnabled=function(){
if(this._listView[ZmId.VIEW_NOTEBOOK_PAGE]){
return this._listView[ZmId.VIEW_NOTEBOOK_PAGE]._USE_IFRAME
}else{
return false
}};
ZmNotebookPageController.prototype._refreshListener=function(t){
if(this.isIframeEnabled()){
var a=this._object;
var e=this._app.getNotebookCache();
e.removeItem(a);
this.refreshCurrentPage()
}else{
ZmNotebookController.prototype._refreshListener.call(this,t)
}};
ZmNotebookController.prototype.handleUpdate=function(d,n){
if(!n){
return
}
var s=this.getPage();
if(!s){
return
}
var e=this._app.getNotebookCache();
for(var h=0;
h<n.length;
h++){
var u=n[h];
var o=u.id;
var l=u.parent?u.parent.id:null;
if(s.isChildOf(o)||o==s.id||o==s.folderId||s.id==l){
if(o==s.folderId&&s.name==ZmNotebook.PAGE_INDEX){
s.restUrl=u.restUrl
}
var r=this._checkForUpdate(u);
var m=e.getItemInfo({
id:s.id}
,r);
e.putItem(m);
var a=d.getDetail("oldName");
if(a&&u.restUrl){
var c=u.restUrl.replace(new RegExp(("/"+u.name+"(/)?$")),"/"+a);
e.updateItems(o,c,u.restUrl)
}
var t=appCtxt.getAppViewMgr();
if(t.getCurrentViewId()!=ZmId.VIEW_NOTEBOOK_FILE&&!this._importInProgress){
this.gotoPage(m)
}}}};
ZmNotebookPageController.prototype._checkForUpdate=function(e){
if(e._updated){
e._updated=null;
return false
}
return true
};
ZmNotebookPageController.prototype._closeListener=function(a){
var i=appCtxt.getOverviewController().getTreeController(ZmOrganizer.NOTEBOOK);
var e=i.getTreeView(this._app.getOverviewId());
var t=e.getSelected();
i._itemClicked(t)
}
}
if(AjxPackage.define("zimbraMail.notebook.controller.ZmPageVersionController")){
ZmPageVersionController=function(e,t){
if(arguments.length==0){
return
}
ZmNotebookPageController.call(this,e,t);
this._listeners[ZmOperation.REVERT_PAGE]=new AjxListener(this,this._pageRevertListener)
};
ZmPageVersionController.prototype=new ZmNotebookPageController;
ZmPageVersionController.prototype.constructor=ZmPageVersionController;
ZmPageVersionController.prototype.toString=function(){
return"ZmPageVersionController"
};
ZmPageVersionController.prototype.loadVersion=function(t){
var e;
this._object=t;
this._page=t;
if(!this._currentView){
this._currentView=this._defaultView();
this._setup(this._currentView);
e=new Object();
e[ZmAppViewMgr.C_TOOLBAR_TOP]=this._toolbar[this._currentView];
e[ZmAppViewMgr.C_APP_CONTENT]=this._listView[this._currentView]
}
this._resetOperations(this._toolbar[this._currentView],1);
this._setView({
view:this._currentView,elements:e,isTransient:true}
)
};
ZmPageVersionController.prototype._defaultView=function(){
return ZmId.VIEW_NOTEBOOK_PAGE_VERSION
};
ZmPageVersionController.prototype._getToolBarOps=function(){
var e=[];
e.push(ZmOperation.REVERT_PAGE,ZmOperation.CLOSE);
return e
};
ZmPageVersionController.prototype._resetOperations=function(t,e){
if(!t){
return
}
ZmNotebookController.prototype._resetOperations.call(this,t,e)
};
ZmPageVersionController.prototype._createNewView=function(e){
if(!this._pageVersionView){
this._pageVersionView=new ZmPageVersionView(this._container,this)
}
return this._pageVersionView
};
ZmPageVersionController.prototype._setView=function(a,n,i,e,o,t){
ZmListController.prototype._setView.apply(this,arguments)
};
ZmPageVersionController.prototype._setViewContents=function(e){
this._listView[e].set(this._object)
};
ZmPageVersionController.prototype._initializeToolBar=function(e){
if(this._toolbar[e]){
return
}
ZmNotebookController.prototype._initializeToolBar.call(this,e);
this._setNewButtonProps(e,ZmMsg.createNewPage,"NewPage","NewPageDis",ZmOperation.NEW_PAGE)
};
ZmPageVersionController.prototype._pageRevertListener=function(e){
AjxDispatcher.run("GetPageEditController").show(this._object)
};
ZmPageVersionController.prototype.enableRevertButton=function(e){
if(this._toolbar[this._currentView]){
this._toolbar[this._currentView].enable([ZmOperation.REVERT_PAGE],e)
}}
}
if(AjxPackage.define("zimbraMail.notebook.controller.ZmNotebookFileController")){
ZmNotebookFileController=function(e,t){
ZmNotebookController.call(this,e,t);
this._listChangeListener=new AjxListener(this,this._fileListChangeListener);
this._dragSrc=new DwtDragSource(Dwt.DND_DROP_MOVE);
this._dragSrc.addDragListener(new AjxListener(this,this._dragListener));
this._listeners[ZmOperation.UNDELETE]=new AjxListener(this,this._undeleteListener)
};
ZmNotebookFileController.prototype=new ZmNotebookController;
ZmNotebookFileController.prototype.constructor=ZmNotebookFileController;
ZmNotebookFileController.prototype.toString=function(){
return"ZmNotebookFileController"
};
ZmNotebookFileController.prototype.show=function(a,n){
ZmListController.prototype.show.call(this,a);
this._fromSearch=n;
this._currentView=ZmId.VIEW_NOTEBOOK_FILE;
this._setup(this._currentView);
var d=a.getResults(ZmItem.MIXED);
this._list=new ZmMailList(ZmItem.MIXED,a.search);
if(d){
var s=d.getArray();
for(var h=0;
h<s.length;
h++){
var t=s[h];
var u=appCtxt.getById(t.folderId);
if(u&&u instanceof ZmNotebook){
this._list.add(t)
}}}
var o=this._listView[this._currentView];
if(this._activeSearch){
if(this._list){
var c=this._list.getArray();
if(c){
var l=((c instanceof Array)&&c.length>0)?c[0].list:c.list;
if(l){
l.addChangeListener(this._listChangeListener)
}}
this._list.setHasMore(this._activeSearch.getAttribute("more"))
}
if(o){
o.offset=parseInt(this._activeSearch.getAttribute("offset"))
}}
var e=new Object();
e[ZmAppViewMgr.C_TOOLBAR_TOP]=this._toolbar[this._currentView];
e[ZmAppViewMgr.C_APP_CONTENT]=o;
this._setView({
view:this._currentView,elements:e,isAppView:true}
);
this._resetNavToolBarButtons(this._currentView);
var l=o.getList();
if(l&&l.size()>0){
o.setSelection(l.get(0))
}};
ZmNotebookFileController.prototype._printListener=function(a){
var e=this._listView[this._currentView];
var t=e.getSelection();
var i=(t instanceof Array)?t[0]:t;
window.open(i.getRestUrl(true),"_blank")
};
ZmNotebookFileController.prototype._resetOperations=function(a,t){
ZmListController.prototype._resetOperations.call(this,a,t);
var i=this._toolbar[this._currentView];
var e=[ZmOperation.SEND,ZmOperation.DETACH];
i.enable(e,true)
};
ZmNotebookFileController.prototype._getToolBarOps=function(){
var e=[ZmOperation.NEW_MENU,ZmOperation.EDIT,ZmOperation.SEP];
if(appCtxt.get(ZmSetting.TAGGING_ENABLED)){
e.push(ZmOperation.TAG_MENU,ZmOperation.SEP)
}
e.push(ZmOperation.DELETE,ZmOperation.FILLER,ZmOperation.SEND_PAGE,ZmOperation.SEP,ZmOperation.DETACH);
return e
};
ZmNotebookFileController.prototype._initializeToolBar=function(t){
if(this._toolbar[t]){
return
}
ZmNotebookController.prototype._initializeToolBar.call(this,t);
this._toolbar[t].addFiller();
var e=new ZmNavToolBar({
parent:this._toolbar[t],context:t}
);
this._setNavToolBar(e,t);
this._setNewButtonProps(t,ZmMsg.compose,"NewPage","NewPageDis",ZmOperation.NEW_PAGE);
var i=this._toolbar[t];
var a=i.getButton(ZmOperation.EDIT);
a.setEnabled(false)
};
ZmNotebookFileController.prototype._initializeActionMenu=function(){
ZmListController.prototype._initializeActionMenu.call(this);
var a=this._getSearchFolder();
var t=a&&a.isInTrash();
var i=this._actionMenu;
var e=i.getMenuItem(ZmOperation.UNDELETE);
e.setVisible(t)
};
ZmNotebookFileController.prototype._getActionMenuOps=function(){
var e=this._standardActionMenuOps();
e.push(ZmOperation.UNDELETE);
return e
};
ZmNotebookFileController.prototype._getViewType=function(){
return ZmId.VIEW_NOTEBOOK_FILE
};
ZmNotebookFileController.prototype._createNewView=function(t){
var e=new ZmFileListView({
parent:this._container,posStyle:Dwt.ABSOLUTE_STYLE,controller:this,dropTgt:this._dropTgt}
);
e.setDragSource(this._dragSrc);
return e
};
ZmNotebookFileController.prototype._getTagMenuMsg=function(e){
return(e==1)?ZmMsg.tagItem:ZmMsg.tagItems
};
ZmNotebookFileController.prototype._getMoveDialogTitle=function(e){
return(e==1)?ZmMsg.moveItem:ZmMsg.moveItems
};
ZmNotebookFileController.prototype._setViewContents=function(e){
this._listView[e].set(this._list)
};
ZmNotebookFileController.prototype._editListener=function(t){
var e=this._app.getPageEditController();
var a=this._listView[this._currentView].getSelection()[0];
e.show(a)
};
ZmNotebookFileController.prototype._resetOperations=function(o,t){
if(!o){
return
}
ZmNotebookController.prototype._resetOperations.call(this,o,t);
var a=this._listView[this._currentView].getSelection();
var i=[ZmOperation.TAG_MENU,ZmOperation.DELETE];
o.enable(i,(a.length>0));
var e=a.length==1&&a[0].type==ZmItem.PAGE;
o.enable([ZmOperation.EDIT],e)
};
ZmNotebookFileController.prototype._listSelectionListener=function(e){
ZmListController.prototype._listSelectionListener.call(this,e);
if(e.detail==DwtListView.ITEM_DBL_CLICKED){
this._doSelectDblClicked(e.item)
}};
ZmNotebookFileController.prototype._doSelectDblClicked=function(i,n){
i.type=(i instanceof ZmPage)?ZmItem.PAGE:ZmItem.DOCUMENT;
if(i.type==ZmItem.PAGE){
var e=this._app.getNotebookController();
e.show(i,true,this._fromSearch||n)
}else{
if(i.type==ZmItem.DOCUMENT){
var a=i.getRestUrl();
var o=a.split("#");
var t=o[0]+(a.indexOf("?")<0?"?":"&")+("disp=i")+(o[1]?"#"+o[1]:"");
window.open(t,"_new","")
}}};
ZmNotebookFileController.prototype._listActionListener=function(e){
ZmListController.prototype._listActionListener.call(this,e);
var t=this.getActionMenu();
t.popup(0,e.docX,e.docY);
if(e.ersatz){
t.setSelectedItem(0)
}};
ZmNotebookFileController.prototype._undeleteListener=function(e){};
ZmNotebookFileController.prototype._doDelete=function(e){
if(!e){
return
}
var t=e instanceof Array?e[0].list:e.list;
var a=new AjxCallback(this,this.deleteCallback,[t]);
ZmNotebookController.prototype._doDelete.call(this,e,a)
};
ZmNotebookController.prototype.deleteCallback=function(s,l){
var a=l.getResponse();
var t=a.ItemActionResponse;
var o=new Array();
var r=this._listView[this._currentView];
if(t&&t.action){
var e=t.action.id.split(",");
if(e){
for(var n=0;
n<e.length;
n++){
var h=s.getById(e[n]);
if(h){
o.push(h)
}}}}
this._list._notify(ZmEvent.E_DELETE,{
items:o}
)
};
ZmNotebookFileController.prototype._fileListChangeListener=function(t){
if(t.handled){
return
}
var e=t._details;
if(!e){
return
}
this._list._notify(t.event,e)
}
}
if(AjxPackage.define("zimbraMail.notebook.controller.ZmPageEditController")){
ZmPageEditController=function(e,t){
ZmListController.call(this,e,t);
ZmPageEditController.RADIO_GROUP={};
ZmPageEditController.RADIO_GROUP[ZmOperation.FORMAT_HTML_SOURCE]=1;
ZmPageEditController.RADIO_GROUP[ZmOperation.FORMAT_MEDIA_WIKI]=1;
ZmPageEditController.RADIO_GROUP[ZmOperation.FORMAT_RICH_TEXT]=1;
ZmPageEditController.RADIO_GROUP[ZmOperation.FORMAT_TWIKI]=1;
this._listeners[ZmOperation.SAVE]=new AjxListener(this,this._saveListener);
this._listeners[ZmOperation.CLOSE]=new AjxListener(this,this._closeListener);
this._listeners[ZmOperation.SPELL_CHECK]=new AjxListener(this,this._spellCheckListener);
this._listeners[ZmOperation.COMPOSE_FORMAT]=new AjxListener(this,this._formatListener);
this._listeners[ZmOperation.NOTIFY]=new AjxListener(this,this._notifyListener);
this._page=null;
this._wikletParamDialog=null;
this._uploadCallback=null;
this._pageEditView=null;
this._popViewWhenSaved=null
};
ZmPageEditController.prototype=new ZmListController;
ZmPageEditController.prototype.constructor=ZmPageEditController;
ZmPageEditController.prototype.toString=function(){
return"ZmPageEditController"
};
ZmPageEditController.prototype.show=function(t){
this._page=AjxUtil.createProxy(t);
this._page.version=t.version;
var e;
if(!this._currentView){
this._currentView=this._defaultView();
this._setup(this._currentView);
e=new Object();
e[ZmAppViewMgr.C_TOOLBAR_TOP]=this._toolbar[this._currentView];
e[ZmAppViewMgr.C_APP_CONTENT]=this._listView[this._currentView]
}
this._resetOperations(this._toolbar[this._currentView],1);
this._setView({
view:this._currentView,elements:e,isTransient:true}
)
};
ZmPageEditController.prototype.getPage=function(){
return this._page
};
ZmPageEditController.prototype.getKeyMapName=function(){
return"ZmPageEditController"
};
ZmPageEditController.prototype.handleKeyAction=function(e){
switch(e){
case ZmKeyMap.SAVE:this._saveListener();
break;
case ZmKeyMap.CANCEL:this._closeListener();
break
}
return true
};
ZmPageEditController.prototype._getToolBarOps=function(){
var e=[ZmOperation.SAVE,ZmOperation.CLOSE,ZmOperation.SEP];
if(!appCtxt.isOffline){
e.push(ZmOperation.SPELL_CHECK)
}
e.push(ZmOperation.FILLER);
if(appCtxt.get(ZmSetting.HTML_COMPOSE_ENABLED)){
e.push(ZmOperation.COMPOSE_FORMAT)
}
e.push(ZmOperation.NOTIFY);
return e
};
ZmPageEditController.prototype._initializeToolBar=function(l){
if(this._toolbar[l]){
return
}
ZmListController.prototype._initializeToolBar.call(this,l);
var c=this._toolbar[l];
var f=c.getButton(ZmOperation.SPELL_CHECK);
if(f){
f.setAlign(DwtLabel.IMAGE_LEFT|DwtButton.TOGGLE_STYLE)
}
if(appCtxt.get(ZmSetting.HTML_COMPOSE_ENABLED)){
var n=c.getButton(ZmOperation.COMPOSE_FORMAT);
var a=new ZmPopupMenu(n);
var r=[{
op:ZmOperation.FORMAT_RICH_TEXT,format:ZmPageEditor.RICH_TEXT}
,{
op:ZmOperation.FORMAT_HTML_SOURCE,format:ZmPageEditor.HTML_SOURCE}
];
for(var o=0;
o<r.length;
o++){
var m=r[o];
var s=m.op;
var h=ZmOperation.getProp(s,"image");
var u=ZmMsg[ZmOperation.getProp(s,"textKey")];
var t=DwtMenuItem.RADIO_STYLE;
var d=ZmPageEditController.RADIO_GROUP[s];
var e=a.createMenuItem(s,{
image:h,text:u,style:t,radioGroupId:d}
);
e.setData(ZmOperation.KEY_ID,s);
e.setData(ZmPageEditor.KEY_FORMAT,m.format);
e.addSelectionListener(this._listeners[ZmOperation.COMPOSE_FORMAT])
}
n.setMenu(a)
}};
ZmPageEditController.prototype._defaultView=function(){
return ZmId.VIEW_NOTEBOOK_PAGE_EDIT
};
ZmPageEditController.prototype._createNewView=function(e){
if(!this._pageEditView){
this._pageEditView=new ZmPageEditView(this._container,this)
}
return this._pageEditView
};
ZmPageEditController.prototype._setView=function(i){
ZmListController.prototype._setView.apply(this,arguments);
this._format=this._format||ZmPageEditor.DEFAULT;
if(appCtxt.get(ZmSetting.HTML_COMPOSE_ENABLED)){
var t=this._toolbar[i.view];
var e=t.getButton(ZmOperation.COMPOSE_FORMAT);
var a=e.getMenu();
a.checkItem(ZmPageEditor.KEY_FORMAT,this._format,true)
}
if(!this._page||!this._page.name){
Dwt.setTitle(ZmMsg.zimbraTitle)
}else{
Dwt.setTitle([ZmMsg.zimbraTitle,this._page.name].join(": "))
}};
ZmPageEditController.prototype._setViewContents=function(e){
this._listView[e].set(this._page)
};
ZmPageEditController.prototype._getTagMenuMsg=function(){
return ZmMsg.tagPage
};
ZmPageEditController.prototype._saveListener=function(e){
this._doSave(false)
};
ZmPageEditController.INVALID_DOC_NAME_CHARS="[\\|]";
ZmPageEditController.INVALID_DOC_NAME_RE=new RegExp(ZmPageEditController.INVALID_DOC_NAME_CHARS);
ZmPageEditController.prototype._doSave=function(s){
var t=this._pageEditView.getPageName();
t=t.replace(/^\s+/,"").replace(/\s+$/,"");
var h;
if(t==""){
h=ZmMsg.errorSavingPageNameRequired
}else{
if(!ZmOrganizer.VALID_NAME_RE.test(t)||!ZmOrganizer.VALID_NAME_RE.test(unescape(t))||!ZmOrganizer.VALID_NAME_RE.test(decodeURI(t))||ZmPageEditController.INVALID_DOC_NAME_RE.test(t)){
h=AjxMessageFormat.format(ZmMsg.errorInvalidName,AjxStringUtil.htmlEncode(t))
}else{
if(t.length>ZmOrganizer.MAX_NAME_LENGTH){
h=AjxMessageFormat.format(ZmMsg.nameTooLong,ZmOrganizer.MAX_NAME_LENGTH)
}}}
var i=appCtxt.getById(this._page.folderId||ZmOrganizer.ID_NOTEBOOK);
if(i&&i.getChild(t)){
h=AjxMessageFormat.format(ZmMsg.errorInvalidPageOrSectionName,t)
}
if(h){
var e=DwtMessageDialog.WARNING_STYLE;
var n=this.warngDlg=appCtxt.getMsgDialog();
n.setMessage(h,e);
n.popup();
n.registerCallback(DwtDialog.OK_BUTTON,this._focusPageInput,this);
this._pageEditView.focus();
return false
}
this._filterScripts();
var o=this._pageEditView.getContent(true);
this._page.name=t;
this._page.setContent(o);
this._popViewWhenSaved=s;
var a=new AjxCallback(this,this._saveResponseHandler,[o]);
var r=new AjxCallback(this,this._saveErrorResponseHandler,[o]);
this._page.save(a,r);
return true
};
ZmPageEditController.prototype._filterScripts=function(){
var e=this._pageEditView;
var t=e._pageEditor;
if(t&&(t._mode==DwtHtmlEditor.HTML)){
var a=t._getIframeDoc();
this.removeComponent(a,"script");
this.removeComponent(a,"object");
this.removeComponent(a,"embed");
this.removeComponent(a,"applet")
}};
ZmPageEditController.prototype.removeComponent=function(o,t){
if(!t){
return
}
var a=o.getElementsByTagName(t);
if(!a){
return
}
for(var e=0;
e<a.length;
++e){
if(a[e].parentNode){
a[e].parentNode.removeChild(a[e])
}}};
ZmPageEditController.prototype._focusPageInput=function(){
if(this.warngDlg){
this.warngDlg.popdown()
}
this._pageEditView._pageNameInput.focus()
};
ZmPageEditController.prototype._showCurrentPage=function(){
if(this._page&&this._page.id){
this._showPage(this._page.id)
}};
ZmPageEditController.prototype._showPage=function(i){
var a=this._app.getNotebookController();
if(a.getCurrentView()){
var e=this._app.getNotebookCache();
var t=e.getPageById(i);
a.gotoPage(t)
}};
ZmPageEditController.prototype._saveResponseHandler=function(n,i){
var t=i._data&&i._data.SaveWikiResponse;
if(t){
var o=t.w[0];
if(!this._page.id){
this._page.set(o)
}else{
this._page.version=o.ver
}}
var e=this._app.getNotebookCache();
var r=e.getPageById(this._page.id);
if(r&&(r.name!=this._page.name)){
e.renamePage(r,this._page.name)
}
this._pageEditView.pageSaved(n);
appCtxt.setStatusMsg(ZmMsg.pageSaved);
var h=this._popViewWhenSaved;
var t=i._data&&i._data.SaveWikiResponse;
var p=t&&t.w&&t.w[0];
var c=/:/.test(p.id);
if(c){
p.l=this._page.folderId;
p.name=this._page.name
}
var m=e.getItemInfo({
id:this._page.id}
,true);
e.putPage(m);
var f=this._pageEditView.getPageEditor();
f.setFooterInfo(m);
var u=this._app.getNotebookController();
var l=u.getPage();
if(l&&(l.id==m.id)){
u._object=m
}
if(h){
this._popViewWhenSaved=false;
if(!c){
var s=[p.id];
var a=new AjxTimedAction(this,this._saveResponseHandlerShowNote,s);
AjxTimedAction.scheduleAction(a,0)
}else{
var s=[p.id];
var d=new AjxCallback(this,this._saveResponseHandlerShowNote,s);
page.load(null,d)
}}};
ZmPageEditController.prototype._saveResponseHandlerShowNote=function(e){
this._showPage(e);
appCtxt.getAppViewMgr().showPendingView(true)
};
ZmPageEditController.prototype._saveErrorResponseHandler=function(o,e){
var i=e.code;
if(i==ZmCsfeException.MAIL_ALREADY_EXISTS||i==ZmCsfeException.MODIFY_CONFLICT){
var s=e.data;
var n={
page:this._page,id:s.id[0],version:s.ver[0]};
var t=appCtxt.getPageConflictDialog();
var a=new AjxCallback(this,this._saveConflictHandler,[o]);
t.popup(n,a);
return true
}
return false
};
ZmPageEditController.prototype._saveConflictHandler=function(t,o,i){
if(o==ZmPageConflictDialog.KEEP_MINE){
var a=i.page;
a.id=ZmItem.getItemId(i.id);
a.version=i.version;
var n=new AjxCallback(this,this._saveResponseHandler,[t]);
var e=new AjxCallback(this,this._saveErrorResponseHandler,[t]);
a.save(n,e)
}};
ZmPageEditController.prototype._closeListener=function(a){
var i=appCtxt.getOverviewController().getTreeController(ZmOrganizer.NOTEBOOK);
var e=i.getTreeView(this._app.getOverviewId());
var t=e.getSelected();
i._itemClicked(t)
};
ZmPageEditController.prototype._notifyListener=function(t){
var e=appCtxt.getFolderNotifyDialog();
e.popup(this.getPage().getNotebook())
};
ZmPageEditController.prototype._spellCheckListener=function(i){
var a=this._toolbar[this._currentView];
var t=a.getButton(ZmOperation.SPELL_CHECK);
var e=this._pageEditView.getPageEditor();
if(t.isToggled()){
var o=new AjxCallback(this,this.toggleSpellCheckButton);
if(!e.spellCheck(o)){
this.toggleSpellCheckButton(false)
}}else{
e.discardMisspelledWords()
}};
ZmPageEditController.prototype.toggleSpellCheckButton=function(t){
var a=this._toolbar[this._currentView];
var e=a.getButton(ZmOperation.SPELL_CHECK);
if(e){
e.setSelected((t||false))
}};
ZmPageEditController.prototype._formatListener=function(i){
var o=i.item.getData(ZmOperation.KEY_ID);
if(o==ZmOperation.COMPOSE_FORMAT){
var a=this._toolbar[this._currentView];
var e=a.getButton(ZmOperation.COMPOSE_FORMAT);
e.popup();
return
}
if(!i.item.getChecked()){
return
}
var t=this._pageEditView.getContent();
this._format=i.item.getData(ZmPageEditor.KEY_FORMAT);
this._pageEditView.setFormat(this._format);
this._pageEditView.setContent(t)
};
ZmPageEditController.prototype._preHideCallback=function(e,t){
ZmController.prototype._preHideCallback.call(this);
if(!this._pageEditView.isDirty()||t){
var i=this._app.getNotebookController();
if(i.isIframeEnabled()){
i.refreshCurrentPage()
}else{
this._showCurrentPage()
}
return true
}
var a=this._popShield=appCtxt.getYesNoCancelMsgDialog();
a.reset();
a.setMessage(ZmMsg.askToSave,DwtMessageDialog.WARNING_STYLE);
a.registerCallback(DwtDialog.YES_BUTTON,this._popShieldYesCallback,this);
a.registerCallback(DwtDialog.NO_BUTTON,this._popShieldNoCallback,this);
a.registerCallback(DwtDialog.CANCEL_BUTTON,this._popShieldDismissCallback,this);
a.popup(this._pageEditView._getDialogXY());
return false
};
ZmPageEditController.prototype._preUnloadCallback=function(e){
return !this._pageEditView.isDirty()
};
ZmPageEditController.prototype._popShieldYesCallback=function(){
this._popShield.popdown();
if(this._doSave()){
appCtxt.getAppViewMgr().showPendingView(true)
}};
ZmPageEditController.prototype._popShieldNoCallback=function(){
this._popShield.popdown();
appCtxt.getAppViewMgr().showPendingView(true)
};
ZmPageEditController.prototype._popShieldDismissCallback=function(){
this._popShield.popdown();
appCtxt.getAppViewMgr().showPendingView(false)
};
ZmPageEditController.prototype.updatePageInfo=function(e){
this._pageEditView.getPageEditor().setFooterInfo(e)
}
}
if(AjxPackage.define("zimbraMail.notebook.controller.ZmNotebookTreeController")){
ZmNotebookTreeController=function(){
ZmTreeController.call(this,ZmOrganizer.NOTEBOOK);
this._listeners[ZmOperation.NEW_NOTEBOOK]=new AjxListener(this,this._newListener);
this._listeners[ZmOperation.SHARE_NOTEBOOK]=new AjxListener(this,this._shareNotebookListener);
this._listeners[ZmOperation.MOUNT_NOTEBOOK]=new AjxListener(this,this._mountNotebookListener);
this._listeners[ZmOperation.REFRESH]=new AjxListener(this,this._refreshListener);
this._listeners[ZmOperation.BROWSE_FOLDER]=new AjxListener(this,this._browseFolderListener);
this._listeners[ZmOperation.BROWSE]=new AjxListener(this,function(){
appCtxt.getSearchController().fromBrowse("")
}
);
this._eventMgrs={}
};
ZmNotebookTreeController.prototype=new ZmTreeController;
ZmNotebookTreeController.prototype.constructor=ZmNotebookTreeController;
ZmNotebookTreeController.prototype.toString=function(){
return"ZmNotebookTreeController"
};
ZmNotebookTreeController.prototype.resetOperations=function(l,h,a){
var c=ZmOrganizer.getSystemId(ZmOrganizer.ID_ROOT);
if(l&&a!=c){
var r=appCtxt.getById(a);
if(!r){
return
}
var t=ZmOrganizer.getSystemId(ZmOrganizer.ID_NOTEBOOK);
var n=(r.id==c);
var i=(r.id==t);
var s=(!n&&r.parent.id==c);
var o=r.link;
var d=o||r.isRemote();
var e=l.getMenuItem(ZmOperation.DELETE);
e.setEnabled(!i&&(!d||(o&&s)||ZmNotebookTreeController.__isAllowed(r.parent,ZmShare.PERM_DELETE)));
e=l.getMenuItem(ZmOperation.NEW_NOTEBOOK);
e.setText(ZmMsg.newSection);
e.setImage("NewSection");
e.setEnabled(!d||ZmNotebookTreeController.__isAllowed(r,ZmShare.PERM_CREATE_SUBDIR));
if(appCtxt.get(ZmSetting.SHARING_ENABLED)){
i=(!n&&r.parent.id==c);
e=l.getMenuItem(ZmOperation.MOUNT_NOTEBOOK);
e.setImage(n?"SharedNotebook":"SharedSection");
e.setEnabled(!d||ZmNotebookTreeController.__isAllowed(r,ZmShare.PERM_CREATE_SUBDIR));
e=l.getMenuItem(ZmOperation.SHARE_NOTEBOOK);
e.setText(i?ZmMsg.shareNotebook:ZmMsg.shareSection);
e.setImage(i?"Notebook":"Section");
e.setEnabled(!d||r.isAdmin())
}}
if(l){
var e=l.getMenuItem(ZmOperation.REFRESH);
e.setImage("Refresh")
}};
ZmNotebookTreeController.__isAllowed=function(e,t){
var i=true;
if(e.link||e.isRemote()){
i=false;
var a=e.getMainShare();
if(a&&!a.isPermRestricted(t)){
i=a.isPermAllowed(t)
}}
return i
};
ZmNotebookTreeController.prototype._getHeaderActionMenuOps=function(){
var e=[ZmOperation.NEW_NOTEBOOK];
if(appCtxt.get(ZmSetting.SHARING_ENABLED)){
e.push(ZmOperation.MOUNT_NOTEBOOK)
}
e.push(ZmOperation.EXPAND_ALL,ZmOperation.SEP,ZmOperation.REFRESH,ZmOperation.BROWSE);
return e
};
ZmNotebookTreeController.prototype._getActionMenuOps=function(){
var e=[ZmOperation.NEW_NOTEBOOK];
if(appCtxt.get(ZmSetting.SHARING_ENABLED)){
e.push(ZmOperation.MOUNT_NOTEBOOK)
}
e.push(ZmOperation.SEP);
if(appCtxt.get(ZmSetting.SHARING_ENABLED)){
e.push(ZmOperation.SHARE_NOTEBOOK)
}
e.push(ZmOperation.BROWSE_FOLDER,ZmOperation.DELETE,ZmOperation.EDIT_PROPS,ZmOperation.REFRESH);
return e
};
ZmNotebookTreeController.prototype._getNewDialog=function(){
return appCtxt.getNewNotebookDialog()
};
ZmNotebookTreeController.prototype.getTreeStyle=function(){
return DwtTree.SINGLE_STYLE
};
ZmNotebookTreeController.prototype._itemClicked=function(a){
if(appCtxt.getCurrentViewId()!=ZmId.VIEW_NOTEBOOK_PAGE){
appCtxt.getAppViewMgr().setView(ZmId.VIEW_NOTEBOOK_PAGE)
}
var i=AjxDispatcher.run("GetNotebookController");
i.show(a?a.id:ZmOrganizer.ID_NOTEBOOK,true);
if(appCtxt.get(ZmSetting.SHOW_SEARCH_STRING)){
var t=appCtxt.getSearchController();
var e=['in:"',a.getSearchPath(),'"'].join("");
t.setDefaultSearchType(ZmItem.PAGE);
t.setSearchField(e)
}};
ZmNotebookTreeController.prototype._dropListener=function(){};
ZmNotebookTreeController.prototype._changeListener=function(i,t,o){
ZmTreeController.prototype._changeListener.call(this,i,t,o);
if(i.type!=this.type){
return
}
if(o!=this._actionedOverviewId){
return
}
var n=AjxDispatcher.run("GetNotebookController");
var e=AjxDispatcher.run("GetNotebookCache");
var a=i.getDetail("organizers");
if(!a&&i.source){
a=[i.source]
}
n.handleUpdate(i,a)
};
ZmNotebookTreeController.prototype._shareNotebookListener=function(a){
this._pendingActionData=this._getActionedOrganizer(a);
var i=this._pendingActionData;
var t=null;
var e=appCtxt.getSharePropsDialog();
e.popup(ZmSharePropsDialog.NEW,i,t)
};
ZmNotebookTreeController.prototype._refreshListener=function(a){
this._pendingActionData=this._getActionedOrganizer(a);
var o=this._pendingActionData;
var t=AjxDispatcher.run("GetNotebookCache");
t.fillCache(o.id);
var e=AjxDispatcher.run("GetNotebookController");
var i=e.getPage();
if(i&&i.folderId==o.id){
e.gotoPage(i)
}};
ZmNotebookTreeController.prototype._browseFolderListener=function(t){
var e=this._getActionedOrganizer(t);
appCtxt.getSearchController().search({
query:e.createQuery(),types:[ZmItem.PAGE,ZmItem.DOCUMENT]}
)
};
ZmNotebookTreeController.prototype._editNotebookListener=function(i){
this._pendingActionData=this._getActionedOrganizer(i);
var n=this._pendingActionData;
var s=i.item.getData(ZmOperation.KEY_ID);
if(s==ZmOperation.EDIT_NOTEBOOK_INDEX){
s=ZmNotebook.PAGE_INDEX
}else{
if(s==ZmOperation.EDIT_NOTEBOOK_CHROME){
s=ZmNotebook.PAGE_CHROME
}else{
if(s==ZmOperation.EDIT_NOTEBOOK_STYLES){
s=ZmNotebook.PAGE_CHROME_STYLES
}else{
if(s==ZmOperation.EDIT_NOTEBOOK_HEADER){
s=ZmNotebook.PAGE_HEADER
}else{
if(s==ZmOperation.EDIT_NOTEBOOK_FOOTER){
s=ZmNotebook.PAGE_FOOTER
}else{
if(s==ZmOperation.EDIT_NOTEBOOK_SIDE_BAR){
s=ZmNotebook.PAGE_SIDE_BAR
}}}}}}
var a=s;
var t=AjxDispatcher.run("GetNotebookCache");
var e=AjxDispatcher.run("GetPageEditController");
var o=t.getPageByName(n.id,a,true);
e.show(o)
};
ZmNotebookTreeController.prototype._deleteListener=function(i){
var e=this._getActionedOrganizer(i);
var o=new AjxCallback(this,this._deleteListener2,[e]);
var a=AjxMessageFormat.format(ZmMsg.confirmDeleteNotebook,e.name);
var t=appCtxt.getConfirmationDialog();
t.popup(a,o)
};
ZmNotebookTreeController.prototype._deleteListener2=function(e){
this._doDelete(e)
};
ZmNotebookTreeController.prototype._notifyListeners=function(n,o,e,i,a,t){
if(this._eventMgrs[n]&&this._eventMgrs[n].isListenerRegistered(o)){
if(a){
DwtUiEvent.copy(t,a)
}
t.items=e;
if(e.length==1){
t.item=e[0]
}
t.detail=i;
this._eventMgrs[n].notifyListeners(o,t)
}};
ZmNotebookTreeController.prototype._doCreate=function(o){
var i;
var n=ZmOrganizer.getSystemId(ZmOrganizer.ID_NOTEBOOK);
var e=(o.parent&&o.parent.id)||n;
var t=AjxDispatcher.run("GetNotebookCache");
if(t.getPageByName(e,o.name)){
i=AjxMessageFormat.format(ZmMsg.errorInvalidPageOrSectionName,o.name)
}
if(i){
var a=appCtxt.getMsgDialog();
a.setMessage(i,DwtMessageDialog.WARNING_STYLE);
a.popup();
return
}
ZmTreeController.prototype._doCreate.apply(this,[o])
};
ZmNotebookTreeController.prototype._getItems=function(i){
var a=this.getTreeView(i);
if(a){
var e=ZmOrganizer.getSystemId(ZmOrganizer.ID_ROOT);
var t=a.getTreeItemById(e);
if(t){
return t.getItems()
}}
return[]
}
}};
