
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
if(AjxPackage.define("TasksCore")){
if(AjxPackage.define("zimbraMail.calendar.model.ZmCalItem")){
ZmCalItem=function(a,i,o,t){
if(arguments.length==0){
return
}
ZmCalBaseItem.call(this,a,i,o,t);
this.notesTopPart=null;
this.attachments=null;
this.viewMode=ZmCalItem.MODE_NEW;
this._recurrence=new ZmRecurrence(this);
this._noBusyOverlay=null;
this._sendNotificationMail=true;
this.identity=null;
this.isProposeTimeMode=false;
this.isForwardMode=false;
this.alarmActions=new AjxVector();
this.alarmActions.add(ZmCalItem.ALARM_DISPLAY);
this._useAbsoluteReminder=false;
this._ignoreVersion=false
};
ZmCalItem.prototype=new ZmCalBaseItem;
ZmCalItem.prototype.constructor=ZmCalItem;
ZmCalItem.prototype.toString=function(){
return"ZmCalItem"
};
ZmCalItem.MODE_NEW=1;
ZmCalItem.MODE_EDIT=2;
ZmCalItem.MODE_EDIT_SINGLE_INSTANCE=3;
ZmCalItem.MODE_EDIT_SERIES=4;
ZmCalItem.MODE_DELETE=5;
ZmCalItem.MODE_DELETE_INSTANCE=6;
ZmCalItem.MODE_DELETE_SERIES=7;
ZmCalItem.MODE_NEW_FROM_QUICKADD=8;
ZmCalItem.MODE_GET=9;
ZmCalItem.MODE_FORWARD=10;
ZmCalItem.MODE_FORWARD_SINGLE_INSTANCE=11;
ZmCalItem.MODE_FORWARD_SERIES=12;
ZmCalItem.MODE_FORWARD_INVITE=13;
ZmCalItem.MODE_PROPOSE_TIME=14;
ZmCalItem.MODE_PURGE=15;
ZmCalItem.MODE_LAST=15;
ZmCalItem.FORWARD_MAPPING={};
ZmCalItem.FORWARD_MAPPING[ZmCalItem.MODE_FORWARD]=ZmCalItem.MODE_EDIT;
ZmCalItem.FORWARD_MAPPING[ZmCalItem.MODE_FORWARD_SINGLE_INSTANCE]=ZmCalItem.MODE_EDIT_SINGLE_INSTANCE;
ZmCalItem.FORWARD_MAPPING[ZmCalItem.MODE_FORWARD_SERIES]=ZmCalItem.MODE_EDIT_SERIES;
ZmCalItem.FORWARD_MAPPING[ZmCalItem.MODE_FORWARD_INVITE]=ZmCalItem.MODE_EDIT;
ZmCalItem.PRIORITY_LOW=9;
ZmCalItem.PRIORITY_NORMAL=5;
ZmCalItem.PRIORITY_HIGH=1;
ZmCalItem.ROLE_CHAIR="CHA";
ZmCalItem.ROLE_REQUIRED="REQ";
ZmCalItem.ROLE_OPTIONAL="OPT";
ZmCalItem.ROLE_NON_PARTICIPANT="NON";
ZmCalItem.SERVER_WEEK_DAYS=["SU","MO","TU","WE","TH","FR","SA"];
ZmCalItem.ATTACHMENT_CHECKBOX_NAME="__calAttCbox__";
ZmCalItem.REMINDER_UNIT_MINUTES="minutes";
ZmCalItem.REMINDER_UNIT_HOURS="hours";
ZmCalItem.REMINDER_UNIT_DAYS="days";
ZmCalItem.REMINDER_UNIT_WEEKS="weeks";
ZmCalItem.REMINDER_NONE="none";
ZmCalItem.ALARM_DISPLAY="DISPLAY";
ZmCalItem.ALARM_EMAIL="EMAIL";
ZmCalItem.ALARM_DEVICE_EMAIL="DEVICE_EMAIL";
ZmCalItem.prototype.getCompNum=function(){
return this.compNum||"0"
};
ZmCalItem.prototype.getFolder=function(){};
ZmCalItem.prototype.getOrganizer=function(){
return this.organizer||""
};
ZmCalItem.prototype.getSentBy=function(){
return this.sentBy||""
};
ZmCalItem.prototype.getOrigStartDate=function(){
return this._origStartDate||this.startDate
};
ZmCalItem.prototype.getOrigStartTime=function(){
return this.getOrigStartDate().getTime()
};
ZmCalItem.prototype.getOrigTimezone=function(){
return this._origTimezone||this.timezone
};
ZmCalItem.prototype.getRecurBlurb=function(){
return this._recurrence.getBlurb()
};
ZmCalItem.prototype.getRecurrence=function(){
return this._recurrence
};
ZmCalItem.prototype.getRecurType=function(){
return this._recurrence.repeatType
};
ZmCalItem.prototype.getTimezone=function(){
return this.timezone
};
ZmCalItem.prototype.getSummary=function(t){};
ZmCalItem.prototype.getToolTip=function(t){};
ZmCalItem.prototype.isCustomRecurrence=function(){
return this._recurrence.repeatCustom=="1"||this._recurrence.repeatEndType!="N"
};
ZmCalItem.prototype.isOrganizer=function(){
return(typeof(this.isOrg)==="undefined")||(this.isOrg==true)
};
ZmCalItem.prototype.isRecurring=function(){
return(this.recurring||(this._rawRecurrences!=null))
};
ZmCalItem.prototype.hasAttachments=function(){
return this.getAttachments()!=null
};
ZmCalItem.prototype.hasAttendeeForType=function(t){
return false
};
ZmCalItem.prototype.hasAttendees=function(){
return false
};
ZmCalItem.prototype.hasPersonAttendees=function(){
return false
};
ZmCalItem.prototype.setAllDayEvent=function(t){
this.allDayEvent=t?"1":"0"
};
ZmCalItem.prototype.setName=function(t){
this.name=t
};
ZmCalItem.prototype.setOrganizer=function(t){
this.organizer=t!=""?t:null
};
ZmCalItem.prototype.setRecurType=function(t){
this._recurrence.repeatType=t
};
ZmCalItem.prototype.setType=function(t){
this.type=t
};
ZmCalItem.prototype.setOrigTimezone=function(t){
this._origTimezone=t
};
ZmCalItem.prototype.setFolderId=function(t){
this.folderId=t||ZmOrganizer.ID_CALENDAR
};
ZmCalItem.prototype.getLocalFolderId=function(){
var a=this.folderId;
if(this.isShared()){
var t=appCtxt.getById(this.folderId);
if(t){
a=t.id
}}
return a
};
ZmCalItem.prototype.setEndDate=function(a,t){
this.endDate=new Date(a instanceof Date?a.getTime():a);
if(!t){
this._resetCached()
}};
ZmCalItem.prototype.setStartDate=function(t,a){
if(this._origStartDate==null&&this.startDate!=null&&this.startDate!=""){
this._origStartDate=new Date(this.startDate.getTime())
}
this.startDate=new Date(t instanceof Date?t.getTime():t);
if(!a){
this._resetCached()
}
if(this.recurring&&this._recurrence){
this._recurrence.setRecurrenceStartTime(this.startDate.getTime())
}};
ZmCalItem.prototype.setTimezone=function(t,a){
if(this._origTimezone==null){
this._origTimezone=t
}
this.timezone=t;
if(!a){
this._resetCached()
}};
ZmCalItem.prototype.setEndTimezone=function(t){
if(this._origEndTimezone==null){
this._origEndTimezone=t
}
this.endTimezone=t
};
ZmCalItem.prototype.setViewMode=function(t){
this.viewMode=t||ZmCalItem.MODE_NEW;
if(this.viewMode==ZmCalItem.MODE_EDIT_SINGLE_INSTANCE){
this._recurrence.repeatType="NON"
}};
ZmCalItem.prototype.getViewMode=function(t){
return this.viewMode
};
ZmCalItem.prototype.getNotesPart=function(n){
if(this.notesTopPart){
var t=n||ZmMimeTable.TEXT_PLAIN;
var a=this.notesTopPart.getContentForType(t);
if(a==null||a==""){
if(t==ZmMimeTable.TEXT_PLAIN){
var o=document.createElement("div");
a=this.notesTopPart.getContentForType(ZmMimeTable.TEXT_HTML);
o.innerHTML=a||"";
var i=AjxStringUtil.convertHtml2Text(o);
return i.substring(1)
}else{
if(t==ZmMimeTable.TEXT_HTML){
a=AjxStringUtil.convertToHtml(this.notesTopPart.getContentForType(ZmMimeTable.TEXT_PLAIN))
}}}
return AjxUtil.isString(a)?a:a.content
}else{
return this.fragment
}};
ZmCalItem.prototype.getRemoteFolderOwner=function(){
var a=AjxDispatcher.run("GetCalController");
if(a.isMovingBetwAccounts(this,this.folderId)){
return null
}
var i=this.getFolder();
var t=i&&i.link&&i.owner;
var o=(!t&&appCtxt.multiAccounts&&i.getAccount());
if(o){
t=o.name
}
return t
};
ZmCalItem.prototype.isReadOnly=function(){
var i=this.getFolder();
if(appCtxt.multiAccounts){
var t=appCtxt.accountList.getAccountByEmail(this.organizer);
var a=appCtxt.accountList.getAccountByEmail(i.getAccount().getEmail());
if(t==a){
return false
}}
return(!this.isOrganizer()||(i.link&&i.isReadOnly()))
};
ZmCalItem.prototype.isVersionIgnored=function(){
return this._ignoreVersion
};
ZmCalItem.prototype.setIgnoreVersion=function(t){
this._ignoreVersion=t
};
ZmCalItem.prototype.resetRepeatWeeklyDays=function(){
if(this.startDate){
this._recurrence.repeatWeeklyDays=[ZmCalItem.SERVER_WEEK_DAYS[this.startDate.getDay()]]
}};
ZmCalItem.prototype.resetRepeatMonthlyDayList=function(){
if(this.startDate){
this._recurrence.repeatMonthlyDayList=[this.startDate.getDate()]
}};
ZmCalItem.prototype.resetRepeatYearlyMonthsList=function(t){
this._recurrence.repeatYearlyMonthsList=t
};
ZmCalItem.prototype.resetRepeatCustomDayOfWeek=function(){
if(this.startDate){
this._recurrence.repeatCustomDayOfWeek=ZmCalItem.SERVER_WEEK_DAYS[this.startDate.getDay()]
}};
ZmCalItem.prototype.isOverlapping=function(t,s){
if(s&&this.folderId!=t.folderId){
return false
}
var a=this.getStartTime();
var o=this.getEndTime();
var n=t.getStartTime();
var i=t.getEndTime();
return(a<i)&&(o>n)
};
ZmCalItem.prototype.isInRange=function(i,a){
var t=this.getStartTime();
var o=this.getEndTime();
return(t<a&&o>i)
};
ZmCalItem.prototype.isValidDuration=function(){
var o=this.getStartTime();
var a=this.getEndTime();
if(this.endTimezone&&this.endTimezone!=this.timezone){
var t=AjxTimezone.getRule(this.timezone).standard.offset;
var i=AjxTimezone.getRule(this.endTimezone).standard.offset;
o=o-(t*60000);
a=a-(i*60000)
}
return(o<=a)
};
ZmCalItem.prototype.parseAlarmData=function(){
if(!this.alarmData){
return
}
for(var a in this.alarmData){
var o=this.alarmData[a].alarm;
if(o){
for(var t in o){
this.parseAlarm(o[t])
}}}};
ZmCalItem.prototype.parseAlarm=function(n){
if(!n){
return
}
var a,s,r,i;
var o=n.trigger;
var t=(o&&(o.length>0))?o[0].rel:null;
a=(t&&(t.length>0))?t[0].m:null;
r=(t&&(t.length>0))?t[0].d:null;
s=(t&&(t.length>0))?t[0].h:null;
i=(t&&(t.length>0))?t[0].w:null;
this._reminderMinutes=0;
if(n.action==ZmCalItem.ALARM_DISPLAY){
if(a!=null){
this._reminderMinutes=a;
this._origReminderUnits=ZmCalItem.REMINDER_UNIT_MINUTES
}
if(s!=null){
s=parseInt(s);
this._reminderMinutes=s*60;
this._origReminderUnits=ZmCalItem.REMINDER_UNIT_HOURS
}
if(r!=null){
r=parseInt(r);
this._reminderMinutes=r*24*60;
this._origReminderUnits=ZmCalItem.REMINDER_UNIT_DAYS
}
if(i!=null){
i=parseInt(i);
this._reminderMinutes=i*7*24*60;
this._origReminderUnits=ZmCalItem.REMINDER_UNIT_WEEKS
}}};
ZmCalItem.prototype.isStartInRange=function(i,a){
var t=this.getStartTime();
return(t<a&&t>=i)
};
ZmCalItem.prototype.isEndInRange=function(a,t){
var i=this.getEndTime();
return(i<=t&&i>a)
};
ZmCalItem.prototype.setDateRange=function(i,t,n,a){
var o=i.startDate;
var r=i.endDate;
this.endDate.setTime(i.endDate.getTime());
this.startDate.setTime(i.startDate.getTime())
};
ZmCalItem.prototype.getDateRange=function(t,i,a){
return{
startDate:this.startDate,endDate:this.endDate}
};
ZmCalItem.prototype.setAttachments=function(o){
this.attachments=[];
if(o&&o.length>0){
var a=o.split(",");
for(var t=0;
t<a.length;
t++){
this.attachments[t]={
id:a[t]}
}}};
ZmCalItem.prototype.getAttachments=function(){
var a=this.message?this.message.attachments:null;
if(a){
if(this._validAttachments==null){
this._validAttachments=[];
for(var t=0;
t<a.length;
++t){
if(this.message.isRealAttachment(a[t])||a[t].ct==ZmMimeTable.TEXT_CAL){
this._validAttachments.push(a[t])
}}}
return this._validAttachments.length>0?this._validAttachments:null
}
return null
};
ZmCalItem.prototype.removeAttachment=function(t){
if(this._validAttachments&&this._validAttachments.length>0){
for(var a=0;
a<this._validAttachments.length;
a++){
if(this._validAttachments[a].part==t){
this._validAttachments.splice(a,1);
break
}}}};
ZmCalItem.prototype.getShortStartHour=function(){
var t=AjxDateFormat.getTimeInstance(AjxDateFormat.SHORT);
return t.format(this.startDate)
};
ZmCalItem.prototype.getUniqueStartDate=function(){
if(this._uniqueStartDate==null&&this.uniqStartTime){
this._uniqueStartDate=new Date(this.uniqStartTime)
}
return this._uniqueStartDate
};
ZmCalItem.prototype.getUniqueEndDate=function(){
if(this._uniqueEndDate==null&&this.uniqStartTime){
this._uniqueEndDate=new Date(this.uniqStartTime+this.getDuration())
}
return this._uniqueEndDate
};
ZmCalItem.prototype.getDetails=function(o,u,h,s,d,n){
var l=o||this.viewMode;
var i=l==ZmCalItem.MODE_EDIT_SERIES;
var t=(i&&this.message&&!this.message.seriesMode);
if(this.message==null||t){
var a=i?(this.seriesInvId||this.invId||this.id):this.invId;
this.message=new ZmMailMsg(a);
if(this._orig){
this._orig.message=this.message
}
var f=new AjxCallback(this,this._handleResponseGetDetails,[l,this.message,u]);
var m=(!s)?(new AjxCallback(this,this._handleErrorGetDetails,[l,u,h])):h;
var c=appCtxt.isOffline&&this.getFolder().getAccount();
var r={
callback:f,errorCallback:m,noBusyOverlay:d,ridZ:(i?null:this.ridZ),batchCmd:n,accountName:(c&&c.name)};
this.message.load(r)
}else{
this.setFromMessage(this.message,l);
if(u){
u.run()
}}};
ZmCalItem.prototype.convertToLocalTimezone=function(){
var s=this.getTimezone();
var a=AjxTimezone.getServerId(AjxTimezone.DEFAULT);
var n=this.startDate;
var t=this.endDate;
if(s!=a){
var o=AjxTimezone.getOffset(AjxTimezone.DEFAULT,n);
var i=AjxTimezone.getOffset(AjxTimezone.getClientId(s),n);
n.setTime(n.getTime()+(o-i)*60*1000);
t.setTime(t.getTime()+(o-i)*60*1000);
this.setTimezone(a);
this.setEndTimezone(a)
}};
ZmCalItem.prototype._handleResponseGetDetails=function(n,o,h,t){
this.setFromMessage(o,n);
o.seriesMode=(n==ZmCalItem.MODE_EDIT_SERIES);
if(this._orig&&this._orig.proposedInvite){
var i=this._orig.proposedInvite;
var r=i.getServerStartTime();
var a=i.getServerEndTime();
if(r){
this.setStartDate(AjxDateUtil.parseServerDateTime(r,true))
}
if(a){
this.setEndDate(AjxDateUtil.parseServerDateTime(a,true))
}
var s=i.getServerStartTimeTz();
this.setTimezone(s||AjxTimezone.getServerId(AjxTimezone.DEFAULT));
this.startsInUTC=r?r.charAt(r.length-1)=="Z":null;
this.endsInUTC=a&&r?a.charAt(r.length-1)=="Z":null;
this.status=i.components[0].status;
this.convertToLocalTimezone();
this.isAcceptingProposal=true
}
if(h){
h.run(t)
}};
ZmCalItem.prototype._handleErrorGetDetails=function(n,r,t,a){
if(a.code=="mail.INVITE_OUT_OF_DATE"){
var i=AjxSoapDoc.create(this._getSoapForMode(ZmCalItem.MODE_GET),"urn:zimbraMail");
i.setMethodAttribute("id",this.id);
var s=new AjxCallback(this,this._handleErrorGetDetails2,[n,r,t]);
var o={
soapDoc:i,asyncMode:true,callback:s,errorCallback:t};
appCtxt.getAppController().sendRequest(o);
return true
}
if(t){
return t.run(a)
}
return false
};
ZmCalItem.prototype._handleErrorGetDetails2=function(n,s,i,t){
var a=this._getInviteFromError(t);
this.invId=[this.id,a.id].join("-");
this.message=null;
var o=true;
this.getDetails(n,s,i,o)
};
ZmCalItem.prototype.setFromMessage=function(a,t){
if(a==this._currentlyLoaded){
return
}
if(a.invite){
this.isOrg=a.invite.isOrganizer();
this.organizer=a.invite.getOrganizerEmail();
this.sentBy=a.invite.getSentBy();
this.name=a.invite.getName()||a.subject;
this.isException=a.invite.isException();
this.recurring=a.invite.isRecurring();
this.location=a.invite.getLocation();
this.seq=a.invite.getSequenceNo();
if(a.invite.id){
this.invId=this.id+"-"+a.invite.id
}
this._setTimeFromMessage(a,t);
this._setExtrasFromMessage(a);
this._setRecurrence(a)
}
this._setNotes(a);
this.getAttachments();
this._currentlyLoaded=a
};
ZmCalItem.prototype.setFromSavedResponse=function(t){
this.invId=t.invId;
if(this.message){
this.message.rev=t.rev;
this.message.ms=t.ms
}
if(this.viewMode==ZmCalItem.MODE_EDIT_SINGLE_INSTANCE&&!this.isException){
this.isException=true
}};
ZmCalItem.prototype.setFromMailMessage=function(a,t){
this.name=t;
this._setNotes(a);
this.message=a;
this.invId=a.id
};
ZmCalItem.prototype.setTextNotes=function(t){
this.notesTopPart=new ZmMimePart();
this.notesTopPart.setContentType(ZmMimeTable.TEXT_PLAIN);
this.notesTopPart.setContent(t)
};
ZmCalItem.prototype._setTimeFromMessage=function(c,o){
var a=c.invite.getServerStartTime();
var n=c.invite.getServerEndTime();
if(o==ZmCalItem.MODE_EDIT_SINGLE_INSTANCE||o==ZmCalItem.MODE_FORWARD_SINGLE_INSTANCE){
var t=this.getUniqueStartDate();
if(t){
this.setStartDate(t)
}
var l=this.getUniqueEndDate();
if(l){
this.setEndDate(l)
}}else{
if(a){
this.setStartDate(AjxDateUtil.parseServerDateTime(a))
}
if(n){
this.setEndDate(AjxDateUtil.parseServerDateTime(n))
}}
this.startsInUTC=a?a.charAt(a.length-1)=="Z":null;
this.endsInUTC=n&&a?n.charAt(a.length-1)=="Z":null;
var r;
if(o==ZmCalItem.MODE_EDIT_SINGLE_INSTANCE||o==ZmCalItem.MODE_DELETE_INSTANCE||o==ZmCalItem.MODE_FORWARD_SINGLE_INSTANCE){
r=AjxTimezone.getServerId(AjxTimezone.DEFAULT);
this.setTimezone(r);
this.setEndTimezone(r)
}else{
var s=!this.startsInUTC&&c.invite.getServerStartTimeTz();
r=s||AjxTimezone.getServerId(AjxTimezone.DEFAULT);
this.setTimezone(r);
var i=!this.endsInUTC&&c.invite.getServerEndTimeTz();
this.setEndTimezone(i||AjxTimezone.getServerId(AjxTimezone.DEFAULT));
if(!this.startsInUTC&&c.invite.getServerEndTimeTz()){
this.setEndTimezone(c.invite.getServerEndTimeTz())
}}
var h=AjxTimezone.getRule(AjxTimezone.getClientId(this.getTimezone()));
if(h){
if(h.aliasId){
h=AjxTimezone.getRule(h.aliasId)||h
}
this.setTimezone(h.serverId)
}
h=AjxTimezone.getRule(AjxTimezone.getClientId(this.endTimezone));
if(h){
if(h.aliasId){
h=AjxTimezone.getRule(h.aliasId)||h
}
this.setEndTimezone(h.serverId)
}};
ZmCalItem.prototype._setExtrasFromMessage=function(t){
this._setAlarmFromMessage(t)
};
ZmCalItem.prototype._setAlarmFromMessage=function(n){
this._reminderMinutes=0;
var l=n.invite.getAlarm();
if(l){
for(var o in l){
var r=l[o];
if(!r){
continue
}
var s=r.action;
if(s==ZmCalItem.ALARM_DISPLAY){
this.parseAlarm(r);
continue
}
if(s==ZmCalItem.ALARM_EMAIL){
var h=r.at;
if(!h){
continue
}
for(var a=0;
a<h.length;
a++){
var t=h[a].a;
if(t==appCtxt.get(ZmSetting.CAL_DEVICE_EMAIL_REMINDERS_ADDRESS)){
s=ZmCalItem.ALARM_DEVICE_EMAIL
}
this.addReminderAction(s)
}}}}};
ZmCalItem.prototype._setRecurrence=function(a){
var t=a.invite.getRecurrenceRules();
if(t){
this._recurrence.parse(t)
}
if(this._recurrence.repeatWeeklyDays==null){
this.resetRepeatWeeklyDays()
}
if(this._recurrence.repeatMonthlyDayList==null){
this.resetRepeatMonthlyDayList()
}};
ZmCalItem.prototype._getCleanHtml2Text=function(r){
var o;
var a=r?r.getDocument():null;
var t=a?a.body:null;
if(t){
var i=t.innerHTML.replace(/\n/ig,"");
t.innerHTML=i.replace(/<!--.*-->/ig,"");
var s=t.firstChild;
var n=(s&&s.tagName&&s.tagName.toLocaleLowerCase()=="p");
o=AjxStringUtil.convertHtml2Text(t);
if(n){
o=o.replace(/\n\n/i,"")
}}
return o
};
ZmCalItem.prototype._setNotes=function(d){
var c=d.getBodyPart(ZmMimeTable.TEXT_PLAIN);
var s=d.getBodyPart(ZmMimeTable.TEXT_HTML);
this.notesTopPart=new ZmMimePart();
var n="";
var r="";
if(s){
var h=AjxUtil.isString(s)?s:s.content;
var n=h.replace(/<title\s*>.*\/title>/ig,"");
if(!this._includeEditReply){
n=this._trimNotesSummary(n,true)
}}
if(s&&n){
var a={
parent:appCtxt.getShell(),hidden:true,html:n};
var o=new DwtIframe(a);
if(o){
r=this._getCleanHtml2Text(o);
var i=o.getIframe();
if(i&&i.parentNode){
i.parentNode.removeChild(i)
}
delete o
}
var t=new ZmMimePart();
t.setContentType(ZmMimeTable.TEXT_PLAIN);
t.setContent(r);
var l=new ZmMimePart();
l.setContentType(ZmMimeTable.TEXT_HTML);
l.setContent(n);
this.notesTopPart.setContentType(ZmMimeTable.MULTI_ALT);
this.notesTopPart.children.add(t);
this.notesTopPart.children.add(l)
}else{
r=(c&&c.content)||"";
if(!this._includeEditReply){
r=this._trimNotesSummary(r)
}
this.notesTopPart.setContentType(ZmMimeTable.TEXT_PLAIN);
this.notesTopPart.setContent(r)
}};
ZmCalItem.prototype.getMailNotificationOption=function(){
return this._sendNotificationMail
};
ZmCalItem.prototype.setMailNotificationOption=function(t){
this._sendNotificationMail=t
};
ZmCalItem.prototype.addExceptionDetails=function(a,t){
var s=a.set("exceptId",null,t);
var o=this._orig?this._orig.allDayEvent:this.allDayEvent;
if(o!="1"){
var n=AjxDateUtil.getServerDateTime(this.getOrigStartDate(),this.startsInUTC);
var i=this.getOrigTimezone();
if(!this.startsInUTC&&i){
s.setAttribute("tz",i)
}
s.setAttribute("d",n)
}else{
var n=AjxDateUtil.getServerDate(this.getOrigStartDate());
s.setAttribute("d",n)
}};
ZmCalItem.prototype.save=function(i,h,o,t){
var l=false;
var s=AjxSoapDoc.create(this._getSoapForMode(this.viewMode,this.isException),"urn:zimbraMail");
if(this.viewMode==ZmCalItem.MODE_EDIT_SINGLE_INSTANCE&&!this.isException){
this._addInviteAndCompNum(s);
l=true
}else{
if(this.viewMode==ZmCalItem.MODE_EDIT||this.viewMode==ZmCalItem.MODE_EDIT_SINGLE_INSTANCE||this.viewMode==ZmCalItem.MODE_EDIT_SERIES){
this._addInviteAndCompNum(s);
l=this.isException
}}
var r=this.getRemoteFolderOwner();
var a=this._setSimpleSoapAttributes(s,i,t,r);
var n=a.inv.getElementsByTagName("comp")[0];
if(l){
this.addExceptionDetails(s,n)
}else{
this._recurrence.setSoap(s,n)
}
this._setAlarmData(s,n);
this._sendRequest(s,r,h,o)
};
ZmCalItem.prototype._setAlarmData=function(m,l){
var c=this._useAbsoluteReminder;
var n=c?this._reminderAbs:this._reminderMinutes;
if(!n){
return
}
var h,u;
for(var r=0,d=this.alarmActions.size();
r<d;
r++){
var s=this.alarmActions.get(r);
if(s==ZmCalItem.ALARM_EMAIL){
u=appCtxt.get(ZmSetting.CAL_EMAIL_REMINDERS_ADDRESS);
if(!u){
continue
}}
if(s==ZmCalItem.ALARM_DEVICE_EMAIL){
u=appCtxt.get(ZmSetting.CAL_DEVICE_EMAIL_REMINDERS_ADDRESS);
if(!u){
continue
}
s=ZmCalItem.ALARM_EMAIL
}
var f=s==ZmCalItem.ALARM_EMAIL;
var t=f&&h;
if(!t){
t=m.set("alarm",null,l);
t.setAttribute("action",s);
var o=m.set("trigger",null,t);
this._setReminderUnits(m,o,n);
this._addXPropsToAlarm(m,t);
if(f){
h=t
}}
if(u){
var a=m.set("at",null,t);
a.setAttribute("a",u);
u=null
}}};
ZmCalItem.prototype._setReminderUnits=function(o,a,n){
n=n||0;
var i=this._useAbsoluteReminder;
var t=o.set(i?"abs":"rel",null,a);
if(i){
t.setAttribute("d",n)
}else{
t.setAttribute("m",n);
t.setAttribute("related","START");
t.setAttribute("neg","1")
}};
ZmCalItem.prototype._addXPropsToAlarm=function(t,a){
if(!this.alarmData){
return
}
var o=(this.alarmData&&this.alarmData.length>0)?this.alarmData[0]:null;
var n=o?o.alarm:null;
var i=(n&&n.length>0)?n[0]:null;
this._setAlarmXProps(i,t,a)
};
ZmCalItem.prototype._setAlarmXProps=function(h,n,r){
var s=(h&&h.xprop)?h.xprop:null;
if(!s){
return
}
s=(s instanceof Array)?s:[s];
for(var o in s){
var a=s[o];
if(a&&a.name){
var t=n.set("xprop",null,r);
t.setAttribute("name",a.name);
if(a.value!=null){
t.setAttribute("value",a.value)
}
this._addXParamToSoap(n,t,a.xparam)
}}};
ZmCalItem.prototype.setReminderMinutes=function(t){
this._reminderMinutes=t
};
ZmCalItem.prototype.setReminderUnits=function(t,a,i){
if(!t){
this._reminderMinutes=0;
return
}
t=parseInt(t+"");
this._reminderMinutes=ZmCalendarApp.convertReminderUnits(t,a);
this._reminderSendEmail=i
};
ZmCalItem.prototype.addReminderAction=function(t){
this.alarmActions.add(t,null,true)
};
ZmCalItem.prototype.removeReminderAction=function(t){
this.alarmActions.remove(t)
};
ZmCalItem.prototype.cancel=function(r,t,h,s,o){
this.setViewMode(r);
if(t){
var d=[];
var a=t._topPart.node.ct==ZmMimeTable.MULTI_ALT?t._topPart.children.getArray():[t._topPart];
for(var n=0;
n<a.length;
n++){
d.push(a[n].node)
}
t.setBodyParts(d);
this._setNotes(t);
this._doCancel(r,h,t,o)
}else{
var l=new AjxCallback(this,this._doCancel,[r,h,null,o]);
var c=new AjxCallback(this,this._handleCancelError,[r,h,s]);
if(this._blobInfoMissing&&r!=ZmCalItem.MODE_DELETE_SERIES){
this.showBlobMissingDlg()
}else{
this.getDetails(null,l,c)
}}};
ZmCalItem.prototype.showBlobMissingDlg=function(){
var t=appCtxt.getMsgDialog();
t.setMessage(ZmMsg.apptBlobMissing,DwtMessageDialog.INFO_STYLE);
t.popup()
};
ZmCalItem.prototype._handleCancelError=function(i,o,t,a){
if(a.code=="mail.NO_SUCH_BLOB"){
if(this.isRecurring()&&i!=ZmCalItem.MODE_DELETE_SERIES){
this._blobInfoMissing=true;
this.showBlobMissingDlg();
return true
}else{
this._doCancel(i,o,this.message)
}
return true
}
if(t){
return t.run(a)
}
return false
};
ZmCalItem.prototype.setCancelFutureInstances=function(t){
this._cancelFutureInstances=t
};
ZmCalItem.prototype._sendCancelMsg=function(t){
this.save(null,t)
};
ZmCalItem.prototype._doCancel=function(g,r,h,y,p){
var a=this.getFolder().nId;
if(a==ZmOrganizer.ID_TRASH){
g=ZmCalItem.MODE_PURGE;
var O=AjxSoapDoc.create(this._getSoapForMode(g),"urn:zimbraMail");
var v=O.set("action");
v.setAttribute("op","delete");
v.setAttribute("id",this.id);
var t=this.getRemoteFolderOwner();
if(y){
y.addRequestParams(O,r)
}else{
this._sendRequest(O,t,r)
}}else{
if(g==ZmCalItem.MODE_DELETE_SERIES&&this._cancelFutureInstances&&this.getOrigStartDate().getTime()!=this.getStartTime()){
var f=this._recurrence;
var d=new Date(this.getOrigStartDate().getTime());
d.setTime(d.getTime()-AjxDateUtil.MSEC_PER_DAY);
f.repeatEndDate=d;
f.repeatEndType="D";
this.viewMode=ZmCalItem.MODE_EDIT_SERIES;
this._sendCancelMsg(r);
return
}
if(g==ZmCalItem.MODE_DELETE||g==ZmCalItem.MODE_DELETE_SERIES||g==ZmCalItem.MODE_DELETE_INSTANCE){
var O=AjxSoapDoc.create(this._getSoapForMode(g),"urn:zimbraMail");
var t=this.getRemoteFolderOwner();
this._addInviteAndCompNum(O);
if(g==ZmCalItem.MODE_DELETE_INSTANCE||this.isException){
O.setMethodAttribute("s",this.getOrigStartTime());
var n=O.set("inst");
var b=this.isAllDayEvent();
var q=b?AjxDateUtil.getServerDate:AjxDateUtil.getServerDateTime;
n.setAttribute("d",q(this.getOrigStartDate()));
if(!b&&this.timezone){
n.setAttribute("tz",this.timezone);
var T=AjxTimezone.getClientId(this.timezone);
ZmTimezone.set(O,T,null,true)
}}
var w=O.set("m");
if(this.isOrganizer()&&!this.inviteNeverSent){
if(h){
for(var x=0;
x<ZmMailMsg.ADDRS.length;
x++){
var s=ZmMailMsg.ADDRS[x];
if(t&&s==AjxEmailAddress.FROM){
continue
}
var o=h.getAddresses(s);
var c=o.size();
for(var k=0;
k<c;
k++){
var u=o.get(k);
var z=O.set("e",null,w);
z.setAttribute("a",u.getAddress());
z.setAttribute("t",AjxEmailAddress.toSoapType[s])
}}
if(t){
var z=O.set("e",null,w);
z.setAttribute("a",t);
z.setAttribute("t",AjxEmailAddress.toSoapType[AjxEmailAddress.FROM])
}}else{
this._addAttendeesToSoap(O,null,w,null,t)
}}
var l=(h&&h.subject)?h.subject:([ZmMsg.cancelled,": ",this.name].join(""));
O.set("su",l,w);
this._addNotesToSoap(O,w,true);
if(y){
y.addRequestParams(O,r)
}else{
this._sendRequest(O,t,r)
}}else{
if(r){
r.run()
}}}};
ZmCalItem.prototype.getMailFromAddress=function(){
var t=appCtxt.get(ZmSetting.MAIL_FROM_ADDRESS);
if(t){
return(t instanceof Array)?t[0]:t
}};
ZmCalItem.prototype.getTextSummary=function(){
return this.getSummary(false)
};
ZmCalItem.prototype.getHtmlSummary=function(){
return this.getSummary(true)
};
ZmCalItem.prototype.getAttachListHtml=function(h,d){
var s=appCtxt.get(ZmSetting.CSFE_MSG_FETCHER_URI);
var l=ZmMimeTable.getInfo(h.ct);
var c=l?l.image:"GenericDoc";
var u=h.s;
var o;
if(u!=null){
if(u<1024){
o=u+" B"
}else{
if(u<1024^2){
o=Math.round((u/1024)*10)/10+" KB"
}else{
o=Math.round((u/(1024*1024))*10)/10+" MB"
}}}
var r=[];
var n=0;
r[n++]="<table border=0 cellpadding=0 cellspacing=0><tr>";
if(d){
r[n++]="<td width=1%><input type='checkbox' checked value='";
r[n++]=h.part;
r[n++]="' name='";
r[n++]=ZmCalItem.ATTACHMENT_CHECKBOX_NAME;
r[n++]="'></td>"
}
var a=["href='",s,"&id=",this.invId,"&amp;part="].join("");
r[n++]="<td width=20><a target='_blank' class='AttLink' ";
r[n++]=a;
r[n++]=h.part;
r[n++]="'>";
r[n++]=AjxImg.getImageHtml(c);
r[n++]="</a></td><td><a target='_blank' class='AttLink' ";
if(appCtxt.get(ZmSetting.MAIL_ENABLED)&&h.ct==ZmMimeTable.MSG_RFC822){
r[n++]=" href='javascript:;' onclick='ZmCalItemView.rfc822Callback(";
r[n++]='"';
r[n++]=this.invId;
r[n++]='"';
r[n++]=',"';
r[n++]=h.part;
r[n++]="\"); return false;'"
}else{
r[n++]=a;
r[n++]=h.part;
r[n++]="'"
}
r[n++]=">";
r[n++]=h.filename;
r[n++]="</a>";
var t=(appCtxt.get(ZmSetting.VIEW_ATTACHMENT_AS_HTML)&&h.body==null&&ZmMimeTable.hasHtmlVersion(h.ct));
if(o||t){
r[n++]="&nbsp;(";
if(o){
r[n++]=o;
r[n++]=") "
}
if(t){
r[n++]="<a style='text-decoration:underline' target='_blank' class='AttLink' ";
r[n++]=a;
r[n++]=h.part;
r[n++]="&view=html'>";
r[n++]=ZmMsg.preview;
r[n++]="</a>&nbsp;"
}
if(h.ct!=ZmMimeTable.MSG_RFC822){
r[n++]="<a style='text-decoration:underline' class='AttLink' onclick='ZmZimbraMail.unloadHackCallback();' ";
r[n++]=a;
r[n++]=h.part;
r[n++]="&disp=a'>";
r[n++]=ZmMsg.download;
r[n++]="</a>"
}}
r[n++]="</td></tr></table>";
return r.join("")
};
ZmCalItem.prototype._getTextSummaryTime=function(s,l,a,t,n,c){
var d=appCtxt.get(ZmSetting.CAL_SHOW_TIMEZONE);
var o=[];
var r=0;
if(a){
o[r++]=AjxDateUtil.longComputeDateStr(a);
o[r++]=", "
}
if(this.isAllDayEvent()){
o[r++]=ZmMsg.allDay
}else{
var h=AjxDateFormat.getTimeInstance();
if(t){
o[r++]=h.format(t)
}
if(t&&n){
o[r++]=" - "
}
if(n){
o[r++]=h.format(n)
}
if(d){
o[r++]=" ";
o[r++]=AjxTimezone.getLongName(AjxTimezone.getClientId(this.timezone))
}}
if(s&&((this._orig&&this._orig.isAllDayEvent()!=this.isAllDayEvent())||c)){
o[r++]=" ";
o[r++]=ZmMsg.apptModifiedStamp
}
o[r++]="\n";
return o.join("")
};
ZmCalItem.prototype._trimNotesSummary=function(a,i){
if(a){
var t=a.indexOf(ZmItem.NOTES_SEPARATOR);
if(t!=-1){
a=a.substr(t+ZmItem.NOTES_SEPARATOR.length);
var o=i?"</div><br>":"\n\n";
if(a.indexOf(o)==0){
a=a.replace(o,"")
}}}
return AjxStringUtil.trim(a)
};
ZmCalItem.prototype._resetCached=function(){
delete this._startTimeUniqId;
this._startTimeUniqId=null;
delete this._validAttachments;
this._validAttachments=null;
delete this.tooltip;
this.tooltip=null
};
ZmCalItem.prototype._getTTDay=function(t){
return DwtCalendar.getDayFormatter().format(t)
};
ZmCalItem.prototype._addInviteAndCompNum=function(t){
if(this.message&&!this.isVersionIgnored()){
t.setMethodAttribute("ms",this.message.ms);
t.setMethodAttribute("rev",this.message.rev)
}
if(this.viewMode==ZmCalItem.MODE_EDIT_SERIES||this.viewMode==ZmCalItem.MODE_DELETE_SERIES){
if(this.recurring&&this.seriesInvId!=null){
t.setMethodAttribute("id",this.seriesInvId);
t.setMethodAttribute("comp",this.getCompNum())
}}else{
if(this.invId!=null&&this.invId!=-1){
var a=this.invId;
if(appCtxt.multiAccounts&&this._orig&&this._orig.getFolder().getAccount()!=this.getFolder().getAccount()){
a=ZmOrganizer.getSystemId(this.invId,this._orig.getFolder().getAccount(),true)
}
t.setMethodAttribute("id",a);
t.setMethodAttribute("comp",this.getCompNum())
}}};
ZmCalItem.prototype._getDefaultBlurb=function(s,n){
var t=[];
var a=0;
var o=this.viewMode==ZmCalItem.MODE_EDIT_SINGLE_INSTANCE||this.viewMode==ZmCalItem.MODE_DELETE_INSTANCE;
if(n){
t[a++]="<h3>"
}
if(this.isProposeTimeMode){
t[a++]=ZmMsg.subjectNewTime
}else{
if(s){
t[a++]=o?ZmMsg.apptInstanceCanceled:ZmMsg.apptCanceled
}else{
if(!this.isForwardMode||this.isOrganizer()){
if(!this.inviteNeverSent&&(this.viewMode==ZmCalItem.MODE_EDIT||this.viewMode==ZmCalItem.MODE_EDIT_SINGLE_INSTANCE||this.viewMode==ZmCalItem.MODE_EDIT_SERIES)){
t[a++]=o?ZmMsg.apptInstanceModified:ZmMsg.apptModified
}else{
t[a++]=ZmMsg.apptNew
}}else{
t[a++]=ZmMsg.apptForwarded
}}}
if(n){
t[a++]="</h3>"
}
t[a++]="\n\n";
t[a++]=this.getSummary(n);
return t.join("")
};
ZmCalItem.prototype._getSoapForMode=function(a,t){};
ZmCalItem.prototype._getInviteFromError=function(t){};
ZmCalItem.prototype._setSimpleSoapAttributes=function(B,s,l,a){
var v=this._messageNode=B.set("m");
var y=this.getFolder();
var f=y.getAccount();
var p=a&&f&&f.name!=a;
v.setAttribute("l",(p?this.getFolder().rid:this.folderId));
var o=B.set("inv",null,v);
if(this.uid!=null&&this.uid!=-1&&!this.isSharedCopy){
o.setAttribute("uid",this.uid)
}
var j=B.set("comp",null,o);
this._addAttendeesToSoap(B,j,v,l,a);
var C=this.identity;
var w=C==null||C.isDefault;
var x=y.isRemote();
var r=this.getMailFromAddress();
if(this.isOrganizer()&&!a&&(r||x||!w)){
var q=B.set("e",null,v);
var u,h;
if(r){
u=r
}else{
if(x){
u=this.organizer
}else{
if(C){
u=C.sendFromAddress;
h=C.sendFromDisplay
}}}
q.setAttribute("a",u);
q.setAttribute("t",AjxEmailAddress.toSoapType[AjxEmailAddress.FROM]);
if(!h&&u==appCtxt.get(ZmSetting.USERNAME)){
h=appCtxt.get(ZmSetting.DISPLAY_NAME)
}
if(h){
q.setAttribute("p",h)
}
if(C&&C.isFromDataSource&&!x){
this._addIdentityFrom(C,q,v,B)
}}
if(x){
var q=B.set("e",null,v);
var u,h;
if(!C){
var g=appCtxt.getIdentityCollection();
C=g&&g.defaultIdentity
}
if(C){
u=C.sendFromAddress;
h=C.sendFromDisplay
}else{
u=appCtxt.get(ZmSetting.USERNAME);
h=appCtxt.get(ZmSetting.DISPLAY_NAME)
}
q.setAttribute("a",u);
q.setAttribute("t",AjxEmailAddress.toSoapType[AjxEmailAddress.SENDER]);
if(h){
q.setAttribute("p",h)
}}
this._addExtrasToSoap(B,o,j);
this._addDateTimeToSoap(B,o,j);
this._addXPropsToSoap(B,o,j);
B.set("su",this.name,v);
j.setAttribute("name",this.name);
this._addLocationToSoap(j);
this._addNotesToSoap(B,v);
if(!(appCtxt.isOffline&&f.isMain)){
var A=(appCtxt.multiAccounts)?f.getEmail():appCtxt.get(ZmSetting.USERNAME);
var W,h,d;
if(!C){
var g=appCtxt.getIdentityCollection(f);
C=g&&g.defaultIdentity
}
if(C){
d=C.sendFromAddress;
h=C.sendFromDisplay
}
W=r||d||A;
var O=this.organizer||W;
var t=B.set("or",null,j);
t.setAttribute("a",O);
if(x){
t.setAttribute("sentBy",W)
}
var b=(O==d)?h:(ZmApptViewHelper.getAddressEmail(O)).getName();
if(b){
t.setAttribute("d",b)
}}
this.flagLocal(ZmItem.FLAG_ATTACH,false);
this.getAttachments();
if(s!=null||(this._validAttachments!=null&&this._validAttachments.length)){
var c=B.set("attach",null,v);
if(s){
c.setAttribute("aid",s);
this.flagLocal(ZmItem.FLAG_ATTACH,true)
}
if(this._validAttachments){
var T=this._validAttachments.length;
for(var k=0;
k<T;
k++){
var n=B.set("mp",null,c);
var z=(this.invId||this.message.id);
if((z.indexOf(":")<0)&&y.isRemote()){
z=(appCtxt.getActiveAccount().id+":"+z)
}
n.setAttribute("mid",z);
n.setAttribute("part",this._validAttachments[k].part)
}
if(T>0){
this.flagLocal(ZmItem.FLAG_ATTACH,true)
}}}
return{
inv:o,m:v}
};
ZmCalItem.prototype._addIdentityFrom=function(n,o,i,h){
var t=appCtxt.getDataSourceCollection().getById(n.id);
if(t){
var a=o;
var r=ZmDataSource.getProviderForAccount(t);
var l=r&&r._nosender;
if(!l){
o.setAttribute("t",AjxEmailAddress.toSoapType[AjxEmailAddress.SENDER]);
o.setAttribute("p",appCtxt.get(ZmSetting.DISPLAY_NAME)||"");
a=h.set("e",null,i)
}
a.setAttribute("t",AjxEmailAddress.toSoapType[AjxEmailAddress.FROM]);
a.setAttribute("a",t.getEmail());
if(appCtxt.get(ZmSetting.DEFAULT_DISPLAY_NAME)){
var s=t.identity&&t.identity.sendFromDisplay;
s=s||t.userName||t.getName();
if(s){
o.setAttribute("p",s)
}}}};
ZmCalItem.prototype._addExtrasToSoap=function(i,t,a){
if(this.priority){
a.setAttribute("priority",this.priority)
}
a.setAttribute("status",this.status)
};
ZmCalItem.prototype._addXPropsToSoap=function(h,a,n){
var c=this.message?this.message:null;
var l=(c&&c.invite)?c.invite:null;
var o=l?l.getXProp():null;
if(!o){
return
}
o=(o instanceof Array)?o:[o];
for(var t in o){
var s=o[t];
if(s&&s.name){
var r=h.set("xprop",null,n);
r.setAttribute("name",s.name);
if(s.value!=null){
r.setAttribute("value",s.value)
}
this._addXParamToSoap(h,r,s.xparam)
}}};
ZmCalItem.prototype._addXParamToSoap=function(n,o,s){
if(!s){
return
}
s=(s instanceof Array)?s:[s];
for(var i in s){
var a=s[i];
if(a&&a.name){
var t=n.set("xparam",null,o);
t.setAttribute("name",a.name);
if(a.value!=null){
t.setAttribute("value",a.value)
}}}};
ZmCalItem.prototype._addDateTimeToSoap=function(l,i,n){
n.setAttribute("allDay",this.allDayEvent);
var a;
if(this.timezone){
var t=AjxTimezone.getClientId(this.timezone);
ZmTimezone.set(l,t,i,true);
a=this.timezone
}
if(this.startDate){
var c=l.set("s",null,n);
if(!this.isAllDayEvent()){
var h=AjxDateUtil.getServerDateTime(this.startDate,this.startsInUTC);
if(!this.startsInUTC&&a&&a.length){
c.setAttribute("tz",a)
}
c.setAttribute("d",h)
}else{
c.setAttribute("d",AjxDateUtil.getServerDate(this.startDate))
}}
if(this.endTimezone){
a=this.endTimezone
}
if(this.endDate){
var r=l.set("e",null,n);
if(!this.isAllDayEvent()){
var o=AjxDateUtil.getServerDateTime(this.endDate,this.endsInUTC);
if(!this.endsInUTC&&a&&a.length){
r.setAttribute("tz",a)
}
r.setAttribute("d",o)
}else{
r.setAttribute("d",AjxDateUtil.getServerDate(this.endDate))
}}};
ZmCalItem.prototype._addAttendeesToSoap=function(o,a,t,n,i){
if(this.isOrganizer()&&i){
e=o.set("e",null,t);
e.setAttribute("a",i);
e.setAttribute("t",AjxEmailAddress.toSoapType[AjxEmailAddress.FROM])
}};
ZmCalItem.prototype._addNotesToSoap=function(v,u,t){
var w=this.hasAttendees();
var o=w?this._getDefaultBlurb(t):"";
var r=w?this._getDefaultBlurb(t,true):"";
var y=v.set("mp",null,u);
y.setAttribute("ct",ZmMimeTable.MULTI_ALT);
var f=this.notesTopPart?this.notesTopPart.children.size():0;
if(f>0){
for(var b=0;
b<f;
b++){
var p=this.notesTopPart.children.get(b);
var h=v.set("mp",null,y);
var a=p.getContentType();
h.setAttribute("ct",a);
var g;
if(a==ZmMimeTable.TEXT_HTML){
g="<html><body id='htmlmode'>"+(this._includeEditReply?p.getContent():AjxBuffer.concat(r,p.getContent()))+"</body></html>"
}else{
g=this._includeEditReply?p.getContent():AjxBuffer.concat(o,p.getContent())
}
v.set("content",g,h)
}}else{
var l=this.notesTopPart?this.notesTopPart.getContent():"";
var c=v.set("mp",null,y);
c.setAttribute("ct",ZmMimeTable.TEXT_PLAIN);
v.set("content",(this._includeEditReply?l:AjxBuffer.concat(o,l)),c);
var d=AjxStringUtil.nl2br(AjxStringUtil.htmlEncode(l));
var n=v.set("mp",null,y);
n.setAttribute("ct",ZmMimeTable.TEXT_HTML);
var s="<html><body>"+(this._includeEditReply?d:AjxBuffer.concat(r,d))+"</body></html>";
v.set("content",s,n)
}};
ZmCalItem.prototype.getInviteDescription=function(n){
var o=this.hasAttendees();
var i=o?this.getSummary(false):"";
var a=o?this.getSummary(true):"";
var t=this.getNotesPart(n?ZmMimeTable.TEXT_HTML:ZmMimeTable.TEXT_PLAIN);
return AjxBuffer.concat(n?a:i,t)
};
ZmCalItem.prototype.setIncludeEditReply=function(t){
this._includeEditReply=t
};
ZmCalItem.prototype._sendRequest=function(o,i,s,a){
var t=o.getMethod().nodeName.replace("Request","Response");
var n=new AjxCallback(this,this._handleResponseSend,[t,s]);
appCtxt.getAppController().sendRequest({
soapDoc:o,asyncMode:true,accountName:i,callback:n,errorCallback:a}
)
};
ZmCalItem.prototype._loadFromDom=function(a,t){
ZmCalBaseItem.prototype._loadFromDom.call(this,a,t);
this.isOrg=this._getAttr(a,t,"isOrg");
var i=a.or;
this.organizer=i&&i.a;
this.sentBy=i&&i.sentBy;
this.invId=this._getAttr(a,t,"invId");
this.compNum=this._getAttr(a,t,"compNum")||"0";
this.parseAlarmData(this.alarmData);
this.seriesInvId=this.recurring?a.invId:null;
this.ridZ=t&&t.ridZ;
if(a.t){
this._parseTags(a.t)
}
if(a.f){
this._parseFlags(a.f)
}};
ZmCalItem.prototype._handleResponseSend=function(s,r,t){
var n=t.getResponse();
var o=n[s];
if(o.uid!=null){
this.uid=o.uid
}
var i;
if(o.echo){
i=o.echo;
if(i.length>0){
i=i[0]
}}
i=i?i.m:o.m;
if(i!=null){
if(i.length>0){
i=i[0]
}
var a=this.invId;
this.invId=i.id;
if(AjxUtil.isSpecified(a)&&a!=this.invId){
this.message=null
}else{
if(i){
this.message=new ZmMailMsg(i.id);
this.message._loadFromDom(i);
delete this._validAttachments;
this._validAttachments=null;
this.getAttachments()
}}}
this._messageNode=null;
if(r){
r.run(o)
}};
ZmCalItem.prototype.setProposedTimeCallback=function(t){
this._proposedTimeCallback=t
};
ZmCalItem.prototype.handlePostSaveCallbacks=function(){
if(this._proposedTimeCallback){
this._proposedTimeCallback.run(this)
}
this.setIgnoreVersion(false)
};
ZmCalItem.getLabelForPriority=function(t){
switch(t){
case ZmCalItem.PRIORITY_LOW:return ZmMsg.low;
case ZmCalItem.PRIORITY_NORMAL:return ZmMsg.normal;
case ZmCalItem.PRIORITY_HIGH:return ZmMsg.high;
default:return""
}};
ZmCalItem.getImageForPriority=function(t,a){
switch(t.priority){
case ZmCalItem.PRIORITY_LOW:return a?AjxImg.getImageHtml("PriorityLow_list",null,["id='",a,"'"].join("")):AjxImg.getImageHtml("PriorityLow_list");
case ZmCalItem.PRIORITY_HIGH:return a?AjxImg.getImageHtml("PriorityHigh_list",null,["id='",a,"'"].join("")):AjxImg.getImageHtml("PriorityHigh_list");
default:return""
}};
ZmCalItem.getLabelForStatus=function(t){
switch(t){
case ZmCalendarApp.STATUS_CANC:return ZmMsg.cancelled;
case ZmCalendarApp.STATUS_COMP:return ZmMsg.completed;
case ZmCalendarApp.STATUS_DEFR:return ZmMsg.deferred;
case ZmCalendarApp.STATUS_INPR:return ZmMsg.inProgress;
case ZmCalendarApp.STATUS_NEED:return ZmMsg.notStarted;
case ZmCalendarApp.STATUS_WAIT:return ZmMsg.waitingOn
}
return""
};
ZmCalItem.getLabelForParticipationStatus=function(t){
switch(t){
case ZmCalBaseItem.PSTATUS_ACCEPT:return ZmMsg.ptstAccept;
case ZmCalBaseItem.PSTATUS_DECLINED:return ZmMsg.ptstDeclined;
case ZmCalBaseItem.PSTATUS_DEFERRED:return ZmMsg.ptstDeferred;
case ZmCalBaseItem.PSTATUS_DELEGATED:return ZmMsg.ptstDelegated;
case ZmCalBaseItem.PSTATUS_NEEDS_ACTION:return ZmMsg.ptstNeedsAction;
case ZmCalBaseItem.PSTATUS_COMPLETED:return ZmMsg.completed;
case ZmCalBaseItem.PSTATUS_TENTATIVE:return ZmMsg.ptstTentative;
case ZmCalBaseItem.PSTATUS_WAITING:return ZmMsg.ptstWaiting
}
return""
};
ZmCalItem.getParticipationStatusIcon=function(t){
switch(t){
case ZmCalBaseItem.PSTATUS_ACCEPT:return"Check";
case ZmCalBaseItem.PSTATUS_DECLINED:return"Cancel";
case ZmCalBaseItem.PSTATUS_DEFERRED:return"QuestionMark";
case ZmCalBaseItem.PSTATUS_DELEGATED:return"Plus";
case ZmCalBaseItem.PSTATUS_NEEDS_ACTION:return"NeedsAction";
case ZmCalBaseItem.PSTATUS_COMPLETED:return"Completed";
case ZmCalBaseItem.PSTATUS_TENTATIVE:return"QuestionMark";
case ZmCalBaseItem.PSTATUS_WAITING:return"Minus"
}
return""
};
ZmCalItem._getTTDay=function(i,a){
a=a||AjxDateFormat.SHORT;
var t=AjxDateFormat.getDateInstance();
return t.format(i)
}
}
if(AjxPackage.define("zimbraMail.calendar.model.ZmRecurrence")){
ZmRecurrence=function(t){
this._startDate=(t&&t.startDate)?t.startDate:(new Date());
this.repeatCustom="0";
this.repeatCustomCount=1;
this.repeatCustomDayOfWeek="SU";
this.repeatBySetPos="1";
this.repeatCustomMonthDay=this._startDate.getDate();
this.repeatCustomType="S";
this.repeatEnd=null;
this.repeatEndCount=1;
this.repeatEndDate=null;
this.repeatEndType="N";
this.repeatMonthlyDayList=null;
this.repeatType=ZmRecurrence.NONE;
this.repeatWeekday=false;
this.repeatWeeklyDays=[];
this.repeatYearlyMonthsList=1;
this._cancelRecurIds={}
};
ZmRecurrence.prototype.toString=function(){
return"ZmRecurrence"
};
ZmRecurrence.NONE="NON";
ZmRecurrence.DAILY="DAI";
ZmRecurrence.WEEKLY="WEE";
ZmRecurrence.MONTHLY="MON";
ZmRecurrence.YEARLY="YEA";
ZmRecurrence.RECURRENCE_DAY=-1;
ZmRecurrence.RECURRENCE_WEEKEND=-2;
ZmRecurrence.RECURRENCE_WEEKDAY=-3;
ZmRecurrence.prototype.setSoap=function(g,h){
if(this.repeatType==ZmRecurrence.NONE){
return
}
var u=g.set("recur",null,h);
var y=g.set("add",null,u);
var p=g.set("rule",null,y);
p.setAttribute("freq",this.repeatType);
var s=g.set("interval",null,p);
s.setAttribute("ival",this.repeatCustomCount);
if(this.repeatEndDate!=null&&this.repeatEndType=="D"){
var o=g.set("until",null,p);
o.setAttribute("d",AjxDateUtil.getServerDate(this.repeatEndDate))
}else{
if(this.repeatEndType=="A"){
var m=g.set("count",null,p);
m.setAttribute("num",this.repeatEndCount)
}}
if(this.repeatCustom!="1"){
this.setExcludes(g,u);
return
}
if(this.repeatType==ZmRecurrence.DAILY){
if(this.repeatWeekday){
var d=g.set("byday",null,p);
for(var r in ZmCalItem.SERVER_WEEK_DAYS){
var f=ZmCalItem.SERVER_WEEK_DAYS[r];
if(f=="SA"||f=="SU"){
continue
}
var l=g.set("wkday",null,d);
l.setAttribute("day",f)
}}}else{
if(this.repeatType==ZmRecurrence.WEEKLY){
var d=g.set("byday",null,p);
for(var r=0;
r<this.repeatWeeklyDays.length;
++r){
var l=g.set("wkday",null,d);
l.setAttribute("day",this.repeatWeeklyDays[r])
}}else{
if(this.repeatType==ZmRecurrence.MONTHLY){
if(this.repeatCustomType=="S"){
var t=g.set("bymonthday",null,p);
t.setAttribute("modaylist",this.repeatMonthlyDayList)
}else{
var d=g.set("byday",null,p);
if(this.repeatCustomDays){
for(var r=0;
r<this.repeatCustomDays.length;
r++){
l=g.set("wkday",null,d);
l.setAttribute("day",this.repeatCustomDays[r]);
if(this.repeatCustomOrdinal){
l.setAttribute("ordwk",this.repeatCustomOrdinal)
}}}
if(this.repeatCustomOrdinal==null){
var a=g.set("bysetpos",null,p);
a.setAttribute("poslist",this.repeatBySetPos)
}}}else{
if(this.repeatType==ZmRecurrence.YEARLY){
var n=g.set("bymonth",null,p);
n.setAttribute("molist",this.repeatYearlyMonthsList);
if(this.repeatCustomType=="O"){
var d=g.set("byday",null,p);
if(this.repeatCustomDays){
for(var r=0;
r<this.repeatCustomDays.length;
r++){
l=g.set("wkday",null,d);
l.setAttribute("day",this.repeatCustomDays[r]);
if(this.repeatCustomOrdinal){
l.setAttribute("ordwk",this.repeatCustomOrdinal)
}}}
if(this.repeatCustomOrdinal==null){
var a=g.set("bysetpos",null,p);
a.setAttribute("poslist",this.repeatBySetPos)
}}else{
var t=g.set("bymonthday",null,p);
t.setAttribute("modaylist",this.repeatCustomMonthDay)
}}}}}
this.setExcludes(g,u)
};
ZmRecurrence.prototype.setExcludes=function(r,n){
if(!this._cancelRecurIds){
return
}
var t;
var c;
for(var a in this._cancelRecurIds){
if(!this._cancelRecurIds[a]){
continue
}
if(!t&&!c){
t=r.set("exclude",null,n);
c=r.set("dates",null,t)
}
var h=a;
var l=r.set("dtval",null,c);
var o=r.set("s",null,l);
o.setAttribute("d",h)
}};
ZmRecurrence.prototype.getBlurb=function(){
if(this.repeatType==ZmRecurrence.NONE){
return""
}
var h=[];
switch(this.repeatType){
case ZmRecurrence.DAILY:if(this.repeatCustom=="1"&&this.repeatWeekday){
h.push(ZmMsg.recurDailyEveryWeekday)
}else{
if(this.repeatCustomCount==1){
h.push(ZmMsg.recurDailyEveryDay)
}else{
var p=new AjxMessageFormat(ZmMsg.recurDailyEveryNumDays);
h.push(p.format(this.repeatCustomCount))
}}
break;
case ZmRecurrence.WEEKLY:if(this.repeatCustomCount==1&&this.repeatWeeklyDays.length==1){
var y=AjxUtil.indexOf(ZmCalItem.SERVER_WEEK_DAYS,this.repeatWeeklyDays[0]);
var o=new Date();
o.setDate(o.getDate()-o.getDay()+y);
var p=new AjxMessageFormat(ZmMsg.recurWeeklyEveryWeekday);
h.push(p.format(o))
}else{
var b=[];
for(var s=0;
s<this.repeatWeeklyDays.length;
s++){
var y=AjxUtil.indexOf(ZmCalItem.SERVER_WEEK_DAYS,this.repeatWeeklyDays[s]);
var o=new Date();
o.setDate(o.getDate()-o.getDay()+y);
b.push(o)
}
var p=new AjxMessageFormat(ZmMsg.recurWeeklyEveryNumWeeksDate);
h.push(p.format([this.repeatCustomCount,b,""]))
}
break;
case ZmRecurrence.MONTHLY:if(this.repeatCustomType=="S"){
var c=Number(this.repeatCustomCount);
var o=Number(this.repeatMonthlyDayList[0]);
var p=new AjxMessageFormat(ZmMsg.recurMonthlyEveryNumMonthsDate);
h.push(p.format([o,c]))
}else{
var u=Number(this.repeatCustomOrdinal);
var a=Number(this.repeatBySetPos);
var y=AjxUtil.indexOf(ZmCalItem.SERVER_WEEK_DAYS,this.repeatCustomDayOfWeek);
var f=new Date();
f.setDate(f.getDate()-f.getDay()+y);
var c=Number(this.repeatCustomCount);
var g=this.repeatCustomDays.join(",");
var l=ZmCalItem.SERVER_WEEK_DAYS.slice(1,6).join(",");
var m=[ZmCalItem.SERVER_WEEK_DAYS[AjxDateUtil.SUNDAY],ZmCalItem.SERVER_WEEK_DAYS[AjxDateUtil.SATURDAY]].join(",");
if((ZmCalItem.SERVER_WEEK_DAYS.join(",")==g)||(l==g)||(m==g)){
var p=new AjxMessageFormat(ZmMsg.recurMonthlyEveryNumMonthsWeekDays);
var r=-1;
if(l==g){
r=1
}else{
if(m==g){
r=0
}}
h.push(p.format([a||u,r,c]))
}else{
var f=new Date();
f.setDate(f.getDate()-f.getDay()+y);
var p=new AjxMessageFormat(ZmMsg.recurMonthlyEveryNumMonthsNumDay);
h.push(p.format([a||u,f,c]))
}}
break;
case ZmRecurrence.YEARLY:if(this.repeatCustomType=="S"){
var d=new Date();
d.setMonth(Number(this.repeatYearlyMonthsList)-1);
var f=Number(this.repeatCustomMonthDay);
var p=new AjxMessageFormat(ZmMsg.recurYearlyEveryDate);
h.push(p.format([d,f]))
}else{
var u=Number(this.repeatCustomOrdinal);
var a=Number(this.repeatBySetPos);
var y=AjxUtil.indexOf(ZmCalItem.SERVER_WEEK_DAYS,this.repeatCustomDayOfWeek);
var d=new Date();
d.setMonth(Number(this.repeatYearlyMonthsList)-1);
var g=this.repeatCustomDays.join(",");
var l=ZmCalItem.SERVER_WEEK_DAYS.slice(1,6).join(",");
var m=[ZmCalItem.SERVER_WEEK_DAYS[AjxDateUtil.SUNDAY],ZmCalItem.SERVER_WEEK_DAYS[AjxDateUtil.SATURDAY]].join(",");
if((ZmCalItem.SERVER_WEEK_DAYS.join(",")==g)||(l==g)||(m==g)){
var p=new AjxMessageFormat(ZmMsg.recurYearlyEveryMonthWeekDays);
var r=-1;
if(l==g){
r=1
}else{
if(m==g){
r=0
}}
h.push(p.format([a||u,r,d]))
}else{
var f=new Date();
f.setDate(f.getDate()-f.getDay()+y);
var p=new AjxMessageFormat(ZmMsg.recurYearlyEveryMonthNumDay);
h.push(p.format([a||u,f,d]))
}}
break
}
var t=[];
var p=new AjxMessageFormat(ZmMsg.recurStart);
t.push(p.format(this._startDate));
var n=[];
switch(this.repeatEndType){
case"N":n.push(ZmMsg.recurEndNone);
break;
case"A":p=new AjxMessageFormat(ZmMsg.recurEndNumber);
n.push(p.format(this.repeatEndCount));
break;
case"D":p=new AjxMessageFormat(ZmMsg.recurEndByDate);
n.push(p.format(this.repeatEndDate));
break
}
p=new AjxMessageFormat(ZmMsg.recurBlurb);
return p.format([h.join(""),t.join(""),n.join("")])
};
ZmRecurrence.prototype.parse=function(l){
this.repeatWeeklyDays=[];
for(var t=0;
t<l.length;
++t){
var s=l[t].add;
if(!s){
continue
}
this.repeatYearlyMonthsList=this._startDate.getMonth()+1;
for(var o=0;
o<s.length;
++o){
var d=s[o].rule;
if(!d){
continue
}
for(var a=0;
a<d.length;
++a){
var r=d[a];
if(r.freq){
this.repeatType=r.freq.substring(0,3);
if(r.interval&&r.interval[0].ival){
this.repeatCustomCount=parseInt(r.interval[0].ival);
this.repeatCustom="1"
}}
if(r.bymonth){
this.repeatYearlyMonthsList=r.bymonth[0].molist;
this.repeatCustom="1"
}
if(r.bymonthday){
if(this.repeatType==ZmRecurrence.YEARLY){
this.repeatCustomMonthDay=r.bymonthday[0].modaylist;
this.repeatCustomType="S"
}else{
if(this.repeatType==ZmRecurrence.MONTHLY){
this.repeatMonthlyDayList=r.bymonthday[0].modaylist.split(",")
}}
this.repeatCustom="1"
}
if(r.byday&&r.byday[0]&&r.byday[0].wkday){
this.repeatCustom="1";
var n=r.byday[0].wkday;
if(this.repeatType==ZmRecurrence.WEEKLY||(this.repeatType==ZmRecurrence.DAILY&&n.length==5)){
this.repeatWeekday=this.repeatType==ZmRecurrence.DAILY;
for(var h=0;
h<n.length;
++h){
this.repeatWeeklyDays.push(n[h].day)
}}else{
this.repeatCustomDayOfWeek=n[0].day;
var c=[];
for(var o in n){
c.push(n[o].day)
}
this.repeatCustomDays=c;
this.repeatCustomOrdinal=n[0].ordwk;
this.repeatBySetPos=(r.bysetpos&&(r.bysetpos.length>0))?r.bysetpos[0].poslist:null;
if(this.repeatBySetPos==null&&this.repeatCustomOrdinal){
this.repeatBySetPos=this.repeatCustomOrdinal
}
this.repeatCustomType="O"
}}
if(r.until){
this.repeatEndType="D";
this.repeatEndDate=AjxDateUtil.parseServerDateTime(r.until[0].d)
}else{
if(r.count){
this.repeatEndType="A";
this.repeatEndCount=r.count[0].num
}}}}}};
ZmRecurrence.prototype.setRecurrenceStartTime=function(t){
this._startDate.setTime(t);
this.repeatCustomMonthDay=this._startDate.getDate();
if(this.repeatType==ZmRecurrence.NONE){
return
}
if(this.repeatCustom!="0"){
return
}
if(this.repeatType==ZmRecurrence.WEEKLY){
this.repeatWeeklyDays=[ZmCalItem.SERVER_WEEK_DAYS[this._startDate.getDay()]]
}else{
if(this.repeatType==ZmRecurrence.MONTHLY){
this.repeatMonthlyDayList=[this._startDate.getDate()]
}else{
if(this.repeatType==ZmRecurrence.YEARLY){
this.repeatYearlyMonthsList=this._startDate.getMonth()+1
}}}};
ZmRecurrence.prototype.setRecurrenceRules=function(a,t){
if(a){
this.parse(a)
}
if(!t){
return
}
if(this.repeatWeeklyDays==null){
this.repeatWeeklyDays=[ZmCalItem.SERVER_WEEK_DAYS[t.getDay()]]
}
if(this.repeatMonthlyDayList==null){
this.repeatMonthlyDayList=[t.getDate()]
}};
ZmRecurrence.prototype.addCancelRecurId=function(t){
this._cancelRecurIds[t]=true
};
ZmRecurrence.prototype.resetCancelRecurIds=function(){
this._cancelRecurIds={}
};
ZmRecurrence.prototype.isInstanceCanceled=function(t){
return this._cancelRecurIds[t]
};
ZmRecurrence.prototype.removeCancelRecurId=function(t){
this._cancelRecurIds[t]=null
};
ZmRecurrence.prototype.parseExcludeInfo=function(t){
if(!t){
return
}
for(var s=0;
s<t.length;
s++){
var o=(t[s]&&t[s].exclude)?t[s].exclude:null;
if(!o){
continue
}
for(var a=0;
a<o.length;
a++){
var n=o[a].dates;
if(n){
this._parseExcludeDates(n)
}}}};
ZmRecurrence.prototype._parseExcludeDates=function(o){
for(var i=0;
i<o.length;
i++){
var n=o[i].dtval;
if(!n){
continue
}
for(var t=0;
t<n.length;
t++){
var a=n[t];
var s=(a&&a.s)?a.s[0].d:null;
if(s){
this.addCancelRecurId(s)
}}}}
}
if(AjxPackage.define("zimbraMail.tasks.model.ZmTaskFolder")){
ZmTaskFolder=function(t){
t.type=ZmOrganizer.TASKS;
ZmFolder.call(this,t)
};
ZmTaskFolder.prototype=new ZmFolder;
ZmTaskFolder.prototype.constructor=ZmTaskFolder;
ZmTaskFolder.prototype.toString=function(){
return"ZmTaskFolder"
};
ZmTaskFolder.prototype.getIcon=function(){
if(this.id==ZmFolder.ID_ROOT){
return null
}
if(this.link){
return"SharedTaskList"
}
return"TaskList"
};
ZmTaskFolder.prototype.supportsPublicAccess=function(){
return true
};
ZmTaskFolder.prototype.setFreeBusy=function(a,i,t){
if(this.excludeFreeBusy==a){
return
}
this._organizerAction({
action:"fb",attrs:{
excludeFreeBusy:a?"1":"0"}
,callback:i,errorCallback:t}
)
};
ZmTaskFolder.prototype.mayContain=function(r){
if(!r){
return true
}
var s=false;
if(this.id==ZmFolder.ID_ROOT){
s=true
}else{
if(this.link){
s=this.isReadOnly()
}}
if(!s){
var t=(r instanceof Array)?r:[r];
var n=t[0];
if(n.type!=ZmItem.TASK){
s=true
}else{
if(!s&&n.folderId){
s=true;
for(var a=0;
a<t.length;
a++){
var n=t[a];
var o=appCtxt.getById(n.folderId);
if(o!=this){
s=false;
break
}}}}}
return !s
};
ZmTaskFolder.prototype.notifyCreate=function(n){
var o=ZmFolderTree.createFromJs(this,n,this.tree);
var a=ZmOrganizer.getSortIndex(o,ZmTaskFolder.sortCompare);
this.children.add(o,a);
o._notify(ZmEvent.E_CREATE)
};
ZmTaskFolder.prototype.notifyModify=function(a){
ZmFolder.prototype.notifyModify.call(this,a);
if(a.f!=null&&!a._isRemote){
this._parseFlags(a.f);
var t={};
t.excludeFreeBusy=true;
this._notify(ZmEvent.E_MODIFY,{
fields:t}
)
}};
ZmTaskFolder.checkName=function(t){
return ZmFolder.checkName(t)
};
ZmTaskFolder.sortCompare=function(o,i){
var t=ZmOrganizer.checkSortArgs(o,i);
if(t!=null){
return t
}
if(o.link!=i.link){
return o.link?1:-1
}
var a=o.name.toLowerCase();
var n=i.name.toLowerCase();
if(a<n){
return -1
}
if(a>n){
return 1
}
return 0
}
}
if(AjxPackage.define("zimbraMail.tasks.model.ZmTask")){
ZmTask=function(a,i,t){
ZmCalItem.call(this,ZmItem.TASK,a,i,t);
this.priority=ZmCalItem.PRIORITY_NORMAL;
this.pComplete=0;
this.status=ZmCalendarApp.STATUS_NEED;
this.startDate="";
this.endDate="";
this.remindDate=new Date();
this.alarm=false;
this._useAbsoluteReminder=true
};
ZmTask.prototype=new ZmCalItem;
ZmTask.prototype.constructor=ZmTask;
ZmTask.PCOMPLETE_INT=10;
ZmTaskClone=function(){};
ZmTask.quickClone=function(a){
ZmTaskClone.prototype=a;
var t=new ZmTaskClone();
t.startDate=a.startDate?(new Date(a.startDate.getTime())):null;
t.endDate=a.endDate?(new Date(a.endDate.getTime())):null;
t._uniqId=Dwt.getNextId();
t._validAttachments=AjxUtil.createProxy(a._validAttachments);
if(!t._orig){
t._orig=a
}
t.type=ZmItem.TASK;
return t
};
ZmTask.createFromDom=function(o,i,t){
var a=new ZmTask(i.list,o.id);
a._loadFromDom(o,t);
return a
};
ZmTask.prototype.toString=function(){
return"ZmTask"
};
ZmTask.prototype.getIcon=function(){
return"Task"
};
ZmTask.prototype.getFolder=function(){
return appCtxt.getById(this.folderId)
};
ZmTask.prototype.getSummary=function(t){};
ZmTask.prototype.getToolTip=function(t){};
ZmTask.prototype.notifyModify=function(t){
ZmItem.prototype.notifyModify.call(this,t);
this.uid=t.uid;
if(t.l){
this.folderId=t.l
}
this.list.modifyLocal(t,{
task:this}
);
this._notify(ZmEvent.E_MODIFY,t)
};
ZmTask.prototype.isPastDue=function(){
return(this.endDate&&((new Date()).getTime()>this.endDate.getTime()))
};
ZmTask.prototype.getEndTime=function(){
return this.endDate?this.endDate.getTime():null
};
ZmTask.prototype.getStartTime=function(){
return this.startDate?this.startDate.getTime():null
};
ZmTask.prototype.isComplete=function(){
return(this.pComplete==100)||(this.status==ZmCalendarApp.STATUS_COMP)
};
ZmTask.prototype.getPercentComplete=function(){
return this.pComplete
};
ZmTask.prototype.getStatus=function(){
return this.status
};
ZmTask.prototype.getPriority=function(){
return this.priority
};
ZmTask.prototype.cancel=function(i,t){
this.setViewMode(i);
var a=AjxSoapDoc.create(this._getSoapForMode(i),"urn:zimbraMail");
this._addInviteAndCompNum(a);
t.addRequestParams(a)
};
ZmTask.prototype.getRemoteFolderOwner=function(){
var t=AjxDispatcher.run("GetTaskController");
if(t.isMovingBetwAccounts(this,this.folderId)){
return null
}
var a=this.getFolder();
return(a&&a.link)?a.owner:null
};
ZmTask.prototype._getDefaultFolderId=function(){
return ZmOrganizer.ID_TASKS
};
ZmTask.prototype._loadFromDom=function(o,m){
var h=o.inv?o.inv[0]:null;
var c=h?h.comp[0]:null;
if(!o.id){
this.id=o.id
}
if(o.invId){
this.invId=o.invId
}else{
if(h){
var n=h.id;
n=n.toString().indexOf(":");
if(n!=-1){
this.invId=this.id+"-"+h.id.substring(n+1)
}else{
this.invId=[o.id,h.id].join("-")
}}}
this.uid=o.uid;
if(o.l){
this.folderId=o.l
}
if(o.s){
this.size=o.s
}
if(o.sf){
this.sf=o.sf
}
this.allDayEvent=(m?m.allDay:null||o.allDay)?"1":"0";
var i=o.inst&&o.inst.length>0?o.inst[0]:null;
var g=this.tzo=i&&i.tzo!=null?i.tzo:0;
var u=this.tzoDue=i&&i.tzoDue!=null?i.tzoDue:0;
if(i&&i.s){
var d=this.isAllDayEvent()?(g+new Date(i.s).getTimezoneOffset()*60*1000):0;
var a=parseInt(i.s,10)+d;
this.startDate=new Date(a);
this.uniqStartTime=this.startDate.getTime()
}else{
this.startDate=null;
if(c&&c.s&&c.s[0].d){
var t=c.s[0].d;
var r=parseInt(t.substr(0,4),10);
var p=parseInt(t.substr(4,2),10);
var f=parseInt(t.substr(6,2),10);
this.startDate=new Date(r,p-1,f)
}}
if(i&&i.dueDate){
var d=this.isAllDayEvent()?(u+new Date(i.dueDate).getTimezoneOffset()*60*1000):0;
var l=parseInt(i.dueDate,10)+d;
this.endDate=new Date(l)
}else{
this.endDate=null;
if(c&&c.e&&c.e[0].d){
var s=c.e[0].d;
var r=parseInt(s.substr(0,4),10);
var p=parseInt(s.substr(4,2),10);
var f=parseInt(s.substr(6,2),10);
this.endDate=new Date(r,p-1,f)
}}
if(o.alarm){
this.alarm=o.alarm
}
if(o.alarmData){
this.alarmData=this._getAttr(o,c,"alarmData")
}
if(o.name||c){
this.name=this._getAttr(o,c,"name")
}
if(o.loc||c){
this.location=this._getAttr(o,c,"loc")
}
if(o.allDay||c){
this.setAllDayEvent(this._getAttr(o,c,"allDay"))
}
if(o.priority||c){
this.priority=parseInt(this._getAttr(o,c,"priority"))
}
if(o.percentComplete||c){
this.pComplete=parseInt(this._getAttr(o,c,"percentComplete"))
}
if(o.status||c){
this.status=this._getAttr(o,c,"status")
}
if(o.isOrg||c){
this.isOrg=this._getAttr(o,c,"isOrg")
}
if(o.or||c){
this.organizer=o.or?o.or.a:(c.or?c.or.a:null)
}
if(o.ptst||c){
this.ptst=this._getAttr(o,c,"ptst")
}
if(o.compNum!=null){
this.compNum=(this._getAttr(o,c,"compNum")||"0")
}
if(o.f){
this._parseFlags(o.f)
}
if(o.t){
this._parseTags(o.t)
}
this.type=ZmItem.TASK
};
ZmTask.prototype.isAlarmInRange=function(){
if(!this.alarmData){
return false
}
var a=this.alarmData[0];
if(!a){
return false
}
this._nextAlarmTime=new Date(a.nextAlarm);
this._alarmInstStart=this.adjustMS(a.alarmInstStart,this.tzo);
var t=(new Date()).getTime();
return this._nextAlarmTime<=t
};
ZmTask.prototype._getAttr=function(i,t,a){
if(i[a]!=null){
return i[a]
}
if(t){
return t[a]
}
return null
};
ZmTask.prototype.isAlarmModified=function(){
if(this._orig.alarm==true&&this.alarm==false){
return true
}
return false
};
ZmTask.prototype.isMultiDay=function(){
var a=this.startDate;
var t=this.endDate;
if(!a&&!t){
return false
}
if(!a){
return false
}
return(a.getDate()!=t.getDate())||(a.getMonth()!=t.getMonth())||(a.getFullYear()!=t.getFullYear())
};
ZmTask.prototype._setExtrasFromMessage=function(t){
ZmCalItem.prototype._setExtrasFromMessage.apply(this,arguments);
this.location=t.invite.getLocation()
};
ZmTask.prototype._setTimeFromMessage=function(a,t){
ZmCalItem.prototype._setTimeFromMessage.apply(this,arguments);
if(a.invite.components[0].s==null){
this.startDate=null
}};
ZmTask.prototype.parseAlarm=function(i){
if(!i){
return
}
var o;
var a=(i)?i.trigger:null;
var t=(a&&(a.length>0))?a[0].abs:null;
o=(t&&(t.length>0))?t[0].d:null;
this._reminderMinutes=0;
if(i&&(i.action=="DISPLAY")){
if(o!=null){
this._reminderAbs=o;
this.remindDate=o?AjxDateUtil.parseServerDateTime(o):null
}}};
ZmTask.prototype._getSoapForMode=function(a,t){
switch(a){
case ZmCalItem.MODE_NEW:return"CreateTaskRequest";
case ZmCalItem.MODE_EDIT_SINGLE_INSTANCE:return !t?"CreateTaskExceptionRequest":"ModifyTaskRequest";
case ZmCalItem.MODE_EDIT:case ZmCalItem.MODE_EDIT_SERIES:return"ModifyTaskRequest";
case ZmCalItem.MODE_DELETE:case ZmCalItem.MODE_DELETE_SERIES:case ZmCalItem.MODE_DELETE_INSTANCE:return"CancelTaskRequest";
case ZmCalItem.MODE_GET:return"GetTaskRequest"
}
return null
};
ZmTask.prototype._addExtrasToSoap=function(i,t,a){
ZmCalItem.prototype._addExtrasToSoap.call(this,i,t,a);
a.setAttribute("percentComplete",this.pComplete)
};
ZmTask.prototype._getInviteFromError=function(t){
return(t._data.GetTaskResponse.task[0].inv[0])
};
ZmTask.prototype.setTaskReminder=function(t){
this._reminderAbs=t
};
ZmTask.isInTrash=function(a){
var t=(a instanceof ZmTask)?a.folderId:a.l;
var i=appCtxt.getById(t);
return(i&&i.isInTrash())
}
}
if(AjxPackage.define("zimbraMail.tasks.controller.ZmTaskListController")){
ZmTaskListController=function(t,a){
ZmListController.call(this,t,a);
this._dragSrc=new DwtDragSource(Dwt.DND_DROP_MOVE);
this._dragSrc.addDragListener(new AjxListener(this,this._dragListener));
this._listeners[ZmOperation.EDIT]=new AjxListener(this,this._editListener);
this._listeners[ZmOperation.PRINT]=null;
this._listeners[ZmOperation.PRINT_TASK]=new AjxListener(this,this._printTaskListener);
this._listeners[ZmOperation.PRINT_TASKFOLDER]=new AjxListener(this,this._printTaskFolderListener);
this._listeners[ZmOperation.CHECK_MAIL]=new AjxListener(this,this._syncAllListener);
this._listeners[ZmOperation.SHOW_ORIG]=new AjxListener(this,this._showOrigListener);
this._listeners[ZmOperation.MARK_AS_COMPLETED]=new AjxListener(this,this._markAsCompletedListener);
this._listeners[ZmOperation.DELETE]=new AjxListener(this,this._deleteListener);
this._listeners[ZmOperation.SHOW_DOWNLOADS]=new AjxListener(this,ZmListController.prototype._showDownloadsListener);
this._currentTaskView=ZmId.VIEW_TASK_ALL
};
ZmTaskListController.prototype=new ZmListController;
ZmTaskListController.prototype.constructor=ZmTaskListController;
ZmTaskListController.SORT_BY=[ZmId.VIEW_TASK_NOT_STARTED,ZmId.VIEW_TASK_COMPLETED,ZmId.VIEW_TASK_IN_PROGRESS,ZmId.VIEW_TASK_WAITING,ZmId.VIEW_TASK_DEFERRED,ZmId.VIEW_TASK_ALL,ZmId.VIEW_TASK_TODO];
ZmTaskListController.ICON={};
ZmTaskListController.ICON[ZmId.VIEW_TASK_NOT_STARTED]="TaskViewNotStarted";
ZmTaskListController.ICON[ZmId.VIEW_TASK_COMPLETED]="TaskViewCompleted";
ZmTaskListController.ICON[ZmId.VIEW_TASK_IN_PROGRESS]="TaskViewInProgress";
ZmTaskListController.ICON[ZmId.VIEW_TASK_WAITING]="TaskViewWaiting";
ZmTaskListController.ICON[ZmId.VIEW_TASK_DEFERRED]="TaskViewDeferred";
ZmTaskListController.ICON[ZmId.VIEW_TASK_ALL]="TaskList";
ZmTaskListController.ICON[ZmId.VIEW_TASK_TODO]="TaskViewTodoList";
ZmTaskListController.MSG_KEY={};
ZmTaskListController.MSG_KEY[ZmId.VIEW_TASK_NOT_STARTED]="notStarted";
ZmTaskListController.MSG_KEY[ZmId.VIEW_TASK_COMPLETED]="completed";
ZmTaskListController.MSG_KEY[ZmId.VIEW_TASK_IN_PROGRESS]="inProgress";
ZmTaskListController.MSG_KEY[ZmId.VIEW_TASK_WAITING]="waitingOn";
ZmTaskListController.MSG_KEY[ZmId.VIEW_TASK_DEFERRED]="deferred";
ZmTaskListController.MSG_KEY[ZmId.VIEW_TASK_ALL]="all";
ZmTaskListController.MSG_KEY[ZmId.VIEW_TASK_TODO]="todoList";
ZmTaskListController.SOAP_STATUS={};
ZmTaskListController.SOAP_STATUS[ZmId.VIEW_TASK_NOT_STARTED]="NEED";
ZmTaskListController.SOAP_STATUS[ZmId.VIEW_TASK_COMPLETED]="COMP";
ZmTaskListController.SOAP_STATUS[ZmId.VIEW_TASK_IN_PROGRESS]="INPR";
ZmTaskListController.SOAP_STATUS[ZmId.VIEW_TASK_WAITING]="WAITING";
ZmTaskListController.SOAP_STATUS[ZmId.VIEW_TASK_DEFERRED]="DEFERRED";
ZmTaskListController.SOAP_STATUS[ZmId.VIEW_TASK_TODO]="NEED,INPR,WAITING";
ZmTaskListController.READING_PANE_TEXT={};
ZmTaskListController.READING_PANE_TEXT[ZmSetting.RP_OFF]=ZmMsg.readingPaneOff;
ZmTaskListController.READING_PANE_TEXT[ZmSetting.RP_BOTTOM]=ZmMsg.readingPaneAtBottom;
ZmTaskListController.READING_PANE_TEXT[ZmSetting.RP_RIGHT]=ZmMsg.readingPaneOnRight;
ZmTaskListController.ACTION_CODE_TO_MENU_ID={};
ZmTaskListController.ACTION_CODE_TO_MENU_ID[ZmKeyMap.READING_PANE_OFF]=ZmSetting.RP_OFF;
ZmTaskListController.ACTION_CODE_TO_MENU_ID[ZmKeyMap.READING_PANE_BOTTOM]=ZmSetting.RP_BOTTOM;
ZmTaskListController.ACTION_CODE_TO_MENU_ID[ZmKeyMap.READING_PANE_RIGHT]=ZmSetting.RP_RIGHT;
ZmTaskListController.READING_PANE_ICON={};
ZmTaskListController.READING_PANE_ICON[ZmSetting.RP_OFF]="SplitPaneOff";
ZmTaskListController.READING_PANE_ICON[ZmSetting.RP_BOTTOM]="SplitPane";
ZmTaskListController.READING_PANE_ICON[ZmSetting.RP_RIGHT]="SplitPaneVertical";
ZmTaskListController.RP_IDS=[ZmSetting.RP_BOTTOM,ZmSetting.RP_RIGHT,ZmSetting.RP_OFF];
ZmTaskListController.prototype.toString=function(){
return"ZmTaskListController"
};
ZmTaskListController.prototype.show=function(a,t){
this._folderId=t;
this._list=a.getResults(ZmItem.TASK);
var i=appCtxt.getById(t);
this._list._isShared=i?i.link:false;
this._list.setHasMore(a.getAttribute("more"));
ZmListController.prototype.show.call(this,a);
if(this._taskMultiView){
var n=this._taskMultiView._taskListView;
n._saveState({
selection:true}
);
n.reset()
}
this._setup(this._currentView);
var s=this._listView[this._currentView];
if(s){
s.offset=0
}
var o={};
o[ZmAppViewMgr.C_TOOLBAR_TOP]=this._toolbar[this._currentView];
o[ZmAppViewMgr.C_APP_CONTENT]=this._taskMultiView;
this._setView({
view:this._currentView,elements:o,isAppView:true}
);
this._setTabGroup(this._tabGroups[this._currentView]);
this._resetNavToolBarButtons(this._currentView);
if(!this._taskTreeController){
this._taskTreeController=appCtxt.getOverviewController().getTreeController(ZmOrganizer.TASKS)
}
this.getCurrentView().setTaskInputVisible(t!=ZmOrganizer.ID_TRASH)
};
ZmTaskListController.prototype.switchView=function(a){
if(this._currentTaskView==a){
return
}
this._currentTaskView=a;
if(a==ZmSetting.RP_OFF||a==ZmSetting.RP_BOTTOM||a==ZmSetting.RP_RIGHT){
this._taskListView._colHeaderActionMenu=null;
if(a!=this._getReadingPanePref()){
this._setReadingPanePref(a);
this._taskMultiView.setReadingPane()
}
var i=this._toolbar[this._currentView].getButton(ZmOperation.VIEW_MENU);
i.setImage(ZmTaskListController.READING_PANE_ICON[a])
}else{
var i=this._toolbar[this._currentView].getButton(ZmOperation.SORTBY_MENU);
i.setImage(ZmTaskListController.ICON[a])
}
var o=appCtxt.getSearchController();
var t=ZmTaskListController.SOAP_STATUS[a];
o.redoSearch(appCtxt.getCurrentSearch(),false,{
allowableTaskStatus:t}
)
};
ZmTaskListController.prototype.getAllowableTaskStatus=function(){
var t=this._toolbar&&this._toolbar[this._currentView];
var i=t?t.getButton(ZmOperation.SORTBY_MENU).getMenu():null;
var a=i?i.getSelectedItem(DwtMenuItem.RADIO_STYLE):null;
var o=a?a.getData(ZmOperation.MENUITEM_ID):ZmId.VIEW_TASK_ALL;
return ZmTaskListController.SOAP_STATUS[o]
};
ZmTaskListController.prototype._updateViewMenu=function(o){
var a=this._toolbar[this._currentView].getButton(ZmOperation.VIEW_MENU);
var i=a&&a.getMenu();
if(i){
var t=i.getItemById(ZmOperation.MENUITEM_ID,o);
if(t){
t.setChecked(true,true)
}}};
ZmTaskListController.prototype.getKeyMapName=function(){
return"ZmTaskListController"
};
ZmTaskListController.prototype.handleKeyAction=function(a){
switch(a){
case ZmKeyMap.MARK_COMPLETE:case ZmKeyMap.MARK_UNCOMPLETE:var t=this._listView[this._currentView].getSelection()[0];
if((t.isComplete()&&a==ZmKeyMap.MARK_UNCOMPLETE)||(!t.isComplete()&&a==ZmKeyMap.MARK_COMPLETE)){
this._doCheckCompleted(t)
}
break;
case ZmKeyMap.READING_PANE_BOTTOM:case ZmKeyMap.READING_PANE_RIGHT:case ZmKeyMap.READING_PANE_OFF:var i=ZmTaskListController.ACTION_CODE_TO_MENU_ID[a];
this._updateViewMenu(i);
this.switchView(i);
break;
default:return ZmListController.prototype.handleKeyAction.call(this,a)
}
return true
};
ZmTaskListController.prototype.mapSupported=function(t){
return(t=="list")
};
ZmTaskListController.prototype._setupReadingPaneMenuItems=function(){};
ZmTaskListController.prototype.isReadingPaneOn=function(){
return(this._getReadingPanePref()!=ZmSetting.RP_OFF)
};
ZmTaskListController.prototype.isReadingPaneOnRight=function(){
return(this._getReadingPanePref()==ZmSetting.RP_RIGHT)
};
ZmTaskListController.prototype._getReadingPanePref=function(){
return appCtxt.get(ZmSetting.READING_PANE_LOCATION_TASKS)
};
ZmTaskListController.prototype._setReadingPanePref=function(t){
appCtxt.set(ZmSetting.READING_PANE_LOCATION_TASKS,t)
};
ZmTaskListController.prototype.quickSave=function(o,s,a){
var t=(this._activeSearch&&this._activeSearch.search)?this._activeSearch.search.folderId:null;
var n=appCtxt.getById(t);
if(n&&n.link){
t=n.getRemoteId()
}
var i=new ZmTask(this._list,null,t);
if(n&&n.link){
i.setOrganizer(n.owner);
i._orig=new ZmTask(this._list)
}
i.setName(o);
i.setViewMode(ZmCalItem.MODE_NEW);
i.location="";
i.setAllDayEvent(true);
i.save(null,s,a)
};
ZmTaskListController.prototype._defaultView=function(){
return ZmId.VIEW_TASKLIST
};
ZmTaskListController.prototype._getViewType=function(){
return this._currentView
};
ZmTaskListController.prototype._createNewView=function(){
if(this._taskListView){
this._taskListView.setDragSource(this._dragSrc)
}
return this._taskListView
};
ZmTaskListController.prototype._getToolBarOps=function(){
var t=[ZmOperation.NEW_MENU,ZmOperation.SEP];
if(appCtxt.isOffline){
t.push(ZmOperation.CHECK_MAIL,ZmOperation.SEP)
}
t.push(ZmOperation.EDIT,ZmOperation.SEP,ZmOperation.DELETE,ZmOperation.MOVE,ZmOperation.PRINT,ZmOperation.SEP,ZmOperation.TAG_MENU,ZmOperation.SEP,ZmOperation.SORTBY_MENU,ZmOperation.SEP,ZmOperation.MARK_AS_COMPLETED,ZmOperation.SEP,ZmOperation.SHOW_DOWNLOADS,ZmOperation.SEP,ZmOperation.VIEW_MENU);
return t
};
ZmTaskListController.prototype._initialize=function(t){
if(!this._taskMultiView){
var a=this._taskMultiView=new ZmTaskMultiView({
parent:this._container,posStyle:Dwt.ABSOLUTE_STYLE,controller:this,dropTgt:this._dropTgt}
);
this._taskListView=a.getTaskListView()
}
if(t==ZmId.VIEW_TASK){
this._listView[t]=new ZmTaskView(this._container,DwtControl.ABSOLUTE_STYLE,this)
}
ZmListController.prototype._initialize.call(this,t)
};
ZmTaskListController.prototype.getTaskMultiView=function(){
return this._taskMultiView
};
ZmTaskListController.prototype._initializeToolBar=function(t){
if(this._toolbar[t]){
return
}
ZmListController.prototype._initializeToolBar.call(this,t);
this._setNewButtonProps(t,ZmMsg.createNewTask,"NewTask","NewTaskDis",ZmOperation.NEW_TASK);
if(appCtxt.isOffline){
this._setupSendRecieveButton(t);
if(appCtxt.accountList.size()>2){
this._setupSendReceiveMenu(t)
}}
this._setupPrintMenu(t);
this._setupViewMenu(t);
this._setupSortByMenu(t);
this._setupMarkAsCompletedMenu(t);
this._toolbar[t].getButton(ZmOperation.DELETE).setToolTipContent(ZmMsg.hardDeleteTooltip);
this._toolbar[t].addFiller();
this._initializeNavToolBar(t)
};
ZmTaskListController.prototype._setupSendRecieveButton=function(t){
var a=this._toolbar[t].getButton(ZmOperation.CHECK_MAIL);
var o=appCtxt.isOffline?ZmMsg.sendReceive:ZmMsg.checkMail;
a.setText(o);
var i;
if(appCtxt.isOffline){
i=ZmMsg.sendReceive
}else{
i=(appCtxt.get(ZmSetting.GET_MAIL_ACTION)==ZmSetting.GETMAIL_ACTION_DEFAULT)?ZmMsg.checkMailPrefDefault:ZmMsg.checkMailPrefUpdate
}
a.setToolTipContent(i)
};
ZmTaskListController.prototype._handleSyncAll=function(){
if(appCtxt.get(ZmSetting.OFFLINE_SHOW_ALL_MAILBOXES)&&appCtxt.get(ZmSetting.GET_MAIL_ACTION)==ZmSetting.GETMAIL_ACTION_DEFAULT){
this._app.getOverviewContainer().highlightAllMboxes()
}};
ZmTaskListController.prototype._syncAllListener=function(t){
var a=new AjxCallback(this,this._handleSyncAll);
appCtxt.accountList.syncAll(a)
};
ZmTaskListController.prototype._setupSendReceiveMenu=function(t){
var a=this._toolbar[t].getButton(ZmOperation.CHECK_MAIL);
if(!a){
return
}
a.setMenu(new AjxCallback(this,this._setupSendReceiveMenuItems,[this._toolbar,a]))
};
ZmTaskListController.prototype._setupSendReceiveMenuItems=function(c,o){
var a=new ZmPopupMenu(o,null,null,this);
o.setMenu(a);
var n=new AjxListener(this,this._sendReceiveListener);
var h=appCtxt.accountList.visibleAccounts;
for(var s=0;
s<h.length;
s++){
var l=h[s];
if(l.isMain){
continue
}
var t=[ZmOperation.CHECK_MAIL,l.id].join("-");
var r=a.createMenuItem(t,{
image:l.getIcon(),text:l.getDisplayName()}
);
r.setData(ZmOperation.MENUITEM_ID,l.id);
r.addSelectionListener(n)
}
return a
};
ZmTaskListController.prototype._sendReceiveListener=function(t){
var a=appCtxt.accountList.getAccount(t.item.getData(ZmOperation.MENUITEM_ID));
if(a){
a.sync()
}};
ZmTaskListController.prototype._setupMarkAsCompletedMenu=function(t){
var a=this._toolbar[t].getButton(ZmOperation.MARK_AS_COMPLETED);
if(!a){
return
}
a.setToolTipContent(ZmMsg.markAsCompleted);
a.addSelectionListener(this._listeners[ZmOperation.MARK_AS_COMPLETED])
};
ZmTaskListController.prototype._setupPrintMenu=function(a){
var t=this._toolbar[a].getButton(ZmOperation.PRINT);
if(!t){
return
}
t.setToolTipContent(ZmMsg.printMultiTooltip);
t.noMenuBar=true;
var o=new ZmPopupMenu(t);
t.setMenu(o);
var n=ZmOperation.PRINT_TASK;
var i=o.createMenuItem(n,{
image:ZmOperation.getProp(n,"image"),text:ZmMsg[ZmOperation.getProp(n,"textKey")]}
);
i.setData(ZmOperation.MENUITEM_ID,n);
i.addSelectionListener(this._listeners[ZmOperation.PRINT_TASK]);
n=ZmOperation.PRINT_TASKFOLDER;
i=o.createMenuItem(n,{
image:ZmOperation.getProp(n,"image"),text:ZmMsg[ZmOperation.getProp(n,"textKey")]}
);
i.setData(ZmOperation.MENUITEM_ID,n);
i.addSelectionListener(this._listeners[ZmOperation.PRINT_TASKFOLDER])
};
ZmTaskListController.prototype._setupViewMenu=function(a){
var s=this._toolbar[a].getButton(ZmOperation.VIEW_MENU);
var h=s.getMenu();
var t=this._getReadingPanePref();
if(!h){
h=new ZmPopupMenu(s);
s.setMenu(h);
for(var n=0;
n<ZmTaskListController.RP_IDS.length;
n++){
var l=ZmTaskListController.RP_IDS[n];
var r={
image:ZmTaskListController.READING_PANE_ICON[l],text:ZmTaskListController.READING_PANE_TEXT[l],style:DwtMenuItem.RADIO_STYLE};
var o=h.createMenuItem(l,r);
o.setData(ZmOperation.MENUITEM_ID,l);
o.addSelectionListener(this._listeners[ZmOperation.VIEW]);
if(l==t){
o.setChecked(true,true)
}}
s.setImage(ZmTaskListController.READING_PANE_ICON[t])
}};
ZmTaskListController.prototype._setupSortByMenu=function(t){
var n=this._toolbar[t].getButton(ZmOperation.SORTBY_MENU);
var r=n.getMenu();
if(!r){
r=new ZmPopupMenu(n);
n.setMenu(r);
for(var o=0;
o<ZmTaskListController.SORT_BY.length;
o++){
var h=ZmTaskListController.SORT_BY[o];
if(h==ZmId.VIEW_TASK_ALL){
new DwtMenuItem({
parent:r,style:DwtMenuItem.SEPARATOR_STYLE}
)
}
var s={
image:ZmTaskListController.ICON[h],text:ZmMsg[ZmTaskListController.MSG_KEY[h]],style:DwtMenuItem.RADIO_STYLE};
var a=r.createMenuItem(h,s);
a.setData(ZmOperation.MENUITEM_ID,h);
a.addSelectionListener(this._listeners[ZmOperation.VIEW]);
if(h==ZmId.VIEW_TASK_ALL){
a.setChecked(true,true)
}}
n.setImage(ZmTaskListController.ICON[ZmId.VIEW_TASK_ALL])
}};
ZmTaskListController.prototype._getActionMenuOps=function(){
return[ZmOperation.EDIT,ZmOperation.MARK_AS_COMPLETED,ZmOperation.SEP,ZmOperation.TAG_MENU,ZmOperation.DELETE,ZmOperation.MOVE,ZmOperation.PRINT_TASK,ZmOperation.SHOW_ORIG]
};
ZmTaskListController.prototype._getTagMenuMsg=function(t){
return(t==1)?ZmMsg.tagTask:ZmMsg.tagTasks
};
ZmTaskListController.prototype._resetOperations=function(m,h){
ZmListController.prototype._resetOperations.call(this,m,h);
var a=(this._activeSearch&&this._activeSearch.search)?this._activeSearch.search.folderId:null;
if(a){
var t=appCtxt.getById(a);
var u=t&&t.link;
var l=t&&t.id==ZmOrganizer.ID_TRASH;
var i=(t==null||!t.isReadOnly());
m.enable([ZmOperation.MOVE,ZmOperation.DELETE],i&&h>0);
m.enable(ZmOperation.EDIT,!l&&i&&h==1);
m.enable(ZmOperation.MARK_AS_COMPLETED,!l&&i&&h>0);
m.enable(ZmOperation.TAG_MENU,(!u&&h>0))
}else{
var n=this._listView[this._currentView].getSelection()[0];
var i=(h==1&&!n.isReadOnly()&&!ZmTask.isInTrash(n));
m.enable([ZmOperation.DELETE,ZmOperation.MOVE,ZmOperation.TAG_MENU],h>0);
m.enable(ZmOperation.EDIT,i);
m.enable(ZmOperation.MARK_AS_COMPLETED,i&&!n.isComplete())
}
var d=(m instanceof ZmButtonToolBar)?m.getButton(ZmOperation.PRINT):null;
var s=s&&d.getMenu();
var o=s&&s.getItem(1);
if(o){
var f=(a!=null)?ZmMsg.printTaskFolder:ZmMsg.printResults;
o.setText(f)
}
var c=(m instanceof ZmActionMenu)?ZmOperation.PRINT_TASK:ZmOperation.PRINT;
m.enable(c,h>0);
m.enable(ZmOperation.SORTBY_MENU,true);
m.enable(ZmOperation.VIEW_MENU,true);
m.enable(ZmOperation.TEXT,true);
if(m.getOp(ZmOperation.SHOW_ORIG)){
var r=this._taskListView.getSelection();
m.enable(ZmOperation.SHOW_ORIG,h==1&&r&&r.length&&r[0].getRestUrl()!=null)
}};
ZmTaskListController.prototype._deleteListener=function(r){
var h=this._listView[this._currentView].getSelection();
if(!h||h.length==0){
return
}
var t=(this._activeSearch&&this._activeSearch.search)?this._activeSearch.search.folderId:null;
if(!t){
var s=false;
for(var n=0,o=h.length;
n<o;
n++){
if(h[n]&&ZmTask.isInTrash(h[n])){
s=true;
break
}}
if(s){
var a=appCtxt.getOkCancelMsgDialog();
a.reset();
a.setMessage(ZmMsg.confirmItemDelete,DwtMessageDialog.WARNING_STYLE);
a.registerCallback(DwtDialog.OK_BUTTON,this._deleteCallback,this,[a]);
a.popup()
}}else{
this._doDelete(this._listView[this._currentView].getSelection())
}};
ZmTaskListController.prototype._deleteCallback=function(t){
t.popdown();
this._doDelete(this._listView[this._currentView].getSelection())
};
ZmTaskListController.prototype._doDelete=function(o,i){
if(!o||o.length==0){
return
}
var t=ZmOrganizer.normalizeId(o[0].folderId);
var a=t==ZmOrganizer.ID_TRASH;
if(a){
this._handleDelete(o)
}else{
this._handleCancel(o)
}};
ZmTaskListController.prototype._handleDelete=function(a){
var t={
items:a,hardDelete:true,finalCallback:new AjxCallback(this,this._handleDeleteResponse,[a])};
a[0].list.deleteItems(t)
};
ZmTaskListController.prototype._handleDeleteResponse=function(i,a){
var t=ZmList.getActionSummary(ZmMsg.actionDelete,i.length,ZmItem.TASK);
appCtxt.setStatusMsg(t)
};
ZmTaskListController.prototype._doCheckCompleted=function(t,a){
var o=ZmTask.quickClone(t);
o.message=null;
var i=new AjxCallback(this,this._doCheckCompletedResponse,[o,a]);
o.getDetails(ZmCalItem.MODE_EDIT,i)
};
ZmTaskListController.prototype._doCheckCompletedResponse=function(t,a){
var o=ZmTask.quickClone(t);
o.pComplete=t.isComplete()?0:100;
o.status=t.isComplete()?ZmCalendarApp.STATUS_NEED:ZmCalendarApp.STATUS_COMP;
if(!t.isComplete()){
o.alarm=false;
o.setTaskReminder(null)
}
o.setViewMode(ZmCalItem.MODE_EDIT);
var i=new AjxCallback(this,this._markAsCompletedResponse,[o,a]);
o.save(null,i)
};
ZmTaskListController.prototype._markAsCompletedResponse=function(t,a){
if(t&&t._orig){
t._orig.message=null
}
t.cache();
this._taskListView.updateListViewEl(t);
if(a&&this.isReadingPaneOn()){
this._taskMultiView.setTask(t)
}};
ZmTaskListController.prototype._handleCancel=function(s){
var n=new ZmBatchCommand();
var d=appCtxt.getActionController();
var h=[];
for(var r=0;
r<s.length;
r++){
var u=s[r];
var o=new AjxCallback(u,u.cancel,[ZmCalItem.MODE_DELETE]);
n.add(o);
h.push(u.id)
}
var a=(d&&d.actionPerformed({
op:"trash",ids:h,attrs:{
l:ZmOrganizer.ID_TRASH}}
))||null;
n.run();
var l=ZmList.getActionSummary(ZmMsg.actionTrash,s.length,ZmItem.TASK);
var c=a&&d&&d.getUndoLink(a);
if(c&&d){
d.onPopup();
appCtxt.setStatusMsg({
msg:l+c,transitions:d.getStatusTransitions()}
)
}else{
appCtxt.setStatusMsg(l)
}};
ZmTaskListController.prototype._editTask=function(a){
var o=ZmCalItem.MODE_EDIT;
var i=appCtxt.getById(a.folderId);
var t=null;
if(i){
t=i.id!=ZmOrganizer.ID_TRASH&&!i.isReadOnly()
}
if(!t){
if(a.isException){
o=ZmCalItem.MODE_EDIT_SINGLE_INSTANCE
}
var n=ZmTask.quickClone(a);
n.getDetails(o,new AjxCallback(this,this._showTaskReadOnlyView,n))
}else{
if(a.isRecurring()){
if(a.isException){
o=ZmCalItem.MODE_EDIT_SINGLE_INSTANCE
}else{
this._showTypeDialog(a,ZmCalItem.MODE_EDIT);
return
}}
a.message=null;
a.getDetails(o,new AjxCallback(this,this._showTaskEditView,[a,o]))
}};
ZmTaskListController.prototype._handleEmptyList=function(t){
t._resetListView();
t._setNoResultsHtml()
};
ZmTaskListController.prototype._setSelectedItem=function(){
var a=this._listView[this._currentView].getSelectionCount();
if(a==1){
var t=this._listView[this._currentView].getSelection()
}};
ZmTaskListController.prototype._showTaskReadOnlyView=function(a){
var t=ZmId.VIEW_TASK;
if(!this.isReadingPaneOn()){
var o=this._listView[t];
if(!o){
this._setup(t);
o=this._listView[t]
}
o.set(a,ZmId.VIEW_TASKLIST);
this._resetOperations(this._toolbar[t],1);
var i={};
i[ZmAppViewMgr.C_TOOLBAR_TOP]=this._toolbar[t];
i[ZmAppViewMgr.C_APP_CONTENT]=this._listView[t];
this._setView({
view:t,elements:i,pushOnly:true}
)
}else{
var o=this._taskMultiView._taskView;
if(o){
o.set(a,ZmId.VIEW_TASK)
}}};
ZmTaskListController.prototype._showTaskEditView=function(t,a){
this._app.getTaskController().show(t,a)
};
ZmTaskListController.prototype._showTypeDialog=function(t,a){
if(!this._typeDialog){
this._typeDialog=new ZmCalItemTypeDialog(this._shell);
this._typeDialog.addSelectionListener(DwtDialog.OK_BUTTON,new AjxListener(this,this._typeOkListener,[t,a]))
}
this._typeDialog.initialize(t,a,ZmItem.TASK);
this._typeDialog.popup()
};
ZmTaskListController.prototype._typeOkListener=function(a,s,i){
var n=this._typeDialog.isInstance();
if(s==ZmCalItem.MODE_DELETE){
var t=n?ZmCalItem.MODE_DELETE_INSTANCE:ZmCalItem.MODE_DELETE_SERIES
}else{
var o=n?ZmCalItem.MODE_EDIT_SINGLE_INSTANCE:ZmCalItem.MODE_EDIT_SERIES;
a.getDetails(s,new AjxCallback(this,this._showTaskEditView,[a,o]))
}};
ZmTaskListController.prototype._newListener=function(t,i,a){
a=a||{};
a.folderId=this._list.search.folderId;
ZmListController.prototype._newListener.call(this,t,i,a)
};
ZmTaskListController.prototype._listSelectionListener=function(a){
Dwt.setLoadingTime("ZmTaskItem",new Date());
ZmListController.prototype._listSelectionListener.call(this,a);
if(a.detail==DwtListView.ITEM_DBL_CLICKED){
this._editTask(a.item)
}else{
if(this.isReadingPaneOn()){
var t=a.item;
var i=ZmCalItem.MODE_EDIT;
var o=ZmTask.quickClone(t);
o.getDetails(i,new AjxCallback(this,this._showTaskReadOnlyView,o))
}}};
ZmTaskListController.prototype._listActionListener=function(t){
ZmListController.prototype._listActionListener.call(this,t);
var a=this.getActionMenu();
a.popup(0,t.docX,t.docY)
};
ZmTaskListController.prototype._editListener=function(a){
var t=this._listView[this._currentView].getSelection()[0];
this._editTask(t)
};
ZmTaskListController.prototype._printTaskListener=function(r){
var a=this._listView[this._currentView];
var o=a.getSelection();
var l=[];
for(var s=0;
s<o.length;
s++){
l.push(o[s].invId)
}
var n=["/h/printtasks?id=",l.join(",")];
if(appCtxt.isOffline){
var t=this._folderId||ZmFolder.ID_CONTACTS;
var h=appCtxt.getById(t).getAccount().name;
n.push("&acct=",h)
}
window.open([appContextPath,n.join(""),"&tz=",AjxTimezone.getServerId(AjxTimezone.DEFAULT)].join(""),"_blank")
};
ZmTaskListController.prototype._markAsCompletedListener=function(s){
var t=this._listView[this._currentView];
var o=t.getSelection();
var r=null;
for(var n=0;
n<o.length;
n++){
var a=o[n];
if(!a.isComplete()){
if(!r){
r=true
}
this._doCheckCompleted(o[n],r)
}}};
ZmTaskListController.prototype._printListener=function(t){
this._printTaskListener(t)
};
ZmTaskListController.prototype._printTaskFolderListener=function(n){
var a=["/h/printtasks?"];
if(this._folderId){
a.push("st=task&sfi=",this._folderId)
}else{
var h=[];
var r=this._list.getArray();
for(var o=0;
o<r.length;
o++){
h.push(r[o].invId)
}
a.push("id=",h.join(","))
}
if(appCtxt.isOffline){
var t=this._folderId||ZmFolder.ID_CONTACTS;
var s=appCtxt.getById(t).getAccount().name;
a.push("&acct=",s)
}
window.open([appContextPath,a.join(""),"&tz=",AjxTimezone.getServerId(AjxTimezone.DEFAULT)].join(""),"_blank")
};
ZmTaskListController.prototype._setViewContents=function(t){
var i=this._taskListView;
i.set(this._list,ZmItem.F_DATE);
if(i.offset==0){
var a=this._list.getVector();
if(a.size()){
this._taskListView.setSelection(a.get(0))
}else{
this._taskMultiView._taskView.reset()
}}};
ZmTaskListController.prototype._getMoveDialogTitle=function(t){
return(t==1)?ZmMsg.moveTask:ZmMsg.moveTasks
};
ZmTaskListController.prototype._moveCallback=function(t){
this._doMove(this._pendingActionData,t);
this._clearDialog(appCtxt.getChooseFolderDialog());
this._pendingActionData=null
};
ZmTaskListController.prototype._showOrigListener=function(t){
var a=this._listView[this._currentView].getSelection();
if(a&&a.length>0){
setTimeout(AjxCallback.simpleClosure(this._showTaskSource,this,a[0]),1)
}};
ZmTaskListController.prototype._showTaskSource=function(t){
var i=t.getRestUrl();
if(i){
var a=[i,(i.indexOf("?")==-1)?"?":"&","mime=text/plain","&","noAttach=1"].join("");
var o=window.open(a,"TaskSource","menubar=yes,resizable=yes,scrollbars=yes");
appCtxt.handlePopupBlocker(o)
}};
ZmTaskListController.prototype.getTaskFolderIds=function(o){
var a=[];
if(o){
if(this._taskTreeController){
if(appCtxt.multiAccounts){
var h=this._app.getOverviewContainer().getOverviews();
for(var r in h){
a=a.concat(this._taskTreeController.getTaskFolders(r,false))
}}else{
if(!this._app._overviewPanelContent){
this._app.setOverviewPanelContent(true)
}
a=this._taskTreeController.getTaskFolders(this._app.getOverviewId(),false)
}}else{
this._app._createDeferredFolders(ZmApp.TASKS);
var l=appCtxt.accountList.visibleAccounts;
for(var r=0;
r<l.length;
r++){
var c=l[r];
if(!appCtxt.get(ZmSetting.TASKS_ENABLED,null,c)){
continue
}
var n=appCtxt.getFolderTree(c).getByType(ZmOrganizer.TASKS);
for(var s=0;
s<n.length;
s++){
if(n[s].nId==ZmOrganizer.ID_TRASH){
continue
}
a.push(n[s])
}}}
this._taskLocalFolderIds=[];
for(var r=0;
r<a.length;
r++){
var t=a[r];
if(t.noSuchFolder){
continue
}
if(t.isRemote&&!t.isRemote()){
this._taskLocalFolderIds.push(t.id)
}}
return this._taskLocalFolderIds
}}
}
if(AjxPackage.define("zimbraMail.tasks.view.ZmTaskListView")){
ZmTaskListView=function(o,a,t){
this._controller=a;
var i=this._getHeaderList(o);
var n={
parent:o,posStyle:Dwt.ABSOLUTE_STYLE,view:ZmId.VIEW_TASKLIST,pageless:false,type:ZmItem.TASK,controller:a,headerList:i,dropTgt:t};
ZmListView.call(this,n)
};
ZmTaskListView.prototype=new ZmListView;
ZmTaskListView.prototype.constructor=ZmTaskListView;
ZmTaskListView.SASH_THRESHOLD=5;
ZmTaskListView.COL_WIDTH_STATUS=ZmMsg.COLUMN_WIDTH_STATUS_TLV;
ZmTaskListView.COL_WIDTH_PCOMPLETE=ZmMsg.COLUMN_WIDTH_PCOMPLETE_TLV;
ZmTaskListView.COL_WIDTH_DATE_DUE=ZmMsg.COLUMN_WIDTH_DATE_DUE_TLV;
ZmTaskListView.SEC_UPCOMING="UPCOMING";
ZmTaskListView.SEC_PASTDUE="PASTDUE";
ZmTaskListView.SEC_TODAY="TODAY";
ZmTaskListView.SEC_NODUEDATE="NODUEDATE";
ZmTaskListView.SEC_MSG_KEY={};
ZmTaskListView.SEC_MSG_KEY[ZmTaskListView.SEC_UPCOMING]=ZmMsg.taskSecUpcoming;
ZmTaskListView.SEC_MSG_KEY[ZmTaskListView.SEC_PASTDUE]=ZmMsg.taskSecPastDue;
ZmTaskListView.SEC_MSG_KEY[ZmTaskListView.SEC_TODAY]=ZmMsg.taskSecToday;
ZmTaskListView.SEC_MSG_KEY[ZmTaskListView.SEC_NODUEDATE]=ZmMsg.taskSecNoDuedate;
ZmTaskListView.SEC_COLOR={};
ZmTaskListView.SEC_COLOR[ZmTaskListView.SEC_UPCOMING]="OrangeC";
ZmTaskListView.SEC_COLOR[ZmTaskListView.SEC_PASTDUE]="RedC";
ZmTaskListView.SEC_COLOR[ZmTaskListView.SEC_TODAY]="GreenC";
ZmTaskListView.SEC_COLOR[ZmTaskListView.SEC_NODUEDATE]="GrayDarkC";
ZmTaskListView.ROW_DOUBLE_CLASS="RowDouble";
ZmTaskListView._NEW_TASK_ROW_ID="_newTaskBannerId";
ZmTaskListView.prototype.toString=function(){
return"ZmTaskListView"
};
ZmTaskListView.prototype.setSize=function(a,t){
ZmListView.prototype.setSize.call(this,a,t);
this._resetColWidth()
};
ZmTaskListView.prototype.saveNewTask=function(i){
if(this._newTaskInputEl&&Dwt.getVisibility(this._newTaskInputEl)){
var a=AjxStringUtil.trim(this._newTaskInputEl.value);
if(a!=""){
var o=new AjxCallback(this,this._saveNewTaskResponse,[i]);
var t=new AjxCallback(this,this._handleNewTaskError);
this._controller.quickSave(a,o,t)
}else{
this._saveNewTaskResponse(i)
}}};
ZmTaskListView.prototype._saveNewTaskResponse=function(t){
if(t){
this._newTaskInputEl.value="";
this._newTaskInputEl.focus()
}else{
Dwt.setVisibility(this._newTaskInputEl,false)
}};
ZmTaskListView.prototype._handleNewTaskError=function(t){
if(t){
this.discardNewTask()
}};
ZmTaskListView.prototype.handleKeyAction=function(t,a){
if(this._editing){
switch(t){
case DwtKeyMap.SELECT_NEXT:this.discardNewTask();
break;
case DwtKeyMap.DBLCLICK:break;
default:DwtListView.prototype.handleKeyAction.call(this,t,a)
}}else{
DwtListView.prototype.handleKeyAction.call(this,t,a)
}};
ZmTaskListView.prototype.discardNewTask=function(){
if(this._newTaskInputEl&&Dwt.getVisibility(this._newTaskInputEl)){
this._newTaskInputEl.value="";
Dwt.setVisibility(this._newTaskInputEl,false);
this.focus();
this._editing=false
}};
ZmTaskListView.prototype.getTitle=function(){
return[ZmMsg.zimbraTitle,this._controller.getApp().getDisplayName()].join(": ")
};
ZmTaskListView.prototype._renderTaskListItemHdr=function(i){
if(!this._newSecHdrHtml[i]){
var a=[];
var t=0;
a[t++]="<div id='_upComingTaskListHdr'>";
a[t++]="<table cellpadding=0 cellspacing=0 border=0 width=100% class='DwtListView-Column'><tr>";
this.dId=Dwt.getNextId();
a[t++]="<td><div class='DwtListHeaderItem-label ";
a[t++]=ZmTaskListView.SEC_COLOR[i];
a[t++]="' style='padding:0px 0px 2px 2px; font-weight:bold;' id='";
a[t++]=this.dId;
a[t++]="'>";
a[t++]=ZmTaskListView.SEC_MSG_KEY[i];
a[t++]="</div></td>";
a[t++]="</tr></table></div>";
return this._newSecHdrHtml[i]=a.join("")
}else{
return null
}};
ZmTaskListView.prototype.setTaskInputVisible=function(a){
var t=document.getElementById(ZmTaskListView._NEW_TASK_ROW_ID);
if(t){
Dwt.setVisible(t,a)
}};
ZmTaskListView.prototype._renderList=function(w,t,a){
this._newSecHdrHtml={};
if(w instanceof AjxVector&&w.size()){
var o=new Date();
var u=w.size();
var f=[];
var l=null;
var q=[];
var y=[];
var h=[];
var n=[];
for(var b=0;
b<u;
b++){
var v=w.get(b);
var k=new Date();
k.setHours(0,0,0,0);
k=k.getTime();
var x=v.endDate;
if(x!=null){
x.setHours(0,0,0,0);
x=x.getTime()
}else{
x=null
}
if(x!=null&&x>k){
var p=this._renderTaskListItemHdr(ZmTaskListView.SEC_UPCOMING);
if(p){
q.push(p)
}
l=ZmTaskListView.SEC_UPCOMING
}else{
if(x!=null&&x==k){
var p=this._renderTaskListItemHdr(ZmTaskListView.SEC_TODAY);
if(p){
h.push(p)
}
l=ZmTaskListView.SEC_TODAY
}else{
if(x!=null&&x<k){
var p=this._renderTaskListItemHdr(ZmTaskListView.SEC_PASTDUE);
if(p){
y.push(p)
}
l=ZmTaskListView.SEC_PASTDUE
}else{
if(x==null){
var p=this._renderTaskListItemHdr(ZmTaskListView.SEC_NODUEDATE);
if(p){
n.push(p)
}
l=ZmTaskListView.SEC_NODUEDATE
}else{
l=null
}}}}
var r=this._normalClass;
if(v.status==ZmCalendarApp.STATUS_COMP){
r+=" ZmCompletedtask"
}else{
if(v.status!=ZmCalendarApp.STATUS_COMP&&l==ZmTaskListView.SEC_PASTDUE){
r+=" ZmOverduetask"
}}
var c=this._createItemHtml(v,{
now:o,divClass:r}
,true,b);
if(c){
if(c instanceof Array){
for(var g=0;
g<c.length;
g++){
this._addRow(c[g])
}}else{
if(c.tagName||a){
this._addRow(c)
}else{
if(this._controller.getAllowableTaskStatus()==ZmTaskListController.SOAP_STATUS[ZmId.VIEW_TASK_TODO]&&v.status==ZmCalendarApp.STATUS_WAIT){
if(l==ZmTaskListView.SEC_PASTDUE){
y.push(c)
}
continue
}
if(l==ZmTaskListView.SEC_UPCOMING){
q.push(c)
}else{
if(l==ZmTaskListView.SEC_TODAY){
h.push(c)
}else{
if(l==ZmTaskListView.SEC_PASTDUE){
y.push(c)
}else{
if(l==ZmTaskListView.SEC_NODUEDATE){
n.push(c)
}else{
f.push(c)
}}}}}}}}
var m=appCtxt.get(ZmSetting.SORTING_PREF,this.view);
if(m==ZmSearch.DUE_DATE_DESC){
if(q.length){
f.push(q.join(""))
}
if(h.length){
f.push(h.join(""))
}
if(y.length){
f.push(y.join(""))
}
if(n.length){
f.push(n.join(""))
}}else{
if(y.length){
f.push(y.join(""))
}
if(h.length){
f.push(h.join(""))
}
if(q.length){
f.push(q.join(""))
}
if(n.length){
f.push(n.join(""))
}}
if(f.length){
this._parentEl.innerHTML=f.join("")
}}else{
if(!t){
this._setNoResultsHtml()
}}
if(a){
return
}
c=document.createElement("DIV");
c.id=ZmTaskListView._NEW_TASK_ROW_ID;
f=[];
var d=0;
f[d++]="<table cellpadding=0 cellspacing=0 border=0 width=100% class='newTaskBannerSep'><tr>";
for(var b=0;
b<this._headerList.length;
b++){
var s=this._headerList[b];
if(!s._visible){
continue
}
if(s._field==ZmItem.F_SUBJECT||s._field==ZmItem.F_SORTED_BY){
this.dId=Dwt.getNextId();
f[d++]="<td><div class='newTaskBanner' onclick='ZmTaskListView._handleOnClick(this)' id='";
f[d++]=this.dId;
f[d++]="'>";
f[d++]=ZmMsg.createNewTaskHint;
f[d++]="</div></td>"
}else{
f[d++]="<td width=";
f[d++]=s._width;
f[d++]=">&nbsp;</td>"
}}
f[d++]="</tr></table>";
c.innerHTML=f.join("");
this._addRow(c,0)
};
ZmTaskListView.prototype._resetListView=function(){
var t;
while(this._parentEl.hasChildNodes()){
if(this._parentEl.lastChild.id=="_newTaskBannerId"){
break
}
t=this._parentEl.removeChild(this._parentEl.lastChild);
this._data[t.id]=null
}
this._selectedItems.removeAll();
this._rightSelItems=null
};
ZmTaskListView.prototype._getCellId=function(t,a){
if(a==ZmItem.F_PRIORITY||a==ZmItem.F_SUBJECT||a==ZmItem.F_STATUS||a==ZmItem.F_PCOMPLETE||a==ZmItem.F_DATE){
return this._getFieldId(t,a)
}else{
if(a==ZmItem.F_SELECTION){
return this._getFieldId(t,ZmItem.F_SELECTION_CELL)
}else{
return DwtListView.prototype._getCellId.apply(this,arguments)
}}};
ZmTaskListView.prototype.setTask=function(t){
this._taskReadOnlyView.set(t)
};
ZmTaskListView.prototype._getAbridgedCell=function(h,r,l,s,i,t,o){
var a={};
h[r++]="<td";
if(t){
h[r++]=" width='";
h[r++]=t;
h[r++]="'"
}
h[r++]=" id='";
h[r++]=this._getCellId(l,s,a);
h[r++]="'";
var n=this._getCellClass(l,s,a);
if(n){
h[r++]=" class='";
h[r++]=n;
h[r++]="'"
}
if(o){
h[r++]=" ";
h[r++]=o
}
h[r++]=">";
r=this._getCellContents(h,r,l,s,i,a);
h[r++]="</td>";
return r
};
ZmTaskListView.prototype.getColorForStatus=function(t){
switch(t){
case ZmCalendarApp.STATUS_CANC:return"YellowDark";
case ZmCalendarApp.STATUS_COMP:return"Green";
case ZmCalendarApp.STATUS_DEFR:return"Red";
case ZmCalendarApp.STATUS_INPR:return"Blue";
case ZmCalendarApp.STATUS_NEED:return"";
case ZmCalendarApp.STATUS_WAIT:return"Orange"
}
return""
};
ZmTaskListView.prototype._getAbridgedContent=function(i,n){
var a=[];
var t=0;
var o=(AjxEnv.isIE||AjxEnv.isSafari)?"22":"16";
a[t++]="<table border=0 cellspacing=0 cellpadding=0 width=100% style='padding-bottom:4px;'>";
a[t++]="<tr id='";
a[t++]=DwtId.getListViewItemId(DwtId.WIDGET_ITEM_FIELD,this._view,i.id,ZmItem.F_ITEM_ROW_3PANE);
a[t++]="'>";
t=this._getAbridgedCell(a,t,i,ZmItem.F_SUBJECT,n);
t=this._getAbridgedCell(a,t,i,ZmItem.F_DATE,n,ZmMsg.COLUMN_WIDTH_DATE,"align=right");
a[t++]="</tr></table>";
a[t++]="<table border=0 cellspacing=0 cellpadding=0 width=100%><tr>";
a[t++]="<td width=50%><div style='height:10px; width:80px; border:1px solid #c5c5c5;'><div";
a[t++]=" class='";
a[t++]=this.getColorForStatus(i.status);
a[t++]="' style='height:10px; width:"+i.pComplete+"%;'></div></div></td>";
a[t++]="<td width=50% align=right><table border=0 cellspacing=0 cellpadding=0><tr>";
t=this._getAbridgedCell(a,t,i,ZmItem.F_TAG,n,"16");
if(i.priority==ZmCalItem.PRIORITY_HIGH||i.priority==ZmCalItem.PRIORITY_LOW){
t=this._getAbridgedCell(a,t,i,ZmItem.F_PRIORITY,n,"16","align=right")
}
if(i.hasAttach){
t=this._getAbridgedCell(a,t,i,ZmItem.F_ATTACHMENT,n,"16")
}
a[t++]="</tr></table></td>";
a[t++]="</tr></table>";
return a.join("")
};
ZmTaskListView.prototype._getCellContents=function(a,t,i,s,h,r){
if(s==ZmItem.F_SELECTION){
var n=r.bContained?"CheckboxChecked":"CheckboxUnchecked";
t=this._getImageHtml(a,t,n,this._getFieldId(i,s))
}else{
if(s==ZmItem.F_PRIORITY){
a[t++]="<center>";
a[t++]=ZmCalItem.getImageForPriority(i,r.fieldId);
a[t++]="</center>"
}else{
if(r.isMixedView&&(s==ZmItem.F_FROM)){
a[t++]=i.organizer||"&nbsp"
}else{
if(s==ZmItem.F_SUBJECT){
if(r.isMixedView){
a[t++]=i.name?AjxStringUtil.htmlEncode(i.name,true):AjxStringUtil.htmlEncode(ZmMsg.noSubject)
}else{
a[t++]=AjxStringUtil.htmlEncode(i.getName(),true)
}}else{
if(s==ZmItem.F_STATUS){
a[t++]=ZmCalItem.getLabelForStatus(i.status)
}else{
if(s==ZmItem.F_PCOMPLETE){
var o=new AjxMessageFormat(AjxMsg.percentageString);
a[t++]=o.format(i.pComplete||0)
}else{
if(s==ZmItem.F_DATE){
a[t++]=i.endDate!=null?AjxDateUtil.simpleComputeDateStr(i.endDate):"&nbsp;"
}else{
if(s==ZmItem.F_SORTED_BY){
a[t++]=this._getAbridgedContent(i,h)
}else{
t=ZmListView.prototype._getCellContents.apply(this,arguments)
}}}}}}}}
return t
};
ZmTaskListView.prototype._getHeaderToolTip=function(a,t){
switch(a){
case ZmItem.F_PRIORITY:return ZmMsg.priority;
case ZmItem.F_STATUS:return ZmMsg.sortByStatus;
case ZmItem.F_PCOMPLETE:return ZmMsg.sortByPComplete;
case ZmItem.F_DATE:return ZmMsg.sortByDueDate
}
return ZmListView.prototype._getHeaderToolTip.call(this,a,t)
};
ZmTaskListView.prototype._sortColumn=function(t,i){
var o;
switch(t._sortable){
case ZmItem.F_SUBJECT:o=i?ZmSearch.SUBJ_ASC:ZmSearch.SUBJ_DESC;
break;
case ZmItem.F_STATUS:o=i?ZmSearch.STATUS_ASC:ZmSearch.STATUS_DESC;
break;
case ZmItem.F_PCOMPLETE:o=i?ZmSearch.PCOMPLETE_ASC:ZmSearch.PCOMPLETE_DESC;
break;
case ZmItem.F_DATE:o=i?ZmSearch.DUE_DATE_ASC:ZmSearch.DUE_DATE_DESC;
break;
case ZmItem.F_SORTED_BY:o=i?ZmSearch.DUE_DATE_ASC:ZmSearch.DUE_DATE_DESC;
break
}
if(o){
this._sortByString=o;
appCtxt.set(ZmSetting.SORTING_PREF,o,this.view)
}
if(this.getList().size()>0&&this._sortByString){
var a={
query:this._controller.getSearchString(),queryHint:this._controller.getSearchStringHint(),types:[ZmItem.TASK],sortBy:this._sortByString,limit:this.getLimit()};
appCtxt.getSearchController().search(a)
}};
ZmTaskListView.prototype._handleNewTaskClick=function(t){
if(!this._newTaskInputEl){
this._newTaskInputEl=document.createElement("INPUT");
this._newTaskInputEl.type="text";
this._newTaskInputEl.className="InlineWidget";
this._newTaskInputEl.style.position="absolute";
this._newTaskInputEl.id=Dwt.getNextId();
Dwt.setHandler(this._newTaskInputEl,DwtEvent.ONBLUR,ZmTaskListView._handleOnBlur);
Dwt.setHandler(this._newTaskInputEl,DwtEvent.ONKEYPRESS,ZmTaskListView._handleKeyPress);
this.shell.getHtmlElement().appendChild(this._newTaskInputEl);
this._resetInputSize(t)
}else{
this._newTaskInputEl.value=""
}
Dwt.setVisibility(this._newTaskInputEl,true);
this._newTaskInputEl.focus();
this._editing=true
};
ZmTaskListView.prototype._handleColHeaderResize=function(t){
ZmListView.prototype._handleColHeaderResize.call(this,t);
this._newTaskInputEl=null
};
ZmTaskListView.prototype._getHeaderList=function(a){
var t=[];
if(appCtxt.get(ZmSetting.SHOW_SELECTION_CHECKBOX)){
t.push(new DwtListHeaderItem({
field:ZmItem.F_SELECTION,icon:"CheckboxUnchecked",width:ZmListView.COL_WIDTH_ICON,name:ZmMsg.selection}
))
}
if(this.isMultiColumn()){
if(appCtxt.get(ZmSetting.TAGGING_ENABLED)){
t.push(new DwtListHeaderItem({
field:ZmItem.F_TAG,icon:"Tag",width:ZmListView.COL_WIDTH_ICON,name:ZmMsg.tag}
))
}
t.push(new DwtListHeaderItem({
field:ZmItem.F_PRIORITY,icon:"PriorityHigh_list",width:ZmListView.COL_WIDTH_ICON,name:ZmMsg.priority}
));
t.push(new DwtListHeaderItem({
field:ZmItem.F_ATTACHMENT,icon:"Attachment",width:ZmListView.COL_WIDTH_ICON,name:ZmMsg.attachment}
));
t.push(new DwtListHeaderItem({
field:ZmItem.F_SUBJECT,text:ZmMsg.subject,sortable:ZmItem.F_SUBJECT,resizeable:true,noRemove:true}
));
t.push(new DwtListHeaderItem({
field:ZmItem.F_STATUS,text:ZmMsg.status,width:ZmTaskListView.COL_WIDTH_STATUS,resizeable:true,sortable:ZmItem.F_STATUS}
));
t.push(new DwtListHeaderItem({
field:ZmItem.F_PCOMPLETE,text:ZmMsg.pComplete,width:ZmTaskListView.COL_WIDTH_PCOMPLETE,sortable:ZmItem.F_PCOMPLETE}
));
t.push(new DwtListHeaderItem({
field:ZmItem.F_DATE,text:ZmMsg.dateDue,width:ZmTaskListView.COL_WIDTH_DATE_DUE,sortable:ZmItem.F_DATE}
))
}else{
t.push(new DwtListHeaderItem({
field:ZmItem.F_SORTED_BY,text:AjxMessageFormat.format(ZmMsg.arrangedBy,ZmMsg.dateDue),sortable:ZmItem.F_SORTED_BY,resizeable:false}
))
}
return t
};
ZmTaskListView.prototype._createHeader=function(c,l,s,o,a,t,h){
if(s._field==ZmItem.F_SORTED_BY){
var r=s._field;
var n=this._itemCountTextTdId=DwtId._makeId(this.view,ZmSetting.RP_RIGHT,"td");
c[l++]="<td id='";
c[l++]=t;
c[l++]="' class='";
c[l++]=(t==this._currentColId)?"DwtListView-Column DwtListView-ColumnActive'":"DwtListView-Column'";
c[l++]=" width='auto'><table border=0 cellpadding=0 cellspacing=0 width='100%'><tr><td id='";
c[l++]=DwtId.getListViewHdrId(DwtId.WIDGET_HDR_LABEL,this._view,r);
c[l++]="' class='DwtListHeaderItem-label'>";
c[l++]=s._label;
c[l++]="</td>";
c[l++]="<td class='itemSortIcon' id='";
c[l++]=DwtId.getListViewHdrId(DwtId.WIDGET_HDR_ARROW,this._view,r);
c[l++]="'>";
c[l++]=AjxImg.getImageHtml(this._bSortAsc?"ColumnUpArrow":"ColumnDownArrow");
c[l++]="</td>";
c[l++]="<td align=right class='itemCountText' id='";
c[l++]=n;
c[l++]="'></td></tr></table></div></td>"
}else{
return DwtListView.prototype._createHeader.apply(this,arguments)
}};
ZmTaskListView.prototype.replenish=function(t){
this._list.addList(t);
this._renderList(this.getList(),true,false)
};
ZmTaskListView.prototype.checkTaskReplenishListView=function(){
this._controller._app._checkReplenishListView=this
};
ZmTaskListView.prototype._changeListener=function(u){
if((u.type!=this.type)&&(ZmList.MIXED!=this.type)){
return
}
var c=u.getDetail("items")||u.items;
c=AjxUtil.toArray(c);
if(u.event==ZmEvent.E_CREATE){
for(var s=0;
s<c.length;
s++){
var f=c[s];
var o=this._controller.getList().search.folderId;
if(appCtxt.getById(o)&&appCtxt.getById(o).isRemote()){
o=appCtxt.getById(o).getRemoteId()
}
if(appCtxt.isOffline){
o=ZmOrganizer.getSystemId(o)
}
if(o&&o!=f.folderId){
continue
}
if(this._list&&this._list.contains(f)){
continue
}
var m=this._list&&this._list.size()>0?1:null;
if(!this._list){
this._list=new AjxVector()
}
if(this._list.size()==0){
this._resetList()
}
this._list.add(f,m);
this._renderList(this.getList(),true,false);
if(this._list&&this._list.size()==1){
this.setSelection(this._list.get(0))
}}}else{
if(u.event==ZmEvent.E_MODIFY){
var n=c[0];
var t=this._getElFromItem(n);
if(t){
var a=this._selectedItems.contains(t);
this._createItemHtml(n,{
div:t,bContained:a}
);
this.associateItemWithElement(n,t);
if(this._controller.isReadingPaneOn()){
n.message=null;
n.getDetails(ZmCalItem.MODE_EDIT,new AjxCallback(this._controller,this._controller._showTaskReadOnlyView,n))
}
this.checkTaskReplenishListView()
}}else{
if(u.event==ZmEvent.E_DELETE||u.event==ZmEvent.E_MOVE){
var d=false;
for(var s=0,h=c.length;
s<h;
s++){
var f=c[s];
var l=f.type==ZmId.ITEM_CONV?f.folders[this._folderId]:f.folderId==this._folderId;
if(l&&u.event==ZmEvent.E_MOVE){
if(this._getRowIndex(f)===null){
this.addItem(f);
d=true
}}else{
this.removeItem(f,true,u.batchMode);
var r=this.getItemList();
if(u.event!=ZmEvent.E_MOVE||!r.isCanonical){
r.remove(f)
}}}
if(d){
this.checkTaskReplenishListView()
}
this._controller._resetToolbarOperations();
if(this._controller.isReadingPaneOn()){
this._controller.getTaskMultiView().getTaskView().reset()
}}else{
ZmListView.prototype._changeListener.call(this,u)
}}}
if(u.event==ZmEvent.E_MOVE){
var o=this._controller._folderId||this.folderId||this._folderId;
for(var s=0;
s<c.length;
s++){
var f=c[s];
if(f&&f.folderId==o&&this._getRowIndex(f)===null){
this.addItem(f,null,true)
}}}
if(u.event==ZmEvent.E_CREATE||u.event==ZmEvent.E_DELETE||u.event==ZmEvent.E_MOVE){
this._resetColWidth()
}};
ZmTaskListView._handleOnClick=function(i){
var a=window.parentAppCtxt||window.appCtxt;
var t=a.getApp(ZmApp.TASKS).getTaskListController().getCurrentView();
t._handleNewTaskClick(i)
};
ZmTaskListView._handleOnBlur=function(t){
var i=window.parentAppCtxt||window.appCtxt;
var a=i.getApp(ZmApp.TASKS).getTaskListController().getCurrentView();
a.saveNewTask()
};
ZmTaskListView.prototype._selectItem=function(i,t,o){
if(!i){
var a=(this._kbAnchor)?this._getSiblingElement(this._kbAnchor,i):this._parentEl.firstChild;
if(a&&a.id=="_newTaskBannerId"){
document.getElementById(this.dId).onclick();
return
}}
DwtListView.prototype._selectItem.call(this,i,t,o)
};
ZmTaskListView._handleKeyPress=function(i){
var a=DwtKeyEvent.getCharCode(i);
var n=window.parentAppCtxt||window.appCtxt;
var o=n.getApp(ZmApp.TASKS).getTaskListController().getCurrentView();
if(a==DwtKeyEvent.KEY_ENTER){
o.saveNewTask(true)
}else{
var t=(!AjxEnv.isIE)?(i.charCode==0&&i.keyCode==40):false;
if(a==DwtKeyEvent.KEY_ESCAPE||t){
o.discardNewTask()
}}};
ZmTaskListView.prototype.isMultiColumn=function(a){
var t=a||this._controller;
return !t.isReadingPaneOnRight()
};
ZmTaskListView.prototype.updateListViewEl=function(t){
var i=this._getElFromItem(t);
if(i){
var a=this._selectedItems.contains(i);
this._createItemHtml(t,{
div:i,bContained:a}
);
this.associateItemWithElement(t,i)
}};
ZmTaskListView.prototype.reRenderListView=function(){
var a=this.isMultiColumn();
if(a!=this._isMultiColumn){
this._saveState({
selection:true,focus:true,scroll:true,expansion:true}
);
this._isMultiColumn=a;
this.headerColCreated=false;
this._headerList=this._getHeaderList();
this._rowHeight=null;
this._normalClass=a?DwtListView.ROW_CLASS:ZmTaskListView.ROW_DOUBLE_CLASS;
var t=this.getList()||(new AjxVector());
this.set(t.clone());
this._restoreState()
}};
ZmTaskListView.prototype.resetSize=function(i,a){
this.setSize(i,a);
var t=(a==Dwt.DEFAULT)?a:a-DwtListView.HEADERITEM_HEIGHT;
Dwt.setSize(this._parentEl,i,t);
this._resetInputSize()
};
ZmTaskListView.prototype._resetColWidth=function(){
if(!this.headerColCreated){
return
}
var a=this._getLastColumnIndex();
if(a){
var t=this._headerList[a];
if(t._field!=ZmItem.F_SORTED_BY){
DwtListView.prototype._resetColWidth.apply(this,arguments)
}}};
ZmTaskListView.prototype._resetInputSize=function(t){
if(this._newTaskInputEl){
t=t||document.getElementById(this.dId);
if(t){
var a=Dwt.getBounds(t);
Dwt.setBounds(this._newTaskInputEl,a.x,a.y,a.width,a.height)
}}}
}}
if(AjxPackage.define("tasks.Tasks")){
AjxTemplate.register("tasks.Task#TaskDetailsDialog",function(a,s,n,t){
var o=Boolean(t);
n=(typeof n=="string"?{
id:n}
:n)||{};
t=t||[];
var i=t.length;
t[i++]="<table cellpadding=0 cellspacing=5 border=0><tr valign='center'><td class='LabelColName'>";
t[i++]=ZmMsg.icsLabel;
t[i++]="</td><td class='LabelColValue'><a href=\"";
t[i++]=n.icsUrl;
t[i++]='" target="_blank">';
t[i++]=n.icsUrl;
t[i++]="</a></td></tr></table>";
return o?t.length:t.join("")
}
,{
id:"tasks.Task#TaskDetailsDialog"}
,false);
AjxTemplate.register("tasks.Task",AjxTemplate.getTemplate("tasks.Task#TaskDetailsDialog"),AjxTemplate.getParams("tasks.Task#TaskDetailsDialog"));
AjxTemplate.register("tasks.Tasks#ReadOnlyView",function(a,s,n,t){
var o=Boolean(t);
n=(typeof n=="string"?{
id:n}
:n)||{};
t=t||[];
var i=t.length;
t[i++]="<div class='MsgHeaderTable'><div class='SubjectCol LabelColValue' style=\"margin-left: 5px;\" id='zv__TKV__";
t[i++]=Dwt.getNextId();
t[i++]="__su'>";
t[i++]=n.subject;
t[i++]="</div><table border=0  id='";
t[i++]=n.id;
t[i++]='_hdrTable\' cellspacing=0 cellpadding=10 style="margin-left: 5px;">';
if(n.location){
t[i++]=AjxTemplate.expand("tasks.Tasks#AddEntry",{
lbl:ZmMsg.location,val:n.location,id:"__lo"}
)
}
if(n.startDate){
t[i++]=AjxTemplate.expand("tasks.Tasks#AddEntry",{
lbl:ZmMsg.startDate,val:n.startDate,id:"__sd"}
)
}
if(n.dueDate){
t[i++]=AjxTemplate.expand("tasks.Tasks#AddEntry",{
lbl:ZmMsg.dueDate,val:n.dueDate,id:"__ed"}
)
}
if(n.priority){
t[i++]=AjxTemplate.expand("tasks.Tasks#AddEntry",{
lbl:ZmMsg.priority,val:n.priority,id:"__pr"}
)
}
if(n.status){
t[i++]=AjxTemplate.expand("tasks.Tasks#AddEntry",{
lbl:ZmMsg.status,val:n.status,id:"__st"}
)
}
if(n.pComplete){
t[i++]=AjxTemplate.expand("tasks.Tasks#AddEntry",{
lbl:ZmMsg.completed,val:n.pComplete+"%",id:"__pc"}
)
}
if(n.alarm){
t[i++]=AjxTemplate.expand("tasks.Tasks#ReminderEntry",{
lbl:ZmMsg.reminder,val1:n.remindDate,val2:n.remindTime,id:"__al"}
)
}
t[i++]="<!-- exception warning -->";
if(n.isException){
t[i++]="<tr valign='center'><td colspan=100><table border=0><tr><td>";
t[i++]=AjxImg.getImageHtml("ApptException");
t[i++]="</td><td><b>";
t[i++]=ZmMsg.apptExceptionNote;
t[i++]="</b></td></tr></table></td></tr>"
}
if(n.attachStr){
t[i++]=AjxTemplate.expand("tasks.Tasks#AddEntry",{
lbl:ZmMsg.attachments,val:n.attachStr}
)
}
t[i++]="</table></div>";
return o?t.length:t.join("")
}
,{
id:"tasks.Tasks#ReadOnlyView"}
,false);
AjxTemplate.register("tasks.Tasks#AddEntry",function(a,s,n,t){
var o=Boolean(t);
n=(typeof n=="string"?{
id:n}
:n)||{};
t=t||[];
var i=t.length;
t[i++]="<tr id='zv__TKV__";
t[i++]=Dwt.getNextId();
t[i++]=n.id;
t[i++]="'><td class='LabelColName' style='padding-left:2px;' >";
t[i++]=AjxMessageFormat.format(ZmMsg.makeLabel,AjxStringUtil.htmlEncode(n.lbl));
t[i++]=" </td><td class='LabelColValue'>";
t[i++]=n.val;
t[i++]="</td></tr>";
return o?t.length:t.join("")
}
,{
id:"tasks.Tasks#AddEntry"}
,false);
AjxTemplate.register("tasks.Tasks#ReminderEntry",function(a,s,n,t){
var o=Boolean(t);
n=(typeof n=="string"?{
id:n}
:n)||{};
t=t||[];
var i=t.length;
t[i++]="<tr id='zv__TKV__";
t[i++]=Dwt.getNextId();
t[i++]=n.id;
t[i++]="'><td class='LabelColName' style='padding-left:2px;'>";
t[i++]=AjxMessageFormat.format(ZmMsg.makeLabel,AjxStringUtil.htmlEncode(n.lbl));
t[i++]=" </td><td class='LabelColValue'>";
t[i++]=n.val1;
t[i++]=" @ ";
t[i++]=n.val2;
t[i++]="</td></tr>";
return o?t.length:t.join("")
}
,{
id:"tasks.Tasks#ReminderEntry"}
,false)
};
