
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
AjxDispatcher=function(){};
AjxDispatcher._registry={};
AjxDispatcher._package={};
AjxDispatcher._preLoad=[];
AjxDispatcher._postLoad=[];
AjxDispatcher._loadFunctionsEnabled=false;
AjxDispatcher._timedAction=null;
AjxDispatcher.addPackageLoadFunction=function(e,a){
var t=AjxDispatcher._getPackageData(e);
if(!t._loaded&&!AjxPackage.isDefined(e)){
t.callback.push(a)
}else{
AjxTimedAction.scheduleAction(new AjxTimedAction(a,a.run),0)
}};
AjxDispatcher.addPreLoadFunction=function(e){
AjxDispatcher._preLoad.push(e)
};
AjxDispatcher.addPostLoadFunction=function(e){
AjxDispatcher._postLoad.push(e)
};
AjxDispatcher.setPackageLoadFunction=AjxDispatcher.addPackageLoadFunction;
AjxDispatcher.setPreLoadFunction=AjxDispatcher.addPreLoadFunction;
AjxDispatcher.setPostLoadFunction=AjxDispatcher.addPostLoadFunction;
AjxDispatcher.enableLoadFunctions=function(e){
AjxDispatcher._loadFunctionsEnabled=e
};
AjxDispatcher.loaded=function(e){
var t=AjxDispatcher._getPackageData(e);
return(t&&t._loaded)||AjxPackage.isDefined(e)
};
AjxDispatcher.setLoaded=function(t,e){
var n=AjxDispatcher._getPackageData(t);
n._loaded=e;
if(e){
var o=n.callback||[];
for(var a=0;
a<o.length;
a++){
o[a].run()
}}};
AjxDispatcher.registerMethod=function(a,e,t){
AjxDispatcher._registry[a]={
pkg:e,callback:t}
};
AjxDispatcher.run=function(o){
if(!o){
return
}
var e,a,t,l,h;
if(typeof(o)=="string"){
e=o;
t=false;
h=false
}else{
e=o.method;
a=o.noLoad;
l=o.callback;
t=o.async!=null?o.async:Boolean(l);
h=o.preLoadOk!=null?o.preLoadOk:(l!=null)
}
var c=AjxDispatcher._registry[e];
if(!c){
AjxPackage.__log("API method '"+e+"' not found");
return
}
AjxPackage.__log("Run method: "+e);
var r=c.pkg;
var s=[];
for(var n=1;
n<arguments.length;
++n){
s.push(arguments[n])
}
if(l){
s.push(l)
}
return AjxDispatcher.require(r,t,c.callback,s,h)
};
AjxDispatcher.require=function(n,a,h,s,r){
if(!n){
return
}
if(typeof(n)=="string"){
n=[n]
}
var l=[];
for(var o=0;
o<n.length;
o++){
var t=n[o];
if(!AjxDispatcher._getPackageData(t)._loaded){
l.push(t)
}}
if(l.length==0){
return AjxDispatcher._postLoadCallback(n,false,h,s)
}else{
var e=AjxDispatcher._preLoad;
if(r&&AjxDispatcher._loadFunctionsEnabled&&e.length){
AjxPackage.__log("pre-load function");
AjxDispatcher._timedAction=new AjxCallback(null,AjxDispatcher._continueRequire,[l,a,h,s]);
for(var o=0;
o<e.length;
o++){
e[o].run()
}
window.setTimeout("AjxDispatcher._timedAction.run()",0)
}else{
return AjxDispatcher._continueRequire(l,a,h,s)
}}};
AjxDispatcher._continueRequire=function(s,e,c,r){
var l=s.join(", ");
AjxPackage.__log("------------------------------------- Loading package: "+l);
if(window.console&&window.console.log){
console.log("------------------------------------- Loading package: "+l)
}
if(e&&c){
var o=new AjxCallback(null,AjxDispatcher._postLoadCallback,[s,true,c,r]);
AjxPackage.require({
name:s,callback:o}
)
}else{
var n=new Date();
for(var a=0;
a<s.length;
a++){
AjxPackage.require(s[a])
}
var h=new Date();
var d=h.getTime()-n.getTime();
AjxPackage.__log("LOAD TIME for "+l+": "+d);
return AjxDispatcher._postLoadCallback(s,true,c,r)
}};
AjxDispatcher._postLoadCallback=function(r,n,l,h){
for(var a=0;
a<r.length;
a++){
AjxDispatcher._getPackageData(r[a])._loaded=true
}
for(var a=0;
a<r.length;
a++){
var e=AjxDispatcher._getPackageData(r[a]);
if(n&&e.callback.length&&!e.callbackDone){
e.callbackDone=true;
AjxPackage.__log("Running post-load package function for "+r[a]);
var s=e.callback;
for(var t=0;
t<s.length;
t++){
s[t].run()
}
e.callback.length=0
}}
if(n){
var o=AjxDispatcher._postLoad;
if(AjxDispatcher._loadFunctionsEnabled&&o.length){
for(var a=0;
a<o.length;
a++){
o[a].run()
}}}
if(l){
return l.run1(h)
}};
AjxDispatcher._getPackageData=function(e){
if(!AjxDispatcher._package[e]){
AjxDispatcher._package[e]={
callback:[]}
}
return AjxDispatcher._package[e]
};
