
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
AjxColor=function(a,t,e){
if(arguments.length==0){
return
}
this.r=a;
this.g=t;
this.b=e
};
AjxColor.prototype.toString=function(){
return AjxColor.color(this.r,this.g,this.b)
};
AjxColor.components=function(t){
var e=AjxColor.__RE.exec(t);
return e?[parseInt(e[1],16),parseInt(e[2],16),parseInt(e[3],16)]:null
};
AjxColor.color=function(a,t,e){
return["#",AjxColor.__pad(Number(Math.round(a)).toString(16),2),AjxColor.__pad(Number(Math.round(t)).toString(16),2),AjxColor.__pad(Number(Math.round(e)).toString(16),2)].join("")
};
AjxColor.lighten=function(e,a){
var t=AjxColor.components(e);
return t?AjxColor.color(AjxColor.__lighten(t[0],a),AjxColor.__lighten(t[1],a),AjxColor.__lighten(t[2],a)):""
};
AjxColor.darken=function(e,a){
var t=AjxColor.components(e);
return t?AjxColor.color(AjxColor.__darken(t[0],a),AjxColor.__darken(t[1],a),AjxColor.__darken(t[2],a)):""
};
AjxColor.deepen=function(e,a){
var s=AjxColor.components(e);
var t=0;
for(var o=1;
o<s.length;
o++){
if(s[o]>s[t]){
t=o
}}
for(var o=0;
o<s.length;
o++){
var n=s[t]?(s[o]/s[t]):1;
s[o]=Math.floor(s[o]*n*(a||1))
}
return AjxColor.color(s[0],s[1],s[2])
};
AjxColor.__RE=/^#([0-9a-f]{2})([0-9a-f]{2})([0-9a-f]{2})/i;
AjxColor.__pad=function(n,a,o){
if(!o){
o="0"
}
var t=String(n);
for(var e=t.length;
e<a;
e++){
t=o+t
}
return t
};
AjxColor.__lighten=function(e,t){
return Math.max(0,Math.min(255,e+(255-e)*t))
};
AjxColor.__darken=function(e,t){
return Math.max(0,Math.min(255,e+(1-e)*t))
};
