
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtIdleTimer=function(t,e){
DwtIdleTimer._initEvents();
this.timeout=t;
this.handler=e;
this.idle=false;
this._onIdle=AjxCallback.simpleClosure(this.setIdle,this);
this._startTimer();
DwtIdleTimer.getHandlers().add(this)
};
DwtIdleTimer.idleHandlers=0;
DwtIdleTimer.prototype.toString=function(){
return"DwtIdleTimer"
};
DwtIdleTimer.prototype.kill=function(){
this._stopTimer();
this.idle=false;
DwtIdleTimer.getHandlers().remove(this)
};
DwtIdleTimer.prototype.resurrect=function(e){
this.idle=false;
DwtIdleTimer.getHandlers().add(this,null,true);
if(e!=null){
this.timeout=e
}
this._startTimer()
};
DwtIdleTimer.prototype.setIdle=function(){
if(!this.idle){
DwtIdleTimer.idleHandlers++;
this.idle=true;
this.handler.run(true)
}};
DwtIdleTimer.prototype.resume=function(){
if(this.idle){
this.idle=false;
this.handler.run(false);
DwtIdleTimer.idleHandlers--
}};
DwtIdleTimer.prototype._startTimer=function(){
this._stopTimer();
this._timer=setTimeout(this._onIdle,this.timeout)
};
DwtIdleTimer.prototype._stopTimer=function(){
if(this._timer){
clearTimeout(this._timer);
this._timer=null
}};
DwtIdleTimer._initEvents=function(){
if(!DwtIdleTimer._initialized){
if(!AjxEnv.isIE){
window.addEventListener("keydown",DwtIdleTimer.resetIdle,true);
window.addEventListener("mousemove",DwtIdleTimer.resetIdle,true);
window.addEventListener("mousedown",DwtIdleTimer.resetIdle,true);
window.addEventListener("focus",DwtIdleTimer.resetIdle,true)
}else{
document.body.attachEvent("onkeydown",DwtIdleTimer.resetIdle);
document.body.attachEvent("onkeyup",DwtIdleTimer.resetIdle);
document.body.attachEvent("onmousedown",DwtIdleTimer.resetIdle);
document.body.attachEvent("onmousemove",DwtIdleTimer.resetIdle);
document.body.attachEvent("onmouseover",DwtIdleTimer.resetIdle);
document.body.attachEvent("onmouseout",DwtIdleTimer.resetIdle);
window.attachEvent("onfocus",DwtIdleTimer.resetIdle)
}
DwtIdleTimer._initialized=true
}};
DwtIdleTimer.getHandlers=function(){
var e=DwtIdleTimer.HANDLERS;
if(!e){
e=DwtIdleTimer.HANDLERS=new AjxVector()
}
return e
};
DwtIdleTimer.resetIdle=function(){
var e=DwtIdleTimer.getHandlers();
e.foreach("_startTimer");
if(DwtIdleTimer.idleHandlers>0){
e.foreach("resume")
}};
