
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtUiEvent=function(e){
if(arguments.length==0){
return
}
DwtEvent.call(this,true);
this.reset()
};
DwtUiEvent.prototype=new DwtEvent;
DwtUiEvent.prototype.constructor=DwtUiEvent;
DwtUiEvent.prototype.toString=function(){
return"DwtUiEvent"
};
DwtUiEvent.prototype.reset=function(){
this.dwtObj=null;
this.altKey=false;
this.ctrlKey=false;
this.metaKey=false;
this.shiftKey=false;
this.target=null;
this.type=null;
this.docX=-1;
this.docY=-1;
this.elementX=-1;
this.elementY=-1;
this.ersatz=false;
this._stopPropagation=false;
this._returnValue=true;
this._dontCallPreventDefault=false
};
DwtUiEvent.getEvent=function(t,a){
t=t||window.event;
if(t){
return t
}
if(a){
var e=(a.ownerDocument||a.document||a).parentWindow;
return e?e.event:null
}};
DwtUiEvent.getTarget=function(e,t){
e=DwtUiEvent.getEvent(e);
if(!e){
return null
}
if(!t){
if(e.target){
return(e.target.nodeType==3)?e.target.parentNode:e.target
}else{
if(e.srcElement){
return e.srcElement
}}}else{
if(e.relatedTarget){
return e.relatedTarget
}else{
if(e.toElement){
return e.toElement
}else{
if(e.fromElement){
return e.fromElement
}}}}
return null
};
DwtUiEvent.getTargetWithProp=function(e,o,i){
var a=DwtUiEvent.getTarget(e,i);
while(a){
var t=Dwt.getAttr(a,o);
if(t!=null&&t!==""){
return a
}
a=a.parentNode
}
return null
};
DwtUiEvent.getTargetWithProps=function(o,a){
var n=DwtUiEvent.getTarget(o);
while(n){
var t=true;
for(var e in a){
var s=Dwt.getAttr(n,a[e]);
if(s==null||s===""){
n=n.parentNode;
t=false;
break
}}
if(t){
return n
}}
return null
};
DwtUiEvent.copy=function(e,t){
e.altKey=t.altKey;
e.ctrlKey=t.ctrlKey;
e.metaKey=t.metaKey;
e.shiftKey=t.shiftKey;
e.target=t.target;
e.type=t.type;
e.dwtObj=t.dwtObj;
e.docX=t.docX;
e.docY=t.docY;
e.elementX=t.elementX;
e.elementY=t.elementY;
e.ersatz=t.ersatz;
e._stopPropagation=t._stopPropagation;
e._returnValue=t._returnValue
};
DwtUiEvent.prototype.setFromDhtmlEvent=function(t,a){
t=DwtUiEvent.getEvent(t);
if(!t){
return
}
this.altKey=t.altKey;
this.ctrlKey=t.ctrlKey;
this.metaKey=t.metaKey;
this.shiftKey=t.shiftKey;
this.type=t.type;
this.target=DwtUiEvent.getTarget(t);
this.dwtObj=(a===true)?DwtControl.getTargetControl(t):a;
if(t.pageX!=null){
this.docX=t.pageX;
this.docY=t.pageY
}else{
if(t.clientX!=null){
this.docX=t.clientX+document.body.scrollLeft-document.body.clientLeft;
this.docY=t.clientY+document.body.scrollTop-document.body.clientTop;
if(document.body.parentElement){
var e=document.body.parentElement;
this.docX+=e.scrollLeft-e.clientLeft;
this.docY+=e.scrollTop-e.clientTop
}}}
if(t.offsetX!=null){
this.elementX=t.offsetX;
this.elementY=t.offsetY
}else{
if(t.layerX!=null){
this.elementX=t.layerX;
this.elementY=t.layerY
}else{
this.elementX=Dwt.DEFAULT;
this.elementY=Dwt.DEFAULT
}}
this.ersatz=false;
return t
};
DwtUiEvent.prototype.setToDhtmlEvent=function(e){
DwtUiEvent.setBehaviour(e,this._stopPropagation,this._returnValue,this._dontCallPreventDefault)
};
DwtUiEvent.setBehaviour=function(o,e,t,a){
var i=DwtUiEvent.getEvent(o);
DwtUiEvent.setDhtmlBehaviour(i,e,t,a)
};
DwtUiEvent.setDhtmlBehaviour=function(i,e,t,a){
i=i||window.event;
if(i.stopPropagation!=null){
if(e){
i.stopPropagation()
}
if(!t&&!a){
i.preventDefault()
}}else{
i.returnValue=t;
i.cancelBubble=e
}};
DwtUiEvent.getDwtObjFromEvent=function(e,a){
var t=DwtUiEvent.getTargetWithProp(e,"dwtObj",a);
return t?Dwt.getObjectFromElement(t):null
};
DwtUiEvent.getDwtObjWithProp=function(e,a){
var t=DwtUiEvent.getTargetWithProps(e,["dwtObj",a]);
return t?Dwt.getObjectFromElement(t):null
};
