
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtAccordion=function(a,t,e){
if(arguments.length==0){
return
}
DwtComposite.call(this,{
parent:a,className:t,posStyle:(e||Dwt.ABSOLUTE_STYLE)}
);
this._initialize(t)
};
DwtAccordion.prototype=new DwtComposite;
DwtAccordion.prototype.constructor=DwtAccordion;
DwtAccordion.prototype.toString=function(){
return"DwtAccordion"
};
DwtAccordion.prototype.addAccordionItem=function(s){
if(!this.isListenerRegistered(DwtEvent.CONTROL)){
this.addControlListener(new AjxListener(this,this._controlListener))
}
var n=this.__ITEMCOUNT++;
var i=new DwtAccordionItem(n,s.title,s.data,this);
var t={
id:this._htmlElId,itemNum:n,title:s.title,icon:s.icon};
var o=this._table.insertRow(-1);
var e=o.insertCell(-1);
e.id=this._htmlElId+"_cell_"+n;
e.className="ZAccordionCell";
e.innerHTML=AjxTemplate.expand("dwt.Widgets#ZAccordionItem",t);
var a=document.getElementById(this._htmlElId+"_header_"+n);
if(s.hideHeader){
Dwt.setVisible(a,false)
}else{
a.onclick=AjxCallback.simpleClosure(this._handleOnClickHeader,this,i);
a.oncontextmenu=AjxCallback.simpleClosure(this._handleOnRightClickHeader,this,i);
a.onmouseover=AjxCallback.simpleClosure(this._handleOnMouseoverHeader,this,i);
a.onmouseout=AjxCallback.simpleClosure(this._handleOnMouseoutHeader,this,i)
}
this._items.push(i);
return i
};
DwtAccordion.prototype.getItems=function(){
return this._items
};
DwtAccordion.prototype.getItem=function(t){
for(var e=0;
e<this._items.length;
e++){
if(this._items[e].id==t){
return this._items[e]
}}
return null
};
DwtAccordion.prototype.getItemByIndex=function(e){
return(e>=0&&e<this._items.length)?this._items[e]:null
};
DwtAccordion.prototype.hideAccordionItems=function(){
for(var e=0;
e<this._items.length;
e++){
var t=document.getElementById(this._htmlElId+"_header_"+this._items[e].id);
if(t){
Dwt.setVisible(t,false)
}}};
DwtAccordion.prototype.showAccordionItem=function(t){
var e=document.getElementById(this._htmlElId+"_header_"+t);
if(e){
Dwt.setVisible(e,true)
}};
DwtAccordion.prototype.setEnabled=function(e){
if(e==this._enabled){
return
}
this._enabled=e;
for(var t in this._items){
var a=this._items[t];
if(this._currentItemId!=a.id){
a._setEnabled(e)
}}};
DwtAccordion.prototype.resize=function(o,d){
if(o){
for(var n=0;
n<this._items.length;
n++){
var t=this._items[n].id;
var l=document.getElementById(this._htmlElId+"_title_"+t);
var a=30;
var r=document.getElementById(this._htmlElId+"_icon_"+t);
if(r&&r.className&&r.className!=""){
a+=16
}
Dwt.setSize(l,o-a)
}}
var e;
if(d){
var c=document.getElementById(this._htmlElId+"_header_"+this._currentItemId);
if(c){
var h=Dwt.getSize(c).y*this._getVisibleHeaderCount();
e=(d-h)
}}
var s=document.getElementById(this._htmlElId+"_body_"+this._currentItemId);
if(s){
Dwt.setSize(s,o,e);
if(s.firstChild){
Dwt.setSize(s.firstChild,o,e)
}}};
DwtAccordion.prototype.setBounds=function(t,i,a,e){
DwtComposite.prototype.setBounds.call(this,t,i,a,e);
this.resize(a,e)
};
DwtAccordion.prototype.getExpandedItem=function(){
return this._items[this._currentItemId||0]
};
DwtAccordion.prototype.expandItem=function(e,l){
var t;
for(var o=0;
o<this._items.length;
o++){
var r=this._items[o].id;
var n=document.getElementById(this._htmlElId+"_header_"+r);
var s=document.getElementById(this._htmlElId+"_body_"+r);
var h=document.getElementById(this._htmlElId+"_cell_"+r);
var a=document.getElementById(this._htmlElId+"_status_"+r);
if(e==r){
Dwt.setVisible(s,true);
n.className="ZAccordionHeader ZWidget ZSelected";
a.className="ImgAccordionOpened";
h.style.height="100%";
this._currentItemId=e;
t=this._items[o]
}else{
Dwt.setVisible(s,false);
n.className="ZAccordionHeader ZWidget";
a.className="ImgAccordionClosed";
h.style.height="0px"
}}
if(t&&l&&this.isListenerRegistered(DwtEvent.SELECTION)){
this.notifySelectionListeners(t)
}};
DwtAccordion.prototype.notifySelectionListeners=function(t){
var e=DwtShell.selectionEvent;
e.item=this;
e.detail=t;
this.notifyListeners(DwtEvent.SELECTION,e)
};
DwtAccordion.prototype.setItemContent=function(i,a){
var t=this.getBody(i);
if(t){
this._items[i].control=a;
a.reparentHtmlElement(t);
var e=a.getSize();
this.resize(e.x,e.y)
}};
DwtAccordion.prototype.getBody=function(e){
return document.getElementById(this._htmlElId+"_body_"+e)
};
DwtAccordion.prototype.getHeader=function(e){
return document.getElementById(this._htmlElId+"_header_"+e)
};
DwtAccordion.prototype.show=function(e){
var t=document.getElementById(this._htmlElId+"_div");
if(t){
Dwt.setVisible(t,e)
}};
DwtAccordion.prototype.addSelectionListener=function(e){
this.addListener(DwtEvent.SELECTION,e)
};
DwtAccordion.prototype.showAlert=function(a,e){
var t=document.getElementById(this._htmlElId+"_header_"+a);
if(e){
Dwt.delClass(t,null,"ZAlert")
}else{
Dwt.delClass(t,"ZAlert",null)
}};
DwtAccordion.prototype._initialize=function(){
this._items=[];
this.__ITEMCOUNT=0;
this.getHtmlElement().innerHTML=AjxTemplate.expand("dwt.Widgets#ZAccordion",{
id:this._htmlElId}
);
this._table=document.getElementById(this._htmlElId+"_accordion_table");
this._setMouseEventHdlrs()
};
DwtAccordion.prototype._getVisibleHeaderCount=function(){
var t=0;
for(var e=0;
e<this._items.length;
e++){
var a=document.getElementById(this._htmlElId+"_header_"+this._items[e].id);
if(a&&Dwt.getVisible(a)){
t++
}}
return t
};
DwtAccordion.prototype._handleOnClickHeader=function(t,e){
if(!this._enabled){
return
}
this.expandItem(t.id,true)
};
DwtAccordion.prototype._handleOnRightClickHeader=function(t,e){
e=e||window.event;
if(this.isListenerRegistered(DwtEvent.ONCONTEXTMENU)){
var a=DwtShell.selectionEvent;
DwtUiEvent.copy(a,e);
a.item=this;
a.detail=t;
this.notifyListeners(DwtEvent.ONCONTEXTMENU,a)
}};
DwtAccordion.prototype._handleOnMouseoverHeader=function(t,e){
e=e||window.event;
if(this.isListenerRegistered(DwtEvent.ONMOUSEOVER)){
var a=DwtShell.selectionEvent;
DwtUiEvent.copy(a,e);
a.item=this;
a.detail=t;
this.notifyListeners(DwtEvent.ONMOUSEOVER,a)
}};
DwtAccordion.prototype._handleOnMouseoutHeader=function(e){
this.setToolTipContent(null)
};
DwtAccordion.prototype._controlListener=function(a){
if(this.getScrollStyle()!=Dwt.CLIP){
return
}
var t=(a.oldWidth!=a.newWidth)?a.newWidth:null;
var e=(a.oldHeight!=a.newHeight)?a.newHeight:null;
if((!t&&!e)||a.newWidth<0||a.newHeight<0){
return
}
this.resize(t,e)
};
DwtAccordionItem=function(i,a,t,e){
this.id=i;
this.title=a;
this.data=t;
this.accordion=e
};
DwtAccordionItem.prototype.toString=function(){
return"DwtAccordionItem"
};
DwtAccordionItem.prototype.setIcon=function(e){
var t=document.getElementById(this.accordion._htmlElId+"_icon_"+this.id);
if(t){
t.className=e
}};
DwtAccordionItem.prototype.getIconCell=function(){
return document.getElementById(this.accordion._htmlElId+"_icon_"+this.id)
};
DwtAccordionItem.prototype.setTitle=function(t){
var e=document.getElementById(this.accordion._htmlElId+"_title_"+this.id);
if(e){
e.innerHTML=t
}};
DwtAccordionItem.prototype._setEnabled=function(a){
var t=document.getElementById(this.accordion._htmlElId+"_title_"+this.id);
if(t){
if(a){
Dwt.delClass(t,"ZDisabled")
}else{
Dwt.addClass(t,"ZDisabled")
}}
var e=document.getElementById(this.accordion._htmlElId+"_status_"+this.id);
if(e){
if(a){
Dwt.delClass(e,"ZDisabledImage ZDisabled")
}else{
Dwt.addClass(e,"ZDisabledImage ZDisabled")
}}};
