
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtHoverMgr=function(){
this._hoverOverAction=new AjxTimedAction(this,this._notifyHoverOver);
this._hoverOutAction=new AjxTimedAction(this,this._notifyHoverOut);
this._ignoreHoverOverOnClickAction=new AjxTimedAction(this,this._resetIgnoreHoverOverOnClick)
};
DwtHoverMgr.prototype._hoverObject;
DwtHoverMgr.prototype._hoverOverDelay=750;
DwtHoverMgr.prototype._hoverOverData;
DwtHoverMgr.prototype._hoverOverAction;
DwtHoverMgr.prototype._hoverOverActionId=-1;
DwtHoverMgr.prototype._hoverOverListener;
DwtHoverMgr.prototype._hoverOutDelay=50;
DwtHoverMgr.prototype._ignoreHoverOverOnClickDelay=750;
DwtHoverMgr.prototype._hoverOutData;
DwtHoverMgr.prototype._hoverOutAction;
DwtHoverMgr.prototype._hoverOutActionId=-1;
DwtHoverMgr.prototype._hoverOutListener;
DwtHoverMgr.prototype._isHovering=false;
DwtHoverMgr.prototype.setHoverObject=function(e){
this._hoverObject=e
};
DwtHoverMgr.prototype.getHoverObject=function(){
return this._hoverObject
};
DwtHoverMgr.prototype.reset=function(){
this._hoverObject=null;
this._hoverOverDelay=DwtHoverMgr.prototype._hoverOverDelay;
this._hoverOverData=null;
if(this._hoverOverActionId!=-1){
AjxTimedAction.cancelAction(this._hoverOverActionId)
}
this._hoverOverActionId=-1;
this._hoverOverListener=null;
this._hoverOutDelay=DwtHoverMgr.prototype._hoverOutDelay;
this._hoverOutData=null;
if(this._hoverOutActionId!=-1){
AjxTimedAction.cancelAction(this._hoverOutActionId);
this._notifyHoverOut()
}
this._hoverOutActionId=-1;
this._hoverOutListener=null
};
DwtHoverMgr.prototype.isHovering=function(){
return this._isHovering
};
DwtHoverMgr.prototype.setHoverOverDelay=function(e){
this._hoverOverDelay=e
};
DwtHoverMgr.prototype.setHoverOverData=function(e){
this._hoverOverData=e
};
DwtHoverMgr.prototype.setHoverOverListener=function(e){
this._hoverOverListener=e
};
DwtHoverMgr.prototype.setHoverOutDelay=function(e){
this._hoverOutDelay=e
};
DwtHoverMgr.prototype.setHoverOutData=function(e){
this._hoverOutData=e
};
DwtHoverMgr.prototype.setHoverOutListener=function(e){
this._hoverOutListener=e
};
DwtHoverMgr.prototype.ignoreHoverOverOnClick=function(){
this._ignoreHoverOverOnClick=true;
AjxTimedAction.scheduleAction(this._ignoreHoverOverOnClickAction,this._ignoreHoverOverOnClickDelay)
};
DwtHoverMgr.prototype._resetIgnoreHoverOverOnClick=function(){
this._ignoreHoverOverOnClick=false
};
DwtHoverMgr.prototype.hoverOver=function(e,t){
if(this._ignoreHoverOverOnClick){
return
}
this._isHovering=true;
if(this._hoverOverActionId!=-1){
AjxTimedAction.cancelAction(this._hoverOverActionId)
}
this._hoverOverAction.args=[e,t];
this._hoverOverActionId=AjxTimedAction.scheduleAction(this._hoverOverAction,this._hoverOverDelay)
};
DwtHoverMgr.prototype.hoverOut=function(){
this._isHovering=false;
if(this._hoverOverActionId!=-1){
AjxTimedAction.cancelAction(this._hoverOverActionId)
}
if(this._hoverOutActionId==-1){
if(this._hoverOutDelay>0){
this._hoverOutActionId=AjxTimedAction.scheduleAction(this._hoverOutAction,this._hoverOutDelay)
}else{
this._notifyHoverOut()
}}};
DwtHoverMgr.prototype._notifyHoverOver=function(){
this._hoverOverActionId=-1;
if(this._hoverOverListener!=null){
var e=this._hoverOverAction.args[0];
var a=this._hoverOverAction.args[1];
var t=new DwtHoverEvent(DwtEvent.HOVEROVER,this._hoverOverDelay,this._hoverOverData,e,a);
this._hoverOverListener.handleEvent(t)
}};
DwtHoverMgr.prototype._notifyHoverOut=function(){
this._hoverOutActionId=-1;
if(this._hoverOutListener!=null){
var e=new DwtHoverEvent(DwtEvent.HOVEROUT,this._hoverOutDelay,this._hoverOutData);
this._hoverOutListener.handleEvent(e)
}};
