
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtListView=function(t){
if(arguments.length==0){
return
}
t=Dwt.getParams(arguments,DwtListView.PARAMS);
t.className=t.className||"DwtListView";
DwtComposite.call(this,t);
this._view=t.view||Dwt.getNextId();
if(t.headerList){
var e=this.getHtmlElement();
this._listColDiv=document.createElement("div");
this._listColDiv.id=DwtId.getListViewId(this._view,DwtId.LIST_VIEW_HEADERS);
this._listColDiv.className="DwtListView-ColHeader";
e.appendChild(this._listColDiv);
this._listDiv=document.createElement("div");
this._listDiv.id=DwtId.getListViewId(this._view,DwtId.LIST_VIEW_ROWS);
this._listDiv.className="DwtListView-Rows";
e.appendChild(this._listDiv);
this._bSortAsc=false;
this._currentColId=null;
this.sortingEnabled=true
}else{
this.setScrollStyle(DwtControl.SCROLL)
}
this._setMouseEventHdlrs();
this._listenerMouseOver=new AjxListener(this,this._mouseOverListener);
this._listenerMouseOut=new AjxListener(this,this._mouseOutListener);
this._listenerMouseDown=new AjxListener(this,this._mouseDownListener);
this._listenerMouseUp=new AjxListener(this,this._mouseUpListener);
this._listenerMouseMove=new AjxListener(this,this._mouseMoveListener);
this._listenerDoubleClick=new AjxListener(this,this._doubleClickListener);
this.addListener(DwtEvent.ONMOUSEOVER,this._listenerMouseOver);
this.addListener(DwtEvent.ONMOUSEOUT,this._listenerMouseOut);
this.addListener(DwtEvent.ONMOUSEDOWN,this._listenerMouseDown);
this.addListener(DwtEvent.ONMOUSEUP,this._listenerMouseUp);
this.addListener(DwtEvent.ONMOUSEMOVE,this._listenerMouseMove);
this.addListener(DwtEvent.ONDBLCLICK,this._listenerDoubleClick);
this._evtMgr=new AjxEventMgr();
this._selectedItems=new AjxVector();
this._selAnchor=null;
this._kbAnchor=null;
this._selEv=new DwtSelectionEvent(true);
this._actionEv=new DwtListViewActionEvent(true);
this._stateChangeEv=new DwtEvent(true);
this._headerList=t.headerList;
this._noMaximize=t.noMaximize;
this._parentEl=this._headerList?this._listDiv:this.getHtmlElement();
this._list=null;
this.offset=0;
this.headerColCreated=false;
this.multiSelectEnabled=true;
this.firstSelIndex=-1;
this._data={};
this._rowClass=[this._className,DwtListView.ROW_CLASS].join("");
var a=this._normalClass=DwtListView.ROW_CLASS;
this._selectedClass=[a,DwtCssStyle.SELECTED].join("-");
this._disabledSelectedClass=[this._selectedClass,DwtCssStyle.DISABLED].join("-");
this._kbFocusClass=[a,DwtCssStyle.FOCUSED].join("-");
this._dndClass=[a,DwtCssStyle.DRAG_PROXY].join("-");
this._rightClickClass=[this._selectedClass,DwtCssStyle.ACTIONED].join("-");
this._styleRe=this._getStyleRegex()
};
DwtListView.prototype=new DwtComposite;
DwtListView.prototype.constructor=DwtListView;
DwtListView.PARAMS=["parent","className","posStyle","headerList","noMaximize"];
DwtListView.ITEM_SELECTED=1;
DwtListView.ITEM_DESELECTED=2;
DwtListView.ITEM_DBL_CLICKED=3;
DwtListView._LAST_REASON=3;
DwtListView._TOOLTIP_DELAY=250;
DwtListView.HEADERITEM_HEIGHT=24;
DwtListView.TYPE_HEADER_ITEM="1";
DwtListView.TYPE_LIST_ITEM="2";
DwtListView.TYPE_HEADER_SASH="3";
DwtListView.DEFAULT_LIMIT=25;
DwtListView.MAX_REPLENISH_THRESHOLD=10;
DwtListView.MIN_COLUMN_WIDTH=20;
DwtListView.COL_MOVE_THRESHOLD=3;
DwtListView.ROW_CLASS="Row";
DwtListView.ROW_CLASS_ODD="RowEven";
DwtListView.ROW_CLASS_EVEN="RowOdd";
DwtListView._STYLE_CLASS="_sc";
DwtListView._SELECTED_STYLE_CLASS="_ssc";
DwtListView._SELECTED_DIS_STYLE_CLASS="_sdsc";
DwtListView._KBFOCUS_CLASS="_kfc";
DwtListView.prototype.toString=function(){
return"DwtListView"
};
DwtListView.prototype.dispose=function(){
this._listColDiv=null;
this._listDiv=null;
this._parentEl=null;
this._clickDiv=null;
this._selectedItems=null;
DwtComposite.prototype.dispose.call(this)
};
DwtListView.prototype.setEnabled=function(e){
DwtComposite.prototype.setEnabled.call(this,e);
this.removeListener(DwtEvent.ONMOUSEOVER,this._listenerMouseOver);
this.removeListener(DwtEvent.ONMOUSEOUT,this._listenerMouseOut);
this.removeListener(DwtEvent.ONMOUSEDOWN,this._listenerMouseDown);
this.removeListener(DwtEvent.ONMOUSEUP,this._listenerMouseUp);
this.removeListener(DwtEvent.ONMOUSEMOVE,this._listenerMouseMove);
this.removeListener(DwtEvent.ONDBLCLICK,this._listenerDoubleClick);
if(e){
this.addListener(DwtEvent.ONMOUSEOVER,this._listenerMouseOver);
this.addListener(DwtEvent.ONMOUSEOUT,this._listenerMouseOut);
this.addListener(DwtEvent.ONMOUSEDOWN,this._listenerMouseDown);
this.addListener(DwtEvent.ONMOUSEUP,this._listenerMouseUp);
this.addListener(DwtEvent.ONMOUSEMOVE,this._listenerMouseMove);
this.addListener(DwtEvent.ONDBLCLICK,this._listenerDoubleClick)
}
var a=this.getSelectedItems();
if(a){
var o=a.getArray();
for(var t=0;
t<o.length;
t++){
Dwt.delClass(o[t],this._styleRe,e?this._selectedClass:this._disabledSelectedClass)
}}};
DwtListView.prototype.createHeaderHtml=function(d){
if(!this._headerList||this.headerColCreated){
return
}
this._headerHash={};
this._headerIdHash={};
var u=0;
var f=[];
f[u++]="<table id='";
f[u++]=DwtId.getListViewHdrId(DwtId.WIDGET_HDR_TABLE,this._view);
f[u++]="' cellpadding=0 cellspacing=0 border=0 height=100%";
f[u++]=this._noMaximize?">":" width=100%>";
f[u++]="<tr>";
var o=this._headerList.length;
for(var s=0;
s<o;
s++){
var l=this._headerList[s];
var c=l._field;
l._index=s;
var t=l._id=DwtId.getListViewHdrId(DwtId.WIDGET_HDR,this._view,c);
this._headerHash[c]=l;
this._headerIdHash[t]=l;
if(l._variable){
this._variableHeaderCol=l
}
if(l._visible){
u=this._createHeader(f,u,l,s,o,t,d)
}}
f[u++]="</tr></table>";
this._listColDiv.innerHTML=f.join("");
var e=0,h;
for(var n=0;
n<this._headerList.length;
n++){
var l=this._headerList[n];
var m=document.getElementById(l._id);
if(!m){
continue
}
if(l._sortable&&l._field==d){
m.className="DwtListView-Column DwtListView-ColumnActive"
}
if(l._resizeable){
var r=DwtId.getListViewHdrId(DwtId.WIDGET_HDR_SASH,this._view,l._field);
var a=document.getElementById(r);
if(a){
this.associateItemWithElement(l,a,DwtListView.TYPE_HEADER_SASH,r,{
index:n}
)
}
e++;
h=l
}
this.associateItemWithElement(l,m,DwtListView.TYPE_HEADER_ITEM,l._id,{
index:n}
)
}
if(e==1){
h._resizeable=false
}
this.headerColCreated=true
};
DwtListView.prototype._createHeader=function(m,u,l,n,o,t,d){
var c=l._field;
m[u++]="<td id='";
m[u++]=t;
m[u++]="' class='";
var r=(t==this._currentColId)?"DwtListView-Column DwtListView-ColumnActive":"DwtListView-Column";
r+=l._sortable?"":" DwtDefaultCursor";
m[u++]=r+"'";
if(l._width){
m[u++]=" width=";
m[u++]=l._width;
if(l._widthUnits){
m[u++]=l._widthUnits
}}
m[u++]=">";
m[u++]="<div";
var s=null;
if(l._width&&l._width!="auto"){
if(AjxEnv.isIE){
s=l._width
}else{
s=l._width+2
}
if(l._widthUnits){
s+=l._widthUnits
}}
if(!!s){
m[u++]=" style='overflow: hidden; width: ";
m[u++]=s;
m[u++]="'>"
}else{
m[u++]=">"
}
m[u++]="<table border=0 cellpadding=0 cellspacing=0 width=100%><tr>";
if(l._iconInfo){
var h=["id='",DwtId.getListViewHdrId(DwtId.WIDGET_HDR_ICON,this._view,c),"'"].join("");
m[u++]="<td><center>";
m[u++]=AjxImg.getImageHtml(l._iconInfo,null,h);
m[u++]="</center></td>"
}
if(l._label){
m[u++]="<td id='";
m[u++]=DwtId.getListViewHdrId(DwtId.WIDGET_HDR_LABEL,this._view,c);
m[u++]="' class='DwtListHeaderItem-label'>";
m[u++]=l._label;
m[u++]="</td>"
}
if(l._sortable&&!l._noSortArrow){
var e=this._bSortAsc?"ColumnUpArrow":"ColumnDownArrow";
m[u++]="<td align=right style='padding-right:2px' width=100% id='";
m[u++]=DwtId.getListViewHdrId(DwtId.WIDGET_HDR_ARROW,this._view,c);
m[u++]="'>";
var a=(c==d);
m[u++]=AjxImg.getImageHtml(e,a?null:"visibility:hidden");
m[u++]="</td>";
if(a){
this._currentColId=t
}}
if(n<(o-1)){
m[u++]="<td width=6>";
m[u++]="<table align=right border=0 cellpadding=0 cellspacing=0 width=6 height=100% id='";
m[u++]=DwtId.getListViewHdrId(DwtId.WIDGET_HDR_SASH,this._view,c);
m[u++]="'><tr>";
m[u++]="<td class='DwtListView-Sash'><div style='width: 1px; height: ";
m[u++]=(DwtListView.HEADERITEM_HEIGHT-2);
m[u++]="px; background-color: #8A8A8A;margin-left:2px'></div></td><td class='DwtListView-Sash'><div style='width: 1px; height: ";
m[u++]=(DwtListView.HEADERITEM_HEIGHT-2);
m[u++]="px; background-color: #FFFFFF;margin-right:2px'></div></td></tr></table>";
m[u++]="</td>"
}
m[u++]="</tr></table>";
m[u++]="</div></td>";
return u
};
DwtListView.prototype.getItemIndex=function(a){
var o=this._list;
if(o){
var e=o.size();
for(var t=0;
t<e;
++t){
if(o.get(t).id==a.id){
return t
}}}
return null
};
DwtListView.prototype.setSize=function(t,e){
DwtComposite.prototype.setSize.call(this,t,e);
this._sizeChildren(e)
};
DwtListView.prototype.size=function(){
return this._list?this._list.size():0
};
DwtListView.prototype.set=function(a,t,e){
if(this._selectedItems){
this._selectedItems.removeAll()
}
this._rightSelItem=null;
this.sortingEnabled=true;
this._resetList();
this._list=a;
this.setUI(t,e)
};
DwtListView.prototype.setUI=function(t,e){
this.removeAll();
this.createHeaderHtml(t);
this._renderList(this._list,e)
};
DwtListView.prototype._renderList=function(r,s,a){
if(r instanceof AjxVector&&r.size()){
var t=new Date();
var c=r.size();
var h=[];
for(var n=0;
n<c;
n++){
var l=r.get(n);
var e=this._createItemHtml(l,{
now:t}
,!a,n);
if(e){
if(e instanceof Array){
for(var o=0;
o<e.length;
o++){
this._addRow(e[o])
}}else{
if(e.tagName||a){
this._addRow(e)
}else{
h.push(e)
}}}}
if(h.length){
this._parentEl.innerHTML=h.join("")
}}else{
if(!s){
this._setNoResultsHtml()
}}};
DwtListView.prototype.addItems=function(e){
if(AjxUtil.isArray(e)){
if(!this._list){
this._list=new AjxVector()
}
if(this._list.size()==0){
this._resetList()
}
this._renderList(AjxVector.fromArray(e),null,true);
this._list.addList(e)
}};
DwtListView.prototype.addItem=function(o,t,a,i){
if(!this._list){
this._list=new AjxVector()
}
if(this._list.size()==0){
this._resetList()
}
this._list.add(o,(i!=null)?i:t);
var n=this._createItemHtml(o);
if(n){
if(n instanceof Array){
for(var e=0;
e<n.length;
e++){
this._addRow(n[e])
}}else{
this._addRow(n,t)
}}
if(!a&&this._evtMgr.isListenerRegistered(DwtEvent.STATE_CHANGE)){
this._evtMgr.notifyListeners(DwtEvent.STATE_CHANGE,this._stateChangeEv)
}};
DwtListView.prototype.removeItem=function(a,t,i){
var e=this._getElFromItem(a);
if(!e){
return
}
var o=this._getRowIndex(a);
this._selectedItems.remove(e);
if(this._rightSelItem==e){
this._rightSelItem=null
}
if(this._kbAnchor==e){
this._kbAnchor=null
}
this._parentEl.removeChild(e);
if(this._list){
this._list.remove(a)
}
var n=e.id;
if(this._data[n]){
this._data[n]=null;
delete this._data[n]
}
if(!i){
this._fixAlternation(o)
}
if(!t&&this._evtMgr.isListenerRegistered(DwtEvent.STATE_CHANGE)){
this._evtMgr.notifyListeners(DwtEvent.STATE_CHANGE,this._stateChangeEv)
}};
DwtListView.prototype.redrawItem=function(o){
var n=this._getElFromItem(o);
if(n){
var s=this._createItemHtml(o);
n.parentNode.replaceChild(s,n);
var a=this.getSelectedItems().getArray();
for(var t=0;
t<a.length;
t++){
var e=a[t];
if(e===o){
this.setSelectedItems([].concat(a));
break
}}}};
DwtListView.prototype.addSelectionListener=function(e){
this._evtMgr.addListener(DwtEvent.SELECTION,e)
};
DwtListView.prototype.removeSelectionListener=function(e){
this._evtMgr.removeListener(DwtEvent.SELECTION,e)
};
DwtListView.prototype.addActionListener=function(e){
this._evtMgr.addListener(DwtEvent.ACTION,e)
};
DwtListView.prototype.removeActionListener=function(e){
this._evtMgr.removeListener(DwtEvent.ACTION,e)
};
DwtListView.prototype.addStateChangeListener=function(e){
this._evtMgr.addListener(DwtEvent.STATE_CHANGE,e)
};
DwtListView.prototype.removeStateChangeListener=function(e){
this._evtMgr.removeListener(DwtEvent.STATE_CHANGE,e)
};
DwtListView.prototype.removeAll=function(e){
if(this._parentEl){
this._parentEl.innerHTML=""
}
if(this._selectedItems){
this._selectedItems.removeAll()
}
this._rightSelItem=this._selAnchor=this._kbAnchor=null;
if(!e&&this._evtMgr.isListenerRegistered(DwtEvent.STATE_CHANGE)){
this._evtMgr.notifyListeners(DwtEvent.STATE_CHANGE,this._stateChangeEv)
}};
DwtListView.prototype.selectAll=function(){
if(this._list&&this._list.size()){
this.setSelectedItems(this._list.getArray())
}};
DwtListView.prototype.deselectAll=function(){
if(this._selectedItems){
var e=this._selectedItems.getArray();
var o=this._selectedItems.size();
for(var t=0;
t<o;
t++){
Dwt.delClass(e[t],this._styleRe)
}
this._selectedItems.removeAll();
this._rightSelItem=this._selAnchor=null;
if(this._kbAnchor!=null&&this.hasFocus()){
Dwt.addClass(this._kbAnchor,this._kbFocusClass)
}}};
DwtListView.prototype.getDnDSelection=function(){
if(this._dndSelection instanceof AjxVector){
return this.getSelection()
}else{
return this.getItemFromElement(this._dndSelection)
}};
DwtListView.prototype.getSelection=function(){
var t=[];
if(this._rightSelItem){
t.push(this.getItemFromElement(this._rightSelItem))
}else{
if(this._selectedItems){
var e=this._selectedItems.getArray();
var n=this._selectedItems.size();
for(var o=0;
o<n;
o++){
t[o]=this.getItemFromElement(e[o])
}}}
return t
};
DwtListView.prototype.getSelectedItems=function(){
return this._selectedItems
};
DwtListView.prototype.setSelection=function(a,e){
if(!a){
return
}
var t=this._getElFromItem(a);
if(t){
if((this._selectedItems.size()==1)&&(this._selectedItems.get(0)==t)){
return
}
this.deselectAll();
this._unmarkKbAnchorElement(true);
this._selAnchor=this._kbAnchor=t;
this.selectItem(a,this.getEnabled());
this.firstSelIndex=(this._list&&this._list.size()>0)?this._list.indexOf(a):-1;
this._scrollList(t);
if(!e&&this._evtMgr.isListenerRegistered(DwtEvent.SELECTION)){
var i=new DwtSelectionEvent(true);
i.button=DwtMouseEvent.LEFT;
i.target=t;
i.item=this.getItemFromElement(t);
i.detail=DwtListView.ITEM_SELECTED;
i.ersatz=true;
this._evtMgr.notifyListeners(DwtEvent.SELECTION,i)
}}};
DwtListView.prototype.setMultiSelection=function(e,o,a){
if(o){
this._selectedItems.remove(e);
Dwt.delClass(e,this._styleRe);
this._selEv.detail=DwtListView.ITEM_DESELECTED
}else{
this._selectedItems.add(e,null,true);
Dwt.delClass(e,this._styleRe,this._selectedClass);
this._selEv.detail=DwtListView.ITEM_SELECTED
}
if(this._kbAnchor&&this._kbAnchor!=e){
var i=this._kbAnchor;
var t=this._selectedClass;
if(i.className.indexOf(t)!=-1){
Dwt.delClass(i,this._styleRe,t)
}else{
Dwt.delClass(i,this._styleRe)
}}
this._selAnchor=this._kbAnchor=e;
Dwt.addClass(this._kbAnchor,this._kbFocusClass)
};
DwtListView.prototype.setSelectedItems=function(a){
this.deselectAll();
var o=a.length,e=this.getEnabled();
for(var t=0;
t<o;
++t){
this.selectItem(a[t],e)
}};
DwtListView.prototype.selectItem=function(a,t){
var e=this._getElFromItem(a);
if(e){
Dwt.delClass(e,this._styleRe,t?this._selectedClass:this._disabledSelectedClass);
if(this._kbAnchor==e&&this.hasFocus()){
Dwt.addClass(e,this._kbFocusClass)
}
this._selectedItems.add(e)
}};
DwtListView.prototype.getSelectionCount=function(){
return this._rightSelItem?1:this._selectedItems.size()
};
DwtListView.prototype.handleActionPopdown=function(){
this._clearRightSel()
};
DwtListView.prototype.associateItemWithElement=function(i,t,a,n,o){
n=n||this._getItemId(i);
if(t){
t.id=n
}
a=a||DwtListView.TYPE_LIST_ITEM;
this._data[n]={
item:i,id:n,type:a};
if(o){
for(var e in o){
this._data[n][e]=o[e]
}}
return n
};
DwtListView.prototype.getItemFromElement=function(e){
return this._getItemData(e,"item")
};
DwtListView.prototype.findItem=function(e){
if(!e){
return
}
var t=this.findItemDiv(e);
return this._getItemData(t,"item")
};
DwtListView.prototype.findItemDiv=function(e){
if(!e){
return
}
while(e&&(e.id!=this._htmlElId)){
if(e.id&&this._data[e.id]){
return e
}
e=e.parentNode
}
return null
};
DwtListView.prototype.getTargetItem=function(e){
return this.findItem(DwtUiEvent.getTarget(e))
};
DwtListView.prototype.getTargetItemDiv=function(e){
return this.findItemDiv(DwtUiEvent.getTarget(e))
};
DwtListView.prototype.dragSelect=function(t){
if(this._dragHighlight){
var e=document.getElementById(this._dragHighlight);
if(!t||(e&&(t.id!=e.id))){
this._updateDragSelection(e,false)
}}
if(!t){
return
}
if(this._getItemData(t,"type")!=DwtListView.TYPE_LIST_ITEM){
return
}
if(t.id!=this._dragHighlight){
this._dragHighlight=t.id;
this._updateDragSelection(t,true)
}};
DwtListView.prototype.dragDeselect=function(t){
if(this._dragHighlight){
var e=document.getElementById(this._dragHighlight);
this._updateDragSelection(e,false);
this._dragHighlight=null
}};
DwtListView.prototype.scrollToItem=function(t){
var e=this._getElFromItem(t);
if(e){
this._listDiv.scrollTop=e.offsetTop
}};
DwtListView.prototype.scrollToTop=function(){
this._listDiv.scrollTop=0
};
DwtListView.prototype.scrollPage=function(e){
var t=this._parentEl;
if(t.clientHeight>=t.scrollHeight){
return
}
t.scrollTop=e?Math.max(t.scrollTop-t.clientHeight,0):Math.min(t.scrollTop+t.clientHeight,t.scrollHeight-t.clientHeight)
};
DwtListView.prototype.setSortByAsc=function(a,t){
if(!this._headerList){
return
}
this._bSortAsc=t;
var o=null;
for(var e=0;
e<this._headerList.length;
e++){
if(this._headerList[e]._sortable&&this._headerList[e]._field==a){
o=this._headerList[e]._id;
break
}}
if(o){
this._setSortedColStyle(o)
}};
DwtListView.prototype.getNewOffset=function(t){
var e=this.getLimit();
var a=t?(this.offset+e):(this.offset-e);
return(a<0)?0:a
};
DwtListView.prototype.getLimit=function(){
return DwtListView.DEFAULT_LIMIT
};
DwtListView.prototype.getReplenishThreshold=function(){
return DwtListView.MAX_REPLENISH_THRESHOLD
};
DwtListView.prototype.getList=function(){
return this._list
};
DwtListView.prototype.replenish=function(o){
this._list.addList(o);
var t=o.size();
for(var e=0;
e<t;
e++){
var a=o.get(e);
var n=this._createItemHtml(a);
if(n){
this._addRow(n)
}}};
DwtListView.prototype.getKeyMapName=function(){
return"DwtListView"
};
DwtListView.prototype.handleKeyAction=function(n,h){
switch(n){
case DwtKeyMap.SELECT:this._emulateSingleClick({
target:this._kbAnchor,button:DwtMouseEvent.LEFT,kbNavEvent:true}
);
break;
case DwtKeyMap.SELECT_CURRENT:this._emulateSingleClick({
target:this._kbAnchor,button:DwtMouseEvent.LEFT,ctrlKey:true,kbNavEvent:true}
);
break;
case DwtKeyMap.SELECT_NEXT:this._selectItem(true,false,true);
break;
case DwtKeyMap.SELECT_PREV:this._selectItem(false,false,true);
break;
case DwtKeyMap.ADD_SELECT_NEXT:this._selectItem(true,true,true);
break;
case DwtKeyMap.ADD_SELECT_PREV:this._selectItem(false,true,true);
break;
case DwtKeyMap.PREV:this._setKbFocusElement(false);
break;
case DwtKeyMap.NEXT:this._setKbFocusElement(true);
break;
case DwtKeyMap.DBLCLICK:if(!this._kbAnchor){
break
}
var t=false;
var c=this.getSelectedItems().getArray();
for(var o=0;
o<c.length;
o++){
if(c[o]==this._kbAnchor){
t=true;
break
}}
if(t){
this.emulateDblClick(this.getItemFromElement(this._kbAnchor),true)
}else{
this._emulateSingleClick({
target:this._kbAnchor,button:DwtMouseEvent.LEFT,kbNavEvent:true}
)
}
break;
case DwtKeyMap.SELECT_ALL:this.selectAll();
break;
case DwtKeyMap.SELECT_FIRST:case DwtKeyMap.SELECT_LAST:var d=(n==DwtKeyMap.SELECT_FIRST)?this._getFirstItem():this._getLastItem();
if(d){
this.setSelection(d);
this._scrollList(this._kbAnchor)
}
break;
case DwtKeyMap.ACTION:if(this._evtMgr.isListenerRegistered(DwtEvent.ACTION)){
var e=Dwt.toWindow(this._kbAnchor,0,0);
var u=Dwt.getSize(this._kbAnchor);
var l=e.x+u.x/4;
var r=e.y+u.y/2;
this._emulateSingleClick({
target:this._kbAnchor,button:DwtMouseEvent.RIGHT,docX:l,docY:r,kbNavEvent:true}
)
}
break;
case DwtKeyMap.PAGE_UP:case DwtKeyMap.PAGE_DOWN:this.scrollPage(n==DwtKeyMap.PAGE_UP);
break;
default:return false
}
return true
};
DwtListView.prototype.setMultiSelect=function(e){
this.multiSelectEnabled=e
};
DwtListView.prototype.isMultiSelectEnabled=function(){
return this.multiSelectEnabled
};
DwtListView.prototype.setListDivHeight=function(a){
if(this._listDiv&&this._listColDiv){
var t=Dwt.getSize(this._listColDiv).y;
var e=a-t-10;
Dwt.setSize(this._listDiv,Dwt.DEFAULT,e)
}};
DwtListView.prototype._getStyleRegex=function(){
return new RegExp("\\b("+[this._disabledSelectedClass,this._selectedClass,this._kbFocusClass,this._dndClass,this._rightClickClass].join("|")+")\\b","g")
};
DwtListView.prototype._addRow=function(a,t){
if(!a||!this._parentEl){
return
}
var e=this._parentEl.childNodes.length;
if(t!=null&&e>0&&t!=e){
this._parentEl.insertBefore(a,this._parentEl.childNodes[t])
}else{
this._parentEl.appendChild(a)
}
this._fixAlternation((t!=null)?t:e)
};
DwtListView.prototype._fixAlternation=function(e){
var o=this._parentEl.childNodes;
if(!(o&&o.length)){
return
}
if(!(this._list&&this._list.size())){
return
}
var i=o[e];
if(!i){
return
}
var a=Boolean(e%2);
this._setAlternatingRowClass(i,a);
var t=i.nextSibling;
while(t){
a=!a;
this._setAlternatingRowClass(t,a);
t=t.nextSibling
}};
DwtListView.prototype._setAlternatingRowClass=function(i,e){
var t=e?DwtListView.ROW_CLASS_ODD:DwtListView.ROW_CLASS_EVEN;
var a=e?DwtListView.ROW_CLASS_EVEN:DwtListView.ROW_CLASS_ODD;
Dwt.delClass(i,t,a)
};
DwtListView.prototype._createItemHtml=function(l,a,n,o){
a=a||{};
this._addParams(l,a,h,r);
var e;
var h=[];
var r=0;
if(n){
r=this._getDivHtml(l,a,h,r,o)
}else{
e=a.div||this._getDiv(l,a)
}
r=this._getTable(h,r,a);
r=this._getRow(h,r,l,a);
var t=a.headerList||this._headerList;
if(t&&t.length){
for(var i=0;
i<t.length;
i++){
if(!t[i]._visible){
continue
}
var s=t[i]._field;
r=this._getCell(h,r,l,s,i,a)
}}else{
r=this._getCell(h,r,l,null,null,a)
}
h[r++]="</tr></table>";
if(n){
h[r++]="</div>";
return h.join("")
}
e.innerHTML=h.join("");
return e
};
DwtListView.prototype._addParams=function(e,t){};
DwtListView.prototype._getDiv=function(e,t){
var i=document.createElement("div");
if(t.isDragProxy&&AjxEnv.isMozilla){
i.style.overflow="visible"
}
i.className=this._getDivClass(t.divClass||this._normalClass,e,t);
if(t.isDragProxy){
Dwt.setPosition(i,Dwt.ABSOLUTE_STYLE)
}
var a=t.isDragProxy?this._getItemId(e)+"_dnd":null;
this.associateItemWithElement(e,i,null,a);
return i
};
DwtListView.prototype._getDivHtml=function(o,n,t,e,i){
t[e++]="<div class='";
t[e++]=this._getDivClass(n.divClass||this._normalClass,o,n);
t[e++]=" ";
t[e++]=(i%2)?DwtListView.ROW_CLASS_EVEN:DwtListView.ROW_CLASS_ODD;
t[e++]="'";
var a=[];
if(n.isDragProxy&&AjxEnv.isMozilla){
a.push("overflow:visible")
}
if(n.isDragProxy){
a.push("position:absolute")
}
if(a.length){
t[e++]=" style='";
t[e++]=a.join(";");
t[e++]="'"
}
var s=n.isDragProxy?this._getItemId(o)+"_dnd":null;
t[e++]=" id='";
t[e++]=this.associateItemWithElement(o,null,null,s);
t[e++]="'>";
return e
};
DwtListView.prototype._getDivClass=function(t,e,a){
return a.isDragProxy?([t," ",t,"-",DwtCssStyle.DRAG_PROXY].join("")):t
};
DwtListView.prototype._getTable=function(t,e,a){
t[e++]="<table cellpadding=0 cellspacing=0 border=0 width=";
t[e++]=!a.isDragProxy?"100%>":(this.getSize().x+">");
return e
};
DwtListView.prototype._getRow=function(t,e,i,n){
var o=this._getRowId(i,n)||Dwt.getNextId();
var a=this._getRowClass(i,n);
t[e++]=o?["<tr id='",o,"'"].join(""):"<tr";
t[e++]=a?([" class='",a,"'>"].join("")):">";
return e
};
DwtListView.prototype._getRowClass=function(e,t){
return null
};
DwtListView.prototype._getRowId=function(e,t){
return null
};
DwtListView.prototype._getCell=function(m,u,p,c,o,i){
var a=this._getCellId(p,c,i);
var d=a?[" id=","'",a,"'"].join(""):"";
var t=this._getCellWidth(o,i);
var r=t?([" width=",t].join("")):(" width='100%'");
var h=this._getCellClass(p,c,i);
var n=h?[" class=",h].join(""):"";
var f=this._getCellAlign(o,i);
var l=f?[" align=",f].join(""):"";
var e=(this._getCellAttrText(p,c,i))||"";
var s=[d,r,n,l,e].join(" ");
m[u++]="<td";
m[u++]=s?(" "+s):"";
m[u++]=">";
u=this._getCellContents(m,u,p,c,o,i);
m[u++]="</td>";
return u
};
DwtListView.prototype._getCellWidth=function(i,a){
if(i==null){
return null
}
var e=a.headerList||this._headerList;
var t=e[i]._width;
if(t){
if(AjxEnv.isIE){
return(t+2)
}
if(AjxEnv.isSafari&&!AjxEnv.isChrome19up){
return(t+5)
}
return t
}
return null
};
DwtListView.prototype._getCellAlign=function(a,t){
if(a==null){
return null
}
var e=t.headerList||this._headerList;
return e[a]._align
};
DwtListView.prototype._getCellId=function(e,t,a){
return null
};
DwtListView.prototype._getCellClass=function(e,t,a){
return null
};
DwtListView.prototype._getCellAttrText=function(e,t,a){
return null
};
DwtListView.prototype._getCellContents=function(t,e,a,i,n,o){
t[e++]=a.toString?a.toString():a;
return e
};
DwtListView.prototype._getFieldId=function(e,t){
return DwtId.getListViewItemId(DwtId.WIDGET_ITEM_FIELD,this._view,e.id,t)
};
DwtListView.prototype._getElement=function(e,t){
return document.getElementById(this._getFieldId(e,t))
};
DwtListView.prototype._getDragProxy=function(i){
var o=this.getDnDSelection();
if(!o){
return null
}
var s;
var e;
var t;
this._dndImg=null;
if(!(o instanceof Array)||o.length==1){
var h=(o instanceof Array)?o[0]:o;
s=this._createItemHtml(h,{
now:new Date(),isDragProxy:true}
);
this._setItemData(s,"origClassName",s.className);
Dwt.setPosition(s,Dwt.ABSOLUTE_STYLE);
t="position:absolute;top:18;left:-11;visibility:hidden"
}else{
s=document.createElement("div");
s.className="DragProxy";
Dwt.setPosition(s,Dwt.ABSOLUTE_STYLE);
AjxImg.setImage(s,"DndMultiYes_48");
this._dndImg=s;
e=document.createElement("div");
Dwt.setPosition(e,Dwt.ABSOLUTE_STYLE);
var r=this.allSelected?ZmMsg.all:o.length;
e.innerHTML="<table><tr><td class='DragProxyTextLabel'>"+r+"</td></tr></table>";
s.appendChild(e);
t="position:absolute;top:30;left:0;visibility:hidden";
Dwt.setBounds(s,Dwt.LOC_NOWHERE,Dwt.LOC_NOWHERE,43+32-16,36+32-20)
}
var a=AjxImg.getImageHtml("RoundPlus",t,"id="+DwtId.DND_PLUS_ID);
if(!this._noDndPlusImage){
s.appendChild(Dwt.parseHtmlFragment(a))
}
this.shell.getHtmlElement().appendChild(s);
if(e){
var n=Dwt.getSize(e);
Dwt.setLocation(e,16+(32-n.x)/2,19+(32-n.y)/2)
}
Dwt.setZIndex(s,Dwt.Z_DND);
return s
};
DwtListView.prototype._setDragProxyState=function(t){
if(this._dndImg){
AjxImg.setImage(this._dndImg,t?"DndMultiYes_48":"DndMultiNo_48")
}else{
if(this._dndProxy){
var a=t?DwtCssStyle.DROPPABLE:DwtCssStyle.NOT_DROPPABLE;
var e=this._getItemData(this._dndProxy,"origClassName");
this._dndProxy.className=[e,a].join(" ")
}}};
DwtListView.prototype._setNoResultsHtml=function(){
var t=document.createElement("div");
var e={
message:this._getNoResultsMessage(),type:this.type};
t.innerHTML=AjxTemplate.expand("dwt.Widgets#DwtListView-NoResults",e);
this._addRow(t)
};
DwtListView.prototype._getNoResultsMessage=function(){
return AjxMsg.noResults
};
DwtListView.prototype._clearRightSel=function(){
if(this._rightSelItem){
Dwt.delClass(this._rightSelItem,this._styleRe);
this._rightSelItem=null
}};
DwtListView.prototype._getItemId=function(e){
return DwtId.getListViewItemId(DwtId.WIDGET_ITEM,this._view,(e&&e.id)?e.id:Dwt.getNextId())
};
DwtListView.prototype._getElFromItem=function(e){
return Dwt.byId(this._getItemId(e))
};
DwtListView.prototype._getRowIndex=function(t){
var o=this._getItemId(t);
var a=this._parentEl.childNodes;
for(var e=0;
e<a.length;
e++){
if(a[e].id==o){
return e
}}
return null
};
DwtListView.prototype._getItemData=function(e,a,i){
i=i||(e?e.id:null);
var t=this._data[i];
return t?t[a]:null
};
DwtListView.prototype._setItemData=function(e,i,a,o){
o=o||(e?e.id:null);
var t=this._data[o];
if(t){
t[i]=a
}};
DwtListView.prototype._isValidDragObject=function(e){
return(this.getTargetItemDiv(e)!=null)
};
DwtListView.prototype._updateDragSelection=function(t,e){
if(!t){
return
}
if(!e){
t.className=this._getItemData(t,"origClassName")
}else{
this._setItemData(t,"origClassName",t.className);
Dwt.delClass(t,this._styleRe,this._dndClass)
}};
DwtListView.prototype._mouseOverAction=function(t,i){
var e=this._getItemData(i,"type");
if(e==DwtListView.TYPE_HEADER_ITEM){
var a=this.getItemFromElement(i);
if(a&&this.sortingEnabled&&a._sortable&&!this._headerClone){
i.className="DwtListView-Column DwtListView-ColumnHover"
}}else{
if(e==DwtListView.TYPE_HEADER_SASH){
i.style.cursor=AjxEnv.isIE?"col-resize":"e-resize"
}}
return true
};
DwtListView.prototype._mouseOutAction=function(t,i){
var e=this._getItemData(i,"type");
if(e==DwtListView.TYPE_HEADER_ITEM&&!this._headerClone){
i.className=(i.id!=this._currentColId)?"DwtListView-Column":"DwtListView-Column DwtListView-ColumnActive";
var a=this.getItemFromElement(i);
if(!a._sortable){
i.className+=" DwtDefaultCursor"
}}else{
if(e==DwtListView.TYPE_HEADER_SASH){
i.style.cursor="auto"
}}
return true
};
DwtListView.prototype._mouseOverListener=function(e){
var t=this.getTargetItemDiv(e);
if(!t){
return
}
this._mouseOverAction(e,t)
};
DwtListView.prototype._mouseOutListener=function(e){
var t=this.getTargetItemDiv(e);
if(!t){
return
}
this.setToolTipContent(null);
this._mouseOutAction(e,t)
};
DwtListView.prototype._mouseMoveListener=function(t){
if(!this._clickDiv){
return
}
var e=this._getItemData(this._clickDiv,"type");
if(e==DwtListView.TYPE_HEADER_ITEM){
this._handleColHeaderMove(t)
}else{
if(e==DwtListView.TYPE_HEADER_SASH){
this._handleColHeaderResize(t)
}}};
DwtListView.prototype._mouseDownListener=function(e){
var t=this.getTargetItemDiv(e);
if(!t){
this._dndSelection=null
}else{
this._clickDiv=t;
if(this._getItemData(t,"type")!=DwtListView.TYPE_LIST_ITEM){
this._dndSelection=null
}else{
this._dndSelection=(this._selectedItems.contains(t))?this._selectedItems:t
}}
this._mouseDownAction(e,t)
};
DwtListView.prototype._mouseUpListener=function(a){
var n=this.getTargetItemDiv(a);
var o=this._handleColHeaderDrop(a);
var e=this._handleColSashDrop(a);
if(!n||n!=this._clickDiv||o||e){
delete this._clickDiv;
this._mouseUpAction(a,n);
return
}
delete this._clickDiv;
var t=this._getItemData(n,"type");
if(this._headerList&&t==DwtListView.TYPE_HEADER_ITEM){
if(a.button==DwtMouseEvent.LEFT){
this._columnClicked(n,a)
}else{
if(a.button==DwtMouseEvent.RIGHT){
var i=this._getActionMenuForColHeader();
if(i&&i instanceof DwtMenu){
i.popup(0,a.docX,a.docY)
}}}}else{
if(t==DwtListView.TYPE_LIST_ITEM){
if(a.button==DwtMouseEvent.LEFT||a.button==DwtMouseEvent.RIGHT){
this._itemClicked(n,a)
}}}
this._mouseUpAction(a,n)
};
DwtListView.prototype._mouseDownAction=function(e,t){};
DwtListView.prototype._mouseUpAction=function(e,t){};
DwtListView.prototype._doubleClickAction=function(e,t){
return true
};
DwtListView.prototype._doubleClickListener=function(t){
var a=this.getTargetItemDiv(t);
if(!a){
return
}
var e=this._getItemData(a,"type");
if(e==DwtListView.TYPE_LIST_ITEM){
if(!this._doubleClickAction(t,a)){
return
}
if(this._evtMgr.isListenerRegistered(DwtEvent.SELECTION)){
DwtUiEvent.copy(this._selEv,t);
this._selEv.item=this.getItemFromElement(a);
this._selEv.detail=DwtListView.ITEM_DBL_CLICKED;
this._evtMgr.notifyListeners(DwtEvent.SELECTION,this._selEv)
}}};
DwtListView.prototype.emulateDblClick=function(e,t){
var i=document.getElementById(this._getItemId(e));
if(i){
var a=new DwtMouseEvent();
this._setMouseEvent(a,{
target:i,button:DwtMouseEvent.LEFT}
);
a.kbNavEvent=t;
this._itemClicked(i,a);
this._doubleClickListener(a)
}};
DwtListView.prototype._selectItem=function(a,e,i){
if(!this.size()){
return
}
var t=(this._kbAnchor)?this._getSiblingElement(this._kbAnchor,a):this._parentEl.firstChild;
this._scrollList(t);
this._emulateSingleClick({
target:t,button:DwtMouseEvent.LEFT,shiftKey:e,kbNavEvent:i}
)
};
DwtListView.prototype._getSiblingElement=function(e,a){
if(!e){
return null
}
var t=a?e.nextSibling:e.previousSibling;
while(this._hasHiddenRows&&t&&!Dwt.getVisible(t)){
t=a?t.nextSibling:t.previousSibling
}
return(!t||(this._hasHiddenRows&&!Dwt.getVisible(t)))?e:t
};
DwtListView.prototype._scrollList=function(e){
DwtControl._scrollIntoView(e,e.parentNode)
};
DwtListView.prototype._setRowHeight=function(){
if(!this._rowHeight){
var e=this._parentEl.firstChild;
this._rowHeight=e&&Dwt.getSize(e).y
}};
DwtListView.prototype._emulateSingleClick=function(e){
this._clickDiv=this.findItemDiv(e.target);
var t=new DwtMouseEvent();
this._setMouseEvent(t,e);
t.kbNavEvent=e.kbNavEvent;
this.notifyListeners(DwtEvent.ONMOUSEUP,t)
};
DwtListView.prototype._setKbFocusElement=function(e){
if(!this._list){
return
}
var a=this._kbAnchor;
if(e&&e!==true){
this._kbAnchor=e
}else{
if(this._kbAnchor){
this._kbAnchor=this._getSiblingElement(this._kbAnchor,e)
}else{
this._kbAnchor=this._parentEl.firstChild
}}
if(this._kbAnchor!=a){
if(a){
var t=this._selectedClass;
if(a.className.indexOf(t)!=-1){
Dwt.delClass(a,this._styleRe,t)
}else{
Dwt.delClass(a,this._styleRe)
}}
Dwt.addClass(this._kbAnchor,this._kbFocusClass)
}
if(this._kbAnchor){
this._scrollList(this._kbAnchor)
}};
DwtListView.prototype._itemSelected=function(e,a){
if(this._allowLeftSelection(e,a,a&&a.button)){
this._unmarkKbAnchorElement(true);
this.deselectAll();
this._selectedItems.add(e);
this._selAnchor=this._kbAnchor=e;
Dwt.delClass(e,this._styleRe,this._selectedClass);
if(this.hasFocus()){
Dwt.addClass(e,this._kbFocusClass)
}
var t=this.getItemFromElement(e);
this.firstSelIndex=(this._list&&t)?this._list.indexOf(t):-1
}};
DwtListView.prototype._itemClicked=function(s,d){
if(this._rightSelItem){
Dwt.delClass(this._rightSelItem,this._styleRe);
this._rightSelItem=null
}
var n=this._selectedItems.size();
var a=this._selectedItems.contains(s);
if((!d.shiftKey&&!d.ctrlKey)||!this.multiSelectEnabled){
if(d.button==DwtMouseEvent.LEFT||d.button==DwtMouseEvent.RIGHT){
this._selEv.detail=DwtListView.ITEM_SELECTED
}
if(d.button==DwtMouseEvent.LEFT){
this._itemSelected(s,d)
}else{
if(d.button==DwtMouseEvent.RIGHT&&!a&&this._evtMgr.isListenerRegistered(DwtEvent.ACTION)){
this._rightSelItem=s;
Dwt.delClass(s,this._styleRe,this._rightClickClass);
if(this._kbAnchor==s){
Dwt.addClass(s,this._kbFocusClass)
}}}}else{
if(d.ctrlKey){
this.setMultiSelection(s,a,d)
}else{
if(!this._selAnchor){
return
}
var r=this._getChildren()||s.parentNode.childNodes;
var l=r.length;
var o;
var e=0;
for(var h=0;
h<l;
h++){
o=r[h];
if(o==this._rightSelItem){
this._rightSelItem=null
}
if(o==s){
e++
}
var t=this._selectedClass;
if(o==this._selAnchor){
e++;
if(o.className.indexOf(t)==-1){
this._selectedItems.add(o)
}
Dwt.delClass(o,this._styleRe,t);
continue
}
if(e!=1&&o.className.indexOf(t)!=-1&&o!=s){
Dwt.delClass(o,this._styleRe);
this._selectedItems.remove(o)
}else{
if(e==1||o==s){
if(o.className.indexOf(t)==-1){
this._selectedItems.add(o)
}
Dwt.delClass(o,this._styleRe,t)
}}}
this._kbAnchor=s;
Dwt.addClass(this._kbAnchor,this._kbFocusClass);
var c=this._selectedItems.size();
if(n<c){
this._selEv.detail=DwtListView.ITEM_SELECTED
}else{
if(n>c){
this._selEv.detail=DwtListView.ITEM_DESELECTED
}else{
return
}}}}
if(d.button==DwtMouseEvent.LEFT&&this._evtMgr.isListenerRegistered(DwtEvent.SELECTION)){
if(this._setListEvent(d,this._selEv,s)){
this._evtMgr.notifyListeners(DwtEvent.SELECTION,this._selEv)
}}else{
if(d.button==DwtMouseEvent.RIGHT&&this._evtMgr.isListenerRegistered(DwtEvent.ACTION)){
if(this._setListEvent(d,this._actionEv,s)){
this._evtMgr.notifyListeners(DwtEvent.ACTION,this._actionEv)
}}}};
DwtListView.prototype._setListEvent=function(t,a,e){
DwtUiEvent.copy(a,t);
a.kbNavEvent=t.kbNavEvent;
a.item=this.findItem(e);
return true
};
DwtListView.prototype._columnClicked=function(o,a){
var n=this.getItemFromElement(o);
if(!(n._sortable&&this.sortingEnabled)){
return
}
var i=this.getList();
var e=i?i.size():null;
var t=this._columnHasCustomQuery(n);
if(!e&&!t){
return
}
this._bSortAsc=(n._id==this._currentColId)?!this._bSortAsc:this._getDefaultSortbyForCol(n);
this._setSortedColStyle(n._id);
if(e>=1||t){
this._sortColumn(n,this._bSortAsc)
}};
DwtListView.prototype._columnHasCustomQuery=function(e){
return false
};
DwtListView.prototype._sortColumn=function(e,t){};
DwtListView.prototype._getActionMenuForColHeader=function(){
return null
};
DwtListView.prototype._getDefaultSortbyForCol=function(e){
return true
};
DwtListView.prototype._allowLeftSelection=function(t,a,e){
return true
};
DwtListView.prototype._setSortedColStyle=function(e){
if(this._currentColId&&(e!=this._currentColId)){
var n=this._headerIdHash[this._currentColId];
if(n&&!n._noSortArrow){
var s=n._field;
var r=DwtId.getListViewHdrId(DwtId.WIDGET_HDR_ARROW,this._view,s);
var i=document.getElementById(r);
if(i&&i.firstChild){
var t=(AjxImg._mode==AjxImg.SINGLE_IMG)?i.firstChild:i.firstChild.firstChild;
if(t){
t.style.visibility="hidden"
}}}
var l=document.getElementById(this._currentColId);
if(l){
l.className="DwtListView-Column"
}}
this._currentColId=e;
var n=this._headerIdHash[this._currentColId];
if(!n._noSortArrow){
var s=n._field;
var h=DwtId.getListViewHdrId(DwtId.WIDGET_HDR_ARROW,this._view,s);
var a=document.getElementById(h);
if(a){
AjxImg.setImage(a,this._bSortAsc?"ColumnUpArrow":"ColumnDownArrow");
var t=(AjxImg._mode==AjxImg.SINGLE_IMG)?a.firstChild:a.firstChild.firstChild;
if(t){
t.style.visibility="visible"
}}}
var o=document.getElementById(e);
if(o){
o.className="DwtListView-Column DwtListView-ColumnActive"
}};
DwtListView.prototype._resetList=function(){
if(this._list&&this._list.size()){
this._list.removeAll()
}
this._resetListView()
};
DwtListView.prototype._resetListView=function(){
var e;
while(this._parentEl&&this._parentEl.hasChildNodes()){
var e=this._parentEl.removeChild(this._parentEl.firstChild);
this._data[e.id]=null
}
if(this._selectedItems){
this._selectedItems.removeAll()
}
this._rightSelItem=null
};
DwtListView.prototype._destroyDragProxy=function(e){
this._data[e.id]=null;
DwtControl.prototype._destroyDragProxy.call(this,e)
};
DwtListView.prototype._handleColHeaderMove=function(s){
if(!this._headerClone){
if(!this._headerColX){
this._headerColX=s.docX;
return
}else{
var o=Math.abs(this._headerColX-s.docX);
if(o<DwtListView.COL_MOVE_THRESHOLD){
return
}}
this._headerClone=document.createElement("div");
var c=Dwt.getSize(this._clickDiv);
var t=AjxEnv.isIE?c.x:c.x-3;
var l=AjxEnv.isIE?c.y:c.y-5;
Dwt.setSize(this._headerClone,t,l);
Dwt.setPosition(this._headerClone,Dwt.ABSOLUTE_STYLE);
Dwt.setZIndex(this._headerClone,Dwt.Z_DND);
Dwt.setLocation(this._headerClone,Dwt.DEFAULT,s.docY);
this._headerClone.className=this._clickDiv.className+" DragProxy";
this._headerClone.innerHTML=this._clickDiv.innerHTML;
this._clickDiv.className="DwtListView-Column DwtListView-ColumnEmpty";
this._headerClone.style.borderTop="1px solid #777777";
var r=this._headerIdHash[this._clickDiv.id];
var h=r._field;
var i=DwtId.getListViewHdrId(DwtId.WIDGET_HDR_LABEL,this._view,h);
var a=document.getElementById(i);
if(a){
a.style.color="#FFFFFF"
}
this.shell.getHtmlElement().appendChild(this._headerClone)
}else{
var e=this.getTargetItemDiv(s);
var n=this._getItemData(e,"type");
if(n==DwtListView.TYPE_HEADER_ITEM){
if(this._headerCloneTarget&&(this._headerCloneTarget==this._clickDiv)){
this._headerCloneTarget=null
}else{
if(this._headerCloneTarget!=e){
this._headerCloneTarget=e
}}}else{
this._headerCloneTarget=null
}}
if(this._headerClone){
Dwt.setLocation(this._headerClone,s.docX+2)
}};
DwtListView.prototype._handleColHeaderResize=function(t){
if(!this._headerSash){
this._headerSash=document.createElement("div");
Dwt.setSize(this._headerSash,Dwt.DEFAULT,this.getSize().y);
Dwt.setPosition(this._headerSash,Dwt.ABSOLUTE_STYLE);
Dwt.setZIndex(this._headerSash,Dwt.Z_DND);
var a=this._getHeaderSashLocation();
this._headerSashFudgeX=a.x;
Dwt.setLocation(this._headerSash,Dwt.DEFAULT,a.y);
this._headerSash.className="DwtListView-ColumnSash";
this.getHtmlElement().appendChild(this._headerSash);
this._headerSashX=t.docX
}
var e=this._getParentForColResize();
var i=Dwt.toWindow(e.getHtmlElement(),0,0);
Dwt.setLocation(this._headerSash,(t.docX-i.x)+this._headerSashFudgeX)
};
DwtListView.prototype._getHeaderSashLocation=function(){
if(!this._tmpPoint){
this._tmpPoint=new DwtPoint()
}
this._tmpPoint.x=0;
this._tmpPoint.y=0;
return this._tmpPoint
};
DwtListView.prototype._handleColHeaderDrop=function(h){
this._headerColX=null;
if(this._headerClone==null||h.button==DwtMouseEvent.RIGHT){
return false
}
if(this._headerCloneTarget){
var e=this._getItemData(this._clickDiv,"index");
var a=this._getItemData(this._headerCloneTarget,"index");
this._reIndexColumn(e,a)
}
this._clickDiv.className=(this._clickDiv.id!=this._currentColId)?"DwtListView-Column":"DwtListView-Column DwtListView-ColumnActive";
var c=this._headerClone.parentNode;
if(c){
c.removeChild(this._headerClone)
}
delete this._headerClone;
var s=this._data[this._clickDiv.id];
if(s.type!=DwtListView.TYPE_HEADER_ITEM){
var l=this._headerIdHash[this._currentColId];
var r=l._sortable?l._field:null;
this.headerColCreated=false;
this.createHeaderHtml(r)
}else{
var l=this._headerIdHash[this._clickDiv.id];
var o=DwtId.getListViewHdrId(DwtId.WIDGET_HDR_LABEL,this._view,l._field);
var t=document.getElementById(o);
if(t){
t.style.color="#000000"
}}
for(var n=0;
n<this._headerList.length;
n++){
this._headerList[n]._width=this._calcRelativeWidth(n)
}
this._resetColWidth();
return true
};
DwtListView.prototype._reIndexColumn=function(i,a){
if(!this._headerList){
return
}
var e=this._headerList.length;
if(i<0||a<0||i>=e||a>=e||i==a){
return
}
var t=this._headerList.splice(i,1);
this._headerList.splice(a,0,t[0]);
this._relayout()
};
DwtListView.prototype._handleColSashDrop=function(c){
if(this._headerSash==null||c.button==DwtMouseEvent.RIGHT){
return false
}
var d=this._headerSash.parentNode;
if(d){
d.removeChild(this._headerSash)
}
delete this._headerSash;
for(var o=0;
o<this._headerList.length;
o++){
this._headerList[o]._width=this._calcRelativeWidth(o)
}
var a=this._getItemData(this._clickDiv,"index");
if(a==null){
return false
}
var u=c.docX-this._headerSashX;
var l=this._headerList[a];
var h=l;
var r;
var n=[];
if(u<0){
if((h==r)||!r){
r=this._getNextResizeableColumnHeader(h)
}
if(!r){
return false
}
u=Math.max(DwtListView.MIN_COLUMN_WIDTH-l._width,u);
l._width=Math.max(l._width+u,DwtListView.MIN_COLUMN_WIDTH);
r._width=Math.max(this._calcRelativeWidth(r._index)-u,DwtListView.MIN_COLUMN_WIDTH);
n.push(l,r)
}else{
if(u>0){
var s=u;
while(s>0){
if((h==r)||!r){
r=this._getNextResizeableColumnHeader(h,[],false)
}
if(!r){
u-=s;
break
}
var m=this._calcRelativeWidth(r._index);
var e=m-DwtListView.MIN_COLUMN_WIDTH;
if(s>e){
s-=e;
m=DwtListView.MIN_COLUMN_WIDTH
}else{
m-=s;
s=0
}
r._width=m;
n.push(r);
h=r
}
l._width=Math.max(l._width+u,DwtListView.MIN_COLUMN_WIDTH);
n.push(l)
}}
var t=this._getNextResizeableColumnHeader(-1,n,true);
if(t){
t._width="auto"
}
this._relayout();
this._resetColWidth();
return true
};
DwtListView.prototype._calcRelativeWidth=function(a){
var t=this._headerList[a];
if(!t._width||(t._width&&t._width=="auto")){
var e=document.getElementById(t._id);
return(e)?(e.clientWidth-(AjxEnv.isIE?4:5)):null
}
return t._width
};
DwtListView.prototype._resetColWidth=function(){
if(!this.headerColCreated){
return
}
var n=this._getLastColumnIndex();
if(n){
var a=this._headerList[n];
var t=document.getElementById(a._id);
if(t){
var s=t.firstChild;
var e=16;
var o=this._listColDiv.clientWidth;
var i=this._listDiv.clientWidth;
if(o!=i){
t.style.width=s.style.width=(a._width!=null&&a._width!="auto")?(a._width+e):(t.clientWidth+e)
}else{
t.style.width=s.style.width=(a._width||"")
}}}};
DwtListView.prototype._getLastColumnIndex=function(){
var t=null;
if(this._headerList){
var e=this._headerList.length-1;
while(t==null&&e>=0){
if(this._headerList[e]._visible){
t=e
}
e--
}}
return t
};
DwtListView.prototype._getNextResizeableColumnIndex=function(n,e,o){
e=e?AjxUtil.arrayAsHash(e):{};
e[n]=true;
if(this._headerList){
for(var a=n+1;
a<this._headerList.length;
a++){
var t=this._headerList[a];
if(e[a]){
continue
}
if(t._visible&&t._resizeable){
return a
}}
if(o){
for(var a=0;
a<n;
a++){
if(e[a]){
continue
}
var t=this._headerList[a];
if(t._visible&&t._resizeable){
return a
}}}}
return null
};
DwtListView.prototype._getNextResizeableColumnHeader=function(i,e,a){
var t=this._getNextResizeableColumnIndex(i._index,e,a);
return(t!==null)?this._headerList[t]:false
};
DwtListView.prototype._relayout=function(){
this.headerColCreated=false;
var a=this._headerIdHash[this._currentColId];
var e=(a&&a._sortable)?a._field:null;
var t=this.getSelection()[0];
this.setUI(e);
this.setSelection(t,true)
};
DwtListView.prototype._getParentForColResize=function(){
return this
};
DwtListView.prototype._sizeChildren=function(e){
if(this.headerColCreated&&this._listDiv&&(e!=Dwt.DEFAULT)){
Dwt.setSize(this._listDiv,Dwt.DEFAULT,e-DwtListView.HEADERITEM_HEIGHT);
return true
}else{
return false
}};
DwtListView.prototype._getChildren=function(){
return null
};
DwtListView.prototype._focus=function(){
if(this.size()==0){
return
}
if(this._kbAnchor){
Dwt.addClass(this._kbAnchor,this._kbFocusClass)
}else{
this._setKbFocusElement()
}};
DwtListView.prototype._blur=function(){
this._unmarkKbAnchorElement()
};
DwtListView.prototype._unmarkKbAnchorElement=function(e){
if(this._kbAnchor){
if(this._selectedItems.contains(this._kbAnchor)){
Dwt.delClass(this._kbAnchor,this._styleRe,this._selectedClass)
}else{
Dwt.delClass(this._kbAnchor,this._styleRe)
}}
if(e){
this._kbAnchor=null
}};
DwtListView.prototype._getFirstItem=function(){
var e=this._list.getArray();
if(e&&e.length>1){
return e[0]
}
return null
};
DwtListView.prototype._getLastItem=function(){
var e=this._list.getArray();
if(e&&e.length>1){
return e[e.length-1]
}
return null
};
DwtListHeaderItem=function(t){
if(arguments.length==0){
return
}
t=Dwt.getParams(arguments,DwtListView.PARAMS);
this._field=t.field;
this._label=t.text;
this._iconInfo=t.icon;
this._sortable=t.sortable;
this._noSortArrow=t.noSortArrow;
this._resizeable=t.resizeable;
this._visible=(t.visible!==false);
this._name=t.name||t.text;
this._align=t.align;
this._noRemove=t.noRemove;
var e=parseInt(t.width);
if(isNaN(e)||!e){
this._width="auto";
this._variable=true;
this._resizeable=true
}else{
if(String(e)==String(t.width)){
this._width=e
}else{
this._width=parseInt(String(t.width).substr(0,String(e).length));
this._widthUnits=AjxStringUtil.getUnitsFromSizeString(t.width)
}}};
DwtListHeaderItem.PARAMS=["id","text","icon","width","sortable","resizeable","visible","name","align","noRemove","view"];
DwtListHeaderItem.sortCompare=function(t,e){
return t._index<e._index?-1:(t._index>e._index?1:0)
};
DwtListHeaderItem.prototype.toString=function(){
return"DwtListHeaderItem"
};
