
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtProgressBar=function(a,t,e){
if(arguments.length==0){
return
}
e=e||DwtControl.STATIC_STYLE;
DwtComposite.call(this,{
parent:a,posStyle:e}
);
this._maxValue=100;
this._value=0;
this._quotabarDiv=null;
this._quotausedDiv=null;
this._progressBgColor=null;
this._progressCssClass="quotaused";
this._wholeBgColor=null;
this._wholeCssClass="quotabar";
this._createHTML()
};
DwtProgressBar.prototype=new DwtComposite;
DwtProgressBar.prototype.constructor=DwtProgressBar;
DwtProgressBar.prototype.setProgressBgColor=function(e){
this._progressBgColor=e
};
DwtProgressBar.prototype.setWholeBgColor=function(e){
this._wholeBgColor=e
};
DwtProgressBar.prototype.setProgressCssClass=function(e){
this._progressCssClass=e
};
DwtProgressBar.prototype.setWholeCssClass=function(e){
this._wholeCssClass=e
};
DwtProgressBar.prototype.setProgressCssStyle=function(e){
this._progressCssStyle=e
};
DwtProgressBar.prototype.setWholeCssStyle=function(e){
this._wholeCssStyle=e
};
DwtProgressBar.prototype.setValue=function(t){
this._value=parseInt(t);
var e;
if(this._value==this._maxValue){
e=100
}else{
e=Math.min(Math.round((this._value/this._maxValue)*100),100)
}
if(isNaN(e)){
e="0"
}
if(!this._quotabarDiv){
this._quotabarDiv=document.createElement("div");
if(this._wholeCssClass){
this._quotabarDiv.className=this._wholeCssClass
}
if(this._wholeBgColor){
this._quotabarDiv.backgroundColor=this._wholeBgColor
}
this._cell.appendChild(this._quotabarDiv)
}
if(!this._quotausedDiv){
this._quotausedDiv=document.createElement("div");
if(this._progressCssClass){
this._quotausedDiv.className=this._progressCssClass
}
if(this._progressBgColor){
this._quotausedDiv.style.backgroundColor=this._progressBgColor
}
this._quotabarDiv.appendChild(this._quotausedDiv)
}
this._quotausedDiv.style.width=e+"%"
};
DwtProgressBar.prototype.setValueByPercent=function(e){
this.setMaxValue(100);
this.setValue(e.replace(/\%/gi,""))
};
DwtProgressBar.prototype.getValue=function(){
return this._value
};
DwtProgressBar.prototype.getMaxValue=function(){
return this._maxValue
};
DwtProgressBar.prototype.setMaxValue=function(e){
this._maxValue=parseInt(e)
};
DwtProgressBar.prototype.setLabel=function(o,t){
var a=document.createTextNode(o);
var e=t?-1:0;
var i=this._row.insertCell(e);
i.appendChild(a)
};
DwtProgressBar.prototype._createHTML=function(){
this._table=document.createElement("table");
this._table.border=this._table.cellpadding=this._table.cellspacing=0;
this._row=this._table.insertRow(-1);
this._cell=this._row.insertCell(-1);
this.getHtmlElement().appendChild(this._table)
};
