
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DynSelect_XFormItem=function(){};
XFormItemFactory.createItemType("_DYNSELECT_","dynselect",DynSelect_XFormItem,OSelect1_XFormItem);
DynSelect_XFormItem.prototype.dataFetcherClass=null;
DynSelect_XFormItem.prototype.dataFetcherMethod=null;
DynSelect_XFormItem.prototype.dataFetcherObject=null;
DynSelect_XFormItem.prototype.dataFetcherTypes=null;
DynSelect_XFormItem.prototype.dataFetcherAttrs=null;
DynSelect_XFormItem.prototype.dataFetcherDomain=null;
DynSelect_XFormItem.prototype.bmolsnr=true;
DynSelect_XFormItem.prototype.emptyText="";
DynSelect_XFormItem.prototype.cssClass="dynselect";
DynSelect_XFormItem.prototype.edited=false;
DynSelect_XFormItem.prototype.focusable=true;
DynSelect_XFormItem.LOAD_PAUSE=AjxEnv.isIE?500:250;
DynSelect_XFormItem.prototype.initFormItem=function(){
var i=this.getChoices();
if(i instanceof Array){
i=new XFormChoices(i,XFormChoices.SIMPLE_LIST)
}
if(!i){
i=new XFormChoices([],XFormChoices.OBJECT_LIST,"name","name")
}
this.setChoices(i);
var a=new AjxListener(this,this.choicesChangeLsnr);
this.choices.addListener(DwtEvent.XFORMS_CHOICES_CHANGED,a);
this.dataFetcherClass=this.getInheritedProperty("dataFetcherClass");
this.dataFetcherMethod=this.getInheritedProperty("dataFetcherMethod");
this.dataFetcherTypes=this.getInheritedProperty("dataFetcherTypes");
this.dataFetcherAttrs=this.getInheritedProperty("dataFetcherAttrs");
this.dataFetcherDomain=this.getInheritedProperty("dataFetcherDomain");
this.dataFetcherObject=null;
if(!this.dataFetcherMethod){
this.dataFetcherMethod=DynSelect_XFormItem.fetchDataDefault;
this.dataFetcherObject=this
}
var e=XFormItem.getParentTabGroupId(this);
this.getForm().indexItem(this,this.getId()+"_display");
if(e){
var t=this.getForm().getItemById(e);
if(t){
t.tabIdOrder.push(this.getId()+"_display")
}}};
DynSelect_XFormItem.prototype.changeChoicesCallback=function(a,e,t){
var i;
i=this.choices?this.choices:this.getChoices();
if(!i){
return
}
i.setChoices(a);
i.dirtyChoices();
if(AjxUtil.isEmpty(a)){
this.hideMenu()
}else{
if(!this.menuUp){
this.showMenu()
}}};
DynSelect_XFormItem.fetchDataDefault=function(e){
var t=e.callback;
t.run(this.choices.getChoiceObject(),false,null)
};
DynSelect_XFormItem.prototype.onKeyUp=function(n,i){
var s=new Date().getTime();
this._lastTypeTime=s;
if(window.console&&window.console.log){
window.console.log("onKeyUp "+n+" @ "+s)
}
this.edited=true;
this.hideNote();
if(i.keyCode==XFG.ARROW_UP){
if(!this.menuUp){
this.showMenu()
}
this.hilitePreviousChoice(i);
this.isSelecting=true;
return
}
if(i.keyCode==XFG.ARROW_DOWN){
if(!this.menuUp){
this.showMenu()
}
this.hiliteNextChoice(i);
this.isSelecting=true;
return
}
if(this.isSelecting&&this.menuUp&&i.keyCode==DwtKeyEvent.KEY_ENTER&&this.__currentHiliteItem!=null&&this.__currentHiliteItem!=undefined){
var n=this.getNormalizedValues()[this.__currentHiliteItem];
if(n!=null&&n!=undefined){
this.setValue(n,true,i);
this.hideMenu();
return
}}else{
if(this.menuUp&&i.keyCode==DwtKeyEvent.KEY_ENTER){
this.hideMenu();
return
}}
this.isSelecting=false;
var r=this.getKeyUpMethod();
if(r){
r.call(this,n,i)
}else{
var t=DwtKeyEvent.getCharCode(i);
if(!AjxUtil.isEmpty(this.keyPressDelayHdlr)){
AjxTimedAction.cancelAction(this.keyPressDelayHdlr);
this.keyPressDelayHdlr=null
}
var a=this.getForm();
var e=new DwtKeyEvent();
e.setFromDhtmlEvent(i);
if(t==DwtKeyEvent.KEY_TAB){
DwtUiEvent.setBehaviour(i,true,false);
return false
}else{
if(!(i.keyCode==XFG.ARROW_RIGHT||i.keyCode==XFG.ARROW_LEFT||i.keyCode==DwtKeyEvent.KEY_ESCAPE)){
var o=new AjxTimedAction(this,this.handleKeyPressDelay,[e,n,s]);
this.keyPressDelayHdlr=AjxTimedAction.scheduleAction(o,DynSelect_XFormItem.LOAD_PAUSE)
}}}};
DynSelect_XFormItem.prototype.onKeyDown=function(i,a){
var t=DwtKeyEvent.getCharCode(a);
if(t==DwtKeyEvent.KEY_ENTER){
DwtUiEvent.setBehaviour(a,true,true);
return false
}else{
if(t==DwtKeyEvent.KEY_TAB){
DwtUiEvent.setBehaviour(a,true,false);
if(this.menuUp){
this.hideMenu()
}
var e=XFormItem.getParentTabGroupId(this);
if(a.shiftKey){
this.getForm().focusPrevious(this.getId()+"_display",e)
}else{
this.getForm().focusNext(this.getId()+"_display",e)
}
return true
}}
return true
};
DynSelect_XFormItem.prototype.resetChoices=function(){
var e=this.getChoices();
e.setChoices([]);
e.dirtyChoices();
if(!this.dataFetcherObject&&this.dataFetcherClass!=null&&this.dataFetcherMethod!=null){
this.dataFetcherObject=new this.dataFetcherClass(this.getForm().getController())
}else{
if(this.getInheritedProperty("dataFetcherInstance")){
this.dataFetcherObject=this.getInstance()
}}};
DynSelect_XFormItem.prototype.handleKeyPressDelay=function(a,i,s){
var e=new Date().getTime();
if(window.console&&window.console.log){
window.console.log("handleKeyPressDelay "+i+" @ "+e)
}
this.keyPressDelayHdlr=null;
var n=this.preProcessInput(i);
if(s==this._lastTypeTime){
this.getForm().itemChanged(this,n,a)
}else{
if(window.console&&window.console.log){
window.console.log("typing faster than retreiving data")
}
return
}
if(!this.dataFetcherObject&&this.dataFetcherClass!=null&&this.dataFetcherMethod!=null){
this.dataFetcherObject=new this.dataFetcherClass(this.getForm().getController())
}else{
if(this.getInheritedProperty("dataFetcherInstance")){
this.dataFetcherObject=this.getInstance()
}}
if(!this.dataFetcherObject){
return
}
var r=new AjxCallback(this,this.changeChoicesCallback);
var t=this.getInheritedProperty("searchByProcessedValue");
var o={
event:a,callback:r,extraLdapQuery:null,form:this.getForm(),types:(this.dataFetcherTypes?this.dataFetcherTypes:null),attrs:(this.dataFetcherAttrs?this.dataFetcherAttrs:null),domain:(this.dataFetcherDomain?this.dataFetcherDomain:null)};
if(t&&!AjxUtil.isEmpty(n)){
o.value=n;
this.dataFetcherMethod.call(this.dataFetcherObject,o)
}else{
if(!AjxUtil.isEmpty(i)){
o.value=i;
this.dataFetcherMethod.call(this.dataFetcherObject,o)
}}};
DynSelect_XFormItem.prototype.outputHTML=function(e){
var r=this.getId();
var i=this.getFormGlobalRef()+".getItemById('"+r+"')";
var a;
var t=this.getInheritedProperty("inputSize");
var n=this.getInheritedProperty("inputWidth");
var o=" onkeypress";
if(!AjxEnv.isFirefox){
o=" onkeydown"
}
var s=n?"style='width:"+n+"'":(t?"size="+t:"");
a=["<input type=text id=",r,"_display class=",this.getDisplayCssClass()," value='VALUE' ",' onchange="',i,'.onValueTyped(this.value, event||window.event)"',o+'="',i,'.onKeyDown(this.value, event||window.event)"',' onkeyup="',i,'.onKeyUp(this.value, event||window.event)"',s,this.getMouseoutHandlerHTML(),">"].join("");
e.append("<div id=",r,this.getCssString(),' onclick="',this.getFormGlobalRef(),".getItemById('",this.getId(),"').onClick(event)\"",' onselectstart="return false"',">","<table ",this.getTableCssString(),">","<tr><td width=100%>",a,"</td>","</tr>","</table>","</div>");
this.edited=false
};
DynSelect_XFormItem.prototype.getMouseoutHandlerHTML=function(){
var i=this.getFormGlobalRef(),a=this.getId();
var e="";
var t=this.getInheritedProperty("onMouseout");
e=AjxBuffer.concat(' onmouseout="',t||"XFormItem.prototype.hideInputTooltip",".call(",this.getGlobalRef(),', event );" ');
return AjxBuffer.concat(e)
};
DynSelect_XFormItem.prototype.onClick=function(t){
var a=this.getNormalizedChoices();
if(!this.edited&&this.getInheritedProperty("editable")){
this.showInputTooltip(t)
}else{
if(a&&a.values&&a.values.length){
this.showMenu()
}}
if(AjxUtil.isEmpty(this.getInstanceValue())&&this._enabled){
var e=this.getDisplayElement();
e.value="";
e.className=this.getDisplayCssClass()
}};
DynSelect_XFormItem.prototype.getArrowElement=function(){
return null
};
DynSelect_XFormItem.prototype.preProcessInput=function(t){
var e=this.getPreProcessMethod();
var a=t;
if(e){
a=e.call(this,t,this.getForm())
}
return a
};
DynSelect_XFormItem.prototype.getPreProcessMethod=function(){
return this.cacheInheritedMethod("inputPreProcessor","inputPreProcessor","value, form")
};
DynSelect_XFormItem.prototype.updateElement=function(o){
if(this.getMultiple()&&o!=null&&o.indexOf(",")>-1){
o=o.split(",");
for(var t=0;
t<o.length;
t++){
o[t]=this.getChoiceLabel(o[t])
}}else{
o=this.getChoiceLabel(o)
}
var a=this.getDisplayElement();
if(a){
if(AjxUtil.isEmpty(o)&&this._enabled&&!this.edited){
var e=this.getInheritedProperty("emptyText");
if(!AjxUtil.isEmpty(e)){
o=e;
a.className=this.getDisplayCssClass()+"_empty"
}}else{
if(this._enabled){
a.className=this.getDisplayCssClass()
}}
if(window.console&&window.console.log){
console.log("updating element with value: "+o+" over "+a.value)
}
a.value=o
}
if(AjxUtil.isEmpty(o)){
if(!this.dataFetcherObject&&this.dataFetcherClass!=null&&this.dataFetcherMethod!=null){
this.dataFetcherObject=new this.dataFetcherClass(this.getForm().getController())
}
if(!this.dataFetcherObject){
return
}}};
DynSelect_XFormItem.prototype.setElementEnabled=function(e){
this._enabled=e;
var t=this.getForm().getElement(this.getId());
if(!t||!t.getElementsByTagName||!t.getElementsByTagName("table")[0]){
return
}
var a=t.getElementsByTagName("table")[0];
if(e){
if(AjxUtil.isEmpty(this.getInstanceValue())&&!AjxUtil.isEmpty(this.getInheritedProperty("emptyText"))){
this.getDisplayElement().className=this.getDisplayCssClass()+"_empty";
this.getDisplayElement().value=this.getInheritedProperty("emptyText")
}else{
this.getDisplayElement().className=this.getDisplayCssClass()
}
this.getForm().getElement(this.getId()).className=this.cssClass;
a.className=this.getTableCssClass();
this.getDisplayElement().disabled=false
}else{
this.getDisplayElement().className=this.getDisplayCssClass()+"_disabled";
var t=this.getArrowElement();
if(t){
AjxImg.setImage(t,"SelectPullDownArrowDis")
}
this.getForm().getElement(this.getId()).className=this.cssClass+"_disabled";
a.className=this.getTableCssClass()+"_disabled";
this.getDisplayElement().disabled=true
}};
