
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
AjxAnimation=function(e){
this.length=e.length||15;
this.speed=e.speed||50;
this.f=e.f||AjxAnimation.f_decelerate;
this.onUpdate=e.onUpdate;
this.onStop=e.onStop;
this.__work=AjxCallback.simpleClosure(this.__work,this)
};
AjxAnimation.prototype.start=function(){
this.i=0;
this.stop();
this.timer=setInterval(this.__work,this.speed)
};
AjxAnimation.prototype.stop=function(){
if(this.timer){
clearInterval(this.timer);
this.timer=null;
if(this.onStop){
this.onStop.run(this)
}}};
AjxAnimation.prototype.__work=function(){
this.onUpdate.run(this.f(this.i++,this.length),this);
if(this.i>this.length){
this.stop()
}};
AjxAnimation.prototype.map=function(i,t,e){
return t+(e-t)*i
};
AjxAnimation.f_decelerate=function(a,t){
var e=1-a/t;
e=e*e;
return 1-e*e
};
AjxAnimation.f_accelerate=function(a,t){
var e=a/t;
e=e*e;
return e*e
};
AjxAnimation.f_plain=function(t,e){
return t/e
};
