
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
AjxStringUtil=function(){};
AjxStringUtil.TRIM_RE=/^\s+|\s+$/g;
AjxStringUtil.COMPRESS_RE=/\s+/g;
AjxStringUtil.ELLIPSIS=" ... ";
AjxStringUtil.LIST_SEP=", ";
AjxStringUtil.makeString=function(e){
return e?String(e):""
};
AjxStringUtil.capitalize=function(e){
return e.length>0?e.charAt(0).toUpperCase()+e.substr(1).toLowerCase():""
};
AjxStringUtil.capitalizeWords=function(e){
return AjxUtil.map(e.split(/\s+/g),AjxStringUtil.capitalize).join(" ")
};
AjxStringUtil.toMixed=function(s,e,o){
if(!s||(typeof s!="string")){
return""
}
e=e||/\s+/;
var a=s.split(e);
var n=[];
n.push(o?a[0].toLowerCase():a[0].substring(0,1).toUpperCase()+a[0].substring(1).toLowerCase());
for(var t=1;
t<a.length;
t++){
n.push(a[t].substring(0,1).toUpperCase()+a[t].substring(1).toLowerCase())
}
return n.join("")
};
AjxStringUtil.fromMixed=function(t,e){
e=["$1",e||" ","$2"].join("");
return AjxStringUtil.trim(t.replace(/([a-z])([A-Z]+)/g,e))
};
AjxStringUtil.trim=function(o,e,i){
if(!o){
return""
}
var a=AjxStringUtil.TRIM_RE;
var t=AjxStringUtil.COMPRESS_RE;
if(i){
a=new RegExp("^"+i+"+|"+i+"+$","g");
t=new RegExp(i+"+","g")
}else{
i=" "
}
o=o.replace(a,"");
if(e){
o=o.replace(t,i)
}
return o
};
AjxStringUtil.repeat=function(o,e){
var a="";
for(var t=0;
t<e;
t++){
a+=o
}
return a
};
AjxStringUtil.getUnitsFromSizeString=function(t){
var a="px";
if(typeof(t)=="string"){
var e=Number(parseInt(t,10)).toString();
if(t.length>e.length){
a=t.substr(e.length,(t.length-e.length));
if(!(a=="em"||a=="ex"||a=="px"||a=="in"||a=="cm"==a=="mm"||a=="pt"||a=="pc"||a=="%")){
a="px"
}}}
return a
};
AjxStringUtil.split=function(l,o){
if(!l){
return[]
}
var s=0;
o=o?o:",";
var u=new Object();
if(typeof o=="string"){
u[o]=1
}else{
for(s=0;
s<o.length;
s++){
u[o[s]]=1
}}
var e=false;
var a=0;
var t=0;
var d;
var r=[];
var n=0;
for(s=0;
s<l.length;
s++){
var h=l.charAt(s);
if(h=='"'){
e=!e
}else{
if(h=="("){
a++
}else{
if(h==")"){
a--
}else{
if(u[h]){
if(!e&&!a){
d=l.substring(t,s);
r[n++]=d;
t=s+1
}}}}}}
d=l.substring(t,l.length);
r[n++]=d;
return r
};
AjxStringUtil.splitKeepLeadingWhitespace=function(t){
var i=/\s*\S+/g;
var o=[];
var e;
while(e=i.exec(t)){
var a=e[0];
o.push(a)
}
return o
};
AjxStringUtil.wordWrap=function(F){
if(!(F&&F.text)){
return""
}
var g=F.text;
var y=F.before||"",t=F.after||"";
if(F.htmlMode){
return[y,g,t].join("")
}
var B=F.len||80;
var x=F.pre||"";
var n="\n";
g=AjxStringUtil.trim(g,false,"[\t ]");
g=g.replace(/\r\n/g,n);
var e=g.split(n);
var k=[];
for(var z=0,S=e.length;
z<S;
z++){
var c=e[z];
var q=c.match(/^([\s>\|]+)/);
var T=q?q[1]:"";
if(T){
c=c.substr(T.length)
}
var r=AjxStringUtil.splitKeepLeadingWhitespace(c);
if(r&&r[0]&&r[0].length){
var j=AjxStringUtil.MSG_SEP_RE.test(c)||AjxStringUtil.COLON_RE.test(c)||AjxStringUtil.HDR_RE.test(c)||AjxStringUtil.SIG_RE.test(c);
for(var d=0,f=r.length;
d<f;
d++){
var s=F.preserveReturns&&(d==f-1);
k.push({
w:r[d],p:T,special:(j&&d==0),lastWord:s}
)
}}else{
k.push({
para:true,p:T}
)
}}
var W=F.len||72;
var o=F.pre||"";
var u=o.length;
var h="",a=0,r=[],b=null;
for(var A=0,B=k.length;
A<B;
A++){
var C=k[A];
var d=C.w,v=C.p;
var O=r.length?1:0;
var D=(b===null)?0:b.length;
if(C.para){
if(r.length){
h+=o+(b||"")+r.join("").replace(/^ /,"")+n
}
h+=o+v+n;
r=[];
a=0;
b=null
}else{
if((u+D+a+O+d.length<=W)&&(v==b||b===null)&&!C.special){
r.push(d);
a+=d.length;
b=v;
if(C.lastWord&&k[A+1]){
k[A+1].special=true
}}else{
if(r.length){
h+=o+(b||"")+r.join("").replace(/^ /,"")+n
}
r=[d];
a=d.length;
b=v;
if(C.lastWord&&k[A+1]){
k[A+1].special=true
}}}}
if(r.length){
h+=o+b+r.join("").replace(/^ /,"")+n
}
return[y,h,t].join("")
};
AjxStringUtil.quoteText=function(i){
if(!(i&&i.text)){
return""
}
var h=i.text;
var r=i.before||"",e=i.after||"";
if(i.htmlMode||!i.pre){
return[r,h,e].join("")
}
var n=i.len||80;
var a=i.pre||"";
var s="\n";
h=AjxStringUtil.trim(h);
h=h.replace(/\n\r/g,s);
var u=h.split(s);
var d=[];
for(var t=0,o=u.length;
t<o;
t++){
var c=AjxStringUtil.trim(u[t]);
d.push(a+c+s)
}
return r+d.join("")+e
};
AjxStringUtil.SHIFT_CHAR={
48:")",49:"!",50:"@",51:"#",52:"$",53:"%",54:"^",55:"&",56:"*",57:"(",59:":",186:":",187:"+",188:"<",189:"_",190:">",191:"?",192:"~",219:"{",220:"|",221:"}",222:'"'};
AjxStringUtil.shiftChar=function(e,t){
return t?AjxStringUtil.SHIFT_CHAR[e]||String.fromCharCode(e):String.fromCharCode(e)
};
AjxStringUtil.diffPoint=function(o,a){
if(!(o&&a)){
return 0
}
var e=Math.min(o.length,a.length);
var t=0;
while(t<e&&(o.charAt(t)==a.charAt(t))){
t++
}
return t
};
AjxStringUtil.resolve=function(t,e){
return AjxMessageFormat.format(t,e)
};
AjxStringUtil.urlEncode=function(t){
if(!t){
return""
}
var e=window.encodeURL||window.encodeURI;
return e(t)
};
AjxStringUtil.urlComponentEncode=function(t){
if(!t){
return""
}
var e=window.encodeURLComponent||window.encodeURIComponent;
return e(t)
};
AjxStringUtil.urlDecode=function(t){
if(!t){
return""
}
var e=window.decodeURL||window.decodeURI;
return e(t)
};
AjxStringUtil.urlComponentDecode=function(o){
if(!o){
return""
}
var a=window.decodeURLComponent||window.decodeURIComponent;
var t;
try{
t=a(o)
}
catch(i){
t=unescape(o)
}
return t||o
};
AjxStringUtil.ENCODE_MAP={
">":"&gt;","<":"&lt;","&":"&amp;"};
AjxStringUtil.htmlEncode=function(t,e){
if(!t){
return""
}
if(!AjxEnv.isSafari||AjxEnv.isSafariNightly){
if(e){
return t.replace(/[<>&]/g,function(a){
return AjxStringUtil.ENCODE_MAP[a]
}
).replace(/  /g," &nbsp;")
}else{
return t.replace(/[<>&]/g,function(a){
return AjxStringUtil.ENCODE_MAP[a]
}
)
}}else{
if(e){
return t.replace(/[&]/g,"&amp;").replace(/  /g," &nbsp;").replace(/[<]/g,"&lt;").replace(/[>]/g,"&gt;")
}else{
return t.replace(/[&]/g,"&amp;").replace(/[<]/g,"&lt;").replace(/[>]/g,"&gt;")
}}};
AjxStringUtil.htmlDecode=function(t,e){
if(e){
t=t.replace(/&nbsp;/g," ")
}
return t.replace(/&amp;/g,"&").replace(/&lt;/g,"<").replace(/&gt;/g,">")
};
AjxStringUtil.stripTags=function(t,e){
if(!t){
return""
}
if(e){
t=t.replace(/(<(\w+)[^>]*>).*(<\/\2[^>]*>)/,"$1$3")
}
return t.replace(/<\/?[^>]+>/gi,"")
};
AjxStringUtil.convertToHtml=function(r,s){
if(!r){
return""
}
if(s){
var n=/^(>|\|\s+)/;
var t=r.split(/\r?\n/);
var h=0;
for(var a=0;
a<t.length;
a++){
var e=t[a];
if(e.length>0){
var o=0;
while(e.match(n)){
e=e.replace(n,"");
o++
}
while(o>h){
e="<blockquote>"+e;
h++
}
while(o<h){
e=e+"</blockquote>";
h--
}}
t[a]=e
}
while(h>0){
t.push("</blockquote>");
h--
}
r=t.join("\n");
r=r.replace(/&/mg,"&amp;");
r=r.replace(/<(?!\/?blockquote)/mg,"&lt;");
r=r.replace(/(\/?blockquote)?>/mg,function(l,i){
return i?l:"&gt;"
}
)
}else{
r=r.replace(/&/mg,"&amp;").replace(/</mg,"&lt;").replace(/>/mg,"&gt;")
}
r=r.replace(/  /mg," &nbsp;").replace(/^ /mg,"&nbsp;").replace(/\t/mg,"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;").replace(/\r?\n/mg,"<br>");
return r
};
AjxStringUtil.SPACE_ENCODE_MAP={
" ":"&nbsp;",">":"&gt;","<":"&lt;","&":"&amp;","\n":"<br>"};
AjxStringUtil.htmlEncodeSpace=function(e){
if(!e){
return""
}
return e.replace(/[&]/g,"&amp;").replace(/ /g,"&nbsp;").replace(/[<]/g,"&lt;").replace(/[>]/g,"&gt;")
};
AjxStringUtil.htmlRubyEncode=function(e,t){
if(e&&t){
return["<ruby>","<rb>",AjxStringUtil.htmlEncode(e),"</rb> ","<rp>(</rp><rt>",AjxStringUtil.htmlEncode(t),"</rt><rp>)</rp>","</ruby>"].join("")
}
return AjxStringUtil.htmlEncode(e||t||"")
};
AjxStringUtil.nl2br=function(e){
if(!e){
return""
}
return e.replace(/^ /mg,"&nbsp;").replace(/\t/mg,"<span style='white-space:pre'>\t</span>").replace(/\n/g,"<br>")
};
AjxStringUtil.xmlEncode=function(e){
if(e){
e=""+e;
return e.replace(/&/g,"&amp;").replace(/</g,"&lt;")
}
return""
};
AjxStringUtil.xmlDecode=function(e){
return e?e.replace(/&amp;/g,"&").replace(/&lt;/g,"<"):""
};
AjxStringUtil.xmlAttrEncode=function(e){
return e?e.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/\x22/g,"&quot;").replace(/\x27/g,"&apos;"):""
};
AjxStringUtil.xmlAttrDecode=function(e){
return e?e.replace(/&amp;/g,"&").replace(/&lt;/g,"<").replace(/&quot;/g,'"').replace(/&apos;/g,"'"):""
};
AjxStringUtil.__RE_META={
" ":" ","\n":"\\n","\r":"\\r","\t":"\\t"};
AjxStringUtil.__reMetaEscape=function(t,e){
return AjxStringUtil.__RE_META[e]||"\\"+e
};
AjxStringUtil.regExEscape=function(e){
return e.replace(/(\W)/g,AjxStringUtil.__reMetaEscape)
};
AjxStringUtil._calcDIV=null;
AjxStringUtil.calcDIV=function(){
if(AjxStringUtil._calcDIV==null){
AjxStringUtil._calcDIV=document.createElement("div");
AjxStringUtil._calcDIV.style.zIndex=0;
AjxStringUtil._calcDIV.style.position=DwtControl.ABSOLUTE_STYLE;
AjxStringUtil._calcDIV.style.visibility="hidden";
document.body.appendChild(AjxStringUtil._calcDIV)
}
return AjxStringUtil._calcDIV
};
AjxStringUtil.clip=function(e,s,n){
var o=AjxStringUtil.calcDIV();
if(arguments.length==3){
o.className=n
}
o.innerHTML=e;
if(o.offsetWidth<=s){
return e
}
for(var a=e.length-1;
a>0;
a--){
var t=e.substr(0,a);
o.innerHTML=t+AjxStringUtil.ELLIPSIS;
if(o.offsetWidth<=s){
return t+AjxStringUtil.ELLIPSIS
}}
return e
};
AjxStringUtil.clipByLength=function(a,t){
var e=a.length;
return(e<=t)?a:[a.substr(0,t/2),"...",a.substring(e-((t/2)-3),e)].join("")
};
AjxStringUtil.wrap=function(n,s,r){
var u=AjxStringUtil.calcDIV();
if(arguments.length==3){
u.className=r
}
var h="";
var o="";
var e=n.split("/n");
for(var i=0;
i<e.length;
i++){
if(i!=0){
h+=o+"<br>";
o=""
}
htmlRows=e[i].split("<br>");
for(var c=0;
c<htmlRows.length;
c++){
if(c!=0){
h+=o+"<br>";
o=""
}
words=htmlRows[c].split(" ");
var d=0;
while(d<words.length){
u.innerHTML=o+" "+words[d];
var a=u.offsetWidth;
if(a>s){
u.innerHTML=words[d];
a=a-u.offsetWidth;
if((a>=s)||(u.offsetWidth<=s)){
h+=o+"<br>";
o=""
}else{
var l=true;
var t=0;
while(l){
t++;
u.innerHTML=o+" "+words[d].substring(0,t);
l=(u.offsetWidth<=s)
}
t--;
h+=o+words[d].substring(0,t)+"<br>";
words[d]=words[d].substr(t);
o=""
}}else{
o+=" "+words[d];
d++
}}}}
h+=o;
return h
};
AjxStringUtil.MSG_SEP_RE=new RegExp("^\\s*--+\\s*("+AjxMsg.origMsg+"|"+AjxMsg.forwardedMessage+")\\s*--+","i");
AjxStringUtil.SIG_RE=/^(- ?-+)|(__+)\r?$/;
AjxStringUtil.COLON_RE=/\S+:$/;
AjxStringUtil.PREFIX_RE=/^\s*(&gt;|>|\|)/;
AjxStringUtil.BRACKET_RE=/^\s*\[.+\]\s*$/;
AjxStringUtil.LINE_RE=/^\s*_{30,}\s*$/;
AjxStringUtil.BLANK_RE=/^\s*$/;
AjxStringUtil.SPLIT_RE=/\r\n|\r|\n/;
AjxStringUtil.HDR_RE=/^\s*\w+:/;
AjxStringUtil.HTML_BLANK_RE=/^\s*(<br\s*\/?>)*\s*$/i;
AjxStringUtil.HTML_BR_RE=/<br\s*\/?>/gi;
AjxStringUtil.HTML_BODY_RE=/<body(\s|>)/i;
AjxStringUtil.HTML_QUOTE_PRE_RE=/^\s*<blockquote/i;
AjxStringUtil.HTML_QUOTE_POST_RE=/^\s*<\/blockquote>/i;
AjxStringUtil.HTML_QUOTE_COLOR="#1010FF";
AjxStringUtil.HTML_QUOTE_STYLE="color:#000;font-weight:normal;font-style:normal;text-decoration:none;font-family:Helvetica,Arial,sans-serif;font-size:12pt;";
AjxStringUtil.getTopLevel=function(m,h,t){
if(!m){
return[""]
}
var e=/<br|<div/i.test(m);
var l=e?AjxStringUtil.HTML_BR_RE:AjxStringUtil.SPLIT_RE;
var h=e?"<br>":"\n";
m=AjxStringUtil._trimBlankLines(m,l,h,e);
var f=m.split(l);
var s=f.length;
var o=0,a=0;
var n=[];
var r=false;
while(o<s){
var u=r;
var d=AjxStringUtil._linesToSkip(f,o,t);
r=(d>0);
if(u&&!r){
a=o
}else{
if(!u&&r&&o>a){
var c=AjxStringUtil._trimBlankLines(f.slice(a,o).join(h),l,h,t);
if(c&&c.length){
n.push(c)
}}}
o+=r?d:1
}
if(!r&&o>a){
var c=AjxStringUtil._trimBlankLines(f.slice(a,o).join(h),l,h,t);
if(c&&c.length){
n.push(c)
}}
return n
};
AjxStringUtil._linesToSkip=function(l,a,e){
var o=l.length;
var h=0;
var t=a;
var c=e?AjxStringUtil.stripTags(l[a]):l[a];
if(AjxStringUtil.MSG_SEP_RE.test(c)){
h=o-a
}else{
if(AjxStringUtil.PREFIX_RE.test(c)){
while(a<l.length&&(AjxStringUtil.PREFIX_RE.test(c)||AjxStringUtil.BLANK_RE.test(c))){
a++;
c=e?AjxStringUtil.stripTags(l[a]):l[a]
}
h=a-t
}else{
if(AjxStringUtil.HTML_QUOTE_PRE_RE.test(c)&&c.indexOf(AjxStringUtil.HTML_QUOTE_COLOR)!=-1){
while(a<l.length&&(!AjxStringUtil.HTML_QUOTE_POST_RE.test(c))){
a++;
c=l[a]
}
if(a<l.length){
l[a]=l[a].replace(AjxStringUtil.HTML_QUOTE_POST_RE,"")
}
h=a-t
}else{
if(AjxStringUtil.COLON_RE.test(c)){
var s=AjxStringUtil._nextNonBlankLineIndex(l,a+1,e);
var r=(s==-1)?null:e?AjxStringUtil.stripTags(l[s]):l[s];
if(r&&AjxStringUtil.PREFIX_RE.test(r)){
h=s-a
}else{
if(s!=-1){
s=AjxStringUtil._nextNonBlankLineIndex(l,s+1,e)
}
var n=(s==-1)?null:e?AjxStringUtil.stripTags(l[s]):l[s];
if(n&&AjxStringUtil.BRACKET_RE.test(r)&&AjxStringUtil.PREFIX_RE.test(n)){
h=s-a
}}}else{
if(AjxStringUtil.LINE_RE.test(c)){
var s=AjxStringUtil._nextNonBlankLineIndex(l,a+1,e);
var r=(s==-1)?null:e?AjxStringUtil.stripTags(l[s]):l[s];
if(r&&AjxStringUtil.HDR_RE.test(r)){
h=o-a
}}else{
if(AjxStringUtil.SIG_RE.test(c)){
h=o-a
}}}}}}
return h
};
AjxStringUtil._nextNonBlankLineIndex=function(e,t,a){
while(t<e.length&&AjxStringUtil.BLANK_RE.test(a?AjxStringUtil.stripTags(e[t]):e[t])){
t++
}
return((t<e.length)?t:-1)
};
AjxStringUtil._trimBlankLines=function(r,s,n,e){
var l=r.split(s);
var o=l.length;
var h=e?AjxStringUtil.HTML_BLANK_RE:AjxStringUtil.BLANK_RE;
var a=0;
while(a<o&&h.test(l[a])){
a++
}
var t=o;
while(t>0&&h.test(l[t-1])){
t--
}
if(a!=0||t!=o){
r=l.slice(a,t).join(n)+n
}
if(e&&AjxStringUtil.HTML_BODY_RE.test(r)){
r=r.replace(/<body\s*[^>]*>(<br\s*\/?>)+/i,"<body>");
r=r.replace(/(<br\s*\/?>)+<\/body>/i,"</body>")
}
return r
};
AjxStringUtil._NO_LIST=0;
AjxStringUtil._ORDERED_LIST=1;
AjxStringUtil._UNORDERED_LIST=2;
AjxStringUtil._INDENT="    ";
AjxStringUtil._NON_WHITESPACE=/\S+/;
AjxStringUtil._LF=/\n/;
AjxStringUtil.convertHtml2Text=function(i,n,o){
if(!i){
return null
}
if(n&&AjxUtil.isFunction(n._before)){
i=n._before(i)
}
if(typeof i=="string"){
var s=document.createElement("SPAN");
s.innerHTML=i;
i=s
}
var r=[];
var a=0;
var t={};
this._traverse(i,r,a,AjxStringUtil._NO_LIST,0,0,t,n,o);
var e=r.join("");
if(n&&AjxUtil.isFunction(n._after)){
e=n._after(e)
}
return e
};
AjxStringUtil._traverse=function(e,f,d,l,r,n,s,c,u){
var h=e.nodeName.toLowerCase();
var p=null;
if(c&&c[h]){
p=c[h](e,s)
}
if(p!=null){
f[d++]=p
}else{
if(h=="#text"){
if(e.nodeValue.search(AjxStringUtil._NON_WHITESPACE)!=-1){
if(s.lastNode=="ol"||s.lastNode=="ul"){
f[d++]="\n"
}
if(s.isPreformatted){
f[d++]=AjxStringUtil.trim(e.nodeValue)+" "
}else{
f[d++]=AjxStringUtil.trim(e.nodeValue.replace(AjxStringUtil._LF," "),true)+" "
}}}else{
if(h=="p"){
f[d++]=u?"\n":"\n\n"
}else{
if(l==AjxStringUtil._NO_LIST&&(h=="br"||h=="hr")){
f[d++]="\n"
}else{
if(h=="ol"||h=="ul"){
f[d++]="\n";
if(e.parentNode.nodeName.toLowerCase()!="li"&&s.lastNode!="br"&&s.lastNode!="hr"){
f[d++]="\n"
}
l=(h=="ol")?AjxStringUtil._ORDERED_LIST:AjxStringUtil._UNORDERED_LIST;
r++;
n=0
}else{
if(h=="li"){
for(var a=0;
a<r;
a++){
f[d++]=AjxStringUtil._INDENT
}
if(l==AjxStringUtil._ORDERED_LIST){
f[d++]=n+". "
}else{
f[d++]="\u002A "
}}else{
if(h=="img"){
if(e.alt&&e.alt!=""){
f[d++]=e.alt
}}else{
if(h=="tr"&&e.parentNode.firstChild!=e){
f[d++]="\n"
}else{
if(h=="td"&&e.parentNode.firstChild!=e){
f[d++]="\t"
}else{
if(h=="div"){
f[d++]="\n"
}else{
if(h=="blockquote"){
f[d++]="\n\n"
}else{
if(h=="pre"){
s.isPreformatted=true
}else{
if(h=="#comment"||h=="script"||h=="select"||h=="style"){
return d
}}}}}}}}}}}}}
var m=e.childNodes;
var o=m.length;
for(var a=0;
a<o;
a++){
var t=m[a];
if(t.nodeType==1&&t.tagName.toLowerCase()=="li"){
n++
}
d=this._traverse(t,f,d,l,r,n,s,c,u)
}
if(c&&c["/"+h]){
f[d++]=c["/"+h](e)
}
if(h=="h1"||h=="h2"||h=="h3"||h=="h4"||h=="h5"||h=="h6"){
f[d++]="\n";
s.list=false
}else{
if(h=="pre"){
s.isPreformatted=false
}else{
if(h=="li"){
if(!s.list){
f[d++]="\n"
}
s.list=false
}else{
if(h=="ol"||h=="ul"){
s.list=true
}else{
if(h!="#text"){
s.list=false
}}}}}
s.lastNode=h;
return d
};
AjxStringUtil.queryStringSet=function(r,l){
var h=l?"":location.search;
if(h.indexOf("?")==0){
h=h.substr(1)
}
var s=h.split("&");
var a={};
for(var o=0;
o<s.length;
o++){
var n=s[o].split("=");
a[n[0]]=n[1]
}
for(var e in r){
a[e]=r[e]
}
var t=[];
var o=0;
for(var e in a){
if(e){
t[o++]=[e,a[e]].join("=")
}}
return"?"+t.join("&")
};
AjxStringUtil.queryStringRemove=function(e,a){
e=e?e:"";
if(e.indexOf("?")==0){
e=e.substr(1)
}
var n=e.split("&");
var t=[];
for(var o=0;
o<n.length;
o++){
if(n[o].indexOf(a)!=0){
t.push(n[o])
}}
return"?"+t.join("&")
};
AjxStringUtil.getAsString=function(e){
return !e?"":(typeof(e)=="object")?e.toString():e
};
AjxStringUtil.isWhitespace=function(e){
return(e.charCodeAt(0)<=32)
};
AjxStringUtil.isDigit=function(t){
var e=t.charCodeAt(0);
return(e>=48&&e<=57)
};
AjxStringUtil.compareRight=function(o,t){
var n=0;
var r=0;
var s=0;
var i;
var e;
for(;
(r<o.length||s<t.length);
r++,s++){
i=o.charAt(r);
e=t.charAt(s);
if(!AjxStringUtil.isDigit(i)&&!AjxStringUtil.isDigit(e)){
return n
}else{
if(!AjxStringUtil.isDigit(i)){
return -1
}else{
if(!AjxStringUtil.isDigit(e)){
return +1
}else{
if(i<e){
if(n==0){
n=-1
}}else{
if(i>e){
if(n==0){
n=+1
}}}}}}}};
AjxStringUtil.natCompare=function(h,r){
var s=0,o=0;
var t=0,e=0;
var n,i;
while(s<h.length||o<r.length){
t=e=0;
n=h.charAt(s);
i=r.charAt(o);
while(AjxStringUtil.isWhitespace(n)||n=="0"){
t=(n=="0")?(t+1):0;
n=h.charAt(++s)
}
while(AjxStringUtil.isWhitespace(i)||i=="0"){
e=(i=="0")?(e+1):0;
i=r.charAt(++o)
}
if(AjxStringUtil.isDigit(n)&&AjxStringUtil.isDigit(i)){
var l=AjxStringUtil.compareRight(h.substring(s),r.substring(o));
if(l&&l!=0){
return l
}}
if(n==0&&i==0){
return t-e
}
if(n<i){
return -1
}else{
if(n>i){
return +1
}}
++s;
++o
}};
AjxStringUtil.clipFile=function(n,t){
var a=n.lastIndexOf(".");
var e=a?(a+1):n.length;
if(e<=t){
return n
}else{
var o=n.substr(0,a);
var i=n.substr(a+1,n.length-1);
return[o.substr(0,t/2),"...",o.substring(e-((t/2)-3),e),".",(i?i:"")].join("")
}};
AjxStringUtil.URL_PARSE_RE=new RegExp("^(?:([^:/?#.]+):)?(?://)?(([^:/?#]*)(?::(\\d*))?)?((/(?:[^?#](?![^?#/]*\\.[^?#/.]+(?:[\\?#]|$)))*/?)?([^?#/]*))?(?:\\?([^#]*))?(?:#(.*))?");
AjxStringUtil.parseURL=function(a){
var n=["source","protocol","authority","domain","port","path","directoryPath","fileName","query","anchor"];
var o=AjxStringUtil.URL_PARSE_RE.exec(a);
var t={};
for(var e=0;
e<n.length;
e++){
t[n[e]]=(o[e]?o[e]:"")
}
if(t.directoryPath.length>0){
t.directoryPath=t.directoryPath.replace(/\/?$/,"/")
}
return t
};
AjxStringUtil.parseQueryString=function(s){
var a=s||(""+window.location);
var t=a.indexOf("?");
if(t==-1){
return null
}
var e=a.substring(t+1).replace(/#.*$/,"");
var n=e.split("&");
var h={};
for(var o=0;
o<n.length;
o++){
var r=n[o].split("=");
h[r[0]]=r[1]
}
return h
};
AjxStringUtil._SPECIAL_CHARS=/["\\\x00-\x1f]/g;
AjxStringUtil._CHARS={
"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f","\r":"\\r",'"':'\\"',"\\":"\\\\"};
AjxStringUtil.objToString=function(n){
var f=typeof n,h,l,r,s,u,m,c,e=[];
var d=function(i){
if(!AjxStringUtil._CHARS[i]){
var t=i.charCodeAt();
AjxStringUtil._CHARS[i]="\\u00"+Math.floor(t/16).toString(16)+(t%16).toString(16)
}
return AjxStringUtil._CHARS[i]
};
var p=function(t){
return'"'+t.replace(AjxStringUtil._SPECIAL_CHARS,d)+'"'
};
if(n===null){
return"null"
}
if(f==="string"){
return p(n)
}
if(f==="boolean"||n instanceof Boolean){
return String(n)
}
if(f==="number"||n instanceof Number){
return isFinite(n)?String(n):"null"
}
if(AjxUtil.isArray(n)||(f==="object"&&n.length)){
for(h=e.length-1;
h>=0;
--h){
if(e[h]===n){
return"null"
}}
e[e.length]=n;
c=[];
for(h=n.length-1;
h>=0;
--h){
c[h]=AjxStringUtil.objToString(n[h])
}
e.pop();
return"["+c.join(",")+"]"
}
if(f==="object"&&n){
for(h=e.length-1;
h>=0;
--h){
if(e[h]===n){
return"null"
}}
e[e.length]=n;
c=[];
r=0;
for(s in n){
if(typeof s==="string"&&n.hasOwnProperty(s)){
u=n[s];
m=typeof u;
if(m!=="undefined"&&m!=="function"){
c[r++]=p(s)+":"+AjxStringUtil.objToString(u)
}}}
e.pop();
return"{"+c.join(",")+"}"
}
return"null"
};
AjxStringUtil.prettyPrint=function(i,a,e,t){
AjxStringUtil._visited=new AjxVector();
var o=AjxStringUtil._prettyPrint(i,a,e,t);
AjxStringUtil._visited=null;
return o
};
AjxStringUtil._visited=null;
AjxStringUtil._prettyPrint=function(r,e,d,t){
var f=0;
var n=false;
var y=false;
if(arguments.length>4){
f=arguments[4];
n=arguments[5];
y=arguments[6]
}
if(AjxUtil.isObject(r)){
var c=r.toString?r.toString():"";
if(t&&c&&t[c]){
return"["+c+"]"
}
if(AjxStringUtil._visited.contains(r)){
return"[visited object]"
}else{
AjxStringUtil._visited.add(r)
}}
var a=AjxStringUtil.repeat(" ",f);
var p="";
if(r===undefined){
p+="[undefined]"
}else{
if(r===null){
p+="[null]"
}else{
if(AjxUtil.isBoolean(r)){
p+=r?"true":"false"
}else{
if(AjxUtil.isString(r)){
p+='"'+AjxStringUtil._escapeForHTML(r)+'"'
}else{
if(AjxUtil.isNumber(r)){
p+=r
}else{
if(AjxUtil.isObject(r)){
var h=AjxUtil.isArray(r);
if(y){
p+=h?"[Array]":r.toString()
}else{
y=!e;
var g=new Array();
for(var s in r){
g.push(s)
}
if(h){
g.sort(function(w,i){
return w-i
}
)
}else{
g.sort()
}
if(n){
p+=h?"[":"{"
}
var l=g.length;
for(var s=0;
s<l;
s++){
var m=g[s];
var o=r[m];
var u=null;
if(o==window||o==document||(!AjxEnv.isIE&&o instanceof Node)){
u=o.toString()
}
if((typeof(o)=="function")){
if(d){
u="[function]"
}else{
continue
}}
if(s>0){
p+=","
}
p+="\n"+a;
if(t&&t[m]){
p+=m+": ["+m+"]"
}else{
if(u!=null){
p+=m+": "+u
}else{
p+=m+": "+this._prettyPrint(o,e,d,t,f+2,true,y)
}}}
if(s>0){
p+="\n"+AjxStringUtil.repeat(" ",f-1)
}
if(n){
p+=h?"]":"}"
}}}}}}}}
return p
};
AjxStringUtil._escapeForHTML=function(t){
if(typeof(t)!="string"){
return t
}
var e=t;
e=e.replace(/\&/g,"&amp;");
e=e.replace(/\</g,"&lt;");
e=e.replace(/\>/g,"&gt;");
e=e.replace(/\"/g,"&quot;");
e=e.replace(/\xA0/g,"&nbsp;");
return e
};
AjxStringUtil._testSpan;
AjxStringUtil._testSpanBold;
AjxStringUtil.WIDTH={};
AjxStringUtil.WIDTH_BOLD={};
AjxStringUtil.MAX_CACHE=1000;
AjxStringUtil._cacheSize=0;
AjxStringUtil.getWidth=function(r,n){
if(!AjxStringUtil._testSpan){
var o=AjxStringUtil._testSpan=document.createElement("SPAN");
var i=AjxStringUtil._testSpanBold=document.createElement("SPAN");
o.style.position=i.style.position=Dwt.ABSOLUTE_STYLE;
var a=DwtShell.getShell(window).getHtmlElement();
a.appendChild(o);
a.appendChild(i);
Dwt.setLocation(o,Dwt.LOC_NOWHERE,Dwt.LOC_NOWHERE);
Dwt.setLocation(i,Dwt.LOC_NOWHERE,Dwt.LOC_NOWHERE);
i.style.fontWeight="bold"
}
var t=n?AjxStringUtil.WIDTH_BOLD:AjxStringUtil.WIDTH;
if(t[r]){
return t[r]
}
if(AjxStringUtil._cacheSize>=AjxStringUtil.MAX_CACHE){
AjxStringUtil.WIDTH={};
AjxStringUtil.WIDTH_BOLD={};
AjxStringUtil._cacheSize=0
}
var s=n?AjxStringUtil._testSpanBold:AjxStringUtil._testSpan;
s.innerHTML=r;
var e=t[r]=Dwt.getSize(s).x;
AjxStringUtil._cacheSize++;
return e
};
AjxStringUtil.fixCrossDomainReference=function(t,a){
var o=AjxStringUtil.parseURL(t);
if(o.authority==window.location.host){
return t
}
if((a&&t.indexOf(a)>=0)||!a){
var i=o.protocol+"://"+o.authority;
var e=window.location.protocol+"//"+window.location.host;
t=t.replace(i,e)
}
return t
};
AjxStringUtil._dummyDiv=document.createElement("DIV");
AjxStringUtil.htmlPlatformIndependent=function(t){
var a=AjxStringUtil._dummyDiv;
a.innerHTML=t;
var e=a.innerHTML;
a.innerHTML="";
return e
};
AjxStringUtil.equalsHtmlPlatformIndependent=function(t,e){
return AjxStringUtil.htmlPlatformIndependent(t)==AjxStringUtil.htmlPlatformIndependent(e)
};
AjxStringUtil.quoteString=function(a,t){
a=a||"";
var e=t?'"':"'";
return e+a+e
};
AjxStringUtil.buildAttribute=function(a,o,e,i,t,s){
if(!a){
return""
}
var n=(e===false)?"":" ";
n+=(a+"=");
if(t){
o=escape(o)
}else{
if(s){
o=AjxStringUtil.htmlEncode(o)
}}
n+=AjxStringUtil.quoteString(o,i);
return n
};
