
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
(function(){
tinymce.create("tinymce.plugins.FullPagePlugin",{
init:function(t,e){
var i=this;
i.editor=t;
t.addCommand("mceFullPageProperties",function(){
t.windowManager.open({
file:e+"/fullpage.htm",width:430+parseInt(t.getLang("fullpage.delta_width",0)),height:495+parseInt(t.getLang("fullpage.delta_height",0)),inline:1}
,{
plugin_url:e,head_html:i.head}
)
}
);
t.addButton("fullpage",{
title:"fullpage.desc",cmd:"mceFullPageProperties"}
);
t.onBeforeSetContent.add(i._setContent,i);
t.onSetContent.add(i._setBodyAttribs,i);
t.onGetContent.add(i._getContent,i)
}
,getInfo:function(){
return{
longname:"Fullpage",author:"Moxiecode Systems AB",authorurl:"http://tinymce.moxiecode.com",infourl:"http://wiki.moxiecode.com/index.php/TinyMCE:Plugins/fullpage",version:tinymce.majorVersion+"."+tinymce.minorVersion}
}
,_setBodyAttribs:function(u,y){
var t,m,r,n,p,o,i,s=this.head.match(/body(.*?)>/i);
if(s&&s[1]){
t=s[1].match(/\s*(\w+\s*=\s*".*?"|\w+\s*=\s*'.*?'|\w+\s*=\s*\w+|\w+)\s*/g);
if(t){
for(m=0,r=t.length;
m<r;
m++){
n=t[m].split("=");
p=n[0].replace(/\s/,"");
o=n[1];
if(o){
o=o.replace(/^\s+/,"").replace(/\s+$/,"");
i=o.match(/^["'](.*)["']$/);
if(i){
o=i[1]
}}else{
o=p
}
u.dom.setAttrib(u.getBody(),"style",o)
}}}}
,_createSerializer:function(){
return new tinymce.dom.Serializer({
dom:this.editor.dom,apply_source_formatting:true}
)
}
,_setContent:function(c,u){
var n=this,m,t,r=u.content,s,o="";
if(u.source_view&&c.getParam("fullpage_hide_in_source_view")){
return
}
r=r.replace(/<(\/?)BODY/gi,"<$1body");
m=r.indexOf("<body");
if(m!=-1){
m=r.indexOf(">",m);
n.head=r.substring(0,m+1);
t=r.indexOf("</body",m);
if(t==-1){
t=r.indexOf("</body",t)
}
u.content=r.substring(m+1,t);
n.foot=r.substring(t);
function l(e){
return e.replace(/<\/?[A-Z]+/g,function(a){
return a.toLowerCase()
}
)
}
n.head=l(n.head);
n.foot=l(n.foot)
}else{
n.head="";
if(c.getParam("fullpage_default_xml_pi")){
n.head+='<?xml version="1.0" encoding="'+c.getParam("fullpage_default_encoding","ISO-8859-1")+'" ?>\n'
}
n.head+=c.getParam("fullpage_default_doctype",'<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">');
n.head+="\n<html>\n<head>\n<title>"+c.getParam("fullpage_default_title","Untitled document")+"</title>\n";
if(s=c.getParam("fullpage_default_encoding")){
n.head+='<meta http-equiv="Content-Type" content="'+s+'" />\n'
}
if(s=c.getParam("fullpage_default_font_family")){
o+="font-family: "+s+";"
}
if(s=c.getParam("fullpage_default_font_size")){
o+="font-size: "+s+";"
}
if(s=c.getParam("fullpage_default_text_color")){
o+="color: "+s+";"
}
n.head+="</head>\n<body"+(o?' style="'+o+'"':"")+">\n";
n.foot="\n</body>\n</html>"
}}
,_getContent:function(t,i){
var e=this;
if(!i.source_view||!t.getParam("fullpage_hide_in_source_view")){
i.content=tinymce.trim(e.head)+"\n"+tinymce.trim(i.content)+"\n"+tinymce.trim(e.foot)
}}}
);
tinymce.PluginManager.add("fullpage",tinymce.plugins.FullPagePlugin)
}
)();
