
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
(function(){
var e=tinymce.each;
tinymce.create("tinymce.plugins.PastePlugin",{
init:function(i,o){
var n=this,a;
n.editor=i;
n.url=o;
n.onPreProcess=new tinymce.util.Dispatcher(n);
n.onPostProcess=new tinymce.util.Dispatcher(n);
n.onPreProcess.add(n._preProcess);
n.onPostProcess.add(n._postProcess);
n.onPreProcess.add(function(t,h){
i.execCallback("paste_preprocess",t,h)
}
);
n.onPostProcess.add(function(t,h){
i.execCallback("paste_postprocess",t,h)
}
);
function r(h){
var t=i.dom;
n.onPreProcess.dispatch(n,h);
h.node=t.create("div",0,h.content);
n.onPostProcess.dispatch(n,h);
h.content=i.serializer.serialize(h.node,{
getInner:1}
);
if(/<(p|h[1-6]|ul|ol)/.test(h.content)){
n._insertBlockContent(i,t,h.content)
}else{
n._insert(h.content)
}}
i.addCommand("mceInsertClipboardContent",function(t,h){
r(h)
}
);
function s(d){
var f,c,h,l=i.selection,m=i.dom,t=i.getBody(),u;
if(m.get("_mcePaste")){
return
}
f=m.add(t,"div",{
id:"_mcePaste"}
,"&nbsp;");
if(t!=i.getDoc().body){
u=m.getPos(i.selection.getStart(),t).y
}else{
u=t.scrollTop
}
m.setStyles(f,{
position:"absolute",left:-10000,top:u,width:1,height:1,overflow:"hidden"}
);
if(tinymce.isIE){
h=m.doc.body.createTextRange();
h.moveToElementText(f);
h.execCommand("Paste");
m.remove(f);
if(f.innerHTML==="&nbsp;"){
return
}
r({
content:f.innerHTML}
);
return tinymce.dom.Event.cancel(d)
}else{
c=i.selection.getRng();
f=f.firstChild;
h=i.getDoc().createRange();
h.setStart(f,0);
h.setEnd(f,1);
l.setRng(h);
window.setTimeout(function(){
var p="";
e(m.select("div[id=_mcePaste]").reverse(),function(g){
p+=(m.select("> span.Apple-style-span div",g)[0]||m.select("> span.Apple-style-span",g)[0]||g).innerHTML;
m.remove(g)
}
);
if(c){
l.setRng(c)
}
r({
content:p}
)
}
,0)
}}
if(i.getParam("paste_auto_cleanup_on_paste",true)){
if(tinymce.isOpera||/Firefox\/2/.test(navigator.userAgent)){
i.onKeyDown.add(function(t,h){
if(((tinymce.isMac?h.metaKey:h.ctrlKey)&&h.keyCode==86)||(h.shiftKey&&h.keyCode==45)){
s(h)
}}
)
}else{
i.onPaste.addToTop(function(t,h){
return s(h)
}
)
}}
if(i.getParam("paste_block_drop")){
i.onInit.add(function(){
i.dom.bind(i.getBody(),["dragend","dragover","draggesture","dragdrop","drop","drag"],function(t){
t.preventDefault();
t.stopPropagation();
return false
}
)
}
)
}
n._legacySupport()
}
,getInfo:function(){
return{
longname:"Paste text/word",author:"Moxiecode Systems AB",authorurl:"http://tinymce.moxiecode.com",infourl:"http://wiki.moxiecode.com/index.php/TinyMCE:Plugins/paste",version:tinymce.majorVersion+"."+tinymce.minorVersion}
}
,_preProcess:function(i,r){
var t=this.editor,a=r.content,s,n;
function s(o){
e(o,function(h){
if(h.constructor==RegExp){
a=a.replace(h,"")
}else{
a=a.replace(h[0],h[1])
}}
)
}
if(/(class=\"?Mso|style=\"[^\"]*\bmso\-|w:WordDocument)/.test(a)||r.wordContent){
r.wordContent=true;
s([/^\s*(&nbsp;)+/g,/(&nbsp;|<br[^>]*>)+\s*$/g]);
if(t.getParam("paste_convert_middot_lists",true)){
s([[/<!--\[if !supportLists\]-->/gi,"$&__MCE_ITEM__"],[/(<span[^>]+:\s*symbol[^>]+>)/gi,"$1__MCE_ITEM__"],[/(<span[^>]+mso-list:[^>]+>)/gi,"$1__MCE_ITEM__"]])
}
s([/<!--[\s\S]+?-->/gi,/<\/?(img|font|meta|link|style|div|v:\w+)[^>]*>/gi,/<\\?\?xml[^>]*>/gi,/<\/?o:[^>]*>/gi,/ (id|name|language|type|on\w+|v:\w+)=\"([^\"]*)\"/gi,/ (id|name|language|type|on\w+|v:\w+)=(\w+)/gi,[/<(\/?)s>/gi,"<$1strike>"],/<script[^>]+>[\s\S]*?<\/script>/gi,[/&nbsp;/g,"\u00a0"]]);
if(!t.getParam("paste_retain_style_properties")){
s([/<\/?(span)[^>]*>/gi])
}}
n=t.getParam("paste_strip_class_attributes","all");
if(n!="none"){
if(n=="all"){
s([/ class=\"([^\"]*)\"/gi,/ class=(\w+)/gi])
}else{
s([/ class=\"(mso[^\"]*)\"/gi,/ class=(mso\w+)/gi])
}}
if(t.getParam("paste_remove_spans")){
s([/<\/?(span)[^>]*>/gi])
}
r.content=a
}
,_postProcess:function(s,h){
var n=this,i=n.editor,r=i.dom,a;
if(h.wordContent){
e(r.select("a",h.node),function(t){
if(!t.href||t.href.indexOf("#_Toc")!=-1){
r.remove(t,1)
}}
);
if(n.editor.getParam("paste_convert_middot_lists",true)){
n._convertLists(s,h)
}
a=i.getParam("paste_retain_style_properties");
if(tinymce.is(a,"string")){
a=tinymce.explode(a)
}
e(r.select("*",h.node),function(c){
var d={}
,o=0,l,u,t;
if(a){
for(l=0;
l<a.length;
l++){
u=a[l];
t=r.getStyle(c,u);
if(t){
d[u]=t;
o++
}}}
r.setAttrib(c,"style","");
if(a&&o>0){
r.setStyles(c,d)
}else{
if(c.nodeName=="SPAN"&&!c.className){
r.remove(c,true)
}}}
)
}
if(i.getParam("paste_remove_styles")||(i.getParam("paste_remove_styles_if_webkit")&&tinymce.isWebKit)){
e(r.select("*[style]",h.node),function(t){
t.removeAttribute("style");
t.removeAttribute("mce_style")
}
)
}else{
if(tinymce.isWebKit){
e(r.select("*",h.node),function(t){
t.removeAttribute("mce_style")
}
)
}}}
,_convertLists:function(n,a){
var r=n.editor.dom,s,c,t=-1,i,d=[],l,h;
e(r.select("p",a.node),function(y){
var m,b="",g,f,o,u;
for(m=y.firstChild;
m&&m.nodeType==3;
m=m.nextSibling){
b+=m.nodeValue
}
b=y.innerHTML.replace(/<\/?\w+[^>]*>/gi,"").replace(/&nbsp;/g,"\u00a0");
if(/^(__MCE_ITEM__)+[\u2022\u00b7\u00a7\u00d8o]\s*\u00a0*/.test(b)){
g="ul"
}
if(/^__MCE_ITEM__\s*\w+\.\s*\u00a0{2,}/.test(b)){
g="ol"
}
if(g){
i=parseFloat(y.style.marginLeft||0);
if(i>t){
d.push(i)
}
if(!s||g!=l){
s=r.create(g);
r.insertAfter(s,y)
}else{
if(i>t){
s=c.appendChild(r.create(g))
}else{
if(i<t){
o=tinymce.inArray(d,i);
u=r.getParents(s.parentNode,g);
s=u[u.length-1-o]||s
}}}
e(r.select("span",y),function(w){
var p=w.innerHTML.replace(/<\/?\w+[^>]*>/gi,"");
if(g=="ul"&&/^[\u2022\u00b7\u00a7\u00d8o]/.test(p)){
r.remove(w)
}else{
if(/^[\s\S]*\w+\.(&nbsp;|\u00a0)*\s*/.test(p)){
r.remove(w)
}}}
);
f=y.innerHTML;
if(g=="ul"){
f=y.innerHTML.replace(/__MCE_ITEM__/g,"").replace(/^[\u2022\u00b7\u00a7\u00d8o]\s*(&nbsp;|\u00a0)+\s*/,"")
}else{
f=y.innerHTML.replace(/__MCE_ITEM__/g,"").replace(/^\s*\w+\.(&nbsp;|\u00a0)+\s*/,"")
}
c=s.appendChild(r.create("li",0,f));
r.remove(y);
t=i;
l=g
}else{
s=t=0
}}
);
h=a.node.innerHTML;
if(h.indexOf("__MCE_ITEM__")!=-1){
a.node.innerHTML=h.replace(/__MCE_ITEM__/g,"")
}}
,_insertBlockContent:function(r,o,h){
var a,s,i=r.selection,u,l,t,c,n;
function d(f){
var m;
if(tinymce.isIE){
m=r.getDoc().body.createTextRange();
m.moveToElementText(f);
m.collapse(false);
m.select()
}else{
i.select(f,1);
i.collapse(false)
}}
this._insert('<span id="_marker">&nbsp;</span>',1);
s=o.get("_marker");
a=o.getParent(s,"p,h1,h2,h3,h4,h5,h6,ul,ol,th,td");
if(a&&!/TD|TH/.test(a.nodeName)){
s=o.split(a,s);
e(o.create("div",0,h).childNodes,function(m){
u=s.parentNode.insertBefore(m.cloneNode(true),s)
}
);
d(u)
}else{
o.setOuterHTML(s,h);
i.select(r.getBody(),1);
i.collapse(0)
}
o.remove("_marker");
l=i.getStart();
t=o.getViewPort(r.getWin());
c=r.dom.getPos(l).y;
n=l.clientHeight;
if(c<t.y||c+n>t.y+t.h){
r.getDoc().body.scrollTop=c<t.y?c:c-t.h+25
}}
,_insert:function(i,t){
var a=this.editor;
if(!a.selection.isCollapsed()){
a.getDoc().execCommand("Delete",false,null)
}
a.execCommand(tinymce.isGecko?"insertHTML":"mceInsertContent",false,i,{
skip_undo:t}
)
}
,_legacySupport:function(){
var i=this,a=i.editor;
e(["mcePasteText","mcePasteWord"],function(t){
a.addCommand(t,function(){
a.windowManager.open({
file:i.url+(t=="mcePasteText"?"/pastetext.htm":"/pasteword.htm"),width:parseInt(a.getParam("paste_dialog_width","450")),height:parseInt(a.getParam("paste_dialog_height","400")),inline:1}
)
}
)
}
);
a.addButton("pastetext",{
title:"paste.paste_text_desc",cmd:"mcePasteText"}
);
a.addButton("pasteword",{
title:"paste.paste_word_desc",cmd:"mcePasteWord"}
);
a.addButton("selectall",{
title:"paste.selectall_desc",cmd:"selectall"}
)
}}
);
tinymce.PluginManager.add("paste",tinymce.plugins.PastePlugin)
}
)();
