
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
(function(){
tinymce.create("tinymce.plugins.XHTMLXtrasPlugin",{
init:function(t,a){
t.addCommand("mceCite",function(){
t.windowManager.open({
file:a+"/cite.htm",width:350+parseInt(t.getLang("xhtmlxtras.cite_delta_width",0)),height:250+parseInt(t.getLang("xhtmlxtras.cite_delta_height",0)),inline:1}
,{
plugin_url:a}
)
}
);
t.addCommand("mceAcronym",function(){
t.windowManager.open({
file:a+"/acronym.htm",width:350+parseInt(t.getLang("xhtmlxtras.acronym_delta_width",0)),height:250+parseInt(t.getLang("xhtmlxtras.acronym_delta_width",0)),inline:1}
,{
plugin_url:a}
)
}
);
t.addCommand("mceAbbr",function(){
t.windowManager.open({
file:a+"/abbr.htm",width:350+parseInt(t.getLang("xhtmlxtras.abbr_delta_width",0)),height:250+parseInt(t.getLang("xhtmlxtras.abbr_delta_width",0)),inline:1}
,{
plugin_url:a}
)
}
);
t.addCommand("mceDel",function(){
t.windowManager.open({
file:a+"/del.htm",width:340+parseInt(t.getLang("xhtmlxtras.del_delta_width",0)),height:310+parseInt(t.getLang("xhtmlxtras.del_delta_width",0)),inline:1}
,{
plugin_url:a}
)
}
);
t.addCommand("mceIns",function(){
t.windowManager.open({
file:a+"/ins.htm",width:340+parseInt(t.getLang("xhtmlxtras.ins_delta_width",0)),height:310+parseInt(t.getLang("xhtmlxtras.ins_delta_width",0)),inline:1}
,{
plugin_url:a}
)
}
);
t.addCommand("mceAttributes",function(){
t.windowManager.open({
file:a+"/attributes.htm",width:380,height:370,inline:1}
,{
plugin_url:a}
)
}
);
t.addButton("cite",{
title:"xhtmlxtras.cite_desc",cmd:"mceCite"}
);
t.addButton("acronym",{
title:"xhtmlxtras.acronym_desc",cmd:"mceAcronym"}
);
t.addButton("abbr",{
title:"xhtmlxtras.abbr_desc",cmd:"mceAbbr"}
);
t.addButton("del",{
title:"xhtmlxtras.del_desc",cmd:"mceDel"}
);
t.addButton("ins",{
title:"xhtmlxtras.ins_desc",cmd:"mceIns"}
);
t.addButton("attribs",{
title:"xhtmlxtras.attribs_desc",cmd:"mceAttributes"}
);
if(tinymce.isIE){
function e(i,n){
if(n.set){
n.content=n.content.replace(/<abbr([^>]+)>/gi,"<html:abbr $1>");
n.content=n.content.replace(/<\/abbr>/gi,"</html:abbr>")
}}
t.onBeforeSetContent.add(e);
t.onPostProcess.add(e)
}
t.onNodeChange.add(function(o,i,r,s){
r=o.dom.getParent(r,"CITE,ACRONYM,ABBR,DEL,INS");
i.setDisabled("cite",s);
i.setDisabled("acronym",s);
i.setDisabled("abbr",s);
i.setDisabled("del",s);
i.setDisabled("ins",s);
i.setDisabled("attribs",r&&r.nodeName=="BODY");
i.setActive("cite",0);
i.setActive("acronym",0);
i.setActive("abbr",0);
i.setActive("del",0);
i.setActive("ins",0);
if(r){
do{
i.setDisabled(r.nodeName.toLowerCase(),0);
i.setActive(r.nodeName.toLowerCase(),1)
}
while(r=r.parentNode)
}}
)
}
,getInfo:function(){
return{
longname:"XHTML Xtras Plugin",author:"Moxiecode Systems AB",authorurl:"http://tinymce.moxiecode.com",infourl:"http://wiki.moxiecode.com/index.php/TinyMCE:Plugins/xhtmlxtras",version:tinymce.majorVersion+"."+tinymce.minorVersion}
}}
);
tinymce.PluginManager.add("xhtmlxtras",tinymce.plugins.XHTMLXtrasPlugin)
}
)();
