
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
if(AjxPackage.define("DocsPreview")){
if(AjxPackage.define("ajax.util.AjxStringUtil")){
AjxStringUtil=function(){};
AjxStringUtil.TRIM_RE=/^\s+|\s+$/g;
AjxStringUtil.COMPRESS_RE=/\s+/g;
AjxStringUtil.ELLIPSIS=" ... ";
AjxStringUtil.LIST_SEP=", ";
AjxStringUtil.makeString=function(e){
return e?String(e):""
};
AjxStringUtil.capitalize=function(e){
return e.length>0?e.charAt(0).toUpperCase()+e.substr(1).toLowerCase():""
};
AjxStringUtil.capitalizeWords=function(e){
return AjxUtil.map(e.split(/\s+/g),AjxStringUtil.capitalize).join(" ")
};
AjxStringUtil.toMixed=function(s,e,o){
if(!s||(typeof s!="string")){
return""
}
e=e||/\s+/;
var a=s.split(e);
var n=[];
n.push(o?a[0].toLowerCase():a[0].substring(0,1).toUpperCase()+a[0].substring(1).toLowerCase());
for(var t=1;
t<a.length;
t++){
n.push(a[t].substring(0,1).toUpperCase()+a[t].substring(1).toLowerCase())
}
return n.join("")
};
AjxStringUtil.fromMixed=function(t,e){
e=["$1",e||" ","$2"].join("");
return AjxStringUtil.trim(t.replace(/([a-z])([A-Z]+)/g,e))
};
AjxStringUtil.trim=function(o,e,i){
if(!o){
return""
}
var a=AjxStringUtil.TRIM_RE;
var t=AjxStringUtil.COMPRESS_RE;
if(i){
a=new RegExp("^"+i+"+|"+i+"+$","g");
t=new RegExp(i+"+","g")
}else{
i=" "
}
o=o.replace(a,"");
if(e){
o=o.replace(t,i)
}
return o
};
AjxStringUtil.repeat=function(o,e){
var a="";
for(var t=0;
t<e;
t++){
a+=o
}
return a
};
AjxStringUtil.getUnitsFromSizeString=function(t){
var a="px";
if(typeof(t)=="string"){
var e=Number(parseInt(t,10)).toString();
if(t.length>e.length){
a=t.substr(e.length,(t.length-e.length));
if(!(a=="em"||a=="ex"||a=="px"||a=="in"||a=="cm"==a=="mm"||a=="pt"||a=="pc"||a=="%")){
a="px"
}}}
return a
};
AjxStringUtil.split=function(l,o){
if(!l){
return[]
}
var s=0;
o=o?o:",";
var u=new Object();
if(typeof o=="string"){
u[o]=1
}else{
for(s=0;
s<o.length;
s++){
u[o[s]]=1
}}
var e=false;
var a=0;
var t=0;
var d;
var r=[];
var n=0;
for(s=0;
s<l.length;
s++){
var h=l.charAt(s);
if(h=='"'){
e=!e
}else{
if(h=="("){
a++
}else{
if(h==")"){
a--
}else{
if(u[h]){
if(!e&&!a){
d=l.substring(t,s);
r[n++]=d;
t=s+1
}}}}}}
d=l.substring(t,l.length);
r[n++]=d;
return r
};
AjxStringUtil.splitKeepLeadingWhitespace=function(t){
var i=/\s*\S+/g;
var o=[];
var e;
while(e=i.exec(t)){
var a=e[0];
o.push(a)
}
return o
};
AjxStringUtil.wordWrap=function(F){
if(!(F&&F.text)){
return""
}
var g=F.text;
var y=F.before||"",t=F.after||"";
if(F.htmlMode){
return[y,g,t].join("")
}
var B=F.len||80;
var x=F.pre||"";
var n="\n";
g=AjxStringUtil.trim(g,false,"[\t ]");
g=g.replace(/\r\n/g,n);
var e=g.split(n);
var k=[];
for(var z=0,S=e.length;
z<S;
z++){
var c=e[z];
var q=c.match(/^([\s>\|]+)/);
var T=q?q[1]:"";
if(T){
c=c.substr(T.length)
}
var r=AjxStringUtil.splitKeepLeadingWhitespace(c);
if(r&&r[0]&&r[0].length){
var j=AjxStringUtil.MSG_SEP_RE.test(c)||AjxStringUtil.COLON_RE.test(c)||AjxStringUtil.HDR_RE.test(c)||AjxStringUtil.SIG_RE.test(c);
for(var d=0,f=r.length;
d<f;
d++){
var s=F.preserveReturns&&(d==f-1);
k.push({
w:r[d],p:T,special:(j&&d==0),lastWord:s}
)
}}else{
k.push({
para:true,p:T}
)
}}
var W=F.len||72;
var o=F.pre||"";
var u=o.length;
var h="",a=0,r=[],b=null;
for(var A=0,B=k.length;
A<B;
A++){
var C=k[A];
var d=C.w,v=C.p;
var O=r.length?1:0;
var D=(b===null)?0:b.length;
if(C.para){
if(r.length){
h+=o+(b||"")+r.join("").replace(/^ /,"")+n
}
h+=o+v+n;
r=[];
a=0;
b=null
}else{
if((u+D+a+O+d.length<=W)&&(v==b||b===null)&&!C.special){
r.push(d);
a+=d.length;
b=v;
if(C.lastWord&&k[A+1]){
k[A+1].special=true
}}else{
if(r.length){
h+=o+(b||"")+r.join("").replace(/^ /,"")+n
}
r=[d];
a=d.length;
b=v;
if(C.lastWord&&k[A+1]){
k[A+1].special=true
}}}}
if(r.length){
h+=o+b+r.join("").replace(/^ /,"")+n
}
return[y,h,t].join("")
};
AjxStringUtil.quoteText=function(i){
if(!(i&&i.text)){
return""
}
var h=i.text;
var r=i.before||"",e=i.after||"";
if(i.htmlMode||!i.pre){
return[r,h,e].join("")
}
var n=i.len||80;
var a=i.pre||"";
var s="\n";
h=AjxStringUtil.trim(h);
h=h.replace(/\n\r/g,s);
var u=h.split(s);
var d=[];
for(var t=0,o=u.length;
t<o;
t++){
var c=AjxStringUtil.trim(u[t]);
d.push(a+c+s)
}
return r+d.join("")+e
};
AjxStringUtil.SHIFT_CHAR={
48:")",49:"!",50:"@",51:"#",52:"$",53:"%",54:"^",55:"&",56:"*",57:"(",59:":",186:":",187:"+",188:"<",189:"_",190:">",191:"?",192:"~",219:"{",220:"|",221:"}",222:'"'};
AjxStringUtil.shiftChar=function(e,t){
return t?AjxStringUtil.SHIFT_CHAR[e]||String.fromCharCode(e):String.fromCharCode(e)
};
AjxStringUtil.diffPoint=function(o,a){
if(!(o&&a)){
return 0
}
var e=Math.min(o.length,a.length);
var t=0;
while(t<e&&(o.charAt(t)==a.charAt(t))){
t++
}
return t
};
AjxStringUtil.resolve=function(t,e){
return AjxMessageFormat.format(t,e)
};
AjxStringUtil.urlEncode=function(t){
if(!t){
return""
}
var e=window.encodeURL||window.encodeURI;
return e(t)
};
AjxStringUtil.urlComponentEncode=function(t){
if(!t){
return""
}
var e=window.encodeURLComponent||window.encodeURIComponent;
return e(t)
};
AjxStringUtil.urlDecode=function(t){
if(!t){
return""
}
var e=window.decodeURL||window.decodeURI;
return e(t)
};
AjxStringUtil.urlComponentDecode=function(o){
if(!o){
return""
}
var a=window.decodeURLComponent||window.decodeURIComponent;
var t;
try{
t=a(o)
}
catch(i){
t=unescape(o)
}
return t||o
};
AjxStringUtil.ENCODE_MAP={
">":"&gt;","<":"&lt;","&":"&amp;"};
AjxStringUtil.htmlEncode=function(t,e){
if(!t){
return""
}
if(!AjxEnv.isSafari||AjxEnv.isSafariNightly){
if(e){
return t.replace(/[<>&]/g,function(a){
return AjxStringUtil.ENCODE_MAP[a]
}
).replace(/  /g," &nbsp;")
}else{
return t.replace(/[<>&]/g,function(a){
return AjxStringUtil.ENCODE_MAP[a]
}
)
}}else{
if(e){
return t.replace(/[&]/g,"&amp;").replace(/  /g," &nbsp;").replace(/[<]/g,"&lt;").replace(/[>]/g,"&gt;")
}else{
return t.replace(/[&]/g,"&amp;").replace(/[<]/g,"&lt;").replace(/[>]/g,"&gt;")
}}};
AjxStringUtil.htmlDecode=function(t,e){
if(e){
t=t.replace(/&nbsp;/g," ")
}
return t.replace(/&amp;/g,"&").replace(/&lt;/g,"<").replace(/&gt;/g,">")
};
AjxStringUtil.stripTags=function(t,e){
if(!t){
return""
}
if(e){
t=t.replace(/(<(\w+)[^>]*>).*(<\/\2[^>]*>)/,"$1$3")
}
return t.replace(/<\/?[^>]+>/gi,"")
};
AjxStringUtil.convertToHtml=function(r,s){
if(!r){
return""
}
if(s){
var n=/^(>|\|\s+)/;
var t=r.split(/\r?\n/);
var h=0;
for(var a=0;
a<t.length;
a++){
var e=t[a];
if(e.length>0){
var o=0;
while(e.match(n)){
e=e.replace(n,"");
o++
}
while(o>h){
e="<blockquote>"+e;
h++
}
while(o<h){
e=e+"</blockquote>";
h--
}}
t[a]=e
}
while(h>0){
t.push("</blockquote>");
h--
}
r=t.join("\n");
r=r.replace(/&/mg,"&amp;");
r=r.replace(/<(?!\/?blockquote)/mg,"&lt;");
r=r.replace(/(\/?blockquote)?>/mg,function(l,i){
return i?l:"&gt;"
}
)
}else{
r=r.replace(/&/mg,"&amp;").replace(/</mg,"&lt;").replace(/>/mg,"&gt;")
}
r=r.replace(/  /mg," &nbsp;").replace(/^ /mg,"&nbsp;").replace(/\t/mg,"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;").replace(/\r?\n/mg,"<br>");
return r
};
AjxStringUtil.SPACE_ENCODE_MAP={
" ":"&nbsp;",">":"&gt;","<":"&lt;","&":"&amp;","\n":"<br>"};
AjxStringUtil.htmlEncodeSpace=function(e){
if(!e){
return""
}
return e.replace(/[&]/g,"&amp;").replace(/ /g,"&nbsp;").replace(/[<]/g,"&lt;").replace(/[>]/g,"&gt;")
};
AjxStringUtil.htmlRubyEncode=function(e,t){
if(e&&t){
return["<ruby>","<rb>",AjxStringUtil.htmlEncode(e),"</rb> ","<rp>(</rp><rt>",AjxStringUtil.htmlEncode(t),"</rt><rp>)</rp>","</ruby>"].join("")
}
return AjxStringUtil.htmlEncode(e||t||"")
};
AjxStringUtil.nl2br=function(e){
if(!e){
return""
}
return e.replace(/^ /mg,"&nbsp;").replace(/\t/mg,"<span style='white-space:pre'>\t</span>").replace(/\n/g,"<br>")
};
AjxStringUtil.xmlEncode=function(e){
if(e){
e=""+e;
return e.replace(/&/g,"&amp;").replace(/</g,"&lt;")
}
return""
};
AjxStringUtil.xmlDecode=function(e){
return e?e.replace(/&amp;/g,"&").replace(/&lt;/g,"<"):""
};
AjxStringUtil.xmlAttrEncode=function(e){
return e?e.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/\x22/g,"&quot;").replace(/\x27/g,"&apos;"):""
};
AjxStringUtil.xmlAttrDecode=function(e){
return e?e.replace(/&amp;/g,"&").replace(/&lt;/g,"<").replace(/&quot;/g,'"').replace(/&apos;/g,"'"):""
};
AjxStringUtil.__RE_META={
" ":" ","\n":"\\n","\r":"\\r","\t":"\\t"};
AjxStringUtil.__reMetaEscape=function(t,e){
return AjxStringUtil.__RE_META[e]||"\\"+e
};
AjxStringUtil.regExEscape=function(e){
return e.replace(/(\W)/g,AjxStringUtil.__reMetaEscape)
};
AjxStringUtil._calcDIV=null;
AjxStringUtil.calcDIV=function(){
if(AjxStringUtil._calcDIV==null){
AjxStringUtil._calcDIV=document.createElement("div");
AjxStringUtil._calcDIV.style.zIndex=0;
AjxStringUtil._calcDIV.style.position=DwtControl.ABSOLUTE_STYLE;
AjxStringUtil._calcDIV.style.visibility="hidden";
document.body.appendChild(AjxStringUtil._calcDIV)
}
return AjxStringUtil._calcDIV
};
AjxStringUtil.clip=function(e,s,n){
var o=AjxStringUtil.calcDIV();
if(arguments.length==3){
o.className=n
}
o.innerHTML=e;
if(o.offsetWidth<=s){
return e
}
for(var a=e.length-1;
a>0;
a--){
var t=e.substr(0,a);
o.innerHTML=t+AjxStringUtil.ELLIPSIS;
if(o.offsetWidth<=s){
return t+AjxStringUtil.ELLIPSIS
}}
return e
};
AjxStringUtil.clipByLength=function(a,t){
var e=a.length;
return(e<=t)?a:[a.substr(0,t/2),"...",a.substring(e-((t/2)-3),e)].join("")
};
AjxStringUtil.wrap=function(n,s,r){
var u=AjxStringUtil.calcDIV();
if(arguments.length==3){
u.className=r
}
var h="";
var o="";
var e=n.split("/n");
for(var i=0;
i<e.length;
i++){
if(i!=0){
h+=o+"<br>";
o=""
}
htmlRows=e[i].split("<br>");
for(var c=0;
c<htmlRows.length;
c++){
if(c!=0){
h+=o+"<br>";
o=""
}
words=htmlRows[c].split(" ");
var d=0;
while(d<words.length){
u.innerHTML=o+" "+words[d];
var a=u.offsetWidth;
if(a>s){
u.innerHTML=words[d];
a=a-u.offsetWidth;
if((a>=s)||(u.offsetWidth<=s)){
h+=o+"<br>";
o=""
}else{
var l=true;
var t=0;
while(l){
t++;
u.innerHTML=o+" "+words[d].substring(0,t);
l=(u.offsetWidth<=s)
}
t--;
h+=o+words[d].substring(0,t)+"<br>";
words[d]=words[d].substr(t);
o=""
}}else{
o+=" "+words[d];
d++
}}}}
h+=o;
return h
};
AjxStringUtil.MSG_SEP_RE=new RegExp("^\\s*--+\\s*("+AjxMsg.origMsg+"|"+AjxMsg.forwardedMessage+")\\s*--+","i");
AjxStringUtil.SIG_RE=/^(- ?-+)|(__+)\r?$/;
AjxStringUtil.COLON_RE=/\S+:$/;
AjxStringUtil.PREFIX_RE=/^\s*(&gt;|>|\|)/;
AjxStringUtil.BRACKET_RE=/^\s*\[.+\]\s*$/;
AjxStringUtil.LINE_RE=/^\s*_{30,}\s*$/;
AjxStringUtil.BLANK_RE=/^\s*$/;
AjxStringUtil.SPLIT_RE=/\r\n|\r|\n/;
AjxStringUtil.HDR_RE=/^\s*\w+:/;
AjxStringUtil.HTML_BLANK_RE=/^\s*(<br\s*\/?>)*\s*$/i;
AjxStringUtil.HTML_BR_RE=/<br\s*\/?>/gi;
AjxStringUtil.HTML_BODY_RE=/<body(\s|>)/i;
AjxStringUtil.HTML_QUOTE_PRE_RE=/^\s*<blockquote/i;
AjxStringUtil.HTML_QUOTE_POST_RE=/^\s*<\/blockquote>/i;
AjxStringUtil.HTML_QUOTE_COLOR="#1010FF";
AjxStringUtil.HTML_QUOTE_STYLE="color:#000;font-weight:normal;font-style:normal;text-decoration:none;font-family:Helvetica,Arial,sans-serif;font-size:12pt;";
AjxStringUtil.getTopLevel=function(m,h,t){
if(!m){
return[""]
}
var e=/<br|<div/i.test(m);
var l=e?AjxStringUtil.HTML_BR_RE:AjxStringUtil.SPLIT_RE;
var h=e?"<br>":"\n";
m=AjxStringUtil._trimBlankLines(m,l,h,e);
var f=m.split(l);
var s=f.length;
var o=0,a=0;
var n=[];
var r=false;
while(o<s){
var u=r;
var d=AjxStringUtil._linesToSkip(f,o,t);
r=(d>0);
if(u&&!r){
a=o
}else{
if(!u&&r&&o>a){
var c=AjxStringUtil._trimBlankLines(f.slice(a,o).join(h),l,h,t);
if(c&&c.length){
n.push(c)
}}}
o+=r?d:1
}
if(!r&&o>a){
var c=AjxStringUtil._trimBlankLines(f.slice(a,o).join(h),l,h,t);
if(c&&c.length){
n.push(c)
}}
return n
};
AjxStringUtil._linesToSkip=function(l,a,e){
var o=l.length;
var h=0;
var t=a;
var c=e?AjxStringUtil.stripTags(l[a]):l[a];
if(AjxStringUtil.MSG_SEP_RE.test(c)){
h=o-a
}else{
if(AjxStringUtil.PREFIX_RE.test(c)){
while(a<l.length&&(AjxStringUtil.PREFIX_RE.test(c)||AjxStringUtil.BLANK_RE.test(c))){
a++;
c=e?AjxStringUtil.stripTags(l[a]):l[a]
}
h=a-t
}else{
if(AjxStringUtil.HTML_QUOTE_PRE_RE.test(c)&&c.indexOf(AjxStringUtil.HTML_QUOTE_COLOR)!=-1){
while(a<l.length&&(!AjxStringUtil.HTML_QUOTE_POST_RE.test(c))){
a++;
c=l[a]
}
if(a<l.length){
l[a]=l[a].replace(AjxStringUtil.HTML_QUOTE_POST_RE,"")
}
h=a-t
}else{
if(AjxStringUtil.COLON_RE.test(c)){
var s=AjxStringUtil._nextNonBlankLineIndex(l,a+1,e);
var r=(s==-1)?null:e?AjxStringUtil.stripTags(l[s]):l[s];
if(r&&AjxStringUtil.PREFIX_RE.test(r)){
h=s-a
}else{
if(s!=-1){
s=AjxStringUtil._nextNonBlankLineIndex(l,s+1,e)
}
var n=(s==-1)?null:e?AjxStringUtil.stripTags(l[s]):l[s];
if(n&&AjxStringUtil.BRACKET_RE.test(r)&&AjxStringUtil.PREFIX_RE.test(n)){
h=s-a
}}}else{
if(AjxStringUtil.LINE_RE.test(c)){
var s=AjxStringUtil._nextNonBlankLineIndex(l,a+1,e);
var r=(s==-1)?null:e?AjxStringUtil.stripTags(l[s]):l[s];
if(r&&AjxStringUtil.HDR_RE.test(r)){
h=o-a
}}else{
if(AjxStringUtil.SIG_RE.test(c)){
h=o-a
}}}}}}
return h
};
AjxStringUtil._nextNonBlankLineIndex=function(e,t,a){
while(t<e.length&&AjxStringUtil.BLANK_RE.test(a?AjxStringUtil.stripTags(e[t]):e[t])){
t++
}
return((t<e.length)?t:-1)
};
AjxStringUtil._trimBlankLines=function(r,s,n,e){
var l=r.split(s);
var o=l.length;
var h=e?AjxStringUtil.HTML_BLANK_RE:AjxStringUtil.BLANK_RE;
var a=0;
while(a<o&&h.test(l[a])){
a++
}
var t=o;
while(t>0&&h.test(l[t-1])){
t--
}
if(a!=0||t!=o){
r=l.slice(a,t).join(n)+n
}
if(e&&AjxStringUtil.HTML_BODY_RE.test(r)){
r=r.replace(/<body\s*[^>]*>(<br\s*\/?>)+/i,"<body>");
r=r.replace(/(<br\s*\/?>)+<\/body>/i,"</body>")
}
return r
};
AjxStringUtil._NO_LIST=0;
AjxStringUtil._ORDERED_LIST=1;
AjxStringUtil._UNORDERED_LIST=2;
AjxStringUtil._INDENT="    ";
AjxStringUtil._NON_WHITESPACE=/\S+/;
AjxStringUtil._LF=/\n/;
AjxStringUtil.convertHtml2Text=function(i,n,o){
if(!i){
return null
}
if(n&&AjxUtil.isFunction(n._before)){
i=n._before(i)
}
if(typeof i=="string"){
var s=document.createElement("SPAN");
s.innerHTML=i;
i=s
}
var r=[];
var a=0;
var t={};
this._traverse(i,r,a,AjxStringUtil._NO_LIST,0,0,t,n,o);
var e=r.join("");
if(n&&AjxUtil.isFunction(n._after)){
e=n._after(e)
}
return e
};
AjxStringUtil._traverse=function(e,f,d,l,r,n,s,c,u){
var h=e.nodeName.toLowerCase();
var p=null;
if(c&&c[h]){
p=c[h](e,s)
}
if(p!=null){
f[d++]=p
}else{
if(h=="#text"){
if(e.nodeValue.search(AjxStringUtil._NON_WHITESPACE)!=-1){
if(s.lastNode=="ol"||s.lastNode=="ul"){
f[d++]="\n"
}
if(s.isPreformatted){
f[d++]=AjxStringUtil.trim(e.nodeValue)+" "
}else{
f[d++]=AjxStringUtil.trim(e.nodeValue.replace(AjxStringUtil._LF," "),true)+" "
}}}else{
if(h=="p"){
f[d++]=u?"\n":"\n\n"
}else{
if(l==AjxStringUtil._NO_LIST&&(h=="br"||h=="hr")){
f[d++]="\n"
}else{
if(h=="ol"||h=="ul"){
f[d++]="\n";
if(e.parentNode.nodeName.toLowerCase()!="li"&&s.lastNode!="br"&&s.lastNode!="hr"){
f[d++]="\n"
}
l=(h=="ol")?AjxStringUtil._ORDERED_LIST:AjxStringUtil._UNORDERED_LIST;
r++;
n=0
}else{
if(h=="li"){
for(var a=0;
a<r;
a++){
f[d++]=AjxStringUtil._INDENT
}
if(l==AjxStringUtil._ORDERED_LIST){
f[d++]=n+". "
}else{
f[d++]="\u002A "
}}else{
if(h=="img"){
if(e.alt&&e.alt!=""){
f[d++]=e.alt
}}else{
if(h=="tr"&&e.parentNode.firstChild!=e){
f[d++]="\n"
}else{
if(h=="td"&&e.parentNode.firstChild!=e){
f[d++]="\t"
}else{
if(h=="div"){
f[d++]="\n"
}else{
if(h=="blockquote"){
f[d++]="\n\n"
}else{
if(h=="pre"){
s.isPreformatted=true
}else{
if(h=="#comment"||h=="script"||h=="select"||h=="style"){
return d
}}}}}}}}}}}}}
var m=e.childNodes;
var o=m.length;
for(var a=0;
a<o;
a++){
var t=m[a];
if(t.nodeType==1&&t.tagName.toLowerCase()=="li"){
n++
}
d=this._traverse(t,f,d,l,r,n,s,c,u)
}
if(c&&c["/"+h]){
f[d++]=c["/"+h](e)
}
if(h=="h1"||h=="h2"||h=="h3"||h=="h4"||h=="h5"||h=="h6"){
f[d++]="\n";
s.list=false
}else{
if(h=="pre"){
s.isPreformatted=false
}else{
if(h=="li"){
if(!s.list){
f[d++]="\n"
}
s.list=false
}else{
if(h=="ol"||h=="ul"){
s.list=true
}else{
if(h!="#text"){
s.list=false
}}}}}
s.lastNode=h;
return d
};
AjxStringUtil.queryStringSet=function(r,l){
var h=l?"":location.search;
if(h.indexOf("?")==0){
h=h.substr(1)
}
var s=h.split("&");
var a={};
for(var o=0;
o<s.length;
o++){
var n=s[o].split("=");
a[n[0]]=n[1]
}
for(var e in r){
a[e]=r[e]
}
var t=[];
var o=0;
for(var e in a){
if(e){
t[o++]=[e,a[e]].join("=")
}}
return"?"+t.join("&")
};
AjxStringUtil.queryStringRemove=function(e,a){
e=e?e:"";
if(e.indexOf("?")==0){
e=e.substr(1)
}
var n=e.split("&");
var t=[];
for(var o=0;
o<n.length;
o++){
if(n[o].indexOf(a)!=0){
t.push(n[o])
}}
return"?"+t.join("&")
};
AjxStringUtil.getAsString=function(e){
return !e?"":(typeof(e)=="object")?e.toString():e
};
AjxStringUtil.isWhitespace=function(e){
return(e.charCodeAt(0)<=32)
};
AjxStringUtil.isDigit=function(t){
var e=t.charCodeAt(0);
return(e>=48&&e<=57)
};
AjxStringUtil.compareRight=function(o,t){
var n=0;
var r=0;
var s=0;
var i;
var e;
for(;
(r<o.length||s<t.length);
r++,s++){
i=o.charAt(r);
e=t.charAt(s);
if(!AjxStringUtil.isDigit(i)&&!AjxStringUtil.isDigit(e)){
return n
}else{
if(!AjxStringUtil.isDigit(i)){
return -1
}else{
if(!AjxStringUtil.isDigit(e)){
return +1
}else{
if(i<e){
if(n==0){
n=-1
}}else{
if(i>e){
if(n==0){
n=+1
}}}}}}}};
AjxStringUtil.natCompare=function(h,r){
var s=0,o=0;
var t=0,e=0;
var n,i;
while(s<h.length||o<r.length){
t=e=0;
n=h.charAt(s);
i=r.charAt(o);
while(AjxStringUtil.isWhitespace(n)||n=="0"){
t=(n=="0")?(t+1):0;
n=h.charAt(++s)
}
while(AjxStringUtil.isWhitespace(i)||i=="0"){
e=(i=="0")?(e+1):0;
i=r.charAt(++o)
}
if(AjxStringUtil.isDigit(n)&&AjxStringUtil.isDigit(i)){
var l=AjxStringUtil.compareRight(h.substring(s),r.substring(o));
if(l&&l!=0){
return l
}}
if(n==0&&i==0){
return t-e
}
if(n<i){
return -1
}else{
if(n>i){
return +1
}}
++s;
++o
}};
AjxStringUtil.clipFile=function(n,t){
var a=n.lastIndexOf(".");
var e=a?(a+1):n.length;
if(e<=t){
return n
}else{
var o=n.substr(0,a);
var i=n.substr(a+1,n.length-1);
return[o.substr(0,t/2),"...",o.substring(e-((t/2)-3),e),".",(i?i:"")].join("")
}};
AjxStringUtil.URL_PARSE_RE=new RegExp("^(?:([^:/?#.]+):)?(?://)?(([^:/?#]*)(?::(\\d*))?)?((/(?:[^?#](?![^?#/]*\\.[^?#/.]+(?:[\\?#]|$)))*/?)?([^?#/]*))?(?:\\?([^#]*))?(?:#(.*))?");
AjxStringUtil.parseURL=function(a){
var n=["source","protocol","authority","domain","port","path","directoryPath","fileName","query","anchor"];
var o=AjxStringUtil.URL_PARSE_RE.exec(a);
var t={};
for(var e=0;
e<n.length;
e++){
t[n[e]]=(o[e]?o[e]:"")
}
if(t.directoryPath.length>0){
t.directoryPath=t.directoryPath.replace(/\/?$/,"/")
}
return t
};
AjxStringUtil.parseQueryString=function(s){
var a=s||(""+window.location);
var t=a.indexOf("?");
if(t==-1){
return null
}
var e=a.substring(t+1).replace(/#.*$/,"");
var n=e.split("&");
var h={};
for(var o=0;
o<n.length;
o++){
var r=n[o].split("=");
h[r[0]]=r[1]
}
return h
};
AjxStringUtil._SPECIAL_CHARS=/["\\\x00-\x1f]/g;
AjxStringUtil._CHARS={
"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f","\r":"\\r",'"':'\\"',"\\":"\\\\"};
AjxStringUtil.objToString=function(n){
var f=typeof n,h,l,r,s,u,m,c,e=[];
var d=function(i){
if(!AjxStringUtil._CHARS[i]){
var t=i.charCodeAt();
AjxStringUtil._CHARS[i]="\\u00"+Math.floor(t/16).toString(16)+(t%16).toString(16)
}
return AjxStringUtil._CHARS[i]
};
var p=function(t){
return'"'+t.replace(AjxStringUtil._SPECIAL_CHARS,d)+'"'
};
if(n===null){
return"null"
}
if(f==="string"){
return p(n)
}
if(f==="boolean"||n instanceof Boolean){
return String(n)
}
if(f==="number"||n instanceof Number){
return isFinite(n)?String(n):"null"
}
if(AjxUtil.isArray(n)||(f==="object"&&n.length)){
for(h=e.length-1;
h>=0;
--h){
if(e[h]===n){
return"null"
}}
e[e.length]=n;
c=[];
for(h=n.length-1;
h>=0;
--h){
c[h]=AjxStringUtil.objToString(n[h])
}
e.pop();
return"["+c.join(",")+"]"
}
if(f==="object"&&n){
for(h=e.length-1;
h>=0;
--h){
if(e[h]===n){
return"null"
}}
e[e.length]=n;
c=[];
r=0;
for(s in n){
if(typeof s==="string"&&n.hasOwnProperty(s)){
u=n[s];
m=typeof u;
if(m!=="undefined"&&m!=="function"){
c[r++]=p(s)+":"+AjxStringUtil.objToString(u)
}}}
e.pop();
return"{"+c.join(",")+"}"
}
return"null"
};
AjxStringUtil.prettyPrint=function(i,a,e,t){
AjxStringUtil._visited=new AjxVector();
var o=AjxStringUtil._prettyPrint(i,a,e,t);
AjxStringUtil._visited=null;
return o
};
AjxStringUtil._visited=null;
AjxStringUtil._prettyPrint=function(r,e,d,t){
var f=0;
var n=false;
var y=false;
if(arguments.length>4){
f=arguments[4];
n=arguments[5];
y=arguments[6]
}
if(AjxUtil.isObject(r)){
var c=r.toString?r.toString():"";
if(t&&c&&t[c]){
return"["+c+"]"
}
if(AjxStringUtil._visited.contains(r)){
return"[visited object]"
}else{
AjxStringUtil._visited.add(r)
}}
var a=AjxStringUtil.repeat(" ",f);
var p="";
if(r===undefined){
p+="[undefined]"
}else{
if(r===null){
p+="[null]"
}else{
if(AjxUtil.isBoolean(r)){
p+=r?"true":"false"
}else{
if(AjxUtil.isString(r)){
p+='"'+AjxStringUtil._escapeForHTML(r)+'"'
}else{
if(AjxUtil.isNumber(r)){
p+=r
}else{
if(AjxUtil.isObject(r)){
var h=AjxUtil.isArray(r);
if(y){
p+=h?"[Array]":r.toString()
}else{
y=!e;
var g=new Array();
for(var s in r){
g.push(s)
}
if(h){
g.sort(function(w,i){
return w-i
}
)
}else{
g.sort()
}
if(n){
p+=h?"[":"{"
}
var l=g.length;
for(var s=0;
s<l;
s++){
var m=g[s];
var o=r[m];
var u=null;
if(o==window||o==document||(!AjxEnv.isIE&&o instanceof Node)){
u=o.toString()
}
if((typeof(o)=="function")){
if(d){
u="[function]"
}else{
continue
}}
if(s>0){
p+=","
}
p+="\n"+a;
if(t&&t[m]){
p+=m+": ["+m+"]"
}else{
if(u!=null){
p+=m+": "+u
}else{
p+=m+": "+this._prettyPrint(o,e,d,t,f+2,true,y)
}}}
if(s>0){
p+="\n"+AjxStringUtil.repeat(" ",f-1)
}
if(n){
p+=h?"]":"}"
}}}}}}}}
return p
};
AjxStringUtil._escapeForHTML=function(t){
if(typeof(t)!="string"){
return t
}
var e=t;
e=e.replace(/\&/g,"&amp;");
e=e.replace(/\</g,"&lt;");
e=e.replace(/\>/g,"&gt;");
e=e.replace(/\"/g,"&quot;");
e=e.replace(/\xA0/g,"&nbsp;");
return e
};
AjxStringUtil._testSpan;
AjxStringUtil._testSpanBold;
AjxStringUtil.WIDTH={};
AjxStringUtil.WIDTH_BOLD={};
AjxStringUtil.MAX_CACHE=1000;
AjxStringUtil._cacheSize=0;
AjxStringUtil.getWidth=function(r,n){
if(!AjxStringUtil._testSpan){
var o=AjxStringUtil._testSpan=document.createElement("SPAN");
var i=AjxStringUtil._testSpanBold=document.createElement("SPAN");
o.style.position=i.style.position=Dwt.ABSOLUTE_STYLE;
var a=DwtShell.getShell(window).getHtmlElement();
a.appendChild(o);
a.appendChild(i);
Dwt.setLocation(o,Dwt.LOC_NOWHERE,Dwt.LOC_NOWHERE);
Dwt.setLocation(i,Dwt.LOC_NOWHERE,Dwt.LOC_NOWHERE);
i.style.fontWeight="bold"
}
var t=n?AjxStringUtil.WIDTH_BOLD:AjxStringUtil.WIDTH;
if(t[r]){
return t[r]
}
if(AjxStringUtil._cacheSize>=AjxStringUtil.MAX_CACHE){
AjxStringUtil.WIDTH={};
AjxStringUtil.WIDTH_BOLD={};
AjxStringUtil._cacheSize=0
}
var s=n?AjxStringUtil._testSpanBold:AjxStringUtil._testSpan;
s.innerHTML=r;
var e=t[r]=Dwt.getSize(s).x;
AjxStringUtil._cacheSize++;
return e
};
AjxStringUtil.fixCrossDomainReference=function(t,a){
var o=AjxStringUtil.parseURL(t);
if(o.authority==window.location.host){
return t
}
if((a&&t.indexOf(a)>=0)||!a){
var i=o.protocol+"://"+o.authority;
var e=window.location.protocol+"//"+window.location.host;
t=t.replace(i,e)
}
return t
};
AjxStringUtil._dummyDiv=document.createElement("DIV");
AjxStringUtil.htmlPlatformIndependent=function(t){
var a=AjxStringUtil._dummyDiv;
a.innerHTML=t;
var e=a.innerHTML;
a.innerHTML="";
return e
};
AjxStringUtil.equalsHtmlPlatformIndependent=function(t,e){
return AjxStringUtil.htmlPlatformIndependent(t)==AjxStringUtil.htmlPlatformIndependent(e)
};
AjxStringUtil.quoteString=function(a,t){
a=a||"";
var e=t?'"':"'";
return e+a+e
};
AjxStringUtil.buildAttribute=function(a,o,e,i,t,s){
if(!a){
return""
}
var n=(e===false)?"":" ";
n+=(a+"=");
if(t){
o=escape(o)
}else{
if(s){
o=AjxStringUtil.htmlEncode(o)
}}
n+=AjxStringUtil.quoteString(o,i);
return n
}
}
if(AjxPackage.define("ajax.util.AjxUtil")){
AjxUtil=function(){};
AjxUtil.FLOAT_RE=/^[+\-]?((\d+(\.\d*)?)|((\d*\.)?\d+))([eE][+\-]?\d+)?$/;
AjxUtil.NOTFLOAT_RE=/[^\d\.]/;
AjxUtil.NOTINT_RE=/[^0-9]+/;
AjxUtil.LIFETIME_FIELD=/^([0-9])+([dhms]|ms)?$/;
AjxUtil.isSpecified=function(e){
return((e!==void 0)&&(e!==null))
};
AjxUtil.isUndefined=function(e){
return(e===void 0)
};
AjxUtil.isNull=function(e){
return(e===null)
};
AjxUtil.isBoolean=function(e){
return(typeof(e)=="boolean")
};
AjxUtil.isString=function(e){
return(typeof(e)=="string")
};
AjxUtil.isNumber=function(e){
return(typeof(e)=="number")
};
AjxUtil.isObject=function(e){
return((typeof(e)=="object")&&(e!==null))
};
AjxUtil.isArray=function(e){
return AjxUtil.isInstance(e,Array)
};
AjxUtil.isFunction=function(e){
return(typeof(e)=="function")
};
AjxUtil.isDate=function(e){
return AjxUtil.isInstance(e,Date)
};
AjxUtil.isLifeTime=function(e){
return AjxUtil.LIFETIME_FIELD.test(e)
};
AjxUtil.isNumeric=function(e){
return(!isNaN(parseFloat(e))&&AjxUtil.FLOAT_RE.test(e)&&!AjxUtil.NOTFLOAT_RE.test(e))
};
AjxUtil.isLong=function(e){
return(AjxUtil.isNumeric(e)&&!AjxUtil.NOTINT_RE.test(e))
};
AjxUtil.isNonNegativeLong=function(e){
return(AjxUtil.isNumeric(e)&&AjxUtil.isLong(e)&&(parseFloat(e)>=0))
};
AjxUtil.isInt=function(e){
return(AjxUtil.isNumeric(e)&&!AjxUtil.NOTINT_RE.test(e))
};
AjxUtil.isPositiveInt=function(e){
return(AjxUtil.isNumeric(e)&&AjxUtil.isInt(e)&&(parseInt(e)>0))
};
AjxUtil.isEmpty=function(e){
return(AjxUtil.isNull(e)||AjxUtil.isUndefined(e)||(e==="")||(AjxUtil.isArray(e)&&(e.length==0)))
};
AjxUtil.IP_ADDRESS_RE=/^\d{1,3}(\.\d{1,3}){3}(\.\d{1,3}\.\d{1,3})?$/;
AjxUtil.IP_ADDRESS_WITH_PORT_RE=/^\d{1,3}(\.\d{1,3}){3}(\.\d{1,3}\.\d{1,3})?:\d{1,5}$/;
AjxUtil.SUBNET_RE=/^\d{1,3}(\.\d{1,3}){3}(\.\d{1,3}\.\d{1,3})?\/\d{1,2}$/;
AjxUtil.DOMAIN_NAME_SHORT_RE=/^[A-Za-z0-9\-]{2,}$/;
AjxUtil.DOMAIN_NAME_FULL_RE=/^[A-Za-z0-9\-]{1,}(\.[A-Za-z0-9\-]{2,}){1,}$/;
AjxUtil.HOST_NAME_RE=/^[A-Za-z0-9\-]{2,}(\.[A-Za-z0-9\-]{1,})*(\.[A-Za-z0-9\-]{2,})*$/;
AjxUtil.HOST_NAME_WITH_PORT_RE=/^[A-Za-z0-9\-]{2,}(\.[A-Za-z0-9\-]{2,})*:([0-9])+$/;
AjxUtil.EMAIL_SHORT_RE=/^[^@\s]+$/;
AjxUtil.EMAIL_FULL_RE=/^[^@\s]+@[A-Za-z0-9\-]{2,}(\.[A-Za-z0-9\-]{2,})+$/;
AjxUtil.SHORT_URL_RE=/^[A-Za-z0-9]{2,}:\/\/[A-Za-z0-9\-]+(\.[A-Za-z0-9\-]+)*(:([0-9])+)?$/;
AjxUtil.IP_SHORT_URL_RE=/^[A-Za-z0-9]{2,}:\/\/\d{1,3}(\.\d{1,3}){3}(\.\d{1,3}\.\d{1,3})?(:([0-9])+)?$/;
AjxUtil.isIpAddress=function(e){
return AjxUtil.IP_ADDR_RE.test(e)
};
AjxUtil.isDomain=function(e){
return AjxUtil.DOMAIN_RE.test(e)
};
AjxUtil.isHostName=function(e){
return AjxUtil.HOST_NAME_RE.test(e)
};
AjxUtil.isDomainName=function(t,e){
return e?AjxUtil.DOMAIN_NAME_SHORT_RE.test(t):AjxUtil.DOMAIN_NAME_FULL_RE.test(t)
};
AjxUtil.isEmailAddress=function(t,e){
return e?AjxUtil.EMAIL_SHORT_RE.test(t):AjxUtil.EMAIL_FULL_RE.test(t)
};
AjxUtil.isValidEmailNonReg=function(e){
return((e.indexOf("@")>0)&&(e.lastIndexOf("@")==e.indexOf("@"))&&(e.indexOf(".@")<0))
};
AjxUtil.SIZE_GIGABYTES="GB";
AjxUtil.SIZE_MEGABYTES="MB";
AjxUtil.SIZE_KILOBYTES="KB";
AjxUtil.SIZE_BYTES="B";
AjxUtil.formatSize=function(o,i,n){
if(i==null){
i=true
}
if(n==null){
n=20
}
var t=AjxMsg.sizeBytes;
var a=AjxMsg.SIZE_BYTES;
if(o>=1073741824){
t=AjxMsg.sizeGigaBytes;
a=AjxUtil.SIZE_GIGABYTES
}else{
if(o>=1048576){
t=AjxMsg.sizeMegaBytes;
a=AjxUtil.SIZE_MEGABYTES
}else{
if(o>1023){
t=AjxMsg.sizeKiloBytes;
a=AjxUtil.SIZE_KILOBYTES
}}}
var e=AjxUtil.formatSizeForUnits(o,a,i,n);
return AjxMessageFormat.format(AjxMsg.formatSizeAndUnits,[e,t])
};
AjxUtil.formatSizeForUnits=function(o,t,e,s){
if(t==null){
t=AjxUtil.SIZE_BYTES
}
if(e==null){
e=true
}
if(s==null){
s=20
}
switch(t){
case AjxUtil.SIZE_GIGABYTES:o/=1073741824;
break;
case AjxUtil.SIZE_MEGABYTES:o/=1048576;
break;
case AjxUtil.SIZE_KILOBYTES:o/=1024;
break
}
var n=I18nMsg.formatNumber.replace(/\..*$/,"");
n=n.replace(/,/,"");
if(!e&&s){
n=n+=".";
for(var a=0;
a<s;
a++){
n+="#"
}}
return AjxNumberFormat.format(n,o)
};
AjxUtil.parseSize=function(t,i){
if(typeof t!=_STRING_){
t=t.toString()
}
var o=parseFloat(t.replace(/^\s*/,""));
var a=/[GMK]?B$/i;
var e=a.exec(t);
if(e){
i=e[0].toUpperCase()
}
switch(i){
case AjxUtil.SIZE_GIGABYTES:o*=1073741824;
break;
case AjxUtil.SIZE_MEGABYTES:o*=1048576;
break;
case AjxUtil.SIZE_KILOBYTES:o*=1024;
break
}
return o
};
AjxUtil.isInstance=function(e,t){
return !!(e&&e.constructor&&(e.constructor===t))
};
AjxUtil.assert=function(e,t){
if(!e&&AjxUtil.onassert){
AjxUtil.onassert(t)
}};
AjxUtil.onassert=function(t){
var l=new Object();
l.message=t;
var c=new Array();
if(AjxEnv.isIE5_5up){
var o=arguments.callee.caller;
var n=0;
while(o&&n++<20){
c[c.length]=o;
o=o.caller
}}else{
try{
var o=arguments.callee.caller;
while(o){
c[c.length]=o;
if(c.length>2){
break
}
o=o.caller
}}
catch(h){}}
l.stack=c;
var r="";
var a=170;
for(var n=1;
n<c.length;
n++){
if(n>1){
r+="\n"
}
if(n<11){
var s=c[n].toString();
if(s.length>a){
s=s.substr(0,a)+"...";
s=s.replace(/\n/g,"")
}
r+=n+": "+s
}else{
r+="("+(c.length-11)+" frames follow)";
break
}}
alert("assertion:\n\n"+t+"\n\n---- Call Stack ---\n"+r);
throw l
};
AjxUtil.ELEMENT_NODE=1;
AjxUtil.TEXT_NODE=3;
AjxUtil.DOCUMENT_NODE=9;
AjxUtil.getInnerText=function(e){
if(AjxEnv.isIE){
return e.innerText
}
function t(s){
if(s){
if(s.nodeType==3){
return s.data
}
if(s.nodeType==1){
if(/^br$/i.test(s.tagName)){
return"\r\n"
}
var o="";
for(var a=s.firstChild;
a;
a=a.nextSibling){
o+=t(a)
}
return o
}}
return""
}
return t(e)
};
AjxUtil.createProxy=function(a,s){
var o;
var t=function(){};
t.prototype=a;
if(a instanceof Array){
o=new Array();
var i=a.length;
for(var e=0;
e<i;
e++){
o[e]=a[e]
}}else{
o=new t
}
if(s){
for(var n in a){
if(typeof a[n]=="object"&&a[n]!==null){
o[n]=AjxUtil.createProxy(a[n],s-1)
}}}
o._object_=a;
return o
};
AjxUtil.unProxy=function(t){
var e=t&&t._object_;
if(e){
for(var a in t){
if(t.hasOwnProperty(a)&&a!="_object_"){
e[a]=t[a]
}}
return e
}
return null
};
AjxUtil.collapseList=function(a){
var t=[];
for(var e=0;
e<a.length;
e++){
if(a[e]){
t.push(a[e])
}}
return t
};
AjxUtil.arrayAsHash=function(r,o){
var s={};
var a=typeof o=="function"&&o;
var n=o||true;
for(var t=0;
t<r.length;
t++){
var e=r[t];
s[e]=a?a(e,s,t,r):n
}
return s
};
AjxUtil.arrayAdd=function(a,t,e){
if(e==null||e<0||e>=a.length){
a.push(t)
}else{
a.splice(e,0,t)
}};
AjxUtil.arrayRemove=function(a,t){
if(a){
for(var e=0;
e<a.length;
e++){
if(a[e]==t){
a.splice(e,1);
return true
}}}
return false
};
AjxUtil.indexOf=function(n,t,e){
if(n){
for(var a=0;
a<n.length;
a++){
var o=n[a];
if((e&&o===t)||(!e&&o==t)){
return a
}}}
return -1
};
AjxUtil.keys=function(t,e){
var a=[];
for(var i in t){
if(e&&!e(i,t)){
continue
}
a.push(i)
}
return a
};
AjxUtil.values=function(a,t){
var e=[];
for(var i in a){
if(t&&!t(i,a)){
continue
}
e.push(a[i])
}
return e
};
AjxUtil.foreach=function(a,t){
if(!t){
return
}
for(var e=0;
e<a.length;
e++){
t(a[e],e)
}};
AjxUtil.map=function(o,a){
var e=new Array(o.length);
for(var t=0;
t<o.length;
t++){
e[t]=a?a(o[t],t):o[t]
}
return e
};
AjxUtil.uniq=function(a){
var e={};
for(var t=0;
t<a.length;
t++){
e[a[t]]=true
}
return AjxUtil.keys(e)
};
AjxUtil.concat=function(t){
var a=[];
for(var e=0;
e<arguments.length;
e++){
a.push.apply(a,arguments[e])
}
return a
};
AjxUtil.union=function(e){
var t=[];
return AjxUtil.uniq(t.concat.apply(t,arguments))
};
AjxUtil.intersection=function(t){
var i=AjxUtil.concat.apply(this,arguments);
var e=AjxUtil.arrayAsHash(i,AjxUtil.__intersection_count);
for(var a in e){
if(e[a]==1){
delete e[a]
}}
return AjxUtil.keys(e)
};
AjxUtil.__intersection_count=function(t,a,e,i){
return a[t]!=null?a[t]+1:1
};
AjxUtil.complement=function(i,t){
var a=AjxUtil.arrayAsHash(i);
var e=AjxUtil.arrayAsHash(t);
for(var o in e){
if(o in a){
delete e[o]
}}
return AjxUtil.keys(e)
};
AjxUtil.getFirstElement=function(o,i,a,t){
for(var n=o.firstChild;
n;
n=n.nextSibling){
if(n.nodeType!=AjxUtil.ELEMENT_NODE){
continue
}
if(i&&n.nodeName!=i){
continue
}
if(a){
var e=n.getAttributeNode(a);
if(e.nodeName!=a){
continue
}
if(t&&e.nodeValue!=t){
continue
}}
return n
}
return null
};
AjxUtil.formatUrl=function(s){
s=s||{};
var a=[];
var o=0;
if(!s.relative){
var n=s.protocol||location.protocol;
if(n.indexOf(":")==-1){
n=n+":"
}
a[o++]=n;
a[o++]="//";
a[o++]=s.host||location.hostname;
var t=Number(s.port||location.port);
if(t&&((n==ZmSetting.PROTO_HTTP&&t!=ZmSetting.HTTP_DEFAULT_PORT)||(n==ZmSetting.PROTO_HTTPS&&t!=ZmSetting.HTTPS_DEFAULT_PORT))){
a[o++]=":";
a[o++]=t
}}
a[o++]=s.path||location.pathname;
var e="";
if(s.qsArgs){
e=AjxStringUtil.queryStringSet(s.qsArgs,s.qsReset)
}else{
e=s.qsReset?"":location.search
}
a[o++]=e;
return a.join("")
};
AjxUtil.byNumber=function(t,e){
return Number(t)-Number(e)
};
AjxUtil.byStringProp=function(i,t,e){
return t[i].localeCompare(e[i])
};
AjxUtil.mergeArrays=function(h,n,e){
if(!e){
e=AjxUtil.__mergeArrays_orderfunc
}
var l=[];
var o=h.length;
for(var t=0;
t<o;
t++){
l.push(h[t])
}
var s=[];
var a=n.length;
for(var t=0;
t<a;
t++){
s.push(n[t])
}
var r=[];
while(l.length>0&&s.length>0){
if(e(l[0],r[r.length-1])==0){
l.shift();
continue
}
if(e(s[0],r[r.length-1])==0){
s.shift();
continue
}
if(e(l[0],s[0])<0){
r.push(l.shift())
}else{
if(e(l[0],s[0])==0){
r.push(l.shift());
s.shift()
}else{
r.push(s.shift())
}}}
while(l.length>0){
if(e(l[0],r[r.length-1])==0){
l.shift();
continue
}
r.push(l.shift())
}
while(s.length>0){
if(e(s[0],r[r.length-1])==0){
s.shift();
continue
}
r.push(s.shift())
}
return r
};
AjxUtil.__mergeArrays_orderfunc=function(t,e){
if(t>e){
return 1
}
if(t<e){
return -1
}
if(t==e){
return 0
}};
AjxUtil.arraySubstract=function(h,n,e){
if(!e){
e=function(c,i){
if(c>i){
return 1
}
if(c<i){
return -1
}
if(c==i){
return 0
}}
}
var l=[];
var o=h.length;
for(var t=0;
t<o;
t++){
l.push(h[t])
}
var s=[];
var a=n.length;
for(var t=0;
t<a;
t++){
s.push(n[t])
}
s.sort(e);
l.sort(e);
var r=[];
while(l.length>0&&s.length>0){
if(e(l[0],s[0])==0){
l.shift();
s.shift();
continue
}
if(e(l[0],s[0])<0){
r.push(l.shift());
continue
}
if(e(l[0],s[0])>0){
s.shift();
continue
}}
while(l.length>0){
r.push(l.shift())
}
return r
};
AjxUtil.getHashKeys=function(a){
var t=[];
for(var e in a){
t.push(e)
}
t.sort();
return t
};
AjxUtil.arrayCompare=function(t,e){
if((!t||!e)&&(t!=e)){
return false
}
if(t.length!=e.length){
return false
}
for(var a=0;
a<t.length;
a++){
if(t[a]!=e[a]){
return false
}}
return true
};
AjxUtil.hashCompare=function(r,s){
var a=AjxUtil.getHashKeys(r);
var t=AjxUtil.getHashKeys(s);
if(!AjxUtil.arrayCompare(a,t)){
return false
}
for(var n=0,e=a.length;
n<e;
n++){
var o=a[n];
if(r[o]!=s[o]){
return false
}}
return true
};
AjxUtil.hashCopy=function(t){
var a={};
for(var e in t){
a[e]=t[e]
}
return a
};
AjxUtil.hashUpdate=function(i,a,e,o){
for(var t in a){
if((e||!(t in i))&&(!o||AjxUtil.indexOf(o,t)==-1)){
i[t]=a[t]
}}
return i
};
AjxUtil.isArray1=function(e){
return Boolean(e&&(e.length!=null)&&e.splice&&e.slice)
};
AjxUtil.toArray=function(e){
return AjxUtil.isArray1(e)?e:(e===undefined)?[]:[e]
};
AjxUtil.get=function(e){
for(var t=1;
e&&t<arguments.length;
t++){
e=e[arguments[t]]
}
return e
}
}
if(AjxPackage.define("ajax.util.AjxTimedAction")){
AjxTimedAction=function(a,t,e){
AjxCallback.call(this,a,t,e);
this._tid=-1;
this._id=-1;
this._runResult=null
};
AjxTimedAction.prototype=new AjxCallback();
AjxTimedAction.prototype.constructor=AjxTimedAction;
AjxTimedAction.MAX_TIMEOUT=20*24*60*60*1000;
AjxTimedAction.prototype.toString=function(){
return"AjxTimedAction"
};
AjxTimedAction.prototype.getRunResult=function(){
return this._runResult
};
AjxTimedAction._pendingActions={};
AjxTimedAction._nextActionId=1;
AjxTimedAction.scheduleAction=function(a,t){
if(!a){
return
}
if(a._tid&&a._tid!=-1){
AjxTimedAction.cancelAction(a._id)
}
t=t||0;
if(t>AjxTimedAction.MAX_TIMEOUT){
if(window.DBG){}
t=AjxTimedAction.MAX_TIMEOUT
}
var i=a._id=AjxTimedAction._nextActionId++;
AjxTimedAction._pendingActions[i]=a;
var e="AjxTimedAction._exec("+i+")";
a._tid=window.setTimeout(e,t);
return a._id
};
AjxTimedAction.cancelAction=function(t){
var e=AjxTimedAction._pendingActions[t];
if(e){
window.clearTimeout(e._tid);
delete AjxTimedAction._pendingActions[t];
delete e._tid
}};
AjxTimedAction._exec=function(a){
try{
var t=AjxTimedAction._pendingActions[a];
if(t){
delete AjxTimedAction._pendingActions[a];
delete t._tid;
t._runResult=t.run()
}}
catch(e){
AjxException.reportScriptError(e)
}}
}
if(AjxPackage.define("ajax.util.AjxText")){
AjxFormat=function(e){
if(arguments.length==0){
return
}
this._pattern=e;
this._segments=[]
};
AjxFormat.prototype.toString=function(){
var t=[];
t.push('pattern="',this._pattern,'"');
if(this._segments.length>0){
t.push(", segments={ ");
for(var e=0;
e<this._segments.length;
e++){
if(e>0){
t.push(", ")
}
t.push(String(this._segments[e]))
}
t.push(" }")
}
return t.join("")
};
AjxFormat.prototype._pattern;
AjxFormat.prototype._segments;
AjxFormat.initialize=function(){
AjxDateFormat.initialize();
AjxNumberFormat.initialize()
};
AjxFormat.prototype.format=function(e){
var a=[];
for(var t=0;
t<this._segments.length;
t++){
a.push(this._segments[t].format(e))
}
return a.join("")
};
AjxFormat.prototype.parse=function(o){
var t=this._createParseObject();
var e=0;
for(var a=0;
a<this._segments.length;
a++){
var n=this._segments[a];
e=n.parse(t,o,e)
}
if(e<o.length){
throw new AjxFormat.ParsingException(this,null,"input too long")
}
return t
};
AjxFormat.prototype.getSegments=function(){
return this._segments
};
AjxFormat.prototype.toPattern=function(){
return this._pattern
};
AjxFormat.prototype.clone=function(){
return new this.constructor(this._pattern)
};
AjxFormat.prototype._createParseObject=function(e){
throw new AjxFormat.ParsingException(this,null,"not implemented")
};
AjxFormat._zeroPad=function(n,r,t,h){
n=typeof n=="string"?n:String(n);
if(n.length>=r){
return n
}
t=t||"0";
var e=[];
for(var o=n.length;
o<r;
o++){
e.push(t)
}
e[h?"unshift":"push"](n);
return e.join("")
};
AjxFormat.FormatException=function(t,e){
this._format=t;
this._message=e
};
AjxFormat.FormatException.prototype.toString=function(){
return this._message
};
AjxFormat.FormatException.prototype._format;
AjxFormat.FormatException.prototype._message;
AjxFormat.FormattingException=function(a,t,e){
AjxFormat.FormatException.call(this,a,e);
this._segment=t
};
AjxFormat.FormattingException.prototype=new AjxFormat.FormatException;
AjxFormat.FormattingException.prototype.constructor=AjxFormat.FormattingException;
AjxFormat.FormattingException.prototype._segment;
AjxFormat.ParsingException=function(a,t,e){
AjxFormat.FormatException.call(this,a,e);
this._segment=t
};
AjxFormat.ParsingException.prototype=new AjxFormat.FormatException;
AjxFormat.ParsingException.prototype.constructor=AjxFormat.ParsingException;
AjxFormat.ParsingException.prototype._segment;
AjxFormat.Segment=function(t,e){
if(arguments.length==0){
return
}
this._parent=t;
this._s=e
};
AjxFormat.Segment.prototype.toString=function(){
return'segment: "'+this._s+'"'
};
AjxFormat.Segment.prototype._parent;
AjxFormat.Segment.prototype._s;
AjxFormat.Segment.prototype.format=function(e){
return this._s
};
AjxFormat.Segment.prototype.parse=function(a,t,e){
throw new AjxFormat.ParsingException(this._parent,this,"not implemented")
};
AjxFormat.Segment.prototype.getFormat=function(){
return this._parent
};
AjxFormat.Segment.prototype.toSubPattern=function(){
return this._s
};
AjxFormat.Segment.prototype._getFixedLength=function(){
var e;
if(this._index+1<this._parent._segments.length){
var t=this._parent._segments[this._index+1];
if(!(t instanceof AjxFormat.TextSegment)){
e=this._s.length
}}
return e
};
AjxFormat.Segment._parseLiteral=function(o,a,e){
if(a.length-e<o.length){
throw new AjxFormat.ParsingException(this._parent,this,"input too short")
}
for(var t=0;
t<o.length;
t++){
if(o.charAt(t)!=a.charAt(e+t)){
throw new AjxFormat.ParsingException(this._parent,this,"input doesn't match")
}}
return e+o.length
};
AjxFormat.Segment._parseLiterals=function(a,h,u,t,p,l){
for(var r=0;
r<t.length;
r++){
try{
var m=t[r];
var n=AjxFormat.Segment._parseLiteral(m,p,l);
if(h){
var d=a||window;
if(typeof h=="function"){
h.call(d,r+u)
}else{
d[h]=r+u
}}
return n
}
catch(c){}}
return -1
};
AjxFormat.Segment._parseInt=function(t,n,p,g,r,e,u){
var h=e||g.length-r;
var d=r;
for(var a=0;
a<h;
a++){
if(!g.charAt(r++).match(/\d/)){
r--;
break
}}
var c=r;
if(d==c){
throw new AjxFormat.ParsingException(this._parent,this,"number not present")
}
if(e&&c-d!=e){
throw new AjxFormat.ParsingException(this._parent,this,"number too short")
}
var m=parseInt(g.substring(d,c),u||10);
if(n){
var l=t||window;
if(typeof n=="function"){
n.call(l,m+p)
}else{
l[n]=m+p
}}
return c
};
AjxDateFormat=function(s){
if(arguments.length==0){
return
}
AjxFormat.call(this,s);
if(s==null){
return
}
if(typeof s=="number"){
switch(s){
case AjxDateFormat.SHORT:s=I18nMsg.formatDateShort;
break;
case AjxDateFormat.MEDIUM:s=I18nMsg.formatDateMedium;
break;
case AjxDateFormat.LONG:s=I18nMsg.formatDateLong;
break;
case AjxDateFormat.FULL:s=I18nMsg.formatDateFull;
break;
case AjxDateFormat.SEARCH:s=I18nMsg.formatDateSearch;
break
}}
for(var a=0;
a<s.length;
a++){
var h=s.charAt(a);
if(h=="'"){
var t=a+1;
for(a++;
a<s.length;
a++){
var h=s.charAt(a);
if(h=="'"){
if(a+1<s.length&&s.charAt(a+1)=="'"){
s=s.substr(0,a)+s.substr(a+1)
}else{
break
}}}
if(a==s.length){}
var e=a;
var n=new AjxFormat.TextSegment(this,s.substring(t,e));
this._segments.push(n);
continue
}
var t=a;
while(a<s.length){
h=s.charAt(a);
if(AjxDateFormat._META_CHARS.indexOf(h)!=-1||h=="'"){
break
}
a++
}
var e=a;
if(t!=e){
var n=new AjxFormat.TextSegment(this,s.substring(t,e));
this._segments.push(n);
a--;
continue
}
var t=a;
while(++a<s.length){
if(s.charAt(a)!=h){
break
}}
var e=a--;
var o=e-t;
var r=s.substr(t,o);
var n=null;
switch(h){
case"G":n=new AjxDateFormat.EraSegment(this,r);
break;
case"y":n=new AjxDateFormat.YearSegment(this,r);
break;
case"M":n=new AjxDateFormat.MonthSegment(this,r);
break;
case"w":n=new AjxDateFormat.WeekSegment(this,r);
break;
case"W":n=new AjxDateFormat.WeekSegment(this,r);
break;
case"D":n=new AjxDateFormat.DaySegment(this,r);
break;
case"d":n=new AjxDateFormat.DaySegment(this,r);
break;
case"F":n=new AjxDateFormat.WeekdaySegment(this,r);
break;
case"E":n=new AjxDateFormat.WeekdaySegment(this,r);
break;
case"a":n=new AjxDateFormat.AmPmSegment(this,r);
break;
case"H":n=new AjxDateFormat.HourSegment(this,r);
break;
case"k":n=new AjxDateFormat.HourSegment(this,r);
break;
case"K":n=new AjxDateFormat.HourSegment(this,r);
break;
case"h":n=new AjxDateFormat.HourSegment(this,r);
break;
case"m":n=new AjxDateFormat.MinuteSegment(this,r);
break;
case"s":n=new AjxDateFormat.SecondSegment(this,r);
break;
case"S":n=new AjxDateFormat.SecondSegment(this,r);
break;
case"z":n=new AjxDateFormat.TimezoneSegment(this,r);
break;
case"Z":n=new AjxDateFormat.TimezoneSegment(this,r);
break
}
if(n!=null){
n._index=this._segments.length;
this._segments.push(n)
}}};
AjxDateFormat.prototype=new AjxFormat;
AjxDateFormat.prototype.constructor=AjxDateFormat;
AjxDateFormat.prototype.toString=function(){
return"[AjxDateFormat: "+AjxFormat.prototype.toString.call(this)+"]"
};
AjxDateFormat.SHORT=0;
AjxDateFormat.MEDIUM=1;
AjxDateFormat.LONG=2;
AjxDateFormat.FULL=3;
AjxDateFormat.DEFAULT=AjxDateFormat.MEDIUM;
AjxDateFormat.SEARCH=4;
AjxDateFormat._META_CHARS="GyMwWDdFEaHkKhmsSzZ";
AjxDateFormat.getDateInstance=function(e){
e=e!=null?e:AjxDateFormat.DEFAULT;
if(!AjxDateFormat._DATE_FORMATTERS[e]){
AjxDateFormat._DATE_FORMATTERS[e]=new AjxDateFormat(AjxDateFormat._dateFormats[e])
}
return AjxDateFormat._DATE_FORMATTERS[e]
};
AjxDateFormat.getTimeInstance=function(e){
e=e!=null?e:AjxDateFormat.DEFAULT;
if(!AjxDateFormat._TIME_FORMATTERS[e]){
AjxDateFormat._TIME_FORMATTERS[e]=new AjxDateFormat(AjxDateFormat._timeFormats[e])
}
return AjxDateFormat._TIME_FORMATTERS[e]
};
AjxDateFormat.getDateTimeInstance=function(e,t){
e=e!=null?e:AjxDateFormat.DEFAULT;
t=t!=null?t:AjxDateFormat.DEFAULT;
var i=e*10+t;
if(!AjxDateFormat._DATETIME_FORMATTERS[i]){
var o=I18nMsg.formatDateTime;
var n=[AjxDateFormat._dateFormats[e],AjxDateFormat._timeFormats[t]];
var a=AjxMessageFormat.format(o,n);
AjxDateFormat._DATETIME_FORMATTERS[i]=new AjxDateFormat(a)
}
return AjxDateFormat._DATETIME_FORMATTERS[i]
};
AjxDateFormat.format=function(t,e){
return new AjxDateFormat(t).format(e)
};
AjxDateFormat.parse=function(t,e){
return new AjxDateFormat(t).parse(e)
};
AjxDateFormat.initialize=function(){
AjxDateFormat._dateFormats=[I18nMsg.formatDateShort,I18nMsg.formatDateMedium,I18nMsg.formatDateLong,I18nMsg.formatDateFull,I18nMsg.formatDateSearch];
AjxDateFormat._timeFormats=[I18nMsg.formatTimeShort,I18nMsg.formatTimeMedium,I18nMsg.formatTimeLong,I18nMsg.formatTimeFull];
AjxDateFormat._timeParsers=[];
for(var t=1,e;
e=I18nMsg["parseTime"+t];
t++){
AjxDateFormat._timeParsers.push(new RegExp(e,"i"))
}
AjxDateFormat._DATE_FORMATTERS={};
AjxDateFormat._TIME_FORMATTERS={};
AjxDateFormat._DATETIME_FORMATTERS={};
AjxDateFormat.MonthSegment.initialize();
AjxDateFormat.WeekdaySegment.initialize()
};
AjxDateFormat.parseTime=function(r){
for(var s=0;
s<AjxDateFormat._timeParsers.length;
s++){
var e=AjxDateFormat._timeParsers[s].exec(r);
if(e){
var a=parseInt(e[1],10)||0;
var n=parseInt(e[2],10)||0;
var o=e[3];
if(o){
var t=I18nMsg.parseTimePMChars;
if(a==12){
a=0
}
if(t.indexOf(o)!=-1){
a+=12
}}
if(a<24&&n<60){
date=new Date();
date.setHours(a);
date.setMinutes(n);
date.setSeconds(0);
return date
}}}};
AjxDateFormat.prototype.parse=function(o){
var i=null;
try{
i=AjxFormat.prototype.parse.call(this,o);
var a=new Date(0,0,1,0,0,0,0);
if(i.year!=null){
a.setFullYear(i.year)
}
if(i.month!=null){
a.setMonth(i.month)
}
if(i.dayofmonth!=null){
a.setDate(i.dayofmonth)
}else{
if(i.dayofyear!=null){
a.setMonth(0,i.dayofyear)
}}
if(i.hours!=null){
a.setHours(i.hours)
}
if(i.minutes!=null){
a.setMinutes(i.minutes)
}
if(i.seconds!=null){
a.setSeconds(i.seconds)
}
if(i.milliseconds!=null){
a.setMilliseconds(i.milliseconds)
}
if(i.ampm!=null){
var t=a.getHours();
if(t==12&&i.ampm==0){
t=0
}else{
if(t!=12&&i.ampm==1){
t+=12
}}
a.setHours(t)
}
if(i.timezone!=null){
a.setMinutes(a.getMinutes()-i.timezone)
}
if(isNaN(a.getTime())){
return null
}
i=a
}
catch(n){}
return i
};
AjxDateFormat.prototype._createParseObject=function(){
return{
year:null,month:null,dayofmonth:null,dayofyear:null,hours:null,minutes:null,seconds:null,milliseconds:null,ampm:null,era:null,timezone:null}
};
AjxFormat.TextSegment=function(t,e){
if(arguments.length==0){
return
}
AjxFormat.Segment.call(this,t,e)
};
AjxFormat.TextSegment.prototype=new AjxFormat.Segment;
AjxFormat.TextSegment.prototype.constructor=AjxFormat.TextSegment;
AjxFormat.TextSegment.prototype.toString=function(){
return'text: "'+this._s+'"'
};
AjxFormat.TextSegment.prototype.parse=function(a,t,e){
return AjxFormat.Segment._parseLiteral(this._s,t,e)
};
AjxDateFormat.DateSegment=function(t,e){
if(arguments.length==0){
return
}
AjxFormat.Segment.call(this,t,e)
};
AjxDateFormat.DateSegment.prototype=new AjxFormat.Segment;
AjxDateFormat.DateSegment.prototype.constructor=AjxDateFormat.DateSegment;
AjxDateFormat.EraSegment=function(t,e){
if(arguments.length==0){
return
}
AjxDateFormat.DateSegment.call(this,t,e)
};
AjxDateFormat.EraSegment.prototype=new AjxDateFormat.DateSegment;
AjxDateFormat.EraSegment.prototype.constructor=AjxDateFormat.EraSegment;
AjxDateFormat.EraSegment.prototype.toString=function(){
return'dateEra: "'+this._s+'"'
};
AjxDateFormat.EraSegment.prototype.format=function(e){
return I18nMsg.eraAD
};
AjxDateFormat.YearSegment=function(t,e){
if(arguments.length==0){
return
}
AjxDateFormat.DateSegment.call(this,t,e)
};
AjxDateFormat.YearSegment.prototype=new AjxDateFormat.DateSegment;
AjxDateFormat.YearSegment.prototype.constructor=AjxDateFormat.YearSegment;
AjxDateFormat.YearSegment.prototype.toString=function(){
return'dateYear: "'+this._s+'"'
};
AjxDateFormat.YearSegment.prototype.format=function(e){
var t=String(e.getFullYear());
return this._s.length<4?t.substr(t.length-2):AjxFormat._zeroPad(t,this._s.length)
};
AjxDateFormat.YearSegment.prototype.parse=function(a,l,o){
var e=this._getFixedLength();
var t=AjxFormat.Segment._parseInt(a,"year",0,l,o,e);
if(t-o==2){
if(!AjxDateFormat._2digitStartYear){
AjxDateFormat._2digitStartYear=parseInt(AjxMsg.dateParsing2DigitStartYear)
}
var r=AjxDateFormat._2digitStartYear;
var h=parseInt(l.substr(o,2),10);
var i=(Math.floor(r/100)+(h<(r%100)?1:0))*100;
var n=i+h;
a.year=n
}
return t
};
AjxDateFormat.MonthSegment=function(t,e){
if(arguments.length==0){
return
}
AjxDateFormat.DateSegment.call(this,t,e)
};
AjxDateFormat.MonthSegment.prototype=new AjxDateFormat.DateSegment;
AjxDateFormat.MonthSegment.prototype.constructor=AjxDateFormat.MonthSegment;
AjxDateFormat.MonthSegment.prototype.toString=function(){
return'dateMonth: "'+this._s+'"'
};
AjxDateFormat.MonthSegment.initialize=function(){
AjxDateFormat.MonthSegment.MONTHS={};
AjxDateFormat.MonthSegment.MONTHS[AjxDateFormat.SHORT]=[AjxMsg.monthJanShort,AjxMsg.monthFebShort,AjxMsg.monthMarShort,AjxMsg.monthAprShort,AjxMsg.monthMayShort,AjxMsg.monthJunShort,AjxMsg.monthJulShort,AjxMsg.monthAugShort,AjxMsg.monthSepShort,AjxMsg.monthOctShort,AjxMsg.monthNovShort,AjxMsg.monthDecShort];
AjxDateFormat.MonthSegment.MONTHS[AjxDateFormat.MEDIUM]=[I18nMsg.monthJanMedium,I18nMsg.monthFebMedium,I18nMsg.monthMarMedium,I18nMsg.monthAprMedium,I18nMsg.monthMayMedium,I18nMsg.monthJunMedium,I18nMsg.monthJulMedium,I18nMsg.monthAugMedium,I18nMsg.monthSepMedium,I18nMsg.monthOctMedium,I18nMsg.monthNovMedium,I18nMsg.monthDecMedium];
AjxDateFormat.MonthSegment.MONTHS[AjxDateFormat.LONG]=[I18nMsg.monthJanLong,I18nMsg.monthFebLong,I18nMsg.monthMarLong,I18nMsg.monthAprLong,I18nMsg.monthMayLong,I18nMsg.monthJunLong,I18nMsg.monthJulLong,I18nMsg.monthAugLong,I18nMsg.monthSepLong,I18nMsg.monthOctLong,I18nMsg.monthNovLong,I18nMsg.monthDecLong]
};
AjxDateFormat.MonthSegment.prototype.format=function(e){
var t=e.getMonth();
switch(this._s.length){
case 1:return String(t+1);
case 2:return AjxFormat._zeroPad(t+1,2);
case 3:return AjxDateFormat.MonthSegment.MONTHS[AjxDateFormat.MEDIUM][t];
case 5:return AjxDateFormat.MonthSegment.MONTHS[AjxDateFormat.SHORT][t]
}
return AjxDateFormat.MonthSegment.MONTHS[AjxDateFormat.LONG][t]
};
AjxDateFormat.MonthSegment.prototype.parse=function(a,o,t){
var e;
switch(this._s.length){
case 3:e=AjxDateFormat.MonthSegment.MONTHS[AjxDateFormat.MEDIUM];
case 4:e=e||AjxDateFormat.MonthSegment.MONTHS[AjxDateFormat.LONG];
case 5:e=e||AjxDateFormat.MonthSegment.MONTHS[AjxDateFormat.SHORT];
var i=AjxFormat.Segment._parseLiterals(a,"month",0,e,o,t);
if(i==-1){
throw new AjxFormat.ParsingException(this._parent,this,"no match")
}
return i
}
var n=this._getFixedLength();
return AjxFormat.Segment._parseInt(a,"month",-1,o,t,n)
};
AjxDateFormat.WeekSegment=function(t,e){
if(arguments.length==0){
return
}
AjxDateFormat.DateSegment.call(this,t,e)
};
AjxDateFormat.WeekSegment.prototype=new AjxDateFormat.DateSegment;
AjxDateFormat.WeekSegment.prototype.constructor=AjxDateFormat.WeekSegment;
AjxDateFormat.WeekSegment.prototype.toString=function(){
return'weekMonth: "'+this._s+'"'
};
AjxDateFormat.WeekSegment.prototype.format=function(t){
var i=t.getYear();
var n=t.getMonth();
var e=t.getDate();
var s=/w/.test(this._s);
var o=new Date(i,s?0:n,1);
var a=0;
while(true){
a++;
if(o.getMonth()>n||(o.getMonth()==n&&o.getDate()>=e)){
break
}
o.setDate(o.getDate()+7)
}
return AjxFormat._zeroPad(a,this._s.length)
};
AjxDateFormat.WeekSegment.prototype.parse=function(t,a,e){
var i=this._getFixedLength();
return AjxFormat.Segment._parseInt(null,null,0,a,e,i)
};
AjxDateFormat.DaySegment=function(t,e){
if(arguments.length==0){
return
}
AjxDateFormat.DateSegment.call(this,t,e)
};
AjxDateFormat.DaySegment.prototype=new AjxDateFormat.DateSegment;
AjxDateFormat.DaySegment.prototype.constructor=AjxDateFormat.DaySegment;
AjxDateFormat.DaySegment.prototype.toString=function(){
return'dateDay: "'+this._s+'"'
};
AjxDateFormat.DaySegment.prototype.format=function(t){
var o=t.getMonth();
var e=t.getDate();
if(/D/.test(this._s)&&o>0){
var a=t.getYear();
do{
var i=new Date(a,o,1);
i.setDate(0);
e+=i.getDate();
o--
}
while(o>0)
}
return AjxFormat._zeroPad(e,this._s.length)
};
AjxDateFormat.DaySegment.prototype.parse=function(t,o,e){
var n=this._getFixedLength();
var i=function(s){
if(s>AjxDateUtil.MAX_DAYS_PER_MONTH){
throw new AjxFormat.ParsingException(this._parent,this,"number too long")
}else{
t.dayofmonth=s
}};
var a=/D/.test(this._s)?"dayofyear":i;
return AjxFormat.Segment._parseInt(t,a,0,o,e,n)
};
AjxDateFormat.WeekdaySegment=function(t,e){
if(arguments.length==0){
return
}
AjxDateFormat.DateSegment.call(this,t,e)
};
AjxDateFormat.WeekdaySegment.prototype=new AjxDateFormat.DateSegment;
AjxDateFormat.WeekdaySegment.prototype.constructor=AjxDateFormat.WeekdaySegment;
AjxDateFormat.DaySegment.prototype.toString=function(){
return'dateDay: "'+this._s+'"'
};
AjxDateFormat.WeekdaySegment.initialize=function(){
AjxDateFormat.WeekdaySegment.WEEKDAYS={};
AjxDateFormat.WeekdaySegment.WEEKDAYS[AjxDateFormat.SHORT]=[AjxMsg.weekdaySunShort,AjxMsg.weekdayMonShort,AjxMsg.weekdayTueShort,AjxMsg.weekdayWedShort,AjxMsg.weekdayThuShort,AjxMsg.weekdayFriShort,AjxMsg.weekdaySatShort];
AjxDateFormat.WeekdaySegment.WEEKDAYS[AjxDateFormat.MEDIUM]=[I18nMsg.weekdaySunMedium,I18nMsg.weekdayMonMedium,I18nMsg.weekdayTueMedium,I18nMsg.weekdayWedMedium,I18nMsg.weekdayThuMedium,I18nMsg.weekdayFriMedium,I18nMsg.weekdaySatMedium];
AjxDateFormat.WeekdaySegment.WEEKDAYS[AjxDateFormat.LONG]=[I18nMsg.weekdaySunLong,I18nMsg.weekdayMonLong,I18nMsg.weekdayTueLong,I18nMsg.weekdayWedLong,I18nMsg.weekdayThuLong,I18nMsg.weekdayFriLong,I18nMsg.weekdaySatLong]
};
AjxDateFormat.WeekdaySegment.prototype.format=function(e){
var a=e.getDay();
if(/E/.test(this._s)){
var t;
switch(this._s.length){
case 4:t=AjxDateFormat.LONG;
break;
case 5:t=AjxDateFormat.SHORT;
break;
default:t=AjxDateFormat.MEDIUM
}
return AjxDateFormat.WeekdaySegment.WEEKDAYS[t][a]
}
return AjxFormat._zeroPad(a,this._s.length)
};
AjxDateFormat.WeekdaySegment.prototype.parse=function(a,o,t){
var e;
switch(this._s.length){
case 3:e=AjxDateFormat.WeekdaySegment.WEEKDAYS[AjxDateFormat.MEDIUM];
case 4:e=e||AjxDateFormat.WeekdaySegment.WEEKDAYS[AjxDateFormat.LONG];
case 5:e=e||AjxDateFormat.WeekdaySegment.WEEKDAYS[AjxDateFormat.SHORT];
var i=AjxFormat.Segment._parseLiterals(null,null,0,e,o,t);
if(i==-1){
throw new AjxFormat.ParsingException(this._parent,this,"no match")
}
return i
}
var n=this._getFixedLength();
return AjxFormat.Segment._parseInt(null,null,0,o,t,n)
};
AjxDateFormat.TimeSegment=function(t,e){
if(arguments.length==0){
return
}
AjxFormat.Segment.call(this,t,e)
};
AjxDateFormat.TimeSegment.prototype=new AjxFormat.Segment;
AjxDateFormat.TimeSegment.prototype.constructor=AjxDateFormat.TimeSegment;
AjxDateFormat.HourSegment=function(t,e){
if(arguments.length==0){
return
}
AjxFormat.Segment.call(this,t,e)
};
AjxDateFormat.HourSegment.prototype=new AjxDateFormat.TimeSegment;
AjxDateFormat.HourSegment.prototype.constructor=AjxDateFormat.HourSegment;
AjxDateFormat.HourSegment.prototype.toString=function(){
return'timeHour: "'+this._s+'"'
};
AjxDateFormat.HourSegment.prototype.format=function(t){
var e=t.getHours();
if(e>12&&/[hK]/.test(this._s)){
e-=12
}else{
if(e==0&&/[h]/.test(this._s)){
e=12
}}
return AjxFormat._zeroPad(e,this._s.length)
};
AjxDateFormat.HourSegment.prototype.parse=function(t,a,e){
var i=this._getFixedLength();
return AjxFormat.Segment._parseInt(t,"hours",0,a,e,i)
};
AjxDateFormat.MinuteSegment=function(t,e){
if(arguments.length==0){
return
}
AjxFormat.Segment.call(this,t,e)
};
AjxDateFormat.MinuteSegment.prototype=new AjxDateFormat.TimeSegment;
AjxDateFormat.MinuteSegment.prototype.constructor=AjxDateFormat.MinuteSegment;
AjxDateFormat.MinuteSegment.prototype.toString=function(){
return'timeMinute: "'+this._s+'"'
};
AjxDateFormat.MinuteSegment.prototype.format=function(e){
var t=e.getMinutes();
return AjxFormat._zeroPad(t,this._s.length)
};
AjxDateFormat.MinuteSegment.prototype.parse=function(t,a,e){
var i=this._getFixedLength();
return AjxFormat.Segment._parseInt(t,"minutes",0,a,e,i)
};
AjxDateFormat.SecondSegment=function(t,e){
if(arguments.length==0){
return
}
AjxFormat.Segment.call(this,t,e)
};
AjxDateFormat.SecondSegment.prototype=new AjxDateFormat.TimeSegment;
AjxDateFormat.SecondSegment.prototype.constructor=AjxDateFormat.SecondSegment;
AjxDateFormat.SecondSegment.prototype.toString=function(){
return'timeSecond: "'+this._s+'"'
};
AjxDateFormat.SecondSegment.prototype.format=function(e){
var t=/s/.test(this._s)?e.getSeconds():e.getMilliseconds();
return AjxFormat._zeroPad(t,this._s.length)
};
AjxDateFormat.SecondSegment.prototype.parse=function(a,o,t){
var e=/s/.test(this._s);
var i=e?"seconds":"milliseconds";
var n=e?this._getFixedLength():0;
return AjxFormat.Segment._parseInt(a,i,0,o,t,n)
};
AjxDateFormat.AmPmSegment=function(t,e){
if(arguments.length==0){
return
}
AjxFormat.Segment.call(this,t,e)
};
AjxDateFormat.AmPmSegment.prototype=new AjxDateFormat.TimeSegment;
AjxDateFormat.AmPmSegment.prototype.constructor=AjxDateFormat.AmPmSegment;
AjxDateFormat.AmPmSegment.prototype.toString=function(){
return'timeAmPm: "'+this._s+'"'
};
AjxDateFormat.AmPmSegment.prototype.format=function(t){
var e=t.getHours();
return e<12?I18nMsg.periodAm:I18nMsg.periodPm
};
AjxDateFormat.AmPmSegment.prototype.parse=function(t,i,e){
var o=[I18nMsg.periodAm.toLowerCase(),I18nMsg.periodPm.toLowerCase(),I18nMsg.periodAm.toUpperCase(),I18nMsg.periodPm.toUpperCase()];
var a=AjxFormat.Segment._parseLiterals(t,"ampm",0,o,i,e);
if(a==-1){
throw new AjxFormat.ParsingException(this._parent,this,"no match")
}
t.ampm=t.ampm%2;
return a
};
AjxDateFormat.TimezoneSegment=function(t,e){
if(arguments.length==0){
return
}
AjxFormat.Segment.call(this,t,e)
};
AjxDateFormat.TimezoneSegment.prototype=new AjxDateFormat.TimeSegment;
AjxDateFormat.TimezoneSegment.prototype.constructor=AjxDateFormat.TimezoneSegment;
AjxDateFormat.TimezoneSegment.prototype.toString=function(){
return'timeTimezone: "'+this._s+'"'
};
AjxDateFormat.TimezoneSegment.prototype.format=function(t){
var e=t.timezone||AjxTimezone.DEFAULT;
if(/Z/.test(this._s)){
return AjxTimezone.getShortName(e)
}
return this._s.length<4?AjxTimezone.getMediumName(e):AjxTimezone.getLongName(e)
};
AjxMessageFormat=function(s){
if(arguments.length==0){
return
}
AjxFormat.call(this,s);
if(s==null){
return
}
for(var t=0;
t<s.length;
t++){
var r=s.charAt(t);
if(r=="'"){
if(t+1<s.length&&s.charAt(t+1)=="'"){
var a=new AjxFormat.TextSegment(this,"'");
this._segments.push(a);
t++;
continue
}
var h=t+1;
for(t++;
t<s.length;
t++){
var r=s.charAt(t);
if(r=="'"){
if(t+1<s.length&&s.charAt(t+1)=="'"){
s=s.substr(0,t)+s.substr(t+1)
}else{
break
}}}
if(t==s.length){}
var n=t;
var a=new AjxFormat.TextSegment(this,s.substring(h,n));
this._segments.push(a);
continue
}
var h=t;
while(t<s.length){
r=s.charAt(t);
if(r=="{"||r=="'"){
break
}
t++
}
var n=t;
if(h!=n){
var a=new AjxFormat.TextSegment(this,s.substring(h,n));
this._segments.push(a);
t--;
continue
}
var h=t+1;
var e=0;
while(++t<s.length){
var r=s.charAt(t);
if(r=="{"){
e++
}else{
if(r=="}"){
if(e==0){
break
}
e--
}}}
var n=t;
var o=n-h;
var l=s.substr(h,o);
var a=new AjxMessageFormat.MessageSegment(this,l);
if(a!=null){
this._segments.push(a)
}}};
AjxMessageFormat.prototype=new AjxFormat;
AjxMessageFormat.prototype.constructor=AjxMessageFormat;
AjxMessageFormat.prototype.toString=function(){
return"[AjxMessageFormat: "+AjxFormat.prototype.toString.call(this)+"]"
};
AjxMessageFormat.format=function(e,t){
return new AjxMessageFormat(e).format(t)
};
AjxMessageFormat.prototype.format=function(e){
if(!(e instanceof Array)){
e=[e]
}
return AjxFormat.prototype.format.call(this,e)
};
AjxMessageFormat.prototype.getFormats=function(){
var e=[];
for(var t=0;
t<this._segments.length;
t++){
var a=this._segments[t];
if(a instanceof AjxMessageFormat.MessageSegment){
e.push(a.getSegmentFormat())
}}
return e
};
AjxMessageFormat.prototype.getFormatsByArgumentIndex=function(){
var e=[];
for(var t=0;
t<this._segments.length;
t++){
var a=this._segments[t];
if(a instanceof AjxMessageFormat.MessageSegment){
e[a.getIndex()]=a.getSegmentFormat()
}}
return e
};
AjxMessageFormat.MessageSegment=function(i,e){
if(arguments.length==0){
return
}
AjxFormat.Segment.call(this,i,e);
var a=AjxMessageFormat.MessageSegment._split(e,",");
this._index=Number(a[0]);
this._type=a[1]||"string";
this._style=a[2];
if(this._type=="list"){
this._isList=true;
this._type=a[2]||"string";
this._style=a[3]
}
switch(this._type){
case"number":switch(this._style){
case"integer":this._formatter=AjxNumberFormat.getIntegerInstance();
break;
case"currency":this._formatter=AjxNumberFormat.getCurrencyInstance();
break;
case"percent":this._formatter=AjxNumberFormat.getPercentInstance();
break;
default:this._formatter=this._style==null?AjxNumberFormat.getInstance():new AjxNumberFormat(this._style)
}
break;
case"date":case"time":var t=this._type=="date"?AjxDateFormat.getDateInstance:AjxDateFormat.getTimeInstance;
switch(this._style){
case"short":this._formatter=t(AjxDateFormat.SHORT);
break;
case"medium":this._formatter=t(AjxDateFormat.MEDIUM);
break;
case"long":this._formatter=t(AjxDateFormat.LONG);
break;
case"full":this._formatter=t(AjxDateFormat.FULL);
break;
default:this._formatter=this._style==null?t(AjxDateFormat.DEFAULT):new AjxDateFormat(this._style)
}
break;
case"choice":this._formatter=new AjxChoiceFormat(this._style);
break
}
if(this._isList){
this._formatter=new AjxListFormat(this._formatter)
}};
AjxMessageFormat.MessageSegment.prototype=new AjxFormat.Segment;
AjxMessageFormat.MessageSegment.prototype.constructor=AjxMessageFormat.MessageSegment;
AjxMessageFormat.MessageSegment.prototype.toString=function(){
var e=['message: "',this._s,'", index: ',this._index];
if(this._isList){
e.push(", list: ",this._isList)
}
if(this._type){
e.push(", type: ",this._type)
}
if(this._style){
e.push(", style: ",this._style)
}
if(this._formatter){
e.push(", formatter: ",this._formatter.toString())
}
return e.join("")
};
AjxMessageFormat.MessageSegment.prototype._index;
AjxMessageFormat.MessageSegment.prototype._type;
AjxMessageFormat.MessageSegment.prototype._style;
AjxMessageFormat.MessageSegment.prototype._isList=false;
AjxMessageFormat.MessageSegment.prototype._formatter;
AjxMessageFormat.MessageSegment.prototype.format=function(t){
var e=t[this._index];
if(this._formatter instanceof AjxChoiceFormat){
return this._formatter.format(t,this._index)
}
return this._formatter?this._formatter.format(e):String(e)
};
AjxMessageFormat.MessageSegment.prototype.getIndex=function(){
return this._index
};
AjxMessageFormat.MessageSegment.prototype.getType=function(){
return this._type
};
AjxMessageFormat.MessageSegment.prototype.getStyle=function(){
return this._style
};
AjxMessageFormat.MessageSegment.prototype.getSegmentFormat=function(){
return this._formatter
};
AjxMessageFormat.MessageSegment._split=function(i,e){
var o=[];
var a=0;
var t;
var n=0;
for(t=0;
t<i.length;
t++){
var r=i.charAt(t);
if(r=="{"){
n++
}else{
if(r=="}"){
n--
}else{
if(r==e&&n==0){
o.push(i.substring(a,t));
a=t+1
}}}}
if(t>a){
o.push(i.substring(a,t))
}
return o
};
AjxNumberFormat=function(g,y){
if(arguments.length==0){
return
}
AjxFormat.call(this,g);
if(!g){
return
}
var a=g.split(/;/);
var g=a[0];
var f=0;
var u=this.__parseStatic(g,f);
f=u.offset;
var s=u.text!="";
if(s){
this._segments.push(new AjxFormat.TextSegment(this,u.text))
}
var r=f;
while(f<g.length&&AjxNumberFormat._META_CHARS.indexOf(g.charAt(f))!=-1){
f++
}
var n=f;
var t=g.substring(r,n);
var b=t.indexOf("E");
var c=b!=-1?t.substring(b+1):null;
if(c){
t=t.substring(0,b);
this._showExponent=true
}
var d=t.indexOf(I18nMsg.numberSeparatorDecimal!=""?I18nMsg.numberSeparatorDecimal:".");
var w=d!=-1?t.substring(0,d):t;
if(w){
var v=w.lastIndexOf(I18nMsg.numberSeparatorGrouping!=""?I18nMsg.numberSeparatorGrouping:",");
if(v!=-1){
this._groupingOffset=w.length-v-1
}
w=w.replace(/[^#0]/g,"");
var l=w.indexOf("0");
if(l!=-1){
this._minIntDigits=w.length-l
}
this._maxIntDigits=w.length
}
var p=d!=-1?t.substring(d+1):null;
if(p){
var l=p.lastIndexOf("0");
if(l!=-1){
this._minFracDigits=l+1
}
this._maxFracDigits=p.replace(/[^#0]/g,"").length
}
this._segments.push(new AjxNumberFormat.NumberSegment(this,t));
var u=this.__parseStatic(g,f);
f=u.offset;
if(u.text!=""){
this._segments.push(new AjxFormat.TextSegment(this,u.text))
}
if(y){
return
}
if(a.length>1){
var g=a[1];
this._negativeFormatter=new AjxNumberFormat(g,true)
}else{
var m=new AjxNumberFormat("");
m._segments=m._segments.concat(this._segments);
var h=s?1:0;
var o=new AjxFormat.TextSegment(m,I18nMsg.numberSignMinus);
m._segments.splice(h,0,o);
this._negativeFormatter=m
}};
AjxNumberFormat.prototype=new AjxFormat;
AjxNumberFormat.prototype.constructor=AjxNumberFormat;
AjxNumberFormat.prototype.toString=function(){
var e=["[AjxNumberFormat: ","formatter=",AjxFormat.prototype.toString.call(this)];
if(this._negativeFormatter){
e.push(", negativeFormatter=",this._negativeFormatter.toString())
}
e.push("]");
return e.join("")
};
AjxNumberFormat._NUMBER="number";
AjxNumberFormat._INTEGER="integer";
AjxNumberFormat._CURRENCY="currency";
AjxNumberFormat._PERCENT="percent";
AjxNumberFormat._META_CHARS="0#.,E";
AjxNumberFormat.prototype._groupingOffset=Number.MAX_VALUE;
AjxNumberFormat.prototype._maxIntDigits;
AjxNumberFormat.prototype._minIntDigits=1;
AjxNumberFormat.prototype._maxFracDigits;
AjxNumberFormat.prototype._minFracDigits;
AjxNumberFormat.prototype._isCurrency=false;
AjxNumberFormat.prototype._isPercent=false;
AjxNumberFormat.prototype._isPerMille=false;
AjxNumberFormat.prototype._showExponent=false;
AjxNumberFormat.prototype._negativeFormatter;
AjxNumberFormat.getInstance=function(){
if(!AjxNumberFormat._FORMATTERS[AjxNumberFormat._NUMBER]){
AjxNumberFormat._FORMATTERS[AjxNumberFormat._NUMBER]=new AjxNumberFormat(I18nMsg.formatNumber)
}
return AjxNumberFormat._FORMATTERS[AjxNumberFormat._NUMBER]
};
AjxNumberFormat.getNumberInstance=AjxNumberFormat.getInstance;
AjxNumberFormat.getCurrencyInstance=function(){
if(!AjxNumberFormat._FORMATTERS[AjxNumberFormat._CURRENCY]){
AjxNumberFormat._FORMATTERS[AjxNumberFormat._CURRENCY]=new AjxNumberFormat(I18nMsg.formatNumberCurrency)
}
return AjxNumberFormat._FORMATTERS[AjxNumberFormat._CURRENCY]
};
AjxNumberFormat.getIntegerInstance=function(){
if(!AjxNumberFormat._FORMATTERS[AjxNumberFormat._INTEGER]){
AjxNumberFormat._FORMATTERS[AjxNumberFormat._INTEGER]=new AjxNumberFormat(I18nMsg.formatNumberInteger)
}
return AjxNumberFormat._FORMATTERS[AjxNumberFormat._INTEGER]
};
AjxNumberFormat.getPercentInstance=function(){
if(!AjxNumberFormat._FORMATTERS[AjxNumberFormat._PERCENT]){
AjxNumberFormat._FORMATTERS[AjxNumberFormat._PERCENT]=new AjxNumberFormat(I18nMsg.formatNumberPercent)
}
return AjxNumberFormat._FORMATTERS[AjxNumberFormat._PERCENT]
};
AjxNumberFormat.format=function(t,e){
return new AjxNumberFormat(t).format(e)
};
AjxNumberFormat.initialize=function(){
AjxNumberFormat._FORMATTERS={}
};
AjxNumberFormat.prototype.format=function(e){
if(e<0&&this._negativeFormatter){
return this._negativeFormatter.format(e)
}
return AjxFormat.prototype.format.call(this,e)
};
AjxNumberFormat.prototype.__parseStatic=function(a,t){
var o=[];
while(t<a.length){
var r=a.charAt(t++);
if(AjxNumberFormat._META_CHARS.indexOf(r)!=-1){
t--;
break
}
switch(r){
case"'":var n=t;
while(t<a.length&&a.charAt(t++)!="'"){}
var e=t;
r=e-n==0?"'":a.substring(n,e);
break;
case"%":r=I18nMsg.numberSignPercent;
this._isPercent=true;
break;
case"\u2030":r=I18nMsg.numberSignPerMill;
this._isPerMille=true;
break;
case"\u00a4":r=a.charAt(t)=="\u00a4"?I18nMsg.currencyCode:I18nMsg.currencySymbol;
this._isCurrency=true;
break
}
o.push(r)
}
return{
text:o.join(""),offset:t}
};
AjxNumberFormat.NumberSegment=function(t,e){
if(arguments.length==0){
return
}
AjxFormat.Segment.call(this,t,e)
};
AjxNumberFormat.NumberSegment.prototype=new AjxFormat.Segment;
AjxNumberFormat.NumberSegment.prototype.constructor=AjxNumberFormat.NumberSegment;
AjxNumberFormat.NumberSegment.prototype.toString=function(){
return'number: "'+this._s+'"'
};
AjxNumberFormat.NumberSegment.prototype.format=function(t){
if(isNaN(t)){
return I18nMsg.numberNaN
}
if(t===Number.NEGATIVE_INFINITY||t===Number.POSITIVE_INFINITY){
return I18nMsg.numberInfinity
}
if(typeof t!="number"){
t=Number(t)
}
t=Math.abs(t);
if(this._parent._isPercent){
t*=100
}else{
if(this._parent._isPerMille){
t*=1000
}}
var e=this._parent._showExponent?t.toExponential(this._parent._maxFracDigits).toUpperCase().replace(/E\+/,"E"):t.toFixed(this._parent._maxFracDigits||0);
e=this._normalize(e);
return e
};
AjxNumberFormat.NumberSegment.prototype._normalize=function(r){
var o=r.split(/[\.Ee]/);
var h=o.shift();
if(h.length<this._parent._minIntDigits){
h=AjxFormat._zeroPad(h,this._parent._minIntDigits,I18nMsg.numberZero)
}
if(h.length>this._parent._groupingOffset){
var t=[];
var n=h.length-this._parent._groupingOffset;
while(n>0){
t.unshift(h.substr(n,this._parent._groupingOffset));
t.unshift(I18nMsg.numberSeparatorGrouping);
n-=this._parent._groupingOffset
}
t.unshift(h.substring(0,n+this._parent._groupingOffset));
h=t.join("")
}
var l="0";
var c;
if(r.match(/\./)){
l=o.shift()
}else{
if(r.match(/\e/)||r.match(/\E/)){
c=o.shift()
}}
l=l.replace(/0+$/,"");
if(l.length<this._parent._minFracDigits){
l=AjxFormat._zeroPad(l,this._parent._minFracDigits,I18nMsg.numberZero,true)
}
var t=[h];
if(l.length>0){
var e=this._parent._isCurrency?I18nMsg.numberSeparatorMoneyDecimal:I18nMsg.numberSeparatorDecimal;
t.push(e,l)
}
if(c){
t.push("E",c.replace(/^\+/,""))
}
return t.join("")
};
AjxChoiceFormat=function(s){
if(arguments.length==0){
return
}
AjxFormat.call(this,s);
if(s==null){
return
}
var l=s.split("|");
if(arguments.length==1){
this._limits=new Array(l.length);
this._lessThan=new Array(l.length);
this._formats=new Array(l.length);
var r=new RegExp("^([^#<\u2264]+)([#<\u2264])(.*)$");
for(var a=0;
a<l.length;
a++){
var t=l[a];
var o=r.exec(t);
var e=o[1];
var n=o[2];
var h=o[3];
if(e=="\u221E"){
this._limits[a]=Number.POSITIVE_INFINITY
}else{
if(e=="-\u221E"){
this._limits[a]=Number.NEGATIVE_INFINITY
}else{
this._limits[a]=parseFloat(e)
}}
this._lessThan[a]=n=="#"||n=="\u2264";
this._formats[a]=new AjxMessageFormat(h)
}}else{
this._limits=arguments[0];
this._lessThan=new Array(arguments[0].length);
this._formats=arguments[1];
this._pattern=[];
for(var a=0;
a<this._formats.length;
a++){
if(a>0){
this._pattern.push("|")
}
this._pattern.push(this._limits[a],"#",this._formats[a]);
this._lessThan[a]=false;
this._formats[a]=new AjxMessageFormat(this._formats[a])
}
this._pattern=this._pattern.join("")
}};
AjxChoiceFormat.prototype=new AjxFormat;
AjxChoiceFormat.prototype.constructor=AjxChoiceFormat;
AjxChoiceFormat.prototype.toString=function(){
return["[AjxChoiceFormat: ","limits={ ",this._limits.join(", ")," }, ","formats={ ",this._formats.join(", ")," }, ","lessThan={ ",this._lessThan.join(", ")," }]"].join("")
};
AjxChoiceFormat.prototype._limits;
AjxChoiceFormat.prototype._lessThan;
AjxChoiceFormat.prototype._formats;
AjxChoiceFormat.prototype.getLimits=function(){
return this._limits
};
AjxChoiceFormat.prototype.getFormats=function(){
return this._formats
};
AjxChoiceFormat.prototype.format=function(e,n){
var o=e instanceof Array?e[n]:e;
var l;
if(isNaN(o)||o<this._limits[0]){
l=this._formats[0]
}else{
for(var t=0;
t<this._limits.length-1;
t++){
var h=this._limits[t];
var r=this._limits[t+1];
var c=o>=h;
var s=this._lessThan[t+1]?o<r:o<=r;
if(c&&s){
l=this._formats[t];
break
}}
if(!l){
l=this._formats[this._formats.length-1]
}}
return l.format(e)
};
AjxListFormat=function(e,a,t){
if(arguments.length==0){
return
}
AjxFormat.call(this,e?e.toPattern():"");
this._formatter=e;
this._separator=a||AjxMsg.listSeparator;
this._lastSeparator=t||AjxMsg.listSeparatorLast
};
AjxListFormat.prototype=new AjxFormat;
AjxListFormat.prototype.constructor=AjxListFormat;
AjxListFormat.prototype._formatter;
AjxListFormat.prototype._separator;
AjxListFormat.prototype._lastSeparator;
AjxListFormat.prototype.format=function(o){
o=o instanceof Array?o:[o];
var a=[];
for(var e=0;
e<o.length;
e++){
if(e>0){
a.push(e<o.length-1?this._separator:this._lastSeparator)
}
var t=o[e];
a.push(this._formatter?this._formatter.format(t):String(t))
}
return a.join("")
};
AjxFormat.initialize()
}
if(AjxPackage.define("ajax.util.AjxTimezoneData")){
AjxTimezoneData={};
AjxTimezoneData.TRANSITION_YEAR=2018;
AjxTimezoneData.TIMEZONE_RULES=[{
serverId:"Etc/GMT+12",clientId:"Etc/GMT+12",score:100,standard:{
offset:-720,tzname:"GMT+12"}}
,{
serverId:"Pacific/Midway",clientId:"Pacific/Midway",score:100,standard:{
offset:-660,tzname:"SST"}}
,{
serverId:"Pacific/Honolulu",clientId:"Pacific/Honolulu",score:200,standard:{
offset:-600,tzname:"HST"}}
,{
serverId:"America/Anchorage",clientId:"America/Anchorage",score:200,standard:{
offset:-540,mon:11,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,11,4],tzname:"AKST"}
,daylight:{
offset:-480,mon:3,week:2,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,11],tzname:"AKDT"}}
,{
serverId:"America/Los_Angeles",clientId:"America/Los_Angeles",score:200,standard:{
offset:-480,mon:11,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,11,4],tzname:"PST"}
,daylight:{
offset:-420,mon:3,week:2,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,11],tzname:"PDT"}}
,{
serverId:"America/Tijuana",clientId:"America/Tijuana",score:100,standard:{
offset:-480,mon:11,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,11,4],tzname:"PST"}
,daylight:{
offset:-420,mon:3,week:2,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,11],tzname:"PDT"}}
,{
serverId:"America/Chihuahua",clientId:"America/Chihuahua",score:100,standard:{
offset:-420,mon:10,week:-1,wkday:1,hour:2,min:0,sec:0,trans:[2018,10,28],tzname:"MST"}
,daylight:{
offset:-360,mon:4,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,4,1],tzname:"MDT"}}
,{
serverId:"America/Denver",clientId:"America/Denver",score:200,standard:{
offset:-420,mon:11,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,11,4],tzname:"MST"}
,daylight:{
offset:-360,mon:3,week:2,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,11],tzname:"MDT"}}
,{
serverId:"America/Phoenix",clientId:"America/Phoenix",score:200,standard:{
offset:-420,tzname:"MST"}}
,{
serverId:"America/Chicago",clientId:"America/Chicago",score:200,standard:{
offset:-360,mon:11,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,11,4],tzname:"CST"}
,daylight:{
offset:-300,mon:3,week:2,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,11],tzname:"CDT"}}
,{
serverId:"America/Guatemala",clientId:"America/Guatemala",score:100,standard:{
offset:-360}}
,{
serverId:"America/Mexico_City",clientId:"America/Mexico_City",score:100,standard:{
offset:-360,mon:10,week:-1,wkday:1,hour:2,min:0,sec:0,trans:[2018,10,28],tzname:"CST"}
,daylight:{
offset:-300,mon:4,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,4,1],tzname:"CDT"}}
,{
serverId:"America/Regina",clientId:"America/Regina",score:200,standard:{
offset:-360,tzname:"CST"}}
,{
serverId:"America/Bogota",clientId:"America/Bogota",score:100,standard:{
offset:-300}}
,{
serverId:"America/Cancun",clientId:"America/Cancun",score:100,standard:{
offset:-300,tzname:"EST"}}
,{
serverId:"America/Indiana/Indianapolis",clientId:"America/Indiana/Indianapolis",score:100,standard:{
offset:-300,mon:11,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,11,4],tzname:"EST"}
,daylight:{
offset:-240,mon:3,week:2,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,11],tzname:"EDT"}}
,{
serverId:"America/New_York",clientId:"America/New_York",score:200,standard:{
offset:-300,mon:11,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,11,4],tzname:"EST"}
,daylight:{
offset:-240,mon:3,week:2,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,11],tzname:"EDT"}}
,{
serverId:"America/Caracas",clientId:"America/Caracas",score:100,standard:{
offset:-270,tzname:"VET"}}
,{
serverId:"America/Asuncion",clientId:"America/Asuncion",score:100,standard:{
offset:-240,mon:3,week:4,wkday:1,hour:0,min:0,sec:0,trans:[2018,3,25],tzname:"PYT"}
,daylight:{
offset:-180,mon:10,week:1,wkday:1,hour:0,min:0,sec:0,trans:[2018,10,7],tzname:"PYST"}}
,{
serverId:"America/Cuiaba",clientId:"America/Cuiaba",score:100,standard:{
offset:-240,mon:2,week:-1,wkday:1,hour:0,min:0,sec:0,trans:[2018,2,25],tzname:"AMT"}
,daylight:{
offset:-180,mon:10,week:3,wkday:1,hour:0,min:0,sec:0,trans:[2018,10,21],tzname:"AMST"}}
,{
serverId:"America/Guyana",clientId:"America/Guyana",score:100,standard:{
offset:-240,tzname:"GYT"}}
,{
serverId:"America/Halifax",clientId:"America/Halifax",score:100,standard:{
offset:-240,mon:11,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,11,4],tzname:"AST"}
,daylight:{
offset:-180,mon:3,week:2,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,11],tzname:"ADT"}}
,{
serverId:"America/St_Johns",clientId:"America/St_Johns",score:100,standard:{
offset:-210,mon:11,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,11,4],tzname:"NST"}
,daylight:{
offset:-150,mon:3,week:2,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,11],tzname:"NDT"}}
,{
serverId:"America/Argentina/Buenos_Aires",clientId:"America/Argentina/Buenos_Aires",score:100,standard:{
offset:-180}}
,{
serverId:"America/Bahia",clientId:"America/Bahia",score:100,standard:{
offset:-180,tzname:"BRT"}}
,{
serverId:"America/Cayenne",clientId:"America/Cayenne",score:100,standard:{
offset:-180,tzname:"GFT"}}
,{
serverId:"America/Godthab",clientId:"America/Godthab",score:100,standard:{
offset:-180,mon:10,week:-1,wkday:1,hour:1,min:0,sec:0,trans:[2018,10,28],tzname:"WGT"}
,daylight:{
offset:-120,mon:3,week:-1,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,25],tzname:"WGST"}}
,{
serverId:"America/Montevideo",clientId:"America/Montevideo",score:100,standard:{
offset:-180,mon:3,week:2,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,11],tzname:"UYT"}
,daylight:{
offset:-120,mon:10,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,10,7],tzname:"UYST"}}
,{
serverId:"America/Santiago",clientId:"America/Santiago",score:100,standard:{
offset:-180,tzname:"CLT"}}
,{
serverId:"America/Sao_Paulo",clientId:"America/Sao_Paulo",score:100,standard:{
offset:-180,mon:2,week:-1,wkday:1,hour:0,min:0,sec:0,trans:[2018,2,25],tzname:"BRT"}
,daylight:{
offset:-120,mon:10,week:3,wkday:1,hour:0,min:0,sec:0,trans:[2018,10,21],tzname:"BRST"}}
,{
serverId:"Atlantic/South_Georgia",clientId:"Atlantic/South_Georgia",score:100,standard:{
offset:-120,tzname:"GST"}}
,{
serverId:"Atlantic/Azores",clientId:"Atlantic/Azores",score:100,standard:{
offset:-60,mon:10,week:-1,wkday:1,hour:1,min:0,sec:0,trans:[2018,10,28],tzname:"AZOT"}
,daylight:{
offset:0,mon:3,week:-1,wkday:1,hour:0,min:0,sec:0,trans:[2018,3,25],tzname:"AZOST"}}
,{
serverId:"Atlantic/Cape_Verde",clientId:"Atlantic/Cape_Verde",score:100,standard:{
offset:-60,tzname:"CVT"}}
,{
serverId:"Africa/Casablanca",clientId:"Africa/Casablanca",score:100,standard:{
offset:0,mon:6,week:2,wkday:7,hour:3,min:0,sec:0,trans:[2018,6,9],tzname:"WET"}
,daylight:{
offset:60,mon:7,week:3,wkday:7,hour:2,min:0,sec:0,trans:[2018,7,21],tzname:"WEST"}}
,{
serverId:"Africa/Monrovia",clientId:"Africa/Monrovia",score:100,standard:{
offset:0,tzname:"GMT"}}
,{
serverId:"Europe/London",clientId:"Europe/London",score:100,standard:{
offset:0,mon:10,week:-1,wkday:1,hour:2,min:0,sec:0,trans:[2018,10,28],tzname:"GMT/BST"}
,daylight:{
offset:60,mon:3,week:-1,wkday:1,hour:1,min:0,sec:0,trans:[2018,3,25],tzname:"GMT/BST"}}
,{
serverId:"UTC",clientId:"UTC",score:100,standard:{
offset:0,tzname:"UTC"}}
,{
serverId:"Africa/Algiers",clientId:"Africa/Algiers",score:100,standard:{
offset:60,tzname:"CET"}}
,{
serverId:"Africa/Windhoek",clientId:"Africa/Windhoek",score:100,standard:{
offset:60,mon:4,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,4,1],tzname:"WAT"}
,daylight:{
offset:120,mon:9,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,9,2],tzname:"WAST"}}
,{
serverId:"Europe/Belgrade",clientId:"Europe/Belgrade",score:100,standard:{
offset:60,mon:10,week:-1,wkday:1,hour:3,min:0,sec:0,trans:[2018,10,28],tzname:"CET"}
,daylight:{
offset:120,mon:3,week:-1,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,25],tzname:"CEST"}}
,{
serverId:"Europe/Berlin",clientId:"Europe/Berlin",score:200,standard:{
offset:60,mon:10,week:-1,wkday:1,hour:3,min:0,sec:0,trans:[2018,10,28],tzname:"CET"}
,daylight:{
offset:120,mon:3,week:-1,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,25],tzname:"CEST"}}
,{
serverId:"Europe/Brussels",clientId:"Europe/Brussels",score:100,standard:{
offset:60,mon:10,week:-1,wkday:1,hour:3,min:0,sec:0,trans:[2018,10,28],tzname:"CET"}
,daylight:{
offset:120,mon:3,week:-1,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,25],tzname:"CEST"}}
,{
serverId:"Europe/Warsaw",clientId:"Europe/Warsaw",score:100,standard:{
offset:60,mon:10,week:-1,wkday:1,hour:3,min:0,sec:0,trans:[2018,10,28],tzname:"CET"}
,daylight:{
offset:120,mon:3,week:-1,wkday:1,hour:2,min:0,sec:0,trans:[2018,3,25],tzname:"CEST"}}
,{
serverId:"Africa/Cairo",clientId:"Africa/Cairo",score:100,standard:{
offset:120}}
,{
serverId:"Africa/Harare",clientId:"Africa/Harare",score:200,standard:{
offset:120,tzname:"CAT"}}
,{
serverId:"Africa/Tripoli",clientId:"Africa/Tripoli",score:100,standard:{
offset:120,tzname:"EET"}}
,{
serverId:"Asia/Amman",clientId:"Asia/Amman",score:100,standard:{
offset:120,mon:10,week:-1,wkday:6,hour:1,min:0,sec:0,trans:[2018,10,26],tzname:"EET"}
,daylight:{
offset:180,mon:3,week:-1,wkday:5,hour:23,min:59,sec:59,trans:[2018,3,29],tzname:"EEST"}}
,{
serverId:"Asia/Beirut",clientId:"Asia/Beirut",score:100,standard:{
offset:120,mon:10,week:-1,wkday:1,hour:0,min:0,sec:0,trans:[2018,10,28],tzname:"EET"}
,daylight:{
offset:180,mon:3,week:-1,wkday:1,hour:0,min:0,sec:0,trans:[2018,3,25],tzname:"EEST"}}
,{
serverId:"Asia/Damascus",clientId:"Asia/Damascus",score:100,standard:{
offset:120,mon:10,week:-1,wkday:6,hour:0,min:0,sec:0,trans:[2018,10,26],tzname:"EET"}
,daylight:{
offset:180,mon:3,week:-1,wkday:6,hour:0,min:0,sec:0,trans:[2018,3,30],tzname:"EEST"}}
,{
serverId:"Asia/Jerusalem",clientId:"Asia/Jerusalem",score:100,standard:{
offset:120,mon:10,week:-1,wkday:1,hour:2,min:0,sec:0,trans:[2018,10,28],tzname:"IST"}
,daylight:{
offset:180,mon:3,week:-1,wkday:6,hour:2,min:0,sec:0,trans:[2018,3,30],tzname:"IDT"}}
,{
serverId:"Europe/Athens",clientId:"Europe/Athens",score:200,standard:{
offset:120,mon:10,week:-1,wkday:1,hour:4,min:0,sec:0,trans:[2018,10,28],tzname:"EET"}
,daylight:{
offset:180,mon:3,week:-1,wkday:1,hour:3,min:0,sec:0,trans:[2018,3,25],tzname:"EEST"}}
,{
serverId:"Europe/Bucharest",clientId:"Europe/Bucharest",score:100,standard:{
offset:120,mon:10,week:-1,wkday:1,hour:4,min:0,sec:0,trans:[2018,10,28],tzname:"EET"}
,daylight:{
offset:180,mon:3,week:-1,wkday:1,hour:3,min:0,sec:0,trans:[2018,3,25],tzname:"EEST"}}
,{
serverId:"Europe/Helsinki",clientId:"Europe/Helsinki",score:100,standard:{
offset:120,mon:10,week:-1,wkday:1,hour:4,min:0,sec:0,trans:[2018,10,28],tzname:"EET"}
,daylight:{
offset:180,mon:3,week:-1,wkday:1,hour:3,min:0,sec:0,trans:[2018,3,25],tzname:"EEST"}}
,{
serverId:"Europe/Istanbul",clientId:"Europe/Istanbul",score:100,standard:{
offset:120,mon:10,week:-1,wkday:1,hour:4,min:0,sec:0,trans:[2018,10,28],tzname:"EET"}
,daylight:{
offset:180,mon:3,week:-1,wkday:1,hour:3,min:0,sec:0,trans:[2018,3,25],tzname:"EEST"}}
,{
serverId:"Europe/Kaliningrad",clientId:"Europe/Kaliningrad",score:100,standard:{
offset:120,tzname:"EET"}}
,{
serverId:"Africa/Nairobi",clientId:"Africa/Nairobi",score:200,standard:{
offset:180,tzname:"EAT"}}
,{
serverId:"Asia/Baghdad",clientId:"Asia/Baghdad",score:100,standard:{
offset:180}}
,{
serverId:"Asia/Kuwait",clientId:"Asia/Kuwait",score:100,standard:{
offset:180,tzname:"AST"}}
,{
serverId:"Europe/Minsk",clientId:"Europe/Minsk",score:100,standard:{
offset:180,tzname:"MSK"}}
,{
serverId:"Europe/Moscow",clientId:"Europe/Moscow",score:100,standard:{
offset:180,tzname:"MSK"}}
,{
serverId:"Asia/Tehran",clientId:"Asia/Tehran",score:100,standard:{
offset:210,mon:9,week:4,wkday:3,hour:0,min:0,sec:0,trans:[2018,9,25],tzname:"IRST"}
,daylight:{
offset:270,mon:3,week:4,wkday:1,hour:0,min:0,sec:0,trans:[2018,3,25],tzname:"IRDT"}}
,{
serverId:"Asia/Baku",clientId:"Asia/Baku",score:100,standard:{
offset:240,mon:10,week:-1,wkday:1,hour:5,min:0,sec:0,trans:[2018,10,28],tzname:"AZT"}
,daylight:{
offset:300,mon:3,week:-1,wkday:1,hour:4,min:0,sec:0,trans:[2018,3,25],tzname:"AZST"}}
,{
serverId:"Asia/Muscat",clientId:"Asia/Muscat",score:100,standard:{
offset:240,tzname:"GST"}}
,{
serverId:"Asia/Tbilisi",clientId:"Asia/Tbilisi",score:200,standard:{
offset:240,tzname:"GET"}}
,{
serverId:"Asia/Yerevan",clientId:"Asia/Yerevan",score:100,standard:{
offset:240,tzname:"AMT"}}
,{
serverId:"Europe/Samara",clientId:"Europe/Samara",score:100,standard:{
offset:240,tzname:"SAMT"}}
,{
serverId:"Indian/Mauritius",clientId:"Indian/Mauritius",score:100,standard:{
offset:240}}
,{
serverId:"Asia/Kabul",clientId:"Asia/Kabul",score:100,standard:{
offset:270,tzname:"AFT"}}
,{
serverId:"Asia/Karachi",clientId:"Asia/Karachi",score:200,standard:{
offset:300}}
,{
serverId:"Asia/Tashkent",clientId:"Asia/Tashkent",score:100,standard:{
offset:300,tzname:"UZT"}}
,{
serverId:"Asia/Yekaterinburg",clientId:"Asia/Yekaterinburg",score:100,standard:{
offset:300,tzname:"YEKT"}}
,{
serverId:"Asia/Colombo",clientId:"Asia/Colombo",score:100,standard:{
offset:330,tzname:"IST"}}
,{
serverId:"Asia/Kolkata",clientId:"Asia/Kolkata",score:200,standard:{
offset:330,tzname:"IST"}}
,{
serverId:"Asia/Kathmandu",clientId:"Asia/Kathmandu",score:100,standard:{
offset:345,tzname:"NPT"}}
,{
serverId:"Asia/Almaty",clientId:"Asia/Almaty",score:100,standard:{
offset:360,tzname:"ALMT"}}
,{
serverId:"Asia/Dhaka",clientId:"Asia/Dhaka",score:100,standard:{
offset:360}}
,{
serverId:"Asia/Novosibirsk",clientId:"Asia/Novosibirsk",score:100,standard:{
offset:360,tzname:"NOVT"}}
,{
serverId:"Asia/Rangoon",clientId:"Asia/Rangoon",score:100,standard:{
offset:390,tzname:"MMT"}}
,{
serverId:"Asia/Bangkok",clientId:"Asia/Bangkok",score:100,standard:{
offset:420,tzname:"ICT"}}
,{
serverId:"Asia/Krasnoyarsk",clientId:"Asia/Krasnoyarsk",score:100,standard:{
offset:420,tzname:"KRAT"}}
,{
serverId:"Asia/Hong_Kong",clientId:"Asia/Hong_Kong",score:200,standard:{
offset:480}}
,{
serverId:"Asia/Irkutsk",clientId:"Asia/Irkutsk",score:100,standard:{
offset:480,tzname:"IRKT"}}
,{
serverId:"Asia/Kuala_Lumpur",clientId:"Asia/Kuala_Lumpur",score:100,standard:{
offset:480,tzname:"MYT"}}
,{
serverId:"Asia/Singapore",clientId:"Asia/Singapore",score:100,standard:{
offset:480,tzname:"SGT"}}
,{
serverId:"Asia/Taipei",clientId:"Asia/Taipei",score:100,standard:{
offset:480}}
,{
serverId:"Asia/Ulaanbaatar",clientId:"Asia/Ulaanbaatar",score:100,standard:{
offset:480,mon:9,week:-1,wkday:7,hour:0,min:0,sec:0,trans:[2018,9,29],tzname:"ULAT"}
,daylight:{
offset:540,mon:3,week:-1,wkday:7,hour:2,min:0,sec:0,trans:[2018,3,31],tzname:"ULAST"}}
,{
serverId:"Australia/Perth",clientId:"Australia/Perth",score:100,standard:{
offset:480}}
,{
serverId:"Asia/Seoul",clientId:"Asia/Seoul",score:100,standard:{
offset:540}}
,{
serverId:"Asia/Tokyo",clientId:"Asia/Tokyo",score:200,standard:{
offset:540}}
,{
serverId:"Asia/Yakutsk",clientId:"Asia/Yakutsk",score:100,standard:{
offset:540,tzname:"YAKT"}}
,{
serverId:"Australia/Adelaide",clientId:"Australia/Adelaide",score:100,standard:{
offset:570,mon:4,week:1,wkday:1,hour:3,min:0,sec:0,trans:[2018,4,1],tzname:"ACST"}
,daylight:{
offset:630,mon:10,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,10,7],tzname:"ACDT"}}
,{
serverId:"Australia/Darwin",clientId:"Australia/Darwin",score:100,standard:{
offset:570}}
,{
serverId:"Asia/Magadan",clientId:"Asia/Magadan",score:100,standard:{
offset:600,tzname:"MAGT"}}
,{
serverId:"Asia/Vladivostok",clientId:"Asia/Vladivostok",score:100,standard:{
offset:600,tzname:"VLAT"}}
,{
serverId:"Australia/Brisbane",clientId:"Australia/Brisbane",score:200,standard:{
offset:600}}
,{
serverId:"Australia/Hobart",clientId:"Australia/Hobart",score:100,standard:{
offset:600,mon:4,week:1,wkday:1,hour:3,min:0,sec:0,trans:[2018,4,1],tzname:"AEST"}
,daylight:{
offset:660,mon:10,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,10,7],tzname:"AEDT"}}
,{
serverId:"Australia/Sydney",clientId:"Australia/Sydney",score:200,standard:{
offset:600,mon:4,week:1,wkday:1,hour:3,min:0,sec:0,trans:[2018,4,1],tzname:"AEST"}
,daylight:{
offset:660,mon:10,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,10,7],tzname:"AEDT"}}
,{
serverId:"Pacific/Guam",clientId:"Pacific/Guam",score:100,standard:{
offset:600,tzname:"ChST"}}
,{
serverId:"Asia/Srednekolymsk",clientId:"Asia/Srednekolymsk",score:100,standard:{
offset:660,tzname:"SRET"}}
,{
serverId:"Pacific/Bougainville",clientId:"Pacific/Bougainville",score:100,standard:{
offset:660,tzname:"BST"}}
,{
serverId:"Pacific/Guadalcanal",clientId:"Pacific/Guadalcanal",score:100,standard:{
offset:660,tzname:"SBT"}}
,{
serverId:"Asia/Kamchatka",clientId:"Asia/Kamchatka",score:100,standard:{
offset:720,tzname:"PETT"}}
,{
serverId:"Pacific/Auckland",clientId:"Pacific/Auckland",score:100,standard:{
offset:720,mon:4,week:1,wkday:1,hour:3,min:0,sec:0,trans:[2018,4,1],tzname:"NZST"}
,daylight:{
offset:780,mon:9,week:-1,wkday:1,hour:2,min:0,sec:0,trans:[2018,9,30],tzname:"NZDT"}}
,{
serverId:"Pacific/Fiji",clientId:"Pacific/Fiji",score:100,standard:{
offset:720,mon:1,week:3,wkday:1,hour:3,min:0,sec:0,trans:[2018,1,21],tzname:"FJT"}
,daylight:{
offset:780,mon:11,week:1,wkday:1,hour:2,min:0,sec:0,trans:[2018,11,4],tzname:"FJST"}}
,{
serverId:"Pacific/Apia",clientId:"Pacific/Apia",score:100,standard:{
offset:780,mon:4,week:1,wkday:1,hour:4,min:0,sec:0,trans:[2018,4,1],tzname:"WSST"}
,daylight:{
offset:840,mon:9,week:-1,wkday:1,hour:3,min:0,sec:0,trans:[2018,9,30],tzname:"WSDT"}}
,{
serverId:"Pacific/Tongatapu",clientId:"Pacific/Tongatapu",score:100,standard:{
offset:780}}
,{
serverId:"Pacific/Kiritimati",clientId:"Pacific/Kiritimati",score:100,standard:{
offset:840,tzname:"LINT"}}
]
}
if(AjxPackage.define("ajax.util.AjxTimezone")){
AjxTimezone=function(){};
AjxTimezone.convertTimezone=function(t,e,o){
if(e==o){
return t
}
var i=AjxTimezone.getOffset(o,t);
var a=AjxTimezone.getOffset(e,t);
return new Date(t.getTime()+(i-a)*60*1000)
};
AjxTimezone.getTransition=function(i,a){
var t=[a||new Date().getFullYear(),i.mon,1];
if(i.mday){
t[2]=i.mday
}else{
if(i.wkday){
var e=new Date(a,i.mon-1,1,i.hour,i.min,i.sec);
if(i.week==-1){
var n=new Date(new Date(e.getTime()).setMonth(i.mon,0));
var o=n.getDate();
var r=n.getDay()+1;
var s=r>=i.wkday?r-i.wkday:7-i.wkday-r;
t[2]=o-s
}else{
var r=e.getDay()+1;
var s=i.wkday==r?1:0;
t[2]=i.wkday+7*(i.week-s)-r+1
}}}
return t
};
AjxTimezone.createMDayTransition=function(e,a){
if(e instanceof Date){
a=a!=null?a:e.getTimezoneOffset();
e=[e.getFullYear(),e.getMonth()+1,e.getDate(),e.getHours(),e.getMinutes(),e.getSeconds()]
}
var t={
offset:a,trans:e};
return AjxTimezone.addMDayTransition(t)
};
AjxTimezone.addMDayTransition=function(t){
var e=t.trans;
t.mon=e[1];
t.mday=e[2];
t.hour=e[3];
t.min=e[4];
t.sec=e[5];
return t
};
AjxTimezone.createWkDayTransition=function(e,a){
if(e instanceof Date){
a=a!=null?a:e.getTimezoneOffset();
e=[e.getFullYear(),e.getMonth()+1,e.getDate(),e.getHours(),e.getMinutes(),e.getSeconds()]
}
var t={
offset:a,trans:e};
return AjxTimezone.addWkDayTransition(t)
};
AjxTimezone.addWkDayTransition=function(o){
var a=o.trans;
var i=a[1];
var r=a[2];
var t=Math.floor((r-1)/7);
var e=new Date(a[0],a[1]-1,a[2],12,0,0);
var s=new Date(new Date(e.getTime()).setMonth(i-1,0)).getDate();
var n=s-r<7;
o.mon=i;
o.week=n?-1:t+1;
o.wkday=e.getDay()+1;
o.hour=a[3];
o.min=a[4];
o.sec=a[5];
return o
};
AjxTimezone.createTransitionDate=function(o){
var e=new Date(AjxTimezoneData.TRANSITION_YEAR,o.mon-1,1,12,0,0);
if(o.mday){
e.setDate(o.mday)
}else{
if(o.week==-1){
e.setMonth(e.getMonth()+1,0);
for(var a=0;
a<7;
a++){
if(e.getDay()+1==o.wkday){
break
}
e.setDate(e.getDate()-1)
}}else{
for(var a=0;
a<7;
a++){
if(e.getDay()+1==o.wkday){
break
}
e.setDate(e.getDate()+1)
}
e.setDate(e.getDate()+7*(o.week-1))
}}
var t=[e.getFullYear(),e.getMonth()+1,e.getDate()];
return t
};
AjxTimezone.getZonePreferences=function(){
if(AjxTimezone._PREF_ZONE_DISPLAY){
var a=AjxTimezone._PREF_ZONE_DISPLAY.length;
var t=AjxTimezone.STANDARD_RULES.length+AjxTimezone.DAYLIGHT_RULES.length;
if(a!=t){
AjxTimezone._PREF_ZONE_DISPLAY=null
}}
if(!AjxTimezone._PREF_ZONE_DISPLAY){
AjxTimezone._PREF_ZONE_DISPLAY=[];
AjxTimezone.getAbbreviatedZoneChoices();
for(var e=0;
e<AjxTimezone._ABBR_ZONE_OPTIONS.length;
e++){
AjxTimezone._PREF_ZONE_DISPLAY.push(AjxTimezone._ABBR_ZONE_OPTIONS[e].displayValue)
}}
return AjxTimezone._PREF_ZONE_DISPLAY
};
AjxTimezone.getZonePreferencesOptions=function(){
if(AjxTimezone._PREF_ZONE_OPTIONS){
var a=AjxTimezone._PREF_ZONE_OPTIONS.length;
var t=AjxTimezone.STANDARD_RULES.length+AjxTimezone.DAYLIGHT_RULES.length;
if(a!=t){
AjxTimezone._PREF_ZONE_OPTIONS=null
}}
if(!AjxTimezone._PREF_ZONE_OPTIONS){
AjxTimezone._PREF_ZONE_OPTIONS=[];
AjxTimezone.getAbbreviatedZoneChoices();
for(var e=0;
e<AjxTimezone._ABBR_ZONE_OPTIONS.length;
e++){
AjxTimezone._PREF_ZONE_OPTIONS.push(AjxTimezone._ABBR_ZONE_OPTIONS[e].value)
}}
return AjxTimezone._PREF_ZONE_OPTIONS
};
AjxTimezone.getServerId=function(e){
return AjxTimezone._CLIENT2SERVER[e]||e
};
AjxTimezone.getClientId=function(e){
return AjxTimezone._SERVER2CLIENT[e]||e
};
AjxTimezone.getShortName=function(t){
var a=AjxTimezone.getRule(t);
if(a&&a.shortName){
return a.shortName
}
var e=["GMT",AjxTimezone._SHORT_NAMES[t]].join("");
if(a){
a.shortName=e
}
return e
};
AjxTimezone.getMediumName=function(e){
var a=AjxTimezone.getRule(e);
if(a&&a.mediumName){
return a.mediumName
}
var t=AjxMsg[e]||["(",AjxTimezone.getShortName(e),") ",e].join("");
if(a){
a.mediumName=t
}
return t
};
AjxTimezone.getLongName=AjxTimezone.getMediumName;
AjxTimezone.addRule=function(a){
var t=a.serverId;
var e=a.clientId;
AjxTimezone._CLIENT2SERVER[e]=t;
AjxTimezone._SERVER2CLIENT[t]=e;
AjxTimezone._SHORT_NAMES[e]=AjxTimezone._generateShortName(a.standard.offset);
AjxTimezone._CLIENT2RULE[e]=a;
var i=a.daylight?AjxTimezone.DAYLIGHT_RULES:AjxTimezone.STANDARD_RULES;
i.push(a)
};
AjxTimezone.getRule=function(e,o){
var c=AjxTimezone._CLIENT2RULE[e];
if(!c){
e=AjxTimezone._SERVER2CLIENT[e];
c=AjxTimezone._CLIENT2RULE[e]
}
if(!c&&o){
var l=["standard","daylight"];
var d=o.daylight?AjxTimezone.DAYLIGHT_RULES:AjxTimezone.STANDARD_RULES;
for(var s=0;
s<d.length;
s++){
c=d[s];
var u=true;
for(var n=0;
n<l.length;
n++){
var t=l[n];
var r=c[t];
if(!r){
continue
}
var h=false;
for(var a in o[t]){
if(o[t][a]!=r[a]){
u=false;
h=true;
break
}}
if(h){
break
}}
if(u){
return c
}}
return null
}
return c
};
AjxTimezone.getOffset=function(e,o){
var u=AjxTimezone.getRule(e||AjxTimezone.DEFAULT);
if(u&&u.daylight){
var c=o.getFullYear();
var s=u.standard,t=u.daylight;
var l=AjxTimezone.getTransition(s,c);
var f=AjxTimezone.getTransition(t,c);
var h=o.getMonth()+1,d=o.getDate();
var n=l[1],m=l[2];
var r=f[1],i=f[2];
var a=false;
if(r<n){
a=h>r&&h<n;
a=a||(h==r&&d>=i);
a=a||(h==n&&d<m)
}else{
a=h<n||h>r;
a=a||(h==r&&d>=i);
a=a||(h==n&&d<m)
}
return a?t.offset:s.offset
}
return u?u.standard.offset:-(new Date().getTimezoneOffset())
};
AjxTimezone.guessMachineTimezone=function(){
return AjxTimezone._guessMachineTimezone().clientId
};
AjxTimezone.getAbbreviatedZoneChoices=function(){
if(AjxTimezone._ABBR_ZONE_OPTIONS){
var o=AjxTimezone._ABBR_ZONE_OPTIONS.length;
var i=AjxTimezone.STANDARD_RULES.length+AjxTimezone.DAYLIGHT_RULES.length;
if(o!=i){
AjxTimezone._ABBR_ZONE_OPTIONS=null
}}
if(!AjxTimezone._ABBR_ZONE_OPTIONS){
AjxTimezone._ABBR_ZONE_OPTIONS=[];
for(var e in AjxTimezone._CLIENT2SERVER){
var n=AjxTimezone._CLIENT2RULE[e];
var t=n.serverId;
var a={
displayValue:AjxTimezone.getMediumName(e),value:t,standard:n.standard,serverId:t,clientId:e};
AjxTimezone._ABBR_ZONE_OPTIONS.push(a)
}
AjxTimezone._ABBR_ZONE_OPTIONS.sort(AjxTimezone._BY_OFFSET)
}
return AjxTimezone._ABBR_ZONE_OPTIONS
};
AjxTimezone.getMatchingTimezoneChoices=function(){
if(AjxTimezone._MATCHING_ZONE_OPTIONS){
var s=AjxTimezone._MATCHING_ZONE_OPTIONS.length;
var n=AjxTimezone.STANDARD_RULES.length+AjxTimezone.DAYLIGHT_RULES.length;
if(s!=n){
AjxTimezone._MATCHING_ZONE_OPTIONS=null
}}
if(!AjxTimezone._MATCHING_ZONE_OPTIONS){
AjxTimezone._MATCHING_ZONE_OPTIONS=[];
for(var a in AjxTimezone.MATCHING_RULES){
var r=AjxTimezone.MATCHING_RULES[a];
var e=r.clientId;
var t=r.serverId;
if(e==AjxTimezone.AUTO_DETECTED){
continue
}
var o={
displayValue:AjxTimezone.getMediumName(e),value:t,standard:r.standard,serverId:t,clientId:e};
AjxTimezone._MATCHING_ZONE_OPTIONS.push(o)
}
AjxTimezone._MATCHING_ZONE_OPTIONS.sort(AjxTimezone._BY_OFFSET)
}
return AjxTimezone._MATCHING_ZONE_OPTIONS
};
AjxTimezone._BY_OFFSET=function(a,t){
var o=a.standard.offset-t.standard.offset;
if(o==0){
var e=a.serverId;
var i=t.serverId;
if(e<i){
o=-1
}else{
if(e>i){
o=1
}}}
return o
};
AjxTimezone.GMT="Europe/London";
AjxTimezone.GMT_NO_DST="UTC";
AjxTimezone.AUTO_DETECTED="Auto-Detected";
AjxTimezone.DEFAULT;
AjxTimezone.DEFAULT_RULE;
AjxTimezone._CLIENT2SERVER={};
AjxTimezone._SERVER2CLIENT={};
AjxTimezone._SHORT_NAMES={};
AjxTimezone._CLIENT2RULE={};
AjxTimezone.STANDARD_RULES=[];
AjxTimezone.DAYLIGHT_RULES=[];
(function(){
for(var e=0;
e<AjxTimezoneData.TIMEZONE_RULES.length;
e++){
var t=AjxTimezoneData.TIMEZONE_RULES[e];
var a=t.daylight?AjxTimezone.DAYLIGHT_RULES:AjxTimezone.STANDARD_RULES;
a.push(t)
}}
)();
AjxTimezone._guessMachineTimezone=function(f){
var u=new Date(AjxTimezoneData.TRANSITION_YEAR,11,1,0,0,0);
var w=new Date(AjxTimezoneData.TRANSITION_YEAR,5,1,0,0,0);
var t=-u.getTimezoneOffset();
var g=-w.getTimezoneOffset();
AjxTimezone.MATCHING_RULES=[];
AjxTimezone.TIMEZONE_CONFLICT=false;
var c=[];
var s={};
var r=[];
var p=false;
if(g==t){
var m=AjxTimezone.STANDARD_RULES;
for(var y=0;
y<m.length;
++y){
var h=m[y];
if(h.standard.offset==g){
if(!s[h.serverId]){
c.push(h);
s[h.serverId]=true
}
AjxTimezone.MATCHING_RULES.push(h)
}}}else{
var m=AjxTimezone.DAYLIGHT_RULES;
var x=Math.max(t,g);
var v=Math.min(t,g);
var o=new Date();
var b=-o.getTimezoneOffset();
for(var y=0;
y<m.length;
++y){
var h=m[y];
if(h.standard.offset==v&&h.daylight.offset==x){
var l=h.standard.trans;
var d=h.daylight.trans;
var n=new Date(l[0],l[1]-1,l[2]-1);
var a=new Date(l[0],l[1]-1,l[2]+2);
var e=new Date(d[0],d[1]-1,d[2]-1);
var k=new Date(d[0],d[1]-1,d[2]+2);
if(-a.getTimezoneOffset()==v&&-k.getTimezoneOffset()==x&&-n.getTimezoneOffset()==x&&-e.getTimezoneOffset()==v){
if(!s[h.serverId]){
c.push(h);
s[h.serverId]=true
}
p=true
}}
if(h.standard.offset==b||h.daylight.offset==b){
AjxTimezone.MATCHING_RULES.push(h)
}}}
if((c.length>0)&&f!=null){
var m=c;
for(var y in m){
if(m[y].serverId==f){
return m[y]
}}}
if(c.length>0){
if(c.length>1){
c.sort(AjxTimezone.__BY_SCORE);
if(c[0].score!=c[1].score){
c.length=1
}}
AjxTimezone.TIMEZONE_CONFLICT=(c.length>1);
return c[0]
}
if((AjxTimezone.MATCHING_RULES.length>0)&&f!=null){
var m=AjxTimezone.MATCHING_RULES;
for(var y in m){
if(m[y].serverId==f){
return m[y]
}}}
return AjxTimezone._generateDefaultRule()
};
AjxTimezone.__BY_SCORE=function(t,e){
return e.score-t.score
};
AjxTimezone._generateDefaultRule=function(){
var l=0;
var a=1;
var i=2;
var s=3;
var o=4;
function c(m,u,w,v){
var p=u.getTime();
var b=new Date();
b.setTime(m.getTime());
var y=new Date();
y.setTime(b.getTime());
var k=m.getTimezoneOffset()*-1;
if(!v){
v={
clientId:AjxTimezone.AUTO_DETECTED,autoDetected:true}
}
while(b.getTime()<=p){
if(w==l){
b.setUTCMonth(b.getUTCMonth()+1)
}else{
if(w==a){
b.setUTCDate(b.getUTCDate()+1)
}else{
if(w==i){
b.setUTCHours(b.getUTCHours()+1)
}else{
if(w==s){
b.setUTCMinutes(b.getUTCMinutes()+1)
}else{
if(w==o){
b.setUTCSeconds(b.getUTCSeconds()+1)
}else{
return v
}}}}}
var f=b.getTimezoneOffset()*-1;
if(f!=k){
if(w<o){
v=c(y,b,w+1,v)
}else{
var x=new Date();
x.setUTCFullYear(y.getFullYear(),y.getMonth(),y.getDate());
x.setUTCHours(y.getHours(),y.getMinutes(),y.getSeconds()+1);
var g=v[k<f?"daylight":"standard"]={
offset:f,trans:[x.getUTCFullYear(),x.getUTCMonth()+1,x.getUTCDate(),x.getUTCHours(),x.getUTCMinutes(),x.getUTCSeconds()]};
AjxTimezone.addWkDayTransition(g);
return v
}}
y.setTime(b.getTime());
k=f
}
return v
}
var t=new Date();
var e=new Date();
var r=t.getFullYear();
t.setUTCFullYear(r,t.getMonth(),t.getDate()-1);
t.setUTCHours(0,0,0,0);
e.setTime(t.getTime());
e.setUTCFullYear(r+1,t.getMonth(),t.getDate()+1);
var h=c(t,e,l);
if(!h.daylight||!h.standard){
h.standard={
offset:t.getTimezoneOffset()*-1};
delete h.daylight
}
h.serverId=["(GMT",AjxTimezone._generateShortName(h.standard.offset,true),") ",AjxTimezone.AUTO_DETECTED].join("");
if(h.daylight&&h.daylight.offset<h.standard.offset){
var n=h.daylight;
h.daylight=h.standard;
h.standard=n
}
return h
};
AjxTimezone._generateShortName=function(n,o){
if(n==0){
return""
}
var t=n<0?"-":"+";
var a=Math.abs(n);
var e=Math.floor(a/60);
var i=a%60;
e=e<10?"0"+e:e;
i=i<10?"0"+i:i;
return[t,e,o?".":"",i].join("")
};
AjxTimezone.DEFAULT_RULE=AjxTimezone._guessMachineTimezone();
(function(){
AjxTimezoneData.TIMEZONE_RULES.sort(AjxTimezone._BY_OFFSET);
for(var e=0;
e<AjxTimezoneData.TIMEZONE_RULES.length;
e++){
var t=AjxTimezoneData.TIMEZONE_RULES[e];
AjxTimezone.addRule(t)
}}
)();
AjxTimezone.DEFAULT=AjxTimezone.getClientId(AjxTimezone.DEFAULT_RULE.serverId)
}
if(AjxPackage.define("ajax.net.AjxRpcRequest")){
AjxRpcRequest=function(e){
if(!AjxRpcRequest.__inited){
AjxRpcRequest.__init()
}
this.id=e;
this.__httpReq=AjxRpcRequest.__msxmlVers?(new ActiveXObject(AjxRpcRequest.__msxmlVers)):(new XMLHttpRequest())
};
AjxRpcRequest.TIMEDOUT=-1000;
AjxRpcRequest.__inited=false;
AjxRpcRequest.__msxmlVers=null;
AjxRpcRequest.prototype.toString=function(){
return"AjxRpcRequest"
};
AjxRpcRequest.prototype.invoke=function(a,t,s,c,h,r){
var e=(c!=null);
this.requestStr=a;
this.__httpReq.open((h)?"get":"post",t,e);
if(e){
if(r){
var o=new AjxTimedAction(this,this.__handleTimeout,[c]);
c._timedActionId=AjxTimedAction.scheduleAction(o,r)
}
var l=this;
this.__httpReq.onreadystatechange=function(i){
if(window.AjxRpcRequest){
AjxRpcRequest.__handleResponse(l,c)
}}
}else{
this.__httpReq.onreadystatechange=function(i){}
}
if(s){
for(var n in s){
this.__httpReq.setRequestHeader(n,s[n])
}}
this.__httpReq.send(a);
if(e){
return this.id
}else{
if(this.__httpReq.status==200||this.__httpReq.status==201){
return{
text:this.__httpReq.responseText,xml:this.__httpReq.responseXML,success:true}
}else{
return{
text:this.__httpReq.responseText,xml:this.__httpReq.responseXML,success:false,status:this.__httpReq.status}
}}};
AjxRpcRequest.prototype.cancel=function(){
AjxRpc.freeRpcCtxt(this);
if(AjxEnv.isFirefox3_5up){
this.__httpReq.onreadystatechange=function(){}
}
this.__httpReq.abort()
};
AjxRpcRequest.prototype.__handleTimeout=function(e){
this.cancel();
e.run({
text:null,xml:null,success:false,status:AjxRpcRequest.TIMEDOUT}
)
};
AjxRpcRequest.__handleResponse=function(a,i){
try{
if(!a||!a.__httpReq){
a.cancel();
AjxDebug.println(AjxDebug.RPC,"Async RPC request: Lost request object!!!");
i.run({
text:null,xml:null,success:false,status:500}
);
return
}
if(a.__httpReq.readyState==4){
if(i._timedActionId!==null){
AjxTimedAction.cancelAction(i._timedActionId)
}
var e=500;
try{
e=a.__httpReq.status
}
catch(t){}
if(e==200||e==201){
i.run({
text:a.__httpReq.responseText,xml:a.__httpReq.responseXML,success:true,reqId:a.id}
)
}else{
i.run({
text:a.__httpReq.responseText,xml:a.__httpReq.responseXML,success:false,status:e,reqId:a.id}
)
}
a.cancel()
}}
catch(t){
AjxException.reportScriptError(t)
}};
AjxRpcRequest.__init=function(){
if(!window.XMLHttpRequest&&window.ActiveXObject){
var t=["MSXML2.XMLHTTP.4.0","MSXML2.XMLHTTP.3.0","MSXML2.XMLHTTP","Microsoft.XMLHTTP"];
for(var o=0;
o<t.length;
o++){
try{
var e=new ActiveXObject(t[o]);
AjxRpcRequest.__msxmlVers=t[o];
break
}
catch(a){}}
if(!AjxRpcRequest.__msxmlVers){
throw new AjxException("MSXML not installed",AjxException.INTERNAL_ERROR,"AjxRpc._init")
}}
AjxRpcRequest.__inited=true
}
}
if(AjxPackage.define("ajax.net.AjxRpc")){
AjxRpc=function(){};
AjxRpc.__rpcCache=[];
AjxRpc.__rpcOutstanding={};
AjxRpc.__RPC_CACHE_MAX=50;
AjxRpc.__RPC_COUNT=0;
AjxRpc.__RPC_REAP_AGE=300000;
AjxRpc.invoke=function(a,t,n,c,l,h){
var e=(c!=null);
var o=AjxRpc.__getFreeRpcCtxt();
try{
var i=o.invoke(a,t,n,c,l,h)
}
catch(s){
var r=new AjxException();
r.method="AjxRpc.prototype._invoke";
if(s instanceof Error){
r.detail=s.message;
r.code=AjxException.NETWORK_ERROR;
r.msg="Network error"
}else{
if(s instanceof XMLHttpRequestException&&s.code==101){
r.detail=s.message;
r.code=AjxException.NETWORK_ERROR;
r.msg="Network error"
}else{
r.detail=s.toString();
r.code=AjxException.UNKNOWN_ERROR;
r.msg="Unknown Error"
}}
if(!e){
AjxRpc.freeRpcCtxt(o)
}
throw r
}
if(!e){
AjxRpc.freeRpcCtxt(o)
}
return i
};
AjxRpc.freeRpcCtxt=function(e){
if(AjxRpc.__rpcOutstanding[e.id]){
AjxRpc.__rpcCache.push(e);
delete AjxRpc.__rpcOutstanding[e.id]
}};
AjxRpc.getRpcRequestById=function(e){
return(AjxRpc.__rpcOutstanding[e])
};
AjxRpc.__getFreeRpcCtxt=function(){
var e;
if(AjxRpc.__rpcCache.length>0){
e=AjxRpc.__rpcCache.pop();
AjxDebug.println(AjxDebug.RPC,"reusing RPC ID "+e.id)
}else{
if(AjxRpc.__RPC_COUNT<AjxRpc.__RPC_CACHE_MAX){
var s="__RpcCtxt_"+AjxRpc.__RPC_COUNT;
e=new AjxRpcRequest(s);
AjxRpc.__RPC_COUNT++;
AjxDebug.println(AjxDebug.RPC,"Created RPC "+s+", total created: "+AjxRpc.__RPC_COUNT)
}else{
e=AjxRpc.__reap();
if(!e){
var n=[];
for(var t in AjxRpc.__rpcOutstanding){
var e=AjxRpc.__rpcOutstanding[t];
var o=e.requestStr;
if(o){
n.push(o.replace(/"authToken":"\w*"/,'"authToken":"[removed]"'))
}}
var a=n.join("<br><br>");
AjxDebug.println(AjxDebug.RPC,"Out of RPC cache!!! Outstanding requests: "+a);
throw new AjxException("Out of RPC cache",AjxException.OUT_OF_RPC_CACHE,"AjxRpc.__getFreeRpcCtxt",a)
}}}
AjxRpc.__rpcOutstanding[e.id]=e;
e.timestamp=(new Date()).getTime();
return e
};
AjxRpc.__reap=function(){
var e;
var a=(new Date()).getTime();
for(var t in AjxRpc.__rpcOutstanding){
e=AjxRpc.__rpcOutstanding[t];
if(e.timestamp+AjxRpc.__RPC_REAP_AGE<a){
AjxDebug.println(AjxDebug.RPC,"AjxRpc.__reap: cleared RPC context "+e.id);
e.cancel();
delete AjxRpc.__rpcOutstanding[t];
return e
}}
return null
}
}
if(AjxPackage.define("zimbraMail.docs.view.ZmDocsPreview")){
ZmDocsPreview=function(e,t){
this._container=document.getElementById(e);
t=t||{};
if(t.versionCont){
t.versionCont=document.getElementById(t.versionCont)
}
if(t.dateContainer){
t.dateContainer=document.getElementById(t.dateContainer)
}
this._params=t;
if(!t.deferInit){
this.init()
}};
ZmDocsPreview.prototype.constructor=ZmDocsPreview;
ZmDocsPreview.launch=function(e,t){
return(new ZmDocsPreview(e,t))
};
ZmDocsPreview.prototype.init=function(){
this.loadContent(new AjxCallback(this,this.show))
};
ZmDocsPreview.prototype.loadContent=function(e){
if(!this._content){
this.fetchContent(e);
return
}
if(e){
e.run()
}};
ZmDocsPreview.prototype.getContent=function(){
return this._content
};
ZmDocsPreview.prototype.fetchContent=function(i){
var e=window.location.href;
e=e.replace(/\?.*/,"");
var a=[];
a.push("fmt=native");
var t=this._params.version;
if(t){
a.push("ver="+t)
}
a=a.join("&");
e=e+(a.length>0?"?":"")+a;
AjxRpc.invoke(a,e,null,new AjxCallback(this,this._handleFetchContent,i),true)
};
ZmDocsPreview.prototype._handleFetchContent=function(t,e){
this._content=e.text;
if(t){
t.run()
}};
ZmDocsPreview.prototype.show=function(){
var a=this._content;
this._container.innerHTML=a;
var i=this._params;
if(i.versionCont){
i.versionCont.innerHTML=this._params.version
}
if(i.dateContainer&&i.dateModified){
var t=new Date(i.dateModified);
i.dateModified=AjxTimezone.convertTimezone(t,AjxTimezone.GMT,AjxTimezone.DEFAULT);
var e=AjxDateFormat.getDateTimeInstance(AjxDateFormat.LONG,AjxDateFormat.SHORT);
i.dateContainer.innerHTML=e.format(i.dateModified)||i.dateModified
}}
}};
