
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
if(AjxPackage.define("IMConference")){
if(AjxPackage.define("zimbraMail.share.view.dialog.ZmPromptDialog")){
ZmPromptDialog=function(e){
e.buttons=e.buttons||[DwtDialog.OK_BUTTON,DwtDialog.CANCEL_BUTTON];
this._password=e.password;
ZmDialog.call(this,e);
this._labelFieldId=this._htmlElId+"_label";
this._nameFieldId=this._htmlElId+"_name";
this._setNameField(this._nameFieldId)
};
ZmPromptDialog.prototype=new ZmDialog;
ZmPromptDialog.prototype.constructor=ZmPromptDialog;
ZmPromptDialog.prototype.toString=function(){
return"ZmPromptDialog"
};
ZmPromptDialog.getInstance=function(){
if(!ZmPromptDialog._INSTANCE){
ZmPromptDialog._INSTANCE=new ZmPromptDialog({
parent:appCtxt.getShell()}
)
}
return ZmPromptDialog._INSTANCE
};
ZmPromptDialog.getPasswordInstance=function(){
if(!ZmPromptDialog._PASSWORD_INSTANCE){
ZmPromptDialog._PASSWORD_INSTANCE=new ZmPromptDialog({
parent:appCtxt.getShell(),password:true}
)
}
return ZmPromptDialog._PASSWORD_INSTANCE
};
ZmPromptDialog.prototype.popup=function(t){
this.setTitle(t.title);
Dwt.byId(this._labelFieldId).innerHTML=t.label;
var e=Dwt.byId(this._nameFieldId);
e.innerHTML=t.value||"";
this._resetCallbacks();
this.registerCallback(DwtDialog.OK_BUTTON,t.callback);
DwtDialog.prototype.popup.call(this);
if(e.focus){
e.focus()
}};
ZmPromptDialog.prototype._contentHtml=function(){
return AjxTemplate.expand("share.Dialogs#ZmPromptDialog",{
id:this._htmlElId,type:this._password?"password":"text"}
)
};
ZmPromptDialog.prototype._okButtonListener=function(t){
var e=this._getPromptData();
if(e){
DwtDialog.prototype._buttonListener.call(this,t,e)
}};
ZmPromptDialog.prototype._getPromptData=function(){
return{
value:AjxStringUtil.trim(this._nameField.value),dialog:this}
};
ZmPromptDialog.prototype._enterListener=function(t){
var e=this._getPromptData();
if(e){
this._runEnterCallback(e)
}};
ZmPromptDialog.prototype._getTabGroupMembers=function(){
return[this._nameField,this._colorButton]
}
}
if(AjxPackage.define("zimbraMail.im.model.ZmConferenceRoom")){
ZmConferenceRoom=function(e){
if(arguments.length==0){
return
}
e.type=ZmOrganizer.CONFERENCE_ITEM;
ZmOrganizer.call(this,e);
this.status=e.status||ZmConferenceRoom.STATUS.READY;
this.thread=e.thread;
this.config=null
};
ZmConferenceRoom.STATUS={
NEW:"NewRoomCreated",READY:"- Ready -"};
ZmConferenceRoom.prototype=new ZmOrganizer;
ZmConferenceRoom.prototype.constructor=ZmConferenceRoom;
ZmConferenceRoom.prototype.toString=function(){
return"ZmConferenceRoom"
};
ZmConferenceRoom.prototype.getAddress=function(){
return this.id
};
ZmConferenceRoom.prototype.getIcon=function(){
return"ImGroup"
};
ZmConferenceRoom.prototype.configure=function(e,a){
var t=new AjxCallback(this,this._handleResponseConfigure,[e,a]);
ZmImApp.INSTANCE.getService().configureConferenceRoom(this,e,t)
};
ZmConferenceRoom.prototype._handleResponseConfigure=function(e,t){
this.status=ZmConferenceRoom.STATUS.READY;
this._config=e;
if(t){
t.run(this)
}};
ZmConferenceRoom.prototype.join=function(e,a){
var t=new AjxCallback(this,this._handleResponseJoin,[a]);
ZmImApp.INSTANCE.getService().joinConferenceRoom(this,e,t)
};
ZmConferenceRoom.prototype._handleResponseJoin=function(t,e){
this.thread=e.thread;
if(t){
t.run(this,e)
}}
}
if(AjxPackage.define("zimbraMail.im.model.ZmConferenceService")){
ZmConferenceService=function(t){
if(arguments.length==0){
return
}
t.type=ZmOrganizer.CONFERENCE_ITEM;
ZmOrganizer.call(this,t);
var e={
tree:this.tree,name:ZmMsg.loading,parent:this,type:ZmOrganizer.CONFERENCE_ITEM};
var a=new ZmOrganizer(e);
this.children.add(a);
this.roomsLoaded=false
};
ZmConferenceService.prototype=new ZmOrganizer;
ZmConferenceService.prototype.constructor=ZmConferenceService;
ZmConferenceService.prototype.toString=function(){
return"ZmConferenceService"
};
ZmConferenceService.sortCompare=function(t,e){
if(t.name.toLowerCase()>e.name.toLowerCase()){
return 1
}
if(t.name.toLowerCase()<e.name.toLowerCase()){
return -1
}
return 0
};
ZmConferenceService.prototype.getAddress=function(){
return this.id
};
ZmConferenceService.prototype.getIcon=function(){
return"Globe"
};
ZmConferenceService.prototype.getRooms=function(t,e){
if(!this.roomsLoaded||e){
ZmImApp.INSTANCE.getService().getConferenceRooms(this,new AjxCallback(this,this._handleResponseGetRooms,[t]))
}};
ZmConferenceService.prototype._handleResponseGetRooms=function(r,n){
while(this.children.size()){
var s=this.children.get(this.children.size()-1);
s.notifyDelete()
}
for(var t=0,a=n.length;
t<a;
t++){
var e={
tree:this.tree,id:n[t].addr,name:n[t].name,parent:this};
var o=new ZmConferenceRoom(e);
this.children.add(o);
o._notify(ZmEvent.E_CREATE)
}
this.roomsLoaded=true;
if(r){
r.run(this.children)
}};
ZmConferenceService.prototype.createRoom=function(e,t){
ZmImApp.INSTANCE.getService().createConferenceRoom(this,e,new AjxCallback(this,this._handleResponseCreateRoom,[t]))
};
ZmConferenceService.prototype._handleResponseCreateRoom=function(i,a){
var e={
id:a.addr,tree:this.tree,name:a.name,parent:this,status:a.status,thread:a.thread};
var t=new ZmConferenceRoom(e);
this.children.add(t);
t._notify(ZmEvent.E_CREATE);
if(i){
i.run(t)
}}
}
if(AjxPackage.define("zimbraMail.im.view.ZmConferenceDialog")){
ZmConferenceDialog=function(a){
ZmDialog.call(this,a);
this._overviewId=this._htmlElId+"_overview";
this._setNameField(this._messageFieldId);
var e={
treeIds:[ZmOrganizer.CONFERENCE_ITEM],fieldId:this._overviewId};
var t=this._setOverview(e);
this._treeView=t.getTreeView(ZmOrganizer.CONFERENCE_ITEM);
this._treeView.addSelectionListener(new AjxListener(this,this._treeViewListener))
};
ZmConferenceDialog.prototype=new ZmDialog;
ZmConferenceDialog.prototype.constructor=ZmConferenceDialog;
ZmConferenceDialog.prototype.toString=function(){
return"ZmConferenceDialog"
};
ZmConferenceDialog.getInstance=function(){
ZmConferenceDialog.INSTANCE=ZmConferenceDialog.INSTANCE||new ZmConferenceDialog({
parent:appCtxt.getShell(),title:ZmMsg.imConferenceRooms}
);
return ZmConferenceDialog.INSTANCE
};
ZmConferenceDialog.prototype.popup=function(){
ZmDialog.prototype.popup.call(this);
ZmImApp.INSTANCE.getRoster().getConferenceServices(new AjxCallback(this,this._handleResponseGetServices))
};
ZmConferenceDialog.prototype._handleResponseGetServices=function(e){
e[0].getRooms(null,true)
};
ZmConferenceDialog.prototype.getValue=function(){
return Dwt.byId(this._messageFieldId).value
};
ZmConferenceDialog.prototype._contentHtml=function(){
this._messageFieldId=Dwt.getNextId();
return AjxTemplate.expand("im.Chat#ZmConferenceDialog",{
id:this._htmlElId}
)
};
ZmConferenceDialog.prototype._enterListener=function(){
this._runEnterCallback()
};
ZmConferenceDialog.prototype._okButtonListener=function(t){
var e=this._treeView.getSelection();
if(e.length){
this._join(e[0])
}};
ZmConferenceDialog.prototype._treeViewListener=function(e){
if(e.detail==DwtTree.ITEM_DBL_CLICKED){
this._join(e.item)
}};
ZmConferenceDialog.prototype._join=function(t){
var e=t.getData(Dwt.KEY_OBJECT);
if(e instanceof ZmConferenceRoom){
e.join(null,new AjxCallback(this,this._handleResponseJoin))
}};
ZmConferenceDialog.prototype._handleResponseJoin=function(a,i){
this.popdown();
if(i.error){
if(i.error=="PasswordRequired"){
var t={
title:ZmMsg.imRoomPasswordRequired,label:ZmMsg.passwordLabel,callback:new AjxCallback(this,this._handlePasswordOk,[a])};
var e=ZmPromptDialog.getPasswordInstance();
e.popup(t)
}else{
this._reportJoinError(i.error)
}}};
ZmConferenceDialog.prototype._handlePasswordOk=function(t,e){
t.join(e.value,new AjxCallback(this,this._handleResponseJoinRetry,[e.dialog]))
};
ZmConferenceDialog.prototype._handleResponseJoinRetry=function(e,t,a){
if(!a.error){
e.popdown()
}else{
if(a.error=="PasswordRequired"){
appCtxt.setStatusMsg(ZmMsg.imRoomPasswordFailed,ZmStatusView.LEVEL_CRITICAL)
}else{
e.popdown();
this._reportJoinError(a.error)
}}};
ZmConferenceDialog.prototype._reportJoinError=function(e){
var a=ZMsg["im."+e]||ZMsg["im.unknown_error"];
var t=appCtxt.getMsgDialog();
t.reset();
t.setMessage(a,DwtMessageDialog.CRITICAL_STYLE,ZmMsg.zimbraTitle);
t.popup()
}
}
if(AjxPackage.define("zimbraMail.im.view.ZmNewConferenceRoomDialog")){
ZmNewConferenceRoomDialog=function(e){
ZmDialog.call(this,e);
this._createForm()
};
ZmNewConferenceRoomDialog.prototype=new ZmDialog;
ZmNewConferenceRoomDialog.prototype.constructor=ZmNewConferenceRoomDialog;
ZmNewConferenceRoomDialog.prototype.toString=function(){
return"ZmNewConferenceRoomDialog"
};
ZmNewConferenceRoomDialog.getInstance=function(){
ZmNewConferenceRoomDialog.INSTANCE=ZmNewConferenceRoomDialog.INSTANCE||new ZmNewConferenceRoomDialog({
parent:appCtxt.getShell()}
);
return ZmNewConferenceRoomDialog.INSTANCE
};
ZmNewConferenceRoomDialog.prototype.popup=function(e){
e=e||{};
e.config=e.config||{};
this.setTitle(e.title);
this._form.setValue("NAME",e.name||"");
this._form.setValue("PASSWORD","");
this._form.setValue("CONFIRM_PASSWORD","");
this._form.setValue("PERMANENT",e.config.persistent);
this._form.setValue("ANONYMOUS",!e.config.noanonymous);
this.registerCallback(DwtDialog.OK_BUTTON,e.callback);
ZmDialog.prototype.popup.call(this)
};
ZmNewConferenceRoomDialog.prototype._createForm=function(){
var e={
parent:this,parentElement:this._getContentDiv()};
e.form={
items:[{
id:"NAME",type:"DwtInputField"}
,{
id:"PERMANENT",type:"DwtCheckbox",label:ZmMsg.imPermanentInfo}
,{
id:"ANONYMOUS",type:"DwtCheckbox",label:ZmMsg.imAnonymousInfo}
,{
id:"PASSWORD",type:"DwtInputField",params:{
type:DwtInputField.PASSWORD}}
,{
id:"CONFIRM_PASSWORD",type:"DwtInputField",params:{
type:DwtInputField.PASSWORD}}
],template:"im.Chat#ZmNewConferenceRoomDialog"};
this._form=new DwtForm(e);
this._setNameField(this._messageFieldId)
};
ZmNewConferenceRoomDialog.prototype._getRoomData=function(){
var a=this._form.getValue("NAME");
if(!a){
appCtxt.setStatusMsg(ZmMsg.imRoomNameRequired,ZmStatusView.LEVEL_CRITICAL);
return null
}
var t=this._form.getValue("PASSWORD");
var e=this._form.getValue("CONFIRM_PASSWORD");
if(t!=e){
appCtxt.setStatusMsg(ZmMsg.imPasswordMismatch,ZmStatusView.LEVEL_CRITICAL);
return null
}
return{
dialog:this,name:a,config:{
passwordprotect:t?true:false,password:this._form.getValue("PASSWORD"),persistent:!!this._form.getValue("PERMANENT"),noanonymous:!this._form.getValue("ANONYMOUS")}}
};
ZmNewConferenceRoomDialog.prototype._enterListener=function(){
var e=this._getRoomData();
if(e){
this._runEnterCallback(e)
}};
ZmNewConferenceRoomDialog.prototype._okButtonListener=function(t){
var e=this._getRoomData();
if(e){
DwtDialog.prototype._buttonListener.call(this,t,e)
}};
ZmNewConferenceRoomDialog.prototype._handleResponseJoin=function(){
this.popdown()
}
}
if(AjxPackage.define("zimbraMail.im.controller.ZmConferenceTreeController")){
ZmConferenceTreeController=function(){
ZmTreeController.call(this,ZmOrganizer.CONFERENCE_ITEM)
};
ZmConferenceTreeController.prototype=new ZmTreeController;
ZmConferenceTreeController.prototype.constructor=ZmConferenceTreeController;
ZmConferenceTreeController.prototype.toString=function(){
return"ZmConferenceTreeController"
};
ZmConferenceTreeController.prototype.getDataTree=function(){
var e=ZmImApp.INSTANCE.getRoster().getConferenceTree();
if(!this._dataChangeListener){
e.addChangeListener(this._getTreeChangeListener())
}
return e
};
ZmConferenceTreeController.prototype.resetOperations=function(t,e,i){
var a=appCtxt.getById(i);
t.enable(ZmOperation.EXPAND_ALL,(a.size()>0))
};
ZmConferenceTreeController.prototype._treeListener=function(t){
ZmTreeController.prototype._treeListener.apply(this,arguments);
if(t.detail==DwtTree.ITEM_EXPANDED){
var e=t&&t.item&&t.item.getData(Dwt.KEY_OBJECT);
if((e instanceof ZmConferenceService)&&!e.roomsLoaded){
e.getRooms()
}}};
ZmConferenceTreeController.prototype._getHeaderActionMenuOps=function(){
return null
};
ZmConferenceTreeController.prototype._getActionMenu=function(e){
return null
}
}};
