
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
if(AjxPackage.define("Share")){
if(AjxPackage.define("zimbraMail.share.model.ZmShare")){
ZmShare=function(e){
this.grantee={};
this.grantor={};
this.link={};
if(!e){
return
}
this.object=e.object;
this.grantee.type=e.granteeType;
this.grantee.id=e.granteeId;
this.grantee.name=e.granteeName||"";
this.link.inh=e.inherit;
this.link.pw=e.granteePwd;
this.invalid=e.invalid;
this.setPermissions(e.perm)
};
ZmShare.URI="urn:zimbraShare";
ZmShare.VERSION="0.1";
ZmShare.NEXT_VERSION="0.2";
ZmShare.NEW="new";
ZmShare.EDIT="edit";
ZmShare.DELETE="delete";
ZmShare.ACCEPT="accept";
ZmShare.DECLINE="decline";
ZmShare.NOTIFY="notify";
ZmShare.RESEND="resend";
ZmShare.REVOKE="revoke";
ZmShare.ACTION_LABEL={};
ZmShare.ACTION_LABEL[ZmShare.EDIT]=ZmMsg.edit;
ZmShare.ACTION_LABEL[ZmShare.RESEND]=ZmMsg.resend;
ZmShare.ACTION_LABEL[ZmShare.REVOKE]=ZmMsg.revoke;
ZmShare.PERM_READ="r";
ZmShare.PERM_WRITE="w";
ZmShare.PERM_INSERT="i";
ZmShare.PERM_DELETE="d";
ZmShare.PERM_ADMIN="a";
ZmShare.PERM_WORKFLOW="x";
ZmShare.PERM_PRIVATE="p";
ZmShare.PERM_CREATE_SUBDIR="c";
ZmShare.PERM_NOREAD="-r";
ZmShare.PERM_NOWRITE="-w";
ZmShare.PERM_NOINSERT="-i";
ZmShare.PERM_NODELETE="-d";
ZmShare.PERM_NOADMIN="-a";
ZmShare.PERM_NOWORKFLOW="-x";
ZmShare.PERMS={};
ZmShare.PERMS[ZmShare.PERM_READ]=ZmMsg.shareActionRead;
ZmShare.PERMS[ZmShare.PERM_WRITE]=ZmMsg.shareActionWrite;
ZmShare.PERMS[ZmShare.PERM_INSERT]=ZmMsg.shareActionInsert;
ZmShare.PERMS[ZmShare.PERM_DELETE]=ZmMsg.shareActionDelete;
ZmShare.PERMS[ZmShare.PERM_ADMIN]=ZmMsg.shareActionAdmin;
ZmShare.PERMS[ZmShare.PERM_WORKFLOW]=ZmMsg.shareActionWorkflow;
ZmShare.PERMS[ZmShare.PERM_NOREAD]=ZmMsg.shareActionNoRead;
ZmShare.PERMS[ZmShare.PERM_NOWRITE]=ZmMsg.shareActionNoWrite;
ZmShare.PERMS[ZmShare.PERM_NOINSERT]=ZmMsg.shareActionNoInsert;
ZmShare.PERMS[ZmShare.PERM_NODELETE]=ZmMsg.shareActionNoDelete;
ZmShare.PERMS[ZmShare.PERM_NOADMIN]=ZmMsg.shareActionNoAdmin;
ZmShare.PERMS[ZmShare.PERM_NOWORKFLOW]=ZmMsg.shareActionNoWorkflow;
ZmShare.ROLE_NONE="NONE";
ZmShare.ROLE_VIEWER="VIEWER";
ZmShare.ROLE_MANAGER="MANAGER";
ZmShare.ROLE_ADMIN="ADMIN";
ZmShare.ROLE_TEXT={};
ZmShare.ROLE_TEXT[ZmShare.ROLE_NONE]=ZmMsg.shareRoleNone;
ZmShare.ROLE_TEXT[ZmShare.ROLE_VIEWER]=ZmMsg.shareRoleViewer;
ZmShare.ROLE_TEXT[ZmShare.ROLE_MANAGER]=ZmMsg.shareRoleManager;
ZmShare.ROLE_TEXT[ZmShare.ROLE_ADMIN]=ZmMsg.shareRoleAdmin;
ZmShare.ROLE_PERMS={};
ZmShare.ROLE_PERMS[ZmShare.ROLE_NONE]="";
ZmShare.ROLE_PERMS[ZmShare.ROLE_VIEWER]="r";
ZmShare.ROLE_PERMS[ZmShare.ROLE_MANAGER]="rwidx";
ZmShare.ROLE_PERMS[ZmShare.ROLE_ADMIN]="rwidxa";
ZmShare.TYPE_ALL="all";
ZmShare.TYPE_USER="usr";
ZmShare.TYPE_GROUP="grp";
ZmShare.TYPE_DOMAIN="dom";
ZmShare.TYPE_COS="cos";
ZmShare.TYPE_GUEST="guest";
ZmShare.TYPE_PUBLIC="pub";
ZmShare.ZID_ALL="00000000-0000-0000-0000-000000000000";
ZmShare.ZID_PUBLIC="99999999-9999-9999-9999-999999999999";
ZmShare.SHARE="SHARE";
ZmShare.GRANT="GRANT";
ZmShare._SUBJECTS={};
ZmShare._SUBJECTS[ZmShare.NEW]=ZmMsg.shareCreatedSubject;
ZmShare._SUBJECTS[ZmShare.EDIT]=ZmMsg.shareModifiedSubject;
ZmShare._SUBJECTS[ZmShare.DELETE]=ZmMsg.shareRevokedSubject;
ZmShare._SUBJECTS[ZmShare.ACCEPT]=ZmMsg.shareAcceptedSubject;
ZmShare._SUBJECTS[ZmShare.DECLINE]=ZmMsg.shareDeclinedSubject;
ZmShare._SUBJECTS[ZmShare.NOTIFY]=ZmMsg.shareNotifySubject;
ZmShare._TEXT=null;
ZmShare._HTML=null;
ZmShare._HTML_NOTE=null;
ZmShare._XML=null;
ZmShare.getDefaultMountpointName=function(e,t){
if(!ZmShare._defaultNameFormatter){
ZmShare._defaultNameFormatter=new AjxMessageFormat(ZmMsg.shareNameDefault)
}
return ZmShare._defaultNameFormatter.format([e,t])
};
ZmShare.getRoleName=function(e){
return ZmShare.ROLE_TEXT[e]||ZmMsg.shareRoleCustom
};
ZmShare.getRoleActions=function(n){
var t=ZmShare.ROLE_PERMS[n];
var a=[];
if(t){
for(var e=0;
e<t.length;
e++){
var o=t.charAt(e);
if(o=="x"){
continue
}
if(o=="-"){
o+=t.charAt(++e)
}
a.push(ZmShare.PERMS[o])
}}
return(a.length>0)?a.join(", "):ZmMsg.shareActionNone
};
ZmShare.ACTIONS={};
ZmShare.ACTIONS[ZmShare.ROLE_NONE]=ZmShare.getRoleActions(ZmShare.ROLE_NONE);
ZmShare.ACTIONS[ZmShare.ROLE_VIEWER]=ZmShare.getRoleActions(ZmShare.ROLE_VIEWER);
ZmShare.ACTIONS[ZmShare.ROLE_MANAGER]=ZmShare.getRoleActions(ZmShare.ROLE_MANAGER);
ZmShare.ACTIONS[ZmShare.ROLE_ADMIN]=ZmShare.getRoleActions(ZmShare.ROLE_ADMIN);
ZmShare.createFromDom=function(a){
var t=new ZmShare();
var e=a.documentElement;
t.version=e.getAttribute("version");
if(t.version!=ZmShare.VERSION&&t.version!=ZmShare.NEXT_VERSION){
throw"Zimbra share version must be "+ZmShare.VERSION
}
t.action=e.getAttribute("action");
var i=e.firstChild;
while(i!=null){
switch(i.nodeName){
case"grantee":case"grantor":t[i.nodeName].id=i.getAttribute("id");
t[i.nodeName].email=i.getAttribute("email");
t[i.nodeName].name=i.getAttribute("name");
break;
case"link":t.link.id=i.getAttribute("id");
t.link.name=i.getAttribute("name");
t.link.view=i.getAttribute("view");
t.link.perm=i.getAttribute("perm");
break
}
i=i.nextSibling
}
return t
};
ZmShare.prototype.toString=function(){
return"ZmShare"
};
ZmShare.prototype.setPermissions=function(e){
this.link.perm=e;
this.link.role=ZmShare.getRoleFromPerm(e)
};
ZmShare.prototype.isPermAllowed=function(t){
if(this.link.perm){
var e=this.link.perm.replace(/-./g,"");
return(e.indexOf(t)!=-1)
}
return false
};
ZmShare.prototype.isPermRestricted=function(e){
if(this.link.perm){
return(this.link.perm.indexOf("-"+e)!=-1)
}
return false
};
ZmShare.prototype.isRead=function(){
return this.isPermAllowed(ZmShare.PERM_READ)
};
ZmShare.prototype.isWrite=function(){
return this.isPermAllowed(ZmShare.PERM_WRITE)
};
ZmShare.prototype.isInsert=function(){
return this.isPermAllowed(ZmShare.PERM_INSERT)
};
ZmShare.prototype.isDelete=function(){
return this.isPermAllowed(ZmShare.PERM_DELETE)
};
ZmShare.prototype.isAdmin=function(){
return this.isPermAllowed(ZmShare.PERM_ADMIN)
};
ZmShare.prototype.isWorkflow=function(){
return this.isPermAllowed(ZmShare.PERM_WORKFLOW)
};
ZmShare.prototype.hasPrivateAccess=function(){
return this.isPermAllowed(ZmShare.PERM_PRIVATE)
};
ZmShare._getFolderType=function(e){
var t=(e&&ZmOrganizer.FOLDER_KEY[ZmOrganizer.TYPE[e]])||"folder";
return ZmMsg[t]
};
ZmShare.createFromJs=function(t,e){
return new ZmShare({
object:t,granteeType:e.gt,granteeId:e.zid,granteeName:e.d,perm:e.perm,inherit:e.inh,granteePwd:e.pw,invalid:e.invalid}
)
};
ZmShare.prototype.isAll=function(){
return this.grantee.type==ZmShare.TYPE_ALL
};
ZmShare.prototype.isUser=function(){
return this.grantee.type==ZmShare.TYPE_USER
};
ZmShare.prototype.isGroup=function(){
return this.grantee.type==ZmShare.TYPE_GROUP
};
ZmShare.prototype.isDomain=function(){
return this.grantee.type==ZmShare.TYPE_DOMAIN
};
ZmShare.prototype.isGuest=function(){
return this.grantee.type==ZmShare.TYPE_GUEST
};
ZmShare.prototype.isPublic=function(){
return(this.grantee.type==ZmShare.TYPE_PUBLIC)
};
ZmShare.prototype.grant=function(a,t,e){
this.link.perm=a;
var i=new AjxCallback(this,this._handleResponseGrant);
this._shareAction("grant",null,{
perm:a,pw:t}
,i,e)
};
ZmShare.prototype._handleResponseGrant=function(e){
var t=e.getResponse().FolderActionResponse.action;
this.grantee.id=t.zid;
this.grantee.email=t.d
};
ZmShare.prototype.revoke=function(i){
var t=this.grantee&&(this.grantee.type==ZmShare.TYPE_ALL);
var e={
zid:this.isPublic()?ZmShare.ZID_PUBLIC:t?ZmShare.ZID_ALL:this.grantee.id};
var a=new AjxCallback(this,this._handleResponseRevoke,[i]);
this._shareAction("!grant",e,null,a)
};
ZmShare.prototype.revokeMultiple=function(o,t,e){
var a={
zid:this.isPublic()?ZmShare.ZID_PUBLIC:this.grantee.id};
var i=new AjxCallback(this,this._handleResponseRevoke,[o]);
this._shareAction("!grant",a,null,i,e)
};
ZmShare.prototype._handleResponseRevoke=function(e){
if(e){
e.run()
}};
ZmShare.prototype.accept=function(a,t,o,i,r,e){
var s=new AjxCallback(this,this._handleResponseAccept,[o,i,r,e]);
var n={
l:ZmOrganizer.ID_ROOT,name:a,zid:this.grantor.id,rid:ZmOrganizer.normalizeId(this.link.id),color:t,view:this.link.view};
if(String(t).match(/^#/)){
n.rgb=t;
delete n.color
}
if(appCtxt.get(ZmSetting.CALENDAR_ENABLED)&&ZmOrganizer.VIEW_HASH[ZmOrganizer.CALENDAR][this.link.view]){
n.f=ZmOrganizer.FLAG_CHECKED
}
ZmMountpoint.create(n,s)
};
ZmShare.prototype._handleResponseAccept=function(a,t,i,e){
this.notes=t;
if(i){
i.run()
}
if(a!=ZmShareReply.NONE){
if(a==ZmShareReply.COMPOSE){
this.composeMessage(ZmShare.ACCEPT,null,e)
}else{
this.sendMessage(ZmShare.ACCEPT,null,e)
}}};
ZmShare.prototype.sendMessage=function(s,o,e,t){
if(!o){
var i=this.grantee.email;
o=new AjxVector();
o.add(new AjxEmailAddress(i,AjxEmailAddress.TO))
}
var n=this._createMsg(s,false,o,e);
var a=appCtxt.multiAccounts?(this.object?(this.object.getAccount().name):null):null;
n.send(false,null,null,a,false,false,t)
};
ZmShare.prototype.composeMessage=function(o,n,e){
if(!n){
var s=this.grantee.email;
n=new AjxVector();
n.add(new AjxEmailAddress(s,AjxEmailAddress.TO))
}
var t=this._createMsg(o,true,n,e);
var i=t._topPart.children;
var a=i.get(0);
var r=i.get(1);
var h=i.get(2);
t.setBodyParts([a.node,r.node,h.node]);
AjxDispatcher.run("Compose",{
action:ZmOperation.SHARE,inNewWindow:true,msg:t}
)
};
ZmShare._getText=function(e){
if(!ZmShare._TEXT){
ZmShare._TEXT={};
ZmShare._TEXT[ZmShare.NEW]=new AjxMessageFormat(ZmMsg.shareCreatedText);
ZmShare._TEXT[ZmShare.EDIT]=new AjxMessageFormat(ZmMsg.shareModifiedText);
ZmShare._TEXT[ZmShare.DELETE]=new AjxMessageFormat(ZmMsg.shareRevokedText);
ZmShare._TEXT[ZmShare.ACCEPT]=new AjxMessageFormat(ZmMsg.shareAcceptedText);
ZmShare._TEXT[ZmShare.DECLINE]=new AjxMessageFormat(ZmMsg.shareDeclinedText);
ZmShare._TEXT[ZmShare.NOTIFY]=new AjxMessageFormat(ZmMsg.shareNotifyText)
}
return ZmShare._TEXT[e]
};
ZmShare._getHtml=function(e){
if(!ZmShare._HTML){
ZmShare._HTML={};
ZmShare._HTML[ZmShare.NEW]=new AjxMessageFormat(ZmMsg.shareCreatedHtml);
ZmShare._HTML[ZmShare.EDIT]=new AjxMessageFormat(ZmMsg.shareModifiedHtml);
ZmShare._HTML[ZmShare.DELETE]=new AjxMessageFormat(ZmMsg.shareRevokedHtml);
ZmShare._HTML[ZmShare.ACCEPT]=new AjxMessageFormat(ZmMsg.shareAcceptedHtml);
ZmShare._HTML[ZmShare.DECLINE]=new AjxMessageFormat(ZmMsg.shareDeclinedHtml);
ZmShare._HTML[ZmShare.NOTIFY]=new AjxMessageFormat(ZmMsg.shareNotifyHtml)
}
return ZmShare._HTML[e]
};
ZmShare._getHtmlNote=function(){
if(!ZmShare._HTML_NOTE){
ZmShare._HTML_NOTE=new AjxMessageFormat(ZmMsg.shareNotesHtml)
}
return ZmShare._HTML_NOTE
};
ZmShare._getXml=function(){
if(!ZmShare._XML){
var e=['<share xmlns="{0}" version="{1}" action="{2}" >','  <grantee id="{3}" email="{4}" name="{5}" />','  <grantor id="{6}" email="{7}" name="{8}" />','  <link id="{9}" name="{10}" view="{11}" perm="{12}" />',"  <notes>{13}</notes>","</share>"].join("\n");
ZmShare._XML=new AjxMessageFormat(e)
}
return ZmShare._XML
};
ZmShare.prototype._shareAction=function(i,e,t,l,a){
var r=AjxSoapDoc.create("FolderActionRequest","urn:zimbraMail");
var h=r.set("action");
h.setAttribute("op",i);
if(this.object.rid&&this.object.zid){
h.setAttribute("id",this.object.zid+":"+this.object.rid)
}else{
h.setAttribute("id",this.object.id)
}
for(var s in e){
h.setAttribute(s,e[s])
}
if(i!="!grant"){
var n=r.set("grant",null,h);
n.setAttribute("gt",this.grantee.type);
if(this.link.inh){
n.setAttribute("inh","1")
}
if(!this.isPublic()){
n.setAttribute("d",this.isGuest()?(this.grantee.id||this.grantee.name):this.grantee.name)
}
for(var s in t){
n.setAttribute(s,(t[s]||""))
}}
var c=new AjxCallback(this,this._handleResponseShareAction,[l]);
var o=new AjxCallback(this,this._handleErrorShareAction);
if(a){
a.addRequestParams(r,c,o)
}else{
appCtxt.getAppController().sendRequest({
soapDoc:r,asyncMode:true,callback:c,errorCallback:o}
)
}};
ZmShare.prototype._handleResponseShareAction=function(t,e){
if(t){
t.run(e)
}};
ZmShare.prototype._handleErrorShareAction=function(e){
var t=ZmMsg.unknownError;
if(e instanceof ZmCsfeException&&e.code=="account.NO_SUCH_ACCOUNT"){
if(!this._unknownUserFormatter){
this._unknownUserFormatter=new AjxMessageFormat(ZmMsg.unknownUser)
}
t=this._unknownUserFormatter.format(AjxStringUtil.htmlEncode(this.grantee.name));
e=null
}
appCtxt.getAppController().popupErrorDialog(t,e,null,true);
return true
};
ZmShare.prototype._createMsg=function(o,i,n,e){
var a=this._createTextPart(o,i);
var r=this._createHtmlPart(o,i);
var c=new ZmMimePart();
c.setContentType(ZmMimeTable.MULTI_ALT);
c.children.add(a);
c.children.add(r);
if(o!=ZmShare.NOTIFY){
var l=this._createXmlPart(o);
c.children.add(l)
}
var t=new ZmMailMsg();
if(o==ZmShare.ACCEPT||o==ZmShare.DECLINE){
t.setAddress(AjxEmailAddress.FROM,new AjxEmailAddress(this.grantee.email,AjxEmailAddress.FROM));
var h=new AjxVector();
if(e&&e!=this.grantor.email){
h.add(new AjxEmailAddress(e,AjxEmailAddress.TO))
}
h.add(new AjxEmailAddress(this.grantor.email,AjxEmailAddress.TO));
t.setAddresses(AjxEmailAddress.TO,h)
}else{
t.setAddress(AjxEmailAddress.FROM,new AjxEmailAddress(this.grantee.email,AjxEmailAddress.FROM));
var s=(n.size()>1)?AjxEmailAddress.BCC:AjxEmailAddress.TO;
t.setAddresses(s,n)
}
t.setSubject(ZmShare._SUBJECTS[o]+": "+AjxMessageFormat.format(ZmMsg.sharedBySubject,[this.link.name,this.grantor.name]));
t.setTopPart(c);
return t
};
ZmShare.prototype._createTextPart=function(n,e){
var a=ZmShare._getText(n);
var i=this._createContent(a);
if(this.notes||e){
var t=this.notes;
i=[i,ZmItem.NOTES_SEPARATOR,t].join("\n")
}
var o=new ZmMimePart();
o.setContentType(ZmMimeTable.TEXT_PLAIN);
o.setContent(i);
return o
};
ZmShare.prototype._createHtmlPart=function(n,e){
var a=ZmShare._getHtml(n);
var i=this._createContent(a);
if(this.notes||e){
a=ZmShare._getHtmlNote();
var t=AjxStringUtil.nl2br(AjxStringUtil.htmlEncode(this.notes));
i=[i,a.format(t)].join("")
}
var o=new ZmMimePart();
o.setContentType(ZmMimeTable.TEXT_HTML);
o.setContent(i);
return o
};
ZmShare.prototype._createXmlPart=function(n){
var t=(appCtxt.isOffline)?appCtxt.getFolderTree().getByPath(this.link.name):null;
var o=(t)?t.nId:this.link.id;
var i=[ZmShare.URI,ZmShare.VERSION,n,this.grantee.id,this.grantee.email,AjxStringUtil.xmlAttrEncode(this.grantee.name),this.grantor.id,this.grantor.email,AjxStringUtil.xmlAttrEncode(this.grantor.name),o,AjxStringUtil.xmlAttrEncode(this.link.name),this.link.view,this.link.perm,AjxStringUtil.xmlEncode(this.notes)];
var e=ZmShare._getXml().format(i);
var a=new ZmMimePart();
a.setContentType(ZmMimeTable.XML_ZIMBRA_SHARE);
a.setContent(e);
return a
};
ZmShare.prototype._createContent=function(t){
var i=ZmShare.getRoleFromPerm(this.link.perm);
var e=this.object?(this.object.owner||this.grantor.name):this.grantor.name;
e=AjxStringUtil.htmlEncode(e);
var a=[AjxStringUtil.htmlEncode(this.link.name),"("+ZmShare._getFolderType(this.link.view)+")",e,AjxStringUtil.htmlEncode(this.grantee.name),ZmShare.getRoleName(i),ZmShare.getRoleActions(i)];
return t.format(a)
};
ZmShare.getRoleFromPerm=function(e){
if(!e){
return ZmShare.ROLE_NONE
}
if(e.indexOf(ZmShare.PERM_ADMIN)!=-1){
return ZmShare.ROLE_ADMIN
}
if(e.indexOf(ZmShare.PERM_WORKFLOW)!=-1){
return ZmShare.ROLE_MANAGER
}
if(e.indexOf(ZmShare.PERM_READ)!=-1){
return ZmShare.ROLE_VIEWER
}
return ZmShare.ROLE_NONE
};
ZmShare._getRoleFromPerm=ZmShare.getRoleFromPerm;
ZmShare.revokeOrphanGrants=function(t,n,o,e){
var i={
FolderActionRequest:{
_jsns:"urn:zimbraMail",action:{
op:"revokeorphangrants",id:ZmFolder.ID_ROOT,zid:t,gt:n}}};
if(e){
var a=new AjxCallback(null,ZmShare._handleResponseRevokeOrphanGrants,[o]);
e.addRequestParams(i,a)
}else{
appCtxt.getRequestMgr().sendRequest({
jsonObj:i,asyncMode:true,callback:a}
)
}};
ZmShare._handleResponseRevokeOrphanGrants=function(e){
if(e){
e.run()
}};
ZmShare.getShareFromShareInfo=function(t,e){
e=e||new ZmShare();
e.grantee=e.grantee||{};
if(t.granteeName){
e.grantee.name=t.granteeName
}
if(t.granteeId){
e.grantee.id=t.granteeId
}
if(t.granteeType){
e.grantee.type=t.granteeType
}
e.grantor=e.grantor||{};
if(t.ownerEmail){
e.grantor.email=t.ownerEmail
}
if(t.ownerName){
e.grantor.name=t.ownerName
}
if(t.ownerId){
e.grantor.id=t.ownerId
}
e.link=e.link||{};
e.link.view=t.view||"message";
if(t.folderId){
e.link.id=t.folderId
}
if(t.folderPath){
e.link.path=t.folderPath
}
if(t.folderPath){
e.link.name=t.folderPath.substr(t.folderPath.lastIndexOf("/")+1)
}
if(t.rights){
e.setPermissions(t.rights)
}
if(t.mid){
e.mounted=true;
e.mountpoint=e.mountpoint||{};
e.mountpoint.id=t.mid;
var a=appCtxt.getById(e.mountpoint.id);
if(a){
e.mountpoint.name=a.getName();
e.mountpoint.path=a.getPath()
}}
e.action="new";
e.version="0.1";
e.type=ZmShare.SHARE;
return e
};
ZmShare.getShareFromLink=function(a,t){
t=t||new ZmShare();
t.grantor=t.grantor||{};
if(a.owner){
t.grantor.email=a.owner
}
if(a.zid){
t.grantor.id=a.zid
}
t.link=t.link||{};
t.link.view=ZmOrganizer.VIEWS[a.type][0];
if(a.rid){
t.link.id=a.rid
}
var e=a.getMainShare();
t.link.name=e?e.link.name:a.name;
t.setPermissions(e?e.link.perm:a.perm);
t.mounted=true;
t.mountpoint=t.mountpoint||{};
t.mountpoint.id=a.id;
t.mountpoint.name=a.getName();
t.mountpoint.path=a.getPath();
t.action="new";
t.version="0.1";
t.type=ZmShare.SHARE;
return t
};
ZmShare.getShareFromGrant=function(t,e){
t.link=t.link||{};
t.link.id=t.object&&(t.object.nId||t.object.id);
t.link.path=t.object&&t.object.getPath();
t.link.name=t.object&&t.object.getName();
t.type=ZmShare.GRANT;
t.domId=e&&e.domId;
return t
}
}
if(AjxPackage.define("zimbraMail.share.model.ZmShareProxy")){
ZmShareProxy=function(e){
e.type=ZmOrganizer.SHARE;
ZmOrganizer.call(this,e)
};
ZmShareProxy.prototype=new ZmOrganizer;
ZmShareProxy.prototype.constructor=ZmShareProxy;
ZmShareProxy.prototype.toString=function(){
return"ZmShareProxy"
};
ZmShareProxy.ID_LOADING=-1;
ZmShareProxy.ID_NONE_FOUND=-2;
ZmShareProxy.ID_WARNING=-2;
ZmShareProxy.ID_ERROR=-3;
ZmShareProxy.prototype.TOOLTIP_TEMPLATE="share.Widgets#ZmShareProxyToolTip";
ZmShareProxy.prototype.getIcon=function(){
var e=String(this.id).match(/^(-\d)(?::(.*))?$/);
switch(Number(e&&e[1])){
case ZmShareProxy.ID_LOADING:return"Spinner";
case ZmShareProxy.ID_NONE_FOUND:return"Warning";
case ZmShareProxy.ID_ERROR:return"Critical"
}
if(!this.shareInfo){
return"SharedMailFolder"
}
var i=ZmOrganizer.TYPE[this.shareInfo.view];
var a=ZmOrganizer.ORG_PACKAGE[i];
if(a){
AjxDispatcher.require(a)
}
var t=window[ZmOrganizer.ORG_CLASS[i]];
return t?t.prototype.getIcon.call(this):"Folder"
};
ZmShareProxy.prototype.getToolTip=function(e){
if(!this.shareInfo){
return null
}
if(e||!this._tooltip){
this._tooltip=AjxTemplate.expand(this.TOOLTIP_TEMPLATE,this.shareInfo)
}
return this._tooltip
}
}
if(AjxPackage.define("zimbraMail.share.model.ZmMountpoint")){
ZmMountpoint=function(e){
e.type=ZmOrganizer.MOUNTPOINT;
ZmOrganizer.call(this,e);
this.view=e.view
};
ZmMountpoint.prototype=new ZmOrganizer;
ZmMountpoint.prototype.constructor=ZmMountpoint;
ZmMountpoint.__CREATE_PARAMS={
l:1,name:1,zid:1,rid:1,owner:1,path:1,view:1,color:1,f:1};
ZmMountpoint.prototype.toString=function(){
return"ZmMountpoint"
};
ZmMountpoint.create=function(o,n){
var a=AjxSoapDoc.create("CreateMountpointRequest","urn:zimbraMail");
var e=a.set("link");
for(var i in o){
if(!(i in ZmMountpoint.__CREATE_PARAMS)){
continue
}
e.setAttribute(i,o[i])
}
var t=new AjxCallback(null,ZmMountpoint._handleCreateError,o.name);
appCtxt.getAppController().sendRequest({
soapDoc:a,asyncMode:true,callback:n,errorCallback:t}
)
};
ZmMountpoint._handleCreateError=function(t,e){
var a;
if(e.code==ZmCsfeException.SVC_PERM_DENIED||e.code==ZmCsfeException.MAIL_NO_SUCH_FOLDER){
a=ZmCsfeException.getErrorMsg(e.code)
}else{
if(e.code==ZmCsfeException.MAIL_ALREADY_EXISTS){
a=AjxMessageFormat.format(ZmMsg.errorAlreadyExists,[t])
}}
if(a){
appCtxt.getAppController().popupErrorDialog(a,null,null,true);
return true
}}
}
if(AjxPackage.define("zimbraMail.share.view.ZmShareReply")){
ZmShareReply=function(a,t,e){
t=t||"ZmShareReply";
DwtComposite.call(this,{
parent:a,className:t,id:"ZmShareReply"}
);
this._initControl(e)
};
ZmShareReply.prototype=new DwtComposite;
ZmShareReply.prototype.constructor=ZmShareReply;
ZmShareReply.NONE=0;
ZmShareReply.STANDARD=1;
ZmShareReply.QUICK=2;
ZmShareReply.COMPOSE=3;
ZmShareReply.DEFAULT_OPTIONS=[ZmShareReply.NONE,ZmShareReply.STANDARD,ZmShareReply.QUICK,ZmShareReply.COMPOSE];
ZmShareReply._LABELS={};
ZmShareReply._LABELS[ZmShareReply.NONE]=ZmMsg.sendNoMailAboutShare;
ZmShareReply._LABELS[ZmShareReply.STANDARD]=ZmMsg.sendStandardMailAboutShare;
ZmShareReply._LABELS[ZmShareReply.QUICK]=ZmMsg.sendStandardMailAboutSharePlusNote;
ZmShareReply._LABELS[ZmShareReply.COMPOSE]=ZmMsg.sendComposedMailAboutShare;
ZmShareReply.prototype.setReplyType=function(e){
this._replyType.setSelectedValue(e);
Dwt.setVisible(this._replyStandardMailNoteEl,e==ZmShareReply.STANDARD||e==ZmShareReply.QUICK);
Dwt.setVisible(this._replyNoteEl,e==ZmShareReply.QUICK)
};
ZmShareReply.prototype.getReplyType=function(){
return this._replyType.getValue()
};
ZmShareReply.prototype.setReplyNote=function(e){
this._replyNoteEl.value=e
};
ZmShareReply.prototype.getReplyNote=function(){
return this._replyNoteEl.value
};
ZmShareReply.prototype.setReplyOptions=function(e){
if(this._replyOptions==e){
return
}
this._replyOptions=e;
this._replyType.clearOptions();
for(var t=0;
t<e.length;
t++){
var a=e[t];
this._replyType.addOption(ZmShareReply._LABELS[a],false,a)
}};
ZmShareReply.prototype.getReplyOptions=function(){
return this._replyOptions
};
ZmShareReply.prototype._handleReplyType=function(t){
var e=this._replyType.getValue();
this.setReplyType(e)
};
ZmShareReply.prototype._initControl=function(e){
this._replyType=new DwtSelect({
parent:this,id:"ZmShareReplySelect"}
);
e=e||ZmShareReply.DEFAULT_OPTIONS;
this.setReplyOptions(e);
this._replyType.addChangeListener(new AjxListener(this,this._handleReplyType));
var a=document;
this._replyTypeEl=a.createElement("DIV");
this._replyTypeEl.style.paddingBottom="0.125em";
this._replyTypeEl.appendChild(this._replyType.getHtmlElement());
this._replyStandardMailNoteEl=a.createElement("DIV");
this._replyStandardMailNoteEl.style.paddingBottom="0.125em";
this._replyStandardMailNoteEl.style.width="30em";
this._replyStandardMailNoteEl.innerHTML=ZmMsg.sendMailAboutShareNote;
var i=a.createElement("DIV");
this._replyNoteEl=a.createElement("TEXTAREA");
this._replyNoteEl.cols=50;
this._replyNoteEl.rows=4;
i.appendChild(this._replyNoteEl);
this._replyControlsEl=a.createElement("DIV");
this._replyControlsEl.style.marginLeft="1.5em";
this._replyControlsEl.appendChild(this._replyTypeEl);
this._replyControlsEl.appendChild(this._replyStandardMailNoteEl);
this._replyControlsEl.appendChild(i);
var t=this.getHtmlElement();
t.appendChild(this._replyControlsEl)
}
}
if(AjxPackage.define("zimbraMail.share.view.ZmShareTreeView")){
ZmShareTreeView=function(e){
if(arguments.length==0){
return
}
e.className=e.className||"ZmShareTreeView OverviewTree";
e.id="ZmShareTreeView";
DwtTree.call(this,e);
this.getHtmlElement().style.overflow="auto"
};
ZmShareTreeView.prototype=new DwtTree;
ZmShareTreeView.prototype.constructor=ZmShareTreeView;
ZmShareTreeView.TREE_INDEX=0;
ZmShareTreeView.prototype.toString=function(){
return"ZmShareTreeView"
};
ZmShareTreeView.prototype.set=function(n){
if(this.root){
this.removeNode(this.root)
}
this._itemHash={};
var e=this.root=n.dataTree.root;
var t=this._createTreeItem(this,e);
var o=e.children.getArray();
for(var a=0;
a<o.length;
a++){
this._createTreeItem(t,o[a])
}};
ZmShareTreeView.prototype.getTreeItemById=function(e){
return this._itemHash&&this._itemHash[e]
};
ZmShareTreeView.prototype.removeChild=function(e){
delete this._itemHash[e.getData(Dwt.KEY_ID)];
DwtTree.prototype.removeChild.apply(this,arguments)
};
ZmShareTreeView.prototype.appendChild=function(i,e,t,n){
var a=e.children;
t=t||a.size();
a.add(i,t);
var o=this.getTreeItemById(e.id);
return this._createTreeItem(o,i,t,n)
};
ZmShareTreeView.prototype.insertBefore=function(a,e){
var i=e.parent;
var t=i.children.indexOf(e);
this.appendChild(a,i,t)
};
ZmShareTreeView.prototype.replaceNode=function(i,n){
var o=n.parent;
var a=o.children;
var t=a.indexOf(n);
var e=a.get(t+1);
this.removeNode(n);
return e?this.insertBefore(i,e):this.appendChild(i,o)
};
ZmShareTreeView.prototype.removeNode=function(t){
if(t.parent){
t.parent.children.remove(t)
}
var e=this.getTreeItemById(t.id);
if(e){
e.parent.removeChild(e)
}};
ZmShareTreeView.prototype._createTreeItem=function(a,e,t,o){
var n="ZmShareTreeItem_"+ZmShareTreeView.TREE_INDEX++;
var i=new DwtTreeItem({
parent:a,id:n}
);
i.setText(e.name);
i.setImage(e.getIcon());
i.setToolTipContent(o);
i.setData(Dwt.KEY_ID,e.id);
i.setData(Dwt.KEY_OBJECT,e);
this._itemHash[e.id]=i;
return i
}
}
if(AjxPackage.define("zimbraMail.share.view.dialog.ZmAcceptShareDialog")){
ZmAcceptShareDialog=function(t,e){
e=e||"ZmAcceptShareDialog";
DwtDialog.call(this,{
parent:t,className:e,title:ZmMsg.acceptShare,standardButtons:[DwtDialog.YES_BUTTON,DwtDialog.NO_BUTTON],id:"ZmAcceptShare"}
);
this.setButtonListener(DwtDialog.YES_BUTTON,new AjxListener(this,this._handleYesButton));
this.setButtonListener(DwtDialog.NO_BUTTON,new AjxListener(this,this._handleNoButton));
this.setView(this._createView());
this._headerFormatter=new AjxMessageFormat(ZmMsg.acceptShareHeader);
this._detailsFormatter=new AjxMessageFormat(ZmMsg.acceptShareDetails)
};
ZmAcceptShareDialog.prototype=new DwtDialog;
ZmAcceptShareDialog.prototype.constructor=ZmAcceptShareDialog;
ZmAcceptShareDialog._ACTIONS={};
ZmAcceptShareDialog._ACTIONS[ZmShare.ROLE_NONE]=ZmMsg.acceptShareDetailsNone;
ZmAcceptShareDialog._ACTIONS[ZmShare.ROLE_VIEWER]=ZmMsg.acceptShareDetailsViewer;
ZmAcceptShareDialog._ACTIONS[ZmShare.ROLE_MANAGER]=ZmMsg.acceptShareDetailsManager;
ZmAcceptShareDialog._ACTIONS[ZmShare.ROLE_ADMIN]=ZmMsg.acceptShareDetailsAdmin;
ZmAcceptShareDialog.prototype.popup=function(h,e){
this._share=h;
this._fromAddr=e;
this._headerEl.innerHTML=this._headerFormatter.format([h.grantor.name||h.grantor.email,AjxStringUtil.htmlEncode(h.link.name)]);
var i=ZmShare._getRoleFromPerm(h.link.perm);
var a=[ZmShare.getRoleName(i),ZmAcceptShareDialog._ACTIONS[i]];
this._detailsEl.innerHTML=this._detailsFormatter.format(a);
this._questionEl.innerHTML="<b>"+ZmMsg.acceptShareQuestion+"</b>";
var l=h.grantor.name||(h.grantor.email&&h.grantor.email.substr(0,h.grantor.email.indexOf("@")));
this._nameEl.value=ZmShare.getDefaultMountpointName(l,h.link.name);
this._reply.setReplyType(ZmShareReply.NONE);
this._reply.setReplyNote("");
var t=ZmOrganizer.TYPE[h.link.view];
var n=null;
var o=ZmOrganizer.ORG_CLASS[t];
if(o){
var r=ZmOrganizer.ORG_PACKAGE[t];
if(r){
AjxDispatcher.require(r);
var s=new window[o]({}
);
s._isRemote=true;
n=s.getIcon()
}}
this._color.setImage(n);
this._color.setValue(ZmOrganizer.DEFAULT_COLOR[t]);
DwtDialog.prototype.popup.call(this)
};
ZmAcceptShareDialog.prototype.setAcceptListener=function(e){
this.removeAllListeners(ZmAcceptShareDialog.ACCEPT);
if(e){
this.addListener(ZmAcceptShareDialog.ACCEPT,e)
}};
ZmAcceptShareDialog.prototype._handleYesButton=function(t){
var a=this._reply.getReplyType();
var e=(a==ZmShareReply.QUICK)?this._reply.getReplyNote():"";
var i=new AjxCallback(this,this._yesButtonCallback,[t]);
this._share.accept(this._nameEl.value,this._color.getValue(),a,e,i,this._fromAddr)
};
ZmAcceptShareDialog.prototype._yesButtonCallback=function(e){
this.notifyListeners(ZmAcceptShareDialog.ACCEPT,e);
this.setAcceptListener(null);
this.popdown()
};
ZmAcceptShareDialog.prototype._handleNoButton=function(e){
this.popdown()
};
ZmAcceptShareDialog.prototype._getSeparatorTemplate=function(){
return""
};
ZmAcceptShareDialog.prototype._createView=function(){
var e=new DwtComposite(this);
this._headerEl=document.createElement("DIV");
this._headerEl.style.marginBottom="0.5em";
this._detailsEl=document.createElement("DIV");
this._detailsEl.style.marginBottom="1em";
this._detailsEl.id="ZmAcceptShare_details";
this._questionEl=document.createElement("DIV");
this._questionEl.style.marginBottom="0.5em";
this._questionEl.id="ZmAcceptShare_questions";
this._nameEl=document.createElement("INPUT");
this._nameEl.style.width="20em";
this._nameEl.id="ZmAcceptShare_name";
var a=this._nameEl;
this._color=new ZmColorButton({
parent:this,id:"ZmAcceptShare_color"}
);
var n=this._propSheet=new DwtPropertySheet(e);
var t=n.getHtmlElement();
t.style.marginBottom="0.5em";
t.id="ZmAcceptShare_props";
n.addProperty(ZmMsg.nameLabel,a);
n.addProperty(ZmMsg.colorLabel,this._color);
this._reply=new ZmShareReply(e);
var o=document.createElement("DIV");
o.style.marginLeft="1.5em";
o.id="ZmAcceptShare_settings";
o.appendChild(t);
o.appendChild(this._reply.getHtmlElement());
var i=e.getHtmlElement();
i.appendChild(this._headerEl);
i.appendChild(this._detailsEl);
i.appendChild(this._questionEl);
i.appendChild(o);
return e
}
}
if(AjxPackage.define("zimbraMail.share.view.dialog.ZmDeclineShareDialog")){
ZmDeclineShareDialog=function(i,a){
a=a||"ZmDeclineShareDialog";
var n=ZmMsg.declineShare;
var o=[DwtDialog.YES_BUTTON,DwtDialog.NO_BUTTON];
DwtDialog.call(this,{
parent:i,className:a,title:n,standardButtons:o}
);
this.setButtonListener(DwtDialog.YES_BUTTON,new AjxListener(this,this._handleYesButton));
this._confirmMsgEl=document.createElement("DIV");
this._confirmMsgEl.style.fontWeight="bold";
this._confirmMsgEl.style.marginBottom="0.25em";
this._reply=new ZmShareReply(this);
var e=new DwtComposite(this);
var t=e.getHtmlElement();
t.appendChild(this._confirmMsgEl);
t.appendChild(this._reply.getHtmlElement());
this.setView(e);
this._formatter=new AjxMessageFormat(ZmMsg.declineShareConfirm)
};
ZmDeclineShareDialog.prototype=new DwtDialog;
ZmDeclineShareDialog.prototype.constructor=ZmDeclineShareDialog;
ZmDeclineShareDialog.prototype.popup=function(a,e){
this._share=a;
this._fromAddr=e;
var t=this._formatter.format([a.grantor.name,a.link.name]);
this._confirmMsgEl.innerHTML=AjxStringUtil.htmlEncode(t);
this._reply.setReplyType(ZmShareReply.STANDARD);
this._reply.setReplyNote("");
DwtDialog.prototype.popup.call(this)
};
ZmDeclineShareDialog.prototype.setDeclineListener=function(e){
this.removeAllListeners(ZmShare.DECLINE);
if(e){
this.addListener(ZmShare.DECLINE,e)
}};
ZmDeclineShareDialog.prototype._handleYesButton=function(e){
var t=this._reply.getReplyType();
if(t!=ZmShareReply.NONE){
this._share.notes=(t==ZmShareReply.QUICK)?this._reply.getReplyNote():"";
if(t==ZmShareReply.COMPOSE){
this._share.composeMessage(ZmShare.DECLINE,null,this._fromAddr)
}else{
this._share.sendMessage(ZmShare.DECLINE,null,this._fromAddr)
}}
this.notifyListeners(ZmShare.DECLINE,e);
this.setDeclineListener(null);
this.popdown()
};
ZmDeclineShareDialog.prototype._getSeparatorTemplate=function(){
return""
}
}
if(AjxPackage.define("zimbraMail.share.view.dialog.ZmLinkPropsDialog")){
ZmLinkPropsDialog=function(e,t){
t=t||"ZmLinkPropsDialog";
DwtDialog.call(this,{
parent:e,className:t,title:ZmMsg.linkProperties}
);
this.setButtonListener(DwtDialog.OK_BUTTON,new AjxListener(this,this._handleOkButton));
this._cache=AjxDispatcher.run("GetNotebookCache");
this.setView(this._createView())
};
ZmLinkPropsDialog.prototype=new DwtDialog;
ZmLinkPropsDialog.prototype.constructor=ZmLinkPropsDialog;
ZmLinkPropsDialog.prototype.popup=function(t,o){
this._linkInfo=t||{};
this._callback=o;
var i=this._linkInfo.url;
if(appCtxt.get(ZmSetting.NOTEBOOK_ENABLED)){
var e=appCtxt.getById(ZmOrganizer.ID_ROOT);
var a=e.children.getArray();
this._notebookSelect.clearOptions();
this.__addNotebookChildren(a,"");
this.notebookChangeListener();
this._pageRadioEl.checked=!i;
this._urlRadioEl.checked=i;
this._pageInput.setValue("")
}
this._urlInput.setValue(this._linkInfo.url||"http://www.");
this._titleInput.setValue(this._linkInfo.text||"");
ZmLinkPropsDialog._setRequiredFields(this,!i);
DwtDialog.prototype.popup.call(this);
ZmLinkPropsDialog._enableFieldsOnEdit(this)
};
ZmLinkPropsDialog.prototype.popdown=function(){
if(this._acPageList){
this._acPageList.show(false)
}
DwtDialog.prototype.popdown.call(this)
};
ZmLinkPropsDialog.prototype.getPageDataLoader=function(){
return this
};
ZmLinkPropsDialog.prototype.autocompleteMatch=function(c){
var e=this._notebookSelect.getValue();
var a=this._cache.getPagesInFolder(e);
var i=[];
var n=c.toLowerCase();
for(var t in a){
var l=t.toLowerCase();
var r=l.indexOf(n);
if(r!=-1){
var h=a[t];
var o={
text:[t.substr(0,r),"<B>",t.substr(r,c.length),"</B>",t.substr(r+c.length)].join(""),name:t,data:h};
i.push(o)
}}
return i
};
ZmLinkPropsDialog.prototype._setAcPageCompletion=function(t,e,a){};
ZmLinkPropsDialog.prototype._acKeyUpListener=function(e){
this._pageInput.validate();
ZmLinkPropsDialog._enableFieldsOnEdit(this)
};
ZmLinkPropsDialog._handleEdit=function(t){
var a=DwtUiEvent.getTarget(t);
var e=Dwt.getObjectFromElement(a);
ZmLinkPropsDialog._enableFieldsOnEdit(e);
return true
};
ZmLinkPropsDialog._handleKeyUp=function(a){
if(DwtInputField._keyUpHdlr(a)){
var i=DwtUiEvent.getTarget(a);
var e=Dwt.getObjectFromElement(i);
var t=e.parent.parent;
return ZmLinkPropsDialog._enableFieldsOnEdit(t)
}
return false
};
ZmLinkPropsDialog._handleLinkTo=function(t){
var i=DwtUiEvent.getTarget(t);
var e=Dwt.getObjectFromElement(i);
var a=i==e._pageRadioEl;
ZmLinkPropsDialog._setRequiredFields(e,a);
ZmLinkPropsDialog._enableFieldsOnEdit(e);
return true
};
ZmLinkPropsDialog._handleUrlTest=function(i){
var n=DwtUiEvent.getTarget(i);
var e=Dwt.getObjectFromElement(n);
var s=e._urlInput.getValue();
if(!s){
return
}
var t="_new";
var a=["width=",(window.outerWidth||640),",","height=",(window.outerHeight||480),",","location,menubar,","resizable,scrollbars,status,toolbar"].join("");
var o=open(s,t,a)
};
ZmLinkPropsDialog._enableFieldsOnEdit=function(t){
var e=false;
if(t._pageRadioEl&&t._pageRadioEl.checked){
e=true
}else{
e=t._urlInput.getValue().replace(/^\s+(.*)\s+$/,"$1")!=""
}
t.setButtonEnabled(DwtDialog.OK_BUTTON,e)
};
ZmLinkPropsDialog._setRequiredFields=function(e,t){
if(e._pageInput){
e._pageInput.setRequired(t)
}
e._urlInput.setRequired(!t)
};
ZmLinkPropsDialog.prototype._handleOkButton=function(t){
this.popdown();
if(this._callback){
var n=this._titleInput.getValue().replace(/^\s+(.*)\s+$/,"$1");
var e;
if(this._pageRadioEl&&this._pageRadioEl.checked){
var s=this._notebookSelect.getValue();
var o=appCtxt.getById(s);
var a=AjxStringUtil.trim(this._pageInput.getValue());
e=["[[","/",o.getSearchPath(),"/",a,(n?"|":""),n,"]]"].join("")
}else{
var i=this._linkInfo.document||document;
e=i.createElement("A");
e.href=AjxStringUtil.trim(this._urlInput.getValue());
e.innerHTML=AjxStringUtil.htmlEncode(n||e.href)
}
this._callback.run(e,this._linkInfo.target)
}};
ZmLinkPropsDialog.prototype._createView=function(){
var b=new DwtComposite(this);
var W={
parent:b,type:DwtInputField.STRING,validationStyle:DwtInputField.CONTINUAL_VALIDATION};
var A=[];
this._urlInput=new DwtInputField(W);
this._urlInput.setRequired(true);
var T=this._urlInput.getInputElement();
Dwt.setHandler(T,DwtEvent.ONKEYUP,ZmLinkPropsDialog._handleKeyUp);
this._titleInput=new DwtInputField(W);
if(appCtxt.get(ZmSetting.NOTEBOOK_ENABLED)){
var e=Dwt.getNextId();
var r=Dwt.getNextId();
var y=Dwt.getNextId();
var h=Dwt.getNextId();
var w=Dwt.getNextId();
var z=Dwt.getNextId();
var f=Dwt.getNextId();
var c=Dwt.getNextId();
var v=Dwt.getNextId();
var g=this._htmlElId+"_type";
var C=["<table border=0 cellpadding=0 cellspacing=0>","<tr valign=top>","<td rowspan=2>","<input id='",e,"' type=radio name='",g,"'>","</td>","<td>",ZmMsg.notebookPageLabel,"</td>","</tr>","<tr>","<td id='",y,"'></td>","</tr>","<tr valign=top>","<td rowspan=2>","<input id='",r,"' type=radio name='",g,"'>","</td>","<td>",ZmMsg.webPageLabel,"</td>","</tr>","<tr>","<td>","<nobr id='",f,"'></nobr>","</td>","</tr>","</table>"].join("");
this._notebookSelect=new DwtSelect({
parent:b}
);
var n=new AjxListener(this,this.notebookChangeListener);
this._notebookSelect.addChangeListener(n);
this._pageSelect=new DwtSelect({
parent:b}
);
var u=new AjxListener(this,this.pageChangeListener);
this._pageSelect.addChangeListener(u);
this._pageInput=new DwtInputField(W);
this._pageInput.setRequired(true);
var d=this._pageInput.getInputElement();
d.style.width="15em";
var o=this._urlInput.getInputElement();
o.style.width="25em";
var o=this._titleInput.getInputElement();
o.style.width="20em";
var B=new DwtGrouper(b);
B.setLabel(ZmMsg.linkTo);
B.setContent(C);
var p=new DwtPropertySheet(B);
p.addProperty(ZmMsg.notebookLabel,"<div id='"+h+"'></div>");
p.addProperty(ZmMsg.pageLabel,"<div id='"+z+"'></div>");
p.addProperty(ZmMsg.pageNameLabel,"<div id='"+w+"'></div>");
var S=document.getElementById(y);
S.appendChild(p.getHtmlElement());
var k=document.getElementById(h);
k.appendChild(this._notebookSelect.getHtmlElement());
var l=document.getElementById(z);
l.appendChild(this._pageSelect.getHtmlElement());
var F=document.getElementById(w);
F.parentNode.replaceChild(this._pageInput.getHtmlElement(),F);
var O=document.createElement("TABLE");
O.border=0;
O.cellSpacing=10;
O.cellpadding=0;
var m=O.insertRow(-1);
var t=m.insertCell(-1);
t.appendChild(this._urlInput.getHtmlElement());
var t=m.insertCell(-1);
t.innerHTML=["<span ","id='",c,"' ","onmouseover='this.style.cursor=\"pointer\"' ","onmouseout='this.style.cursor=\"default\"' ","style='color:blue;text-decoration:underline;'",">",ZmMsg.testUrl,"</span>"].join("");
var q=t.firstChild;
Dwt.setHandler(q,DwtEvent.ONCLICK,ZmLinkPropsDialog._handleUrlTest);
Dwt.associateElementWithObject(q,this);
var a=document.getElementById(f);
a.parentNode.replaceChild(O,a);
this._pageRadioEl=document.getElementById(e);
this._pageRadioEl.checked=true;
this._urlRadioEl=document.getElementById(r);
var x=[this._pageRadioEl,this._urlRadioEl];
for(var j=0;
j<x.length;
j++){
Dwt.setHandler(x[j],DwtEvent.ONCLICK,ZmLinkPropsDialog._handleLinkTo);
Dwt.associateElementWithObject(x[j],this)
}
var D={
dataClass:this,dataLoader:this.getPageDataLoader,matchValue:"name",separator:"",compCallback:new AjxCallback(this,this._setAcPageCompletion),keyUpCallback:new AjxCallback(this,this._acKeyUpListener)};
this._acPageList=new ZmAutocompleteListView(D);
this._acPageList.handle(d);
A.push(Dwt.byId(e),this._notebookSelect,this._pageSelect,this._pageInput,Dwt.byId(r),this._urlInput)
}
A.push(this._titleInput);
var s=new DwtPropertySheet(b);
if(!appCtxt.get(ZmSetting.NOTEBOOK_ENABLED)){
s.addProperty(linkUrlLabel,this._urlInput)
}
s.addProperty(ZmMsg.linkTitleLabel,this._titleInput);
for(var j=0;
j<A.length;
j++){
this._tabGroup.addMember(A[j],j)
}
return b
};
ZmLinkPropsDialog.prototype.__addNotebookChildren=function(t,o){
if(!t){
return
}
for(var e=0;
e<t.length;
e++){
var n=t[e];
if(n instanceof ZmNotebook){
this._notebookSelect.addOption(n.getSearchPath(),false,n.id);
var a=n.children.getArray();
this.__addNotebookChildren(a,o+"&nbsp;")
}}};
ZmLinkPropsDialog.prototype.notebookChangeListener=function(t){
var o=this._notebookSelect.getValue();
this._pageSelect.clearOptions();
this._pageSelect.setText("Loading...");
var e=this._cache.getPagesInFolder(o);
var i=true;
for(var a in e){
if(a!="_Index"){
this._pageSelect.addOption(a,false,a);
i=false
}}
if(i){
this._pageSelect.setText(ZmMsg.notAvailable);
this._pageSelect.disable()
}else{
this._pageSelect.enable()
}
this.pageChangeListener()
};
ZmLinkPropsDialog.prototype.pageChangeListener=function(t){
var e=this._pageSelect.getValue();
this._pageInput.setValue(e);
ZmLinkPropsDialog._enableFieldsOnEdit(this)
}
}
if(AjxPackage.define("zimbraMail.share.view.dialog.ZmSharePropsDialog")){
ZmSharePropsDialog=function(e,t){
t=t||"ZmSharePropsDialog";
DwtDialog.call(this,{
parent:e,className:t,title:ZmMsg.shareProperties,id:"ShareDialog"}
);
this.setButtonListener(DwtDialog.OK_BUTTON,new AjxListener(this,this._handleOkButton));
if(appCtxt.get(ZmSetting.CONTACTS_ENABLED)||appCtxt.get(ZmSetting.GAL_ENABLED)){
var a={
dataClass:appCtxt.getAutocompleter(),matchValue:ZmAutocomplete.AC_VALUE_EMAIL,compCallback:(new AjxCallback(this,this._handleCompletionData,[this])),keyUpCallback:(new AjxCallback(this,this._acKeyUpListener))};
this._acAddrSelectList=new ZmAutocompleteListView(a)
}
this.setView(this._createView());
this._tabGroupComplete=false
};
ZmSharePropsDialog.prototype=new DwtDialog;
ZmSharePropsDialog.prototype.constructor=ZmSharePropsDialog;
ZmSharePropsDialog.NEW=ZmShare.NEW;
ZmSharePropsDialog.EDIT=ZmShare.EDIT;
ZmSharePropsDialog.prototype._mode=ZmSharePropsDialog.NEW;
ZmSharePropsDialog.prototype.toString=function(){
return"ZmSharePropsDialog"
};
ZmSharePropsDialog.prototype.popup=function(h,o,u){
this._shareMode=h;
this._object=o;
this._share=u;
this._nameEl.innerHTML=AjxStringUtil.htmlEncode(o.name);
this._typeEl.innerHTML=ZmMsg[ZmOrganizer.FOLDER_KEY[this._object.type]]||ZmMsg.folder;
var f=(this._shareMode==ZmSharePropsDialog.NEW);
var t=u?u.isUser()||u.isGroup():true;
var e=u?u.isGuest():false;
var i=u?u.isPublic():false;
var s=o.supportsPublicAccess();
this._userRadioEl.checked=t;
this._userRadioEl.disabled=!f;
this._guestRadioEl.checked=e;
this._guestRadioEl.disabled=!f||!s;
this._publicRadioEl.checked=i;
this._publicRadioEl.disabled=!f||!s;
var l=this._getType(t,e,i);
this._handleShareWith(l);
var r="",d="";
if(u){
if(e){
r=u.grantee.id;
d=u.link.pw
}else{
r=(u.grantee.name||ZmMsg.userUnknown);
d=u.grantee.id
}}
this._granteeInput.setValue(r,true);
this._granteeInput.setEnabled(f);
this._props.setPropertyVisible(this._shareWithOptsId,true);
this._shareWithOptsProps.setPropertyVisible(this._passwordId,true);
this._props.setPropertyVisible(this._shareWithBreakId,true);
this._granteeInput.setValidatorFunction(null,e?DwtInputField.validateEmail:DwtInputField.validateAny);
this._passwordButton.setVisible(!f);
this._shareWithOptsProps.setPropertyVisible(this._passwordId,e);
this._passwordInput.setValue(d,true);
if(this._inheritEl){
this._inheritEl.checked=u?u.link.inh:f
}
if(!this._tabGroupComplete){
this._tabGroup.addMember(this._granteeInput,0);
this._tabGroupComplete=true
}
var a=u&&u.link.perm;
if(a!=null){
a=a.replace(/-./g,"");
this._privateEl.checked=(a.indexOf(ZmShare.PERM_PRIVATE)!=-1);
a=a.replace(/p/g,"");
var n=ZmShare._getRoleFromPerm(a);
var m=this._radioElByRole[n];
if(m){
m.checked=true
}}
this._privatePermissionEnabled=o.supportsPrivatePermission();
this._privatePermission.setVisible(o.supportsPrivatePermission());
if(a==null||(a==this._viewerRadioEl.value)){
this._viewerRadioEl.checked=true
}else{
if(a==this._noneRadioEl.value){
this._noneRadioEl.checked=true
}else{
if(a==this._managerRadioEl.value){
this._managerRadioEl.checked=true
}else{
if(a==this._adminRadioEl.value){
this._adminRadioEl.checked=true
}}}}
this._reply.setReplyType(ZmShareReply.STANDARD);
this._reply.setReplyNote("");
this._populateUrls();
var p=this.getSize();
Dwt.setSize(this._granteeInput.getInputElement(),0.6*p.x);
Dwt.setSize(this._passwordInput.getInputElement(),0.6*p.x);
DwtDialog.prototype.popup.call(this);
this.setButtonEnabled(DwtDialog.OK_BUTTON,false);
if(f){
this._userRadioEl.checked=true;
this._granteeInput.focus()
}
if(appCtxt.multiAccounts){
var c=o.account||appCtxt.accountList.mainAccount;
this._acAddrSelectList.setActiveAccount(c)
}};
ZmSharePropsDialog.prototype._populateUrls=function(){
var r,i;
if(appCtxt.multiAccounts){
r=this._object.getAccount();
i=this._object.getRestUrl(r)
}else{
i=this._object.getRestUrl()
}
if(appCtxt.isOffline){
var o=appCtxt.get(ZmSetting.OFFLINE_REMOTE_SERVER_URI,null,r);
i=o+i.substring((i.indexOf("/",7)))
}
var a=AjxStringUtil.htmlEncode(i).replace(/&amp;/g,"%26");
var s=a;
if(s.length>50){
var n=s.length-50;
var t=(s.length-n)/2;
s=s.substr(0,t)+"..."+s.substr(t+n)
}
var e=this._object.type!=ZmOrganizer.FOLDER;
this._urlGroup.setVisible(e);
if(e){
if(this._object.type==ZmOrganizer.CALENDAR){
this._urlEl.innerHTML=["<div>",ZmMsg.ics,":&nbsp;&nbsp;&nbsp;&nbsp;",'<a target=_new href="',a,'">',s,"</a>","</div>","<div>",ZmMsg.view,":&nbsp;&nbsp;",'<a target=_new href="',a,'.html">',s,".html</a>","</div>"].join("")
}else{
this._urlEl.innerHTML=["<div style='padding-left:2em;'>",'<a target=_new href="',a,'">',s,"</a>","</div>"].join("")
}}};
ZmSharePropsDialog.prototype.popdown=function(){
if(this._acAddrSelectList){
this._acAddrSelectList.reset();
this._acAddrSelectList.show(false)
}
DwtDialog.prototype.popdown.call(this)
};
ZmSharePropsDialog.prototype._getType=function(a,e,t){
if(arguments.length==0){
a=this._userRadioEl.checked;
e=this._guestRadioEl.checked;
t=this._publicRadioEl.checked
}
return(a&&ZmShare.TYPE_USER)||(e&&ZmShare.TYPE_GUEST)||(t&&ZmShare.TYPE_PUBLIC)
};
ZmSharePropsDialog.prototype._handleChangeButton=function(e){
this._passwordButton.setVisible(false);
this._passwordInput.setVisible(true);
this._passwordInput.focus()
};
ZmSharePropsDialog.prototype._handleOkButton=function(g){
var a=this._userRadioEl.checked;
var o=this._guestRadioEl.checked;
var r=this._publicRadioEl.checked;
if(!r){
var m;
if(this._granteeInput.isValid()==null){
m=this._granteeInput.getValue()?AjxMsg.invalidEmailAddr:AjxMsg.valueIsRequired
}
if(!m&&o&&this._passwordInput.isValid()==null){
m=AjxMsg.valueIsRequired
}
if(m){
var w=appCtxt.getErrorDialog();
w.setMessage(m);
w.popup(null,true);
return
}}
var p=[];
if(this._shareMode==ZmSharePropsDialog.NEW){
var s=this._getType(a,o,r);
if(!r){
var l=AjxEmailAddress.split(this._granteeInput.getValue());
if(l&&l.length){
for(var b=0;
b<l.length;
b++){
var h=l[b];
var u=AjxEmailAddress.parse(h);
if(u){
h=u.getAddress()
}
if(appCtxt.isMyAddress(h)){
continue
}
var y=this._setUpShare();
y.grantee.name=h;
y.grantee.type=s;
p.push(y)
}}}else{
var y=this._setUpShare();
y.grantee.type=s;
p.push(y)
}}else{
p.push(this._setUpShare(this._share))
}
var e=appCtxt.multiAccounts?this._object.getAccount().name:null;
var c=new ZmBatchCommand(null,e);
var t=this._getPermsFromRole();
var d=o&&this._passwordInput.getValue();
for(var b=0;
b<p.length;
b++){
var y=p[b];
if(t!=y.link.perm||d!=y.link.pw){
var f=new AjxCallback(y,y.grant,[t,d]);
c.add(f)
}}
if(c.size()>0){
var n=!r?(new AjxCallback(this,this._handleResponseBatchCmd,[p])):null;
c.run(n)
}
this.popdown()
};
ZmSharePropsDialog.prototype._handleResponseBatchCmd=function(f,c){
if(!f||(f&&f.length==0)){
return
}
var y=this._getFaultyEmails(c);
var b=this._reply.getReplyType();
if(b!=ZmShareReply.NONE){
var d=(b==ZmShareReply.QUICK)?this._reply.getReplyNote():"";
var o;
var u;
if(b!=ZmShareReply.COMPOSE&&f.length>1){
var e=appCtxt.multiAccounts?this._object.getAccount().name:null;
u=new ZmBatchCommand(false,e,true)
}
for(var g=0;
g<f.length;
g++){
var p=f[g];
var m=p.grantee.email||p.grantee.id;
if(!m){
if(AjxEmailAddress.isValid(p.grantee.name)){
m=p.grantee.name
}}
if(!m||(m&&y[m])){
continue
}
var l=new AjxVector();
var h=new AjxEmailAddress(m,AjxEmailAddress.TO);
l.add(h);
var n=new ZmShare({
object:p.object}
);
n.grantee.id=p.grantee.id;
n.grantee.email=m;
n.grantee.name=p.grantee.name;
if(n.object.isRemote()){
n.grantor.id=n.object.zid;
n.grantor.email=n.object.owner;
n.grantor.name=n.grantor.email;
n.link.id=n.object.rid;
n.link.name=n.object.oname||n.object.name
}else{
n.grantor.id=appCtxt.get(ZmSetting.USERID,null,this._object.getAccount());
n.grantor.email=appCtxt.get(ZmSetting.USERNAME,null,this._object.getAccount());
n.grantor.name=appCtxt.get(ZmSetting.DISPLAY_NAME,null,this._object.getAccount())||n.grantor.email;
n.link.id=n.object.id;
n.link.name=n.object.name
}
if(appCtxt.isOffline){
var r=this.getLinkIdfromResp(c);
if(r){
n.link.id=[n.grantor.id,r].join(":")
}}
n.link.perm=p.link.perm;
n.link.view=ZmOrganizer.getViewName(n.object.type);
n.link.inh=this._inheritEl?this._inheritEl.checked:true;
if(this._guestRadioEl.checked){
if(!this._guestFormatter){
this._guestFormatter=new AjxMessageFormat(ZmMsg.shareWithGuestNotes)
}
var s=p.object.getRestUrl();
s=s.replace(/&/g,"%26");
if(appCtxt.isOffline){
var a=appCtxt.get(ZmSetting.OFFLINE_REMOTE_SERVER_URI);
s=a+s.substring((s.indexOf("/",7)))
}
var t=this._passwordInput.getValue();
o=this._guestFormatter.format([s,m,t,d])
}
n.notes=o||d;
if(b==ZmShareReply.COMPOSE){
n.composeMessage(this._shareMode,l)
}else{
n.sendMessage(this._shareMode,l,null,u)
}}
if(u){
u.run()
}
var w=(this._shareMode==ZmSharePropsDialog.NEW)?ZmMsg.shareCreatedSubject:ZmMsg.shareModifiedSubject;
appCtxt.setStatusMsg(w)
}};
ZmSharePropsDialog.prototype.getLinkIdfromResp=function(e){
if(!e){
return
}
var t=e.getResponse().BatchResponse.FolderActionResponse||[];
if(t.length>0&&t[0].action){
return t[0].action.id
}else{
return null
}};
ZmSharePropsDialog.prototype._getFaultyEmails=function(e){
if(!e){
return
}
var t="no such account: ";
var s={};
var o=e.getResponse().BatchResponse.Fault||[];
for(var a=0;
a<o.length;
a++){
var n=o[a].Reason.Text;
if(n.indexOf(t)==0){
s[n.substring(t.length)]=true
}}
return s
};
ZmSharePropsDialog.prototype._setUpShare=function(e){
if(!e){
e=new ZmShare({
object:this._object}
)
}
e.link.inh=(this._inheritEl&&this._inheritEl.checked);
return e
};
ZmSharePropsDialog.prototype._acKeyUpListener=function(a,t,e){
ZmSharePropsDialog._enableFieldsOnEdit(this)
};
ZmSharePropsDialog._handleKeyUp=function(e){
if(DwtInputField._keyUpHdlr(e)){
return ZmSharePropsDialog._handleEdit(e)
}
return false
};
ZmSharePropsDialog._handleEdit=function(t){
var a=DwtUiEvent.getTarget(t);
var e=Dwt.getObjectFromElement(a);
if(e instanceof DwtInputField){
e=e.getData(Dwt.KEY_OBJECT)
}
if(e!=null){
ZmSharePropsDialog._enableFieldsOnEdit(e)
}
return true
};
ZmSharePropsDialog._enableFieldsOnEdit=function(i){
var n=i._mode==ZmSharePropsDialog.EDIT;
var r=i._userRadioEl.checked;
var o=i._publicRadioEl.checked;
var t=i._guestRadioEl.checked;
i._privatePermission.setVisible(i._privatePermissionEnabled&&!i._noneRadioEl.checked&&!o);
var e=AjxStringUtil.trim(i._granteeInput.getValue())!="";
var s=AjxStringUtil.trim(i._passwordInput.getValue())!="";
var a=n||o||(r&&e)||(t&&e&&s);
i.setButtonEnabled(DwtDialog.OK_BUTTON,a)
};
ZmSharePropsDialog._handleShareWith=function(t){
var a=DwtUiEvent.getTarget(t);
var e=Dwt.getObjectFromElement(a);
e._handleShareWith(a.value);
return ZmSharePropsDialog._handleEdit(t)
};
ZmSharePropsDialog.prototype._handleShareWith=function(t){
var i=t==ZmShare.TYPE_USER;
var e=t==ZmShare.TYPE_GUEST;
var a=t==ZmShare.TYPE_PUBLIC;
this._granteeInput.setValidatorFunction(null,e?DwtInputField.validateEmail:DwtInputField.validateAny);
this._rolesGroup.setVisible(i);
this._messageGroup.setVisible(!a);
this._privatePermission.setVisible(this._privatePermissionEnabled&&!a);
this._props.setPropertyVisible(this._shareWithOptsId,!a);
this._shareWithOptsProps.setPropertyVisible(this._passwordId,e);
this._props.setPropertyVisible(this._shareWithBreakId,!a);
if(!i){
this._viewerRadioEl.checked=true
}};
ZmSharePropsDialog.prototype._getPermsFromRole=function(){
var t=ZmShare.ROLE_NONE;
if(this._viewerRadioEl.checked){
t=ZmShare.ROLE_VIEWER
}
if(this._managerRadioEl.checked){
t=ZmShare.ROLE_MANAGER
}
if(this._adminRadioEl.checked){
t=ZmShare.ROLE_ADMIN
}
var e=ZmShare.ROLE_PERMS[t];
if(e&&this._privatePermissionEnabled&&this._privateEl.checked){
e+=ZmShare.PERM_PRIVATE
}
return e
};
ZmSharePropsDialog.prototype._handleCompletionData=function(i,o,t){
t.value=o;
try{
if(t.fireEvent){
t.fireEvent("onchange")
}else{
if(document.createEvent){
var a=document.createEvent("UIEvents");
a.initUIEvent("change",false,window,1);
t.dispatchEvent(a)
}}}
catch(e){}};
ZmSharePropsDialog.prototype._createView=function(){
var y=new DwtComposite(this);
var s=Dwt.getNextId();
var h=Dwt.getNextId();
var m=Dwt.getNextId();
var f=Dwt.getNextId();
var v=Dwt.getNextId();
var l=Dwt.getNextId();
var k=this._htmlElId+"_shareWith";
var u=this._htmlElId+"_role";
var a=new DwtPropertySheet(this,null,null,DwtPropertySheet.RIGHT);
var r=[{
label:ZmMsg.shareWithUserOrGroup,field:["<input type='radio' id='ShareWith_user' name='",k,"' value='",ZmShare.TYPE_USER,"'>"].join("")}
,{
label:ZmMsg.shareWithGuest,field:["<input type='radio' id='ShareWith_external' name='",k,"' value='",ZmShare.TYPE_GUEST,"'>"].join("")}
,{
label:ZmMsg.shareWithPublicLong,field:["<input type='radio' id='ShareWith_public' name='",k,"' value='",ZmShare.TYPE_PUBLIC,"'>"].join("")}
];
for(var q=0;
q<r.length;
q++){
var d=r[q];
var c=a.addProperty(d.label,d.field)
}
this._granteeInput=new DwtInputField({
parent:this,id:"ShareDialog_grantee"}
);
this._granteeInput.setData(Dwt.KEY_OBJECT,this);
this._granteeInput.setRequired(true);
Dwt.associateElementWithObject(this._granteeInput.getInputElement(),this);
var e=new DwtComposite(this);
this._passwordInput=new DwtInputField({
parent:e,id:"ShareDialog_password"}
);
this._passwordInput.setData(Dwt.KEY_OBJECT,this);
this._passwordInput.setRequired(true);
this._passwordButton=new DwtButton({
parent:e,id:"ShareDialog_Button"}
);
this._passwordButton.setText(ZmMsg.changePassword);
this._passwordButton.addSelectionListener(new AjxListener(this,this._handleChangeButton));
Dwt.associateElementWithObject(this._passwordInput.getInputElement(),this);
this._shareWithOptsProps=new DwtPropertySheet(this);
this._shareWithOptsProps.addProperty(ZmMsg.emailLabel,this._granteeInput);
this._passwordId=this._shareWithOptsProps.addProperty(ZmMsg.passwordLabel,e);
var g=["<table border='0' cellpadding='0' cellpadding='3'>","<tr>","<td>","<input type='checkbox' id='",f,"' checked>","</td>","<td>",ZmMsg.inheritPerms,"</td>","</tr>","</table>"].join("");
this._props=new DwtPropertySheet(y);
this._props.addProperty(ZmMsg.nameLabel,"<span id='"+s+"'></span>");
this._props.addProperty(ZmMsg.typeLabel,"<span id='"+h+"'></span>");
this._props.addProperty(ZmMsg.shareWithLabel,a);
var t=this._props.addProperty(ZmMsg.otherLabel,g);
this._inheritEl=document.getElementById(f);
this._props.setPropertyVisible(t,false);
this._shareWithBreakId=this._props.addProperty("","<HR>");
this._shareWithOptsId=this._props.addProperty("",this._shareWithOptsProps);
var w=0;
var p=[];
p[w++]="<table border=0 cellpadding=0 cellspacing=3>";
var b=[ZmShare.ROLE_NONE,ZmShare.ROLE_VIEWER,ZmShare.ROLE_MANAGER,ZmShare.ROLE_ADMIN];
for(var q=0;
q<b.length;
q++){
var z=b[q];
p[w++]="<tr><td valign=top><input type='radio' name='";
p[w++]=u;
p[w++]="' value='";
p[w++]=z;
p[w++]="' id='ShareRole_";
p[w++]=z;
p[w++]="'></td><td style='font-weight:bold; padding-right:0.25em'>";
p[w++]=ZmShare.getRoleName(z);
p[w++]="</td><td style='white-space:nowrap'>";
p[w++]=ZmShare.getRoleActions(z);
p[w++]="</td></tr>"
}
p[w++]="</table>";
this._rolesGroup=new DwtGrouper(y);
this._rolesGroup.setLabel(ZmMsg.role);
this._rolesGroup.setContent(p.join(""));
this._privatePermission=new DwtPropertySheet(y);
this._privatePermission._vAlign="middle";
this._privatePermission.addProperty("<input type='checkbox' id='"+l+"'/>",ZmMsg.privatePermission);
this._privateEl=document.getElementById(l);
Dwt.setHandler(this._privateEl,DwtEvent.ONCLICK,ZmSharePropsDialog._handleEdit);
Dwt.associateElementWithObject(this._privateEl,this);
this._reply=new ZmShareReply(y);
this._messageGroup=new DwtGrouper(y);
this._messageGroup.setLabel(ZmMsg.message);
this._messageGroup.setView(this._reply);
var j=["<div>","<div style='margin-bottom:.25em'>",ZmMsg.shareUrlInfo,"</div>","<div style='cursor:text' id='",v,"'></div>","</div>"].join("");
this._urlGroup=new DwtGrouper(y);
this._urlGroup.setLabel(ZmMsg.url);
this._urlGroup.setContent(j);
this._urlGroup._setAllowSelection();
this._nameEl=document.getElementById(s);
this._typeEl=document.getElementById(h);
this._urlEl=document.getElementById(v);
var o=this._granteeInput.getInputElement();
if(this._acAddrSelectList){
this._acAddrSelectList.handle(o)
}else{
Dwt.setHandler(o,DwtEvent.ONKEYUP,ZmSharePropsDialog._handleKeyUp)
}
if(this._inheritEl){
Dwt.setHandler(this._inheritEl,DwtEvent.ONCLICK,ZmSharePropsDialog._handleEdit);
Dwt.associateElementWithObject(this._inheritEl,this)
}
var n=["_userRadioEl","_guestRadioEl","_publicRadioEl"];
var x=document.getElementsByName(k);
for(var q=0;
q<x.length;
q++){
this[n[q]]=x[q];
Dwt.setHandler(x[q],DwtEvent.ONCLICK,ZmSharePropsDialog._handleShareWith);
Dwt.associateElementWithObject(x[q],this)
}
var o=this._passwordInput.getInputElement();
Dwt.setHandler(o,DwtEvent.ONKEYUP,ZmSharePropsDialog._handleEdit);
var n=["_noneRadioEl","_viewerRadioEl","_managerRadioEl","_adminRadioEl"];
var x=document.getElementsByName(u);
var b=[ZmShare.ROLE_NONE,ZmShare.ROLE_VIEWER,ZmShare.ROLE_MANAGER,ZmShare.ROLE_ADMIN];
this._radioElByRole={};
for(var q=0;
q<x.length;
q++){
this[n[q]]=x[q];
this._radioElByRole[b[q]]=x[q];
Dwt.setHandler(x[q],DwtEvent.ONCLICK,ZmSharePropsDialog._handleEdit);
Dwt.associateElementWithObject(x[q],this)
}
return y
}
}
if(AjxPackage.define("zimbraMail.share.view.dialog.ZmShareSearchDialog")){
ZmShareSearchDialog=function(a){
a.className=a.className||"ZmShareSearchDialog DwtDialog";
a.title=ZmMsg.sharedFoldersAddTitle;
a.standardButtons=[ZmShareSearchDialog.ADD_BUTTON,DwtDialog.CANCEL_BUTTON];
a.id="ZmShareSearchDialog";
var e={
dataClass:appCtxt.getAutocompleter(),matchValue:ZmAutocomplete.AC_VALUE_EMAIL,compCallback:(new AjxCallback(this,this._handleCompletionData)),keyUpCallback:(new AjxCallback(this,this._acKeyUpListener))};
this._acAddrSelectList=new ZmAutocompleteListView(e);
DwtDialog.call(this,a);
this.getButton(ZmShareSearchDialog.ADD_BUTTON).setText(ZmMsg.add);
var t=this._tabGroup;
t.addMemberBefore(this._form.getTabGroupMember(),t.getFirstMember())
};
ZmShareSearchDialog.prototype=new DwtDialog;
ZmShareSearchDialog.prototype.constructor=ZmShareSearchDialog;
ZmShareSearchDialog.prototype.toString=function(){
return"ZmShareSearchDialog"
};
ZmShareSearchDialog.ADD_BUTTON=DwtDialog.OK_BUTTON;
ZmShareSearchDialog._APP_TYPES=[ZmApp.MAIL,ZmApp.CONTACTS,ZmApp.CALENDAR,ZmApp.TASKS,ZmApp.BRIEFCASE];
ZmShareSearchDialog._APP_KEY={};
ZmShareSearchDialog._APP_KEY[ZmApp.MAIL]="mailSharesOnly";
ZmShareSearchDialog._APP_KEY[ZmApp.TASKS]="taskSharesOnly";
ZmShareSearchDialog._APP_KEY[ZmApp.BRIEFCASE]="briefcaseSharesOnly";
ZmShareSearchDialog._APP_KEY[ZmApp.CALENDAR]="calendarSharesOnly";
ZmShareSearchDialog._APP_KEY[ZmApp.CONTACTS]="addrbookSharesOnly";
ZmShareSearchDialog.prototype.CONTENT_TEMPLATE="share.Widgets#ZmShareSearchView";
ZmShareSearchDialog.prototype.getShares=function(){
var t=this._form.getControl("TREE");
var e=this._getNode(ZmOrganizer.ID_ROOT);
var a=[];
this._collectShares(t,e,a);
return a
};
ZmShareSearchDialog.prototype._collectShares=function(e,n,o){
if(n.shareInfo){
var s=e.getTreeItemById(n.id);
if(s.getChecked()&&s.getVisible()){
o.push(n.shareInfo)
}}else{
var a=n.children.getArray();
for(var t=0;
t<a.length;
t++){
this._collectShares(e,a[t],o)
}}};
ZmShareSearchDialog.prototype._filterResults=function(){
var t=this._form.getControl("TREE");
var e=this._getNode(ZmOrganizer.ID_ROOT);
var a=this._form.getValue("FILTER")||"";
this._filterNode(t,e,a.toLowerCase())
};
ZmShareSearchDialog.prototype._filterNode=function(s,n,f){
var c=n.children.size();
var o=this._form.getValue("APP")||"";
if(c>0){
var d=0;
for(var h=0;
h<c;
h++){
var a=n.children.get(h);
d+=this._filterNode(s,a,f)?1:0
}
var t=s.getTreeItemById(n.id);
t.setVisible(n.id==ZmOrganizer.ID_ROOT||d>0);
return t.getVisible()
}
var u=String(n.id).match(/^-/);
var r=!f||(n.name.toLowerCase().indexOf(f)!=-1);
var e=!o||(n.shareInfo&&n.shareInfo.view==o);
var l=!u&&r&&e;
var m=s.getTreeItemById(n.id);
m.setVisible(l);
return l
};
ZmShareSearchDialog.prototype._createOrganizer=function(t,a,e){
return new ZmShareProxy({
parent:t,id:a,name:e,tree:(t&&t.tree)}
)
};
ZmShareSearchDialog.prototype._resetTree=function(){
var e=new ZmTree(ZmOrganizer.SHARE);
e.root=this._createOrganizer(null,ZmOrganizer.ID_ROOT,"[Root]");
var t=this._form.getControl("TREE");
t.set({
dataTree:e}
);
var a=t.getTreeItemById(ZmOrganizer.ID_ROOT);
a.setVisible(false,true);
a.setExpanded(true);
a.enableSelection(false);
a.showCheckBox(false)
};
ZmShareSearchDialog.prototype._doGroupSearch=function(){
this._setSearching(true);
this._appendInfoNode(ZmOrganizer.ID_ROOT,ZmShareProxy.ID_LOADING,ZmMsg.sharedFoldersLoading);
var e={
jsonObj:{
GetShareInfoRequest:{
_jsns:"urn:zimbraAccount",includeSelf:0,grantee:{
type:"grp"}}}
,asyncMode:true,callback:new AjxCallback(this,this._handleGroupSearchResults),errorCallback:new AjxCallback(this,this._handleGroupSearchError)};
appCtxt.getAppController().sendRequest(e)
};
ZmShareSearchDialog.prototype._doUserSearch=function(s){
this._resetTree();
s=s.split(/\s*[;,]\s*/);
var r={};
for(var n=0;
n<s.length;
n++){
var h=AjxStringUtil.trim(s[n]);
if(!h){
continue
}
if(h==appCtxt.get(ZmSetting.USERNAME)){
continue
}
r[h.toLowerCase()]=h
}
var e=[],t={};
var n=0;
for(var a in r){
e.push({
_jsns:"urn:zimbraAccount",requestId:n,includeSelf:0,owner:{
by:"name",_content:r[a]}}
);
if(!this._loadingUserFormatter){
this._loadingUserFormatter=new AjxMessageFormat(ZmMsg.sharedFoldersLoadingUser)
}
var c=this._loadingUserFormatter.format([h]);
var l=[ZmShareProxy.ID_LOADING,Dwt.getNextId("share")].join(":");
this._appendInfoNode(ZmOrganizer.ID_ROOT,l,AjxStringUtil.htmlEncode(c));
r[a]=l;
t[n]=l;
n++
}
if(e.length==0){
return
}
this._setSearching(true);
var o={
jsonObj:{
BatchRequest:{
_jsns:"urn:zimbra",GetShareInfoRequest:e}}
,asyncMode:true,callback:new AjxCallback(this,this._handleUserSearchResults,[r,t]),errorCallback:new AjxCallback(this,this._handleUserSearchError)};
appCtxt.getAppController().sendRequest(o)
};
ZmShareSearchDialog.prototype._setSearching=function(e){
this._form.setEnabled(!e)
};
ZmShareSearchDialog.prototype._handleGroupSearchResults=function(o){
this._setSearching(false);
this._removeNode(ZmShareProxy.ID_LOADING);
var t=AjxUtil.get(o.getResponse(),"GetShareInfoResponse","share");
if(t&&t.length>0){
var a={};
this._addToOwnerMap(a,t);
a=AjxUtil.values(a);
a.sort(ZmShareSearchDialog.__byOwnerName);
this._appendShareNodes(a);
var n=new Array(t.length);
for(var e=0;
e<t.length;
e++){
n[e]=t[e].ownerEmail
}
this._doUserSearch(n.join(";"))
}else{
this._appendInfoNode(ZmOrganizer.ID_ROOT,ZmShareProxy.ID_NONE_FOUND,ZmMsg.sharedFoldersNoGroupsFound)
}};
ZmShareSearchDialog.prototype._handleGroupSearchError=function(t){
this._setSearching(false);
this._removeNode(ZmShareProxy.ID_LOADING);
var e=this._appendInfoNode(ZmOrganizer.ID_ROOT,ZmShareProxy.ID_ERROR,ZmMsg.sharedFoldersError)
};
ZmShareSearchDialog.prototype._handleUserSearchResults=function(u,e,n){
this._setSearching(false);
for(var f in u){
this._removeNode(u[f])
}
var p=AjxUtil.get(n.getResponse(),"BatchResponse");
var c=AjxUtil.get(p,"GetShareInfoResponse");
if(c){
var a={};
for(var s=0;
s<c.length;
s++){
var o=c[s];
this._addToOwnerMap(a,o.share)
}
a=AjxUtil.values(a);
a.sort(ZmShareSearchDialog.__byOwnerName);
this._appendShareNodes(a)
}
this._filterResults();
var h=AjxUtil.get(p,"Fault");
if(h){
var t=this._form.getControl("TREE");
for(var s=0;
s<h.length;
s++){
var m=h[s];
var l=ZmShareProxy.ID_ERROR;
var d=this._getNode(e[m.requestId]);
var g=this._createOrganizer(d.parent,l,ZmMsg.sharedFoldersError);
t.replaceNode(g,d);
var r=t.getTreeItemById(l);
r.showCheckBox(false);
r.setToolTipContent(AjxStringUtil.htmlEncode(m.Reason.Text))
}}};
ZmShareSearchDialog.prototype._addToOwnerMap=function(i,a){
if(!a){
return
}
for(var t=0;
t<a.length;
t++){
var o=a[t];
var e=i[o.ownerId];
if(!e){
e=i[o.ownerId]={
ownerId:o.ownerId,ownerName:o.ownerName||o.ownerEmail,ownerEmail:o.ownerEmail,shares:[]}
}
e.shares.push(o)
}};
ZmShareSearchDialog.prototype._handleUserSearchError=function(e){
this._setSearching(false)
};
ZmShareSearchDialog.prototype._getNode=function(a){
var e=this._form.getControl("TREE");
var t=e.getTreeItemById(a);
return t&&t.getData(Dwt.KEY_OBJECT)
};
ZmShareSearchDialog.prototype._removeNode=function(t){
var e=this._form.getControl("TREE");
e.removeNode(this._getNode(t))
};
ZmShareSearchDialog.prototype._appendChild=function(i,e,t,n){
var a=this._form.getControl("TREE");
var o=a.appendChild(i,e,null,n);
o.setExpanded(true);
o.enableSelection(false);
o.showCheckBox(t);
o.setVisible(false);
return o
};
ZmShareSearchDialog.prototype._appendShareNodes=function(a){
if(!a){
return
}
for(var n=0;
n<a.length;
n++){
var e=a[n];
var r=this._getNode(e.ownerId);
if(!r){
var c=this._getNode(ZmOrganizer.ID_ROOT);
r=this._createOrganizer(c,e.ownerId,e.ownerName||e.ownerEmail);
this._appendChild(r,c)
}
var l=e.shares;
if(l.length>0){
l.sort(ZmShareSearchDialog.__byFolderPath);
for(var s=0;
s<l.length;
s++){
var d=l[s];
var t=[d.ownerId,d.folderId].join(":");
if(this._getNode(t)!=null){
continue
}
var o=d.folderPath.substr(1).replace(/\//g," ");
var h=this._createOrganizer(r,t,o);
h.shareInfo=d;
d.icon=h.getIcon();
d.role=ZmShare.getRoleFromPerm(d.rights);
d.roleName=ZmShare.getRoleName(d.role);
d.roleActions=ZmShare.getRoleActions(d.role);
d.normalizedOwnerName=d.ownerName||d.ownerEmail;
d.normalizedGranteeName=d.granteeDisplayName||d.granteeName;
d.normalizedFolderPath=o;
d.defaultMountpointName=ZmShare.getDefaultMountpointName(d.normalizedOwnerName,d.normalizedFolderPath);
var u=AjxTemplate.expand(h.TOOLTIP_TEMPLATE,d);
this._appendChild(h,r,true,u)
}}else{
this._appendInfoNode(r,ZmShareProxy.ID_NONE_FOUND,ZmMsg.sharedFoldersNoneFound)
}}};
ZmShareSearchDialog.prototype._appendInfoNode=function(n,o,i,a){
var e=this._getNode(n);
var t=this._createOrganizer(e,o,i);
return this._appendChild(t,e,null,a)
};
ZmShareSearchDialog.__byOwnerName=AjxCallback.simpleClosure(AjxUtil.byStringProp,window,"ownerName");
ZmShareSearchDialog.__byFolderPath=AjxCallback.simpleClosure(AjxUtil.byStringProp,window,"folderPath");
ZmShareSearchDialog.prototype._acKeyUpListener=function(a,t,e){};
ZmShareSearchDialog.prototype._handleCompletionData=function(i,t){
t.value=i;
try{
if(t.fireEvent){
t.fireEvent("onchange")
}else{
if(document.createEvent){
var a=document.createEvent("UIEvents");
a.initUIEvent("change",false,window,1);
t.dispatchEvent(a)
}}}
catch(e){}};
ZmShareSearchDialog.prototype.popup=function(t,i,e){
this.reset();
if(i){
this._buttonDesc[ZmShareSearchDialog.ADD_BUTTON].callback=i
}
if(e){
this._buttonDesc[DwtDialog.CANCEL_BUTTON].callback=e
}
if(appCtxt.multiAccounts){
var o=appCtxt.getActiveAccount()||appCtxt.accountList.mainAccount;
this._acAddrSelectList.setActiveAccount(o)
}
var a=this._form;
a.setValue("FILTER","");
a.setValue("EMAIL","");
a.setEnabled("SEARCH",false);
this._selectApplicationOption();
this._resetTree();
this._doGroupSearch();
DwtDialog.prototype.popup.call(this);
a.getControl("EMAIL").focus()
};
ZmShareSearchDialog.prototype.popdown=function(){
if(this._acAddrSelectList){
this._acAddrSelectList.reset();
this._acAddrSelectList.show(false)
}
DwtDialog.prototype.popdown.call(this)
};
ZmShareSearchDialog.prototype._createHtmlFromTemplate=function(e,a){
DwtDialog.prototype._createHtmlFromTemplate.apply(this,arguments);
var n={
parent:this,className:"ZmShareSearchView",form:{
template:this.CONTENT_TEMPLATE,items:[{
id:"FILTER",type:"DwtInputField",hint:ZmMsg.sharedFoldersFilterHint,onchange:"this.parent._filterResults()"}
,{
id:"TREE",type:"ZmShareTreeView",style:DwtTree.CHECKEDITEM_STYLE}
,{
id:"EMAIL",type:"DwtInputField",hint:ZmMsg.sharedFoldersUserSearchHint}
,{
id:"SEARCH",type:"DwtButton",label:ZmMsg.searchInput,enabled:"get('EMAIL')",onclick:"this.parent._doUserSearch(get('EMAIL'))"}
,{
id:"APP",type:"DwtSelect",items:this._getAppOptions(),onchange:"this.parent._filterResults()"}
]}
,id:"ZmShareSearchView"};
this._form=new DwtForm(n);
this.setView(this._form);
var i=this._form.getControl("EMAIL").getInputElement();
var o=[i.onkeyup];
if(this._acAddrSelectList){
this._acAddrSelectList.handle(i);
o.push(i.onkeyup)
}
o.push(AjxCallback.simpleClosure(this._handleEmailEnter,this));
var t=AjxCallback.simpleClosure(ZmShareSearchDialog.__onKeyUp,window,o);
Dwt.setHandler(i,DwtEvent.ONKEYUP,t)
};
ZmShareSearchDialog.__onKeyUp=function(t,e){
for(var a=0;
a<t.length;
a++){
t[a](e)
}};
ZmShareSearchDialog.prototype._handleEmailEnter=function(e){
if(false){
this._doUserSearch(this.getValue("EMAIL"))
}};
ZmShareSearchDialog.prototype._getAppOptions=function(){
var t=[];
t.push({
value:"",label:ZmMsg.allApplications}
);
for(var n=0;
n<ZmShareSearchDialog._APP_TYPES.length;
n++){
var e=ZmShareSearchDialog._APP_TYPES[n];
var o=ZmShareSearchDialog._APP_KEY[e];
var a=appCtxt.get(ZmApp.SETTING[e]);
if(a){
var s=ZmApp.ORGANIZER[e];
if(AjxUtil.isArray1(ZmOrganizer.VIEWS[s])){
t.push({
id:e,value:ZmOrganizer.VIEWS[s][0],label:ZmMsg[o]}
)
}}}
return t
};
ZmShareSearchDialog.prototype._selectApplicationOption=function(){
var a=appCtxt.getCurrentApp();
var o=this._form.getControl("APP");
var t=this._getAppOptions();
if(!a||!o||!t){
return
}
for(var e=0;
e<t.length;
e++){
if(t[e].hasOwnProperty("id")&&t[e].id==a.getName()){
o.setSelectedValue(t[e].value);
return
}}}
}
if(AjxPackage.define("zimbraMail.share.view.dialog.ZmRevokeShareDialog")){
ZmRevokeShareDialog=function(a,t){
t=t||"ZmRevokeShareDialog";
var o=ZmMsg.revokeShare;
var i=[DwtDialog.YES_BUTTON,DwtDialog.NO_BUTTON];
DwtDialog.call(this,{
parent:a,className:t,title:o,standardButtons:i}
);
this.setButtonListener(DwtDialog.YES_BUTTON,new AjxListener(this,this._handleYesButton));
var e=this._createView();
this.setView(e);
this._formatter=new AjxMessageFormat(ZmMsg.revokeShareConfirm)
};
ZmRevokeShareDialog.prototype=new DwtDialog;
ZmRevokeShareDialog.prototype.constructor=ZmRevokeShareDialog;
ZmRevokeShareDialog.prototype.toString=function(){
return"ZmRevokeShareDialog"
};
ZmRevokeShareDialog.prototype.popup=function(t){
this._share=t;
var e=t.isPublic();
var a=t.grantee&&(t.grantee.type==ZmShare.TYPE_ALL);
var i=e?ZmMsg.shareWithPublic:a?ZmMsg.shareWithAll:(t.grantee.name||ZmMsg.userUnknown);
this._confirmMsgEl.innerHTML=this._formatter.format(i);
this._reply.setReplyType(ZmShareReply.STANDARD);
this._reply.setReplyNote("");
this._reply.setVisible(!e&&!a);
DwtDialog.prototype.popup.call(this);
this.setButtonEnabled(DwtDialog.YES_BUTTON,true)
};
ZmRevokeShareDialog.prototype._handleYesButton=function(){
var e=new AjxCallback(this,this._yesButtonCallback);
this._share.revoke(e)
};
ZmRevokeShareDialog.prototype._yesButtonCallback=function(){
var e=this._share;
var a=this._reply.getReplyType();
var t=!(e.isAll()||e.isPublic()||e.invalid);
if(a!=ZmShareReply.NONE&&t){
e.grantee.email=e.grantee.name||e.grantee.id;
e.grantor.id=appCtxt.get(ZmSetting.USERID);
e.grantor.email=appCtxt.get(ZmSetting.USERNAME);
e.grantor.name=appCtxt.get(ZmSetting.DISPLAY_NAME)||e.grantor.email;
e.link.id=e.object.id;
e.link.name=e.object.name;
e.link.view=ZmOrganizer.getViewName(e.object.type);
e.notes=(a==ZmShareReply.QUICK)?this._reply.getReplyNote():"";
if(a==ZmShareReply.COMPOSE){
e.composeMessage(ZmShare.DELETE)
}else{
e.sendMessage(ZmShare.DELETE)
}}
this.popdown()
};
ZmRevokeShareDialog.prototype._createView=function(){
this._confirmMsgEl=document.createElement("DIV");
this._confirmMsgEl.style.fontWeight="bold";
this._confirmMsgEl.style.marginBottom="0.25em";
var e=new DwtComposite(this);
this._reply=new ZmShareReply(e);
var t=e.getHtmlElement();
t.appendChild(this._confirmMsgEl);
t.appendChild(this._reply.getHtmlElement());
return e
};
ZmRevokeShareDialog.prototype._getSeparatorTemplate=function(){
return""
}
}
if(AjxPackage.define("zimbraMail.share.view.dialog.ZmFindnReplaceDialog")){
ZmFindnReplaceDialog=function(t,i){
i=i||"ZmFindnReplaceDialog";
var o=new DwtDialog_ButtonDescriptor(ZmFindnReplaceDialog.FIND_BUTTON,ZmMsg.find,DwtDialog.ALIGN_LEFT);
var s=new DwtDialog_ButtonDescriptor(ZmFindnReplaceDialog.REPLACE_BUTTON,ZmMsg.replace,DwtDialog.ALIGN_LEFT);
var n=new DwtDialog_ButtonDescriptor(ZmFindnReplaceDialog.REPLACE_ALL_BUTTON,ZmMsg.replaceAll,DwtDialog.ALIGN_LEFT);
DwtDialog.call(this,{
parent:t,className:i,title:ZmMsg.findNReplaceTitle,standardButtons:[DwtDialog.CANCEL_BUTTON],extraButtons:[o,s,n]}
);
this._findId=Dwt.getNextId();
this._replaceId=Dwt.getNextId();
this._dirId=Dwt.getNextId();
this._dirIdUp=Dwt.getNextId();
this._dirIdDown=Dwt.getNextId();
this._caseId=Dwt.getNextId();
this._wholeWordId=Dwt.getNextId();
this._messageId=Dwt.getNextId();
var a=1;
var e=["<table><tr><td>","<div style='padding:2px;' id='",this._messageId,"' style='padding-left:30px;'></div>","<table border='0'>","<tr><td class='Label' align='left'>",ZmMsg.findWhatLabel,"</td>","<td colspan=2 id='",this._findId,"'></td></tr>","<tr><td class='Label' align='left'>",ZmMsg.replaceWithLabel,"</td>","<td colspan=2 id='",this._replaceId,"'></td></tr>","<tr><td class='Label' align='left'>",ZmMsg.directionLabel,"</td>","<td colspan=2 id='",this._dirId,"' align='left'>","<table cellpadding='3'><tr>","<td><input type='radio' id='",this._dirIdUp,"' name='",this._dirId,"' value='up'></td>","<td class='Label'>",ZmMsg.upLabel,"</td>","<td><input type='radio' id='",this._dirIdDown,"' name='",this._dirId,"' value='down' checked></td>","<td class='Label'>",ZmMsg.downLabel,"</td>","</tr></table>","</td></tr>","<tr><td colspan='3'>","<table cellpadding='3'><tr>","<td class='Label' align='right'><input type='checkbox' id='",this._caseId,"'>","<td class='Label' align='left'>",ZmMsg.caseSensitive,"</td>","</tr></table>","</td></tr>","</table>","</td></tr></table>"].join("");
this.setContent(e);
this.setView(this._createView());
this.registerCallback(ZmFindnReplaceDialog.FIND_BUTTON,this._handleFindButton,this);
this.registerCallback(ZmFindnReplaceDialog.REPLACE_BUTTON,this._handleReplaceButton,this);
this.registerCallback(ZmFindnReplaceDialog.REPLACE_ALL_BUTTON,this._handleReplaceAllButton,this)
};
ZmFindnReplaceDialog.prototype=new DwtDialog;
ZmFindnReplaceDialog.prototype.constructor=ZmFindnReplaceDialog;
ZmFindnReplaceDialog.FIND_BUTTON=++DwtDialog.LAST_BUTTON;
ZmFindnReplaceDialog.REPLACE_BUTTON=++DwtDialog.LAST_BUTTON;
ZmFindnReplaceDialog.REPLACE_ALL_BUTTON=++DwtDialog.LAST_BUTTON;
ZmFindnReplaceDialog.prototype.popup=function(t,i){
this._editorInfo=t||{};
this._callback=i;
var e="";
if(t){
var a=t.editor;
e=a._getSelectedText();
if(e){
e=AjxStringUtil.trim(e.toString())
}}
this._findInput.setValue(e);
this._replaceInput.setValue("");
DwtDialog.prototype.popup.call(this)
};
ZmFindnReplaceDialog.prototype.popdown=function(){
if(this._acPageList){
this._acPageList.show(false)
}
DwtDialog.prototype.popdown.call(this)
};
ZmFindnReplaceDialog._handleKeyPress=function(i){
var t=DwtControl.getTargetControl(i);
var e=DwtKeyEvent.getCharCode(i);
if(e==13||e==3){
var a=t.parent.parent;
a.replaceAction("none",true);
return false
}
return true
};
ZmFindnReplaceDialog.prototype._createView=function(){
var e=new DwtComposite(this);
var t={
parent:e,type:DwtInputField.STRING,validationStyle:DwtInputField.CONTINUAL_VALIDATION};
this._findInput=new DwtInputField(t);
this._findInput.reparentHtmlElement(this._findId);
this._replaceInput=new DwtInputField(t);
this._replaceInput.reparentHtmlElement(this._replaceId);
Dwt.setHandler(this._findInput.getInputElement(),DwtEvent.ONKEYPRESS,ZmFindnReplaceDialog._handleKeyPress);
return e
};
ZmFindnReplaceDialog.prototype._handleFindButton=function(e){
this.replaceAction("none",true)
};
ZmFindnReplaceDialog.prototype._handleReplaceButton=function(){
this.replaceAction("current",false)
};
ZmFindnReplaceDialog.prototype._handleReplaceAllButton=function(){
this.replaceAction("all",false)
};
ZmFindnReplaceDialog.prototype.showInfoMsg=function(e){
if(!this.msgEl){
this.msgEl=document.getElementById(this._messageId)
}
this.msgEl.innerHTML=e
};
ZmFindnReplaceDialog.prototype.replaceAction=function(r,a){
var i=this._findInput.getValue();
var t=(a?null:this._replaceInput.getValue());
var s=document.getElementById(this._dirIdUp);
var o=false;
var e=false;
if(s&&s.checked){
e=true
}
this._caseCheckbox=document.getElementById(this._caseId);
if(this._caseCheckbox&&this._caseCheckbox.checked){
o=true
}
var n={
searchstring:i,replacestring:t,replacemode:r,casesensitive:o,backwards:e};
if(this._editorInfo.editor){
var h=this._editorInfo.editor;
if(AjxEnv.iIE){
h.focus()
}
h.searchnReplace(n)
}
if(this._callback){
this._callback.run(n)
}}
}
if(AjxPackage.define("zimbraMail.share.view.dialog.ZmFolderNotifyDialog")){
ZmFolderNotifyDialog=function(t,e){
e=e||"ZmFolderNotifyDialog";
var a=[new DwtDialog_ButtonDescriptor(ZmFolderPropsDialog.ADD_SHARE_BUTTON,ZmMsg.addShare,DwtDialog.ALIGN_LEFT)];
DwtDialog.call(this,{
parent:t,className:e,title:ZmMsg.folderNotify,extraButtons:a}
);
this.getButton(DwtDialog.OK_BUTTON).setText(ZmMsg.notify);
this.registerCallback(ZmFolderPropsDialog.ADD_SHARE_BUTTON,this._handleAddShareButton,this);
this.setButtonListener(DwtDialog.OK_BUTTON,new AjxListener(this,this._handleOkButton));
this.setButtonListener(DwtDialog.CANCEL_BUTTON,new AjxListener(this,this._handleCancelButton));
this._folderChangeListener=new AjxListener(this,this._handleFolderChange);
this.setView(this._createView())
};
ZmFolderNotifyDialog.prototype=new DwtDialog;
ZmFolderNotifyDialog.prototype.constructor=ZmFolderNotifyDialog;
ZmFolderNotifyDialog.ADD_SHARE_BUTTON=++DwtDialog.LAST_BUTTON;
ZmFolderNotifyDialog.SHARES_HEIGHT="9em";
ZmFolderNotifyDialog.prototype.toString=function(){
return"ZmFolderNotifyDialog"
};
ZmFolderNotifyDialog.prototype.popup=function(e){
this._organizer=e;
e.addChangeListener(this._folderChangeListener);
this._populateShares(e);
this._reply.setReplyType(ZmShareReply.STANDARD);
this._reply.setReplyNote("");
DwtDialog.prototype.popup.call(this)
};
ZmFolderNotifyDialog.prototype.popdown=function(){
this._organizer.removeChangeListener(this._folderChangeListener);
this._organizer=null;
DwtDialog.prototype.popdown.call(this)
};
ZmFolderNotifyDialog.prototype._handleAddShareButton=function(t){
var e=appCtxt.getSharePropsDialog();
e.popup(ZmSharePropsDialog.NEW,this._organizer,null)
};
ZmFolderNotifyDialog.prototype._handleOkButton=function(e){
var o=this._reply.getReplyType();
var s=o==ZmShareReply.QUICK?this._reply.getReplyNote():"";
var r=this._organizer.shares;
for(var a=0;
a<r.length;
a++){
var c=r[a];
var h=c.grantee.email;
if(!h){
if(AjxEmailAddress.isValid(c.grantee.name)){
h=c.grantee.name
}}
if(!h){
continue
}
var n=new AjxVector();
var l=new AjxEmailAddress(h,AjxEmailAddress.TO);
n.add(l);
var t=new ZmShare({
object:c.object}
);
t.grantee.id=c.grantee.id;
t.grantee.email=h;
t.grantee.name=c.grantee.name;
if(t.object.isRemote()){
t.grantor.id=t.object.zid;
t.grantor.email=t.object.owner;
t.grantor.name=t.grantor.email;
t.link.id=t.object.rid
}else{
t.grantor.id=appCtxt.get(ZmSetting.USERID);
t.grantor.email=appCtxt.get(ZmSetting.USERNAME);
t.grantor.name=appCtxt.get(ZmSetting.DISPLAY_NAME)||t.grantor.email;
t.link.id=t.object.id
}
t.link.perm=c.link.perm;
t.link.name=t.object.name;
t.link.view=ZmOrganizer.getViewName(t.object.type);
t.link.inh=this._inheritEl?this._inheritEl.checked:true;
t.notes=s;
t.sendMessage(ZmShare.NOTIFY,n)
}
this.popdown()
};
ZmFolderNotifyDialog.prototype._handleCancelButton=function(e){
this.popdown()
};
ZmFolderNotifyDialog.prototype._handleFolderChange=function(e){
this._populateShares(this._organizer)
};
ZmFolderNotifyDialog.prototype._populateShares=function(c){
this._sharesGroup.setContent("");
var l=c.link;
var r=c.shares;
var o=((!l||c.isAdmin())&&r&&r.length>0);
if(o){
AjxDispatcher.require("Share");
var m=document.createElement("TABLE");
m.border=0;
m.cellSpacing=0;
m.cellPadding=3;
for(var s=0;
s<r.length;
s++){
var u=r[s];
var f=m.insertRow(-1);
var t=f.insertCell(-1);
t.style.paddingRight="15px";
var h=u.grantee.name||ZmMsg.userUnknown;
if(u.isAll()){
h=ZmMsg.shareWithAll
}else{
if(u.isPublic()){
h=ZmMsg.shareWithPublic
}}
t.innerHTML=AjxStringUtil.htmlEncode(h);
var n=f.insertCell(-1);
n.style.paddingRight="15px";
n.innerHTML=ZmShare.getRoleName(u.link.perm)
}
this._sharesGroup.setElement(m);
var e=Dwt.DEFAULT;
var d=r.length>5?ZmFolderNotifyDialog.SHARES_HEIGHT:Dwt.CLEAR;
var a=this._sharesGroup.getInsetHtmlElement();
Dwt.setScrollStyle(a,Dwt.SCROLL);
Dwt.setSize(a,e,d);
this.getButton(DwtDialog.OK_BUTTON).setEnabled(true)
}else{
this._sharesGroup.setContent("<center>"+ZmMsg.noShareDetailsFound+"</center>");
this.getButton(DwtDialog.OK_BUTTON).setEnabled(false)
}};
ZmFolderNotifyDialog.prototype._createView=function(){
var e=new DwtComposite(this);
this._reply=new ZmShareReply(e,null,[ZmShareReply.STANDARD,ZmShareReply.QUICK]);
this._messageGroup=new DwtGrouper(e);
this._messageGroup.setLabel(ZmMsg.message);
this._messageGroup.setView(this._reply);
e.getHtmlElement().appendChild(this._messageGroup.getHtmlElement());
this._sharesGroup=new DwtGrouper(e);
this._sharesGroup.setLabel(ZmMsg.folderSharing);
this._sharesGroup.setVisible(true);
this._sharesGroup.setScrollStyle(Dwt.SCROLL);
e.getHtmlElement().appendChild(this._sharesGroup.getHtmlElement());
return e
}
}
if(AjxPackage.define("zimbraMail.share.view.dialog.ZmTimezonePicker")){
ZmTimezonePicker=function(t,e){
var a=[ZmTimezonePicker.SAVE_BUTTON];
var i=new DwtDialog_ButtonDescriptor(ZmTimezonePicker.SAVE_BUTTON,ZmMsg.save,DwtDialog.ALIGN_RIGHT);
DwtDialog.call(this,{
parent:t,className:e,title:ZmMsg.selectTimezoneTitle,standardButtons:DwtDialog.NO_BUTTONS,extraButtons:[i]}
);
this.setButtonListener(ZmTimezonePicker.SAVE_BUTTON,new AjxListener(this,this._handleSaveButton));
this.setContent(this._contentHtml());
this._setTimezoneMenu()
};
ZmTimezonePicker.prototype=new DwtDialog;
ZmTimezonePicker.prototype.constructor=ZmTimezonePicker;
ZmTimezonePicker.SAVE_BUTTON=++DwtDialog.LAST_BUTTON;
ZmTimezonePicker.prototype.toString=function(){
return"ZmTimezonePicker"
};
ZmTimezonePicker.prototype.popup=function(){
this._initTzSelect();
this.autoSelectTimezone();
DwtDialog.prototype.popup.call(this)
};
ZmTimezonePicker.prototype.cleanup=function(e){
DwtDialog.prototype.cleanup.call(this,e)
};
ZmTimezonePicker.prototype._setTimezoneMenu=function(){
var e=new AjxListener(this,this._timezoneListener);
this._tzoneSelect=new DwtSelect({
parent:this,parentElement:(this._htmlElId+"_tzSelect"),layout:DwtMenu.LAYOUT_SCROLL,maxRows:7}
);
this._tzoneSelect.addChangeListener(e);
this._tzoneShowAll=new DwtCheckbox({
parent:this,parentElement:(this._htmlElId+"_tzShowAll")}
);
this._tzoneShowAll.setText(ZmMsg.selectTimezoneIShowAll);
this._tzoneShowAll.addSelectionListener(new AjxListener(this,this._handleShowAllChange))
};
ZmTimezonePicker.prototype._initTzSelect=function(n){
var o=this._tzoneShowAll.isSelected();
var t=o?AjxTimezone.getAbbreviatedZoneChoices():AjxTimezone.getMatchingTimezoneChoices();
var s={};
var e;
if(n||t.length!=this._tzCount){
this._tzCount=t.length;
this._tzoneSelect.clearOptions();
for(var a=0;
a<t.length;
a++){
if(t[a].autoDetected){
continue
}
e=t[a].value;
if(!o&&s[e]){
continue
}
s[e]=true;
this._tzoneSelect.addOption(t[a])
}}};
ZmTimezonePicker.prototype.autoSelectTimezone=function(){
if(AjxTimezone.DEFAULT_RULE.autoDetected){
var r=AjxTimezone.DEFAULT_RULE;
var n,l,d;
for(var s in AjxTimezone.MATCHING_RULES){
var c=AjxTimezone.MATCHING_RULES[s];
if(c.autoDetected){
continue
}
if(c.standard.offset==r.standard.offset){
if(!n){
n=c.serverId
}
var t=(r.daylight&&c.daylight&&(c.daylight.offset==r.daylight.offset));
if(t){
if(!l){
l=c.serverId
}
var e=(c.daylight.trans[0]==r.daylight.trans[0]);
var a=(c.daylight.trans[1]==r.daylight.trans[1]);
if(e&&a&&!d){
d=c.serverId
}}}}
var h=d?d:(l||n);
if(h){
this._tzoneSelect.setSelectedValue(h)
}}else{
var o=AjxTimezone.getServerId(AjxTimezone.DEFAULT);
this._tzoneSelect.setSelectedValue(o)
}};
ZmTimezonePicker.prototype.updateTimezone=function(e){
this._tzoneSelect.setSelectedValue(e.timezone)
};
ZmTimezonePicker.prototype.setCallback=function(e){
this._callback=e
};
ZmTimezonePicker.prototype._timezoneListener=function(e){};
ZmTimezonePicker.prototype._handleShowAllChange=function(e){
var t=this._tzoneSelect.getValue();
this._initTzSelect(true);
this._tzoneSelect.setSelectedValue(t)
};
ZmTimezonePicker.prototype._contentHtml=function(){
return AjxTemplate.expand("share.Dialogs#ZmTimezonePicker",{
id:this._htmlElId}
)
};
ZmTimezonePicker.prototype._okButtonListener=function(e){
DwtDialog.prototype._buttonListener.call(this,e,results)
};
ZmTimezonePicker.prototype._enterListener=function(e){};
ZmTimezonePicker.prototype._getTabGroupMembers=function(){
return[this._tzoneSelect]
};
ZmTimezonePicker.prototype._handleSaveButton=function(t){
var e=this._tzoneSelect.getValue();
this.popdown();
if(this._callback){
this._callback.run(e)
}};
ZmTimezonePicker.prototype.handleKeyAction=function(e,t){
switch(e){
case DwtKeyMap.CANCEL:this._runCallbackForButtonId(DwtDialog.CANCEL_BUTTON);
break;
default:DwtDialog.prototype.handleKeyAction.call(this,e,t);
break
}
return true
}
}};
