
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
if(AjxPackage.define("SpreadsheetALE")){
if(AjxPackage.define("zimbraMail.ale.spreadsheet.msgs")){
ZmMsg.SS={
func:{
sum:{
help:ZmMsg.spreadSheet_func_sum}
,multiply:{
help:ZmMsg.spreadSheet_func_multiply}
,modulo:{
help:ZmMsg.spreadSheet_func_modulo}
,PI:{
help:ZmMsg.spreadSheet_func_PI,helper:"=PI|"}
,sin:{
help:ZmMsg.spreadSheet_func_sin}
,cos:{
help:ZmMsg.spreadSheet_func_cos}
,tan:{
help:ZmMsg.spreadSheet_func_tan}
,round:{
help:ZmMsg.spreadSheet_func_round}
,ceil:{
help:ZmMsg.spreadSheet_func_ceil}
,floor:{
help:ZmMsg.spreadSheet_func_floor}
,abs:{
help:ZmMsg.spreadSheet_func_abs}
,sqrt:{
help:ZmMsg.spreadSheet_func_sqrt}
,exp:{
help:ZmMsg.spreadSheet_func_exp}
,log:{
help:ZmMsg.spreadSheet_func_log}
,min:{
help:ZmMsg.spreadSheet_func_min}
,max:{
help:ZmMsg.spreadSheet_func_max}
,len:{
help:ZmMsg.spreadSheet_func_len}
,concat:{
help:ZmMsg.spreadSheet_func_concat}
,average:{
help:ZmMsg.spreadSheet_func_average}
,join:{
help:ZmMsg.spreadSheet_func_join,args:"join(separator, string1 [, string2...])",helper:'=join(", ", |)'}
,"if":{
help:ZmMsg.spreadSheet_func_if,args:"if(condition, true_value, false_value)"}}}
}
if(AjxPackage.define("zimbraMail.ale.spreadsheet.ZmSpreadSheet")){
ZmSpreadSheet=function(o,i,a,e){
if(arguments.length==0){
return
}
i=i||"ZmSpreadSheet";
DwtComposite.call(this,{
parent:o,className:i,posStyle:a,deferred:e}
);
var t=null;
this._selectRangeCapture=new DwtMouseEventCapture({
targetObj:this,id:"ZmSpreadSheet",mouseOverHdlr:AjxCallback.simpleClosure(this._table_selrange_MouseOver,this),mouseMoveHdlr:AjxCallback.simpleClosure(function(s){
var n=this;
if(t){
clearTimeout(t)
}
t=setTimeout(function(){
n._getRangeDiv().style.display="none";
setTimeout(function(){
n._getRangeDiv().style.display=""
}
,1)
}
,50)
}
,this),mouseUpHdlr:AjxCallback.simpleClosure(this._clear_selectRangeCapture,this)}
);
this._colsizeCapture=new DwtMouseEventCapture({
targetObj:this,id:"ZmSpreadSheet",mouseMoveHdlr:AjxCallback.simpleClosure(this._colsize_mouseMove,this),mouseUpHdlr:AjxCallback.simpleClosure(this._colsize_mouseUp,this)}
);
this._onResize=new AjxListener(this,this._onResize);
this._hoverOverListener=new AjxListener(this,this._handleOverListener);
this._hoverOutListener=new AjxListener(this,this._handleOutListener);
this.addControlListener(this._onResize);
this.onSelectCell=[];
this.onInputModified=[]
};
ZmSpreadSheet.TOOLTIP_DELAY=750;
ZmSpreadSheet.prototype=new DwtComposite;
ZmSpreadSheet.prototype.construction=ZmSpreadSheet;
ZmSpreadSheet.getCellName=function(e){
return ZmSpreadSheetModel.getCellName(e.parentNode.rowIndex,e.cellIndex)
};
ZmSpreadSheet.prototype.setModel=function(e){
e.reset();
this._model=e;
this._init();
e.setViewListener("onCellValue",new AjxCallback(this,this._model_cellComputed));
e.setViewListener("onInsertRow",new AjxCallback(this,this._model_insertRow));
e.setViewListener("onInsertCol",new AjxCallback(this,this._model_insertCol));
e.setViewListener("onDeleteRow",new AjxCallback(this,this._model_deleteRow));
e.setViewListener("onDeleteCol",new AjxCallback(this,this._model_deleteCol))
};
ZmSpreadSheet.prototype._model_cellEdited=function(a,t,e){
var i=this._getTable().rows[a].cells[t];
e.setToElement(i)
};
ZmSpreadSheet.prototype._model_cellComputed=function(a,t,e){
var i=this._getTable().rows[a].cells[t];
e.setToElement(i)
};
ZmSpreadSheet.prototype._model_deleteRow=function(h){
this._hideRange();
var o=this._selectedCell;
this._selectCell();
var t=o.cellIndex;
var e=o.parentNode.rowIndex;
var r=this._getTable().rows;
var s=r[r.length-1];
s.removeChild(s.firstChild);
++h;
for(var a=r.length;
--a>h;
){
var n=r[a-1].firstChild;
r[a].insertBefore(n,r[a].firstChild)
}
var s=r[a];
s.parentNode.removeChild(s);
if(e>=r.length){
--e
}
this._selectCell(r[e].cells[t])
};
ZmSpreadSheet.prototype._model_deleteCol=function(a){
this._hideRange();
var n=this._selectedCell;
this._selectCell();
var t=n.cellIndex;
var e=n.parentNode.rowIndex;
var r=this._getTable().rows;
for(var o=1;
o<r.length;
++o){
var s=r[o];
var h=s.cells[a+1];
s.removeChild(h)
}
s=r[0];
s.removeChild(s.cells[s.cells.length-1]);
if(t>=s.cells.length){
--t
}
this._header_resetColWidths();
this._selectCell(r[e].cells[t])
};
ZmSpreadSheet.prototype._model_insertRow=function(h,r){
this._hideRange();
var a=this._selectedCell;
this._selectCell();
var c=this._getTable().rows;
var l=this._getTable().insertRow(r+1);
var o=true;
for(var s=l.rowIndex;
s<c.length-1;
++s){
var e=c[s+1].firstChild;
var n=e;
if(s==c.length-2){
e=e.cloneNode(true);
n.firstChild.innerHTML=s+1
}
c[s].insertBefore(e,c[s].firstChild);
o=false
}
if(o){
var t=l.insertCell(0);
t.className="LeftBar";
t.innerHTML="<div>"+(r+1)+"</div>"
}
for(var s=0;
s<h.length;
++s){
var t=l.insertCell(s+1);
t.className="cell";
h[s]._td=t;
h[s].setToElement(t)
}
this._selectCell(a)
};
ZmSpreadSheet.prototype._model_insertCol=function(t,e){
this._hideRange();
var o=this._selectedCell;
this._selectCell();
var n=this._getTable().rows;
var s=n[0];
var r=s.insertCell(e+1);
r.innerHTML="<div></div>";
for(var a=e+1;
a<s.cells.length;
++a){
s.cells[a].firstChild.innerHTML=ZmSpreadSheetModel.getColName(a)
}
for(var a=0;
a<t.length;
++a){
s=n[a+1];
var r=s.insertCell(e+1);
r.className="cell";
t[a]._td=r;
t[a].setToElement(r)
}
this._header_resetColWidths();
this._selectCell(o)
};
ZmSpreadSheet.prototype.getCellModel=function(e){
return this._model.getCell(e.parentNode.rowIndex,e.cellIndex)
};
ZmSpreadSheet.prototype._init=function(){
var r=[];
var d=true;
if(!this._relDivID){
d=false;
this._relDivID=Dwt.getNextId();
r.push("<div id='",this._relDivID,"' class='ZmSpreadSheet-RelDiv'>")
}
this._focusLinkID=Dwt.getNextId();
this._tableID=Dwt.getNextId();
r.push("<a class='FocusLink' id='",this._focusLinkID,"'");
if(AjxEnv.isIE){
r.push(" href='#' onclick='return false'")
}
r.push(">");
if(AjxEnv.isIE){
r.push("&nbsp;")
}
r.push("</a>");
r.push("<table class='SpreadSheet' id='",this._tableID,"' cellspacing='1' cellpadding='0' border='0'>");
var f=["<tr><td class='LeftBar'></td>"];
var u=this._model.ROWS;
var h=this._model.COLS;
this._inputFieldID=null;
this._spanFieldID=null;
for(var o=h;
o>0;
){
f[o--]="<td class='cell'></td>"
}
f[h+1]="</tr>";
f=f.join("");
for(var o=u;
o-->=0;
){
r[r.length]=f
}
r[r.length]="</table>";
if(!d){
r[r.length]="</div>";
var e=this.getHtmlElement();
e.innerHTML=r.join("")
}else{
this._getRelDiv().innerHTML=r.join("")
}
var m=this._getTable();
m.rows[0].className="TopBar";
m.rows[0].cells[0].className="TopLeft";
for(var o=0;
o<m.rows.length;
++o){
m.rows[o].cells[0].innerHTML="<div>"+o+"</div>"
}
f=m.rows[0];
for(var o=1;
o<f.cells.length;
++o){
f.cells[o].innerHTML="<div>"+ZmSpreadSheetModel.getColName(o)+"</div>"
}
m.onmouseup=AjxCallback.simpleClosure(this._table_onMouseUp,this);
m.onmousedown=AjxCallback.simpleClosure(this._table_onClick,this);
m.onclick=AjxCallback.simpleClosure(this._table_onClick,this);
m.ondblclick=AjxCallback.simpleClosure(this._table_onClick,this);
m.onmousemove=AjxCallback.simpleClosure(this._table_mouseMove,this);
m.onmouseout=AjxCallback.simpleClosure(this._table_mouseOut,this);
var l=this._getFocusLink();
l.onkeypress=AjxCallback.simpleClosure(this._focus_keyPress,this);
if(AjxEnv.isIE||AjxEnv.isOpera){
l.onkeydown=l.onkeypress
}
var s=document.createElement("table");
s.cellSpacing=1;
s.cellPadding=0;
s.border=0;
s.id=this._headerID=Dwt.getNextId();
s.className="SpreadSheet Header";
var n=document.createElement("tbody");
s.appendChild(n);
s.style.position="absolute";
s.style.left="0px";
s.style.top="0px";
this._getRelDiv().appendChild(s);
s.onclick=m.onclick;
s.onmousemove=AjxCallback.simpleClosure(this._header_onMouseMove,this);
s.onmousedown=AjxCallback.simpleClosure(this._header_onMouseDown,this);
this._getRelDiv().onscroll=AjxCallback.simpleClosure(this._header_resetScrollTop,this);
this.getHtmlElement().style.display="none";
if(!this._model.version){
if(ZmSpreadSheetModel.DEBUG){
console.log("Loading old spreadsheet file -- slower")
}
for(var o=0;
o<u;
++o){
var f=m.rows[o+1];
for(var a=0;
a<h;
++a){
this._model.data[o][a]._td=f.cells[a+1]
}}}
this._model.doneSetView();
for(var o=0;
o<u;
++o){
var f=m.rows[o+1];
for(var a=0;
a<h;
++a){
var c=this._model.data[o][a];
var t=c._td=f.cells[a+1];
c._savedRow=c._savedCol=null;
c.setToElement(t)
}}
this.getHtmlElement().style.display="";
this._header_resetColWidths()
};
ZmSpreadSheet.prototype._topCellClicked=function(o,i){
if(/click/i.test(i.type)){
var e=o.cellIndex;
this._selectCell(this._getTable().rows[o.parentNode.rowIndex+1].cells[e]);
var e=ZmSpreadSheetModel.getColName(e);
var a=e+"1";
var t=e+this._model.ROWS;
this._selectRange(a,t)
}};
ZmSpreadSheet.prototype._leftCellClicked=function(o,a){
if(/click/i.test(a.type)){
var i=o.parentNode.rowIndex;
this._selectCell(this._getTable().rows[i].cells[o.cellIndex+1]);
var t="A"+i;
var e=ZmSpreadSheetModel.getColName(this._model.COLS)+i;
this._selectRange(t,e)
}};
ZmSpreadSheet.prototype._topLeftCellClicked=function(i,a){
var t="A1";
var e=ZmSpreadSheetModel.getColName(this._model.COLS)+this._model.ROWS;
this.focus();
this._selectRange(t,e,true)
};
ZmSpreadSheet.prototype._cellClicked=function(s,i){
var t=/mousedown/i.test(i.type);
this._hideRange();
this._selectCell(s);
if(AjxEnv.isIE&&DwtMenu._activeMenu){
DwtMenu._activeMenu.popdown()
}
if(t){
var a=true;
if(this._editingCell&&this._hasExpression){
var e=this._getInputField();
var n=Dwt.getSelectionStart(e);
var o=e.value.substr(0,n);
if(/\)\s*$/.test(o)){
a=false
}else{
this._updateCellRangeToken()
}}else{
this.focus()
}
if(a){
i._stopPropagation=true;
i._returnValue=false;
this._selectRangeCapture.capture()
}}
if(/dblclick/i.test(i.type)){
i._stopPropagation=true;
i._returnValue=false;
this._editCell(s)
}};
ZmSpreadSheet.prototype.focus=function(){
if(!this._selectedCell){
this._selectCell(this._getTable().rows[1].cells[1])
}
this._getFocusLink().focus();
window.status=""
};
ZmSpreadSheet.prototype._getTopLeftCell=function(){
return this._getHeaderTable().rows[0].cells[0]
};
ZmSpreadSheet.prototype._getTopHeaderCell=function(e){
return this._getHeaderTable().rows[0].cells[e.cellIndex]
};
ZmSpreadSheet.prototype._getLeftHeaderCell=function(o){
var e=null;
var t=this._getTable();
var a=(t&&t.rows)?t.rows:null;
var i=(o&&o.parentNode)?o.parentNode.rowIndex:0;
return(a?a[i][0]:null)
};
ZmSpreadSheet.prototype._colsize_mouseMove=function(o){
var i=new DwtMouseEvent();
i.setFromDhtmlEvent(o);
var s=i.docX-this._colsizeArgs.docX;
var n=AjxEnv.isIE?0:-2;
var a=true;
if(this._resizeColStart){
var t=this._colsizeArgs.w1-s+n;
var e=this._colsizeArgs.w2+s+n;
if(t>7&&e>7){
this._colsizeArgs.td1.firstChild.style.width=t+"px";
this._colsizeArgs.td2.firstChild.style.width=e+"px"
}else{
a=false
}}else{
var t=this._colsizeArgs.w1+s+n;
if(t>7){
this._colsizeArgs.td1.firstChild.style.width=t+"px"
}else{
a=false
}}
if(a){
this._colsizeArgs.delta=s
}
i._stopPropagation=true;
i._returnValue=false;
i.setToDhtmlEvent(o);
return i._returnValue
};
ZmSpreadSheet.prototype._colsize_mouseUp=function(i){
var a=new DwtMouseEvent();
a.setFromDhtmlEvent(i);
this._colsizeCapture.release();
var e;
var o=this._colsizeArgs.delta;
if(o){
var t=this._resizeColIndex;
if(this._resizeColStart){
e=this._model.getColWidth(t-1);
this._model.setColWidth(t-1,e-o);
e=this._model.getColWidth(t-2);
this._model.setColWidth(t-2,e+o)
}else{
e=this._model.getColWidth(t-1);
this._model.setColWidth(t-1,e+o)
}}
this._colsizeArgs.td1=null;
this._colsizeArgs.td2=null;
this._colsizeArgs=null;
a._stopPropagation=true;
a._returnValue=false;
a.setToDhtmlEvent(i);
return a._returnValue
};
ZmSpreadSheet.prototype._header_onMouseDown=function(a){
var t=new DwtMouseEvent();
t.setFromDhtmlEvent(a);
if(this._resizeColIndex){
this._hideRange();
var i=this._getHeaderTable().rows[0].cells[this._resizeColIndex];
this._colsizeArgs={
td1:i,w1:i.firstChild.offsetWidth,docX:t.docX,docY:t.docY};
var e=this._resizeColStart?-1:+1;
i=this._getHeaderTable().rows[0].cells[this._resizeColIndex+e];
if(i){
this._colsizeArgs.td2=i;
this._colsizeArgs.w2=i.firstChild.offsetWidth
}
this._colsizeCapture.capture();
t._stopPropagation=true;
t._returnValue=false
}
t.setToDhtmlEvent(a);
return t._returnValue
};
ZmSpreadSheet.prototype._header_onMouseMove=function(n){
var e=new DwtMouseEvent();
e.setFromDhtmlEvent(n);
var s=this._getHeaderTable();
var t=DwtUiEvent.getTarget(e);
while(t&&t!==s&&!/^td$/i.test(t.tagName)){
t=t.parentNode
}
if(t&&/^td$/i.test(t.tagName)){
var i=t.cellIndex;
if(i>0){
var h=t.parentNode;
var r=h.cells;
var a=Dwt.getLocation(this._getRelDiv());
var o=e.docX-a.x-t.offsetLeft+this._getRelDiv().scrollLeft;
if(Math.abs(o-t.offsetWidth)<5){
this._resizeColIndex=i;
this._resizeColStart=false;
Dwt.delClass(s,"Header-ColWSize","Header-ColESize")
}else{
if(o<5&&i>1){
this._resizeColIndex=i;
this._resizeColStart=true;
Dwt.delClass(s,"Header-ColESize","Header-ColWSize")
}else{
this._resizeColIndex=null;
Dwt.delClass(s,"Header-ColWSize");
Dwt.delClass(s,"Header-ColESize")
}}}}else{}
e.setToDhtmlEvent(n);
return e._returnValue
};
ZmSpreadSheet.prototype._header_resetColWidths=function(){
var n=this._getTable();
var r=this._getHeaderTable();
if(r.rows.length>0){
r.deleteRow(0)
}
r.firstChild.appendChild(n.rows[0].cloneNode(true));
var t=n.rows[0].cells;
var e=r.rows[0].cells;
var s=AjxEnv.isIE?0:-2;
for(var o=0;
o<t.length;
++o){
e[o].firstChild.style.width=t[o].firstChild.offsetWidth+s+"px"
}};
ZmSpreadSheet.prototype._header_resetScrollTop=function(){
this._getHeaderTable().style.top=this._getRelDiv().scrollTop+"px"
};
ZmSpreadSheet.prototype._selectCell=function(a){
if(this._selectedCell){
Dwt.delClass(this._getTopHeaderCell(this._selectedCell),"TopSelected");
Dwt.delClass(this._getLeftHeaderCell(this._selectedCell),"LeftSelected");
Dwt.delClass(this._selectedCell,"SSelected")
}
this._selectedCell=a;
if(a){
Dwt.addClass(a,"SSelected");
Dwt.addClass(this._getTopHeaderCell(a),"TopSelected");
Dwt.addClass(this._getLeftHeaderCell(a),"LeftSelected");
this._getTopLeftCell().innerHTML="<div>"+ZmSpreadSheet.getCellName(a)+"</div>";
var t=this._getFocusLink();
t.style.top=a.offsetTop+"px";
t.style.left=a.offsetLeft+"px";
if(!this._editingCell){
this.focus()
}
t.style.top=a.offsetTop+a.offsetHeight-1+"px";
t.style.left=a.offsetLeft+a.offsetWidth-1+"px";
if(!this._editingCell){
this.focus();
for(var e=this.onSelectCell.length;
--e>=0;
){
this.onSelectCell[e].run(this.getCellModel(a),a)
}}}};
ZmSpreadSheet.prototype._getHeaderTable=function(){
return document.getElementById(this._headerID)
};
ZmSpreadSheet.prototype._getRelDiv=function(){
return document.getElementById(this._relDivID)
};
ZmSpreadSheet.prototype._getFocusLink=function(){
return document.getElementById(this._focusLinkID)
};
ZmSpreadSheet.prototype._input_setValue=function(a){
var e=this._getInputField();
e.value=a;
for(var t=this.onInputModified.length;
--t>=0;
){
this.onInputModified[t].run(a)
}};
ZmSpreadSheet.prototype._getInputField=function(){
var e=null;
if(this._inputFieldID){
e=document.getElementById(this._inputFieldID)
}
if(!e){
var t=this._getRelDiv();
e=document.createElement("input");
this._inputFieldID=e.id=Dwt.getNextId();
e.setAttribute("autocomplete","off");
e.type="text";
e.className="InputField";
e.style.left="0px";
e.style.top="0px";
e.style.visibility="hidden";
t.appendChild(e);
e[(AjxEnv.isIE||AjxEnv.isOpera)?"onkeydown":"onkeypress"]=AjxCallback.simpleClosure(this._input_keyPress,this);
e.onmouseup=AjxCallback.simpleClosure(this._input_mouseUp,this);
e.onblur=AjxCallback.simpleClosure(this._input_blur,this);
e.onfocus=AjxCallback.simpleClosure(this._input_focus,this);
e.setValue=AjxCallback.simpleClosure(this._input_setValue,this)
}
return e
};
ZmSpreadSheet.prototype._getSpanField=function(){
var e=null;
if(this._spanFieldID){
e=document.getElementById(this._spanFieldID)
}
if(!e){
var e=document.createElement("span");
this._spanFieldID=e.id=Dwt.getNextId();
e.className="InputField";
var t=this._getRelDiv();
t.appendChild(e)
}
return e
};
ZmSpreadSheet.prototype._editCell=function(a){
this._shiftRangeStart=null;
var e=this._getInputField();
if(this._editingCell){
e.blur()
}
if(a){
this._selectCell(a);
e.style.visibility="";
e.style.top=a.offsetTop-1+"px";
e.style.left=a.offsetLeft-1+"px";
e.style.width=a.offsetWidth+2+"px";
e.style.height=a.offsetHeight+2+"px";
var t=this.getCellModel(a);
e.setValue(t.getEditValue());
e._caretMoved=false;
e.select();
e.focus();
this._editingCell=a;
t.setStyleToElement(e,true);
this._displayRangeIfAny();
this._input_keyPress()
}};
ZmSpreadSheet.prototype._input_blur=function(t){
this._shiftRangeStart=null;
var e=this._getInputField();
e.style.visibility="hidden";
e.style.left=0;
e.style.top=0;
e.style.width="";
if(!this._preventSaveOnBlur){
this._save_value(e.value)
}
this._editingCell=null;
this._hideRange()
};
ZmSpreadSheet.prototype._input_focus=function(t){
var e=this._getInputField();
if(e.style.visibility=="hidden"&&this._selectedCell){
this._editCell(this._selectedCell)
}};
ZmSpreadSheet.prototype._save_value=function(e){
this.getCellModel(this._editingCell).setEditValue(e)
};
ZmSpreadSheet.prototype._getNextCell=function(a){
if(a==null){
a=this._editingCell||this._selectedCell
}
var t=a.parentNode;
if(a.cellIndex<t.cells.length-1){
return t.cells[a.cellIndex+1]
}
var e=this._getTable();
if(t.rowIndex<e.rows.length-1){
return e.rows[t.rowIndex+1].cells[1]
}
return null
};
ZmSpreadSheet.prototype._getPrevCell=function(a){
if(a==null){
a=this._editingCell||this._selectedCell
}
var t=a.parentNode;
if(a.cellIndex>1){
return t.cells[a.cellIndex-1]
}
var e=this._getTable();
if(t.rowIndex>1){
t=e.rows[t.rowIndex-1];
return t.cells[t.cells.length-1]
}
return null
};
ZmSpreadSheet.prototype._getDownCell=function(a){
if(a==null){
a=this._editingCell||this._selectedCell
}
var t=a.parentNode;
var e=this._getTable();
if(t.rowIndex<e.rows.length-1){
t=e.rows[t.rowIndex+1];
return t.cells[a.cellIndex]
}
return null
};
ZmSpreadSheet.prototype._getUpCell=function(a){
if(a==null){
a=this._editingCell||this._selectedCell
}
var t=a.parentNode;
var e=this._getTable();
if(t.rowIndex>1){
t=e.rows[t.rowIndex-1];
return t.cells[a.cellIndex]
}
return null
};
ZmSpreadSheet.prototype._getRightCell=function(t){
if(t==null){
t=this._editingCell||this._selectedCell
}
var e=t.parentNode;
if(t.cellIndex<e.cells.length-1){
return e.cells[t.cellIndex+1]
}
return null
};
ZmSpreadSheet.prototype._getLeftCell=function(t){
if(t==null){
t=this._editingCell||this._selectedCell
}
var e=t.parentNode;
if(t.cellIndex>1){
return e.cells[t.cellIndex-1]
}
return null
};
ZmSpreadSheet.prototype._focus_handleKey=function(t,a){
var r=AjxEnv.isIE||AjxEnv.isOpera;
this.focus();
var o=true;
var i=false;
var e=this._selectedCell;
switch(t.keyCode){
case 9:var s=t.shiftKey?this._getPrevCell():this._getNextCell();
if(s){
this._selectCell(s)
}
break;
case 37:case 39:var s=t.keyCode==37?this._getLeftCell():this._getRightCell();
if(s){
this._selectCell(s);
i=true
}
break;
case 38:case 13:case 40:var s=(t.keyCode==13?(t.shiftKey?this._getUpCell():this._getDownCell()):(t.keyCode==38?this._getUpCell():this._getDownCell()));
if(s){
this._selectCell(s);
i=t.keyCode!=13
}
break;
case 113:this._editCell(this._selectedCell);
break;
case 46:if(this._selectedRangeName){
this._model.forEachCell(this._selectedRangeName,function(h){
if(t.isCommand()){
h.clearAll()
}else{
h.clearValue()
}}
)
}
this.getCellModel(this._selectedCell).clearValue();
break;
case 27:this._hideRange();
break;
default:if(!t.isCommand()&&((!r&&a.charCode)||(r&&/keypress/i.test(t.type)))){
var n=String.fromCharCode(t.charCode);
this._editCell(this._selectedCell);
this._getInputField().setValue(n);
Dwt.setSelectionRange(this._getInputField(),1,1)
}else{
o=false
}}
if(!o){
switch(String.fromCharCode(t.charCode).toLowerCase()){
case"c":if(t.isCommand()){
o=true;
this.clipboardCopy()
}
break;
case"x":if(t.isCommand()){
o=true;
this.clipboardCut()
}
break;
case"v":if(t.isCommand()){
o=true;
this.clipboardPaste()
}
break
}}
if(o){
t._stopPropagation=true;
t._returnValue=false
}
if(i){
if(t.shiftKey&&!this._shiftRangeStart){
this._shiftRangeStart=e
}else{
if(!t.shiftKey){
this._shiftRangeStart=null;
this._hideRange()
}}
if(this._shiftRangeStart){
this._selectRange(ZmSpreadSheet.getCellName(this._shiftRangeStart),ZmSpreadSheet.getCellName(this._selectedCell),false)
}}
return o
};
ZmSpreadSheet.prototype._focus_keyPress=function(t){
this._clearTooltip();
t||(t=window.event);
var e=new DwtKeyEvent();
e.setFromDhtmlEvent(t);
this._focus_handleKey(e,t);
e.setToDhtmlEvent(t);
return e._returnValue
};
ZmSpreadSheet.prototype._input_mouseUp=function(){
this._displayRangeIfAny()
};
ZmSpreadSheet.prototype._input_keyPress=function(o){
o||(o=window.event);
var e=true;
if(o){
var i=new DwtKeyEvent();
i.setFromDhtmlEvent(o);
var a=this._getInputField();
this._preventSaveOnBlur=true;
switch(o.keyCode){
case 9:e=false;
this._save_value(a.value);
a.blur();
this._focus_handleKey(i,o);
break;
case 37:case 39:var s=(!a._caretMoved&&((Dwt.getSelectionStart(a)==0&&i.keyCode==37)||(Dwt.getSelectionEnd(a)==a.value.length&&i.keyCode==39)));
if(s||!a.value||o.altKey){
e=false;
this._save_value(a.value);
a.blur();
this._focus_handleKey(i,o)
}else{
a._caretMoved=true
}
break;
case 38:case 13:case 40:e=false;
this._save_value(a.value);
a.blur();
this._focus_handleKey(i,o);
break;
case 27:e=false;
if(AjxEnv.isIE){
var n=this.getCellModel(this._editingCell);
a.setValue(n.getEditValue())
}
this.focus();
break;
case 113:Dwt.setSelectionRange(a,0,a.value.length);
break
}
i.setToDhtmlEvent(o);
this._preventSaveOnBlur=false
}
if(e){
if(this._input_keyPress_timer){
clearTimeout(this._input_keyPress_timer)
}
var t=this;
this._input_keyPress_timer=setTimeout(function(){
var l=t._getSpanField();
var r=t._getInputField();
l.innerHTML="";
l.appendChild(document.createTextNode(r.value));
if(l.offsetWidth>(r.offsetWidth-20)){
r.style.width=l.offsetWidth+50+"px"
}
t._input_keyPress_timer=null;
t._displayRangeIfAny();
for(var h=t.onInputModified.length;
--h>=0;
){
t.onInputModified[h].run(r.value)
}}
,10)
}else{
this._hideRange()
}};
ZmSpreadSheet.prototype._selectRange=function(o,i,r){
this._selectedRangeName=null;
var e=r||(o.toLowerCase()!=i.toLowerCase());
o=ZmSpreadSheetModel.identifyCell(o);
i=ZmSpreadSheetModel.identifyCell(i);
if(e&&o&&i){
var a=Math.min(o.row,i.row);
var s=Math.min(o.col,i.col);
var t=Math.max(o.row,i.row);
var n=Math.max(o.col,i.col);
this._showRange(a,s,t,n)
}else{
this._hideRange()
}};
ZmSpreadSheet.prototype._displayRangeIfAny=function(){
var d=this._getInputField();
this._hasExpression=/^=(.*)$/.test(d.value);
if(!this._hasExpression){
this._hideRange();
return
}
var u=RegExp.$1;
var e=Dwt.getSelectionStart(d),l=Dwt.getSelectionEnd(d);
try{
if(e>0){
--e
}
if(l>0){
--l
}
var h=ZmSpreadSheetFormulae.parseTokens(u,true);
var m=null;
for(var n=0;
n<h.length;
++n){
var s=h[n];
if(s.strPos<=e&&s.strPos+s.strLen>=l&&(s.type===ZmSpreadSheetFormulae.TOKEN.CELL||s.type===ZmSpreadSheetFormulae.TOKEN.CELLRANGE)){
m=s;
break
}}
this._rangeToken=m;
if(m){
var o,t;
if(m.type===ZmSpreadSheetFormulae.TOKEN.CELL){
o=t=m.val
}
if(m.type===ZmSpreadSheetFormulae.TOKEN.CELLRANGE){
var c=m.val.split(/:/);
o=c[0];
t=c[1]
}
this._selectRange(o,t,true)
}else{
throw"HIDE"
}}
catch(r){
this._hideRange()
}};
ZmSpreadSheet.prototype._showRange=function(d,t,n,l){
this._model.checkBounds(d,t);
this._model.checkBounds(n,l);
var i=this._getTable().rows[d+1];
var a=this._getTable().rows[n+1];
if(!i||!a){
this._hideRange()
}
var s=i.cells[t+1];
var o=a.cells[l+1];
if(!s||!o){
this._hideRange()
}
this._selectedRangeName=[ZmSpreadSheet.getCellName(s),ZmSpreadSheet.getCellName(o)].join(":");
var e=this._getRangeDiv();
var c=o.offsetTop+o.offsetHeight-s.offsetTop;
var r=o.offsetLeft+o.offsetWidth-s.offsetLeft;
if(AjxEnv.isIE){
c+=2;
r+=2
}
e.style.display="none";
e.style.height=c+"px";
e.style.width=r+"px";
e.style.left=s.offsetLeft-1+"px";
e.style.top=s.offsetTop-1+"px";
e.style.display=""
};
ZmSpreadSheet.prototype._getRangeDiv=function(){
if(!this._rangeDivID){
this._rangeDivID=Dwt.getNextId()
}
var e=document.getElementById(this._rangeDivID);
if(!e){
var e=document.createElement("div");
e.id=this._rangeDivID;
e.className="ShowRange";
e.style.display="none";
this._getRelDiv().appendChild(e);
e.onmousedown=AjxCallback.simpleClosure(this._rangediv_mousedown,this);
e.onmousemove=AjxCallback.simpleClosure(this._rangediv_mousemove,this)
}
return e
};
ZmSpreadSheet.prototype._rangediv_mousemove=function(ev){
if(this._selectRangeCapture.capturing()){
return
}
var dwtev=new DwtMouseEvent(ev);
dwtev.setFromDhtmlEvent(ev);
var html=["<div class='ZmSpreadSheet-Tooltip'>","<div class='CellName'>",ZmMsg.cellRange+" - "+this._selectedRangeName,"</div>"];
var g=ZmSpreadSheetModel.getRangeGeometry(this._selectedRangeName);
html.push("<div class='CellDesc'>[ ",g.rows," rows x ",g.cols," cols = ",g.rows*g.cols," cells ]</div>");
try{
var formula=new ZmSpreadSheetFormulae(this._model,"sum("+this._selectedRangeName+")");
html.push("Sum: ",formula.eval())
}
catch(ex){}
html.push("</div>");
this._setTooltip(html.join(""),dwtev.docX,dwtev.docY)
};
ZmSpreadSheet.prototype._rangediv_mousedown=function(t){
this._clearTooltip();
var e=new DwtUiEvent(t);
e.setFromDhtmlEvent(t);
this._hideRange();
e._stopPropagation=true;
e._returnValue=false;
e.setToDhtmlEvent(t)
};
ZmSpreadSheet.prototype._hideRange=function(){
this._shiftRangeStart=null;
this._selectedRangeName=null;
var e=this._getRangeDiv();
e.style.display="none";
e.style.top="0px";
e.style.left="0px";
e.style.width="5px";
e.style.height="5px"
};
ZmSpreadSheet.prototype._table_selrange_MouseOver=function(a){
var e=new DwtMouseEvent();
e.setFromDhtmlEvent(a);
var t=this._getTable();
var i=DwtUiEvent.getTarget(e);
while(i&&i!==t&&!/^td$/i.test(i.tagName)){
i=i.parentNode
}
if(i&&/^td$/i.test(i.tagName)&&i.cellIndex>0&&i.parentNode.rowIndex>0){
this._selectRange(ZmSpreadSheet.getCellName(this._selectedCell),ZmSpreadSheet.getCellName(i),false);
this._updateCellRangeToken()
}
e._stopPropagation=true;
e._returnValue=false;
e.setToDhtmlEvent(a);
return e._returnValue
};
ZmSpreadSheet.prototype._updateCellRangeToken=function(){
if(this._editingCell&&this._hasExpression){
var a=this._selectedRangeName||ZmSpreadSheet.getCellName(this._selectedCell);
var t=this._getInputField();
var e=this._rangeToken;
if(!e){
e={
strPos:Dwt.getSelectionStart(t)};
e.strLen=Dwt.getSelectionEnd(t)-e.strPos;
e.strPos--
}
Dwt.setSelectionRange(t,e.strPos+1,e.strPos+e.strLen+1);
e.strLen=a.length;
Dwt.setSelectionText(t,a);
a=e.strPos+e.strLen+1;
Dwt.setSelectionRange(t,a,a);
this._displayRangeIfAny()
}};
ZmSpreadSheet.prototype._clear_selectRangeCapture=function(e){
this._selectRangeCapture.release();
if(this._editingCell){
this._selectCell(this._editingCell)
}};
ZmSpreadSheet.prototype._table_onMouseUp=function(e){
if(this._editingCell&&!this._hasExpression){
this._getInputField().blur()
}};
ZmSpreadSheet.prototype._setTooltip=function(t,e,o){
var i=DwtShell.getShell(window);
var a=i.getHoverMgr();
if(!a.isHovering()){
a.reset();
a.setHoverOverDelay(ZmSpreadSheet.TOOLTIP_DELAY);
if(typeof t=="object"){
a.setHoverOverData(t.getTooltipText())
}else{
a.setHoverOverData(t)
}
a.setHoverOverListener(this._hoverOverListener);
a.hoverOver(e,o)
}};
ZmSpreadSheet.prototype._handleOverListener=function(t){
var e=DwtShell.getShell(window);
var i=t.object;
var a=e.getToolTip();
a.setContent(i);
a.popup(t.x,t.y)
};
ZmSpreadSheet.prototype._handleOutListener=function(t){
var e=DwtShell.getShell(window);
var a=e.getToolTip();
a.popdown()
};
ZmSpreadSheet.prototype._clearTooltip=function(){
var t=DwtShell.getShell(window);
var e=t.getHoverMgr();
e.setHoverOutDelay(0);
e.setHoverOutData(null);
e.setHoverOutListener(this._hoverOutListener);
e.hoverOut()
};
ZmSpreadSheet.prototype._table_mouseOut=function(){
this._clearTooltip()
};
ZmSpreadSheet.prototype._table_mouseMove=function(o){
if(this._editingCell||this._selectRangeCapture.capturing()){
return
}
var a=new DwtMouseEvent();
a.setFromDhtmlEvent(o);
var i=this._getTable();
var n=DwtUiEvent.getTarget(a);
while(n&&n!==i&&!/^td$/i.test(n.tagName)){
n=n.parentNode
}
if(n&&/^td$/i.test(n.tagName)){
try{
var e=this.getCellModel(n);
this._setTooltip(e,a.docX,a.docY)
}
catch(t){}}};
ZmSpreadSheet.prototype._table_onClick=function(a){
this._clearTooltip();
var e=new DwtMouseEvent();
e.setFromDhtmlEvent(a);
var t=this._getTable();
var o=DwtUiEvent.getTarget(e);
while(o&&o!==t&&!/^td$/i.test(o.tagName)){
o=o.parentNode
}
if(o&&/^td$/i.test(o.tagName)){
var i=o.parentNode;
if(i.rowIndex==0){
if(o.cellIndex==0){
this._topLeftCellClicked(o,e)
}else{
this._topCellClicked(o,e)
}}else{
if(o.cellIndex==0){
this._leftCellClicked(o,e)
}else{
this._cellClicked(o,e)
}}}
e.setToDhtmlEvent(a);
return e._returnValue
};
ZmSpreadSheet.prototype._getTable=function(){
return document.getElementById(this._tableID)
};
ZmSpreadSheet.prototype._onResize=function(o){
var i=this.getHtmlElement();
var t=this._getRelDiv();
t.style.display="none";
var a=i.offsetHeight;
t.style.display="";
a-=t.offsetTop+2;
var e=o.requestedWidth;
if(AjxEnv.isIE){
e-=2
}
var n=t.nextSibling;
while(n){
a-=n.offsetHeight;
n=n.nextSibling
}
t.style.height=a+"px";
t.style.width=e+"px"
};
ZmSpreadSheet.prototype.getSelectionRange=function(){
var e=this._selectedRangeName;
if(!e&&this._selectedCell){
e=ZmSpreadSheet.getCellName(this._selectedCell);
e+=":"+e
}
return e
};
ZmSpreadSheet.prototype.getSelectedCellModel=function(){
if(this._selectedCell){
return this.getCellModel(this._selectedCell)
}
return null
};
ZmSpreadSheet.prototype.clipboardCopy=function(){
window.top._ZmSpreadSheet_clipboard=new ZmSpreadSheetClipboard(this._model,this.getSelectionRange(),false)
};
ZmSpreadSheet.prototype.clipboardCut=function(){
window.top._ZmSpreadSheet_clipboard=new ZmSpreadSheetClipboard(this._model,this.getSelectionRange(),true)
};
ZmSpreadSheet.prototype.clipboardPaste=function(){
var t=window.top._ZmSpreadSheet_clipboard;
if(t){
var e=this._model.paste(t,this.getSelectionRange());
this._selectRange.apply(this,e)
}}
}
if(AjxPackage.define("zimbraMail.ale.spreadsheet.ZmSpreadSheetModel")){
ZmSpreadSheetModel=function(a,o){
this.ROWS=a;
this.COLS=o;
this.version=1;
var s=this.data=new Array(a);
for(var t=0;
t<a;
++t){
var n=s[t]=new Array(o);
for(var e=0;
e<o;
++e){
n[e]=new ZmSpreadSheetCellModel(this)
}}
this.colProps=new Array(o);
for(var t=0;
t<o;
++t){
this.colProps[t]=ZmSpreadSheetModel.getDefaultColProp()
}
this._expressionCells=[];
this.reset()
};
ZmSpreadSheetModel.DEBUG=false;
ZmSpreadSheetModel.getDefaultColProp=function(){
var e={
width:100};
return e
};
ZmSpreadSheetModel.getCellName=function(t,e){
return ZmSpreadSheetModel.getColName(e)+t
};
ZmSpreadSheetModel.getRangeName=function(t,i,e,a){
return ZmSpreadSheetModel.getCellName(t,i)+":"+ZmSpreadSheetModel.getCellName(e,a)
};
ZmSpreadSheetModel.getColName=function(e){
--e;
var t=[];
do{
t.unshift(String.fromCharCode(65+e%26));
e=Math.floor(e/26)
}
while(e>0);
return t.join("")
};
ZmSpreadSheetModel.identifyCell=function(n){
if(/^([a-z]+)([0-9]+)$/i.test(n)){
var t=RegExp.$1.toUpperCase();
var e=parseInt(RegExp.$2);
var o=0;
for(var a=0;
a<t.length;
++a){
o*=26;
o+=t.charCodeAt(a)-64
}
return{
row:e-1,col:o-1}
}
throw"Can't parse cell identifier "+n+" at ZmSpreadSheetModel.identifyCell"
};
ZmSpreadSheetModel.getRangeBounds=function(o){
var e=o.split(/:/);
var s=ZmSpreadSheetModel.identifyCell(e[0]);
var n=ZmSpreadSheetModel.identifyCell(e[1]);
var i=Math.min(s.row,n.row);
var h=Math.min(s.col,n.col);
var t=Math.max(s.row,n.row);
var r=Math.max(s.col,n.col);
return[{
row:i,col:h}
,{
row:t,col:r}
]
};
ZmSpreadSheetModel.shiftCell=function(e,t,a){
var i=ZmSpreadSheetModel.identifyCell(e);
i.row+=t;
i.col+=a;
return ZmSpreadSheetModel.getCellName(i.row+1,i.col+1)
};
ZmSpreadSheetModel.shiftRange=function(t,i,o){
var e=t.split(/:/);
return ZmSpreadSheetModel.shiftCell(e[0],i,o)+":"+ZmSpreadSheetModel.shiftCell(e[1],i,o)
};
ZmSpreadSheetModel.getRangeGeometry=function(e){
var t=ZmSpreadSheetModel.getRangeBounds(e);
return{
rows:t[1].row-t[0].row+1,cols:t[1].col-t[0].col+1,bounds:t}
};
ZmSpreadSheetModel.prototype.getCellsInRange=function(s){
var e=ZmSpreadSheetModel.getRangeBounds(s);
var h=e[0].row;
var t=e[0].col;
var o=e[1].row;
var r=e[1].col;
var l=[];
for(var n=h;
n<=o;
++n){
for(var a=t;
a<=r;
++a){
l.push(this.data[n][a])
}}
return l
};
ZmSpreadSheetModel.prototype.forEachCell=function(e,o,n){
var t=this.getCellsInRange(e);
for(var a=0;
a<t.length;
++a){
o.apply(n,[t[a],a,t])
}};
ZmSpreadSheetModel.prototype.insertRow=function(t){
if(t==null){
t=this.ROWS
}
var a=new Array(this.COLS);
for(var e=this.COLS;
--e>=0;
){
a[e]=new ZmSpreadSheetCellModel(this)
}
this.data.splice(t,0,a);
++this.ROWS;
this.triggerEvent("onInsertRow",a,t);
this.recompute()
};
ZmSpreadSheetModel.prototype.insertCol=function(a){
if(a==null){
a=this.COLS
}
var e=new Array(this.ROWS);
for(var t=this.ROWS;
--t>=0;
){
var o=new ZmSpreadSheetCellModel(this);
e[t]=o;
this.data[t].splice(a,0,o)
}
this.colProps.splice(a,0,ZmSpreadSheetModel.getDefaultColProp());
++this.COLS;
this.triggerEvent("onInsertCol",e,a);
this.recompute()
};
ZmSpreadSheetModel.prototype.deleteRow=function(a){
if(this.ROWS>1){
var e=this.data[a];
for(var t=e.length;
--t>=0;
){
if(e[t]._expr){
e[t].setExpression(null)
}
e[t]._td=null
}
this.data.splice(a,1);
--this.ROWS;
this.triggerEvent("onDeleteRow",a);
this.recompute()
}};
ZmSpreadSheetModel.prototype.deleteCol=function(t){
if(this.COLS>1){
for(var a=this.ROWS;
--a>=0;
){
var e=this.data[a][t];
if(e._expr){
e.setExpression(null)
}
this.data[a].splice(t,1);
e._td=null
}
this.colProps.splice(t,1);
--this.COLS;
this.triggerEvent("onDeleteCol",t);
this.recompute()
}};
ZmSpreadSheetModel.prototype.getColWidth=function(e){
return this.colProps[e].width
};
ZmSpreadSheetModel.prototype.setColWidth=function(t,o){
this.colProps[t].width=o;
for(var a=0;
a<this.data.length;
++a){
var e=this.data[a][t];
e.setWidth(o)
}};
ZmSpreadSheetModel.prototype.checkBounds=function(t,e){
if(t<0||t>this.ROWS-1){
throw"Row out of bounds"
}
if(e<0||e>this.COLS-1){
throw"Col out of bounds"
}};
ZmSpreadSheetModel.prototype.reset=function(){
this._viewEvents={}
};
ZmSpreadSheetModel.prototype.triggerEvent=function(e){
var o=this._viewEvents[e];
if(!o){
return null
}
var t=new Array(arguments.length-1);
for(var a=1;
a<arguments.length;
++a){
t[a-1]=arguments[a]
}
o.run.apply(o,t)
};
ZmSpreadSheetModel.prototype.setViewListener=function(e,t){
this._viewEvents[e]=t
};
ZmSpreadSheetModel.prototype.getCell=function(t,e){
return this.data[t-1][e-1]
};
ZmSpreadSheetModel.prototype.getCellByID=function(e){
var t=ZmSpreadSheetModel.identifyCell(e);
return this.data[t.row][t.col]
};
ZmSpreadSheetModel.prototype._orderExpressionCells=function(n){
var i=[];
var s={};
var t=n||this._expressionCells;
while(t.length>0){
var e=t.shift();
var o=e.getName();
if(e._expr&&!s[o]){
t.unshift.apply(t,e._expr.dependsArray());
s[o]=true;
i.push(e)
}}
if(!n){
this._expressionCells=i
}
return i
};
ZmSpreadSheetModel.prototype.recompute=function(o){
for(var a=this._expressionCells.length;
--a>=0;
){
var e=this._expressionCells[a];
try{
e.updateExpression()
}
catch(t){
e._td.firstChild.innerHTML="#REF"
}}};
ZmSpreadSheetModel.prototype.paste=function(r,f){
var n=r.geometry;
var m=r.bounds;
var t=ZmSpreadSheetModel.getRangeGeometry(f);
var u=t.bounds;
var h;
if(t.rows<n.rows){
t.rows=n.rows
}else{
t.rows-=t.rows%n.rows
}
if(t.cols<n.cols){
t.cols=n.cols
}else{
t.cols-=t.cols%n.cols
}
u[1].row=u[0].row+t.rows-1;
u[1].col=u[0].col+t.cols-1;
r.setDelta(u[0].row-m[0].row,u[0].col-m[0].col);
for(h=u[1].row-this.ROWS;
h-->=0;
){
this.insertRow()
}
for(h=u[1].col-this.COLS;
h-->=0;
){
this.insertCol()
}
var a=0;
var o=0;
var l=[];
for(var h=u[0].row;
h<=u[1].row;
++h){
var e=0;
var p=0;
for(var s=u[0].col;
s<=u[1].col;
++s){
var d=this.data[h][s];
r.paste(a,e,d,o,p);
l.push(d);
e++;
if(e==n.cols){
p+=n.cols;
e=0
}}
a++;
if(a==n.rows){
o+=n.rows;
a=0
}}
var c=this._orderExpressionCells(l);
for(var h=0;
h<c.length;
++h){
c[h].recompute()
}
return[ZmSpreadSheetModel.getCellName(u[0].row+1,u[0].col+1),ZmSpreadSheetModel.getCellName(u[1].row+1,u[1].col+1)]
};
ZmSpreadSheetModel.serializeJSObject=function(a){
var e;
var o=ZmSpreadSheetModel.DEBUG?",\n":",";
switch(typeof a){
case"object":if(a==null){
e="null"
}else{
if(a.serialize&&typeof a.serialize=="function"){
e=a.serialize()
}else{
if(a instanceof Array){
e=new Array(a.length);
for(var t=0;
t<a.length;
++t){
e[t]=this.serializeJSObject(a[t])
}
e=["[",e.join(o),"]"].join("")
}else{
e=new Array();
for(var t in a){
e.push(['"',t.replace(/\x22/g,"\\x22"),'":',this.serializeJSObject(a[t])].join(""))
}
e=["{",e.join(o),"}"].join("")
}}}
break;
case"string":e=a.replace(/\n/g,"\\n").replace(/\x5c/g,"\\x5c").replace(/\x22/g,'\\"');
e=['"',e,'"'].join("");
break;
default:e=a
}
return e
};
ZmSpreadSheetModel.deserializeJSObject=function(str){
var tmp=str.replace(/(\x22(\\.|[^\x22\\])*\x22|\x27(\\.|[^\x27\\])*\x27)/g,"");
var forbid=ZmSpreadSheetModel.DEBUG?/([;()+=\x2f*.-])/g:/([\n;()+=\x2f*.-])/g;
if(forbid.test(tmp)){
throw new DwtException("Can't deserialize in ZmSpreadSheetModel: "+RegExp.$1+" characters not allowed.")
}
try{
var foo;
eval(["foo=",str].join(""));
return foo
}
catch(ex){
throw new DwtException("Can't deserialize in ZmSpreadSheetModel: malformed data\n[ "+ex+" ]")
}};
ZmSpreadSheetModel.prototype.serialize=function(){
var e={
ROWS:this.ROWS,COLS:this.COLS,version:1,colProps:this.colProps,data:this.data};
return ZmSpreadSheetModel.serializeJSObject(e)
};
ZmSpreadSheetModel.prototype.deserialize=function(s){
var a=ZmSpreadSheetModel.deserializeJSObject(s);
this.ROWS=a.ROWS;
this.COLS=a.COLS;
this.colProps=a.colProps;
this.version=a.version||0;
var o=this.data=a.data;
for(var t=0;
t<this.ROWS;
++t){
var n=o[t];
for(var e=0;
e<this.COLS;
++e){
n[e]=ZmSpreadSheetCellModel.deserialize(this,n[e])
}}};
ZmSpreadSheetModel.prototype.loadFromXml=function(h){
var a=AjxXmlDoc.createFromXml(h);
if(a){
var u=a.toJSObject(false,false,true);
if(!u){
return
}
var r=(u&&u.Worksheet)?u.Worksheet:null;
var p=(r&&r.ColProps)?r.ColProps:null;
var c=(r&&r.Table)?r.Table:null;
var f=(c&&c.Row)?c.Row:[];
this.ROWS=(c&&c.ExpandedRowCount)?c.ExpandedRowCount:0;
this.COLS=(c&&c.ExpandedColumnCount)?c.ExpandedColumnCount:0;
this.colProps=(p&&p.Col)?p.Col:[];
this.version=(r&&r.version)?r.version:0;
var n=this.data=new Array(this.ROWS);
var s=null;
var o=null;
for(var t=0;
t<this.ROWS;
++t){
if(!f||!f[t]){
continue
}
var l=f[t].Cell;
if(!l){
continue
}
var m=n[t]=new Array(this.COLS);
for(var e=0;
e<this.COLS;
++e){
if(!l[e]){
continue
}
s=l[e];
o={
row:s.row,col:s.col,type:s.type,decimals:s.decimals,editValue:s.editValue,style:s.Style};
m[e]=ZmSpreadSheetCellModel.deserialize(this,o)
}}}};
ZmSpreadSheetModel.prototype.doneSetView=function(){
var r=this.data;
for(var s=0;
s<this.ROWS;
++s){
var h=r[s];
for(var n=0;
n<this.COLS;
++n){
var e=h[n];
e.setEditValue(e._editValue,true)
}}
this._orderExpressionCells();
var t=this._expressionCells;
if(ZmSpreadSheetModel.DEBUG){
var o=[];
for(var s=0;
s<t.length;
++s){
o[s]=t[s].getName()
}
console.log("Computing: %s",o.join(", "))
}
for(var s=0;
s<t.length;
++s){
t[s].recompute()
}};
ZmSpreadSheetModel.prototype.getHtml=function(){
var a=["<table style='font: 8pt tahoma,verdana,sans-serif; background-color: #fff; border-collapse: collapse'>"];
for(var t=0;
t<this.ROWS;
++t){
a.push("<tr>");
for(var e=0;
e<this.COLS;
++e){
a.push(this.data[t][e].getHtml())
}
a.push("</tr>")
}
a.push("</table>");
return a.join("")
};
ZmSpreadSheetModel.prototype.getXml=function(){
var t=AjxXmlDoc.createRoot("Workbook");
var l=AjxXmlDoc.createElement("Worksheet");
l.root.setAttribute("version",1);
var e=AjxXmlDoc.createElement("ColProps");
for(var n=0;
n<this.COLS;
++n){
var a=AjxXmlDoc.createElement("Col");
a.root.setAttribute("width",this.colProps[n].width);
e.appendChild(a)
}
l.appendChild(e);
var s=AjxXmlDoc.createElement("Table");
s.root.setAttribute("ExpandedRowCount",this.ROWS);
s.root.setAttribute("ExpandedColumnCount",this.COLS);
var h=null;
for(var n=0;
n<this.ROWS;
++n){
rowN=AjxXmlDoc.createElement("Row");
for(var o=0;
o<this.COLS;
++o){
var r=this.data[n][o].getXml(n+1,o+1);
rowN.appendChild(r)
}
s.appendChild(rowN)
}
l.appendChild(s);
t.appendChild(l);
return t
};
ZmSpreadSheetClipboard=function(n,o,t){
this._move=!!t;
this.model=n;
this.geometry=ZmSpreadSheetModel.getRangeGeometry(o);
this.range=o;
this.bounds=this.geometry.bounds;
var e=this.cells=n.getCellsInRange(o);
if(!t){
for(var s=e.length;
--s>=0;
){
e[s]=e[s].clone()
}}};
ZmSpreadSheetClipboard.prototype.getCell=function(t,e){
return this.cells[t*this.geometry.cols+e]
};
ZmSpreadSheetClipboard.prototype.setDelta=function(e,t){
this.delta={
rows:e,cols:t}
};
ZmSpreadSheetClipboard.prototype.paste=function(d,a,l,o,c){
var t=this.getCell(d,a);
for(var s in t._style){
l._style[s]=t._style[s]
}
if(t._expr){
var r=t._expr;
var n=r.shift(this.delta.rows+o,this.delta.cols+c);
l._type=t._type;
l._decimals=t._decimals;
l.setEditValue("="+n)
}else{
l._type=t._type;
l._autoType=t._autoType;
l._decimals=t._decimals;
l.setEditValue(t.getEditValue())
}
if(this._move&&!t._wasCut){
var h=t.clone();
this.cells[d*this.geometry.cols+a]=h;
h._wasCut=true;
t.clearAll()
}};
ZmSpreadSheetCellModel=function(t,i,e,a){
if(e==null){
e=""
}
if(i==null){
i=null
}
this._model=t;
this._td=null;
this._decimals=null;
this._type=i;
this._autoType=null;
this._editValue=e;
this._value=e;
this._style=ZmSpreadSheetCellModel.getDefaultStyle(a);
this._expr=null;
this._affects=[]
};
ZmSpreadSheetCellModel.defaultStyle={
fontFamily:"",fontWeight:"",fontStyle:"",fontSize:"",backgroundColor:"",color:"",textAlign:"",verticalAlign:"",textDecoration:""};
ZmSpreadSheetCellModel.prototype.serialize=function(){
var e={
decimals:this._decimals,type:this._type,editValue:this._editValue,style:this._style,row:this.getRow(),col:this.getCol()};
return ZmSpreadSheetModel.serializeJSObject(e)
};
ZmSpreadSheetCellModel.deserialize=function(t,a){
var e=new ZmSpreadSheetCellModel(t,a.type,a.editValue,a.style);
e._decimals=a.decimals;
e._savedRow=a.row;
e._savedCol=a.col;
return e
};
ZmSpreadSheetCellModel.getDefaultStyle=function(a){
if(!a){
a={}
}
var t=ZmSpreadSheetCellModel.defaultStyle;
for(var e in t){
if(typeof a[e]=="undefined"){
a[e]=t[e]
}}
return a
};
ZmSpreadSheetCellModel.prototype.clone=function(){
var t=new ZmSpreadSheetCellModel(null);
t._decimals=this._decimals;
t._type=this._type;
t._autoType=this._autoType;
t._editValue=this._editValue;
t._value=this._value;
t._expr=this._expr;
for(var e in this._style){
t._style[e]=this._style[e]
}
return t
};
ZmSpreadSheetCellModel.prototype.setWidth=function(e){
if(this._td){
var t=-2;
this._td.firstChild.style.width=e+t+"px"
}};
ZmSpreadSheetCellModel.prototype.getHtml=function(){
var n=[];
for(var a in this._style){
if(this._style[a]!=""){
var e=a.replace(/([a-z])([A-Z])([a-z])/g,function(l,h,r,i){
return h+"-"+r.toLowerCase()+i
}
);
n.push(e+":"+this._style[a])
}}
var o=this._model.getColWidth(this.getCol()-1);
if(AjxEnv.isIE){
o-=2
}
n.push("width:"+o+"px");
n.push("border:1px solid #aaa");
if(n.length>0){
n=[" style='",n.join(";"),"'"].join("")
}else{
n=""
}
var t=this.getType();
if(t){
var t=" class='SpreadSheet-Type-"+t+"'"
}else{
t=""
}
var s=AjxStringUtil.htmlEncode(this.getDisplayValue().toString());
if(s==""){
s="&nbsp;"
}
return["<td",t,n,">",s,"</td>"].join("")
};
ZmSpreadSheetCellModel.prototype.getXml=function(s,t){
var r=AjxXmlDoc.createElement("Style");
for(var a in this._style){
if(this._style[a]!=""){
var e=a;
if(e!="toString"){
r.root.setAttribute(e,this._style[a])
}}}
var n=AjxXmlDoc.createElement("Cell");
var o=n.root;
o.setAttribute("row",s);
o.setAttribute("col",t);
o.setAttribute("editValue",(this._editValue?this._editValue:""));
o.setAttribute("decimals",(this._decimals?this._decimals:""));
o.setAttribute("type",(this._type?this._type:""));
n.appendChild(r);
return n
};
ZmSpreadSheetCellModel.prototype.setToElement=function(t){
var i=t.firstChild;
if(!i){
t.innerHTML="<div class='Wrapper'></div>";
i=t.firstChild
}
var a=this.getDisplayValue();
if(!/\S/.test(a)){
a="\xA0"
}else{
a=a.toString().replace(/\s/g,"\xA0")
}
i.innerHTML="";
i.appendChild(document.createTextNode(a));
if(AjxEnv.isGeckoBased){
i.style.overflow="visible"
}
this.setStyleToElement(t);
if(this._expr){
Dwt.addClass(t,"hasFormula")
}else{
Dwt.delClass(t,"hasFormula")
}
var e=this.getType();
if(e){
t.className=t.className.replace(/(^|\s)SpreadSheet-Type-.*?(\s|$)/g," ");
Dwt.addClass(t,"SpreadSheet-Type-"+e)
}
i.style.width=this._model.getColWidth(this.getCol()-1)-2+"px"
};
ZmSpreadSheetCellModel.prototype.setStyleToElement=function(a,e){
for(var t in this._style){
var o=this._style[t];
switch(t){
default:a.style[t]=o
}}};
ZmSpreadSheetCellModel.prototype._mkDeps=function(){
var a=[];
var t={};
function e(o){
var n=o._affects,r=0,h,s;
while(h=n[r++]){
s=h.getName();
if(!t[s]){
t[s]=true;
e(h);
a.unshift(h)
}}}
e(this);
return a
};
ZmSpreadSheetCellModel.prototype.setValue=function(n,t){
if(!this._settingValue){
this._settingValue=true;
this._value=n;
this._model.triggerEvent("onCellValue",this.getRow(),this.getCol(),this);
if(!t){
var e=this._mkDeps();
for(var o=0;
o<e.length;
++o){
e[o].recompute()
}}
this._settingValue=false
}};
ZmSpreadSheetCellModel.prototype.getValue=function(){
switch(this.getType()){
case"currency":case"percentage":case"number":return ZmSpreadSheetFormulae.parseFloat(this._value)
}
return this._value
};
ZmSpreadSheetCellModel.prototype.getDisplayValue=function(){
var t=this.getValue();
var e=this.getType();
switch(e){
case"number":if(!/\S/.test(this._editValue)){
t=""
}else{
t=ZmSpreadSheetFormulae.parseFloat(t);
if(this._decimals!=null){
t=t.toFixed(this._decimals)
}}
break;
case"currency":t=ZmSpreadSheetFormulae.parseFloat(t);
if(this._decimals!=null){
t=t.toFixed(this._decimals)
}
t="$"+t;
break;
case"percentage":t=ZmSpreadSheetFormulae.parseFloat(t);
if(this._decimals!=null){
t=t.toFixed(this._decimals)
}
t=t+"%";
break
}
return t
};
ZmSpreadSheetCellModel.prototype.setExpression=function(s){
var e=this._model._expressionCells;
for(var n=e.length;
--n>=0;
){
if(e[n]===this){
e.splice(n,1)
}}
if(this._expr){
var r=this._expr.depends();
for(var n in r){
var t=r[n]._affects;
for(var o=t.length;
--o>=0;
){
if(t[o]===this){
t.splice(o,1)
}}}}
this._expr=s;
if(s){
e.push(this);
var r=this._expr.depends();
for(var n in r){
r[n]._affects.push(this)
}}};
ZmSpreadSheetCellModel.prototype.recompute=function(){
this.setValue(this._expr.eval(),true)
};
ZmSpreadSheetCellModel.prototype.updateExpression=function(){
if(this._expr){
var e=this._expr.update();
if(e){
this._editValue="="+e;
this.recompute()
}}};
ZmSpreadSheetCellModel.prototype._determineType=function(a){
var t=a;
var e=null;
if(/^\x27(.*)$/.test(a)){
e="string";
t=RegExp.$1
}else{
if(/^=(.+)$/.test(a)){
t=RegExp.$1;
if(/\S/.test(t)){
e="expression"
}else{
t=a
}}else{
if(/^([0-9]*\.?[0-9]+)$/.test(a)){
e="number";
t=RegExp.$1
}else{
if(/^\$\s*([0-9]*\.?[0-9]+)$/.test(a)||/^([0-9]*\.?[0-9]+)\$$/.test(a)){
e="currency";
t=RegExp.$1;
if(this._decimals==null){
this._decimals=2
}}else{
if(/^([0-9]*\.?[0-9]+)\s*%$/.test(a)){
e="percentage";
t=RegExp.$1
}}}}}
return{
type:e,val:t}
};
ZmSpreadSheetCellModel.prototype.getType=function(){
return this._type||this._autoType||"string"
};
ZmSpreadSheetCellModel.prototype.setType=function(e){
this._type=e;
if(e==null){
var t=this._determineType(this.getValue());
this._value=t.val;
this._type=t.type
}else{
if(e=="currency"&&this._decimals==null){
this._decimals=2
}}
if(this._td){
this.setToElement(this._td)
}};
ZmSpreadSheetCellModel.prototype.getDecimals=function(){
return this._decimals
};
ZmSpreadSheetCellModel.prototype.setDecimals=function(t){
this._decimals=t;
var e=this.getType();
if(e=="currency"&&t==null){
this._decimals=2
}
if(this._td){
this.setToElement(this._td)
}};
ZmSpreadSheetCellModel.prototype.clearValue=function(){
this._type=null;
this.setEditValue("")
};
ZmSpreadSheetCellModel.prototype.clearStyle=function(){
this._style=ZmSpreadSheetCellModel.getDefaultStyle();
if(this._td){
this.setStyleToElement(this._td)
}};
ZmSpreadSheetCellModel.prototype.clearAll=function(){
this._type=this._decimals=null;
this.clearStyle();
this.clearValue()
};
ZmSpreadSheetCellModel.prototype.setEditValue=function(editValue,force){
if(force||editValue!=this._editValue){
this._editValue=editValue;
var val=editValue;
var auto=this._determineType(editValue);
this._autoType=auto.type;
if(auto.type=="expression"){
var expr;
try{
expr=new ZmSpreadSheetFormulae(this._model,auto.val);
this._errorMessage=null
}
catch(ex){
expr=null;
this._errorMessage=ex;
val="#ERROR"
}
this.setExpression(expr);
if(expr){
val=expr.eval();
if(expr.decimals!=null&&this._decimals==null){
this._decimals=expr.decimals
}
auto=this._determineType(val);
this._autoType=expr.autoType||auto.type;
if(this._autoType=="currency"){
val=auto.val
}}else{
this._type=null;
this._autoType="error"
}}else{
this.setExpression(null);
val=auto.val;
if(auto.type=="string"){
if(!/^([\x27=]|\$?[0-9]+\.?[0-9]*$)/.test(val)){
this._editValue=editValue=val
}}}
this.setValue(val);
this._model.triggerEvent("onCellEdit",this.getRow(),this.getCol(),this)
}};
ZmSpreadSheetCellModel.prototype.getEditValue=function(){
return this._expr?"="+this._expr.getFormula():this._editValue
};
ZmSpreadSheetCellModel.prototype.getRow=function(){
if(this._td){
return this._td.parentNode.rowIndex
}else{
return this._savedRow
}};
ZmSpreadSheetCellModel.prototype.getCol=function(){
if(this._td){
return this._td.cellIndex
}else{
return this._savedCol
}};
ZmSpreadSheetCellModel.prototype._getTD=function(){
return this._td
};
ZmSpreadSheetCellModel.prototype.getName=function(){
if(this._td||(this._savedRow&&this._savedCol)){
return ZmSpreadSheetModel.getCellName(this.getRow(),this.getCol())
}else{
return"##"
}};
ZmSpreadSheetCellModel.prototype.setStyleProp=function(t,e){
this._style[t]=e;
if(this._td){
this.setStyleToElement(this._td)
}};
ZmSpreadSheetCellModel.prototype.getStyleProp=function(e){
return this._style[e]
};
ZmSpreadSheetCellModel.prototype.isEmpty=function(){
return this._editValue==""
};
ZmSpreadSheetCellModel.prototype.getTooltipText=function(){
var o=["<div class='ZmSpreadSheet-Tooltip'>","<div class='CellName'>",ZmMsg.cell," - ",this.getName(),"</div>"];
if(!this.isEmpty()){
o.push("<div class='CellType'>",ZmMsg.type,": ",this.getType(),"</div>")
}else{
o.push("<div class='CellType'>",ZmMsg.emptyCell,"</div>")
}
if(this._errorMessage){
o.push(ZmMsg.editValue,": ",this._editValue);
o.push("<div class='CellExprError'>",this._errorMessage,"</div>")
}else{
if(this._expr){
o.push(ZmMsg.expression,":");
o.push("<div class='CellExpr'>[",this._expr.toString(),"]</div>")
}}
if(ZmSpreadSheetModel.DEBUG){
var e=this._affects;
if(e.length>0){
o.push("Directly affects cells:<br />");
for(var t=0;
t<e.length;
++t){
o.push(e[t].getName()," ")
}
o.push("<br />")
}
e=this._mkDeps();
if(e.length>0){
o.push("Affects cells:<br />");
for(var t=0;
t<e.length;
++t){
o.push(e[t].getName()," ")
}
o.push("<br />")
}
var n=this._td.firstChild;
if(n.offsetWidth>=this._td.offsetWidth){
o.push("Value:","<div class='CellValue'>",this.getDisplayValue(),"</div>")
}}
o.push("</div>");
return o.join("")
}
}
if(AjxPackage.define("zimbraMail.ale.spreadsheet.ZmSpreadSheetFormulae")){
ZmSpreadSheetFormulae=function(e,t){
this._model=e;
if(t){
this.compile(t)
}};
ZmSpreadSheetFormulae.TOKEN={
STRING:{
match:{
exec:function(e){
if(!(/^([\x22\x27])/.test(e))){
return null
}
var a=RegExp.$1;
var t=false;
var n="";
for(var o=1;
o<e.length;
++o){
var s=e.charAt(o);
if(!t&&s=="\\"){
t=true
}else{
if(s==a&&!t){
return[e.substr(0,o+1),n]
}
if(t){
switch(s){
case"n":s="\n";
break;
case"t":s="\t";
break
}}
n+=s;
t=false
}}
throw"Unfinished string: "+e
}}
,getVal:function(e){
return e[1]
}
,isOpr:true,type:"string"}
,NUMBER:{
match:/^([0-9]*\.?[0-9]+)/,getVal:function(e){
return parseFloat(e[1],10)
}
,isOpr:true,isNumber:true,type:"number"}
,CURRENCY:{
match:/^\$\s*([0-9]*\.?[0-9]+)/,getVal:function(e){
return parseFloat(e[1],10)
}
,isOpr:true,isNumber:true,type:"currency"}
,CELLRANGE:{
match:/^([a-z]+[0-9]+:[a-z]+[0-9]+)/i,getVal:function(e){
return e[1].toUpperCase()
}
,isOpr:true,type:"cellrange"}
,CELL:{
match:/^([a-z]+[0-9]+)/i,getVal:function(e){
return e[1].toUpperCase()
}
,isOpr:true,type:"cell"}
,OPERATOR:{
match:/^(<=|>=|==|!=|lt|gt|eq|uc|lc|ne|&&|and|\|\||or|not|[-x*\/+%^.<>!])/,getVal:function(e){
return e[1]
}
,isOpr:false,type:"operator"}
,IDENTIFIER:{
match:/^([a-z_][a-z0-9_?]*)/i,getVal:function(e){
return e[1]
}
,isOpr:false,type:"identifier"}
,OPENPAREN:{
match:new RegExp("^\\("),getVal:function(e){
return e[0]
}
,isOpr:false,type:"openparen"}
,CLOSEPAREN:{
match:/^\)/,getVal:function(e){
return e[0]
}
,isOpr:false,type:"closeparen"}
,COMMA:{
match:new RegExp("^,"),getVal:function(e){
return e[0]
}
,isOpr:false,type:"comma"}};
ZmSpreadSheetFormulae.parseFloat=function(t,e){
if(typeof t=="boolean"){
return t?1:0
}
t=parseFloat(t,10);
if(isNaN(t)){
t=e?e:0
}
return t
};
ZmSpreadSheetFormulae.OPERATORS={
"+":{
priority:10,assoc:3,n_args:2}
,"-":{
priority:10,assoc:2,n_args:2}
,"*":{
priority:20,assoc:3,n_args:2}
,"/":{
priority:20,assoc:2,n_args:2}
,"%":{
priority:30,assoc:2,n_args:2}
,"^":{
priority:30,assoc:2,n_args:2}
,".":{
priority:5,assoc:2,n_args:2}
,lc:{
priority:5,assoc:1,n_args:1}
,uc:{
priority:5,assoc:1,n_args:1}
,x:{
priority:35,assoc:2,n_args:2}
,"<":{
priority:3,assoc:2,n_args:2}
,">":{
priority:3,assoc:2,n_args:2}
,"<=":{
priority:3,assoc:2,n_args:2}
,">=":{
priority:3,assoc:2,n_args:2}
,"==":{
priority:3,assoc:2,n_args:2}
,"!=":{
priority:3,assoc:2,n_args:2}
,lt:{
priority:3,assoc:2,n_args:2}
,gt:{
priority:3,assoc:2,n_args:2}
,eq:{
priority:3,assoc:2,n_args:2}
,ne:{
priority:3,assoc:2,n_args:2}
,"&&":{
priority:2,assoc:2,n_args:2}
,and:{
priority:2,assoc:2,n_args:2}
,"||":{
priority:2,assoc:2,n_args:2}
,or:{
priority:2,assoc:2,n_args:2}
,"!":{
priority:4,assoc:1,n_args:1}
,not:{
priority:4,assoc:1,n_args:1}};
ZmSpreadSheetFormulae.FUNCTIONS={};
ZmSpreadSheetFormulae.getFunc=function(e){
return ZmSpreadSheetFormulae.FUNCTIONS[e.toLowerCase()]
};
ZmSpreadSheetFormulae.HELP={};
ZmSpreadSheetFormulae.getHelp=function(t){
var a=ZmSpreadSheetFormulae.HELP[t];
var e=null;
if(a){
e=a.help;
if(a.args){
e+="<br />"+a.args
}}
return e
};
ZmSpreadSheetFormulae.DEF=function(a,t,h,e){
if(a instanceof Array){
var r=a[0];
var s;
ZmSpreadSheetFormulae.DEF(r,t,h,e);
if(e&&a.length>1){
var n={
alias:r};
for(s in e){
n[s]=e[s]
}
e=n
}
for(s=1;
s<a.length;
++s){
ZmSpreadSheetFormulae.DEF(a[s],t,h,e)
}}else{
var o={
name:a,n_args:t,func:h};
ZmSpreadSheetFormulae.FUNCTIONS[a.toLowerCase()]=o;
if(e){
ZmSpreadSheetFormulae.HELP[a]=e
}}};
ZmSpreadSheetFormulae.DEF(["sum","+"],-1,function(){
var e=0;
for(var t=arguments.length;
--t>=0;
){
e+=ZmSpreadSheetFormulae.parseFloat(arguments[t])
}
return e
}
,ZmMsg.SS.func.sum);
ZmSpreadSheetFormulae.DEF(["multiply","*"],-1,function(){
var e=1;
for(var t=arguments.length;
--t>=0;
){
e*=ZmSpreadSheetFormulae.parseFloat(arguments[t],1)
}
return e
}
,ZmMsg.SS.func.multiply);
ZmSpreadSheetFormulae.DEF(["modulo","%"],2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)%ZmSpreadSheetFormulae.parseFloat(e)
}
,ZmMsg.SS.func.modulo);
ZmSpreadSheetFormulae.DEF(["average","avg"],-1,function(){
var t=arguments.length;
var a=0;
for(var e=t;
--e>=0;
){
var o=arguments[e];
if(!/\S/.test(o)){
o=NaN
}
if(!isNaN(o)){
o=ZmSpreadSheetFormulae.parseFloat(o,NaN)
}
if(!isNaN(o)){
a+=o
}else{
--t
}}
return a/t
}
,ZmMsg.SS.func.average);
ZmSpreadSheetFormulae.DEF("PI",0,function(){
return Math.PI
}
,ZmMsg.SS.func.PI);
ZmSpreadSheetFormulae.DEF("sin",1,function(e){
return Math.sin(e)
}
,ZmMsg.SS.func.sin);
ZmSpreadSheetFormulae.DEF("cos",1,function(e){
return Math.cos(e)
}
,ZmMsg.SS.func.cos);
ZmSpreadSheetFormulae.DEF("tan",1,function(e){
return Math.tan(e)
}
,ZmMsg.SS.func.tan);
ZmSpreadSheetFormulae.DEF("round",1,function(e){
return Math.round(e)
}
,ZmMsg.SS.func.round);
ZmSpreadSheetFormulae.DEF("ceil",1,function(e){
return Math.ceil(e)
}
,ZmMsg.SS.func.ceil);
ZmSpreadSheetFormulae.DEF("floor",1,function(e){
return Math.floor(e)
}
,ZmMsg.SS.func.floor);
ZmSpreadSheetFormulae.DEF("abs",1,function(e){
return Math.abs(e)
}
,ZmMsg.SS.func.abs);
ZmSpreadSheetFormulae.DEF("sqrt",1,function(e){
return Math.sqrt(e)
}
,ZmMsg.SS.func.sqrt);
ZmSpreadSheetFormulae.DEF("exp",1,function(e){
return Math.exp(e)
}
,ZmMsg.SS.func.exp);
ZmSpreadSheetFormulae.DEF("log",1,function(e){
return Math.log(e)
}
,ZmMsg.SS.func.log);
ZmSpreadSheetFormulae.DEF("min",-1,function(){
var t=arguments[0];
for(var e=1;
e<arguments.length;
++e){
if(t>arguments[e]){
t=arguments[e]
}}
return t
}
,ZmMsg.SS.func.min);
ZmSpreadSheetFormulae.DEF("max",-1,function(){
var e=arguments[0];
for(var t=1;
t<arguments.length;
++t){
if(e<arguments[t]){
e=arguments[t]
}}
return e
}
,ZmMsg.SS.func.max);
ZmSpreadSheetFormulae.DEF("len",1,function(e){
return e.toString().length
}
,ZmMsg.SS.func.len);
ZmSpreadSheetFormulae.DEF(["concat","."],-1,function(){
var e=[arguments[0]];
for(var t=1;
t<arguments.length;
++t){
if(arguments[t]!=""){
e.push(arguments[t])
}}
return e.join("")
}
,ZmMsg.SS.func.concat);
ZmSpreadSheetFormulae.DEF("join",-2,function(t){
var e=[arguments[1]];
for(var a=2;
a<arguments.length;
++a){
if(arguments[a]!=""){
e.push(arguments[a])
}}
return e.join(t)
}
,ZmMsg.SS.func.join);
ZmSpreadSheetFormulae.DEF("x",2,function(a,t){
var e="";
while(t-->0){
e+=a
}
return e
}
);
ZmSpreadSheetFormulae.DEF("<",2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)<ZmSpreadSheetFormulae.parseFloat(e)
}
);
ZmSpreadSheetFormulae.DEF(">",2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)>ZmSpreadSheetFormulae.parseFloat(e)
}
);
ZmSpreadSheetFormulae.DEF("<=",2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)<=ZmSpreadSheetFormulae.parseFloat(e)
}
);
ZmSpreadSheetFormulae.DEF(">=",2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)>=ZmSpreadSheetFormulae.parseFloat(e)
}
);
ZmSpreadSheetFormulae.DEF("==",2,function(t,e){
return t==e
}
);
ZmSpreadSheetFormulae.DEF("!=",2,function(t,e){
return t!=e
}
);
ZmSpreadSheetFormulae.DEF(["&&","and"],2,function(t,e){
return t&&e
}
);
ZmSpreadSheetFormulae.DEF(["||","or"],2,function(t,e){
return t||e
}
);
ZmSpreadSheetFormulae.DEF(["!","not"],1,function(e){
return !e
}
);
ZmSpreadSheetFormulae.DEF("lt",2,function(t,e){
return t.toString()<e.toString()
}
);
ZmSpreadSheetFormulae.DEF("gt",2,function(t,e){
return t.toString()>e.toString()
}
);
ZmSpreadSheetFormulae.DEF("eq",2,function(t,e){
return t.toString()==e.toString()
}
);
ZmSpreadSheetFormulae.DEF("ne",2,function(t,e){
return t.toString()!=e.toString()
}
);
ZmSpreadSheetFormulae.DEF("lc",1,function(e){
return e.toString().toLowerCase()
}
);
ZmSpreadSheetFormulae.DEF("uc",1,function(e){
return e.toString().toUpperCase()
}
);
ZmSpreadSheetFormulae.DEF("if",3,function(a,e,t){
return a?e:t
}
);
ZmSpreadSheetFormulae.DEF("WHO_are_YOU?",0,function(){
return"http://www.zimbra.com/"
}
);
ZmSpreadSheetFormulae.DEF("-",2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)-ZmSpreadSheetFormulae.parseFloat(e)
}
);
ZmSpreadSheetFormulae.DEF("/",2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)/ZmSpreadSheetFormulae.parseFloat(e)
}
);
ZmSpreadSheetFormulae.DEF("^",2,function(t,e){
return Math.pow(t,e)
}
);
ZmSpreadSheetFormulae.prototype.depends=function(e){
return e!=null?this._deps[e]:this._deps
};
ZmSpreadSheetFormulae.prototype.dependsArray=function(){
return this._depsArray
};
ZmSpreadSheetFormulae.prototype.callFunction=function(t,e){
var a=ZmSpreadSheetFormulae.getFunc(t);
if(!a){
throw"No such function: "+t
}
return a.func.apply(this,e)
};
ZmSpreadSheetFormulae.prototype._analyzeRange=function(g){
var o=g.val;
var m=o.split(/:/);
var l=ZmSpreadSheetModel.identifyCell(m[0]);
var s=ZmSpreadSheetModel.identifyCell(m[1]);
var f=g.startRow=Math.min(l.row,s.row);
var t=g.startCol=Math.min(l.col,s.col);
var r=g.endRow=Math.max(l.row,s.row);
var d=g.endCol=Math.max(l.col,s.col);
g.startCell=this._model.data[f][t];
g.endCell=this._model.data[r][d];
var p=g.cells=[];
for(var h=f;
h<=r;
++h){
for(var n=t;
n<=d;
++n){
var u=this._model.data[h][n];
p.push(u);
var e=ZmSpreadSheetModel.getCellName(h+1,n+1);
if(!this._deps[e]){
this._deps[e]=u;
this._depsArray.push(u)
}}}};
ZmSpreadSheetFormulae.prototype.update=function(){
var h=this._formula,e=this._cellTokens,r=ZmSpreadSheetFormulae.TOKEN;
for(var s=e.length;
--s>=0;
){
var n=e[s];
var o=null;
if(n.type===r.CELL){
o=n.cell.getName()
}
if(n.type===r.CELLRANGE){
o=n.startCell.getName()+":"+n.endCell.getName()
}
if(o&&n.val!=o){
h=[h.substr(0,n.strPos),o,h.substr(n.strPos+n.strLen)].join("")
}}
if(h!=this._formula){
this.compile(h);
return h
}};
ZmSpreadSheetFormulae.prototype.shift=function(r,h){
var c=this._formula,e=this._cellTokens,l=ZmSpreadSheetFormulae.TOKEN;
for(var s=e.length;
--s>=0;
){
var n=e[s];
var o=null;
if(n.type===l.CELL){
o=ZmSpreadSheetModel.shiftCell(n.val,r,h)
}
if(n.type===l.CELLRANGE){
o=ZmSpreadSheetModel.shiftRange(n.val,r,h)
}
if(o&&n.val!=o){
c=[c.substr(0,n.strPos),o,c.substr(n.strPos+n.strLen)].join("")
}}
return c
};
ZmSpreadSheetFormulae.prototype.getFormula=function(){
return this._formula
};
ZmSpreadSheetFormulae.parseTokens=function(c,s){
var l=ZmSpreadSheetFormulae.TOKEN;
var d=[];
var u=0;
function g(t){
return t[t.length-1]
}
while(c.length>0){
var m=/^\s+/.exec(c);
if(m){
var h=m[0].length;
u+=h;
c=c.substr(h)
}
var y=false;
for(var r in l){
var p=l[r];
var m=p.match.exec(c);
if(m){
var e=p.getVal(m);
var h=m[0].length;
c=c.substr(h);
var f={
type:p,val:e,isOpr:p.isOpr,strPos:u,strLen:h};
u+=h;
if(p===l.OPERATOR){
var n=ZmSpreadSheetFormulae.OPERATORS[e];
f.priority=n.priority;
f.assoc=n.assoc;
f.n_args=n.n_args
}
if(p===l.IDENTIFIER){
var o=ZmSpreadSheetFormulae.getFunc(e);
if(!o&&!s){
throw'No such function: "'+e+'"'
}
f.priority=100;
if(o&&o.n_args==0){
f.isOpr=true;
f.val=o.func()
}}
d.push(f);
y=true;
break
}}
if(!y){
if(!s){
throw"Parse error at: "+c
}else{
c=c.substr(1);
++u
}}}
return d
};
ZmSpreadSheetFormulae.prototype.getTokens=function(){
return this._tokens
};
ZmSpreadSheetFormulae.prototype.compile=function(h){
this._formula=new String(h);
this._deps={};
this._depsArray=[];
this._cellTokens=[];
this._running=false;
var r=ZmSpreadSheetFormulae.TOKEN;
function p(t){
return t[t.length-1]
}
var l=this._tokens=ZmSpreadSheetFormulae.parseTokens(h);
var u=null;
var m=0;
var y=false;
for(var n=0;
n<l.length;
++n){
var f=l[n];
var s=l[n+1];
if(f.type===r.OPERATOR&&!s){
throw"Misplaced operator"
}
if(u){
if(f.type===r.COMMA&&(u.type===r.COMMA||u.type===r.OPENPAREN)){
throw"Misplaced comma"
}}
if(f.type===r.CELL){
f.val=f.val.toUpperCase();
var d=ZmSpreadSheetModel.identifyCell(f.val);
this._model.checkBounds(d.row,d.col);
f.cell=this._deps[f.val];
if(!f.cell){
f.cell=this._deps[f.val]=this._model.data[d.row][d.col];
this._depsArray.push(f.cell)
}
this._cellTokens.push(f)
}
if(f.type===r.CELLRANGE){
this._analyzeRange(f);
this._cellTokens.push(f)
}
if(f.type===r.OPENPAREN){
m++;
if(u&&u.isOpr){
throw"Paren after operand"
}}
if(f.type===r.CLOSEPAREN){
m--
}
if(f.type===r.OPERATOR&&f.val=="-"&&(!u||!u.isOpr)&&s.type.isNumber){
s.val=-s.val;
l.splice(n,1);
f=u;
--n
}
u=f
}
if(m!=0){
throw"Mismatched parentheses"
}
var c=[];
var a=[];
for(var n=0;
n<l.length;
++n){
var f=l[n];
if(f.isOpr){
a.push(f)
}else{
if(f.type===r.IDENTIFIER){
f.n_args=-1;
c.push(f);
if(ZmSpreadSheetFormulae.getFunc(f.val).n_args!=0){
if(!l[n+1]||l[n+1].type!==r.OPENPAREN){
throw'Function "'+f.val+'" expects arguments.'
}}}else{
if(f.type===r.COMMA){
while(c.length>0&&p(c).type!==r.OPENPAREN){
a.push(c.pop())
}
if(c.length==0||!l[n+1]||l[n+1].type===r.CLOSEPAREN){
throw"Syntax error: misplaced comma or parens"
}
var o=c[c.length-2];
if(!o||o.type!==r.IDENTIFIER){
throw"Syntax error: expecting a function identifier"
}
++o.n_args
}else{
if(f.type===r.OPERATOR){
var e;
while(((e=p(c))!=null)&&e.type===r.OPERATOR&&((f.assoc>=2&&f.priority<=e.priority)||(f.assoc==1&&f.priority>e.priority))){
a.push(c.pop())
}
c.push(f)
}else{
if(f.type===r.OPENPAREN){
var o=p(c);
var s=l[n+1];
if(o&&o.type===r.IDENTIFIER&&s&&s.type!==r.CLOSEPAREN){
++o.n_args
}
c.push(f)
}else{
if(f.type===r.CLOSEPAREN){
while(c.length>0&&p(c).type!==r.OPENPAREN){
a.push(c.pop())
}
if(c.length==0){
throw"Syntax error: misplaced parens"
}else{
c.pop()
}
if(c.length>0&&p(c).type===r.IDENTIFIER){
var o=c.pop();
o.n_args++;
a.push(o);
var g=ZmSpreadSheetFormulae.getFunc(o.val).n_args;
if(g!=null){
if(g>=0&&o.n_args!=g){
throw"Function "+o.val+" expects exactly "+g+" arguments."
}
if(g<0&&o.n_args+g<0){
throw"Function "+o.val+" expects at least "+(-g)+" arguments."
}}}}}}}}}}
while(c.length>0){
var f=c.pop();
if((f.type!==r.OPERATOR&&f.type!==r.IDENTIFIER)||(f.type===r.IDENTIFIER&&ZmSpreadSheetFormulae.getFunc(f.val).n_args>0)){
throw"Expecting only operators or constants at ZmSpreadSheetFormulae.compile"
}
a.push(f)
}
this._stack=a
};
ZmSpreadSheetFormulae.prototype.eval=function(){
if(this._running){
return""
}
this._running=true;
var o=ZmSpreadSheetFormulae.TOKEN,n=this._stack,a=n.length-1,r=this;
var h={};
var e=null;
function s(l){
h[l.getType()]=true;
if(l.getDecimals()!=null){
if(e==null){
e=0
}
if(e<l.getDecimals()){
e=l.getDecimals()
}}
return l.getValue()
}
function t(){
var c=n[a--];
if(c.type===o.CELL){
return s(c.cell)
}
if(c.type===o.CELLRANGE){
var l=new Array(c.cells.length);
for(var m=l.length;
--m>=0;
){
l[m]=s(c.cells[m])
}
return l
}
if(c.isOpr){
return c.val
}
var u=[],d=c.n_args;
while(d-->0){
var f=t();
if(f instanceof Array){
u.unshift.apply(u,f)
}else{
u.unshift(f)
}}
return r.callFunction(c.val,u)
}
var i=t();
if(h.percentage&&!h.currency){
h="percentage"
}else{
if(h.currency){
h="currency"
}else{
h=null
}}
this.autoType=h;
this.decimals=e;
this._running=false;
return i
};
ZmSpreadSheetFormulae.prototype.toString=function(){
return this._formula
}
}
if(AjxPackage.define("zimbraMail.ale.spreadsheet.ZmSpreadSheetToolbars")){
ZmSpreadSheetToolbars=function(t,e){
if(e==null){
e=t
}
this._spreadSheet=e;
DwtComposite.call(this,{
parent:t,className:"ZmSpreadSheetToolbars",posStyle:DwtControl.RELATIVE_STYLE}
);
this._on_buttonPress=new AjxListener(this,this._on_buttonPress);
this._buttons={};
this._createWidgets();
if(t===e){
t=t.getHtmlElement();
t.insertBefore(this.getHtmlElement(),t.firstChild)
}
e.onSelectCell.push(new AjxCallback(this,this._cellSelected))
};
ZmSpreadSheetToolbars.prototype=new DwtComposite;
ZmSpreadSheetToolbars.prototype.construction=ZmSpreadSheetToolbars;
ZmSpreadSheetToolbars.prototype._cellSelected=function(e){
this._buttons.bold.setSelected(e.getStyleProp("fontWeight")=="bold");
this._buttons.italic.setSelected(e.getStyleProp("fontStyle")=="italic");
this._buttons.underline.setSelected(e.getStyleProp("textDecoration")=="underline");
this._buttons.strike.setSelected(e.getStyleProp("textDecoration")=="line-through");
var a=e.getStyleProp("textAlign");
this._buttons.justifyLeft.setSelected(a=="left");
this._buttons.justifyCenter.setSelected(a=="center");
this._buttons.justifyRight.setSelected(a=="right");
if(this._dataField){
this._dataField.setValue(e.getEditValue())
}
this._buttons.typeSelect.setSelectedValue(e.getType());
var t=e.getDecimals();
if(t==null){
t=-1
}
this._buttons.decimalsSelect.setSelectedValue(t)
};
ZmSpreadSheetToolbars.prototype._createWidgets=function(){
this._createToolbar1();
this._createToolbar2()
};
ZmSpreadSheetToolbars.prototype._createToolbar1=function(){
var t=new DwtToolBar({
parent:this,className:"ToolBar",posStyle:DwtControl.RELATIVE_STYLE}
);
var a=this._on_buttonPress;
var e;
var i={
parent:t};
e=this._buttons.clipboardCopy=new DwtToolBarButton(i);
e.setImage("Copy");
e.setData("SS","ClipboardCopy");
e.addSelectionListener(a);
e.setToolTipContent(ZmMsg.copy);
e=this._buttons.clipboardCut=new DwtToolBarButton(i);
e.setImage("Cut");
e.setData("SS","ClipboardCut");
e.addSelectionListener(a);
e.setToolTipContent(ZmMsg.cut);
e=this._buttons.clipboardPaste=new DwtToolBarButton(i);
e.setImage("Paste");
e.setData("SS","ClipboardPaste");
e.addSelectionListener(a);
e.setToolTipContent(ZmMsg.paste);
new DwtControl({
parent:t,className:"vertSep"}
);
i.style=DwtButton.TOGGLE_STYLE;
e=this._buttons.bold=new DwtToolBarButton(i);
e.setImage("Bold");
e.setData("SS","Bold");
e.addSelectionListener(a);
e.setToolTipContent(AjxKeys["editor.Bold.summary"]);
e=this._buttons.italic=new DwtToolBarButton(i);
e.setImage("Italics");
e.setData("SS","Italic");
e.addSelectionListener(a);
e.setToolTipContent(AjxKeys["editor.Italic.summary"]);
e=this._buttons.underline=new DwtToolBarButton(i);
e.setImage("Underline");
e.setData("SS","Underline");
e.addSelectionListener(a);
e.setToolTipContent(AjxKeys["editor.Underline.summary"]);
e=this._buttons.strike=new DwtToolBarButton(i);
e.setImage("StrikeThru");
e.setData("SS","Strike");
e.addSelectionListener(a);
e.setToolTipContent(AjxKeys["editor.Strikethru.summary"]);
new DwtControl({
parent:t,className:"vertSep"}
);
e=this._buttons.justifyLeft=new DwtToolBarButton(i);
e.setImage("LeftJustify");
e.setData("SS","JustifyLeft");
e.addSelectionListener(a);
e.setToolTipContent(AjxKeys["editor.LeftJustify.summary"]);
e=this._buttons.justifyCenter=new DwtToolBarButton(i);
e.setImage("CenterJustify");
e.setData("SS","JustifyCenter");
e.addSelectionListener(a);
e.setToolTipContent(AjxKeys["editor.CenterJustify.summary"]);
e=this._buttons.justifyRight=new DwtToolBarButton(i);
e.setImage("RightJustify");
e.setData("SS","JustifyRight");
e.addSelectionListener(a);
e.setToolTipContent(AjxKeys["editor.RightJustify.summary"]);
new DwtControl({
parent:t,className:"vertSep"}
);
e=this._buttons.fontColor=new ZmSpreadSheetEditorColorPicker(t,null,"DwtToolbarButton",null,null,null,ZmMsg.auto);
e.setImage("FontColor");
e.showColorDisplay();
e.setToolTipContent(ZmMsg.fontColor);
e.addSelectionListener(new AjxListener(this,this._on_fontColor));
e=this._buttons.bgColor=new ZmSpreadSheetEditorColorPicker(t,null,"DwtToolbarButton",null,null,null,ZmMsg.auto);
e.setImage("FontBackground");
e.showColorDisplay();
e.setToolTipContent(ZmMsg.fontBackground);
e.addSelectionListener(new AjxListener(this,this._on_bgColor))
};
ZmSpreadSheetToolbars.prototype._inputModified=function(e){
if(this._dataField){
this._dataField.setValue(e)
}};
ZmSpreadSheetToolbars.prototype._input_clicked=function(t){
var e=new DwtUiEvent();
this._dataField.getInputElement().blur();
e.setFromDhtmlEvent(t);
var a=this._spreadSheet._selectedCell;
if(a){
this._spreadSheet.focus();
this._spreadSheet._editCell(a)
}
e._stopPropagation=true;
e._returnValue=false;
e.setToDhtmlEvent(t);
return false
};
ZmSpreadSheetToolbars.prototype._createToolbar2=function(){
var h=new DwtToolBar({
parent:this,className:"ToolBar ToolBar2",posStyle:DwtControl.RELATIVE_STYLE}
);
var a=this._on_buttonPress;
var o={
parent:h,style:0};
b=this._buttons.rowInsertAbove=new DwtToolBarButton(o);
b.setImage("InsertRowBefore");
b.setData("SS","RowInsertAbove");
b.addSelectionListener(a);
b.setToolTipContent(ZmMsg.insertRowAbove);
b=this._buttons.rowInsertUnder=new DwtToolBarButton(o);
b.setImage("InsertRowAfter");
b.setData("SS","RowInsertUnder");
b.addSelectionListener(a);
b.setToolTipContent(ZmMsg.insertRowUnder);
b=this._buttons.rowDelete=new DwtToolBarButton(o);
b.setImage("DeleteRow");
b.setData("SS","RowDelete");
b.addSelectionListener(a);
b.setToolTipContent(ZmMsg.deleteRow);
new DwtControl({
parent:h,className:"vertSep"}
);
b=this._buttons.colInsertBefore=new DwtToolBarButton(o);
b.setImage("InsertColBefore");
b.setData("SS","ColInsertBefore");
b.addSelectionListener(a);
b.setToolTipContent(ZmMsg.insertColumnBefore);
b=this._buttons.colInsertAfter=new DwtToolBarButton(o);
b.setImage("InsertColAfter");
b.setData("SS","ColInsertAfter");
b.addSelectionListener(a);
b.setToolTipContent(ZmMsg.insertColumnAfter);
b=this._buttons.colDelete=new DwtToolBarButton(o);
b.setImage("DeleteCol");
b.setData("SS","ColDelete");
b.addSelectionListener(a);
b.setToolTipContent(ZmMsg.deleteColumn);
new DwtControl({
parent:h,className:"vertSep"}
);
b=new DwtToolBarButton(o);
b.setImage("Sum");
b.setToolTipContent(ZmMsg.sumCells);
b.setData("SS","Func-SumCells");
b.addSelectionListener(a);
b=new DwtToolBarButton(o);
b.setText(ZmMsg.insertFunction);
var t=new DwtMenu({
parent:b}
);
t.dontStealFocus();
var e=[];
for(var r in ZmSpreadSheetFormulae.HELP){
e.push(r)
}
e=e.sort();
var c=new AjxListener(this,this._on_insertFunction);
for(var r=0;
r<e.length;
++r){
var n=ZmSpreadSheetFormulae.HELP[e[r]];
if(n.alias){
continue
}
var d=new DwtMenuItem({
parent:t}
);
d.setText(['<div style="float:left; width: 5em; text-align: right">',e[r],"</div>",'<div style="margin-left: 5em">&nbsp;- ',n.help,"</div>"].join(""));
d.setData("SS",e[r]);
d.addSelectionListener(c);
if(n.args){
d.setToolTipContent(n.args)
}}
b.setMenu(t);
new DwtControl({
parent:h,className:"vertSep"}
);
var u=this._buttons.typeSelect=new ZmSpreadSheetEditorSelect(h,null);
u.addChangeListener(new AjxListener(this,this._on_typeSelect));
u.addOption(ZmMsg.spreadSheet_msg_autoType,true,null);
u.addOption(ZmMsg.number,false,"number");
u.addOption(ZmMsg.currency,false,"currency");
u.addOption(ZmMsg.percent,false,"percentage");
u.addOption(ZmMsg.text,false,"string");
var u=this._buttons.decimalsSelect=new ZmSpreadSheetEditorSelect(h,null);
u.addChangeListener(new AjxListener(this,this._on_decimalsSelect));
u.addOption(ZmMsg.spreadSheet_msg_autoDecimals,true,-1);
var l=new AjxMessageFormat(ZmMsg.spreadsheet_msg_numberOfDecimals);
for(var r=0;
r<=6;
r++){
u.addOption(l.format(r),false,r)
}
if(ZmSpreadSheetModel.DEBUG){
new DwtControl({
parent:h,className:"vertSep"}
);
new DwtLabel({
parent:h}
).setText("DEBUG: ");
b=new DwtToolBarButton(o);
b.setText("Serialize");
b.addSelectionListener(new AjxListener(this,function(){
var i=this.getModel().serialize();
var m=window.open(appContextPath+"/public/blank.html","_blank","scrollbars=no");
var s=setInterval(function(){
try{
var g=m.document;
b=g.body;
b.style.backgroundColor="ButtonFace";
var p=g.createElement("textarea");
p.value=i;
b.appendChild(p);
p.style.width="100%";
p.style.height="100%";
clearInterval(s)
}
catch(f){}}
,250)
}
));
b=new DwtToolBarButton(o);
b.setText("getHtml");
b.addSelectionListener(new AjxListener(this,function(){
var i=this.getModel().getHtml();
var m=window.open(appContextPath+"/public/blank.html","_blank","scrollbars=yes");
var s=setInterval(function(){
try{
var p=m.document;
b=p.body;
b.style.backgroundColor="ButtonFace";
b.innerHTML=i;
clearInterval(s)
}
catch(f){}}
,250)
}
))
}};
ZmSpreadSheetToolbars.prototype._on_insertFunction=function(e){
this.insertFunction(e.item.getData("SS"))
};
ZmSpreadSheetToolbars.prototype._on_fontColor=function(e){
this.applyStyle("color",e.detail);
this._spreadSheet.focus()
};
ZmSpreadSheetToolbars.prototype._on_bgColor=function(e){
this.applyStyle("backgroundColor",e.detail);
this._spreadSheet.focus()
};
ZmSpreadSheetToolbars.prototype._on_buttonPress=function(i){
var a=i.item;
var o=a.getData("SS");
var t=this._spreadSheet;
t.focus();
switch(o){
case"ClipboardCopy":t.clipboardCopy();
break;
case"ClipboardCut":t.clipboardCut();
break;
case"ClipboardPaste":t.clipboardPaste();
break;
case"Bold":this.applyStyle("fontWeight",a.isToggled()?"bold":"");
break;
case"Italic":this.applyStyle("fontStyle",a.isToggled()?"italic":"");
break;
case"Strike":this.applyStyle("textDecoration",a.isToggled()?"line-through":"");
this._buttons.underline.setSelected(false);
break;
case"Underline":this.applyStyle("textDecoration",a.isToggled()?"underline":"");
this._buttons.strike.setSelected(false);
break;
case"JustifyLeft":this.applyStyle("textAlign",a.isToggled()?"left":"");
this._buttons.justifyCenter.setSelected(false);
this._buttons.justifyRight.setSelected(false);
break;
case"JustifyCenter":this.applyStyle("textAlign",a.isToggled()?"center":"");
this._buttons.justifyLeft.setSelected(false);
this._buttons.justifyRight.setSelected(false);
break;
case"JustifyRight":this.applyStyle("textAlign",a.isToggled()?"right":"");
this._buttons.justifyLeft.setSelected(false);
this._buttons.justifyCenter.setSelected(false);
break;
case"RowInsertAbove":var e=t.getSelectedCellModel();
if(e){
this.getModel().insertRow(e.getRow()-1)
}
break;
case"RowInsertUnder":var e=t.getSelectedCellModel();
if(e){
this.getModel().insertRow(e.getRow())
}
break;
case"ColInsertBefore":var e=t.getSelectedCellModel();
if(e){
this.getModel().insertCol(e.getCol()-1)
}
break;
case"ColInsertAfter":var e=t.getSelectedCellModel();
if(e){
this.getModel().insertCol(e.getCol())
}
break;
case"RowDelete":var e=t.getSelectedCellModel();
if(e){
this.getModel().deleteRow(e.getRow()-1)
}
break;
case"ColDelete":var e=t.getSelectedCellModel();
if(e){
this.getModel().deleteCol(e.getCol()-1)
}
break;
case"Func-SumCells":this.insertFunction("sum");
break
}};
ZmSpreadSheetToolbars.prototype.insertFunction=function(o){
var i=this._spreadSheet;
var e=i.getSelectedCellModel();
if(e){
var a=ZmSpreadSheetFormulae.HELP[o];
var n=o.length+2;
if(a&&a.helper){
o=a.helper;
n=o.indexOf("|");
o=o.replace(/\|/g,"")
}else{
o="="+o+"()"
}
var t=i._getInputField();
i.focus();
i._editCell(e._td);
t.setValue(o);
Dwt.setSelectionRange(t,n,n)
}};
ZmSpreadSheetToolbars.prototype._on_typeSelect=function(a){
this._spreadSheet.focus();
var e=this._spreadSheet.getSelectionRange();
if(!e){
return
}
var t=a._args.newValue;
this.getModel().forEachCell(e,function(i){
i.setType(t)
}
,this)
};
ZmSpreadSheetToolbars.prototype._on_decimalsSelect=function(t){
this._spreadSheet.focus();
var e=this._spreadSheet.getSelectionRange();
if(!e){
return
}
var a=t._args.newValue;
if(a==-1){
a=null
}
this.getModel().forEachCell(e,function(i){
i.setDecimals(a)
}
,this)
};
ZmSpreadSheetToolbars.prototype.getModel=function(){
return this._spreadSheet._model
};
ZmSpreadSheetToolbars.prototype.applyStyle=function(t,a){
var e=this._spreadSheet.getSelectionRange();
if(!e){
return
}
this.getModel().forEachCell(e,function(i){
i.setStyleProp(t,a)
}
,this)
};
ZmSpreadSheetEditorColorPicker=function(o,i,a,t,s,e,n){
DwtButtonColorPicker.call(this,o,i,a,t,s,e,n)
};
ZmSpreadSheetEditorColorPicker.prototype=new DwtButtonColorPicker;
ZmSpreadSheetEditorColorPicker.prototype.constructor=ZmSpreadSheetEditorColorPicker;
ZmSpreadSheetEditorColorPicker.prototype.TEMPLATE="dwt.Widgets#ZToolbarButton";
ZmSpreadSheetEditorSelect=function(i,e,a,t){
DwtSelect.call(this,{
parent:i,options:e,className:a,posStyle:t}
)
};
ZmSpreadSheetEditorSelect.prototype=new DwtSelect;
ZmSpreadSheetEditorSelect.prototype.constructor=ZmSpreadSheetEditorSelect;
ZmSpreadSheetEditorSelect.prototype.TEMPLATE="dwt.Widgets#ZBorderlessButton"
}
if(AjxPackage.define("zimbraMail.ale.spreadsheet.test")){
DBG=new AjxDebug(AjxDebug.NONE,null,false);
var shell=null;
var spreadSheet=null;
var model=null;
create=function(e){
shell=new DwtShell({
className:"MainShell"}
);
shell.getKeyboardMgr().registerKeyMap(new DwtKeyMap(true));
spreadSheet=new ZmSpreadSheet(shell,null,"absolute");
if(e!=null){
model=new ZmSpreadSheetModel(0,0);
model.deserialize(e)
}else{
model=new ZmSpreadSheetModel(10,6)
}
spreadSheet.setModel(model);
new ZmSpreadSheetToolbars(spreadSheet,spreadSheet);
spreadSheet.setZIndex(Dwt.Z_VIEW);
window.onresize=_resize;
_resize();
spreadSheet._selectedCell=null;
spreadSheet.focus()
};
_resize=function(){
spreadSheet.setDisplay("none");
var e=document.body.clientWidth;
var t=document.body.clientHeight;
if(!AjxEnv.isIE){
e-=2;
t-=2
}
spreadSheet.setDisplay("block");
spreadSheet.setBounds(0,0,e,t)
};
serialize=function(){
return model.serialize()
};
deserialize=function(e){
model=new ZmSpreadSheetModel(0,0);
model.deserialize(e);
spreadSheet.setModel(model)
};
getHTML=function(){
return model.getHtml()
};
getHeadHTML=function(){
return["<style type='text/css'>","td.SpreadSheet-Type-number { text-align: right; }","td.SpreadSheet-Type-currency { text-align: right; }","td.SpreadSheet-Type-error { text-align: center; color: #f00; }","</style>"].join("")
};
window.onload=function(){
setTimeout(function(){
if(!window.ZmACE){
create()
}}
,200)
}
}};
