
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
if(AjxPackage.define("SpreadsheetEmbed")){
if(AjxPackage.define("zimbraMail.share.view.htmlEditor.ZmSpellChecker")){
ZmSpellChecker=function(e){
this._parent=e
};
ZmSpellChecker.prototype.toString=function(){
return"ZmSpellChecker"
};
ZmSpellChecker.prototype.check=function(e,o,t){
var i=typeof e=="string"?{
text:e}
:e;
var a=AjxSoapDoc.create("CheckSpellingRequest","urn:zimbraMail");
a.getMethod().appendChild(a.getDoc().createTextNode(i.text));
if(i.ignore){
a.getMethod().setAttribute("ignore",i.ignore)
}
var o=new AjxCallback(this,this._checkCallback,o);
appCtxt.getAppController().sendRequest({
soapDoc:a,asyncMode:true,callback:o,errorCallback:t}
)
};
ZmSpellChecker.prototype._checkCallback=function(a,e){
var t=e._isException?null:e.getResponse().CheckSpellingResponse;
if(a){
a.run(t)
}}
}
if(AjxPackage.define("zimbraMail.share.view.htmlEditor.ZmHtmlEditor")){
ZmHtmlEditor=function(o,i,n,h,e,t){
if(arguments.length==0){
return
}
this._toolbars=[];
this.ACE_ENABLED=!!e;
this.ACE_DEBUG=false;
if(this.ACE_ENABLED){
this._ace_componentsLoading=0
}
if(t){
this._isPasteEnabled=t
}
DwtHtmlEditor.call(this,{
parent:o,className:"ZmHtmlEditor",posStyle:i,content:n,mode:h}
);
this.addStateChangeListener(new AjxListener(this,this._rteStateChangeListener));
var a=appCtxt.getSettings();
var s=new AjxListener(this,this._settingChangeListener);
a.getSetting(ZmSetting.COMPOSE_INIT_FONT_COLOR).addChangeListener(s);
a.getSetting(ZmSetting.COMPOSE_INIT_FONT_FAMILY).addChangeListener(s);
a.getSetting(ZmSetting.COMPOSE_INIT_FONT_SIZE).addChangeListener(s);
this._ignoreWords={}
};
ZmHtmlEditor.prototype=new DwtHtmlEditor;
ZmHtmlEditor.prototype.constructor=ZmHtmlEditor;
ZmHtmlEditor._VALUE="value";
ZmHtmlEditor.FONT_SIZE_VALUES=["8pt","10pt","12pt","14pt","18pt","24pt","36pt"];
ZmHtmlEditor.__makeFontName=function(e){
return e.replace(/,.*/,"").replace(/[']/g,"").replace(/\b[a-z]/g,ZmHtmlEditor.__toUpperCase)
};
ZmHtmlEditor.__toUpperCase=function(e){
return e.toUpperCase()
};
ZmHtmlEditor.ACE_IFRAME_RE=new RegExp("<iframe\\s+.*?\\bid\\s*=\\s*[\"']?(ace-[^\"'\\s]*).*?>.*?</iframe(\\s.*?)?>","ig");
ZmHtmlEditor.prototype.toString=function(){
return"ZmHtmlEditor"
};
ZmHtmlEditor.prototype.isHtmlEditingSupported=function(){
var e=DwtHtmlEditor.prototype.isHtmlEditingSupported.call(this);
if(e){
e=appCtxt.get(ZmSetting.HTML_COMPOSE_ENABLED)
}
return e
};
ZmHtmlEditor.prototype.setContent=function(e){
DwtHtmlEditor.prototype.setContent.apply(this,arguments);
this._ignoreWords={}
};
ZmHtmlEditor.prototype.setMode=function(n,o,e){
this.discardMisspelledWords();
DwtHtmlEditor.prototype.setMode.call(this,n,o,e);
if(n==DwtHtmlEditor.HTML){
this._createToolbars()
}
for(var t=0;
t<this._toolbars.length;
t++){
var a=this._toolbars[t];
a.setVisible(n==DwtHtmlEditor.HTML)
}
appCtxt.notifyZimlets("on_htmlEditor_setMode",[this,n])
};
ZmHtmlEditor.prototype.getBodyFieldId=function(){
return this._mode==DwtHtmlEditor.HTML?this._iFrameId:this._textAreaId
};
ZmHtmlEditor.prototype.getTextVersion=function(e){
return this._mode==DwtHtmlEditor.HTML?this._convertHtml2Text(e):this.getContent()
};
ZmHtmlEditor.prototype.reEnableDesignMode=function(){
if(AjxEnv.isGeckoBased||AjxEnv.isSafari){
this._enableDesignMode(this._getIframeDoc())
}};
ZmHtmlEditor.prototype.addEventCallback=function(e){
this._eventCallback=e
};
ZmHtmlEditor.prototype._onContentInitialized=function(){
DwtHtmlEditor.prototype._onContentInitialized.call(this);
this._loadExternalStyle("/css/editor.css");
this._setFontStyles();
if(this.ACE_ENABLED&&this._mode==DwtHtmlEditor.HTML){
setTimeout(AjxCallback.simpleClosure(this._deserializeAceObjects,this),100)
}
if(this._onContentInitializeCallback){
AjxDebug.println(AjxDebug.REPLY,"ZmHtmlEditor::_onContentInitialized - run callback");
this._onContentInitializeCallback.run()
}};
ZmHtmlEditor.prototype.addOnContentInitializedListener=function(e){
this._onContentInitializeCallback=e
};
ZmHtmlEditor.prototype.removeOnContentInitializedListener=function(){
this._onContentInitializeCallback=null
};
ZmHtmlEditor.prototype.getContent=function(e,a){
this.discardMisspelledWords();
var i;
if(this._mode==DwtHtmlEditor.HTML){
AjxDebug.println(AjxDebug.REPLY,"ZmHtmlEditor::getContent - in HTML mode");
var o=this._getIframeDoc();
var t=(o&&o.body&&o.body.innerHTML)||"";
AjxDebug.println(AjxDebug.REPLY,"content from iframe body: "+AjxStringUtil.htmlEncode(t.substr(0,200)));
this._blankDiv=this._blankDiv||this._getFontStyle("");
this._blankHtml=this._blankHtml||this._embedHtmlContent("",true);
if(this._pendingContent&&(!t||t==this._blankDiv||t==this._blankHtml)){
t=this._pendingContent;
AjxDebug.println(AjxDebug.REPLY,"using pending content: "+AjxStringUtil.htmlEncode(t.substr(0,200)))
}
i=this._embedHtmlContent(t,e,a);
if(this.ACE_ENABLED){
i=this._serializeAceObjects(i)
}}else{
i=document.getElementById(this._textAreaId).value
}
return i
};
ZmHtmlEditor.prototype.checkMisspelledWords=function(o,t,e){
var i=this.getTextVersion();
if(/\S/.test(i)){
AjxDispatcher.require("Extras");
this._spellChecker=new ZmSpellChecker(this);
this._spellCheck=null;
this._spellCheckSuggestionListenerObj=new AjxListener(this,this._spellCheckSuggestionListener);
if(!this.onExitSpellChecker){
this.onExitSpellChecker=t
}
var a={
text:i,ignore:AjxUtil.keys(this._ignoreWords).join()};
this._spellChecker.check(a,o,e);
return true
}
return false
};
ZmHtmlEditor.prototype.spellCheck=function(a){
var t=this.getTextVersion();
if(/\S/.test(t)){
AjxDispatcher.require("Extras");
this._spellChecker=new ZmSpellChecker(this);
this._spellCheck=null;
this._spellCheckSuggestionListenerObj=new AjxListener(this,this._spellCheckSuggestionListener);
if(!this.onExitSpellChecker){
this.onExitSpellChecker=a
}
var e={
text:t,ignore:AjxUtil.keys(this._ignoreWords).join()};
this._spellChecker.check(e,new AjxCallback(this,this._spellCheckCallback));
return true
}
return false
};
ZmHtmlEditor.prototype.resetSpellCheck=function(){
if(!this._spellCheck){
return
}
this.discardMisspelledWords();
this._spellCheckHideModeDiv()
};
ZmHtmlEditor.prototype.discardMisspelledWords=function(c){
if(!this._spellCheck){
return
}
if(this._mode==DwtHtmlEditor.HTML){
var s=this._getIframeDoc();
s.body.style.display="none";
var t=null;
var h=this._spellCheck.spanIds;
for(var n in h){
var l=s.getElementById(n);
if(!l){
continue
}
t=l.parentNode;
while(l.firstChild){
t.insertBefore(l.firstChild,l)
}
t.removeChild(l)
}
if(!AjxEnv.isIE){
s.body.normalize()
}else{
s.body.innerHTML=s.body.innerHTML
}
t=s.getElementById("ZM-SPELLCHECK-STYLE");
if(t){
t.parentNode.removeChild(t)
}
s.body.style.display="";
this._unregisterEditorEventHandler(s,"contextmenu")
}else{
if(this._spellCheckDivId!=null){
var e=document.getElementById(this._spellCheckDivId);
var o=e.scrollTop;
var a=document.getElementById(this._textAreaId);
if(AjxEnv.isGeckoBased){
e.innerHTML=AjxStringUtil.htmlDecode(e.innerHTML,true)
}
a.value=AjxUtil.getInnerText(e);
e.onclick=null;
e.oncontextmenu=null;
e.onmousedown=null;
e.parentNode.removeChild(e);
a.style.display="";
a.scrollTop=o
}}
this._spellCheckDivId=this._spellCheck=null;
window.status="";
if(!c){
this._spellCheckHideModeDiv()
}
if(this.onExitSpellChecker){
this.onExitSpellChecker.run()
}};
ZmHtmlEditor.prototype._resetFormatControls=function(){
this._resetFormatControlDefaults();
setTimeout(AjxCallback.simpleClosure(this._loadExternalStyle,this,"/css/editor.css"),250);
setTimeout(AjxCallback.simpleClosure(this._setFontStyles,this),250)
};
ZmHtmlEditor.prototype._resetFormatControlDefaults=function(){
this._fontFamilyButton&&this._fontFamilyButton.setText(DwtHtmlEditor._normalizeFontName(appCtxt.get(ZmSetting.COMPOSE_INIT_FONT_FAMILY)));
this._fontSizeButton&&this._fontSizeButton.setText(this._getFontSizeLabel(appCtxt.get(ZmSetting.COMPOSE_INIT_FONT_SIZE)));
this._fontColorButton&&this._fontColorButton.setColor(appCtxt.get(ZmSetting.COMPOSE_INIT_FONT_COLOR));
this._styleMenu&&this._styleMenu.checkItem(ZmHtmlEditor._VALUE,DwtHtmlEditor.PARAGRAPH,true);
this._justifyMenu&&this._justifyMenu.checkItem(ZmHtmlEditor._VALUE,DwtHtmlEditor.JUSTIFY_LEFT,true)
};
ZmHtmlEditor.prototype._loadExternalStyle=function(n){
var o=this._getIframeDoc();
var a=o.getElementById(n);
if(!a){
a=o.createElement("link");
a.id=n;
a.rel="stylesheet";
a.type="text/css";
var i=appContextPath+n+"?v="+cacheKillerVersion;
if(AjxEnv.isGeckoBased||AjxEnv.isSafari){
i=document.baseURI.replace(/^(https?:\x2f\x2f[^\x2f]+).*$/,"$1")+i
}
var e=DBG&&DBG.getDebugLevel();
if(e){
i=i+"&debug="+e
}
a.href=i;
var t=o.getElementsByTagName("head")[0];
if(!t){
t=o.createElement("head");
var s=o.documentElement;
if(s){
s.insertBefore(t,s.firstChild)
}}
t.appendChild(a)
}};
ZmHtmlEditor.prototype._setFontStyles=function(){
var t=this._getIframeDoc();
var e=t.body&&t.body.style;
if(e){
e.fontFamily=DwtHtmlEditor._normalizeFontValue(appCtxt.get(ZmSetting.COMPOSE_INIT_FONT_FAMILY));
e.fontSize=appCtxt.get(ZmSetting.COMPOSE_INIT_FONT_SIZE);
e.color=appCtxt.get(ZmSetting.COMPOSE_INIT_FONT_COLOR)
}};
ZmHtmlEditor.prototype.highlightMisspelledWords=function(u,t){
this.discardMisspelledWords(t);
var y,p,v,o,d=this,n={}
,m={}
,k=["([^A-Za-z0-9']|^)("],l={};
for(var f=0;
f<u.length;
++f){
y=u[f].word;
if(!l[y]){
f&&k.push("|");
k.push(y);
var w=u[f].suggestions.split(/\s*,\s*/);
if(!w[w.length-1]){
w.pop()
}
l[y]=w;
if(l[y].length>5){
l[y].length=5
}}}
k.push(")([^A-Za-z0-9']|$)");
k=new RegExp(k.join(""),"gm");
function h(T,A){
T=A?AjxStringUtil.convertToHtml(T):AjxStringUtil.htmlEncode(T);
var x;
k.lastIndex=0;
while(x=k.exec(T)){
var z=x[0];
var q=x[1];
var a=x[2];
var O=x[3];
var i=Dwt.getNextId();
n[i]=a;
if(!m[a]){
m[a]=[]
}
m[a].push(i);
var j=[q,'<span word="',a,'" id="',i,'" class="ZM-SPELLCHECK-MISSPELLED">',a,"</span>",O].join("");
T=[T.substr(0,x.index),j,T.substr(x.index+z.length)].join("");
k.lastIndex=x.index+j.length-O.length
}
return T
}
var v;
rec=function(T){
switch(T.nodeType){
case 1:for(var z=T.firstChild;
z;
z=rec(z)){}
T=T.nextSibling;
break;
case 3:if(!/[^\s\xA0]/.test(T.data)){
T=T.nextSibling;
break
}
var j=null,q=null;
var x=/^[\s\xA0]+/.exec(T.data);
if(x){
j=T;
T=T.splitText(x[0].length)
}
x=/[\s\xA0]+$/.exec(T.data);
if(x){
q=T.splitText(T.data.length-x[0].length)
}
var A=h(T.data,false);
A=A.replace(/^ +/,"&nbsp;").replace(/ +$/,"&nbsp;");
var W=v.createElement("div");
W.innerHTML=A;
if(j){
W.insertBefore(j,W.firstChild)
}
if(q){
W.appendChild(q)
}
var O=T.parentNode;
while(W.firstChild){
O.insertBefore(W.firstChild,T)
}
W=T.nextSibling;
O.removeChild(T);
T=W;
break;
default:T=T.nextSibling
}
return T
};
if(this._mode==DwtHtmlEditor.HTML){
v=this._getIframeDoc();
o=v.body;
this._loadExternalStyle("/css/spellcheck.css");
o.style.display="none";
if(!AjxEnv.isIE){
o.normalize()
}else{
o.innerHTML=o.innerHTML
}
rec(o);
if(!AjxEnv.isIE){
o.normalize()
}else{
o.innerHTML=o.innerHTML
}
o.style.display="";
this._registerEditorEventHandler(v,"contextmenu")
}else{
var g=document.getElementById(this._textAreaId);
var e=g.scrollTop;
var c=Dwt.getSize(g);
g.style.display="none";
var s=document.createElement("div");
s.className="TextSpellChecker";
this._spellCheckDivId=s.id=Dwt.getNextId();
s.style.overflow="auto";
if(!AjxEnv.isIE){
c.x-=4;
c.y-=6
}
s.style.width=c.x+"px";
s.style.height=c.y+"px";
s.innerHTML=AjxStringUtil.convertToHtml(this.getContent());
v=document;
rec(s);
g.parentNode.insertBefore(s,g);
s.scrollTop=e;
s.oncontextmenu=s.onclick=function(a){
d._handleSpellCheckerEvents(a||window.event)
}
}
this._spellCheckShowModeDiv();
this._spellCheck={
suggestions:l,spanIds:n,wordIds:m}
};
ZmHtmlEditor.prototype.setSize=function(t,l){
var h=this._spellCheckDivId&&document.getElementById(this._spellCheckDivId);
var e=document.getElementById(this.getBodyFieldId());
var s=this._mode==DwtHtmlEditor.HTML?8:10;
if(t==Dwt.CLEAR){
e.style.width=null;
if(h){
h.style.width=null
}}else{
if(t==Dwt.DEFAULT){
e.style.width="auto";
if(h){
h.style.width="auto"
}}else{
if(typeof(t)=="number"){
t-=s+4;
if(t<0){
t=0
}
e.style.width=t+5+"px";
if(h){
if(!AjxEnv.isIE){
t=t>4?(t-4):t
}
h.style.width=t+"px"
}}}}
if(l==Dwt.CLEAR){
e.style.height=null;
if(h){
h.style.height=null
}}else{
if(l==Dwt.DEFAULT){
e.style.height="auto";
if(h){
h.style.height="auto"
}}else{
if(typeof(l)=="number"){
if(this._spellCheckModeDivId){
var a=document.getElementById(this._spellCheckModeDivId).offsetHeight;
l-=(isNaN(a)?0:a)
}
if(this._mode==DwtHtmlEditor.HTML&&this._toolbars.length>0){
for(var o=0;
o<this._toolbars.length;
o++){
var n=this._toolbars[o];
l-=n.getHtmlElement().offsetHeight
}}
l-=s;
if(l<0){
l=0
}
e.style.height=l+"px";
if(h){
if(!AjxEnv.isIE){
l=l>4?(l-4):l
}else{
l+=2
}
h.style.height=l+"px"
}}}}};
ZmHtmlEditor.prototype._initialize=function(){
if(this._mode==DwtHtmlEditor.HTML){
this._createToolbars()
}
DwtHtmlEditor.prototype._initialize.call(this)
};
ZmHtmlEditor.prototype._styleListener=function(e){
this.setStyle(e.item.getData(ZmHtmlEditor._VALUE))
};
ZmHtmlEditor.prototype._fontFamilyListener=function(e){
this.setFont(DwtHtmlEditor._normalizeFontValue(e.item.getData(ZmHtmlEditor._VALUE)))
};
ZmHtmlEditor.prototype._fontSizeListener=function(e){
this.setFont(null,null,e.item.getData(ZmHtmlEditor._VALUE))
};
ZmHtmlEditor.prototype._indentListener=function(e){
this.setIndent(e.item.getData(ZmHtmlEditor._VALUE))
};
ZmHtmlEditor.prototype._insertLinkListener=function(){
var o=this._insertLinkDialog;
if(!o){
o=this._insertLinkDialog=new DwtDialog({
parent:DwtShell.getShell(window),title:ZmMsg.linkProperties}
);
var n=o.base_id=Dwt.getNextId();
var a=AjxTemplate.expand("share.Dialogs#EditorInsertLink",{
id:n}
);
o.setContent(a);
o.linkText=new DwtInputField({
parent:o,size:40,parentElement:n+"_linkTextCont"}
);
o.linkTarget=new DwtInputField({
parent:o,size:40,parentElement:n+"_linkTargetCont"}
);
function e(){
var s=o.linkTarget.getValue();
if(s&&!/^(https?|ftp|notes|cid):\x2f\x2f/i.test(s)&&!/^mailto:([a-zA-Z0-9_.-])+@([a-zA-Z0-9_.-])+\.([a-zA-Z])+([a-zA-Z])+/i.test(s)){
s="http://"+s;
o.linkTarget.setValue(s)
}
return s
}
var t=new DwtButton({
parent:o,parentElement:n+"_testBtnCont"}
);
t.setText(ZmMsg.testUrl);
t.setToolTipContent(ZmMsg.testUrlTooltip);
t.addSelectionListener(new AjxListener(this,function(){
var s=e();
if(s){
window.open(s)
}}
));
o._tabGroup.addMember(o.linkText,0);
o._tabGroup.addMember(o.linkTarget,1);
o._tabGroup.addMember(t,2);
o.registerCallback(DwtDialog.OK_BUTTON,new AjxListener(this,function(){
var h=e();
var s=this.getNearestElement("img");
var l=o.linkText.getValue()||h;
if(s){
var l=o.linkText.getValue()
}
o.popdown();
this.insertLink({
text:l,url:h}
)
}
))
}
var i=this.getLinkProps();
o.linkText.setValue(i.text||"");
o.linkTarget.setValue(i.url||"");
o.popup();
if(/\S/.test(i.text)){
o.linkTarget.focus()
}else{
o.linkText.focus()
}};
ZmHtmlEditor.prototype._insElementListener=function(e){
this.insertElement(e.item.getData(ZmHtmlEditor._VALUE))
};
ZmHtmlEditor.prototype._justificationListener=function(e){
this.setJustification(e.item.getData(ZmHtmlEditor._VALUE))
};
ZmHtmlEditor.prototype._fontStyleListener=function(e){
this.setFont(null,e.item.getData(ZmHtmlEditor._VALUE))
};
ZmHtmlEditor.prototype._fontColorListener=function(e){
this.setFont(null,null,null,e.detail||"#000000")
};
ZmHtmlEditor.prototype._fontHiliteListener=function(e){
this.setFont(null,null,null,null,e.detail||"#ffffff")
};
ZmHtmlEditor.prototype._createToolbars=function(t){
if(!this._toolbar1){
var e=this._toolbar1=new DwtToolBar({
parent:this,className:"ZToolbar",posStyle:DwtControl.RELATIVE_STYLE,cellSpacing:2,index:0}
);
e.setVisible(this._mode==DwtHtmlEditor.HTML);
if(!t){
this._createToolBar1(e);
new DwtControl({
parent:e,className:"vertSep"}
);
this._createToolBar2(e);
this._resetFormatControls()
}
this._toolbars.push(e)
}};
ZmHtmlEditor.prototype._createToolBar1=function(e){
this._createFontFamilyMenu(e);
this._createFontSizeMenu(e);
this._createStyleMenu(e);
this._createJustifyMenu(e);
new DwtControl({
parent:e,className:"vertSep"}
);
this._createListMenu(e);
this._createIndentMenu(e);
new DwtControl({
parent:e,className:"vertSep"}
);
this._createBUIButtons(e);
appCtxt.notifyZimlets("on_htmlEditor_createToolbar1",[this,e])
};
ZmHtmlEditor.prototype._createToolBar2=function(e){
this._createFontColorButtons(e);
new DwtControl({
parent:e,className:"vertSep"}
);
this._createHorizRuleButton(e);
this._createUrlButton(e);
this._createTableMenu(e);
if(this.ACE_ENABLED){
this._createSpreadSheetButton(e)
}
appCtxt.notifyZimlets("on_htmlEditor_createToolbar2",[this,e])
};
ZmHtmlEditor.prototype.__createTableOperationItems=function(e){
var h=new AjxListener(this,this._tableOperationsListener);
var s=["tableProperties...","cellProperties...",null,"insertRowAbove","insertRowUnder","deleteRow",null,"insertColumnBefore","insertColumnAfter","deleteColumn",null];
if(AjxEnv.isGeckoBased){
s.push("mergeCells","splitCells",null)
}
s.push("deleteTable");
var a=["TableProperties","CellProperties",null,"InsertRowBefore","InsertRowAfter","DeleteRow",null,"InsertColBefore","InsertColAfter","DeleteCol",null,"MergeCells","SplitCells",null,"DeleteTable"];
e._tblItems={};
for(var n=0;
n<s.length;
++n){
var t=s[n];
if(t==null){
new DwtMenuItem({
parent:e,style:DwtMenuItem.SEPARATOR_STYLE}
)
}else{
var l="";
if(/\.\.\.$/.test(t)){
t=t.substr(0,t.length-3);
l="&hellip;"
}
var c=new DwtMenuItem({
parent:e}
);
e._tblItems[t]=c;
var o=ZmMsg[t]||t;
c.setText(o+l);
if(a[n]){
c.setImage(a[n])
}
c.setData("TableOperations",t);
c.addSelectionListener(h)
}}
e.addPopupListener(new AjxListener(this,this.__onTableOperationsPopup))
};
ZmHtmlEditor.prototype.__onTableOperationsPopup=function(t){
this.focus();
var m=this.getNearestElement("table");
var c=t._tblItems;
for(var s in c){
c[s].setEnabled(!!m)
}
if(!m){
return
}
t.setData("table",m);
if(!AjxEnv.isIE){
var o=this.getNearestElement("td");
var d=o&&((o.colSpan&&o.colSpan>1)||(o.rowSpan&&o.rowSpan>1));
if(c.splitCells){
c.splitCells.setEnabled(d)
}
var u=this.getSelectedCells();
var f=true;
var h=0;
try{
for(var s=u.length;
--s>=0;
){
var e=u[s];
for(var n=e.length;
--n>=0;
){
var o=e[n];
++h;
if(o.rowSpan>1||o.colSpan>1){
throw"can't merge"
}}}}
catch(l){
f=false
}
if(h<2){
f=false
}
if(c.mergeCells){
c.mergeCells.setEnabled(f)
}}};
ZmHtmlEditor.prototype._tableOperationsListener=function(a){
var t=a.item;
var e=t.parent.getData("table");
var i=t.getData("TableOperations");
this.focus();
switch(i){
case"tableProperties":AjxDispatcher.require("Extras");
var o=ZmTableEditor.getTablePropsDialog(this,this.getNearestElement("table"));
o.popup();
break;
case"cellProperties":AjxDispatcher.require("Extras");
var o=ZmTableEditor.getCellPropsDialog(this,this.getNearestElement("table"),this.getSelectedCells());
o.popup();
break;
default:this.doTableOperation(i,{
table:e,cells:this.getSelectedCells()}
)
}};
ZmHtmlEditor.prototype._createTableListener=function(t){
var e=t.detail;
this.insertTable(e.rows,e.cols,"90%",null,3,"center")
};
ZmHtmlEditor.prototype._menu_insertObject=function(t){
var e=t.item;
var a=e.getData("ACE");
this.insertObject(a)
};
ZmHtmlEditor.prototype.insertObject=function(e,s,o){
var a=document.URL.replace(/^(https?:\x2f\x2f[^\x2f]+\x2f?).*$/i,"$1").replace(/\x2f*$/,"");
var n=null;
switch(e){
case"ZmSpreadSheet":n=[a,appContextPath,"/public/Spreadsheet.jsp?localeId=",AjxEnv.DEFAULT_LOCALE].join("");
break
}
if(n){
var l=this._getIframeDoc();
this.focus();
++this._ace_componentsLoading;
if(AjxEnv.isGeckoBased){
Dwt.enableDesignMode(l,false)
}
var i=l.createElement("iframe");
i.id="ACE-"+Dwt.getNextId();
i.frameBorder=0;
i.src=n;
i.style.width="100%";
i.style.height="400px";
i.ondragstart=AjxCallback.returnFalse;
if(!s){
var t=l.createElement("br");
var h=l.createDocumentFragment();
h.appendChild(t);
h.appendChild(i);
h.appendChild(t.cloneNode(true));
this._insertNodeAtSelection(h)
}else{
s.parentNode.replaceChild(i,s)
}
var c=AjxCallback.simpleClosure(this._ace_finishedLoading,this,i,e,o);
if(AjxEnv.isIE){
i.onreadystatechange=c
}else{
i.addEventListener("load",c,true)
}}};
ZmHtmlEditor.prototype._ace_finishedLoading=function(i,t,a){
var e=this;
if(!AjxEnv.isIE||i.readyState=="complete"){
setTimeout(function(){
try{
var n=Dwt.getIframeWindow(i);
n.ZmACE=true;
n.ZmACE_COMPONENT_NAME=t;
i.onload=null;
i.onreadystatechange=null;
n.create(a);
--e._ace_componentsLoading
}
catch(o){
--e._ace_componentsLoading;
var s=appCtxt.getErrorDialog();
s.setMessage(ZmMsg.aleError,o.msg||o.toString(),DwtMessageDialog.WARNING_STYLE,"ALE error");
s.popup(null,true)
}}
,10)
}};
ZmHtmlEditor.prototype._getAceObjects=function(){
var o=this._getIframeDoc().getElementsByTagName("iframe");
var e=new Array(o.length);
for(var t=o.length;
--t>=0;
){
e[t]=o[t]
}
return e
};
ZmHtmlEditor.prototype._embedHtmlContent=function(a,e,t){
if(!e&&!t){
if(!(this.ACE_ENABLED&&this._headContent)){
return DwtHtmlEditor.prototype._embedHtmlContent.call(this,a)
}}
if(e){
a=this._getFontStyle(a)
}
if(t){
return a
}
var o=this._headContent?this._headContent.join(""):"";
var i="<style type='text/css'>p { margin: 0; }</style>";
return["<html><head>",i,o,"</head><body>",a,"</body></html>"].join("")
};
ZmHtmlEditor.prototype._getFontStyle=function(o){
var e=[],t=0;
e[t++]="<div style='font-family: ";
e[t++]=DwtHtmlEditor._normalizeFontValue(appCtxt.get(ZmSetting.COMPOSE_INIT_FONT_FAMILY));
e[t++]="; font-size: ";
e[t++]=appCtxt.get(ZmSetting.COMPOSE_INIT_FONT_SIZE);
e[t++]="; color: ";
e[t++]=appCtxt.get(ZmSetting.COMPOSE_INIT_FONT_COLOR);
e[t++]="'>";
e[t++]=o;
e[t++]="</div>";
return e.join("")
};
ZmHtmlEditor.prototype._serializeAceObjects=function(t){
this._headContent=[];
var e={};
var a=AjxCallback.simpleClosure(this._replaceAceIframes,this,e);
return t.replace(ZmHtmlEditor.ACE_IFRAME_RE,a)
};
ZmHtmlEditor.prototype._replaceAceIframes=function(e,a,h){
var o=this._getIframeDoc().getElementById(h);
var s=Dwt.getIframeWindow(o);
var i=s.getHTML();
var n=s.serialize().replace(/&/g,"&amp;").replace(/>/g,"&gt;");
var t=s.ZmACE_COMPONENT_NAME;
if(!e[t]&&typeof s.getHeadHTML=="function"){
e[t]=true;
this._headContent.push(s.getHeadHTML())
}
return['<div class="ACE ',t,'">',i,"<!--","ACE[",t,"]:",n,"-->","</div>"].join("")
};
ZmHtmlEditor.prototype._deserializeAceObjects=function(){
var n=this._getIframeDoc().getElementsByTagName("div");
var o=new Array(n.length);
for(var a=0;
a<n.length;
++a){
o[a]=n.item(a)
}
n=o;
for(var a=0;
a<n.length;
++a){
var t=n[a];
if(/^ACE\s+([^\s]+)/.test(t.className)){
var e=RegExp.$1;
var s=t.lastChild;
if(s.nodeType==8){
s=s.data;
var h="ACE["+e+"]:";
if(s.indexOf(h)==0){
s=s.substr(h.length).replace(/&gt;/g,">").replace(/&amp;/g,"&");
this.insertObject(e,t,s)
}}}}};
ZmHtmlEditor.prototype._createBUIButtons=function(e){
var a={
parent:e,style:DwtButton.TOGGLE_STYLE};
var t=new AjxListener(this,this._fontStyleListener);
this._boldButton=new DwtToolBarButton(a);
this._boldButton.setImage("Bold");
this._boldButton.setToolTipContent(appCtxt.getShortcutHint("editor",DwtKeyMap.TEXT_BOLD));
this._boldButton.setData(ZmHtmlEditor._VALUE,DwtHtmlEditor.BOLD_STYLE);
this._boldButton.addSelectionListener(t);
this._italicButton=new DwtToolBarButton(a);
this._italicButton.setImage("Italics");
this._italicButton.setToolTipContent(appCtxt.getShortcutHint("editor",DwtKeyMap.TEXT_ITALIC));
this._italicButton.setData(ZmHtmlEditor._VALUE,DwtHtmlEditor.ITALIC_STYLE);
this._italicButton.addSelectionListener(t);
this._underlineButton=new DwtToolBarButton(a);
this._underlineButton.setImage("Underline");
this._underlineButton.setToolTipContent(appCtxt.getShortcutHint("editor",DwtKeyMap.TEXT_UNDERLINE));
this._underlineButton.setData(ZmHtmlEditor._VALUE,DwtHtmlEditor.UNDERLINE_STYLE);
this._underlineButton.addSelectionListener(t)
};
ZmHtmlEditor.prototype._createFontColorButtons=function(e){
this._fontColorButton=new ZmHtmlEditorColorPicker(e,null,"ZToolbarButton");
this._fontColorButton.dontStealFocus();
this._fontColorButton.setImage("FontColor");
this._fontColorButton.showColorDisplay(true);
this._fontColorButton.setToolTipContent(ZmMsg.fontColor);
this._fontColorButton.addSelectionListener(new AjxListener(this,this._fontColorListener));
this._fontBackgroundButton=new ZmHtmlEditorColorPicker(e,null,"ZToolbarButton");
this._fontBackgroundButton.dontStealFocus();
this._fontBackgroundButton.setImage("FontBackground");
this._fontBackgroundButton.showColorDisplay(true);
this._fontBackgroundButton.setToolTipContent(ZmMsg.fontBackground);
this._fontBackgroundButton.addSelectionListener(new AjxListener(this,this._fontHiliteListener))
};
ZmHtmlEditor.prototype._createHorizRuleButton=function(e){
var t={
parent:e};
this._horizRuleButton=new DwtToolBarButton(t);
this._horizRuleButton.setImage("HorizRule");
this._horizRuleButton.setToolTipContent(ZmMsg.horizRule);
this._horizRuleButton.setData(ZmHtmlEditor._VALUE,DwtHtmlEditor.HORIZ_RULE);
this._horizRuleButton.addSelectionListener(new AjxListener(this,this._insElementListener))
};
ZmHtmlEditor.prototype._createUrlButton=function(e){
var t={
parent:e};
this._insertLinkButton=new DwtToolBarButton(t);
this._insertLinkButton.setImage("URL");
this._insertLinkButton.setToolTipContent(ZmMsg.insertLink);
this._insertLinkButton.addSelectionListener(new AjxListener(this,this._insertLinkListener))
};
ZmHtmlEditor.prototype._createTableMenu=function(t){
var s={
parent:t};
var e=this._tableMenu=new DwtToolBarButton(s);
e.setToolTipContent(ZmMsg.insertTable);
e.dontStealFocus();
e.setImage("Table");
var n=new DwtMenu({
parent:e}
);
e.setMenu(n);
var o=new DwtMenuItem({
parent:n}
);
o.setText(ZmMsg.insertTable);
var i=new DwtMenu({
parent:o,style:DwtMenu.GENERIC_WIDGET_STYLE}
);
var a=new DwtGridSizePicker(i,ZmMsg.tableSize);
a.addSelectionListener(new AjxListener(this,this._createTableListener));
o.setMenu(i);
o.setImage("InsertTable");
new DwtMenuItem({
parent:n,style:DwtMenuItem.SEPARATOR_STYLE}
);
this.__createTableOperationItems(n)
};
ZmHtmlEditor.prototype._createSpreadSheetButton=function(t){
new DwtControl({
parent:t,className:"vertSep"}
);
var a={
parent:t,style:0};
var e=new DwtToolBarButton(a);
e.setImage("SpreadSheet");
e.setData("ACE","ZmSpreadSheet");
e.setToolTipContent(ZmMsg.insertSpreadsheet);
e.addSelectionListener(new AjxListener(this,this._menu_insertObject))
};
ZmHtmlEditor.prototype._createStyleMenu=function(e){
var n=new DwtToolBarButton({
parent:e}
);
n.setText("x");
n._textEl.innerHTML="<span style='font-size:13px'>&sect;</span>";
n.setToolTipContent(ZmMsg.sections);
n.dontStealFocus();
var c=this._styleMenu=new ZmPopupMenu(n);
var l=new AjxListener(this,this._styleListener);
var o=[{
label:ZmMsg.normal,id:DwtHtmlEditor.PARAGRAPH}
,{
label:ZmMsg.heading1,id:DwtHtmlEditor.H1}
,{
label:ZmMsg.heading2,id:DwtHtmlEditor.H2}
,{
label:ZmMsg.heading3,id:DwtHtmlEditor.H3}
,{
label:ZmMsg.heading4,id:DwtHtmlEditor.H4}
,{
label:ZmMsg.heading5,id:DwtHtmlEditor.H5}
,{
label:ZmMsg.heading6,id:DwtHtmlEditor.H6}
,{
label:ZmMsg.address,id:DwtHtmlEditor.ADDRESS}
,{
label:ZmMsg.preformatted,id:DwtHtmlEditor.PREFORMATTED}
];
for(var a=0;
a<o.length;
a++){
var h=o[a];
var t=c.createMenuItem(h.id,{
text:h.label,style:DwtMenuItem.RADIO_STYLE}
);
t.addSelectionListener(l);
t.setData(ZmHtmlEditor._VALUE,h.id);
if(a==0){
t.setChecked(true,true)
}}
n.setMenu(c)
};
ZmHtmlEditor.prototype._createListMenu=function(t){
var e=this._listMenuButton=new DwtToolBarButton({
parent:t}
);
e.dontStealFocus();
e.setImage("BulletedList");
e.setToolTipContent(ZmMsg.bulletedList);
var a=new AjxListener(this,this._insElementListener);
var n=this._listMenu=new ZmPopupMenu(e);
var i=this._bulletListMenuItem=n.createMenuItem(DwtHtmlEditor.UNORDERED_LIST,{
image:"BulletedList",style:DwtMenuItem.SELECT_STYLE}
);
i.addSelectionListener(a);
i.setData(ZmHtmlEditor._VALUE,DwtHtmlEditor.UNORDERED_LIST);
var o=this._numberListMenuItem=n.createMenuItem(DwtHtmlEditor.ORDERED_LIST,{
image:"NumberedList",style:DwtMenuItem.SELECT_STYLE}
);
o.addSelectionListener(a);
o.setData(ZmHtmlEditor._VALUE,DwtHtmlEditor.ORDERED_LIST);
e.setMenu(n)
};
ZmHtmlEditor.prototype._createIndentMenu=function(t){
var e=this._indentMenuButton=new DwtToolBarButton({
parent:t}
);
e.dontStealFocus();
e.setImage("Outdent");
e.setToolTipContent(ZmMsg.indentTooltip);
var o=new AjxListener(this,this._indentListener);
var n=this._indentMenu=new ZmPopupMenu(e);
var a=this._indentMenuItem=n.createMenuItem(DwtHtmlEditor.OUTDENT,{
image:"Outdent",style:DwtMenuItem.SELECT_STYLE}
);
a.addSelectionListener(o);
a.setData(ZmHtmlEditor._VALUE,DwtHtmlEditor.OUTDENT);
var i=this._outdentMenuItem=n.createMenuItem(DwtHtmlEditor.INDENT,{
image:"Indent",style:DwtMenuItem.SELECT_STYLE}
);
i.addSelectionListener(o);
i.setData(ZmHtmlEditor._VALUE,DwtHtmlEditor.INDENT);
e.setMenu(n)
};
ZmHtmlEditor.prototype._createJustifyMenu=function(t){
var e=new DwtToolBarButton({
parent:t}
);
e.dontStealFocus();
e.setImage("LeftJustify");
e.setToolTipContent(ZmMsg.alignment);
var l=this._justifyMenu=new ZmPopupMenu(e);
var h=new AjxListener(this,this._justificationListener);
var n=[{
image:"LeftJustify",id:DwtHtmlEditor.JUSTIFY_LEFT}
,{
image:"CenterJustify",id:DwtHtmlEditor.JUSTIFY_CENTER}
,{
image:"RightJustify",id:DwtHtmlEditor.JUSTIFY_RIGHT}
,{
image:"FullJustify",id:DwtHtmlEditor.JUSTIFY_FULL}
];
for(var o=0;
o<n.length;
o++){
var s=n[o];
var a=l.createMenuItem(s.id,{
image:s.image,style:DwtMenuItem.RADIO_STYLE}
);
a.addSelectionListener(h);
a.setData(ZmHtmlEditor._VALUE,s.id);
if(o==0){
a.setChecked(true,true)
}}
e.setMenu(l,false,DwtMenuItem.RADIO_STYLE)
};
ZmHtmlEditor.prototype._createFontFamilyMenu=function(e){
this._fontFamilyButton=new DwtToolBarButton({
parent:e}
);
this._fontFamilyButton.dontStealFocus();
this._fontFamilyButton.setSize(Dwt.DEFAULT);
this._fontFamilyButton.setAlign(DwtLabel.ALIGN_LEFT);
var o=new ZmPopupMenu(this._fontFamilyButton);
var i=new AjxListener(this,this._fontFamilyListener);
for(var n in DwtHtmlEditor.FONT_FAMILY){
var a=DwtHtmlEditor.FONT_FAMILY[n]&&DwtHtmlEditor.FONT_FAMILY[n].name||ZmHtmlEditor.__makeFontName(n);
var t=o.createMenuItem(a,{
text:a}
);
t.addSelectionListener(i);
t.setData(ZmHtmlEditor._VALUE,DwtHtmlEditor.FONT_FAMILY[n]&&DwtHtmlEditor.FONT_FAMILY[n].value||ZmHtmlEditor.__makeFontName(n))
}
this._fontFamilyButton.setMenu(o)
};
ZmHtmlEditor.prototype._createFontSizeMenu=function(e){
this._fontSizeButton=new DwtToolBarButton({
parent:e}
);
this._fontSizeButton.dontStealFocus();
var l=new ZmPopupMenu(this._fontSizeButton);
var s=new AjxListener(this,this._fontSizeListener);
for(var o=0;
o<ZmHtmlEditor.FONT_SIZE_VALUES.length;
o++){
var n=ZmHtmlEditor.FONT_SIZE_VALUES[o];
var a=o+1;
var h=a+" ("+n+")";
var t=l.createMenuItem(o,{
text:h}
);
t.addSelectionListener(s);
t.setData(ZmHtmlEditor._VALUE,a)
}
this._fontSizeButton.setMenu(l)
};
ZmHtmlEditor.prototype._getFontSizeLabel=function(a){
for(var e=0;
e<ZmHtmlEditor.FONT_SIZE_VALUES.length;
e++){
var t=ZmHtmlEditor.FONT_SIZE_VALUES[e];
if(a==t){
return((e+1)+" ("+t+")")
}}
return"3 (12pt)"
};
ZmHtmlEditor.prototype._rteStateChangeListener=function(t){
this._boldButton.setSelected(t.isBold);
this._underlineButton.setSelected(t.isUnderline);
this._italicButton.setSelected(t.isItalic);
if(this._strikeThruButton){
this._strikeThruButton.setSelected(t.isStrikeThru)
}
if(this._subscriptButton){
this._subscriptButton.setSelected(t.isSubscript)
}
if(this._superscriptButton){
this._superscriptButton.setSelected(t.isSuperscript)
}
if(t.color){
this._fontColorButton.setColor(t.color)
}
if(t.backgroundColor){
this._fontBackgroundButton.setColor(t.backgroundColor)
}
if(t.style){
this._styleMenu.checkItem(ZmHtmlEditor._VALUE,t.style,true)
}
if(!AjxEnv.isIE){
if(t.fontFamily){
this._fontFamilyButton.setText(DwtHtmlEditor._normalizeFontName(t.fontFamily))
}
if(t.fontSize){
var e=this._fontSizeButton.getMenu().getItem(parseInt(t.fontSize)-1);
if(e){
this._fontSizeButton.setText(e.getText())
}}}
this._justifyMenu.checkItem(ZmHtmlEditor._VALUE,t.justification,true)
};
ZmHtmlEditor.prototype._settingChangeListener=function(e){
if(e.type!=ZmEvent.S_SETTING){
return
}
var t=e.source.id;
if(t==ZmSetting.COMPOSE_INIT_FONT_COLOR||t==ZmSetting.COMPOSE_INIT_FONT_FAMILY||t==ZmSetting.COMPOSE_INIT_FONT_SIZE){
this._resetFormatControlDefaults();
this._fontStyle=null
}};
ZmHtmlEditor.prototype._handleEditorEvent=function(s){
var a=this._eventCallback?this._eventCallback.run(s):true;
if(a){
a=DwtHtmlEditor.prototype._handleEditorEvent.call(this,s)
}
if(this._TIMER_spell){
clearTimeout(this._TIMER_spell)
}
var l=this;
if(this._spellCheck){
var e;
if(/mouse|context|click|select/i.test(s.type)){
e=new DwtMouseEvent(true)
}else{
e=new DwtUiEvent(true)
}
e.setFromDhtmlEvent(s);
this._TIMER_spell=setTimeout(function(){
l._handleSpellCheckerEvents(e);
this._TIMER_spell=null
}
,100)
}
if(/keydown/i.test(s.type)){
if(s.keyCode==13){
var i=this._getParentElement();
var o=i;
while(o){
var h=Dwt.getAttr(o,"tagName");
if(h&&h.toLowerCase()==="blockquote"){
break
}
o=o.parentNode
}
if(o){
this._splitBlockquote(o,i);
a=false
}}
if(s.keyCode==8||s.keyCode==46){
setTimeout(AjxCallback.simpleClosure(function(){
var m,d;
for(var u=this._getIframeDoc().body.firstChild;
u&&u.nextSibling;
u=u.nextSibling){
var c=u.nextSibling;
if(c&&c.tagName&&c.tagName.toLowerCase()=="p"&&this._elementIsIEFiller(c.firstChild)){
c=c.nextSibling
}
if(c&&u.tagName&&c.tagName&&u.tagName.toLowerCase()=="blockquote"&&c.tagName.toLowerCase()=="blockquote"){
this._mergeBlockquotes(u,c)
}}}
,this),5);
if(s.keyCode==46){
if(!AjxEnv.isIE){
var n=this._getRange();
var t=n.startContainer.childNodes[n.startOffset];
if(t&&t.tagName&&t.tagName.toLowerCase()=="br"){
this._removeElement(t);
if(s.preventDefault){
s.preventDefault()
}
a=false
}}}}}
return a
};
ZmHtmlEditor.prototype._splitBlockquote=function(e,i){
var d,a,n=null,s=null;
var l,h;
if(AjxEnv.isIE){
var u=this._getIframeDoc();
d=u.selection.createRange();
d.collapse(false);
a=i;
var T="###"+Dwt.getNextId()+"###";
d.pasteHTML(T);
n=a.innerHTML.indexOf(T);
a.innerHTML=a.innerHTML.replace(T,"");
l=n?a.innerHTML.substring(0,n):"";
h=a.innerHTML.substring(n)
}else{
d=this._getRange();
d.collapse(false);
var o=d.startContainer.nodeType;
if(o==3||o==4||o==8){
n=d.startOffset;
a=d.startContainer.parentNode;
l=n?d.startContainer.textContent.substring(0,n):"";
h=d.startContainer.textContent.substring(n);
var v=d.startContainer.previousSibling;
while(v){
l=this._getElementHTML(v)+l;
v=v.previousSibling
}
v=d.startContainer.nextSibling;
while(v){
h=h+this._getElementHTML(v);
v=v.nextSibling
}}else{
s=d.startOffset;
a=d.startContainer
}}
var w=a.id=a.id||Dwt.getNextId();
var y=e.cloneNode(true);
var f=a;
var m=Dwt.byId(w,y);
m.removeAttribute("id");
if(n!==null){
f.innerHTML=l;
m.innerHTML=h
}else{
if(s!==null){
this._removeNextSiblings(f.childNodes[s]);
var k=m.childNodes[s];
this._removePreviousSiblings(k);
this._removeElement(k)
}}
while(f!=e){
this._removeNextSiblings(f);
f=f.parentNode
}
while(m!=y){
this._removePreviousSiblings(m);
m=m.parentNode
}
if(e.nextSibling){
e.parentNode.insertBefore(y,e.nextSibling)
}else{
e.parentNode.appendChild(y)
}
if(AjxEnv.isIE){
var g=document.createElement("p");
var j=document.createElement("span");
var x=document.createElement("span");
var z=document.createElement("br");
j.appendChild(x);
j.appendChild(z);
g.appendChild(j);
y.parentNode.insertBefore(g,y);
this._setCursor(x);
this._setIEFiller(j);
x.parentNode.removeChild(x)
}else{
if(AjxEnv.isSafari){
var c=this;
setTimeout(function(){
var O;
if(e.lastChild&&e.lastChild.childElementCount==1&&e.lastChild.firstChild instanceof HTMLBRElement){
O=e.lastChild
}else{
if(y.firstChild&&y.firstChild.childElementCount==1&&y.firstChild.firstChild instanceof HTMLBRElement){
O=y.firstChild
}}
if(O){
e.parentNode.insertBefore(O,y);
d.setStart(O,0);
var t=c._getSelection();
t.removeAllRanges();
t.addRange(d)
}}
,5)
}
d.setStartAfter(e);
var q=this._getSelection();
q.removeAllRanges();
q.addRange(d)
}};
ZmHtmlEditor.prototype._getElementHTML=function(t){
if(AjxEnv.isIE){
return t.outerHTML
}
var e=document.createElement(t.parentNode&&t.parentNode.tagName||"span");
e.appendChild(t.cloneNode(true));
return e.innerHTML
};
ZmHtmlEditor.prototype._removeElement=function(e){
if(e&&e.parentNode){
e.parentNode.removeChild(e)
}};
ZmHtmlEditor.prototype._removePreviousSiblings=function(e){
if(e&&e.parentNode){
while(e.previousSibling){
this._removeElement(e.previousSibling)
}}};
ZmHtmlEditor.prototype._removeNextSiblings=function(e){
if(e&&e.parentNode){
while(e.nextSibling){
this._removeElement(e.nextSibling)
}}};
ZmHtmlEditor.prototype._selectNode=function(a){
var i;
var e=this._getRange();
while(!i&&a){
try{
e.setStartBefore(a);
i=true
}
catch(t){
a=a.parentNode;
i=false
}}};
ZmHtmlEditor.prototype._nextElement=function(e){
if(e.childNodes&&e.childNodes.length){
return e.childNodes[0]
}
if(e.nextSibling){
return e.nextSibling
}
var t=e.parentNode;
while(!e.nextSibling){
e=e.parentNode;
if(!e){
return null
}}
return e.nextSibling
};
ZmHtmlEditor.prototype._elementIsIEFiller=function(t){
if(t&&t.attributes){
for(var e=0;
e<t.attributes.length;
e++){
if(t.attributes[e].name=="_ieFiller"){
return true
}}}};
ZmHtmlEditor.prototype._setIEFiller=function(e){
if(e){
e.setAttribute("_ieFiller","")
}};
ZmHtmlEditor.prototype._removeIEFiller=function(t){
if(t){
if(this._elementIsIEFiller(t)){
t.parentNode.removeChild(t)
}
for(var e=0;
e<t.children.length;
e++){
this._removeIEFiller(t.children[e])
}}};
ZmHtmlEditor.prototype._mergeBlockquotes=function(h,s){
if(AjxEnv.isIE){
this._removeIEFiller(h.lastChild)
}
var i=h;
var u=0;
while(i.childNodes.length){
i=i.childNodes[i.childNodes.length-1];
while(i.previousSibling&&i.tagName=="BR"){
i=i.previousSibling
}
u++
}
var a=s;
var d=0;
while(a.childNodes.length){
a=a.childNodes[0];
d++
}
if(i.nodeType==3){
i=i.parentNode;
u--
}
if(a.nodeType==3){
a=a.parentNode;
d--
}
var l=(AjxEnv.isIE)?this._getIframeDoc().selection.createRange():this._getRange();
if(u==d){
var f=[i.innerHTML,a.innerHTML];
var o="###"+Dwt.getNextId()+"###";
i.innerHTML=f.join(o);
var n=i.innerHTML.replace(/<br>/ig," ").replace(/<\/?[^>]+>/g,"").indexOf(o);
i.innerHTML=f.join("");
if(AjxEnv.isIE){
l.moveToElementText(i);
l.moveStart("character",n)
}else{
var e;
for(var e=i;
e!=null&&n>0;
e=this._nextElement(e)){
var m=e.nodeType;
var c=e.textContent||e.innerText||e.innerHTML||"";
if(m==3||m==4||m==8){
if(n<=c.length){
break
}
n-=c.length
}else{
if(e.tagName.toLowerCase()=="br"){
n--
}
if(n==0){
break
}}}
l.setStart(e,n)
}}else{
if(u==d+1){
while(a.firstChild){
i.parentNode.appendChild(a.firstChild)
}
if(AjxEnv.isIE){
var m=e.nodeType;
var n=1;
if(m==3||m==4||m==8){
n=e.length;
e=e.parentNode
}
l.moveToElementText(e);
l.moveStart("character",n)
}else{
if(i.tagName&&i.tagName.toLowerCase()=="br"){
l.setStartBefore(i)
}else{
l.setStartAfter(i)
}}
i=i.parentNode
}else{
if(u+1==d){
var e=i.childNodes.length?i.childNodes[i.childNodes.length-1]:i;
a=a.parentNode;
while(a.firstChild){
i.appendChild(a.firstChild)
}
if(AjxEnv.isIE){
var m=e.nodeType;
var n=1;
if(m==3||m==4||m==8){
n=e.length;
e=e.parentNode
}
l.moveToElementText(e);
l.moveStart("character",n)
}else{
if(e.tagName&&e.tagName.toLowerCase()=="br"){
l.setStartBefore(e)
}else{
l.setStartAfter(e)
}}}else{
return
}}}
while(i!=h&&a!=s){
while(a.nextSibling){
i.parentNode.appendChild(a.nextSibling)
}
i=i.parentNode;
a=a.parentNode
}
this._removeElement(s);
l.collapse(true);
if(AjxEnv.isIE){
l.select()
}else{
var t=this._getSelection();
t.removeAllRanges();
t.addRange(l)
}};
ZmHtmlEditor._spellCheckResumeEditing=function(){
var e=Dwt.getObjectFromElement(this);
e.discardMisspelledWords()
};
ZmHtmlEditor._spellCheckAgain=function(){
var e=Dwt.getObjectFromElement(this);
e.discardMisspelledWords();
e.spellCheck()
};
ZmHtmlEditor.prototype._spellCheckShowModeDiv=function(){
var o=this.getSize();
if(!this._spellCheckModeDivId){
var s=document.createElement("div");
s.className="SpellCheckModeDiv";
s.id=this._spellCheckModeDivId=Dwt.getNextId();
var a=new Array();
var t=0;
a[t++]="<table border=0 cellpadding=0 cellspacing=0><tr><td style='width:25'>";
a[t++]=AjxImg.getImageHtml("SpellCheck");
a[t++]="</td><td style='white-space:nowrap'><span class='SpellCheckLink'>";
a[t++]=ZmMsg.resumeEditing;
a[t++]="</span> | <span class='SpellCheckLink'>";
a[t++]=ZmMsg.checkAgain;
a[t++]="</span></td></tr></table>";
s.innerHTML=a.join("");
var e=document.getElementById((this._spellCheckDivId||this.getBodyFieldId()));
e.parentNode.insertBefore(s,e);
var n=s.getElementsByTagName("span");
Dwt.associateElementWithObject(n[0],this);
Dwt.setHandler(n[0],"onclick",ZmHtmlEditor._spellCheckResumeEditing);
Dwt.associateElementWithObject(n[1],this);
Dwt.setHandler(n[1],"onclick",ZmHtmlEditor._spellCheckAgain)
}else{
document.getElementById(this._spellCheckModeDivId).style.display=""
}
this.setSize(o.x,o.y+(this._mode==DwtHtmlEditor.TEXT?1:2))
};
ZmHtmlEditor.prototype._spellCheckHideModeDiv=function(){
var e=this.getSize();
if(this._spellCheckModeDivId){
document.getElementById(this._spellCheckModeDivId).style.display="none"
}
this.setSize(e.x,e.y+(this._mode==DwtHtmlEditor.TEXT?1:2))
};
ZmHtmlEditor.prototype._spellCheckSuggestionListener=function(l){
var m=l.item;
var d=m.getData("orig");
if(!d){
return
}
var t=m.getData("value");
var n=this._mode==DwtHtmlEditor.TEXT;
var h=m.getData("fixall");
var u=n?document:this._getIframeDoc();
var o=u.getElementById(m.getData("spanId"));
var i=m.getData(ZmPopupMenu.MENU_ITEM_ID_KEY);
switch(i){
case"ignore":t=d;
this._ignoreWords[t]=true;
if(h){}
break;
case"add":t=d;
var c=AjxSoapDoc.create("ModifyPrefsRequest","urn:zimbraAccount");
var s=c.set("pref",t);
s.setAttribute("name","+zimbraPrefSpellIgnoreWord");
var a={
soapDoc:c,asyncMode:true,callback:new AjxCallback(appCtxt,appCtxt.setStatusMsg,[ZmMsg.wordAddedToDictionary])};
appCtxt.getAppController().sendRequest(a);
this._ignoreWords[t]=true;
break;
default:break
}
if(n&&t==null){
this._editWord(h,o)
}else{
var e=h?this._spellCheck.wordIds[d]:o;
this._editWordFix(e,t)
}
this._handleSpellCheckerEvents(null)
};
ZmHtmlEditor.prototype._getEditorDocument=function(){
var e=this._mode==DwtHtmlEditor.TEXT;
return e?document:this._getIframeDoc()
};
ZmHtmlEditor.prototype._editWord=function(s,e){
var o=this._getEditorDocument();
var t=o.createElement("input");
t.type="text";
t.value=AjxUtil.getInnerText(e);
t.className="SpellCheckInputField";
t.style.left=e.offsetLeft-2+"px";
t.style.top=e.offsetTop-2+"px";
t.style.width=e.offsetWidth+4+"px";
var n=o.getElementById(this._spellCheckDivId);
var i=n.scrollTop;
n.appendChild(t);
n.scrollTop=i;
t.setAttribute("autocomplete","off");
t.focus();
if(!AjxEnv.isGeckoBased){
t.select()
}else{
t.setSelectionRange(0,t.value.length)
}
var a=AjxCallback.simpleClosure(this._editWordHandler,this,s,e);
t.onblur=a;
t.onkeydown=a
};
ZmHtmlEditor.prototype._editWordHandler=function(a,e,t){
t=DwtUiEvent.getEvent(t);
t={
type:t.type,keyCode:t.keyCode,ctrlKey:t.ctrlKey,target:DwtUiEvent.getTarget(t)};
setTimeout(AjxCallback.simpleClosure(this._editWordHandler2,this,a,e,t),20)
};
ZmHtmlEditor.prototype._editWordHandler2=function(s,o,h){
h=DwtUiEvent.getEvent(h);
var l=h.type;
var t=h.keyCode;
var i=h.ctrlKey;
var c=DwtUiEvent.getTarget(h);
var n=/key/.test(l);
var a=true;
if(/blur/.test(l)||(n&&t==13)){
if(i){
s=!s
}
var d=AjxUtil.getInnerText(o);
var e=s?this._spellCheck.wordIds[d]:o;
this._editWordFix(e,c.value)
}else{
if(n&&t==27){
this._editWordFix(o,AjxUtil.getInnerText(o))
}else{
a=false
}}
if(a){
c.onblur=null;
c.onkeydown=null;
if(c.parentNode){
c.parentNode.removeChild(c)
}}
this._handleSpellCheckerEvents(null)
};
ZmHtmlEditor.prototype._editWordFix=function(a,o){
a=a instanceof Array?a:[a];
var n=this._getEditorDocument();
for(var t=a.length-1;
t>=0;
t--){
var e=a[t];
if(typeof e=="string"){
e=n.getElementById(e)
}
if(e){
e.innerHTML=o
}}};
ZmHtmlEditor.prototype._handleSpellCheckerEvents=function(f){
var h=this._mode==DwtHtmlEditor.TEXT;
var n=h?(f?DwtUiEvent.getTarget(f):null):this._getParentElement(),y,e,s,l,d=this._spellCheck,g=this._getEditorDocument(),w=false,o="";
if(f&&/^span$/i.test(n.tagName)&&/ZM-SPELLCHECK/.test(n.className)){
o=n.getAttribute("word");
w=o!=AjxUtil.getInnerText(n)
}
e=d.spanIds;
for(s in e){
y=g.getElementById(s);
if(y){
if(e[s]!=AjxUtil.getInnerText(y)||this._ignoreWords[e[s]]){
y.className="ZM-SPELLCHECK-FIXED"
}else{
if(e[s]==o){
y.className="ZM-SPELLCHECK-MISSPELLED2"
}else{
y.className="ZM-SPELLCHECK-MISSPELLED"
}}}}
if(d.menu&&(!f||(/click|mousedown|mouseup|contextmenu/.test(f.type)||(/key/.test(f.type)&&(!o||w))))){
if(d.menu._menuItems.fixall){
d.menu._menuItems.fixall.getMenu().dispose()
}
d.menu.dispose();
d.menu=null;
window.status=""
}
if(f&&o&&(l=d.suggestions[o])&&(/mouseup|contextmenu/i.test(f.type)||(h&&/(click|mousedown|contextmenu)/i.test(f.type)))&&(o==AjxUtil.getInnerText(n)&&!this._ignoreWords[o])){
d.menu=this._spellCheckCreateMenu(this,0,l,o,n.id,w);
var m,a=d.menu.getSize(),c=this.shell.getSize();
if(!h){
m=Dwt.toWindow(document.getElementById(this._iFrameId),0,0,null,true);
var u=Dwt.toWindow(n,0,0,null,true);
m.x+=u.x-(g.documentElement.scrollLeft||g.body.scrollLeft);
m.y+=u.y-(g.documentElement.scrollTop||g.body.scrollTop)
}else{
m=Dwt.toWindow(n,0,0,null,true);
var t=document.getElementById(this._spellCheckDivId);
m.x-=t.scrollLeft;
m.y-=t.scrollTop
}
m.y+=n.offsetHeight;
if(m.y+a.y>c.y){
m.y-=a.y+n.offsetHeight
}
d.menu.popup(0,m.x,m.y);
f._stopPropagation=true;
f._returnValue=false
}};
ZmHtmlEditor.prototype._spellCheckCreateMenu=function(d,c,l,t,o,u){
var a=new ZmPopupMenu(d);
if(u){
var s="<b>"+t+"</b>";
this._spellCheckCreateMenuItem(a,"orig",{
text:s}
,c,t,t,o)
}
if(l.length>0){
for(var n=0;
n<l.length;
++n){
this._spellCheckCreateMenuItem(a,"sug-"+n,{
text:l[n],className:""}
,c,l[n],t,o)
}
if(!(d instanceof DwtMenuItem)&&this._spellCheck.wordIds[t].length>1){
if(!this._replaceAllFormatter){
this._replaceAllFormatter=new AjxMessageFormat(ZmMsg.replaceAllMenu)
}
var s="<i>"+this._replaceAllFormatter.format(this._spellCheck.wordIds[t].length)+"</i>";
var m=a.createMenuItem("fixall",{
text:s}
);
var e=this._spellCheckCreateMenu(m,1,l,t,o,u);
m.setMenu(e)
}}else{
var m=this._spellCheckCreateMenuItem(a,"noop",{
text:ZmMsg.noSuggestions}
,c,"",t,o);
m.setEnabled(false);
this._spellCheckCreateMenuItem(a,"clear",{
text:"<i>"+ZmMsg.clearText+"</i>"}
,c,"",t,o)
}
a.createSeparator();
var h=this._mode==DwtHtmlEditor.TEXT;
if(h){
var s=c?ZmMsg.editAll:ZmMsg.edit;
this._spellCheckCreateMenuItem(a,"edit",{
text:s}
,c,null,t,o)
}
if(!c){
this._spellCheckCreateMenuItem(a,"ignore",{
text:ZmMsg.ignoreWord}
,0,null,t,o)
}
if(!c&&appCtxt.get(ZmSetting.SPELL_CHECK_ADD_WORD_ENABLED)){
this._spellCheckCreateMenuItem(a,"add",{
text:ZmMsg.addWord}
,c,null,t,o)
}
return a
};
ZmHtmlEditor.prototype._spellCheckCreateMenuItem=function(a,t,o,s,h,e,n,i){
if(o.className==null){
o.className="ZMenuItem ZmSpellMenuItem"
}
var l=a.createMenuItem(t,o);
l.setData("fixall",s);
l.setData("value",h);
l.setData("orig",e);
l.setData("spanId",n);
l.addSelectionListener(i||this._spellCheckSuggestionListenerObj);
return l
};
ZmHtmlEditor.prototype._spellCheckCallback=function(i){
var e=false;
if(i&&i.available){
var a=i.misspelled;
if(a==null||a.length==0){
appCtxt.setStatusMsg(ZmMsg.noMisspellingsFound,ZmStatusView.LEVEL_INFO)
}else{
var t=AjxMessageFormat.format(ZmMsg.misspellingsResult,a.length);
appCtxt.setStatusMsg(t,ZmStatusView.LEVEL_WARNING);
this.highlightMisspelledWords(a);
e=true
}}else{
appCtxt.setStatusMsg(ZmMsg.spellCheckUnavailable,ZmStatusView.LEVEL_CRITICAL)
}
if(AjxEnv.isGeckoBased&&this._mode==DwtHtmlEditor.HTML){
setTimeout(AjxCallback.simpleClosure(this.focus,this),10)
}
if(this.onExitSpellChecker){
this.onExitSpellChecker.run(e)
}};
ZmHtmlEditor.prototype.isSpellCheckMode=function(){
return Boolean(this._spellCheck)
};
ZmHtmlEditor.prototype._enableDesignMode=function(e){
if(!e){
return
}
if(!(AjxEnv.isGeckoBased&&this.ACE_ENABLED)){
return DwtHtmlEditor.prototype._enableDesignMode.call(this,e)
}
if(!this._hasGeckoFocusHacks){
this.__enableGeckoFocusHacks()
}
this._getIframeWin().addEventListener("blur",this._designModeHack_blur,true);
this._getIframeWin().addEventListener("focus",this._designModeHack_focus,true)
};
ZmHtmlEditor.prototype.__enableGeckoFocusHacks=function(){
var t=null;
var a=0;
this._hasGeckoFocusHacks=true;
function e(n){
var o=[];
for(var s=0;
s<this._toolbars.length;
s++){
o=o.concat(this._toolbars[s].getChildren())
}
for(var s=0;
s<o.length;
++s){
o[s].setEnabled(n)
}}
this._designModeHack_blur=AjxCallback.simpleClosure(function(u){
if(a<0){
return
}
var c=false;
var h=DwtShell.mouseEvent;
h.setFromDhtmlEvent(u,true);
var n=appCtxt.getKeyboardMgr();
if(n&&n.__focusObj){
for(var l=0;
l<this._toolbars.length;
l++){
if((n.__focusObj==this._toolbars[l])||(n.__focusObj.parent==this._toolbars[l])){
c=true;
break
}}}
e.call(this,c);
var m=this._getIframeDoc();
Dwt.enableDesignMode(m,false);
a=-1;
if(this._ace_componentsLoading>0){
return
}
try{
var s=this._getIframeWin().getSelection();
var l=0,o;
try{
t=[];
while(o=s.getRangeAt(l++)){
t.push(o)
}}
catch(d){}
s.removeAllRanges()
}
catch(d){
t=null
}}
,this);
e.call(this,false);
this._designModeHack_focus=AjxCallback.simpleClosure(function(n){
if(a>0){
return
}
var h=this._getIframeDoc();
var s=this._getIframeWin().getSelection();
e.call(this,true);
if(this._ace_componentsLoading>0){
return
}
Dwt.enableDesignMode(h,true);
if(!t||t.length==0){
r=h.createRange();
r.selectNodeContents(h.body);
r.collapse(true);
t=[r]
}
s.removeAllRanges();
for(var o=0;
o<t.length;
++o){
s.addRange(t[o])
}
t=null;
a=1
}
,this)
};
ZmHtmlEditor.WRAP_LENGTH=72;
ZmHtmlEditor.HTML_QUOTE_PREFIX_PRE='<blockquote style="border-left:2px solid '+AjxStringUtil.HTML_QUOTE_COLOR+";margin-left:5px;padding-left:5px;"+AjxStringUtil.HTML_QUOTE_STYLE+'">';
ZmHtmlEditor.HTML_QUOTE_PREFIX_POST="</blockquote><br/>";
ZmHtmlEditor.HTML_QUOTE_NONPREFIX_PRE='<div style="'+AjxStringUtil.HTML_QUOTE_STYLE+'">';
ZmHtmlEditor.HTML_QUOTE_NONPREFIX_POST="</div><br/>";
ZmHtmlEditor.getWrapParams=function(a,e){
e=e||{};
var t={};
t.htmlMode=a;
t.len=ZmHtmlEditor.WRAP_LENGTH;
t.eol=a?"<br/>":"\n";
t.pre=(a||!e.prefix)?"":appCtxt.get(ZmSetting.REPLY_PREFIX)+" ";
t.before=(a)?((e.prefix)?ZmHtmlEditor.HTML_QUOTE_PREFIX_PRE:ZmHtmlEditor.HTML_QUOTE_NONPREFIX_PRE):"";
t.after=(a)?((e.prefix)?ZmHtmlEditor.HTML_QUOTE_PREFIX_POST:ZmHtmlEditor.HTML_QUOTE_NONPREFIX_POST):"";
return t
};
ZmHtmlEditor.prototype._updateState=function(){
var e=appCtxt.get(ZmSetting.COMPOSE_INIT_FONT_SIZE);
DwtHtmlEditor.prototype._updateState.call(this,e)
};
ZmHtmlEditorColorPicker=function(a,t,e){
DwtButtonColorPicker.call(this,a,t,e)
};
ZmHtmlEditorColorPicker.prototype=new DwtButtonColorPicker;
ZmHtmlEditorColorPicker.prototype.constructor=ZmHtmlEditorColorPicker;
ZmHtmlEditorColorPicker.prototype.TEMPLATE="dwt.Widgets#ZToolbarButton"
}
if(AjxPackage.define("zimbraMail.ale.spreadsheet.msgs")){
ZmMsg.SS={
func:{
sum:{
help:ZmMsg.spreadSheet_func_sum}
,multiply:{
help:ZmMsg.spreadSheet_func_multiply}
,modulo:{
help:ZmMsg.spreadSheet_func_modulo}
,PI:{
help:ZmMsg.spreadSheet_func_PI,helper:"=PI|"}
,sin:{
help:ZmMsg.spreadSheet_func_sin}
,cos:{
help:ZmMsg.spreadSheet_func_cos}
,tan:{
help:ZmMsg.spreadSheet_func_tan}
,round:{
help:ZmMsg.spreadSheet_func_round}
,ceil:{
help:ZmMsg.spreadSheet_func_ceil}
,floor:{
help:ZmMsg.spreadSheet_func_floor}
,abs:{
help:ZmMsg.spreadSheet_func_abs}
,sqrt:{
help:ZmMsg.spreadSheet_func_sqrt}
,exp:{
help:ZmMsg.spreadSheet_func_exp}
,log:{
help:ZmMsg.spreadSheet_func_log}
,min:{
help:ZmMsg.spreadSheet_func_min}
,max:{
help:ZmMsg.spreadSheet_func_max}
,len:{
help:ZmMsg.spreadSheet_func_len}
,concat:{
help:ZmMsg.spreadSheet_func_concat}
,average:{
help:ZmMsg.spreadSheet_func_average}
,join:{
help:ZmMsg.spreadSheet_func_join,args:"join(separator, string1 [, string2...])",helper:'=join(", ", |)'}
,"if":{
help:ZmMsg.spreadSheet_func_if,args:"if(condition, true_value, false_value)"}}}
}
if(AjxPackage.define("zimbraMail.ale.spreadsheet.ZmSpreadSheet")){
ZmSpreadSheet=function(o,i,a,e){
if(arguments.length==0){
return
}
i=i||"ZmSpreadSheet";
DwtComposite.call(this,{
parent:o,className:i,posStyle:a,deferred:e}
);
var t=null;
this._selectRangeCapture=new DwtMouseEventCapture({
targetObj:this,id:"ZmSpreadSheet",mouseOverHdlr:AjxCallback.simpleClosure(this._table_selrange_MouseOver,this),mouseMoveHdlr:AjxCallback.simpleClosure(function(s){
var n=this;
if(t){
clearTimeout(t)
}
t=setTimeout(function(){
n._getRangeDiv().style.display="none";
setTimeout(function(){
n._getRangeDiv().style.display=""
}
,1)
}
,50)
}
,this),mouseUpHdlr:AjxCallback.simpleClosure(this._clear_selectRangeCapture,this)}
);
this._colsizeCapture=new DwtMouseEventCapture({
targetObj:this,id:"ZmSpreadSheet",mouseMoveHdlr:AjxCallback.simpleClosure(this._colsize_mouseMove,this),mouseUpHdlr:AjxCallback.simpleClosure(this._colsize_mouseUp,this)}
);
this._onResize=new AjxListener(this,this._onResize);
this._hoverOverListener=new AjxListener(this,this._handleOverListener);
this._hoverOutListener=new AjxListener(this,this._handleOutListener);
this.addControlListener(this._onResize);
this.onSelectCell=[];
this.onInputModified=[]
};
ZmSpreadSheet.TOOLTIP_DELAY=750;
ZmSpreadSheet.prototype=new DwtComposite;
ZmSpreadSheet.prototype.construction=ZmSpreadSheet;
ZmSpreadSheet.getCellName=function(e){
return ZmSpreadSheetModel.getCellName(e.parentNode.rowIndex,e.cellIndex)
};
ZmSpreadSheet.prototype.setModel=function(e){
e.reset();
this._model=e;
this._init();
e.setViewListener("onCellValue",new AjxCallback(this,this._model_cellComputed));
e.setViewListener("onInsertRow",new AjxCallback(this,this._model_insertRow));
e.setViewListener("onInsertCol",new AjxCallback(this,this._model_insertCol));
e.setViewListener("onDeleteRow",new AjxCallback(this,this._model_deleteRow));
e.setViewListener("onDeleteCol",new AjxCallback(this,this._model_deleteCol))
};
ZmSpreadSheet.prototype._model_cellEdited=function(a,t,e){
var i=this._getTable().rows[a].cells[t];
e.setToElement(i)
};
ZmSpreadSheet.prototype._model_cellComputed=function(a,t,e){
var i=this._getTable().rows[a].cells[t];
e.setToElement(i)
};
ZmSpreadSheet.prototype._model_deleteRow=function(l){
this._hideRange();
var o=this._selectedCell;
this._selectCell();
var t=o.cellIndex;
var e=o.parentNode.rowIndex;
var h=this._getTable().rows;
var s=h[h.length-1];
s.removeChild(s.firstChild);
++l;
for(var a=h.length;
--a>l;
){
var n=h[a-1].firstChild;
h[a].insertBefore(n,h[a].firstChild)
}
var s=h[a];
s.parentNode.removeChild(s);
if(e>=h.length){
--e
}
this._selectCell(h[e].cells[t])
};
ZmSpreadSheet.prototype._model_deleteCol=function(a){
this._hideRange();
var n=this._selectedCell;
this._selectCell();
var t=n.cellIndex;
var e=n.parentNode.rowIndex;
var h=this._getTable().rows;
for(var o=1;
o<h.length;
++o){
var s=h[o];
var l=s.cells[a+1];
s.removeChild(l)
}
s=h[0];
s.removeChild(s.cells[s.cells.length-1]);
if(t>=s.cells.length){
--t
}
this._header_resetColWidths();
this._selectCell(h[e].cells[t])
};
ZmSpreadSheet.prototype._model_insertRow=function(l,h){
this._hideRange();
var a=this._selectedCell;
this._selectCell();
var d=this._getTable().rows;
var c=this._getTable().insertRow(h+1);
var o=true;
for(var s=c.rowIndex;
s<d.length-1;
++s){
var e=d[s+1].firstChild;
var n=e;
if(s==d.length-2){
e=e.cloneNode(true);
n.firstChild.innerHTML=s+1
}
d[s].insertBefore(e,d[s].firstChild);
o=false
}
if(o){
var t=c.insertCell(0);
t.className="LeftBar";
t.innerHTML="<div>"+(h+1)+"</div>"
}
for(var s=0;
s<l.length;
++s){
var t=c.insertCell(s+1);
t.className="cell";
l[s]._td=t;
l[s].setToElement(t)
}
this._selectCell(a)
};
ZmSpreadSheet.prototype._model_insertCol=function(t,e){
this._hideRange();
var o=this._selectedCell;
this._selectCell();
var n=this._getTable().rows;
var s=n[0];
var h=s.insertCell(e+1);
h.innerHTML="<div></div>";
for(var a=e+1;
a<s.cells.length;
++a){
s.cells[a].firstChild.innerHTML=ZmSpreadSheetModel.getColName(a)
}
for(var a=0;
a<t.length;
++a){
s=n[a+1];
var h=s.insertCell(e+1);
h.className="cell";
t[a]._td=h;
t[a].setToElement(h)
}
this._header_resetColWidths();
this._selectCell(o)
};
ZmSpreadSheet.prototype.getCellModel=function(e){
return this._model.getCell(e.parentNode.rowIndex,e.cellIndex)
};
ZmSpreadSheet.prototype._init=function(){
var h=[];
var u=true;
if(!this._relDivID){
u=false;
this._relDivID=Dwt.getNextId();
h.push("<div id='",this._relDivID,"' class='ZmSpreadSheet-RelDiv'>")
}
this._focusLinkID=Dwt.getNextId();
this._tableID=Dwt.getNextId();
h.push("<a class='FocusLink' id='",this._focusLinkID,"'");
if(AjxEnv.isIE){
h.push(" href='#' onclick='return false'")
}
h.push(">");
if(AjxEnv.isIE){
h.push("&nbsp;")
}
h.push("</a>");
h.push("<table class='SpreadSheet' id='",this._tableID,"' cellspacing='1' cellpadding='0' border='0'>");
var p=["<tr><td class='LeftBar'></td>"];
var m=this._model.ROWS;
var l=this._model.COLS;
this._inputFieldID=null;
this._spanFieldID=null;
for(var o=l;
o>0;
){
p[o--]="<td class='cell'></td>"
}
p[l+1]="</tr>";
p=p.join("");
for(var o=m;
o-->=0;
){
h[h.length]=p
}
h[h.length]="</table>";
if(!u){
h[h.length]="</div>";
var e=this.getHtmlElement();
e.innerHTML=h.join("")
}else{
this._getRelDiv().innerHTML=h.join("")
}
var f=this._getTable();
f.rows[0].className="TopBar";
f.rows[0].cells[0].className="TopLeft";
for(var o=0;
o<f.rows.length;
++o){
f.rows[o].cells[0].innerHTML="<div>"+o+"</div>"
}
p=f.rows[0];
for(var o=1;
o<p.cells.length;
++o){
p.cells[o].innerHTML="<div>"+ZmSpreadSheetModel.getColName(o)+"</div>"
}
f.onmouseup=AjxCallback.simpleClosure(this._table_onMouseUp,this);
f.onmousedown=AjxCallback.simpleClosure(this._table_onClick,this);
f.onclick=AjxCallback.simpleClosure(this._table_onClick,this);
f.ondblclick=AjxCallback.simpleClosure(this._table_onClick,this);
f.onmousemove=AjxCallback.simpleClosure(this._table_mouseMove,this);
f.onmouseout=AjxCallback.simpleClosure(this._table_mouseOut,this);
var c=this._getFocusLink();
c.onkeypress=AjxCallback.simpleClosure(this._focus_keyPress,this);
if(AjxEnv.isIE||AjxEnv.isOpera){
c.onkeydown=c.onkeypress
}
var s=document.createElement("table");
s.cellSpacing=1;
s.cellPadding=0;
s.border=0;
s.id=this._headerID=Dwt.getNextId();
s.className="SpreadSheet Header";
var n=document.createElement("tbody");
s.appendChild(n);
s.style.position="absolute";
s.style.left="0px";
s.style.top="0px";
this._getRelDiv().appendChild(s);
s.onclick=f.onclick;
s.onmousemove=AjxCallback.simpleClosure(this._header_onMouseMove,this);
s.onmousedown=AjxCallback.simpleClosure(this._header_onMouseDown,this);
this._getRelDiv().onscroll=AjxCallback.simpleClosure(this._header_resetScrollTop,this);
this.getHtmlElement().style.display="none";
if(!this._model.version){
if(ZmSpreadSheetModel.DEBUG){
console.log("Loading old spreadsheet file -- slower")
}
for(var o=0;
o<m;
++o){
var p=f.rows[o+1];
for(var a=0;
a<l;
++a){
this._model.data[o][a]._td=p.cells[a+1]
}}}
this._model.doneSetView();
for(var o=0;
o<m;
++o){
var p=f.rows[o+1];
for(var a=0;
a<l;
++a){
var d=this._model.data[o][a];
var t=d._td=p.cells[a+1];
d._savedRow=d._savedCol=null;
d.setToElement(t)
}}
this.getHtmlElement().style.display="";
this._header_resetColWidths()
};
ZmSpreadSheet.prototype._topCellClicked=function(o,i){
if(/click/i.test(i.type)){
var e=o.cellIndex;
this._selectCell(this._getTable().rows[o.parentNode.rowIndex+1].cells[e]);
var e=ZmSpreadSheetModel.getColName(e);
var a=e+"1";
var t=e+this._model.ROWS;
this._selectRange(a,t)
}};
ZmSpreadSheet.prototype._leftCellClicked=function(o,a){
if(/click/i.test(a.type)){
var i=o.parentNode.rowIndex;
this._selectCell(this._getTable().rows[i].cells[o.cellIndex+1]);
var t="A"+i;
var e=ZmSpreadSheetModel.getColName(this._model.COLS)+i;
this._selectRange(t,e)
}};
ZmSpreadSheet.prototype._topLeftCellClicked=function(i,a){
var t="A1";
var e=ZmSpreadSheetModel.getColName(this._model.COLS)+this._model.ROWS;
this.focus();
this._selectRange(t,e,true)
};
ZmSpreadSheet.prototype._cellClicked=function(s,i){
var t=/mousedown/i.test(i.type);
this._hideRange();
this._selectCell(s);
if(AjxEnv.isIE&&DwtMenu._activeMenu){
DwtMenu._activeMenu.popdown()
}
if(t){
var a=true;
if(this._editingCell&&this._hasExpression){
var e=this._getInputField();
var n=Dwt.getSelectionStart(e);
var o=e.value.substr(0,n);
if(/\)\s*$/.test(o)){
a=false
}else{
this._updateCellRangeToken()
}}else{
this.focus()
}
if(a){
i._stopPropagation=true;
i._returnValue=false;
this._selectRangeCapture.capture()
}}
if(/dblclick/i.test(i.type)){
i._stopPropagation=true;
i._returnValue=false;
this._editCell(s)
}};
ZmSpreadSheet.prototype.focus=function(){
if(!this._selectedCell){
this._selectCell(this._getTable().rows[1].cells[1])
}
this._getFocusLink().focus();
window.status=""
};
ZmSpreadSheet.prototype._getTopLeftCell=function(){
return this._getHeaderTable().rows[0].cells[0]
};
ZmSpreadSheet.prototype._getTopHeaderCell=function(e){
return this._getHeaderTable().rows[0].cells[e.cellIndex]
};
ZmSpreadSheet.prototype._getLeftHeaderCell=function(o){
var e=null;
var t=this._getTable();
var a=(t&&t.rows)?t.rows:null;
var i=(o&&o.parentNode)?o.parentNode.rowIndex:0;
return(a?a[i][0]:null)
};
ZmSpreadSheet.prototype._colsize_mouseMove=function(o){
var i=new DwtMouseEvent();
i.setFromDhtmlEvent(o);
var s=i.docX-this._colsizeArgs.docX;
var n=AjxEnv.isIE?0:-2;
var a=true;
if(this._resizeColStart){
var t=this._colsizeArgs.w1-s+n;
var e=this._colsizeArgs.w2+s+n;
if(t>7&&e>7){
this._colsizeArgs.td1.firstChild.style.width=t+"px";
this._colsizeArgs.td2.firstChild.style.width=e+"px"
}else{
a=false
}}else{
var t=this._colsizeArgs.w1+s+n;
if(t>7){
this._colsizeArgs.td1.firstChild.style.width=t+"px"
}else{
a=false
}}
if(a){
this._colsizeArgs.delta=s
}
i._stopPropagation=true;
i._returnValue=false;
i.setToDhtmlEvent(o);
return i._returnValue
};
ZmSpreadSheet.prototype._colsize_mouseUp=function(i){
var a=new DwtMouseEvent();
a.setFromDhtmlEvent(i);
this._colsizeCapture.release();
var e;
var o=this._colsizeArgs.delta;
if(o){
var t=this._resizeColIndex;
if(this._resizeColStart){
e=this._model.getColWidth(t-1);
this._model.setColWidth(t-1,e-o);
e=this._model.getColWidth(t-2);
this._model.setColWidth(t-2,e+o)
}else{
e=this._model.getColWidth(t-1);
this._model.setColWidth(t-1,e+o)
}}
this._colsizeArgs.td1=null;
this._colsizeArgs.td2=null;
this._colsizeArgs=null;
a._stopPropagation=true;
a._returnValue=false;
a.setToDhtmlEvent(i);
return a._returnValue
};
ZmSpreadSheet.prototype._header_onMouseDown=function(a){
var t=new DwtMouseEvent();
t.setFromDhtmlEvent(a);
if(this._resizeColIndex){
this._hideRange();
var i=this._getHeaderTable().rows[0].cells[this._resizeColIndex];
this._colsizeArgs={
td1:i,w1:i.firstChild.offsetWidth,docX:t.docX,docY:t.docY};
var e=this._resizeColStart?-1:+1;
i=this._getHeaderTable().rows[0].cells[this._resizeColIndex+e];
if(i){
this._colsizeArgs.td2=i;
this._colsizeArgs.w2=i.firstChild.offsetWidth
}
this._colsizeCapture.capture();
t._stopPropagation=true;
t._returnValue=false
}
t.setToDhtmlEvent(a);
return t._returnValue
};
ZmSpreadSheet.prototype._header_onMouseMove=function(n){
var e=new DwtMouseEvent();
e.setFromDhtmlEvent(n);
var s=this._getHeaderTable();
var t=DwtUiEvent.getTarget(e);
while(t&&t!==s&&!/^td$/i.test(t.tagName)){
t=t.parentNode
}
if(t&&/^td$/i.test(t.tagName)){
var i=t.cellIndex;
if(i>0){
var l=t.parentNode;
var h=l.cells;
var a=Dwt.getLocation(this._getRelDiv());
var o=e.docX-a.x-t.offsetLeft+this._getRelDiv().scrollLeft;
if(Math.abs(o-t.offsetWidth)<5){
this._resizeColIndex=i;
this._resizeColStart=false;
Dwt.delClass(s,"Header-ColWSize","Header-ColESize")
}else{
if(o<5&&i>1){
this._resizeColIndex=i;
this._resizeColStart=true;
Dwt.delClass(s,"Header-ColESize","Header-ColWSize")
}else{
this._resizeColIndex=null;
Dwt.delClass(s,"Header-ColWSize");
Dwt.delClass(s,"Header-ColESize")
}}}}else{}
e.setToDhtmlEvent(n);
return e._returnValue
};
ZmSpreadSheet.prototype._header_resetColWidths=function(){
var n=this._getTable();
var h=this._getHeaderTable();
if(h.rows.length>0){
h.deleteRow(0)
}
h.firstChild.appendChild(n.rows[0].cloneNode(true));
var t=n.rows[0].cells;
var e=h.rows[0].cells;
var s=AjxEnv.isIE?0:-2;
for(var o=0;
o<t.length;
++o){
e[o].firstChild.style.width=t[o].firstChild.offsetWidth+s+"px"
}};
ZmSpreadSheet.prototype._header_resetScrollTop=function(){
this._getHeaderTable().style.top=this._getRelDiv().scrollTop+"px"
};
ZmSpreadSheet.prototype._selectCell=function(a){
if(this._selectedCell){
Dwt.delClass(this._getTopHeaderCell(this._selectedCell),"TopSelected");
Dwt.delClass(this._getLeftHeaderCell(this._selectedCell),"LeftSelected");
Dwt.delClass(this._selectedCell,"SSelected")
}
this._selectedCell=a;
if(a){
Dwt.addClass(a,"SSelected");
Dwt.addClass(this._getTopHeaderCell(a),"TopSelected");
Dwt.addClass(this._getLeftHeaderCell(a),"LeftSelected");
this._getTopLeftCell().innerHTML="<div>"+ZmSpreadSheet.getCellName(a)+"</div>";
var t=this._getFocusLink();
t.style.top=a.offsetTop+"px";
t.style.left=a.offsetLeft+"px";
if(!this._editingCell){
this.focus()
}
t.style.top=a.offsetTop+a.offsetHeight-1+"px";
t.style.left=a.offsetLeft+a.offsetWidth-1+"px";
if(!this._editingCell){
this.focus();
for(var e=this.onSelectCell.length;
--e>=0;
){
this.onSelectCell[e].run(this.getCellModel(a),a)
}}}};
ZmSpreadSheet.prototype._getHeaderTable=function(){
return document.getElementById(this._headerID)
};
ZmSpreadSheet.prototype._getRelDiv=function(){
return document.getElementById(this._relDivID)
};
ZmSpreadSheet.prototype._getFocusLink=function(){
return document.getElementById(this._focusLinkID)
};
ZmSpreadSheet.prototype._input_setValue=function(a){
var e=this._getInputField();
e.value=a;
for(var t=this.onInputModified.length;
--t>=0;
){
this.onInputModified[t].run(a)
}};
ZmSpreadSheet.prototype._getInputField=function(){
var e=null;
if(this._inputFieldID){
e=document.getElementById(this._inputFieldID)
}
if(!e){
var t=this._getRelDiv();
e=document.createElement("input");
this._inputFieldID=e.id=Dwt.getNextId();
e.setAttribute("autocomplete","off");
e.type="text";
e.className="InputField";
e.style.left="0px";
e.style.top="0px";
e.style.visibility="hidden";
t.appendChild(e);
e[(AjxEnv.isIE||AjxEnv.isOpera)?"onkeydown":"onkeypress"]=AjxCallback.simpleClosure(this._input_keyPress,this);
e.onmouseup=AjxCallback.simpleClosure(this._input_mouseUp,this);
e.onblur=AjxCallback.simpleClosure(this._input_blur,this);
e.onfocus=AjxCallback.simpleClosure(this._input_focus,this);
e.setValue=AjxCallback.simpleClosure(this._input_setValue,this)
}
return e
};
ZmSpreadSheet.prototype._getSpanField=function(){
var e=null;
if(this._spanFieldID){
e=document.getElementById(this._spanFieldID)
}
if(!e){
var e=document.createElement("span");
this._spanFieldID=e.id=Dwt.getNextId();
e.className="InputField";
var t=this._getRelDiv();
t.appendChild(e)
}
return e
};
ZmSpreadSheet.prototype._editCell=function(a){
this._shiftRangeStart=null;
var e=this._getInputField();
if(this._editingCell){
e.blur()
}
if(a){
this._selectCell(a);
e.style.visibility="";
e.style.top=a.offsetTop-1+"px";
e.style.left=a.offsetLeft-1+"px";
e.style.width=a.offsetWidth+2+"px";
e.style.height=a.offsetHeight+2+"px";
var t=this.getCellModel(a);
e.setValue(t.getEditValue());
e._caretMoved=false;
e.select();
e.focus();
this._editingCell=a;
t.setStyleToElement(e,true);
this._displayRangeIfAny();
this._input_keyPress()
}};
ZmSpreadSheet.prototype._input_blur=function(t){
this._shiftRangeStart=null;
var e=this._getInputField();
e.style.visibility="hidden";
e.style.left=0;
e.style.top=0;
e.style.width="";
if(!this._preventSaveOnBlur){
this._save_value(e.value)
}
this._editingCell=null;
this._hideRange()
};
ZmSpreadSheet.prototype._input_focus=function(t){
var e=this._getInputField();
if(e.style.visibility=="hidden"&&this._selectedCell){
this._editCell(this._selectedCell)
}};
ZmSpreadSheet.prototype._save_value=function(e){
this.getCellModel(this._editingCell).setEditValue(e)
};
ZmSpreadSheet.prototype._getNextCell=function(a){
if(a==null){
a=this._editingCell||this._selectedCell
}
var t=a.parentNode;
if(a.cellIndex<t.cells.length-1){
return t.cells[a.cellIndex+1]
}
var e=this._getTable();
if(t.rowIndex<e.rows.length-1){
return e.rows[t.rowIndex+1].cells[1]
}
return null
};
ZmSpreadSheet.prototype._getPrevCell=function(a){
if(a==null){
a=this._editingCell||this._selectedCell
}
var t=a.parentNode;
if(a.cellIndex>1){
return t.cells[a.cellIndex-1]
}
var e=this._getTable();
if(t.rowIndex>1){
t=e.rows[t.rowIndex-1];
return t.cells[t.cells.length-1]
}
return null
};
ZmSpreadSheet.prototype._getDownCell=function(a){
if(a==null){
a=this._editingCell||this._selectedCell
}
var t=a.parentNode;
var e=this._getTable();
if(t.rowIndex<e.rows.length-1){
t=e.rows[t.rowIndex+1];
return t.cells[a.cellIndex]
}
return null
};
ZmSpreadSheet.prototype._getUpCell=function(a){
if(a==null){
a=this._editingCell||this._selectedCell
}
var t=a.parentNode;
var e=this._getTable();
if(t.rowIndex>1){
t=e.rows[t.rowIndex-1];
return t.cells[a.cellIndex]
}
return null
};
ZmSpreadSheet.prototype._getRightCell=function(t){
if(t==null){
t=this._editingCell||this._selectedCell
}
var e=t.parentNode;
if(t.cellIndex<e.cells.length-1){
return e.cells[t.cellIndex+1]
}
return null
};
ZmSpreadSheet.prototype._getLeftCell=function(t){
if(t==null){
t=this._editingCell||this._selectedCell
}
var e=t.parentNode;
if(t.cellIndex>1){
return e.cells[t.cellIndex-1]
}
return null
};
ZmSpreadSheet.prototype._focus_handleKey=function(t,a){
var h=AjxEnv.isIE||AjxEnv.isOpera;
this.focus();
var o=true;
var i=false;
var e=this._selectedCell;
switch(t.keyCode){
case 9:var s=t.shiftKey?this._getPrevCell():this._getNextCell();
if(s){
this._selectCell(s)
}
break;
case 37:case 39:var s=t.keyCode==37?this._getLeftCell():this._getRightCell();
if(s){
this._selectCell(s);
i=true
}
break;
case 38:case 13:case 40:var s=(t.keyCode==13?(t.shiftKey?this._getUpCell():this._getDownCell()):(t.keyCode==38?this._getUpCell():this._getDownCell()));
if(s){
this._selectCell(s);
i=t.keyCode!=13
}
break;
case 113:this._editCell(this._selectedCell);
break;
case 46:if(this._selectedRangeName){
this._model.forEachCell(this._selectedRangeName,function(l){
if(t.isCommand()){
l.clearAll()
}else{
l.clearValue()
}}
)
}
this.getCellModel(this._selectedCell).clearValue();
break;
case 27:this._hideRange();
break;
default:if(!t.isCommand()&&((!h&&a.charCode)||(h&&/keypress/i.test(t.type)))){
var n=String.fromCharCode(t.charCode);
this._editCell(this._selectedCell);
this._getInputField().setValue(n);
Dwt.setSelectionRange(this._getInputField(),1,1)
}else{
o=false
}}
if(!o){
switch(String.fromCharCode(t.charCode).toLowerCase()){
case"c":if(t.isCommand()){
o=true;
this.clipboardCopy()
}
break;
case"x":if(t.isCommand()){
o=true;
this.clipboardCut()
}
break;
case"v":if(t.isCommand()){
o=true;
this.clipboardPaste()
}
break
}}
if(o){
t._stopPropagation=true;
t._returnValue=false
}
if(i){
if(t.shiftKey&&!this._shiftRangeStart){
this._shiftRangeStart=e
}else{
if(!t.shiftKey){
this._shiftRangeStart=null;
this._hideRange()
}}
if(this._shiftRangeStart){
this._selectRange(ZmSpreadSheet.getCellName(this._shiftRangeStart),ZmSpreadSheet.getCellName(this._selectedCell),false)
}}
return o
};
ZmSpreadSheet.prototype._focus_keyPress=function(t){
this._clearTooltip();
t||(t=window.event);
var e=new DwtKeyEvent();
e.setFromDhtmlEvent(t);
this._focus_handleKey(e,t);
e.setToDhtmlEvent(t);
return e._returnValue
};
ZmSpreadSheet.prototype._input_mouseUp=function(){
this._displayRangeIfAny()
};
ZmSpreadSheet.prototype._input_keyPress=function(o){
o||(o=window.event);
var e=true;
if(o){
var i=new DwtKeyEvent();
i.setFromDhtmlEvent(o);
var a=this._getInputField();
this._preventSaveOnBlur=true;
switch(o.keyCode){
case 9:e=false;
this._save_value(a.value);
a.blur();
this._focus_handleKey(i,o);
break;
case 37:case 39:var s=(!a._caretMoved&&((Dwt.getSelectionStart(a)==0&&i.keyCode==37)||(Dwt.getSelectionEnd(a)==a.value.length&&i.keyCode==39)));
if(s||!a.value||o.altKey){
e=false;
this._save_value(a.value);
a.blur();
this._focus_handleKey(i,o)
}else{
a._caretMoved=true
}
break;
case 38:case 13:case 40:e=false;
this._save_value(a.value);
a.blur();
this._focus_handleKey(i,o);
break;
case 27:e=false;
if(AjxEnv.isIE){
var n=this.getCellModel(this._editingCell);
a.setValue(n.getEditValue())
}
this.focus();
break;
case 113:Dwt.setSelectionRange(a,0,a.value.length);
break
}
i.setToDhtmlEvent(o);
this._preventSaveOnBlur=false
}
if(e){
if(this._input_keyPress_timer){
clearTimeout(this._input_keyPress_timer)
}
var t=this;
this._input_keyPress_timer=setTimeout(function(){
var c=t._getSpanField();
var h=t._getInputField();
c.innerHTML="";
c.appendChild(document.createTextNode(h.value));
if(c.offsetWidth>(h.offsetWidth-20)){
h.style.width=c.offsetWidth+50+"px"
}
t._input_keyPress_timer=null;
t._displayRangeIfAny();
for(var l=t.onInputModified.length;
--l>=0;
){
t.onInputModified[l].run(h.value)
}}
,10)
}else{
this._hideRange()
}};
ZmSpreadSheet.prototype._selectRange=function(o,i,h){
this._selectedRangeName=null;
var e=h||(o.toLowerCase()!=i.toLowerCase());
o=ZmSpreadSheetModel.identifyCell(o);
i=ZmSpreadSheetModel.identifyCell(i);
if(e&&o&&i){
var a=Math.min(o.row,i.row);
var s=Math.min(o.col,i.col);
var t=Math.max(o.row,i.row);
var n=Math.max(o.col,i.col);
this._showRange(a,s,t,n)
}else{
this._hideRange()
}};
ZmSpreadSheet.prototype._displayRangeIfAny=function(){
var u=this._getInputField();
this._hasExpression=/^=(.*)$/.test(u.value);
if(!this._hasExpression){
this._hideRange();
return
}
var m=RegExp.$1;
var e=Dwt.getSelectionStart(u),c=Dwt.getSelectionEnd(u);
try{
if(e>0){
--e
}
if(c>0){
--c
}
var l=ZmSpreadSheetFormulae.parseTokens(m,true);
var f=null;
for(var n=0;
n<l.length;
++n){
var s=l[n];
if(s.strPos<=e&&s.strPos+s.strLen>=c&&(s.type===ZmSpreadSheetFormulae.TOKEN.CELL||s.type===ZmSpreadSheetFormulae.TOKEN.CELLRANGE)){
f=s;
break
}}
this._rangeToken=f;
if(f){
var o,t;
if(f.type===ZmSpreadSheetFormulae.TOKEN.CELL){
o=t=f.val
}
if(f.type===ZmSpreadSheetFormulae.TOKEN.CELLRANGE){
var d=f.val.split(/:/);
o=d[0];
t=d[1]
}
this._selectRange(o,t,true)
}else{
throw"HIDE"
}}
catch(h){
this._hideRange()
}};
ZmSpreadSheet.prototype._showRange=function(u,t,n,c){
this._model.checkBounds(u,t);
this._model.checkBounds(n,c);
var i=this._getTable().rows[u+1];
var a=this._getTable().rows[n+1];
if(!i||!a){
this._hideRange()
}
var s=i.cells[t+1];
var o=a.cells[c+1];
if(!s||!o){
this._hideRange()
}
this._selectedRangeName=[ZmSpreadSheet.getCellName(s),ZmSpreadSheet.getCellName(o)].join(":");
var e=this._getRangeDiv();
var d=o.offsetTop+o.offsetHeight-s.offsetTop;
var l=o.offsetLeft+o.offsetWidth-s.offsetLeft;
if(AjxEnv.isIE){
d+=2;
l+=2
}
e.style.display="none";
e.style.height=d+"px";
e.style.width=l+"px";
e.style.left=s.offsetLeft-1+"px";
e.style.top=s.offsetTop-1+"px";
e.style.display=""
};
ZmSpreadSheet.prototype._getRangeDiv=function(){
if(!this._rangeDivID){
this._rangeDivID=Dwt.getNextId()
}
var e=document.getElementById(this._rangeDivID);
if(!e){
var e=document.createElement("div");
e.id=this._rangeDivID;
e.className="ShowRange";
e.style.display="none";
this._getRelDiv().appendChild(e);
e.onmousedown=AjxCallback.simpleClosure(this._rangediv_mousedown,this);
e.onmousemove=AjxCallback.simpleClosure(this._rangediv_mousemove,this)
}
return e
};
ZmSpreadSheet.prototype._rangediv_mousemove=function(ev){
if(this._selectRangeCapture.capturing()){
return
}
var dwtev=new DwtMouseEvent(ev);
dwtev.setFromDhtmlEvent(ev);
var html=["<div class='ZmSpreadSheet-Tooltip'>","<div class='CellName'>",ZmMsg.cellRange+" - "+this._selectedRangeName,"</div>"];
var g=ZmSpreadSheetModel.getRangeGeometry(this._selectedRangeName);
html.push("<div class='CellDesc'>[ ",g.rows," rows x ",g.cols," cols = ",g.rows*g.cols," cells ]</div>");
try{
var formula=new ZmSpreadSheetFormulae(this._model,"sum("+this._selectedRangeName+")");
html.push("Sum: ",formula.eval())
}
catch(ex){}
html.push("</div>");
this._setTooltip(html.join(""),dwtev.docX,dwtev.docY)
};
ZmSpreadSheet.prototype._rangediv_mousedown=function(t){
this._clearTooltip();
var e=new DwtUiEvent(t);
e.setFromDhtmlEvent(t);
this._hideRange();
e._stopPropagation=true;
e._returnValue=false;
e.setToDhtmlEvent(t)
};
ZmSpreadSheet.prototype._hideRange=function(){
this._shiftRangeStart=null;
this._selectedRangeName=null;
var e=this._getRangeDiv();
e.style.display="none";
e.style.top="0px";
e.style.left="0px";
e.style.width="5px";
e.style.height="5px"
};
ZmSpreadSheet.prototype._table_selrange_MouseOver=function(a){
var e=new DwtMouseEvent();
e.setFromDhtmlEvent(a);
var t=this._getTable();
var i=DwtUiEvent.getTarget(e);
while(i&&i!==t&&!/^td$/i.test(i.tagName)){
i=i.parentNode
}
if(i&&/^td$/i.test(i.tagName)&&i.cellIndex>0&&i.parentNode.rowIndex>0){
this._selectRange(ZmSpreadSheet.getCellName(this._selectedCell),ZmSpreadSheet.getCellName(i),false);
this._updateCellRangeToken()
}
e._stopPropagation=true;
e._returnValue=false;
e.setToDhtmlEvent(a);
return e._returnValue
};
ZmSpreadSheet.prototype._updateCellRangeToken=function(){
if(this._editingCell&&this._hasExpression){
var a=this._selectedRangeName||ZmSpreadSheet.getCellName(this._selectedCell);
var t=this._getInputField();
var e=this._rangeToken;
if(!e){
e={
strPos:Dwt.getSelectionStart(t)};
e.strLen=Dwt.getSelectionEnd(t)-e.strPos;
e.strPos--
}
Dwt.setSelectionRange(t,e.strPos+1,e.strPos+e.strLen+1);
e.strLen=a.length;
Dwt.setSelectionText(t,a);
a=e.strPos+e.strLen+1;
Dwt.setSelectionRange(t,a,a);
this._displayRangeIfAny()
}};
ZmSpreadSheet.prototype._clear_selectRangeCapture=function(e){
this._selectRangeCapture.release();
if(this._editingCell){
this._selectCell(this._editingCell)
}};
ZmSpreadSheet.prototype._table_onMouseUp=function(e){
if(this._editingCell&&!this._hasExpression){
this._getInputField().blur()
}};
ZmSpreadSheet.prototype._setTooltip=function(t,e,o){
var i=DwtShell.getShell(window);
var a=i.getHoverMgr();
if(!a.isHovering()){
a.reset();
a.setHoverOverDelay(ZmSpreadSheet.TOOLTIP_DELAY);
if(typeof t=="object"){
a.setHoverOverData(t.getTooltipText())
}else{
a.setHoverOverData(t)
}
a.setHoverOverListener(this._hoverOverListener);
a.hoverOver(e,o)
}};
ZmSpreadSheet.prototype._handleOverListener=function(t){
var e=DwtShell.getShell(window);
var i=t.object;
var a=e.getToolTip();
a.setContent(i);
a.popup(t.x,t.y)
};
ZmSpreadSheet.prototype._handleOutListener=function(t){
var e=DwtShell.getShell(window);
var a=e.getToolTip();
a.popdown()
};
ZmSpreadSheet.prototype._clearTooltip=function(){
var t=DwtShell.getShell(window);
var e=t.getHoverMgr();
e.setHoverOutDelay(0);
e.setHoverOutData(null);
e.setHoverOutListener(this._hoverOutListener);
e.hoverOut()
};
ZmSpreadSheet.prototype._table_mouseOut=function(){
this._clearTooltip()
};
ZmSpreadSheet.prototype._table_mouseMove=function(o){
if(this._editingCell||this._selectRangeCapture.capturing()){
return
}
var a=new DwtMouseEvent();
a.setFromDhtmlEvent(o);
var i=this._getTable();
var n=DwtUiEvent.getTarget(a);
while(n&&n!==i&&!/^td$/i.test(n.tagName)){
n=n.parentNode
}
if(n&&/^td$/i.test(n.tagName)){
try{
var e=this.getCellModel(n);
this._setTooltip(e,a.docX,a.docY)
}
catch(t){}}};
ZmSpreadSheet.prototype._table_onClick=function(a){
this._clearTooltip();
var e=new DwtMouseEvent();
e.setFromDhtmlEvent(a);
var t=this._getTable();
var o=DwtUiEvent.getTarget(e);
while(o&&o!==t&&!/^td$/i.test(o.tagName)){
o=o.parentNode
}
if(o&&/^td$/i.test(o.tagName)){
var i=o.parentNode;
if(i.rowIndex==0){
if(o.cellIndex==0){
this._topLeftCellClicked(o,e)
}else{
this._topCellClicked(o,e)
}}else{
if(o.cellIndex==0){
this._leftCellClicked(o,e)
}else{
this._cellClicked(o,e)
}}}
e.setToDhtmlEvent(a);
return e._returnValue
};
ZmSpreadSheet.prototype._getTable=function(){
return document.getElementById(this._tableID)
};
ZmSpreadSheet.prototype._onResize=function(o){
var i=this.getHtmlElement();
var t=this._getRelDiv();
t.style.display="none";
var a=i.offsetHeight;
t.style.display="";
a-=t.offsetTop+2;
var e=o.requestedWidth;
if(AjxEnv.isIE){
e-=2
}
var n=t.nextSibling;
while(n){
a-=n.offsetHeight;
n=n.nextSibling
}
t.style.height=a+"px";
t.style.width=e+"px"
};
ZmSpreadSheet.prototype.getSelectionRange=function(){
var e=this._selectedRangeName;
if(!e&&this._selectedCell){
e=ZmSpreadSheet.getCellName(this._selectedCell);
e+=":"+e
}
return e
};
ZmSpreadSheet.prototype.getSelectedCellModel=function(){
if(this._selectedCell){
return this.getCellModel(this._selectedCell)
}
return null
};
ZmSpreadSheet.prototype.clipboardCopy=function(){
window.top._ZmSpreadSheet_clipboard=new ZmSpreadSheetClipboard(this._model,this.getSelectionRange(),false)
};
ZmSpreadSheet.prototype.clipboardCut=function(){
window.top._ZmSpreadSheet_clipboard=new ZmSpreadSheetClipboard(this._model,this.getSelectionRange(),true)
};
ZmSpreadSheet.prototype.clipboardPaste=function(){
var t=window.top._ZmSpreadSheet_clipboard;
if(t){
var e=this._model.paste(t,this.getSelectionRange());
this._selectRange.apply(this,e)
}}
}
if(AjxPackage.define("zimbraMail.ale.spreadsheet.ZmSpreadSheetModel")){
ZmSpreadSheetModel=function(a,o){
this.ROWS=a;
this.COLS=o;
this.version=1;
var s=this.data=new Array(a);
for(var t=0;
t<a;
++t){
var n=s[t]=new Array(o);
for(var e=0;
e<o;
++e){
n[e]=new ZmSpreadSheetCellModel(this)
}}
this.colProps=new Array(o);
for(var t=0;
t<o;
++t){
this.colProps[t]=ZmSpreadSheetModel.getDefaultColProp()
}
this._expressionCells=[];
this.reset()
};
ZmSpreadSheetModel.DEBUG=false;
ZmSpreadSheetModel.getDefaultColProp=function(){
var e={
width:100};
return e
};
ZmSpreadSheetModel.getCellName=function(t,e){
return ZmSpreadSheetModel.getColName(e)+t
};
ZmSpreadSheetModel.getRangeName=function(t,i,e,a){
return ZmSpreadSheetModel.getCellName(t,i)+":"+ZmSpreadSheetModel.getCellName(e,a)
};
ZmSpreadSheetModel.getColName=function(e){
--e;
var t=[];
do{
t.unshift(String.fromCharCode(65+e%26));
e=Math.floor(e/26)
}
while(e>0);
return t.join("")
};
ZmSpreadSheetModel.identifyCell=function(n){
if(/^([a-z]+)([0-9]+)$/i.test(n)){
var t=RegExp.$1.toUpperCase();
var e=parseInt(RegExp.$2);
var o=0;
for(var a=0;
a<t.length;
++a){
o*=26;
o+=t.charCodeAt(a)-64
}
return{
row:e-1,col:o-1}
}
throw"Can't parse cell identifier "+n+" at ZmSpreadSheetModel.identifyCell"
};
ZmSpreadSheetModel.getRangeBounds=function(o){
var e=o.split(/:/);
var s=ZmSpreadSheetModel.identifyCell(e[0]);
var n=ZmSpreadSheetModel.identifyCell(e[1]);
var i=Math.min(s.row,n.row);
var l=Math.min(s.col,n.col);
var t=Math.max(s.row,n.row);
var h=Math.max(s.col,n.col);
return[{
row:i,col:l}
,{
row:t,col:h}
]
};
ZmSpreadSheetModel.shiftCell=function(e,t,a){
var i=ZmSpreadSheetModel.identifyCell(e);
i.row+=t;
i.col+=a;
return ZmSpreadSheetModel.getCellName(i.row+1,i.col+1)
};
ZmSpreadSheetModel.shiftRange=function(t,i,o){
var e=t.split(/:/);
return ZmSpreadSheetModel.shiftCell(e[0],i,o)+":"+ZmSpreadSheetModel.shiftCell(e[1],i,o)
};
ZmSpreadSheetModel.getRangeGeometry=function(e){
var t=ZmSpreadSheetModel.getRangeBounds(e);
return{
rows:t[1].row-t[0].row+1,cols:t[1].col-t[0].col+1,bounds:t}
};
ZmSpreadSheetModel.prototype.getCellsInRange=function(s){
var e=ZmSpreadSheetModel.getRangeBounds(s);
var l=e[0].row;
var t=e[0].col;
var o=e[1].row;
var h=e[1].col;
var c=[];
for(var n=l;
n<=o;
++n){
for(var a=t;
a<=h;
++a){
c.push(this.data[n][a])
}}
return c
};
ZmSpreadSheetModel.prototype.forEachCell=function(e,o,n){
var t=this.getCellsInRange(e);
for(var a=0;
a<t.length;
++a){
o.apply(n,[t[a],a,t])
}};
ZmSpreadSheetModel.prototype.insertRow=function(t){
if(t==null){
t=this.ROWS
}
var a=new Array(this.COLS);
for(var e=this.COLS;
--e>=0;
){
a[e]=new ZmSpreadSheetCellModel(this)
}
this.data.splice(t,0,a);
++this.ROWS;
this.triggerEvent("onInsertRow",a,t);
this.recompute()
};
ZmSpreadSheetModel.prototype.insertCol=function(a){
if(a==null){
a=this.COLS
}
var e=new Array(this.ROWS);
for(var t=this.ROWS;
--t>=0;
){
var o=new ZmSpreadSheetCellModel(this);
e[t]=o;
this.data[t].splice(a,0,o)
}
this.colProps.splice(a,0,ZmSpreadSheetModel.getDefaultColProp());
++this.COLS;
this.triggerEvent("onInsertCol",e,a);
this.recompute()
};
ZmSpreadSheetModel.prototype.deleteRow=function(a){
if(this.ROWS>1){
var e=this.data[a];
for(var t=e.length;
--t>=0;
){
if(e[t]._expr){
e[t].setExpression(null)
}
e[t]._td=null
}
this.data.splice(a,1);
--this.ROWS;
this.triggerEvent("onDeleteRow",a);
this.recompute()
}};
ZmSpreadSheetModel.prototype.deleteCol=function(t){
if(this.COLS>1){
for(var a=this.ROWS;
--a>=0;
){
var e=this.data[a][t];
if(e._expr){
e.setExpression(null)
}
this.data[a].splice(t,1);
e._td=null
}
this.colProps.splice(t,1);
--this.COLS;
this.triggerEvent("onDeleteCol",t);
this.recompute()
}};
ZmSpreadSheetModel.prototype.getColWidth=function(e){
return this.colProps[e].width
};
ZmSpreadSheetModel.prototype.setColWidth=function(t,o){
this.colProps[t].width=o;
for(var a=0;
a<this.data.length;
++a){
var e=this.data[a][t];
e.setWidth(o)
}};
ZmSpreadSheetModel.prototype.checkBounds=function(t,e){
if(t<0||t>this.ROWS-1){
throw"Row out of bounds"
}
if(e<0||e>this.COLS-1){
throw"Col out of bounds"
}};
ZmSpreadSheetModel.prototype.reset=function(){
this._viewEvents={}
};
ZmSpreadSheetModel.prototype.triggerEvent=function(e){
var o=this._viewEvents[e];
if(!o){
return null
}
var t=new Array(arguments.length-1);
for(var a=1;
a<arguments.length;
++a){
t[a-1]=arguments[a]
}
o.run.apply(o,t)
};
ZmSpreadSheetModel.prototype.setViewListener=function(e,t){
this._viewEvents[e]=t
};
ZmSpreadSheetModel.prototype.getCell=function(t,e){
return this.data[t-1][e-1]
};
ZmSpreadSheetModel.prototype.getCellByID=function(e){
var t=ZmSpreadSheetModel.identifyCell(e);
return this.data[t.row][t.col]
};
ZmSpreadSheetModel.prototype._orderExpressionCells=function(n){
var i=[];
var s={};
var t=n||this._expressionCells;
while(t.length>0){
var e=t.shift();
var o=e.getName();
if(e._expr&&!s[o]){
t.unshift.apply(t,e._expr.dependsArray());
s[o]=true;
i.push(e)
}}
if(!n){
this._expressionCells=i
}
return i
};
ZmSpreadSheetModel.prototype.recompute=function(o){
for(var a=this._expressionCells.length;
--a>=0;
){
var e=this._expressionCells[a];
try{
e.updateExpression()
}
catch(t){
e._td.firstChild.innerHTML="#REF"
}}};
ZmSpreadSheetModel.prototype.paste=function(h,p){
var n=h.geometry;
var f=h.bounds;
var t=ZmSpreadSheetModel.getRangeGeometry(p);
var m=t.bounds;
var l;
if(t.rows<n.rows){
t.rows=n.rows
}else{
t.rows-=t.rows%n.rows
}
if(t.cols<n.cols){
t.cols=n.cols
}else{
t.cols-=t.cols%n.cols
}
m[1].row=m[0].row+t.rows-1;
m[1].col=m[0].col+t.cols-1;
h.setDelta(m[0].row-f[0].row,m[0].col-f[0].col);
for(l=m[1].row-this.ROWS;
l-->=0;
){
this.insertRow()
}
for(l=m[1].col-this.COLS;
l-->=0;
){
this.insertCol()
}
var a=0;
var o=0;
var c=[];
for(var l=m[0].row;
l<=m[1].row;
++l){
var e=0;
var g=0;
for(var s=m[0].col;
s<=m[1].col;
++s){
var u=this.data[l][s];
h.paste(a,e,u,o,g);
c.push(u);
e++;
if(e==n.cols){
g+=n.cols;
e=0
}}
a++;
if(a==n.rows){
o+=n.rows;
a=0
}}
var d=this._orderExpressionCells(c);
for(var l=0;
l<d.length;
++l){
d[l].recompute()
}
return[ZmSpreadSheetModel.getCellName(m[0].row+1,m[0].col+1),ZmSpreadSheetModel.getCellName(m[1].row+1,m[1].col+1)]
};
ZmSpreadSheetModel.serializeJSObject=function(a){
var e;
var o=ZmSpreadSheetModel.DEBUG?",\n":",";
switch(typeof a){
case"object":if(a==null){
e="null"
}else{
if(a.serialize&&typeof a.serialize=="function"){
e=a.serialize()
}else{
if(a instanceof Array){
e=new Array(a.length);
for(var t=0;
t<a.length;
++t){
e[t]=this.serializeJSObject(a[t])
}
e=["[",e.join(o),"]"].join("")
}else{
e=new Array();
for(var t in a){
e.push(['"',t.replace(/\x22/g,"\\x22"),'":',this.serializeJSObject(a[t])].join(""))
}
e=["{",e.join(o),"}"].join("")
}}}
break;
case"string":e=a.replace(/\n/g,"\\n").replace(/\x5c/g,"\\x5c").replace(/\x22/g,'\\"');
e=['"',e,'"'].join("");
break;
default:e=a
}
return e
};
ZmSpreadSheetModel.deserializeJSObject=function(str){
var tmp=str.replace(/(\x22(\\.|[^\x22\\])*\x22|\x27(\\.|[^\x27\\])*\x27)/g,"");
var forbid=ZmSpreadSheetModel.DEBUG?/([;()+=\x2f*.-])/g:/([\n;()+=\x2f*.-])/g;
if(forbid.test(tmp)){
throw new DwtException("Can't deserialize in ZmSpreadSheetModel: "+RegExp.$1+" characters not allowed.")
}
try{
var foo;
eval(["foo=",str].join(""));
return foo
}
catch(ex){
throw new DwtException("Can't deserialize in ZmSpreadSheetModel: malformed data\n[ "+ex+" ]")
}};
ZmSpreadSheetModel.prototype.serialize=function(){
var e={
ROWS:this.ROWS,COLS:this.COLS,version:1,colProps:this.colProps,data:this.data};
return ZmSpreadSheetModel.serializeJSObject(e)
};
ZmSpreadSheetModel.prototype.deserialize=function(s){
var a=ZmSpreadSheetModel.deserializeJSObject(s);
this.ROWS=a.ROWS;
this.COLS=a.COLS;
this.colProps=a.colProps;
this.version=a.version||0;
var o=this.data=a.data;
for(var t=0;
t<this.ROWS;
++t){
var n=o[t];
for(var e=0;
e<this.COLS;
++e){
n[e]=ZmSpreadSheetCellModel.deserialize(this,n[e])
}}};
ZmSpreadSheetModel.prototype.loadFromXml=function(l){
var a=AjxXmlDoc.createFromXml(l);
if(a){
var m=a.toJSObject(false,false,true);
if(!m){
return
}
var h=(m&&m.Worksheet)?m.Worksheet:null;
var g=(h&&h.ColProps)?h.ColProps:null;
var u=(h&&h.Table)?h.Table:null;
var p=(u&&u.Row)?u.Row:[];
this.ROWS=(u&&u.ExpandedRowCount)?u.ExpandedRowCount:0;
this.COLS=(u&&u.ExpandedColumnCount)?u.ExpandedColumnCount:0;
this.colProps=(g&&g.Col)?g.Col:[];
this.version=(h&&h.version)?h.version:0;
var n=this.data=new Array(this.ROWS);
var s=null;
var o=null;
for(var t=0;
t<this.ROWS;
++t){
if(!p||!p[t]){
continue
}
var c=p[t].Cell;
if(!c){
continue
}
var f=n[t]=new Array(this.COLS);
for(var e=0;
e<this.COLS;
++e){
if(!c[e]){
continue
}
s=c[e];
o={
row:s.row,col:s.col,type:s.type,decimals:s.decimals,editValue:s.editValue,style:s.Style};
f[e]=ZmSpreadSheetCellModel.deserialize(this,o)
}}}};
ZmSpreadSheetModel.prototype.doneSetView=function(){
var h=this.data;
for(var s=0;
s<this.ROWS;
++s){
var l=h[s];
for(var n=0;
n<this.COLS;
++n){
var e=l[n];
e.setEditValue(e._editValue,true)
}}
this._orderExpressionCells();
var t=this._expressionCells;
if(ZmSpreadSheetModel.DEBUG){
var o=[];
for(var s=0;
s<t.length;
++s){
o[s]=t[s].getName()
}
console.log("Computing: %s",o.join(", "))
}
for(var s=0;
s<t.length;
++s){
t[s].recompute()
}};
ZmSpreadSheetModel.prototype.getHtml=function(){
var a=["<table style='font: 8pt tahoma,verdana,sans-serif; background-color: #fff; border-collapse: collapse'>"];
for(var t=0;
t<this.ROWS;
++t){
a.push("<tr>");
for(var e=0;
e<this.COLS;
++e){
a.push(this.data[t][e].getHtml())
}
a.push("</tr>")
}
a.push("</table>");
return a.join("")
};
ZmSpreadSheetModel.prototype.getXml=function(){
var t=AjxXmlDoc.createRoot("Workbook");
var c=AjxXmlDoc.createElement("Worksheet");
c.root.setAttribute("version",1);
var e=AjxXmlDoc.createElement("ColProps");
for(var n=0;
n<this.COLS;
++n){
var a=AjxXmlDoc.createElement("Col");
a.root.setAttribute("width",this.colProps[n].width);
e.appendChild(a)
}
c.appendChild(e);
var s=AjxXmlDoc.createElement("Table");
s.root.setAttribute("ExpandedRowCount",this.ROWS);
s.root.setAttribute("ExpandedColumnCount",this.COLS);
var l=null;
for(var n=0;
n<this.ROWS;
++n){
rowN=AjxXmlDoc.createElement("Row");
for(var o=0;
o<this.COLS;
++o){
var h=this.data[n][o].getXml(n+1,o+1);
rowN.appendChild(h)
}
s.appendChild(rowN)
}
c.appendChild(s);
t.appendChild(c);
return t
};
ZmSpreadSheetClipboard=function(n,o,t){
this._move=!!t;
this.model=n;
this.geometry=ZmSpreadSheetModel.getRangeGeometry(o);
this.range=o;
this.bounds=this.geometry.bounds;
var e=this.cells=n.getCellsInRange(o);
if(!t){
for(var s=e.length;
--s>=0;
){
e[s]=e[s].clone()
}}};
ZmSpreadSheetClipboard.prototype.getCell=function(t,e){
return this.cells[t*this.geometry.cols+e]
};
ZmSpreadSheetClipboard.prototype.setDelta=function(e,t){
this.delta={
rows:e,cols:t}
};
ZmSpreadSheetClipboard.prototype.paste=function(u,a,c,o,d){
var t=this.getCell(u,a);
for(var s in t._style){
c._style[s]=t._style[s]
}
if(t._expr){
var h=t._expr;
var n=h.shift(this.delta.rows+o,this.delta.cols+d);
c._type=t._type;
c._decimals=t._decimals;
c.setEditValue("="+n)
}else{
c._type=t._type;
c._autoType=t._autoType;
c._decimals=t._decimals;
c.setEditValue(t.getEditValue())
}
if(this._move&&!t._wasCut){
var l=t.clone();
this.cells[u*this.geometry.cols+a]=l;
l._wasCut=true;
t.clearAll()
}};
ZmSpreadSheetCellModel=function(t,i,e,a){
if(e==null){
e=""
}
if(i==null){
i=null
}
this._model=t;
this._td=null;
this._decimals=null;
this._type=i;
this._autoType=null;
this._editValue=e;
this._value=e;
this._style=ZmSpreadSheetCellModel.getDefaultStyle(a);
this._expr=null;
this._affects=[]
};
ZmSpreadSheetCellModel.defaultStyle={
fontFamily:"",fontWeight:"",fontStyle:"",fontSize:"",backgroundColor:"",color:"",textAlign:"",verticalAlign:"",textDecoration:""};
ZmSpreadSheetCellModel.prototype.serialize=function(){
var e={
decimals:this._decimals,type:this._type,editValue:this._editValue,style:this._style,row:this.getRow(),col:this.getCol()};
return ZmSpreadSheetModel.serializeJSObject(e)
};
ZmSpreadSheetCellModel.deserialize=function(t,a){
var e=new ZmSpreadSheetCellModel(t,a.type,a.editValue,a.style);
e._decimals=a.decimals;
e._savedRow=a.row;
e._savedCol=a.col;
return e
};
ZmSpreadSheetCellModel.getDefaultStyle=function(a){
if(!a){
a={}
}
var t=ZmSpreadSheetCellModel.defaultStyle;
for(var e in t){
if(typeof a[e]=="undefined"){
a[e]=t[e]
}}
return a
};
ZmSpreadSheetCellModel.prototype.clone=function(){
var t=new ZmSpreadSheetCellModel(null);
t._decimals=this._decimals;
t._type=this._type;
t._autoType=this._autoType;
t._editValue=this._editValue;
t._value=this._value;
t._expr=this._expr;
for(var e in this._style){
t._style[e]=this._style[e]
}
return t
};
ZmSpreadSheetCellModel.prototype.setWidth=function(e){
if(this._td){
var t=-2;
this._td.firstChild.style.width=e+t+"px"
}};
ZmSpreadSheetCellModel.prototype.getHtml=function(){
var n=[];
for(var a in this._style){
if(this._style[a]!=""){
var e=a.replace(/([a-z])([A-Z])([a-z])/g,function(c,l,h,i){
return l+"-"+h.toLowerCase()+i
}
);
n.push(e+":"+this._style[a])
}}
var o=this._model.getColWidth(this.getCol()-1);
if(AjxEnv.isIE){
o-=2
}
n.push("width:"+o+"px");
n.push("border:1px solid #aaa");
if(n.length>0){
n=[" style='",n.join(";"),"'"].join("")
}else{
n=""
}
var t=this.getType();
if(t){
var t=" class='SpreadSheet-Type-"+t+"'"
}else{
t=""
}
var s=AjxStringUtil.htmlEncode(this.getDisplayValue().toString());
if(s==""){
s="&nbsp;"
}
return["<td",t,n,">",s,"</td>"].join("")
};
ZmSpreadSheetCellModel.prototype.getXml=function(s,t){
var h=AjxXmlDoc.createElement("Style");
for(var a in this._style){
if(this._style[a]!=""){
var e=a;
if(e!="toString"){
h.root.setAttribute(e,this._style[a])
}}}
var n=AjxXmlDoc.createElement("Cell");
var o=n.root;
o.setAttribute("row",s);
o.setAttribute("col",t);
o.setAttribute("editValue",(this._editValue?this._editValue:""));
o.setAttribute("decimals",(this._decimals?this._decimals:""));
o.setAttribute("type",(this._type?this._type:""));
n.appendChild(h);
return n
};
ZmSpreadSheetCellModel.prototype.setToElement=function(t){
var i=t.firstChild;
if(!i){
t.innerHTML="<div class='Wrapper'></div>";
i=t.firstChild
}
var a=this.getDisplayValue();
if(!/\S/.test(a)){
a="\xA0"
}else{
a=a.toString().replace(/\s/g,"\xA0")
}
i.innerHTML="";
i.appendChild(document.createTextNode(a));
if(AjxEnv.isGeckoBased){
i.style.overflow="visible"
}
this.setStyleToElement(t);
if(this._expr){
Dwt.addClass(t,"hasFormula")
}else{
Dwt.delClass(t,"hasFormula")
}
var e=this.getType();
if(e){
t.className=t.className.replace(/(^|\s)SpreadSheet-Type-.*?(\s|$)/g," ");
Dwt.addClass(t,"SpreadSheet-Type-"+e)
}
i.style.width=this._model.getColWidth(this.getCol()-1)-2+"px"
};
ZmSpreadSheetCellModel.prototype.setStyleToElement=function(a,e){
for(var t in this._style){
var o=this._style[t];
switch(t){
default:a.style[t]=o
}}};
ZmSpreadSheetCellModel.prototype._mkDeps=function(){
var a=[];
var t={};
function e(o){
var n=o._affects,h=0,l,s;
while(l=n[h++]){
s=l.getName();
if(!t[s]){
t[s]=true;
e(l);
a.unshift(l)
}}}
e(this);
return a
};
ZmSpreadSheetCellModel.prototype.setValue=function(n,t){
if(!this._settingValue){
this._settingValue=true;
this._value=n;
this._model.triggerEvent("onCellValue",this.getRow(),this.getCol(),this);
if(!t){
var e=this._mkDeps();
for(var o=0;
o<e.length;
++o){
e[o].recompute()
}}
this._settingValue=false
}};
ZmSpreadSheetCellModel.prototype.getValue=function(){
switch(this.getType()){
case"currency":case"percentage":case"number":return ZmSpreadSheetFormulae.parseFloat(this._value)
}
return this._value
};
ZmSpreadSheetCellModel.prototype.getDisplayValue=function(){
var t=this.getValue();
var e=this.getType();
switch(e){
case"number":if(!/\S/.test(this._editValue)){
t=""
}else{
t=ZmSpreadSheetFormulae.parseFloat(t);
if(this._decimals!=null){
t=t.toFixed(this._decimals)
}}
break;
case"currency":t=ZmSpreadSheetFormulae.parseFloat(t);
if(this._decimals!=null){
t=t.toFixed(this._decimals)
}
t="$"+t;
break;
case"percentage":t=ZmSpreadSheetFormulae.parseFloat(t);
if(this._decimals!=null){
t=t.toFixed(this._decimals)
}
t=t+"%";
break
}
return t
};
ZmSpreadSheetCellModel.prototype.setExpression=function(s){
var e=this._model._expressionCells;
for(var n=e.length;
--n>=0;
){
if(e[n]===this){
e.splice(n,1)
}}
if(this._expr){
var h=this._expr.depends();
for(var n in h){
var t=h[n]._affects;
for(var o=t.length;
--o>=0;
){
if(t[o]===this){
t.splice(o,1)
}}}}
this._expr=s;
if(s){
e.push(this);
var h=this._expr.depends();
for(var n in h){
h[n]._affects.push(this)
}}};
ZmSpreadSheetCellModel.prototype.recompute=function(){
this.setValue(this._expr.eval(),true)
};
ZmSpreadSheetCellModel.prototype.updateExpression=function(){
if(this._expr){
var e=this._expr.update();
if(e){
this._editValue="="+e;
this.recompute()
}}};
ZmSpreadSheetCellModel.prototype._determineType=function(a){
var t=a;
var e=null;
if(/^\x27(.*)$/.test(a)){
e="string";
t=RegExp.$1
}else{
if(/^=(.+)$/.test(a)){
t=RegExp.$1;
if(/\S/.test(t)){
e="expression"
}else{
t=a
}}else{
if(/^([0-9]*\.?[0-9]+)$/.test(a)){
e="number";
t=RegExp.$1
}else{
if(/^\$\s*([0-9]*\.?[0-9]+)$/.test(a)||/^([0-9]*\.?[0-9]+)\$$/.test(a)){
e="currency";
t=RegExp.$1;
if(this._decimals==null){
this._decimals=2
}}else{
if(/^([0-9]*\.?[0-9]+)\s*%$/.test(a)){
e="percentage";
t=RegExp.$1
}}}}}
return{
type:e,val:t}
};
ZmSpreadSheetCellModel.prototype.getType=function(){
return this._type||this._autoType||"string"
};
ZmSpreadSheetCellModel.prototype.setType=function(e){
this._type=e;
if(e==null){
var t=this._determineType(this.getValue());
this._value=t.val;
this._type=t.type
}else{
if(e=="currency"&&this._decimals==null){
this._decimals=2
}}
if(this._td){
this.setToElement(this._td)
}};
ZmSpreadSheetCellModel.prototype.getDecimals=function(){
return this._decimals
};
ZmSpreadSheetCellModel.prototype.setDecimals=function(t){
this._decimals=t;
var e=this.getType();
if(e=="currency"&&t==null){
this._decimals=2
}
if(this._td){
this.setToElement(this._td)
}};
ZmSpreadSheetCellModel.prototype.clearValue=function(){
this._type=null;
this.setEditValue("")
};
ZmSpreadSheetCellModel.prototype.clearStyle=function(){
this._style=ZmSpreadSheetCellModel.getDefaultStyle();
if(this._td){
this.setStyleToElement(this._td)
}};
ZmSpreadSheetCellModel.prototype.clearAll=function(){
this._type=this._decimals=null;
this.clearStyle();
this.clearValue()
};
ZmSpreadSheetCellModel.prototype.setEditValue=function(editValue,force){
if(force||editValue!=this._editValue){
this._editValue=editValue;
var val=editValue;
var auto=this._determineType(editValue);
this._autoType=auto.type;
if(auto.type=="expression"){
var expr;
try{
expr=new ZmSpreadSheetFormulae(this._model,auto.val);
this._errorMessage=null
}
catch(ex){
expr=null;
this._errorMessage=ex;
val="#ERROR"
}
this.setExpression(expr);
if(expr){
val=expr.eval();
if(expr.decimals!=null&&this._decimals==null){
this._decimals=expr.decimals
}
auto=this._determineType(val);
this._autoType=expr.autoType||auto.type;
if(this._autoType=="currency"){
val=auto.val
}}else{
this._type=null;
this._autoType="error"
}}else{
this.setExpression(null);
val=auto.val;
if(auto.type=="string"){
if(!/^([\x27=]|\$?[0-9]+\.?[0-9]*$)/.test(val)){
this._editValue=editValue=val
}}}
this.setValue(val);
this._model.triggerEvent("onCellEdit",this.getRow(),this.getCol(),this)
}};
ZmSpreadSheetCellModel.prototype.getEditValue=function(){
return this._expr?"="+this._expr.getFormula():this._editValue
};
ZmSpreadSheetCellModel.prototype.getRow=function(){
if(this._td){
return this._td.parentNode.rowIndex
}else{
return this._savedRow
}};
ZmSpreadSheetCellModel.prototype.getCol=function(){
if(this._td){
return this._td.cellIndex
}else{
return this._savedCol
}};
ZmSpreadSheetCellModel.prototype._getTD=function(){
return this._td
};
ZmSpreadSheetCellModel.prototype.getName=function(){
if(this._td||(this._savedRow&&this._savedCol)){
return ZmSpreadSheetModel.getCellName(this.getRow(),this.getCol())
}else{
return"##"
}};
ZmSpreadSheetCellModel.prototype.setStyleProp=function(t,e){
this._style[t]=e;
if(this._td){
this.setStyleToElement(this._td)
}};
ZmSpreadSheetCellModel.prototype.getStyleProp=function(e){
return this._style[e]
};
ZmSpreadSheetCellModel.prototype.isEmpty=function(){
return this._editValue==""
};
ZmSpreadSheetCellModel.prototype.getTooltipText=function(){
var o=["<div class='ZmSpreadSheet-Tooltip'>","<div class='CellName'>",ZmMsg.cell," - ",this.getName(),"</div>"];
if(!this.isEmpty()){
o.push("<div class='CellType'>",ZmMsg.type,": ",this.getType(),"</div>")
}else{
o.push("<div class='CellType'>",ZmMsg.emptyCell,"</div>")
}
if(this._errorMessage){
o.push(ZmMsg.editValue,": ",this._editValue);
o.push("<div class='CellExprError'>",this._errorMessage,"</div>")
}else{
if(this._expr){
o.push(ZmMsg.expression,":");
o.push("<div class='CellExpr'>[",this._expr.toString(),"]</div>")
}}
if(ZmSpreadSheetModel.DEBUG){
var e=this._affects;
if(e.length>0){
o.push("Directly affects cells:<br />");
for(var t=0;
t<e.length;
++t){
o.push(e[t].getName()," ")
}
o.push("<br />")
}
e=this._mkDeps();
if(e.length>0){
o.push("Affects cells:<br />");
for(var t=0;
t<e.length;
++t){
o.push(e[t].getName()," ")
}
o.push("<br />")
}
var n=this._td.firstChild;
if(n.offsetWidth>=this._td.offsetWidth){
o.push("Value:","<div class='CellValue'>",this.getDisplayValue(),"</div>")
}}
o.push("</div>");
return o.join("")
}
}
if(AjxPackage.define("zimbraMail.ale.spreadsheet.ZmSpreadSheetFormulae")){
ZmSpreadSheetFormulae=function(e,t){
this._model=e;
if(t){
this.compile(t)
}};
ZmSpreadSheetFormulae.TOKEN={
STRING:{
match:{
exec:function(e){
if(!(/^([\x22\x27])/.test(e))){
return null
}
var a=RegExp.$1;
var t=false;
var n="";
for(var o=1;
o<e.length;
++o){
var s=e.charAt(o);
if(!t&&s=="\\"){
t=true
}else{
if(s==a&&!t){
return[e.substr(0,o+1),n]
}
if(t){
switch(s){
case"n":s="\n";
break;
case"t":s="\t";
break
}}
n+=s;
t=false
}}
throw"Unfinished string: "+e
}}
,getVal:function(e){
return e[1]
}
,isOpr:true,type:"string"}
,NUMBER:{
match:/^([0-9]*\.?[0-9]+)/,getVal:function(e){
return parseFloat(e[1],10)
}
,isOpr:true,isNumber:true,type:"number"}
,CURRENCY:{
match:/^\$\s*([0-9]*\.?[0-9]+)/,getVal:function(e){
return parseFloat(e[1],10)
}
,isOpr:true,isNumber:true,type:"currency"}
,CELLRANGE:{
match:/^([a-z]+[0-9]+:[a-z]+[0-9]+)/i,getVal:function(e){
return e[1].toUpperCase()
}
,isOpr:true,type:"cellrange"}
,CELL:{
match:/^([a-z]+[0-9]+)/i,getVal:function(e){
return e[1].toUpperCase()
}
,isOpr:true,type:"cell"}
,OPERATOR:{
match:/^(<=|>=|==|!=|lt|gt|eq|uc|lc|ne|&&|and|\|\||or|not|[-x*\/+%^.<>!])/,getVal:function(e){
return e[1]
}
,isOpr:false,type:"operator"}
,IDENTIFIER:{
match:/^([a-z_][a-z0-9_?]*)/i,getVal:function(e){
return e[1]
}
,isOpr:false,type:"identifier"}
,OPENPAREN:{
match:new RegExp("^\\("),getVal:function(e){
return e[0]
}
,isOpr:false,type:"openparen"}
,CLOSEPAREN:{
match:/^\)/,getVal:function(e){
return e[0]
}
,isOpr:false,type:"closeparen"}
,COMMA:{
match:new RegExp("^,"),getVal:function(e){
return e[0]
}
,isOpr:false,type:"comma"}};
ZmSpreadSheetFormulae.parseFloat=function(t,e){
if(typeof t=="boolean"){
return t?1:0
}
t=parseFloat(t,10);
if(isNaN(t)){
t=e?e:0
}
return t
};
ZmSpreadSheetFormulae.OPERATORS={
"+":{
priority:10,assoc:3,n_args:2}
,"-":{
priority:10,assoc:2,n_args:2}
,"*":{
priority:20,assoc:3,n_args:2}
,"/":{
priority:20,assoc:2,n_args:2}
,"%":{
priority:30,assoc:2,n_args:2}
,"^":{
priority:30,assoc:2,n_args:2}
,".":{
priority:5,assoc:2,n_args:2}
,lc:{
priority:5,assoc:1,n_args:1}
,uc:{
priority:5,assoc:1,n_args:1}
,x:{
priority:35,assoc:2,n_args:2}
,"<":{
priority:3,assoc:2,n_args:2}
,">":{
priority:3,assoc:2,n_args:2}
,"<=":{
priority:3,assoc:2,n_args:2}
,">=":{
priority:3,assoc:2,n_args:2}
,"==":{
priority:3,assoc:2,n_args:2}
,"!=":{
priority:3,assoc:2,n_args:2}
,lt:{
priority:3,assoc:2,n_args:2}
,gt:{
priority:3,assoc:2,n_args:2}
,eq:{
priority:3,assoc:2,n_args:2}
,ne:{
priority:3,assoc:2,n_args:2}
,"&&":{
priority:2,assoc:2,n_args:2}
,and:{
priority:2,assoc:2,n_args:2}
,"||":{
priority:2,assoc:2,n_args:2}
,or:{
priority:2,assoc:2,n_args:2}
,"!":{
priority:4,assoc:1,n_args:1}
,not:{
priority:4,assoc:1,n_args:1}};
ZmSpreadSheetFormulae.FUNCTIONS={};
ZmSpreadSheetFormulae.getFunc=function(e){
return ZmSpreadSheetFormulae.FUNCTIONS[e.toLowerCase()]
};
ZmSpreadSheetFormulae.HELP={};
ZmSpreadSheetFormulae.getHelp=function(t){
var a=ZmSpreadSheetFormulae.HELP[t];
var e=null;
if(a){
e=a.help;
if(a.args){
e+="<br />"+a.args
}}
return e
};
ZmSpreadSheetFormulae.DEF=function(a,t,l,e){
if(a instanceof Array){
var h=a[0];
var s;
ZmSpreadSheetFormulae.DEF(h,t,l,e);
if(e&&a.length>1){
var n={
alias:h};
for(s in e){
n[s]=e[s]
}
e=n
}
for(s=1;
s<a.length;
++s){
ZmSpreadSheetFormulae.DEF(a[s],t,l,e)
}}else{
var o={
name:a,n_args:t,func:l};
ZmSpreadSheetFormulae.FUNCTIONS[a.toLowerCase()]=o;
if(e){
ZmSpreadSheetFormulae.HELP[a]=e
}}};
ZmSpreadSheetFormulae.DEF(["sum","+"],-1,function(){
var e=0;
for(var t=arguments.length;
--t>=0;
){
e+=ZmSpreadSheetFormulae.parseFloat(arguments[t])
}
return e
}
,ZmMsg.SS.func.sum);
ZmSpreadSheetFormulae.DEF(["multiply","*"],-1,function(){
var e=1;
for(var t=arguments.length;
--t>=0;
){
e*=ZmSpreadSheetFormulae.parseFloat(arguments[t],1)
}
return e
}
,ZmMsg.SS.func.multiply);
ZmSpreadSheetFormulae.DEF(["modulo","%"],2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)%ZmSpreadSheetFormulae.parseFloat(e)
}
,ZmMsg.SS.func.modulo);
ZmSpreadSheetFormulae.DEF(["average","avg"],-1,function(){
var t=arguments.length;
var a=0;
for(var e=t;
--e>=0;
){
var o=arguments[e];
if(!/\S/.test(o)){
o=NaN
}
if(!isNaN(o)){
o=ZmSpreadSheetFormulae.parseFloat(o,NaN)
}
if(!isNaN(o)){
a+=o
}else{
--t
}}
return a/t
}
,ZmMsg.SS.func.average);
ZmSpreadSheetFormulae.DEF("PI",0,function(){
return Math.PI
}
,ZmMsg.SS.func.PI);
ZmSpreadSheetFormulae.DEF("sin",1,function(e){
return Math.sin(e)
}
,ZmMsg.SS.func.sin);
ZmSpreadSheetFormulae.DEF("cos",1,function(e){
return Math.cos(e)
}
,ZmMsg.SS.func.cos);
ZmSpreadSheetFormulae.DEF("tan",1,function(e){
return Math.tan(e)
}
,ZmMsg.SS.func.tan);
ZmSpreadSheetFormulae.DEF("round",1,function(e){
return Math.round(e)
}
,ZmMsg.SS.func.round);
ZmSpreadSheetFormulae.DEF("ceil",1,function(e){
return Math.ceil(e)
}
,ZmMsg.SS.func.ceil);
ZmSpreadSheetFormulae.DEF("floor",1,function(e){
return Math.floor(e)
}
,ZmMsg.SS.func.floor);
ZmSpreadSheetFormulae.DEF("abs",1,function(e){
return Math.abs(e)
}
,ZmMsg.SS.func.abs);
ZmSpreadSheetFormulae.DEF("sqrt",1,function(e){
return Math.sqrt(e)
}
,ZmMsg.SS.func.sqrt);
ZmSpreadSheetFormulae.DEF("exp",1,function(e){
return Math.exp(e)
}
,ZmMsg.SS.func.exp);
ZmSpreadSheetFormulae.DEF("log",1,function(e){
return Math.log(e)
}
,ZmMsg.SS.func.log);
ZmSpreadSheetFormulae.DEF("min",-1,function(){
var t=arguments[0];
for(var e=1;
e<arguments.length;
++e){
if(t>arguments[e]){
t=arguments[e]
}}
return t
}
,ZmMsg.SS.func.min);
ZmSpreadSheetFormulae.DEF("max",-1,function(){
var e=arguments[0];
for(var t=1;
t<arguments.length;
++t){
if(e<arguments[t]){
e=arguments[t]
}}
return e
}
,ZmMsg.SS.func.max);
ZmSpreadSheetFormulae.DEF("len",1,function(e){
return e.toString().length
}
,ZmMsg.SS.func.len);
ZmSpreadSheetFormulae.DEF(["concat","."],-1,function(){
var e=[arguments[0]];
for(var t=1;
t<arguments.length;
++t){
if(arguments[t]!=""){
e.push(arguments[t])
}}
return e.join("")
}
,ZmMsg.SS.func.concat);
ZmSpreadSheetFormulae.DEF("join",-2,function(t){
var e=[arguments[1]];
for(var a=2;
a<arguments.length;
++a){
if(arguments[a]!=""){
e.push(arguments[a])
}}
return e.join(t)
}
,ZmMsg.SS.func.join);
ZmSpreadSheetFormulae.DEF("x",2,function(a,t){
var e="";
while(t-->0){
e+=a
}
return e
}
);
ZmSpreadSheetFormulae.DEF("<",2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)<ZmSpreadSheetFormulae.parseFloat(e)
}
);
ZmSpreadSheetFormulae.DEF(">",2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)>ZmSpreadSheetFormulae.parseFloat(e)
}
);
ZmSpreadSheetFormulae.DEF("<=",2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)<=ZmSpreadSheetFormulae.parseFloat(e)
}
);
ZmSpreadSheetFormulae.DEF(">=",2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)>=ZmSpreadSheetFormulae.parseFloat(e)
}
);
ZmSpreadSheetFormulae.DEF("==",2,function(t,e){
return t==e
}
);
ZmSpreadSheetFormulae.DEF("!=",2,function(t,e){
return t!=e
}
);
ZmSpreadSheetFormulae.DEF(["&&","and"],2,function(t,e){
return t&&e
}
);
ZmSpreadSheetFormulae.DEF(["||","or"],2,function(t,e){
return t||e
}
);
ZmSpreadSheetFormulae.DEF(["!","not"],1,function(e){
return !e
}
);
ZmSpreadSheetFormulae.DEF("lt",2,function(t,e){
return t.toString()<e.toString()
}
);
ZmSpreadSheetFormulae.DEF("gt",2,function(t,e){
return t.toString()>e.toString()
}
);
ZmSpreadSheetFormulae.DEF("eq",2,function(t,e){
return t.toString()==e.toString()
}
);
ZmSpreadSheetFormulae.DEF("ne",2,function(t,e){
return t.toString()!=e.toString()
}
);
ZmSpreadSheetFormulae.DEF("lc",1,function(e){
return e.toString().toLowerCase()
}
);
ZmSpreadSheetFormulae.DEF("uc",1,function(e){
return e.toString().toUpperCase()
}
);
ZmSpreadSheetFormulae.DEF("if",3,function(a,e,t){
return a?e:t
}
);
ZmSpreadSheetFormulae.DEF("WHO_are_YOU?",0,function(){
return"http://www.zimbra.com/"
}
);
ZmSpreadSheetFormulae.DEF("-",2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)-ZmSpreadSheetFormulae.parseFloat(e)
}
);
ZmSpreadSheetFormulae.DEF("/",2,function(t,e){
return ZmSpreadSheetFormulae.parseFloat(t)/ZmSpreadSheetFormulae.parseFloat(e)
}
);
ZmSpreadSheetFormulae.DEF("^",2,function(t,e){
return Math.pow(t,e)
}
);
ZmSpreadSheetFormulae.prototype.depends=function(e){
return e!=null?this._deps[e]:this._deps
};
ZmSpreadSheetFormulae.prototype.dependsArray=function(){
return this._depsArray
};
ZmSpreadSheetFormulae.prototype.callFunction=function(t,e){
var a=ZmSpreadSheetFormulae.getFunc(t);
if(!a){
throw"No such function: "+t
}
return a.func.apply(this,e)
};
ZmSpreadSheetFormulae.prototype._analyzeRange=function(y){
var o=y.val;
var f=o.split(/:/);
var d=ZmSpreadSheetModel.identifyCell(f[0]);
var s=ZmSpreadSheetModel.identifyCell(f[1]);
var p=y.startRow=Math.min(d.row,s.row);
var t=y.startCol=Math.min(d.col,s.col);
var h=y.endRow=Math.max(d.row,s.row);
var u=y.endCol=Math.max(d.col,s.col);
y.startCell=this._model.data[p][t];
y.endCell=this._model.data[h][u];
var g=y.cells=[];
for(var l=p;
l<=h;
++l){
for(var n=t;
n<=u;
++n){
var m=this._model.data[l][n];
g.push(m);
var e=ZmSpreadSheetModel.getCellName(l+1,n+1);
if(!this._deps[e]){
this._deps[e]=m;
this._depsArray.push(m)
}}}};
ZmSpreadSheetFormulae.prototype.update=function(){
var l=this._formula,e=this._cellTokens,h=ZmSpreadSheetFormulae.TOKEN;
for(var s=e.length;
--s>=0;
){
var n=e[s];
var o=null;
if(n.type===h.CELL){
o=n.cell.getName()
}
if(n.type===h.CELLRANGE){
o=n.startCell.getName()+":"+n.endCell.getName()
}
if(o&&n.val!=o){
l=[l.substr(0,n.strPos),o,l.substr(n.strPos+n.strLen)].join("")
}}
if(l!=this._formula){
this.compile(l);
return l
}};
ZmSpreadSheetFormulae.prototype.shift=function(h,l){
var d=this._formula,e=this._cellTokens,c=ZmSpreadSheetFormulae.TOKEN;
for(var s=e.length;
--s>=0;
){
var n=e[s];
var o=null;
if(n.type===c.CELL){
o=ZmSpreadSheetModel.shiftCell(n.val,h,l)
}
if(n.type===c.CELLRANGE){
o=ZmSpreadSheetModel.shiftRange(n.val,h,l)
}
if(o&&n.val!=o){
d=[d.substr(0,n.strPos),o,d.substr(n.strPos+n.strLen)].join("")
}}
return d
};
ZmSpreadSheetFormulae.prototype.getFormula=function(){
return this._formula
};
ZmSpreadSheetFormulae.parseTokens=function(d,s){
var c=ZmSpreadSheetFormulae.TOKEN;
var u=[];
var m=0;
function y(t){
return t[t.length-1]
}
while(d.length>0){
var f=/^\s+/.exec(d);
if(f){
var l=f[0].length;
m+=l;
d=d.substr(l)
}
var w=false;
for(var h in c){
var g=c[h];
var f=g.match.exec(d);
if(f){
var e=g.getVal(f);
var l=f[0].length;
d=d.substr(l);
var p={
type:g,val:e,isOpr:g.isOpr,strPos:m,strLen:l};
m+=l;
if(g===c.OPERATOR){
var n=ZmSpreadSheetFormulae.OPERATORS[e];
p.priority=n.priority;
p.assoc=n.assoc;
p.n_args=n.n_args
}
if(g===c.IDENTIFIER){
var o=ZmSpreadSheetFormulae.getFunc(e);
if(!o&&!s){
throw'No such function: "'+e+'"'
}
p.priority=100;
if(o&&o.n_args==0){
p.isOpr=true;
p.val=o.func()
}}
u.push(p);
w=true;
break
}}
if(!w){
if(!s){
throw"Parse error at: "+d
}else{
d=d.substr(1);
++m
}}}
return u
};
ZmSpreadSheetFormulae.prototype.getTokens=function(){
return this._tokens
};
ZmSpreadSheetFormulae.prototype.compile=function(l){
this._formula=new String(l);
this._deps={};
this._depsArray=[];
this._cellTokens=[];
this._running=false;
var h=ZmSpreadSheetFormulae.TOKEN;
function g(t){
return t[t.length-1]
}
var c=this._tokens=ZmSpreadSheetFormulae.parseTokens(l);
var m=null;
var f=0;
var w=false;
for(var n=0;
n<c.length;
++n){
var p=c[n];
var s=c[n+1];
if(p.type===h.OPERATOR&&!s){
throw"Misplaced operator"
}
if(m){
if(p.type===h.COMMA&&(m.type===h.COMMA||m.type===h.OPENPAREN)){
throw"Misplaced comma"
}}
if(p.type===h.CELL){
p.val=p.val.toUpperCase();
var u=ZmSpreadSheetModel.identifyCell(p.val);
this._model.checkBounds(u.row,u.col);
p.cell=this._deps[p.val];
if(!p.cell){
p.cell=this._deps[p.val]=this._model.data[u.row][u.col];
this._depsArray.push(p.cell)
}
this._cellTokens.push(p)
}
if(p.type===h.CELLRANGE){
this._analyzeRange(p);
this._cellTokens.push(p)
}
if(p.type===h.OPENPAREN){
f++;
if(m&&m.isOpr){
throw"Paren after operand"
}}
if(p.type===h.CLOSEPAREN){
f--
}
if(p.type===h.OPERATOR&&p.val=="-"&&(!m||!m.isOpr)&&s.type.isNumber){
s.val=-s.val;
c.splice(n,1);
p=m;
--n
}
m=p
}
if(f!=0){
throw"Mismatched parentheses"
}
var d=[];
var a=[];
for(var n=0;
n<c.length;
++n){
var p=c[n];
if(p.isOpr){
a.push(p)
}else{
if(p.type===h.IDENTIFIER){
p.n_args=-1;
d.push(p);
if(ZmSpreadSheetFormulae.getFunc(p.val).n_args!=0){
if(!c[n+1]||c[n+1].type!==h.OPENPAREN){
throw'Function "'+p.val+'" expects arguments.'
}}}else{
if(p.type===h.COMMA){
while(d.length>0&&g(d).type!==h.OPENPAREN){
a.push(d.pop())
}
if(d.length==0||!c[n+1]||c[n+1].type===h.CLOSEPAREN){
throw"Syntax error: misplaced comma or parens"
}
var o=d[d.length-2];
if(!o||o.type!==h.IDENTIFIER){
throw"Syntax error: expecting a function identifier"
}
++o.n_args
}else{
if(p.type===h.OPERATOR){
var e;
while(((e=g(d))!=null)&&e.type===h.OPERATOR&&((p.assoc>=2&&p.priority<=e.priority)||(p.assoc==1&&p.priority>e.priority))){
a.push(d.pop())
}
d.push(p)
}else{
if(p.type===h.OPENPAREN){
var o=g(d);
var s=c[n+1];
if(o&&o.type===h.IDENTIFIER&&s&&s.type!==h.CLOSEPAREN){
++o.n_args
}
d.push(p)
}else{
if(p.type===h.CLOSEPAREN){
while(d.length>0&&g(d).type!==h.OPENPAREN){
a.push(d.pop())
}
if(d.length==0){
throw"Syntax error: misplaced parens"
}else{
d.pop()
}
if(d.length>0&&g(d).type===h.IDENTIFIER){
var o=d.pop();
o.n_args++;
a.push(o);
var y=ZmSpreadSheetFormulae.getFunc(o.val).n_args;
if(y!=null){
if(y>=0&&o.n_args!=y){
throw"Function "+o.val+" expects exactly "+y+" arguments."
}
if(y<0&&o.n_args+y<0){
throw"Function "+o.val+" expects at least "+(-y)+" arguments."
}}}}}}}}}}
while(d.length>0){
var p=d.pop();
if((p.type!==h.OPERATOR&&p.type!==h.IDENTIFIER)||(p.type===h.IDENTIFIER&&ZmSpreadSheetFormulae.getFunc(p.val).n_args>0)){
throw"Expecting only operators or constants at ZmSpreadSheetFormulae.compile"
}
a.push(p)
}
this._stack=a
};
ZmSpreadSheetFormulae.prototype.eval=function(){
if(this._running){
return""
}
this._running=true;
var o=ZmSpreadSheetFormulae.TOKEN,n=this._stack,a=n.length-1,h=this;
var l={};
var e=null;
function s(c){
l[c.getType()]=true;
if(c.getDecimals()!=null){
if(e==null){
e=0
}
if(e<c.getDecimals()){
e=c.getDecimals()
}}
return c.getValue()
}
function t(){
var d=n[a--];
if(d.type===o.CELL){
return s(d.cell)
}
if(d.type===o.CELLRANGE){
var c=new Array(d.cells.length);
for(var f=c.length;
--f>=0;
){
c[f]=s(d.cells[f])
}
return c
}
if(d.isOpr){
return d.val
}
var m=[],u=d.n_args;
while(u-->0){
var p=t();
if(p instanceof Array){
m.unshift.apply(m,p)
}else{
m.unshift(p)
}}
return h.callFunction(d.val,m)
}
var i=t();
if(l.percentage&&!l.currency){
l="percentage"
}else{
if(l.currency){
l="currency"
}else{
l=null
}}
this.autoType=l;
this.decimals=e;
this._running=false;
return i
};
ZmSpreadSheetFormulae.prototype.toString=function(){
return this._formula
}
}
if(AjxPackage.define("zimbraMail.ale.spreadsheet.ZmSpreadSheetToolbars")){
ZmSpreadSheetToolbars=function(t,e){
if(e==null){
e=t
}
this._spreadSheet=e;
DwtComposite.call(this,{
parent:t,className:"ZmSpreadSheetToolbars",posStyle:DwtControl.RELATIVE_STYLE}
);
this._on_buttonPress=new AjxListener(this,this._on_buttonPress);
this._buttons={};
this._createWidgets();
if(t===e){
t=t.getHtmlElement();
t.insertBefore(this.getHtmlElement(),t.firstChild)
}
e.onSelectCell.push(new AjxCallback(this,this._cellSelected))
};
ZmSpreadSheetToolbars.prototype=new DwtComposite;
ZmSpreadSheetToolbars.prototype.construction=ZmSpreadSheetToolbars;
ZmSpreadSheetToolbars.prototype._cellSelected=function(e){
this._buttons.bold.setSelected(e.getStyleProp("fontWeight")=="bold");
this._buttons.italic.setSelected(e.getStyleProp("fontStyle")=="italic");
this._buttons.underline.setSelected(e.getStyleProp("textDecoration")=="underline");
this._buttons.strike.setSelected(e.getStyleProp("textDecoration")=="line-through");
var a=e.getStyleProp("textAlign");
this._buttons.justifyLeft.setSelected(a=="left");
this._buttons.justifyCenter.setSelected(a=="center");
this._buttons.justifyRight.setSelected(a=="right");
if(this._dataField){
this._dataField.setValue(e.getEditValue())
}
this._buttons.typeSelect.setSelectedValue(e.getType());
var t=e.getDecimals();
if(t==null){
t=-1
}
this._buttons.decimalsSelect.setSelectedValue(t)
};
ZmSpreadSheetToolbars.prototype._createWidgets=function(){
this._createToolbar1();
this._createToolbar2()
};
ZmSpreadSheetToolbars.prototype._createToolbar1=function(){
var t=new DwtToolBar({
parent:this,className:"ToolBar",posStyle:DwtControl.RELATIVE_STYLE}
);
var a=this._on_buttonPress;
var e;
var i={
parent:t};
e=this._buttons.clipboardCopy=new DwtToolBarButton(i);
e.setImage("Copy");
e.setData("SS","ClipboardCopy");
e.addSelectionListener(a);
e.setToolTipContent(ZmMsg.copy);
e=this._buttons.clipboardCut=new DwtToolBarButton(i);
e.setImage("Cut");
e.setData("SS","ClipboardCut");
e.addSelectionListener(a);
e.setToolTipContent(ZmMsg.cut);
e=this._buttons.clipboardPaste=new DwtToolBarButton(i);
e.setImage("Paste");
e.setData("SS","ClipboardPaste");
e.addSelectionListener(a);
e.setToolTipContent(ZmMsg.paste);
new DwtControl({
parent:t,className:"vertSep"}
);
i.style=DwtButton.TOGGLE_STYLE;
e=this._buttons.bold=new DwtToolBarButton(i);
e.setImage("Bold");
e.setData("SS","Bold");
e.addSelectionListener(a);
e.setToolTipContent(AjxKeys["editor.Bold.summary"]);
e=this._buttons.italic=new DwtToolBarButton(i);
e.setImage("Italics");
e.setData("SS","Italic");
e.addSelectionListener(a);
e.setToolTipContent(AjxKeys["editor.Italic.summary"]);
e=this._buttons.underline=new DwtToolBarButton(i);
e.setImage("Underline");
e.setData("SS","Underline");
e.addSelectionListener(a);
e.setToolTipContent(AjxKeys["editor.Underline.summary"]);
e=this._buttons.strike=new DwtToolBarButton(i);
e.setImage("StrikeThru");
e.setData("SS","Strike");
e.addSelectionListener(a);
e.setToolTipContent(AjxKeys["editor.Strikethru.summary"]);
new DwtControl({
parent:t,className:"vertSep"}
);
e=this._buttons.justifyLeft=new DwtToolBarButton(i);
e.setImage("LeftJustify");
e.setData("SS","JustifyLeft");
e.addSelectionListener(a);
e.setToolTipContent(AjxKeys["editor.LeftJustify.summary"]);
e=this._buttons.justifyCenter=new DwtToolBarButton(i);
e.setImage("CenterJustify");
e.setData("SS","JustifyCenter");
e.addSelectionListener(a);
e.setToolTipContent(AjxKeys["editor.CenterJustify.summary"]);
e=this._buttons.justifyRight=new DwtToolBarButton(i);
e.setImage("RightJustify");
e.setData("SS","JustifyRight");
e.addSelectionListener(a);
e.setToolTipContent(AjxKeys["editor.RightJustify.summary"]);
new DwtControl({
parent:t,className:"vertSep"}
);
e=this._buttons.fontColor=new ZmSpreadSheetEditorColorPicker(t,null,"DwtToolbarButton",null,null,null,ZmMsg.auto);
e.setImage("FontColor");
e.showColorDisplay();
e.setToolTipContent(ZmMsg.fontColor);
e.addSelectionListener(new AjxListener(this,this._on_fontColor));
e=this._buttons.bgColor=new ZmSpreadSheetEditorColorPicker(t,null,"DwtToolbarButton",null,null,null,ZmMsg.auto);
e.setImage("FontBackground");
e.showColorDisplay();
e.setToolTipContent(ZmMsg.fontBackground);
e.addSelectionListener(new AjxListener(this,this._on_bgColor))
};
ZmSpreadSheetToolbars.prototype._inputModified=function(e){
if(this._dataField){
this._dataField.setValue(e)
}};
ZmSpreadSheetToolbars.prototype._input_clicked=function(t){
var e=new DwtUiEvent();
this._dataField.getInputElement().blur();
e.setFromDhtmlEvent(t);
var a=this._spreadSheet._selectedCell;
if(a){
this._spreadSheet.focus();
this._spreadSheet._editCell(a)
}
e._stopPropagation=true;
e._returnValue=false;
e.setToDhtmlEvent(t);
return false
};
ZmSpreadSheetToolbars.prototype._createToolbar2=function(){
var l=new DwtToolBar({
parent:this,className:"ToolBar ToolBar2",posStyle:DwtControl.RELATIVE_STYLE}
);
var a=this._on_buttonPress;
var o={
parent:l,style:0};
b=this._buttons.rowInsertAbove=new DwtToolBarButton(o);
b.setImage("InsertRowBefore");
b.setData("SS","RowInsertAbove");
b.addSelectionListener(a);
b.setToolTipContent(ZmMsg.insertRowAbove);
b=this._buttons.rowInsertUnder=new DwtToolBarButton(o);
b.setImage("InsertRowAfter");
b.setData("SS","RowInsertUnder");
b.addSelectionListener(a);
b.setToolTipContent(ZmMsg.insertRowUnder);
b=this._buttons.rowDelete=new DwtToolBarButton(o);
b.setImage("DeleteRow");
b.setData("SS","RowDelete");
b.addSelectionListener(a);
b.setToolTipContent(ZmMsg.deleteRow);
new DwtControl({
parent:l,className:"vertSep"}
);
b=this._buttons.colInsertBefore=new DwtToolBarButton(o);
b.setImage("InsertColBefore");
b.setData("SS","ColInsertBefore");
b.addSelectionListener(a);
b.setToolTipContent(ZmMsg.insertColumnBefore);
b=this._buttons.colInsertAfter=new DwtToolBarButton(o);
b.setImage("InsertColAfter");
b.setData("SS","ColInsertAfter");
b.addSelectionListener(a);
b.setToolTipContent(ZmMsg.insertColumnAfter);
b=this._buttons.colDelete=new DwtToolBarButton(o);
b.setImage("DeleteCol");
b.setData("SS","ColDelete");
b.addSelectionListener(a);
b.setToolTipContent(ZmMsg.deleteColumn);
new DwtControl({
parent:l,className:"vertSep"}
);
b=new DwtToolBarButton(o);
b.setImage("Sum");
b.setToolTipContent(ZmMsg.sumCells);
b.setData("SS","Func-SumCells");
b.addSelectionListener(a);
b=new DwtToolBarButton(o);
b.setText(ZmMsg.insertFunction);
var t=new DwtMenu({
parent:b}
);
t.dontStealFocus();
var e=[];
for(var h in ZmSpreadSheetFormulae.HELP){
e.push(h)
}
e=e.sort();
var d=new AjxListener(this,this._on_insertFunction);
for(var h=0;
h<e.length;
++h){
var n=ZmSpreadSheetFormulae.HELP[e[h]];
if(n.alias){
continue
}
var u=new DwtMenuItem({
parent:t}
);
u.setText(['<div style="float:left; width: 5em; text-align: right">',e[h],"</div>",'<div style="margin-left: 5em">&nbsp;- ',n.help,"</div>"].join(""));
u.setData("SS",e[h]);
u.addSelectionListener(d);
if(n.args){
u.setToolTipContent(n.args)
}}
b.setMenu(t);
new DwtControl({
parent:l,className:"vertSep"}
);
var m=this._buttons.typeSelect=new ZmSpreadSheetEditorSelect(l,null);
m.addChangeListener(new AjxListener(this,this._on_typeSelect));
m.addOption(ZmMsg.spreadSheet_msg_autoType,true,null);
m.addOption(ZmMsg.number,false,"number");
m.addOption(ZmMsg.currency,false,"currency");
m.addOption(ZmMsg.percent,false,"percentage");
m.addOption(ZmMsg.text,false,"string");
var m=this._buttons.decimalsSelect=new ZmSpreadSheetEditorSelect(l,null);
m.addChangeListener(new AjxListener(this,this._on_decimalsSelect));
m.addOption(ZmMsg.spreadSheet_msg_autoDecimals,true,-1);
var c=new AjxMessageFormat(ZmMsg.spreadsheet_msg_numberOfDecimals);
for(var h=0;
h<=6;
h++){
m.addOption(c.format(h),false,h)
}
if(ZmSpreadSheetModel.DEBUG){
new DwtControl({
parent:l,className:"vertSep"}
);
new DwtLabel({
parent:l}
).setText("DEBUG: ");
b=new DwtToolBarButton(o);
b.setText("Serialize");
b.addSelectionListener(new AjxListener(this,function(){
var i=this.getModel().serialize();
var f=window.open(appContextPath+"/public/blank.html","_blank","scrollbars=no");
var s=setInterval(function(){
try{
var y=f.document;
b=y.body;
b.style.backgroundColor="ButtonFace";
var g=y.createElement("textarea");
g.value=i;
b.appendChild(g);
g.style.width="100%";
g.style.height="100%";
clearInterval(s)
}
catch(p){}}
,250)
}
));
b=new DwtToolBarButton(o);
b.setText("getHtml");
b.addSelectionListener(new AjxListener(this,function(){
var i=this.getModel().getHtml();
var f=window.open(appContextPath+"/public/blank.html","_blank","scrollbars=yes");
var s=setInterval(function(){
try{
var g=f.document;
b=g.body;
b.style.backgroundColor="ButtonFace";
b.innerHTML=i;
clearInterval(s)
}
catch(p){}}
,250)
}
))
}};
ZmSpreadSheetToolbars.prototype._on_insertFunction=function(e){
this.insertFunction(e.item.getData("SS"))
};
ZmSpreadSheetToolbars.prototype._on_fontColor=function(e){
this.applyStyle("color",e.detail);
this._spreadSheet.focus()
};
ZmSpreadSheetToolbars.prototype._on_bgColor=function(e){
this.applyStyle("backgroundColor",e.detail);
this._spreadSheet.focus()
};
ZmSpreadSheetToolbars.prototype._on_buttonPress=function(i){
var a=i.item;
var o=a.getData("SS");
var t=this._spreadSheet;
t.focus();
switch(o){
case"ClipboardCopy":t.clipboardCopy();
break;
case"ClipboardCut":t.clipboardCut();
break;
case"ClipboardPaste":t.clipboardPaste();
break;
case"Bold":this.applyStyle("fontWeight",a.isToggled()?"bold":"");
break;
case"Italic":this.applyStyle("fontStyle",a.isToggled()?"italic":"");
break;
case"Strike":this.applyStyle("textDecoration",a.isToggled()?"line-through":"");
this._buttons.underline.setSelected(false);
break;
case"Underline":this.applyStyle("textDecoration",a.isToggled()?"underline":"");
this._buttons.strike.setSelected(false);
break;
case"JustifyLeft":this.applyStyle("textAlign",a.isToggled()?"left":"");
this._buttons.justifyCenter.setSelected(false);
this._buttons.justifyRight.setSelected(false);
break;
case"JustifyCenter":this.applyStyle("textAlign",a.isToggled()?"center":"");
this._buttons.justifyLeft.setSelected(false);
this._buttons.justifyRight.setSelected(false);
break;
case"JustifyRight":this.applyStyle("textAlign",a.isToggled()?"right":"");
this._buttons.justifyLeft.setSelected(false);
this._buttons.justifyCenter.setSelected(false);
break;
case"RowInsertAbove":var e=t.getSelectedCellModel();
if(e){
this.getModel().insertRow(e.getRow()-1)
}
break;
case"RowInsertUnder":var e=t.getSelectedCellModel();
if(e){
this.getModel().insertRow(e.getRow())
}
break;
case"ColInsertBefore":var e=t.getSelectedCellModel();
if(e){
this.getModel().insertCol(e.getCol()-1)
}
break;
case"ColInsertAfter":var e=t.getSelectedCellModel();
if(e){
this.getModel().insertCol(e.getCol())
}
break;
case"RowDelete":var e=t.getSelectedCellModel();
if(e){
this.getModel().deleteRow(e.getRow()-1)
}
break;
case"ColDelete":var e=t.getSelectedCellModel();
if(e){
this.getModel().deleteCol(e.getCol()-1)
}
break;
case"Func-SumCells":this.insertFunction("sum");
break
}};
ZmSpreadSheetToolbars.prototype.insertFunction=function(o){
var i=this._spreadSheet;
var e=i.getSelectedCellModel();
if(e){
var a=ZmSpreadSheetFormulae.HELP[o];
var n=o.length+2;
if(a&&a.helper){
o=a.helper;
n=o.indexOf("|");
o=o.replace(/\|/g,"")
}else{
o="="+o+"()"
}
var t=i._getInputField();
i.focus();
i._editCell(e._td);
t.setValue(o);
Dwt.setSelectionRange(t,n,n)
}};
ZmSpreadSheetToolbars.prototype._on_typeSelect=function(a){
this._spreadSheet.focus();
var e=this._spreadSheet.getSelectionRange();
if(!e){
return
}
var t=a._args.newValue;
this.getModel().forEachCell(e,function(i){
i.setType(t)
}
,this)
};
ZmSpreadSheetToolbars.prototype._on_decimalsSelect=function(t){
this._spreadSheet.focus();
var e=this._spreadSheet.getSelectionRange();
if(!e){
return
}
var a=t._args.newValue;
if(a==-1){
a=null
}
this.getModel().forEachCell(e,function(i){
i.setDecimals(a)
}
,this)
};
ZmSpreadSheetToolbars.prototype.getModel=function(){
return this._spreadSheet._model
};
ZmSpreadSheetToolbars.prototype.applyStyle=function(t,a){
var e=this._spreadSheet.getSelectionRange();
if(!e){
return
}
this.getModel().forEachCell(e,function(i){
i.setStyleProp(t,a)
}
,this)
};
ZmSpreadSheetEditorColorPicker=function(o,i,a,t,s,e,n){
DwtButtonColorPicker.call(this,o,i,a,t,s,e,n)
};
ZmSpreadSheetEditorColorPicker.prototype=new DwtButtonColorPicker;
ZmSpreadSheetEditorColorPicker.prototype.constructor=ZmSpreadSheetEditorColorPicker;
ZmSpreadSheetEditorColorPicker.prototype.TEMPLATE="dwt.Widgets#ZToolbarButton";
ZmSpreadSheetEditorSelect=function(i,e,a,t){
DwtSelect.call(this,{
parent:i,options:e,className:a,posStyle:t}
)
};
ZmSpreadSheetEditorSelect.prototype=new DwtSelect;
ZmSpreadSheetEditorSelect.prototype.constructor=ZmSpreadSheetEditorSelect;
ZmSpreadSheetEditorSelect.prototype.TEMPLATE="dwt.Widgets#ZBorderlessButton"
}
if(AjxPackage.define("zimbraMail.ale.spreadsheet.test-embed")){
Test=function(){
this.shell=new DwtShell({
className:"MainShell"}
);
try{
var a=new DwtComposite(this.shell,"","absolute");
var e=new DwtButton({
parent:a,style:0}
);
e.setText("Insert Spreadsheet");
e.setSize(100,null);
var o=new DwtHtmlEditor({
parent:a,className:"ZmHtmlEditor",content:"<h1>Check This Out</h1><p>paragraph</p>",mode:DwtHtmlEditor.HTML,blankIframeSrc:"/public/blank.html"}
);
a.setLocation(20,20);
o.setSize(800,600);
var t=false;
e.addSelectionListener(function(){
var n=o._getIframeDoc();
if(AjxEnv.isGeckoBased&&!t){
t=true;
n.addEventListener("blur",function(){
o._getIframeDoc().designMode="off"
}
,true);
n.addEventListener("focus",function(){
o._getIframeDoc().designMode="on"
}
,true)
}
o.focus();
if(AjxEnv.isGeckoBased){
n.designMode="off"
}
var s=n.createElement("iframe");
s.src=location.protocol+"//"+location.hostname+((location.port=="80")?"":":"+location.port)+"/public/Spreadsheet.jsp";
s.style.width="100%";
s.style.height="400px";
o._insertNodeAtSelection(s)
}
);
a.setZIndex(Dwt.Z_VIEW)
}
catch(i){
alert(i.dump())
}};
Test.run=function(){
new Test()
}
}};
