
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtKeyMap=function(e){
if(e){
return
}
this._map={};
this._args={};
this._checkedMap={};
this._load(this._map,AjxKeys);
DwtKeyMap.MOD_ORDER[DwtKeyMap.ALT]=1;
DwtKeyMap.MOD_ORDER[DwtKeyMap.CTRL]=2;
DwtKeyMap.MOD_ORDER[DwtKeyMap.META]=3;
DwtKeyMap.MOD_ORDER[DwtKeyMap.SHIFT]=4
};
DwtKeyMap.deserialize=function(e){
alert("DwtKeyMap.deserialize: NOT IMPLEMENTED")
};
DwtKeyMap.serialize=function(e){
alert("DwtKeyMap.serialize: NOT IMPLEMENTED")
};
DwtKeyMap.MAP_NAME={};
DwtKeyMap.MAP_NAME.dialog="DwtDialog";
DwtKeyMap.MAP_NAME.button="DwtButton";
DwtKeyMap.MAP_NAME.list="DwtListView";
DwtKeyMap.MAP_NAME.menu="DwtMenu";
DwtKeyMap.MAP_NAME.editor="DwtHtmlEditor";
DwtKeyMap.MAP_NAME.toolbar="DwtToolBar";
DwtKeyMap.MAP_NAME.toolbarHorizontal="DwtToolBar-horiz";
DwtKeyMap.MAP_NAME.toolbarVertical="DwtToolBar-vert";
DwtKeyMap.MAP_NAME.tabView="DwtTabView";
DwtKeyMap.MAP_NAME.tree="DwtTreeItem";
DwtKeyMap.MAP_NAME_R={};
(function(){
for(var e in DwtKeyMap.MAP_NAME){
DwtKeyMap.MAP_NAME_R[DwtKeyMap.MAP_NAME[e]]=e
}}
)();
DwtKeyMap.IS_MODIFIER={};
DwtKeyMap.MOD_ORDER={};
DwtKeyMap.ARROW_DOWN="ArrowDown";
DwtKeyMap.ARROW_LEFT="ArrowLeft";
DwtKeyMap.ARROW_RIGHT="ArrowRight";
DwtKeyMap.ARROW_UP="ArrowUp";
DwtKeyMap.BACKSLASH="Backslash";
DwtKeyMap.BACKSPACE="Backspace";
DwtKeyMap.COMMA="Comma";
DwtKeyMap.SEMICOLON="Semicolon";
DwtKeyMap.DELETE="Del";
DwtKeyMap.END="End";
DwtKeyMap.ENTER="Enter";
DwtKeyMap.ESC="Esc";
DwtKeyMap.HOME="Home";
DwtKeyMap.PGDOWN="PgDown";
DwtKeyMap.PGUP="PgUp";
DwtKeyMap.SPACE="Space";
DwtKeyMap.TAB="Tab";
DwtKeyMap.ACTION="ContextMenu";
DwtKeyMap.SELECT_CURRENT="SelectCurrent";
DwtKeyMap.ADD_SELECT_NEXT="AddNext";
DwtKeyMap.ADD_SELECT_PREV="AddPrevious";
DwtKeyMap.CANCEL="Cancel";
DwtKeyMap.COLLAPSE="Collapse";
DwtKeyMap.DBLCLICK="DoubleClick";
DwtKeyMap.EXPAND="Expand";
DwtKeyMap.GOTO_TAB="GoToTab";
DwtKeyMap.HEADER1="Header1";
DwtKeyMap.HEADER2="Header2";
DwtKeyMap.HEADER3="Header3";
DwtKeyMap.HEADER4="Header4";
DwtKeyMap.HEADER5="Header5";
DwtKeyMap.HEADER6="Header6";
DwtKeyMap.JUSTIFY_CENTER="CenterJustify";
DwtKeyMap.JUSTIFY_LEFT="LeftJustify";
DwtKeyMap.JUSTIFY_RIGHT="RightJustify";
DwtKeyMap.NEXT="Next";
DwtKeyMap.NEXT_TAB="NextTab";
DwtKeyMap.NO="No";
DwtKeyMap.PAGE_UP="PageUp";
DwtKeyMap.PAGE_DOWN="PageDown";
DwtKeyMap.PARENTMENU="ParentMenu";
DwtKeyMap.PREV="Previous";
DwtKeyMap.PREV_TAB="PreviousTab";
DwtKeyMap.SELECT_ALL="SelectAll";
DwtKeyMap.SELECT="Select";
DwtKeyMap.SELECT_FIRST="SelectFirst";
DwtKeyMap.SELECT_LAST="SelectLast";
DwtKeyMap.SELECT_NEXT="SelectNext";
DwtKeyMap.SELECT_PREV="SelectPrevious";
DwtKeyMap.SUBMENU="SubMenu";
DwtKeyMap.SWITCH_MODE="SwitchMode";
DwtKeyMap.TEXT_BOLD="Bold";
DwtKeyMap.TEXT_ITALIC="Italic";
DwtKeyMap.TEXT_UNDERLINE="Underline";
DwtKeyMap.TEXT_STRIKETHRU="Strikethru";
DwtKeyMap.YES="Yes";
DwtKeyMap.DELETE="Delete";
DwtKeyMap.GOTO_TAB_RE=new RegExp(DwtKeyMap.GOTO_TAB+"(\\d+)");
DwtKeyMap.JOIN="+";
DwtKeyMap.SEP=",";
DwtKeyMap.INHERIT="INHERIT";
DwtKeyMap.prototype.getMap=function(){
return this._map
};
DwtKeyMap.prototype._load=function(w,h,u){
u=u||{};
var f=AjxEnv.platform.toLowerCase();
for(var r in h){
var d=r.split(".");
var s=d[d.length-1];
if(s=="win"||s=="mac"||s=="linux"){
if(s==f){
var y=d.slice(0,d.length-1).join(".");
h[y]=h[r]
}
h[r]=null
}}
for(var r in h){
var n=AjxStringUtil.trim(h[r]);
if(!n||(typeof h[r]!="string")){
continue
}
var d=r.split(".");
var e=d[d.length-1];
var a=(d.length==2);
var m=a?null:d[1];
if(d[0]=="keys"){
this._processKeyDef(m,e,n);
continue
}
if(e!=DwtKeyMap.INHERIT&&e!="keycode"){
continue
}
var c=DwtKeyMap.MAP_NAME[d[0]]||u[d[0]];
if((this._checkedMap[c]===false)||(!this._checkedMap[c]&&!this._checkMap(c))){
continue
}
if(!w[c]){
w[c]={}
}
if(!this._checkAction(c,m)){
continue
}
var o=n.split(/\s*;\s*/);
for(var g=0;
g<o.length;
g++){
var v=this._canonicalize(o[g]);
if(e==DwtKeyMap.INHERIT){
var b=v.split(/\s*,\s*/);
var t=[];
for(var l=0;
l<b.length;
l++){
t[l]=DwtKeyMap.MAP_NAME[b[l]]||u[b[l]]
}
w[c][d[1]]=t.join(",")
}else{
if(e=="keycode"){
w[c][v]=m
}}}}};
DwtKeyMap.prototype._checkMap=function(t){
var e=true;
this._checkedMap[t]=e;
return e
};
DwtKeyMap.prototype._checkAction=function(e,t){
return true
};
DwtKeyMap.prototype._processKeyDef=function(e,a,t){
if(!e||!a||!t){
return
}
if(a=="display"){
DwtKeyMap[e.toUpperCase()]=t
}else{
if(a=="keycode"){
DwtKeyMap.IS_MODIFIER[t]=true
}}};
DwtKeyMap.prototype._canonicalize=function(r){
var n=r.split(DwtKeyMap.SEP);
var e=[];
for(var a=0;
a<n.length;
a++){
var t=n[a];
var s=t.split(DwtKeyMap.JOIN);
if(s.length>2){
var o=s.slice(0,s.length-1);
o.sort(function(c,h){
var l=DwtKeyMap.MOD_ORDER[c]||0;
var i=DwtKeyMap.MOD_ORDER[h]||0;
return Number(l-i)
}
);
o.push(s[s.length-1]);
e.push(o.join(DwtKeyMap.JOIN))
}else{
e.push(t)
}}
return e.join(",")
};
