
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtKeyboardMgr=function(e){
DwtKeyboardMgr.__shell=e;
this.__tabGrpStack=[];
this.__defaultHandlerStack=[];
this.__tabGroupChangeListenerObj=new AjxListener(this,this.__tabGrpChangeListener);
this.__kbEventStatus=DwtKeyboardMgr.__KEYSEQ_NOT_HANDLED;
this.__keyTimeout=750;
this.__currTabGroup=null;
this.__currDefaultHandler=null;
this._evtMgr=new AjxEventMgr()
};
DwtKeyboardMgr.__KEYSEQ_NOT_HANDLED=1;
DwtKeyboardMgr.__KEYSEQ_HANDLED=2;
DwtKeyboardMgr.__KEYSEQ_PENDING=3;
DwtKeyboardMgr.FOCUS_FIELD_ID="kbff";
DwtKeyboardMgr.isPossibleInputShortcut=function(e){
var t=DwtUiEvent.getTarget(e);
return(!DwtKeyMap.IS_MODIFIER[e.keyCode]&&(e.keyCode==27||DwtKeyMapMgr.hasModifier(e))||(t&&t.nodeName.toUpperCase()=="INPUT"&&(e.keyCode==13||e.keyCode==3)))
};
DwtKeyboardMgr.prototype.toString=function(){
return"DwtKeyboardMgr"
};
DwtKeyboardMgr.prototype.pushTabGroup=function(t){
if(!this.__keyboardHandlingInited||!t){
return
}
this.__tabGrpStack.push(t);
this.__currTabGroup=t;
var e=t.getFocusMember();
if(!e){
e=t.resetFocusMember(true)
}
if(!e){
return
}
t.addFocusChangeListener(this.__tabGroupChangeListenerObj);
this.grabFocus(e)
};
DwtKeyboardMgr.prototype.popTabGroup=function(r){
if(!this.__keyboardHandlingInited){
return
}
if(!r){
return
}
if(this.__tabGrpStack.length<=1){
return null
}
if(r&&this.__tabGrpStack[this.__tabGrpStack.length-1]!=r){
var t=this.__tabGrpStack;
var e=t.length;
for(var s=e-1;
s>=0;
s--){
if(r==t[s]){
t[s].dump();
break
}}
if(s<0){
return null
}else{
if(s!=e-1){
t.splice(s,1);
return r
}}}
var r=this.__tabGrpStack.pop();
r.removeFocusChangeListener(this.__tabGroupChangeListenerObj);
var n=null;
if(this.__tabGrpStack.length>0){
n=this.__tabGrpStack[this.__tabGrpStack.length-1];
var o=n.getFocusMember();
if(!o){
o=n.resetFocusMember(true)
}
if(o){
this.grabFocus(o)
}}
this.__currTabGroup=n;
return r
};
DwtKeyboardMgr.prototype.setTabGroup=function(t){
if(!this.__enabled||!this.__keyboardHandlingInited){
return
}
var e=this.popTabGroup();
this.pushTabGroup(t);
return e
};
DwtKeyboardMgr.prototype.getCurrentTabGroup=function(){
return this.__currTabGroup
};
DwtKeyboardMgr.prototype.pushDefaultHandler=function(e){
if(!this.__enabled||!this.__keyboardHandlingInited||!e){
return
}
if(this.__currDefaultHandler&&this.__currDefaultHandler._zIndex&&e._zIndex&&(this.__currDefaultHandler._zIndex>e._zIndex)){
this.__defaultHandlerStack.splice((this.__defaultHandlerStack.length-1),0,e)
}else{
this.__defaultHandlerStack.push(e);
this.__currDefaultHandler=e
}};
DwtKeyboardMgr.prototype.popDefaultHandler=function(){
if(!this.__keyboardHandlingInited||(this.__defaultHandlerStack.length<=1)){
return
}
var e=this.__defaultHandlerStack.pop();
this.__currDefaultHandler=this.__defaultHandlerStack[this.__defaultHandlerStack.length-1];
return e
};
DwtKeyboardMgr.prototype.grabFocus=function(e){
if(!this.__enabled){
return
}
if(!this.__keyboardHandlingInited){
return
}
if(typeof e=="string"){
e=document.getElementById(e)
}
if(!e){
return
}
if(this.__currTabGroup){
this.__currTabGroup.setFocusMember(e,false,true)
}
this.__doGrabFocus(e)
};
DwtKeyboardMgr.prototype.inputGotFocus=function(e){
this.__focusObj=e;
this.__dwtInputCtrl=true;
this.__dwtCtrlHasFocus=false;
if(this.__currTabGroup){
this.__currTabGroup.setFocusMember(e.getTabGroupMember(),false,true)
}};
DwtKeyboardMgr.prototype.getFocusObj=function(e){
return this.__focusObj
};
DwtKeyboardMgr.prototype.dwtControlHasFocus=function(e){
if(!this.__enabled){
return false
}
if(!this.__keyboardHandlingInited){
return false
}
return(this.__dwtCtrlHasFocus&&this.__focusObj==e)
};
DwtKeyboardMgr.prototype.registerDefaultKeyActionHandler=function(e){
if(!this.__enabled){
return
}
this.__defaultKeyActionHdlr=e
};
DwtKeyboardMgr.prototype.registerKeyMap=function(e){
if(!this.__checkStatus()){
return
}
this.__keyMapMgr=new DwtKeyMapMgr(e)
};
DwtKeyboardMgr.prototype.setKeyTimeout=function(e){
this.__keyTimeout=e
};
DwtKeyboardMgr.prototype.clearKeySeq=function(){
this.__killKeySeqTimedActionId=-1;
this.__keySequence=[]
};
DwtKeyboardMgr.prototype.enable=function(e){
this.__enabled=e;
if(e){
this.__checkStatus();
Dwt.setHandler(document,DwtEvent.ONKEYDOWN,DwtKeyboardMgr.__keyDownHdlr);
Dwt.setHandler(document,DwtEvent.ONKEYUP,DwtKeyboardMgr.__keyUpHdlr);
Dwt.setHandler(document,DwtEvent.ONKEYPRESS,DwtKeyboardMgr.__keyPressHdlr)
}else{
Dwt.clearHandler(document,DwtEvent.ONKEYDOWN);
Dwt.clearHandler(document,DwtEvent.ONKEYUP);
Dwt.clearHandler(document,DwtEvent.ONKEYPRESS)
}};
DwtKeyboardMgr.prototype.isEnabled=function(){
return this.__enabled
};
DwtKeyboardMgr.prototype.addListener=function(e,t){
this._evtMgr.addListener(e,t)
};
DwtKeyboardMgr.prototype.removeListener=function(e,t){
this._evtMgr.removeListener(e,t)
};
DwtKeyboardMgr.prototype.__initKeyboardHandling=function(){
var e=this._kbFocusField=document.createElement("textarea");
e.id=DwtKeyboardMgr.FOCUS_FIELD_ID;
e.tabIndex=0;
e.style.position=Dwt.ABSOLUTE_STYLE;
e.style.top=e.style.left=Dwt.LOC_NOWHERE;
e.onblur=DwtKeyboardMgr.__onBlurHdlr;
e.onfocus=DwtKeyboardMgr.__onFocusHdlr;
document.body.appendChild(e);
this.__killKeySeqTimedAction=new AjxTimedAction(this,this.__killKeySequenceAction);
this.__killKeySeqTimedActionId=-1;
this.__keySequence=[];
this.__keyboardHandlingInited=true
};
DwtKeyboardMgr.prototype.__checkStatus=function(){
if(!this.__enabled){
return false
}
if(!this.__keyboardHandlingInited){
this.__initKeyboardHandling()
}
return true
};
DwtKeyboardMgr.prototype.__doGrabFocus=function(e){
if(!e){
return
}
var i=(Dwt.instanceOf(e,"DwtInputField")||Dwt.instanceOf(e,"DwtHtmlEditor")||Dwt.instanceOf(e,"DwtCheckbox")||Dwt.instanceOf(e,"DwtRadioButton")||Dwt.instanceOf(e,"ZmAdvancedHtmlEditor"));
if(i||!(e instanceof DwtControl)){
if(this.__focusObj instanceof DwtControl&&!this.__dwtInputCtrl){
this.__oldFocusObj=this.__focusObj
}
this.__focusObj=e;
this.__dwtInputCtrl=i;
var a=i?e.getInputElement():e;
if((!AjxEnv.isIE&&e.focus)||(AjxEnv.isIE&&e.focus&&!a.disabled&&Dwt.getVisible(a))){
try{
e.focus()
}
catch(t){}}}else{
if(this.__dwtCtrlHasFocus&&(this.__focusObj instanceof DwtControl)){
DwtKeyboardMgr.__onBlurHdlr();
this.__dwtCtrlHasFocus=true
}
this.__focusObj=e;
this.__dwtInputCtrl=false;
if(this.__dwtCtrlHasFocus){
DwtKeyboardMgr.__onFocusHdlr()
}else{
DwtKeyboardMgr.__onFocusHdlr();
this._kbFocusField.focus()
}}};
DwtKeyboardMgr.__onFocusHdlr=function(t){
var a=DwtKeyboardMgr.__shell.getKeyboardMgr();
a.__dwtCtrlHasFocus=true;
var e=a.__focusObj;
if(e&&e.__doFocus){
e.__doFocus()
}};
DwtKeyboardMgr.__onBlurHdlr=function(t){
var a=DwtKeyboardMgr.__shell.getKeyboardMgr();
var e=a.__oldFocusObj||a.__focusObj;
if(e&&e.__doBlur){
e.__doBlur()
}
a.__oldFocusObj=null;
a.__dwtCtrlHasFocus=false
};
DwtKeyboardMgr.__keyUpHdlr=function(e){
e=DwtUiEvent.getEvent(e);
var t=DwtKeyboardMgr.__shell.getKeyboardMgr();
if(t._evtMgr.notifyListeners(DwtEvent.ONKEYUP,e)===false){
return false
}
if(AjxEnv.isMac&&AjxEnv.isGeckoBased&&e.keyCode==0){
return DwtKeyboardMgr.__keyDownHdlr(e)
}else{
return DwtKeyboardMgr.__handleKeyEvent(e)
}};
DwtKeyboardMgr.__keyPressHdlr=function(e){
e=DwtUiEvent.getEvent(e);
var t=DwtKeyboardMgr.__shell.getKeyboardMgr();
if(t._evtMgr.notifyListeners(DwtEvent.ONKEYPRESS,e)===false){
return false
}
DwtKeyEvent.geckoCheck(e);
return DwtKeyboardMgr.__handleKeyEvent(e)
};
DwtKeyboardMgr.__handleKeyEvent=function(e){
if(DwtKeyboardMgr.__shell._blockInput){
return false
}
e=DwtUiEvent.getEvent(e,this);
var a=DwtKeyboardMgr.__shell.getKeyboardMgr();
var t=DwtShell.keyEvent;
t.setFromDhtmlEvent(e);
if(a.__kbEventStatus!=DwtKeyboardMgr.__KEYSEQ_NOT_HANDLED){
return a.__processKeyEvent(e,t,false)
}};
DwtKeyboardMgr.__syncFocus=function(t,e){
if((e!=t._kbFocusField)&&t.__dwtCtrlHasFocus){
t._kbFocusField.focus()
}
if(!t.__dwtCtrlHasFocus){
if((e!=t.__focusObj)&&!t.__dwtInputCtrl){
if(t.__currTabGroup&&t.__currTabGroup.setFocusMember(e)){
t.__focusObj=e;
t.__oldFocusObj=null
}else{
return false
}}}
return true
};
DwtKeyboardMgr.__keyDownHdlr=function(r){
try{
r=DwtUiEvent.getEvent(r,this);
var e=DwtKeyboardMgr.__shell.getKeyboardMgr();
r.focusObj=null;
if(e._evtMgr.notifyListeners(DwtEvent.ONKEYDOWN,r)===false){
return false
}
if(DwtKeyboardMgr.__shell._blockInput){
return false
}
if(e&&!e.isEnabled()){
return true
}
if(!e||!e.__checkStatus()){
return false
}
var l=DwtShell.keyEvent;
l.setFromDhtmlEvent(r);
var h=DwtKeyEvent.getCharCode(r);
DwtKeyboardMgr.__shell.getToolTip().popdown();
var i=DwtKeyboardMgr.__syncFocus(e,l.target);
if(!i){}
if(h==DwtKeyMapMgr.TAB_KEYCODE){
if(e.__currTabGroup&&!DwtKeyMapMgr.hasModifier(l)){
if(!DwtMenu.menuShowing()){
if(i||e.__currTabGroup.getFocusMember()){
if(!l.shiftKey){
e.__currTabGroup.getNextFocusMember(true)
}else{
e.__currTabGroup.getPrevFocusMember(true)
}}else{
e.__currTabGroup.resetFocusMember(true)
}}
return e.__processKeyEvent(r,l,false,DwtKeyboardMgr.__KEYSEQ_HANDLED)
}else{
return e.__processKeyEvent(r,l,true,DwtKeyboardMgr.__KEYSEQ_NOT_HANDLED)
}}else{
if(e.__currTabGroup&&!i&&AjxEnv.isGecko&&l.target instanceof HTMLHtmlElement){
e.__currTabGroup.resetFocusMember(true)
}}
if(e.__dwtCtrlHasFocus){
e._kbFocusField.value=""
}
if(DwtKeyMap.IS_MODIFIER[h]||(!e.__dwtCtrlHasFocus&&(e.__killKeySeqTimedActionId==-1)&&DwtKeyMapMgr.isInputElement(l.target)&&!DwtKeyboardMgr.isPossibleInputShortcut(l))){
return e.__processKeyEvent(r,l,true,DwtKeyboardMgr.__KEYSEQ_NOT_HANDLED)
}
if(e.__killKeySeqTimedActionId!=-1){
AjxTimedAction.cancelAction(e.__killKeySeqTimedActionId);
e.__killKeySeqTimedActionId=-1
}
var t=[];
if(l.altKey){
t.push(DwtKeyMap.ALT)
}
if(l.ctrlKey){
t.push(DwtKeyMap.CTRL)
}
if(l.metaKey){
t.push(DwtKeyMap.META)
}
if(l.shiftKey){
t.push(DwtKeyMap.SHIFT)
}
t.push(h);
e.__keySequence[e.__keySequence.length]=t.join(DwtKeyMap.JOIN);
var n=DwtKeyboardMgr.__KEYSEQ_NOT_HANDLED;
var a=r.focusObj||e.__focusObj;
if(a&&(a.handleKeyAction)&&(e.__dwtCtrlHasFocus||e.__dwtInputCtrl||(a.hasFocus&&a.hasFocus()))){
n=e.__dispatchKeyEvent(a,l);
while((n==DwtKeyboardMgr.__KEYSEQ_NOT_HANDLED)&&a.parent&&a.parent.getKeyMapName){
a=a.parent;
n=e.__dispatchKeyEvent(a,l)
}}
if((n==DwtKeyboardMgr.__KEYSEQ_NOT_HANDLED)&&e.__currDefaultHandler&&!(e.__currTabGroup&&e.__currTabGroup.isDefaultHandlingBlocked())){
n=e.__dispatchKeyEvent(e.__currDefaultHandler,l)
}
e.__kbEventStatus=n;
var o=(n==DwtKeyboardMgr.__KEYSEQ_NOT_HANDLED);
if(n!=DwtKeyboardMgr.__KEYSEQ_PENDING){
e.clearKeySeq()
}
return e.__processKeyEvent(r,l,o)
}
catch(s){
AjxException.reportScriptError(s)
}};
DwtKeyboardMgr.prototype.__dispatchKeyEvent=function(o,n,a){
if(o&&o.handleKeyEvent){
var s=o.handleKeyEvent(n);
return s?DwtKeyboardMgr.__KEYSEQ_HANDLED:DwtKeyboardMgr.__KEYSEQ_NOT_HANDLED
}
var i=(o&&o.getKeyMapName)?o.getKeyMapName():null;
if(!i){
return DwtKeyboardMgr.__KEYSEQ_NOT_HANDLED
}
var t=this.__keyMapMgr.getActionCode(this.__keySequence,i,a);
if(t==DwtKeyMapMgr.NOT_A_TERMINAL){
this.__hdlr=o;
this.__mapName=i;
this.__ev=n;
this.__killKeySeqTimedActionId=AjxTimedAction.scheduleAction(this.__killKeySeqTimedAction,this.__keyTimeout);
return DwtKeyboardMgr.__KEYSEQ_PENDING
}else{
if(t!=null){
if(!o.handleKeyAction){
return DwtKeyboardMgr.__KEYSEQ_NOT_HANDLED
}
var e=o.handleKeyAction(t,n);
return e?DwtKeyboardMgr.__KEYSEQ_HANDLED:DwtKeyboardMgr.__KEYSEQ_NOT_HANDLED
}else{
return DwtKeyboardMgr.__KEYSEQ_NOT_HANDLED
}}};
DwtKeyboardMgr.prototype.__killKeySequenceAction=function(){
this.__dispatchKeyEvent(this.__hdlr,this.__ev,true);
this.clearKeySeq()
};
DwtKeyboardMgr.prototype.__tabGrpChangeListener=function(e){
this.__doGrabFocus(e.newFocusMember)
};
DwtKeyboardMgr.prototype.__processKeyEvent=function(a,i,e,t){
if(t){
this.__kbEventStatus=t
}
i._stopPropagation=!e;
i._returnValue=e;
i.setToDhtmlEvent(a);
return e
};
