
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtMenu=function(o){
this._created=false;
if(arguments.length==0){
return
}
o=Dwt.getParams(arguments,DwtMenu.PARAMS);
this._origStyle=o.style;
var a=o.parent;
if(a){
if(a instanceof DwtMenuItem||a instanceof DwtButton){
if(o.style==DwtMenu.GENERIC_WIDGET_STYLE){
this._style=o.style
}else{
this._style=DwtMenu.DROPDOWN_STYLE
}}else{
this._style=o.style||DwtMenu.POPUP_STYLE
}
if(!o.posStyle){
o.posStyle=(this._style==DwtMenu.BAR_STYLE)?DwtControl.STATIC_STYLE:DwtControl.ABSOLUTE_STYLE
}}
o.className=o.className||"DwtMenu";
this._layoutStyle=o.layout==null||o.layout;
if(this._layoutStyle===true){
this._layoutStyle=DwtMenu.LAYOUT_CASCADE
}else{
if(this._layoutStyle===false){
this._layoutStyle=DwtMenu.LAYOUT_STACK
}}
this._maxRows=this._layoutStyle&&o.maxRows||0;
this._congruent=o.congruent;
o.parent=(a instanceof DwtShell)?a:a.shell;
DwtComposite.call(this,o);
this.parent=a;
var e=(this._style==DwtMenu.POPUP_STYLE||this._style==DwtMenu.DROPDOWN_STYLE);
if(e&&(this._layoutStyle==DwtMenu.LAYOUT_STACK)){
this.setScrollStyle(DwtControl.SCROLL)
}
if(!a){
return
}
var t=AjxEnv.isIE?[DwtEvent.ONMOUSEDOWN,DwtEvent.ONMOUSEUP]:[DwtEvent.ONMOUSEDOWN,DwtEvent.ONMOUSEUP,DwtEvent.ONMOUSEOVER,DwtEvent.ONMOUSEOUT];
this._setEventHdlrs(t);
this._hasSetMouseEvents=true;
var i=this.getHtmlElement();
if(o.posStyle!=DwtControl.STATIC_STYLE){
Dwt.setLocation(i,Dwt.LOC_NOWHERE,Dwt.LOC_NOWHERE)
}
if(this._style!=DwtMenu.COLOR_PICKER_STYLE&&this._style!=DwtMenu.CALENDAR_PICKER_STYLE&&this._style!=DwtMenu.GENERIC_WIDGET_STYLE){
this._table=document.createElement("table");
this._table.border=this._table.cellPadding=this._table.cellSpacing=0;
this._table.className="DwtMenuTable";
this._table.id=Dwt.getNextId();
if(this._layoutStyle==DwtMenu.LAYOUT_SCROLL){
this._setupScroll()
}else{
i.appendChild(this._table)
}
this._table.backgroundColor=DwtCssStyle.getProperty(i,"background-color")
}
if(o.style!=DwtMenu.BAR_STYLE){
this.setZIndex(Dwt.Z_HIDDEN);
this._isPoppedUp=false
}else{
DwtMenu._activeMenuIds.add(i.id,null,true);
this._isPoppedUp=true
}
this._popdownAction=new AjxTimedAction(this,this._doPopdown);
this._popdownActionId=-1;
this._popupAction=new AjxTimedAction(this,this._doPopup);
this._popupActionId=-1;
this._outsideListener=new AjxListener(null,DwtMenu._outsideMouseDownListener);
this._menuItemsHaveChecks=false;
this._menuItemsHaveIcons=false;
this._menuItemsWithSubmenus=0;
this.__currentItem=null;
this.__preventMenuFocus=false;
this._tabGroup=new DwtTabGroup(this.toString(),true);
this._tabGroup.addMember(this);
this._created=true;
this._itemSelectionListener=new AjxListener(this,this._propagateItemSelection)
};
DwtMenu.PARAMS=["parent","style","className","posStyle","cascade","id"];
DwtMenu.prototype=new DwtComposite;
DwtMenu.prototype.constructor=DwtMenu;
DwtMenu.prototype.toString=function(){
return"DwtMenu"
};
DwtMenu.BAR_STYLE=1;
DwtMenu.POPUP_STYLE=2;
DwtMenu.DROPDOWN_STYLE=3;
DwtMenu.COLOR_PICKER_STYLE=4;
DwtMenu.CALENDAR_PICKER_STYLE=5;
DwtMenu.GENERIC_WIDGET_STYLE=6;
DwtMenu.HAS_ICON="ZHasIcon";
DwtMenu.HAS_CHECK="ZHasCheck";
DwtMenu.HAS_SUBMENU="ZHasSubMenu";
DwtMenu.LAYOUT_STACK=0;
DwtMenu.LAYOUT_CASCADE=1;
DwtMenu.LAYOUT_SCROLL=2;
DwtMenu._activeMenuUp=false;
DwtMenu._activeMenuIds=new AjxVector();
DwtMenu._activeMenus=new AjxVector();
DwtMenu.prototype.dispose=function(){
this._table=null;
DwtComposite.prototype.dispose.call(this);
if(!(this.parent instanceof DwtShell)){
this.shell.removeChild(this)
}};
DwtMenu.prototype.addSelectionListener=function(e){
this.addListener(DwtEvent.SELECTION,e)
};
DwtMenu.prototype.removeSelectionListener=function(e){
this.removeListener(DwtEvent.SELECTION,e)
};
DwtMenu.prototype.addPopupListener=function(e){
this.addListener(DwtEvent.POPUP,e)
};
DwtMenu.prototype.removePopupListener=function(e){
this.removeListener(DwtEvent.POPUP,e)
};
DwtMenu.prototype.addPopdownListener=function(e){
this.addListener(DwtEvent.POPDOWN,e)
};
DwtMenu.prototype.removePopdownListener=function(e){
this.removeListener(DwtEvent.POPDOWN,e)
};
DwtMenu.prototype.setWidth=function(e){
this._width=e
};
DwtMenu.prototype.getItem=function(e){
return this._children.get(e)
};
DwtMenu.prototype.getItemIndex=function(e){
return this._children.indexOf(e)
};
DwtMenu.prototype.getItemById=function(a,n){
var e=this.getItems();
for(var t=0;
t<e.length;
t++){
var o=e[t].getData(a);
if(o==n){
return e[t]
}}
return null
};
DwtMenu.prototype.getItemCount=function(){
return this._children.size()
};
DwtMenu.prototype.getItems=function(){
return this._children.getArray()
};
DwtMenu.prototype.getSelectedItem=function(n){
var e=this._children.getArray();
for(var o=0;
o<e.length;
o++){
var t=e[o];
if((n==null||(t._style&&n!=0))&&t.getChecked()){
return t
}}
return null
};
DwtMenu.prototype.isPoppedUp=function(){
return this._isPoppedUp
};
DwtMenu.prototype.popup=function(a,e,i,t){
if(this._style==DwtMenu.BAR_STYLE){
return
}
if(this._popdownActionId!=-1){
AjxTimedAction.cancelAction(this._popdownActionId);
this._popdownActionId=-1
}else{
if(this._isPoppedUp||(this._popupActionId!=-1&&a&&a>0)){
return
}else{
if(this._popupActionId!=-1){
AjxTimedAction.cancelAction(this._popupActionId);
this._popupActionId=-1
}}
if(!a){
this._doPopup(e,i,t)
}else{
this._popupAction.args=[e,i,t];
this._popupActionId=AjxTimedAction.scheduleAction(this._popupAction,a)
}}};
DwtMenu.prototype.popdown=function(e){
if(this._style==DwtMenu.BAR_STYLE){
return
}
if(this._popupActionId!=-1){
AjxTimedAction.cancelAction(this._popupActionId);
this._popupActionId=-1
}else{
if(!this._isPoppedUp||this._popdownActionId!=-1){
return
}
if(e==null||e==0){
this._doPopdown()
}else{
this._popdownActionId=AjxTimedAction.scheduleAction(this._popdownAction,e)
}}};
DwtMenu.prototype._setupScroll=function(){
var r=this.getHtmlElement();
this._table.style.position="relative";
this._topScroller=document.createElement("div");
this._topScroller.className="DwtMenuScrollTop";
this._topScroller.id=Dwt.getNextId();
this._imgDivTop=document.createElement("div");
this._imgDivTop.className="ImgUpArrowSmall";
this._topScroller.appendChild(this._imgDivTop);
Dwt.setHandler(this._imgDivTop,DwtEvent.ONMOUSEOUT,DwtMenu._stopEvent);
Dwt.setHandler(this._imgDivTop,DwtEvent.ONMOUSEOVER,DwtMenu._stopEvent);
r.appendChild(this._topScroller);
this._tableContainer=document.createElement("div");
this._tableContainer.appendChild(this._table);
r.appendChild(this._tableContainer);
this._bottomScroller=document.createElement("div");
this._bottomScroller.className="DwtMenuScrollBottom";
this._bottomScroller.id=Dwt.getNextId();
this._imgDivBottom=document.createElement("div");
this._imgDivBottom.className="ImgDownArrowSmall";
Dwt.setHandler(this._imgDivBottom,DwtEvent.ONMOUSEOUT,DwtMenu._stopEvent);
Dwt.setHandler(this._imgDivBottom,DwtEvent.ONMOUSEOVER,DwtMenu._stopEvent);
this._bottomScroller.appendChild(this._imgDivBottom);
r.appendChild(this._bottomScroller);
var a=AjxCallback.simpleClosure(this._scroll,this,this._table.id,true,false);
var e=AjxCallback.simpleClosure(this._scroll,this,this._table.id,false,false);
var t=AjxCallback.simpleClosure(this._handleMouseOut,this,this._topScroller.id,this._table.id);
var n=AjxCallback.simpleClosure(this._handleMouseOut,this,this._bottomScroller.id,this._table.id);
Dwt.setHandler(this._topScroller,DwtEvent.ONMOUSEDOWN,a);
Dwt.setHandler(this._topScroller,DwtEvent.ONMOUSEUP,e);
if(!AjxEnv.isIE){
Dwt.setHandler(this._topScroller,DwtEvent.ONMOUSEOUT,t)
}else{
Dwt.setHandler(this._topScroller,DwtEvent.ONMOUSELEAVE,e)
}
var o=AjxCallback.simpleClosure(this._scroll,this,this._table.id,true,true);
var i=AjxCallback.simpleClosure(this._scroll,this,this._table.id,false,true);
Dwt.setHandler(this._bottomScroller,DwtEvent.ONMOUSEDOWN,o);
Dwt.setHandler(this._bottomScroller,DwtEvent.ONMOUSEUP,i);
if(!AjxEnv.isIE){
Dwt.setHandler(this._bottomScroller,DwtEvent.ONMOUSEOUT,n)
}else{
Dwt.setHandler(this._bottomScroller,DwtEvent.ONMOUSELEAVE,i)
}
var s=AjxCallback.simpleClosure(this._handleScroll,this,this._table.id);
Dwt.setHandler(r,DwtEvent.ONMOUSEWHEEL,s)
};
DwtMenu.prototype.render=function(v,b){
var z=this.shell.getSize();
var D=this.getSize();
var k=this.getHtmlElement();
z.y-=10+(AjxEnv.isIE?20:0);
z.x-=28;
var q=this._layoutStyle==DwtMenu.LAYOUT_SCROLL;
var s=(this._style==DwtMenu.POPUP_STYLE||this._style==DwtMenu.DROPDOWN_STYLE);
var A=this._layoutStyle==DwtMenu.LAYOUT_CASCADE;
if(this._table){
if(s&&A){
var S=z.y;
var F=null;
var w=this._table.rows;
var r=w.length;
var t=this._maxRows;
var T=D.y;
var g=S-25;
for(var B=r-1;
B>=0;
B--){
T-=Dwt.getSize(w[B]).y;
if(T<g){
break
}}
var p=t?Math.min(B+1,t):(B+1);
for(var W=p;
W<r;
W++){
var f=w[(W-p)%p];
var o=f.insertCell(-1);
o.className="DwtMenuCascadeCell";
var m=w[W].cells[0].firstChild;
while(m!=null){
o.appendChild(m);
m=m.nextSibling
}}
for(W=w.length-1;
W>=p;
W--){
this._table.deleteRow(p)
}
var d=r%p;
if(d>0){
for(var W=d;
W<p;
W++){
var f=w[W];
var o=f.insertCell(-1);
o.className="DwtMenuCascadeCell";
o.empty=true;
o.innerHTML="&nbsp;"
}}
D=this.getSize();
if(F){
b=F-D.y
}}else{
if(s&&q){
var w=this._table.rows;
var r=w.length;
var t=this._maxRows;
var u=t?Math.min(t,r):r;
var c=z.y-25;
var T=20;
for(var B=0;
B<u;
B++){
var e=Dwt.getSize(w[B]).y;
if(T+e<=c){
T+=e
}else{
break
}}
D.y=T
}}}
var R="auto";
var l="auto";
if(s&&q){
l=D.y;
if(this._tableContainer){
this._tableContainer.style.height=(l-20)+"px"
}}else{
if((s&&A)||b+D.y<z.y-5){
l="auto"
}else{
l=z.y-b-5
}}
if(q){
if(this._table){
this._table.style.width=D.x
}
R=D.x
}
this.setSize(R,l);
if((AjxEnv.isGeckoBased||AjxEnv.isSafari||(this._origStyle==DwtMenu.CALENDAR_PICKER_STYLE))&&this._table&&!q){
k.style.width=(D.x+(s&&!A?10:0))+"px"
}
var M=v+D.x>=z.x?z.x-D.x:v;
if(this.parent instanceof DwtMenuItem){
Dwt.delClass(k,"DwtMenu-congruentLeft");
Dwt.delClass(k,"DwtMenu-congruentRight");
var C=this.parent.getBounds();
var H=DwtCssStyle.getComputedStyleObject(this.parent.parent.getHtmlElement());
var a=DwtCssStyle.getComputedStyleObject(k);
if(((M>C.x&&M<C.x+C.width)||(C.x>M&&C.x<M+D.x))&&C.x>=D.x){
var n=parseInt(a.width);
if(!AjxEnv.isIE){
n+=parseInt(a.paddingLeft)+parseInt(a.paddingRight)+parseInt(a.borderLeftWidth)+parseInt(a.borderRightWidth)
}
M=(parseInt(H.left)||C.x)-(n||D.x);
if(this._congruent){
var d;
if(AjxEnv.isIE){
d=parseInt(a.borderLeftWidth)
}else{
d=parseInt(a.borderLeftWidth)+parseInt(a.borderRightWidth)
}
if(!isNaN(d)){
M+=d;
Dwt.addClass(k,"DwtMenu-congruentLeft")
}}}else{
var h=parseInt(H.left)||(C.x-(parseInt(H.paddingLeft)||0));
var O=parseInt(H.width)||C.width;
M=h+O;
if(this._congruent){
var d=parseInt(H.paddingRight)+parseInt(a.paddingLeft)+parseInt(a.borderLeftWidth);
if(!isNaN(d)){
M+=d;
Dwt.addClass(k,"DwtMenu-congruentRight")
}}}}
var F=s&&b+D.y>=z.y?z.y-D.y:b;
if(this.parent instanceof DwtMenuItem&&this._congruent){
var d=(parseInt(a.paddingTop)||0)-(parseInt(a.borderTopWidth)||0);
if(d>0){
F-=d
}}
this.setLocation(M,F)
};
DwtMenu.prototype.getKeyMapName=function(){
return"DwtMenu"
};
DwtMenu.prototype._handleScroll=function(e,i){
if(!i){
i=window.event
}
var n=Dwt.byId(e);
if(n&&i){
i=i?i:window.event;
var t=i.detail?i.detail*-1:i.wheelDelta/40;
var o=n.rows;
var a=Dwt.getSize(o[0]).y||10;
this._popdownSubmenus();
if(t>0){
this._doScroll(n,+a)
}else{
if(t<0){
this._doScroll(n,-a)
}}}};
DwtMenu.prototype._handleMouseOut=function(e,t,a){
if(e&&a.type&&a.type=="mouseout"&&!AjxEnv.isIE){
var i=e?Dwt.byId(e):null;
fromEl=a.target;
if(fromEl!=i){
return
}
toEl=a.relatedTarget;
while(toEl){
toEl=toEl.parentNode;
if(toEl==i){
return
}}
this._scroll(t,false,false,null)
}};
DwtMenu.prototype._scroll=function(e,n,o,a){
var s=e?document.getElementById(e):null;
if(s&&n){
var i=s.rows;
var t=Dwt.getSize(i[0]).y||10;
if(this._direction!=o||!this._scrollTimer){
this._popdownSubmenus();
this._direction=o;
if(this._scrollTimer){
clearInterval(this._scrollTimer);
this._scrollTimer=null
}
if(o){
this._scrollTimer=setInterval(AjxCallback.simpleClosure(this._doScroll,this,s,-t),100);
this._doScroll(s,-t)
}else{
this._scrollTimer=setInterval(AjxCallback.simpleClosure(this._doScroll,this,s,t),100);
this._doScroll(s,t)
}}}else{
if(this._scrollTimer){
clearInterval(this._scrollTimer);
this._scrollTimer=null
}}};
DwtMenu.prototype._doScroll=function(s,i){
if(s&&i){
var a=parseInt(s.style.top)||0;
var n;
if(i<0){
var o=this._table.rows||null;
var t=o&&o.length&&Dwt.getSize(o[0]).y;
var e=s.scrollHeight-(parseInt(s.parentNode.style.height)||((this._maxRows||(o&&o.length))*t)||0);
if(Math.abs(a+i)<=e){
n=a+i
}else{
n=-e
}}else{
if((a+i)<0){
n=a+i
}else{
n=0
}}
Dwt.setLocation(s,Dwt.DEFAULT,n)
}};
DwtMenu.prototype.scrollToItem=function(a,e){
var t=this.getItemIndex(a);
if(t!=-1){
this.scrollToIndex(t,e)
}};
DwtMenu.prototype.scrollToIndex=function(r,o){
if(this._created&&this._layoutStyle==DwtMenu.LAYOUT_SCROLL&&r!==null&&r>=0&&this._table){
var f=this._table.rows;
if(f){
var u=this._maxRows;
var e=0;
var c=[];
for(var a=0,s=f.length;
a<s;
a++){
var n=Dwt.getSize(f[a]).y;
if(a<u){
e+=n
}
c.push(n)
}
var t=c[r];
var l=parseInt(this._table.style.top)||0;
if(r>=f.length){
r=f.length-1
}
var d=0;
for(var a=0;
a<r&&a<c.length;
a++){
d+=c[a]
}
var m=0;
if(o){
if(d<-l){
m=-(d+l)
}else{
if(d+t>e-l){
m=-(d+l-e+t)
}}}else{
m=-(d+l)
}
if(m){
this._popdownSubmenus();
this._doScroll(this._table,m)
}}}};
DwtMenu.prototype.handleKeyAction=function(t,i){
switch(this._style){
case DwtMenu.BAR_STYLE:case DwtMenu.POPUP_STYLE:case DwtMenu.DROPDOWN_STYLE:break;
default:return false
}
switch(t){
case DwtKeyMap.PAGE_UP:case DwtKeyMap.PAGE_DOWN:var a=this.__currentItem||this._children.get(0);
var e=this.getItemIndex(a);
if(this._maxRows&&e!=-1){
this.setSelectedItem(e+((t==DwtKeyMap.PAGE_UP)?-this._maxRows:this._maxRows))
}else{
this.setSelectedItem(t==DwtKeyMap.PAGE_DOWN)
}
break;
case DwtKeyMap.SELECT_NEXT:case DwtKeyMap.SELECT_PREV:this.setSelectedItem(t==DwtKeyMap.SELECT_NEXT);
break;
case DwtKeyMap.SELECT:if(this.__currentItem){
this.__currentItem._emulateSingleClick()
}
break;
case DwtKeyMap.SUBMENU:if(this.__currentItem&&this.__currentItem._menu){
this.__currentItem._popupMenu(0,true)
}
break;
case DwtKeyMap.PARENTMENU:if(this.parent instanceof DwtMenuItem){
this.popdown(0)
}
break;
case DwtKeyMap.CANCEL:if(this.__currentItem){
var o=new DwtMouseEvent();
this._setMouseEvent(o,{
dwtObj:this.__currentItem}
);
this.notifyListeners(DwtEvent.ONMOUSEOUT,o);
this.__currentItem=null
}
this.popdown(0);
break;
default:return false
}
return true
};
DwtMenu.prototype._focus=function(){};
DwtMenu.prototype._blur=function(){};
DwtMenu.prototype.setAssociatedObj=function(e){
this._associatedObj=e
};
DwtMenu.prototype.setAssociatedElementId=function(e){
this._associatedElId=e
};
DwtMenu.prototype.checkItem=function(s,n,a){
var e=this._children.getArray();
for(var t=0;
t<e.length;
t++){
var o=e[t];
if(!(o.isStyle(DwtMenuItem.CHECK_STYLE)||o.isStyle(DwtMenuItem.RADIO_STYLE))){
continue
}
var r=o.getData(s);
if(r==n){
o.setChecked(true,a)
}}};
DwtMenu.prototype.setSelectedItem=function(t){
var e=this.__currentItem;
if(typeof(t)=="boolean"){
e=!e?this._children.get(0):t?this._children.getNext(e):this._children.getPrev(e)
}else{
if(t instanceof DwtMenuItem){
if(this._children.contains(t)){
e=t
}}else{
t=Math.max(0,Math.min(this._children.size()-1,t));
e=this._children.get(t)
}}
while(e&&(e.isStyle(DwtMenuItem.SEPARATOR_STYLE)||!e.getEnabled()||!e.getVisible())){
e=(t===false)?this._children.getPrev(e):this._children.getNext(e)
}
if(!e){
return
}
var a=new DwtMouseEvent();
if(this.__currentItem){
this._setMouseEvent(a,{
dwtObj:this.__currentItem}
);
this.__currentItem.notifyListeners(DwtEvent.ONMOUSEOUT,a)
}
this._setMouseEvent(a,{
dwtObj:e}
);
e.notifyListeners(DwtEvent.ONMOUSEOVER,a);
this.__currentItem=e;
this.scrollToItem(e,true)
};
DwtMenu.prototype.clearExternallySelectedItems=function(){
if(this._externallySelected!=null){
this._externallySelected._deselect();
this._externallySelected=null
}};
DwtMenu.prototype.removeChild=function(a){
if(this._table){
if(this._style==DwtMenu.BAR_STYLE){
var e=a.getHtmlElement().parentNode;
this._table.rows[0].deleteCell(Dwt.getCellIndex(e))
}else{
var t=a.getHtmlElement();
if(t){
this._table.deleteRow(t.parentNode.parentNode.rowIndex)
}}}
this._children.remove(a);
if(a.removeSelectionListener){
a.removeSelectionListener(this._itemSelectionListener)
}};
DwtMenu.prototype.addChild=function(e){
DwtComposite.prototype.addChild.apply(this,arguments);
if(Dwt.instanceOf(e,"DwtColorPicker")||Dwt.instanceOf(e,"DwtCalendar")||(this._style==DwtMenu.GENERIC_WIDGET_STYLE)){
this._addItem(e)
}
if(e.addSelectionListener){
e.addSelectionListener(this._itemSelectionListener)
}};
DwtMenu.prototype._addItem=function(i,t){
if(this._style==DwtMenu.COLOR_PICKER_STYLE||this._style==DwtMenu.CALENDAR_PICKER_STYLE||this._style==DwtMenu.GENERIC_WIDGET_STYLE){
return
}
var n;
var e;
if(this._style==DwtMenu.BAR_STYLE){
var o=this._table.rows;
n=(o.length!=0)?o[0]:this._table.insertRow(0);
if(t==null||t>n.cells.length){
t=o.cells.length
}
e=n.insertCell(t);
e.align="center";
e.vAlign="middle";
var a=n.insertCell(-1);
a.nowrap=true;
a.width="7px"
}else{
if(i.isStyle&&(i.isStyle(DwtMenuItem.CHECK_STYLE)||i.isStyle(DwtMenuItem.RADIO_STYLE))){
this._checkItemAdded()
}
if(t==null||t>this._table.rows.length){
t=-1
}
n=this._table.insertRow(t);
e=n.insertCell(0)
}
e.noWrap=true;
e.appendChild(i.getHtmlElement())
};
DwtMenu.prototype._radioItemSelected=function(r,n){
var t=r._radioGroupId;
var s=this._children.size();
var e=this._children.getArray();
for(var o=0;
o<s;
o++){
if(e[o]!=r&&e[o].isStyle(DwtMenuItem.RADIO_STYLE)&&e[o]._radioGroupId==t&&e[o]._itemChecked){
e[o].setChecked(false,n);
break
}}};
DwtMenu.prototype._propagateItemSelection=function(e){
if(this.isListenerRegistered(DwtEvent.SELECTION)){
this.notifyListeners(DwtEvent.SELECTION,e)
}};
DwtMenu.prototype._menuHasCheckedItems=function(){
return this._menuItemsHaveChecks
};
DwtMenu.prototype._menuHasItemsWithIcons=function(){
return this._menuItemsHaveIcons
};
DwtMenu.prototype._menuHasSubmenus=function(){
return(this._menuItemsWithSubmenus>0)
};
DwtMenu.prototype._iconItemAdded=function(e){
if(!this._menuItemsHaveIcons){
Dwt.addClass(this.getHtmlElement(),DwtMenu.HAS_ICON)
}
this._menuItemsHaveIcons=true
};
DwtMenu.prototype._checkItemAdded=function(e){
if(!this._menuItemsHaveChecks){
Dwt.addClass(this.getHtmlElement(),DwtMenu.HAS_CHECK)
}
this._menuItemsHaveChecks=true
};
DwtMenu.prototype._submenuItemAdded=function(){
Dwt.addClass(this.getHtmlElement(),DwtMenu.HAS_SUBMENU);
this._menuItemsWithSubmenus++
};
DwtMenu.prototype._submenuItemRemoved=function(){
if(this._menuItemsWithSubmenus==1){
var o=this._children.size();
var e=this._children.getArray();
for(var t=0;
t<o;
t++){
e[t]._submenuItemRemoved()
}}
this._menuItemsWithSubmenus--;
if(this._menuItemsWithSubmenus==0){
Dwt.delClass(this.getHtmlElement(),DwtMenu.HAS_SUBMENU)
}};
DwtMenu.prototype._popdownSubmenus=function(){
var o=this._children.size();
var e=this._children.getArray();
for(var t=0;
t<o;
t++){
if(e[t]._popdownMenu){
e[t]._popdownMenu()
}}};
DwtMenu.prototype.dontStealFocus=function(e){
if(e==null){
e=true
}
this.__preventMenuFocus=!!e
};
DwtMenu.prototype._doPopup=function(o,a,r){
this.render(o,a);
var t=this._layoutStyle==DwtMenu.LAYOUT_SCROLL;
var l=(this._style==DwtMenu.POPUP_STYLE||this._style==DwtMenu.DROPDOWN_STYLE);
var n=this._layoutStyle==DwtMenu.LAYOUT_CASCADE;
if(!t){
this.setScrollStyle(l&&n?Dwt.CLIP:Dwt.SCROLL)
}else{
if(this._tableContainer){
Dwt.setScrollStyle(this._tableContainer,Dwt.CLIP)
}}
this.notifyListeners(DwtEvent.POPUP,this);
var h=this.shell.getToolTip();
if(h){
h.popdown()
}
var i=DwtBaseDialog.getActiveDialog()?Dwt.Z_DIALOG_MENU:Dwt.Z_MENU;
this.setZIndex(i);
this._popupActionId=-1;
this._isPoppedUp=true;
var s=DwtOutsideMouseEventMgr.INSTANCE;
var e={
id:"DwtMenu",obj:this,outsideListener:this._outsideListener};
s.startListening(e);
if(!DwtMenu._activeMenu){
DwtMenu._activeMenu=this;
DwtMenu._activeMenuUp=true
}
DwtMenu._activeMenuIds.add(this._htmlElId,null,true);
DwtMenu._activeMenuIds.sort();
DwtMenu._activeMenus.add(this,null,true);
if(!this.__preventMenuFocus){
DwtShell.getShell(window).getKeyboardMgr().pushTabGroup(this._tabGroup)
}
if(r){
this.handleKeyAction(DwtKeyMap.SELECT_NEXT)
}else{
if(this.__currentItem){
this.setSelectedItem(this.__currentItem)
}}};
DwtMenu.prototype.getSize=function(t){
var e;
if(this._table){
e=Dwt.getSize(this._table,t)
}else{
e=DwtComposite.prototype.getSize.call(this,t)
}
if(this._width&&this._width>e.x){
e.x=this._width
}
return e
};
DwtMenu.prototype._doPopdown=function(){
var l=this._children.getArray();
var m=this._children.size();
for(var n=0;
n<m;
n++){
if((l[n] instanceof DwtMenuItem)&&!(l[n].isStyle(DwtMenuItem.SEPARATOR_STYLE))){
l[n]._popdownMenu()
}}
this.setZIndex(Dwt.Z_HIDDEN);
this.setLocation(Dwt.LOC_NOWHERE,Dwt.LOC_NOWHERE);
this.notifyListeners(DwtEvent.POPDOWN,this);
var c=DwtOutsideMouseEventMgr.INSTANCE;
c.stopListening({
id:"DwtMenu",obj:this}
);
if(DwtMenu._activeMenu==this){
DwtMenu._activeMenu=null;
DwtMenu._activeMenuUp=false
}
DwtMenu._activeMenuIds.remove(this._htmlElId);
DwtMenu._activeMenus.remove(this);
this._popdownActionId=-1;
this._isPoppedUp=false;
if((this._style==DwtMenu.POPUP_STYLE||this._style==DwtMenu.DROPDOWN_STYLE)&&this._table.rows.length&&this._table.rows[0].cells.length){
var t=this._table.rows[0].cells.length;
var r=this._table.rows.length;
for(var n=1;
n<t;
n++){
for(var o=0;
o<r;
o++){
var d=this._table.rows[o].cells[n];
if(!d.empty){
var e=d.firstChild;
var u=this._table.insertRow(this._table.rows.length);
var d=u.insertCell(0);
while(e!=null){
d.appendChild(e);
e=e.nextSibling
}}}}
for(var o=0;
o<r;
o++){
var u=this._table.rows[o];
for(var n=u.cells.length-1;
n>0;
n--){
u.deleteCell(n)
}}}
this.__currentItem=null;
if(this._hoveredItem){
var h=new DwtMouseEvent();
h.dwtObj=this._hoveredItem;
DwtButton._mouseOutListener(h)
}
DwtShell.getShell(window).getKeyboardMgr().popTabGroup(this._tabGroup)
};
DwtMenu.prototype._getActiveItem=function(){
var e=this._children.getArray();
var o=this._children.size();
for(var t=0;
t<o;
t++){
if(e[t]._isMenuPoppedUp()){
return e[t]
}}
return null
};
DwtMenu._outsideMouseDownListener=function(t){
if(DwtMenu._activeMenuUp){
var i=DwtMenu._activeMenu;
var o=i._htmlElId;
var a=DwtUiEvent.getTarget(t);
while(a!=null){
if(a.id&&a.id!=""&&(a.id==o||a.id==i._associatedElId||DwtMenu._activeMenuIds.binarySearch(a.id)!=-1)){
return false
}
a=a.parentNode
}
i.popdown();
var e=null;
do{
e=DwtMenu._activeMenus.getLast();
if(e!=null&&e instanceof DwtMenu){
e.popdown()
}}
while(e!=null)
}};
DwtMenu._stopEvent=function(t){
if(!t){
t=window.event
}
t.cancelBubble=true;
if(t.stopPropagation){
t.stopPropagation()
}};
DwtMenu.menuShowing=function(){
return DwtMenu._activeMenuUp
};
DwtMenu.closeActiveMenu=function(){
if(DwtMenu._activeMenuUp){
DwtMenu._activeMenu.popdown()
}};
