
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtMenuItem=function(a){
if(arguments.length==0){
return
}
a=Dwt.getParams(arguments,DwtMenuItem.PARAMS);
var t=a.parent;
if(!(t instanceof DwtMenu)){
throw new DwtException("Parent must be a DwtMenu object",DwtException.INVALIDPARENT,"DwtMenuItem")
}
var e=a.style=a.style||DwtMenuItem.NO_STYLE;
if(t._style==DwtMenu.BAR_STYLE&&e!=DwtMenuItem.PUSH_STYLE){
throw new DwtException("DwtMenuItemInit: invalid style",DwtException.INVALID_PARAM,"DwtMenuItem")
}
e&=~DwtLabel.IMAGE_RIGHT;
e|=DwtButton.ALWAYS_FLAT|DwtLabel.IMAGE_LEFT;
a.className=(e&DwtMenuItem.SEPARATOR_STYLE)?"ZMenuItemSeparator":(a.className||"ZMenuItem");
a.listeners=DwtMenuItem._listeners;
DwtButton.call(this,a);
this.setDropDownImages("Cascade","Cascade","Cascade","Cascade");
this._radioGroupId=a.radioGroupId;
if(t._addItem){
t._addItem(this,a.index)
}
if(!(e&DwtMenuItem.SEPARATOR_STYLE)){
this.addSelectionListener(new AjxListener(this,this.__handleItemSelect))
}};
DwtMenuItem.PARAMS=["parent","style","radioGroupId","index","className","posStyle","id"];
DwtMenuItem.prototype=new DwtButton;
DwtMenuItem.prototype.constructor=DwtMenuItem;
DwtMenuItem.prototype.toString=function(){
return"DwtMenuItem"
};
DwtMenuItem.CHECKED=1;
DwtMenuItem.UNCHECKED=2;
DwtMenuItem.NO_STYLE=0;
DwtMenuItem.CHECK_STYLE=DwtButton._LAST_STYLE*2;
DwtMenuItem.RADIO_STYLE=DwtButton._LAST_STYLE*4;
DwtMenuItem.SEPARATOR_STYLE=DwtButton._LAST_STYLE*8;
DwtMenuItem.CASCADE_STYLE=DwtButton._LAST_STYLE*16;
DwtMenuItem.PUSH_STYLE=DwtButton._LAST_STYLE*32;
DwtMenuItem.SELECT_STYLE=DwtButton._LAST_STYLE*64;
DwtMenuItem._LAST_STYLE=DwtMenuItem.SELECT_STYLE;
DwtMenuItem._MENU_POPUP_DELAY=250;
DwtMenuItem._MENU_POPDOWN_DELAY=250;
DwtMenuItem.prototype.TEMPLATE="dwt.Widgets#ZMenuItem";
DwtMenuItem.prototype.SEPARATOR_TEMPLATE="dwt.Widgets#ZMenuItemSeparator";
DwtMenuItem.prototype.BLANK_CHECK_TEMPLATE="dwt.Widgets#ZMenuItemBlankCheck";
DwtMenuItem.prototype.BLANK_ICON_TEMPLATE="dwt.Widgets#ZMenuItemBlankIcon";
DwtMenuItem.prototype.BLANK_CASCADE_TEMPLATE="dwt.Widgets#ZMenuItemBlankCascade";
DwtMenuItem.prototype.dispose=function(){
delete this._checkEl;
DwtButton.prototype.dispose.call(this)
};
DwtMenuItem.create=function(t){
var e=new DwtMenuItem(t);
if(t.imageInfo){
e.setImage(t.imageInfo)
}
if(t.text){
e.setText(t.text)
}
e.setEnabled(t.enabled!==false);
return e
};
DwtMenuItem.prototype.getChecked=function(){
return this._itemChecked
};
DwtMenuItem.prototype.setChecked=function(t,e){
this._setChecked(t,null,e);
this.parent._checkItemAdded(this)
};
DwtMenuItem.prototype.setImage=function(e){
DwtButton.prototype.setImage.call(this,e);
this.parent._iconItemAdded(this)
};
DwtMenuItem.prototype.setText=function(e){
DwtButton.prototype.setText.call(this,e);
if(this.parent.isPoppedUp()){
this.parent.render()
}};
DwtMenuItem.prototype.setMenu=function(a,e,t){
DwtButton.prototype.setMenu.call(this,a,e,t);
this.parent._submenuItemAdded(this)
};
DwtMenuItem.prototype.setHoverDelay=function(e){
this._hoverDelay=e
};
DwtMenuItem.prototype.setShortcut=function(e){
if(e&&this._dropDownEl){
this._dropDownEl.innerHTML=e
}};
DwtMenuItem.prototype.setSelectableWithSubmenu=function(e){
this._selectableWithSubmenu=e
};
DwtMenuItem.prototype._createHtml=function(e){
var t=(this._style&DwtMenuItem.SEPARATOR_STYLE)?this.SEPARATOR_TEMPLATE:this.TEMPLATE;
DwtButton.prototype._createHtml.call(this,e||t)
};
DwtMenuItem.prototype._createHtmlFromTemplate=function(e,t){
DwtButton.prototype._createHtmlFromTemplate.call(this,e,t);
this._checkEl=document.getElementById(t.id+"_check")
};
DwtMenuItem.prototype._setChecked=function(n,o,t){
var e=this._style&DwtMenuItem.CHECK_STYLE;
var i=this._style&DwtMenuItem.RADIO_STYLE;
if((e||i)&&this._itemChecked!=n){
this._itemChecked=n;
if(this._checkEl){
this._checkEl.innerHTML="";
var a=n?(e?"MenuCheck":"MenuRadio"):"Blank_9";
AjxImg.setImage(this._checkEl,a);
if(n){
if(i){
this.parent._radioItemSelected(this,t)
}}}}};
DwtMenuItem.prototype._checkItemAdded=function(e){};
DwtMenuItem.prototype._checkedItemsRemoved=function(){};
DwtMenuItem.prototype._submenuItemAdded=function(){
if(this._style&DwtMenuItem.SEPARATOR_STYLE){
return
}
if(this._cascCell==null){
this._cascCell=this._row.insertCell(-1);
this._cascCell.noWrap=true;
this._cascCell.style.width=DwtMenuItem._CASCADE_DIM;
this._cascCell.style.height=(this._style!=DwtMenuItem.SEPARATOR_STYLE)?DwtMenuItem._CASCADE_DIM:DwtMenuItem._SEPAARATOR_DIM
}};
DwtMenuItem.prototype._submenuItemRemoved=function(){
if(this._dropDownEl){
this._dropDownEl.innerHTML=""
}};
DwtMenuItem.prototype._popupMenu=function(o,d){
var e=this.getMenu();
var t=this.parent.parent;
var l=this.getBounds();
var n=e.shell.getSize();
var u=e.getSize();
var c;
var r;
var i;
var h;
var a=t.getHtmlElement();
if(t._style==DwtMenu.BAR_STYLE){
i=(a.style.borderLeftWidth=="")?0:parseInt(a.style.borderLeftWidth);
c=l.x+i;
h=(a.style.borderTopWidth=="")?0:parseInt(a.style.borderTopWidth);
h+=(a.style.borderBottomWidth=="")?0:parseInt(a.style.borderBottonWidth);
r=l.y+l.height+h;
c=((c+u.x)>=n.x)?c-(c+u.x-n.x):c
}else{
i=(a.style.borderLeftWidth=="")?0:parseInt(a.style.borderLeftWidth);
i+=(a.style.borderRightWidth=="")?0:parseInt(a.style.borderRightWidth);
c=l.x+l.width+i;
h=(a.style.borderTopWidth=="")?0:parseInt(a.style.borderTopWidth);
r=l.y+h
}
e.popup(o,c,r,d)
};
DwtMenuItem.prototype._popdownMenu=function(){
var e=this.getMenu();
if(e){
e.popdown()
}};
DwtMenuItem.prototype._isMenuPoppedUp=function(){
var e=this.getMenu();
return(e&&e.isPoppedUp())
};
DwtMenuItem.prototype.__handleItemSelect=function(e){
this.setDisplayState(DwtControl.NORMAL);
if(this.isStyle(DwtMenuItem.CHECK_STYLE)){
this._setChecked(!this._itemChecked,null,true);
e.detail=this.getChecked()?DwtMenuItem.CHECKED:DwtMenuItem.UNCHECKED
}else{
if(this.isStyle(DwtMenuItem.RADIO_STYLE)){
this._setChecked(true,true);
this.parent._radioItemSelected(this,true);
e.detail=this.getChecked()?DwtMenuItem.CHECKED:DwtMenuItem.UNCHECKED
}else{
if(this.isStyle(DwtMenuItem.PUSH_STYLE)){
if(this._menu){
if(this._isMenuPoppedUp()){
DwtMenu.closeActiveMenu()
}else{
this._popupMenu()
}}
return
}}}
if(!this.isStyle(DwtMenuItem.CASCADE_STYLE)){
if(this._selectableWithSubmenu||!this._menu||!this._menu.isPoppedUp||!this._menu.isPoppedUp()){
DwtMenu.closeActiveMenu()
}}};
DwtMenuItem._mouseOverListener=function(a){
var e=a.dwtObj;
if(!e){
return false
}
var i=e.parent;
if(i._hoveredItem){
var t=new DwtMouseEvent();
t.dwtObj=i._hoveredItem;
DwtButton._mouseOutListener(t)
}
if(e._style&DwtMenuItem.SEPARATOR_STYLE){
return false
}
DwtButton._mouseOverListener(a,e);
i._hoveredItem=e;
i._popdownSubmenus();
if(e._menu&&!a.ersatz){
e._popupMenu(e._hoverDelay)
}};
DwtMenuItem._mouseOutListener=function(a){
var t=a.dwtObj;
var e=t&&t.getMenu();
if(e&&e.isPoppedUp()){
return
}
DwtButton._mouseOutListener(a);
if(t){
t.parent._hoveredItem=null
}};
DwtMenuItem.prototype.getRowElement=function(){
var e=this._textEl?this._textEl:this._iconEl?this._iconEl:this._dropDownEl;
if(e){
return e.parentNode
}};
DwtMenuItem._listeners={};
DwtMenuItem._listeners[DwtEvent.ONMOUSEOVER]=new AjxListener(null,DwtMenuItem._mouseOverListener);
DwtMenuItem._listeners[DwtEvent.ONMOUSEOUT]=new AjxListener(null,DwtMenuItem._mouseOutListener);
DwtMenuItem._listeners[DwtEvent.ONMOUSEDOWN]=new AjxListener(null,DwtButton._mouseDownListener);
DwtMenuItem._listeners[DwtEvent.ONMOUSEUP]=new AjxListener(null,DwtButton._mouseUpListener);
DwtMenuItem._listeners[DwtEvent.ONMOUSEENTER]=new AjxListener(null,DwtMenuItem._mouseOverListener);
DwtMenuItem._listeners[DwtEvent.ONMOUSELEAVE]=new AjxListener(null,DwtButton._mouseOutListener);
