
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtSoundPlugin=function(e){
if(arguments.length==0){
return
}
e.className=e.className||"DwtSoundPlugin";
DwtControl.call(this,{
parent:e.parent,className:e.className,posStyle:e.posStyle}
);
this._width=e.width||200;
this._height=e.height||18;
if(e.offscreen){
this.setLocation(Dwt.LOC_NOWHERE,Dwt.LOC_NOWHERE)
}};
DwtSoundPlugin.prototype=new DwtControl;
DwtSoundPlugin.prototype.constructor=DwtSoundPlugin;
DwtSoundPlugin.MAX_VOLUME=256;
DwtSoundPlugin.WAITING=1;
DwtSoundPlugin.LOADING=2;
DwtSoundPlugin.PLAYABLE=3;
DwtSoundPlugin.ERROR=4;
DwtSoundPlugin.create=function(t){
var e=this._getPluginClass();
return new e(t)
};
DwtSoundPlugin.isPluginMissing=function(){
var e=this._getPluginClass();
return e._pluginMissing
};
DwtSoundPlugin.isScriptingBroken=function(){
var e=this._getPluginClass();
return e._isScriptingBroken
};
DwtSoundPlugin._getPluginClass=function(){
if(!DwtSoundPlugin._pluginClass){
if(AjxEnv.isIE&&AjxPluginDetector.detectWindowsMedia()){
DwtSoundPlugin._pluginClass=DwtWMSoundPlugin
}else{
var e=AjxPluginDetector.getQuickTimeVersion();
if(e){
if(DwtQTSoundPlugin.checkVersion(e)&&DwtQTSoundPlugin.checkScripting()){
DwtSoundPlugin._pluginClass=DwtQTSoundPlugin
}else{
DwtSoundPlugin._pluginClass=DwtQTBrokenSoundPlugin
}}else{
if(window.DBG&&!DBG.isDisabled()){
AjxPluginDetector.detectQuickTime()
}}}
if(!DwtSoundPlugin._pluginClass){
DwtSoundPlugin._pluginClass=DwtMissingSoundPlugin
}}
return DwtSoundPlugin._pluginClass
};
DwtSoundPlugin.prototype.play=function(){};
DwtSoundPlugin.prototype.pause=function(){};
DwtSoundPlugin.prototype.rewind=function(){};
DwtSoundPlugin.prototype.setTime=function(e){};
DwtSoundPlugin.prototype.setVolume=function(e){};
DwtSoundPlugin.prototype._resetEvent=function(e){
return false
};
DwtSoundPlugin.prototype.dispose=function(){
DwtControl.prototype.dispose.call(this);
this._ignoreStatus()
};
DwtSoundPlugin.prototype.addChangeListener=function(e){
this.addListener(DwtEvent.ONCHANGE,e);
this._monitorStatus()
};
DwtSoundPlugin.prototype._monitorStatus=function(){
if(this.isListenerRegistered(DwtEvent.ONCHANGE)){
if(!this._statusAction){
this._statusAction=new AjxTimedAction(this,this._checkStatus)
}
this._statusActionId=AjxTimedAction.scheduleAction(this._statusAction,250)
}};
DwtSoundPlugin.prototype._ignoreStatus=function(){
if(this._statusActionId){
AjxTimedAction.cancelAction(this._statusActionId)
}};
DwtSoundPlugin.prototype._checkStatus=function(){
this._statusActionId=0;
if(!this._changeEvent){
this._changeEvent=new DwtEvent(true);
this._changeEvent.dwtObj=this
}
var e=this._resetEvent(this._changeEvent);
this.notifyListeners(DwtEvent.ONCHANGE,this._changeEvent);
if(e){
this._monitorStatus()
}};
DwtSoundPlugin.prototype._createQTHtml=function(a){
var t=a.volume*100/256;
var e=["<embed classid='clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B' ","id='",this._playerId,"' width='",this._width,"' height='",this._height,"' src='",a.url,"' volume='",t,"' enablejavascript='true' type='audio/wav'/>"];
this.getHtmlElement().innerHTML=e.join("")
};
DwtQTSoundPlugin=function(e){
if(arguments.length==0){
return
}
e.className=e.className||"DwtSoundPlugin";
DwtSoundPlugin.call(this,e);
this._playerId=Dwt.getNextId();
this._createHtml(e)
};
DwtQTSoundPlugin.prototype=new DwtSoundPlugin;
DwtQTSoundPlugin.prototype.constructor=DwtQTSoundPlugin;
DwtQTSoundPlugin.prototype.toString=function(){
return"DwtQTSoundPlugin"
};
DwtQTSoundPlugin.checkVersion=function(e){
if(AjxEnv.isFirefox){
var o=[7,1,6];
for(var t=0,a=e.length;
t<a;
t++){
if(e[t]<o[t]){
return true
}else{
if(e[t]>o[t]){
return false
}}}
return false
}else{
return true
}};
DwtQTSoundPlugin.checkScripting=function(){
var n=false;
var i=DwtControl.fromElementId(window._dwtShellId);
var t={
parent:i,width:200,height:16,offscreen:true,posStyle:DwtControl.RELATIVE_STYLE,url:"/QuickTimeScriptTest.wav",volume:0};
var s=new DwtQTSoundPlugin(t);
try{
var a=s._getPlayer();
n=a.GetQuickTimeVersion&&a.GetQuickTimeVersion();
if(!n){}}
catch(o){}
finally{
s.dispose()
}
return n
};
DwtQTSoundPlugin.prototype.play=function(){
var e=this._getPlayer();
e.Play();
this._monitorStatus()
};
DwtQTSoundPlugin.prototype.pause=function(){
try{
var t=this._getPlayer();
t.Stop()
}
catch(a){}};
DwtQTSoundPlugin.prototype.rewind=function(){
try{
var t=this._getPlayer();
t.Rewind()
}
catch(a){}};
DwtQTSoundPlugin.prototype.setTime=function(i){
var t=this._getPlayer();
try{
var o=1000/t.GetTimeScale();
t.SetTime(i/o)
}
catch(a){}};
DwtQTSoundPlugin.prototype.setVolume=function(t){
var e=this._getPlayer();
e.SetVolume(t)
};
DwtQTSoundPlugin.prototype._resetEvent=function(i){
var n=true;
var t=this._getPlayer();
i.finished=false;
var a=false;
if(t){
var e=t.GetPluginStatus();
switch(e){
case"Waiting":i.status=DwtSoundPlugin.LOADING;
break;
case"Loading":a=true;
i.status=DwtSoundPlugin.LOADING;
break;
case"Playable":case"Complete":a=true;
i.status=DwtSoundPlugin.PLAYABLE;
break;
default:i.status=DwtSoundPlugin.ERROR;
i.errorDetail=e;
n=false;
break
}}
if(a){
var o=1000/t.GetTimeScale();
i.time=t.GetTime()*o;
i.duration=t.GetDuration()*o
}else{
i.status=DwtSoundPlugin.WAITING;
i.time=0;
i.duration=100
}
if(i.status==DwtSoundPlugin.PLAYABLE&&i.time==i.duration){
i.time=0;
i.finished=true;
n=false
}
return n
};
DwtQTSoundPlugin.prototype._createHtml=function(e){
this._createQTHtml(e)
};
DwtQTSoundPlugin.prototype._getPlayer=function(){
return document.getElementById(this._playerId)
};
DwtQTBrokenSoundPlugin=function(e){
if(arguments.length==0){
return
}
e.className=e.className||"DwtSoundPlugin";
DwtSoundPlugin.call(this,e);
this._playerId=Dwt.getNextId();
this._createHtml(e)
};
DwtQTBrokenSoundPlugin.prototype=new DwtSoundPlugin;
DwtQTBrokenSoundPlugin.prototype.constructor=DwtQTBrokenSoundPlugin;
DwtQTBrokenSoundPlugin.prototype.toString=function(){
return"DwtQTBrokenSoundPlugin"
};
DwtQTBrokenSoundPlugin._isScriptingBroken=true;
DwtQTBrokenSoundPlugin.prototype._resetEvent=function(e){
e.time=0;
e.duration=100;
e.status=DwtSoundPlugin.PLAYABLE;
e.finished=true;
return false
};
DwtQTBrokenSoundPlugin.prototype._createHtml=function(e){
this._createQTHtml(e)
};
DwtWMSoundPlugin=function(e){
if(arguments.length==0){
return
}
e.className=e.className||"DwtSoundPlugin";
DwtSoundPlugin.call(this,e);
this._playerId=Dwt.getNextId();
this._createHtml(e)
};
DwtWMSoundPlugin.prototype=new DwtSoundPlugin;
DwtWMSoundPlugin.prototype.constructor=DwtWMSoundPlugin;
DwtWMSoundPlugin.prototype.toString=function(){
return"DwtWMSoundPlugin"
};
DwtWMSoundPlugin.prototype.play=function(){
var e=this._getPlayer();
e.controls.play();
this._monitorStatus()
};
DwtWMSoundPlugin.prototype.pause=function(){
var e=this._getPlayer();
e.controls.pause()
};
DwtWMSoundPlugin.prototype.rewind=function(){
this.setTime(0)
};
DwtWMSoundPlugin.prototype.setTime=function(t){
var e=this._getPlayer();
e.controls.currentPosition=t/1000
};
DwtWMSoundPlugin.prototype.setVolume=function(t){
var t=t*100/256;
var e=this._getPlayer();
e.settings.volume=t
};
DwtWMSoundPlugin.prototype._resetEvent=function(a){
var i=true;
var t=this._getPlayer();
var e=t.currentMedia.error;
if(e){
a.status=DwtSoundPlugin.ERROR;
a.errorDetail=e.errorDescription;
i=false
}else{
if(!t.controls.isAvailable("currentPosition")){
a.status=DwtSoundPlugin.LOADING;
a.time=0;
a.duration=100
}else{
a.status=DwtSoundPlugin.PLAYABLE;
a.time=t.controls.currentPosition*1000;
a.duration=t.currentMedia.duration*1000||a.time+100;
if(!a.time){
a.finished=true;
i=false;
t.close()
}}}
return i
};
DwtWMSoundPlugin.prototype._createHtml=function(s){
var o=s.volume*100/256;
var a=[];
var t=0;
if(AjxEnv.isIE){
a[t++]="<object classid='CLSID:6BF52A52-394A-11d3-B153-00C04F79FAA6' id='";
a[t++]=this._playerId;
a[t++]="'>"
}else{
a[t++]="<embed classid='CLSID:6BF52A52-394A-11d3-B153-00C04F79FAA6' id='";
a[t++]=this._playerId;
a[t++]="' "
}
var n={
width:this._width,height:this._height,url:s.url,volume:o,enablejavascript:"true"};
for(var e in n){
if(AjxEnv.isIE){
a[t++]="<param name='";
a[t++]=e;
a[t++]="' value='";
a[t++]=n[e];
a[t++]="'/>"
}else{
a[t++]=e;
a[t++]="='";
a[t++]=n[e];
a[t++]="' "
}}
if(AjxEnv.isIE){
a[t++]="</object>"
}else{
a[t++]=" type='application/x-mplayer2'/>"
}
this.getHtmlElement().innerHTML=a.join("")
};
DwtWMSoundPlugin.prototype._getPlayer=function(){
return document.getElementById(this._playerId)
};
DwtMissingSoundPlugin=function(t){
if(arguments.length==0){
return
}
t.className=t.className||"DwtSoundPlugin";
DwtSoundPlugin.call(this,t);
var e={};
this.getHtmlElement().innerHTML=AjxTemplate.expand("dwt.Widgets#DwtMissingSoundPlayer",e);
this._setMouseEventHdlrs()
};
DwtMissingSoundPlugin.prototype=new DwtSoundPlugin;
DwtMissingSoundPlugin.prototype.constructor=DwtMissingSoundPlugin;
DwtMissingSoundPlugin.prototype.toString=function(){
return"DwtMissingSoundPlugin"
};
DwtMissingSoundPlugin._pluginMissing=true;
DwtMissingSoundPlugin.prototype.addHelpListener=function(e){
this.addListener(DwtEvent.ONMOUSEDOWN,e)
};
