
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
DwtWizardDialog=function(o,i,r,e,a){
if(arguments.length==0){
return
}
i=i||"DwtDialog";
var s=new DwtDialog_ButtonDescriptor(DwtWizardDialog.NEXT_BUTTON,AjxMsg._next,DwtDialog.ALIGN_RIGHT,new AjxCallback(this,this.goNext));
var t=new DwtDialog_ButtonDescriptor(DwtWizardDialog.PREV_BUTTON,AjxMsg._prev,DwtDialog.ALIGN_RIGHT,new AjxCallback(this,this.goPrev));
var n=new DwtDialog_ButtonDescriptor(DwtWizardDialog.FINISH_BUTTON,AjxMsg._finish,DwtDialog.ALIGN_RIGHT,new AjxCallback(this,this.finishWizard));
DwtDialog.call(this,{
parent:o,className:i,standardButtons:[DwtDialog.CANCEL_BUTTON],extraButtons:[t,s,n]}
);
if(!e){
this._contentW="80ex"
}else{
this._contentW=e
}
if(!a){
this._contentH="100ex"
}else{
this._contentH=a
}
this._pages=new Array();
this._pageIx=1;
this._currentPage=1;
this._progressDiv=document.createElement("div");
this._progressDiv.style.position=DwtControl.STATIC_STYLE;
this._pageDiv=document.createElement("div");
this._pageDiv.className="DwtWizardDialogPageDiv";
this._pageDiv.style.width=this._contentW;
this._pageDiv.style.height=this._contentH;
this._progressBar=new DwtWizProgressBar(this);
this._createContentHtml();
this.setTitle(r)
};
DwtWizardDialog.prototype=new DwtDialog;
DwtWizardDialog.prototype.constructor=DwtWizardDialog;
DwtWizardDialog.Z_ACTIVE_PAGE=Dwt.Z_VIEW+10;
DwtWizardDialog.Z_HIDDEN_PAGE=Dwt.Z_HIDDEN;
DwtWizardDialog.Z_TAB_PANEL=Dwt.Z_VIEW+20;
DwtWizardDialog.Z_CURTAIN=Dwt.Z_CURTAIN;
DwtWizardDialog.NEXT_BUTTON=12;
DwtWizardDialog.PREV_BUTTON=11;
DwtWizardDialog.FINISH_BUTTON=13;
DwtWizardDialog.prototype.toString=function(){
return"DwtWizardDialog"
};
DwtWizardDialog.prototype.popdown=function(){
DwtDialog.prototype.popdown.call(this);
this._hideAllPages()
};
DwtWizardDialog.prototype.goPage=function(e){
if(this._pages&&this._pages[e]){
this._currentPage=e;
this._showPage(e);
this._progressBar.showStep(e);
this._pages[e].setActive()
}};
DwtWizardDialog.prototype.goNext=function(){
var e=this._currentPage+1;
if(this._pages&&this._pages[this._currentPage]){
this._pages[this._currentPage].switchToNextPage(e)
}};
DwtWizardDialog.prototype.goPrev=function(){
var e=this._currentPage-1;
if(this._pages&&this._pages[this._currentPage]){
this._pages[this._currentPage].switchToPrevPage(e)
}};
DwtWizardDialog.prototype.finishWizard=function(){
this.popdown()
};
DwtWizardDialog.prototype.getPage=function(e){
if(this._pages&&this._pages[e]){
return this._pages[e]
}else{
return null
}};
DwtWizardDialog.prototype.addPage=function(e,t){
var a=this._pageIx++;
this._pages[a]=e;
this._progressBar.addStep(a,t);
this._pageDiv.appendChild(this._pages[a].getHtmlElement());
if(a==1){
this._pages[a].setZIndex(DwtWizardDialog.Z_ACTIVE_PAGE)
}else{
this._pages[a].setZIndex(DwtWizardDialog.Z_HIDDEN_PAGE);
Dwt.setVisible(this._pages[a].getHtmlElement(),false)
}
return a
};
DwtWizardDialog.prototype._createContentHtml=function(){
this._table=document.createElement("table");
this._table.border=0;
this._table.width=this._contentW;
this._table.cellPadding=this._table.cellSpacing=0;
this._table.backgroundColor=DwtCssStyle.getProperty(this.parent.getHtmlElement(),"background-color");
var i;
var o;
i=this._table.insertRow(0);
i.align="left";
i.vAlign="middle";
o=i.insertCell(i.cells.length);
o.align="left";
o.vAlign="middle";
o.noWrap=true;
o.width="100%";
o.className="DwtTabTable";
o.appendChild(this._progressBar.getHtmlElement());
var s;
var e;
s=this._table.insertRow(1);
s.align="center";
s.vAlign="middle";
e=s.insertCell(s.cells.length);
e.align="left";
e.vAlign="middle";
e.noWrap=true;
e.style.width=this._contentW;
var n=document.createElement("div");
n.className="horizSep";
n.style.width=this._contentW;
n.style.height="5px";
e.appendChild(n);
var t;
var a;
t=this._table.insertRow(2);
t.align="left";
t.vAlign="middle";
a=t.insertCell(t.cells.length);
a.align="left";
a.vAlign="middle";
a.noWrap=true;
a.width=this._contentW;
a.appendChild(this._pageDiv);
this._getContentDiv().appendChild(this._table)
};
DwtWizardDialog.prototype.addChild=function(e){
this._children.add(e)
};
DwtWizardDialog.prototype._showPage=function(e){
if(this._pages&&this._pages[e]){
this._hideAllPages();
this._pages[e].showMe();
Dwt.setVisible(this._pages[e].getHtmlElement(),true)
}};
DwtWizardDialog.prototype._hideAllPages=function(){
if(this._pages&&this._pages.length){
for(var e in this._pages){
if(this._pages[e]){
this._pages[e].hideMe();
Dwt.setVisible(this._pages[e].getHtmlElement(),false)
}}}};
DwtWizardPage=function(t,e){
if(arguments.length==0){
return
}
var a=e||"DwtDialog";
DwtPropertyPage.call(this,t,e,DwtControl.ABSOLUTE_STYLE)
};
DwtWizardPage.prototype=new DwtTabViewPage;
DwtWizardPage.prototype.constructor=DwtWizardPage;
DwtWizardPage.prototype.toString=function(){
return"DwtWizardPage"
};
DwtWizardPage.prototype.setActive=function(){};
DwtWizardPage.prototype.switchToNextPage=function(e){
this.parent.goPage(e)
};
DwtWizardPage.prototype.switchToPrevPage=function(e){
this.parent.goPage(e)
};
DwtWizardPage.prototype.showMe=function(){
this.setZIndex(DwtTabView.Z_ACTIVE_TAB);
this.getHtmlElement().style.height=this.parent._contentH;
this.getHtmlElement().style.width=this.parent._contentW
};
DwtWizProgressBar=function(e){
if(arguments.length==0){
return
}
DwtComposite.call(this,{
parent:e,className:"DwtWizProgressBar",posStyle:DwtControl.STATIC_STYLE}
);
this._table=document.createElement("table");
this._table.border=0;
this._table.cellPadding=0;
this._table.cellSpacing=0;
this.getHtmlElement().appendChild(this._table);
this._table.backgroundColor=DwtCssStyle.getProperty(this.parent.getHtmlElement(),"background-color");
this._stepsNumber=0;
this._steps=new Array();
this._lblHeader=new DwtStepLabel(this);
this._lblHeader.setText("Step 0 of 0");
this._lblHeader.setActive(true)
};
DwtWizProgressBar.prototype=new DwtComposite;
DwtWizProgressBar.prototype.constructor=DwtWizProgressBar;
DwtWizProgressBar.prototype.toString=function(){
return"DwtWizProgressBar"
};
DwtWizProgressBar.prototype.showStep=function(t){
var e="Step "+t+" of "+this._stepsNumber;
if(this._steps[t]){
e=e+": "+this._steps[t]
}
this._lblHeader.setText(e)
};
DwtWizProgressBar.prototype.addStep=function(t,e){
this._steps[t]=e;
return(++this._stepsNumber)
};
DwtWizProgressBar.prototype.addChild=function(a){
this._children.add(a);
var t;
var e;
this._table.width="100%";
t=(this._table.rows.length!=0)?this._table.rows[0]:this._table.insertRow(0);
t.align="center";
t.vAlign="middle";
e=t.insertCell(t.cells.length);
e.align="center";
e.vAlign="middle";
e.noWrap=true;
e.appendChild(a.getHtmlElement())
};
DwtStepLabel=function(e){
DwtLabel.call(this,{
parent:e,style:DwtLabel.ALIGN_CENTER,className:"DwtStepLabel"}
)
};
DwtStepLabel.prototype=new DwtLabel;
DwtStepLabel.prototype.constructor=DwtStepLabel;
DwtStepLabel.prototype.toString=function(){
return"DwtStepLabel"
};
DwtStepLabel.prototype.setActive=function(e){
if(e){
this._textCell.className="DwtStepLabelActive"
}else{
this._textCell.className="DwtStepLabelInactive"
}};
