
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
AjxRpc=function(){};
AjxRpc.__rpcCache=[];
AjxRpc.__rpcOutstanding={};
AjxRpc.__RPC_CACHE_MAX=50;
AjxRpc.__RPC_COUNT=0;
AjxRpc.__RPC_REAP_AGE=300000;
AjxRpc.invoke=function(a,t,n,c,l,h){
var e=(c!=null);
var o=AjxRpc.__getFreeRpcCtxt();
try{
var i=o.invoke(a,t,n,c,l,h)
}
catch(s){
var r=new AjxException();
r.method="AjxRpc.prototype._invoke";
if(s instanceof Error){
r.detail=s.message;
r.code=AjxException.NETWORK_ERROR;
r.msg="Network error"
}else{
if(s instanceof XMLHttpRequestException&&s.code==101){
r.detail=s.message;
r.code=AjxException.NETWORK_ERROR;
r.msg="Network error"
}else{
r.detail=s.toString();
r.code=AjxException.UNKNOWN_ERROR;
r.msg="Unknown Error"
}}
if(!e){
AjxRpc.freeRpcCtxt(o)
}
throw r
}
if(!e){
AjxRpc.freeRpcCtxt(o)
}
return i
};
AjxRpc.freeRpcCtxt=function(e){
if(AjxRpc.__rpcOutstanding[e.id]){
AjxRpc.__rpcCache.push(e);
delete AjxRpc.__rpcOutstanding[e.id]
}};
AjxRpc.getRpcRequestById=function(e){
return(AjxRpc.__rpcOutstanding[e])
};
AjxRpc.__getFreeRpcCtxt=function(){
var e;
if(AjxRpc.__rpcCache.length>0){
e=AjxRpc.__rpcCache.pop();
AjxDebug.println(AjxDebug.RPC,"reusing RPC ID "+e.id)
}else{
if(AjxRpc.__RPC_COUNT<AjxRpc.__RPC_CACHE_MAX){
var s="__RpcCtxt_"+AjxRpc.__RPC_COUNT;
e=new AjxRpcRequest(s);
AjxRpc.__RPC_COUNT++;
AjxDebug.println(AjxDebug.RPC,"Created RPC "+s+", total created: "+AjxRpc.__RPC_COUNT)
}else{
e=AjxRpc.__reap();
if(!e){
var n=[];
for(var t in AjxRpc.__rpcOutstanding){
var e=AjxRpc.__rpcOutstanding[t];
var o=e.requestStr;
if(o){
n.push(o.replace(/"authToken":"\w*"/,'"authToken":"[removed]"'))
}}
var a=n.join("<br><br>");
AjxDebug.println(AjxDebug.RPC,"Out of RPC cache!!! Outstanding requests: "+a);
throw new AjxException("Out of RPC cache",AjxException.OUT_OF_RPC_CACHE,"AjxRpc.__getFreeRpcCtxt",a)
}}}
AjxRpc.__rpcOutstanding[e.id]=e;
e.timestamp=(new Date()).getTime();
return e
};
AjxRpc.__reap=function(){
var e;
var a=(new Date()).getTime();
for(var t in AjxRpc.__rpcOutstanding){
e=AjxRpc.__rpcOutstanding[t];
if(e.timestamp+AjxRpc.__RPC_REAP_AGE<a){
AjxDebug.println(AjxDebug.RPC,"AjxRpc.__reap: cleared RPC context "+e.id);
e.cancel();
delete AjxRpc.__rpcOutstanding[t];
return e
}}
return null
};
