
/* Copyright (C) 2005-2009 Zimbra Inc. http://www.zimbra.com/ */
(function(){
tinymce.create("tinymce.plugins.Save",{
init:function(t,e){
var i=this;
i.editor=t;
t.addCommand("mceSave",i._save,i);
t.addCommand("mceCancel",i._cancel,i);
t.addButton("save",{
title:"save.save_desc",cmd:"mceSave"}
);
t.addButton("cancel",{
title:"save.cancel_desc",cmd:"mceCancel"}
);
t.onNodeChange.add(i._nodeChange,i);
t.addShortcut("ctrl+s",t.getLang("save.save_desc"),"mceSave")
}
,getInfo:function(){
return{
longname:"Save",author:"Moxiecode Systems AB",authorurl:"http://tinymce.moxiecode.com",infourl:"http://wiki.moxiecode.com/index.php/TinyMCE:Plugins/save",version:tinymce.majorVersion+"."+tinymce.minorVersion}
}
,_nodeChange:function(e,t,i){
var e=this.editor;
if(e.getParam("save_enablewhendirty")){
t.setDisabled("save",!e.isDirty());
t.setDisabled("cancel",!e.isDirty())
}}
,_save:function(){
var s=this.editor,i,o,n,t;
i=tinymce.DOM.get(s.id).form||tinymce.DOM.getParent(s.id,"form");
if(s.getParam("save_enablewhendirty")&&!s.isDirty()){
return
}
tinyMCE.triggerSave();
if(o=s.getParam("save_onsavecallback")){
if(s.execCallback("save_onsavecallback",s)){
s.startContent=tinymce.trim(s.getContent({
format:"raw"}
));
s.nodeChanged()
}
return
}
if(i){
s.isNotDirty=true;
if(i.onsubmit==null||i.onsubmit()!=false){
i.submit()
}
s.nodeChanged()
}else{
s.windowManager.alert("Error: No form element found.")
}}
,_cancel:function(){
var t=this.editor,i,e=tinymce.trim(t.startContent);
if(i=t.getParam("save_oncancelcallback")){
t.execCallback("save_oncancelcallback",t);
return
}
t.setContent(e);
t.undoManager.clear();
t.nodeChanged()
}}
);
tinymce.PluginManager.add("save",tinymce.plugins.Save)
}
)();
